      subroutine COEXEN
C
C     Rudolf Loeser, 1994 Aug 16
C---- Does nothing - just contains data statements
C
C     Initializes CO energy arrays with Goorvitch 1994 data.
C     !DASH
      save
C     !DASH
      integer J
C     !COM
C---- LOOM        as of 1994 Dec 16
      integer     JCOLMF,KCOLMF,JCOLMO,KCOLMO,JCOLMS,KCOLMS,
     $            JCOLMR,KCOLMR,JCOMAX,KCOMAX
      parameter   (JCOLMF=111, KCOLMF=20)
      parameter   (JCOLMO=111, KCOLMO=13)
      parameter   (JCOLMS=111, KCOLMS=12)
      parameter   (JCOLMR=53,  KCOLMR=21)
      parameter   (JCOMAX=max(JCOLMF,JCOLMO,JCOLMS,JCOLMR))
      parameter   (KCOMAX=max(KCOLMF,KCOLMO,KCOLMS,KCOLMR))
C     (Be sure to recompile all users of LOOM when changing any
C     of the above parameter values!)
      real*8      WNUPF,WNDNF,WNUPO,WNDNO,WNUPS,WNDNS,WNROT,
     $            FUPF ,FDNF ,FUPO ,FDNO ,FUPS ,FDNS ,FROT ,
     $            EXEN,WVCOLO,WVCOHI,RC1213
      integer     JCOFUN,KCOFUN,JCOOVR,KCOOVR,JCOSEC,KCOSEC,
     $            JCOROT,KCOROT,ISOSLCT,METHCOW,METHCOF
      logical     FUNDCO,OVERCO,SECNCO,ROTACO
C
      dimension   WNUPF(JCOLMF,KCOLMF,2), WNDNF(JCOLMF,KCOLMF,2),
     $            WNUPO(JCOLMO,KCOLMO,2), WNDNO(JCOLMO,KCOLMO,2),
     $            WNUPS(JCOLMS,KCOLMS,2), WNDNS(JCOLMS,KCOLMS,2),
     $            WNROT(JCOLMR,KCOLMR,2),
     $            FUPF(JCOLMF,KCOLMF,2),  FDNF(JCOLMF,KCOLMF,2),
     $            FUPO(JCOLMO,KCOLMO,2),  FDNO(JCOLMO,KCOLMO,2),
     $            FUPS(JCOLMS,KCOLMS,2),  FDNS(JCOLMS,KCOLMS,2),
     $            FROT(JCOLMR,KCOLMR,2),
     $            EXEN(JCOMAX+1,KCOMAX,2)
      dimension   FUNDCO(2),OVERCO(2),SECNCO(2),ROTACO(2),
     $            JCOFUN(2),KCOFUN(2),JCOOVR(2),KCOOVR(2),
     $            JCOSEC(2),KCOSEC(2),JCOROT(2),KCOROT(2)
C
C     Carbon Monoxide lines:  wavenumbers and oscillator strengths.
C
C     WNROT, etc., are for rotational lines     : j'-j=+1, v'-v=0;
C     WNUPF, etc., are for fundamental lines    : j'-j=+1, v'-v=1;
C     WNDNF, etc., are for fundamental lines    : j'-j=-1, v'-v=1;
C     WNUPO, etc., are for first overtone lines : j'-j=+1, v'-v=2;
C     WNDNO, etc., are for first overtone lines : j'-j=-1, v'-v=2;
C     WNUPS, etc., are for second overtone lines: j'-j=+1, v'-v=3;
C     WNDNS, etc., are for second overtone lines: j'-j=-1, v'-v=3.
C
C     This is how the array indices relate to the quantum numbers:
C
C     1. index J corresponds to quantum number j -
C                in WNROT, etc., j = J-1, j' = J
C                in WNUPF, etc., j = J-1, j' = J
C                in WNDNF, etc., j = J  , j' = J-1
C                in WNUPO, etc., j = J-1, j' = J
C                in WNDNO, etc., j = J  , j' = J-1
C                in WNUPS, etc., j = J-1, j' = J
C                in WNDNS, etc., j = J  , j' = J-1
C
C     2. index K corresponds to quantum number v (=nu) -
C                in WNROT, etc.,                 v = K-1, v' = K-1
C                in WNUPF, etc. and WNDNF, etc., v = K-1, v' = K
C                in WNUPO, etc. and WNDNO, etc., v = K-1, v' = K+1
C                in WNUPS, etc. and WNDNS, etc., v = K-1, v' = K+2
C
C     3. index L identifies the Carbon isotope -
C                L=1 for Carbon-12, L=2 for Carbon-13.
C
C     Wavenumbers and energies from:
C        Farrenq, R., Guelachvili, G., Sauval, A.J., Grevesse, N.,
C        and Farmer, C.B. 1991,
C        J.Molec.Spectrosc., 149, 375
C       or
C        Coxon, J.A., and Hajigeorgiou, P.G. 1992,
C        Can.J.Phys., 70, 40-54
C       or
C        Goorvitch, 1994, Ap.J.Suppl.
C     f-values from:
C        Chackerian, C., Jr, and Tipping, R. H. 1983
C        J.Molec.Spectros., 99, 431
C       or
C        "improved" Chackerian
C       or
C        Goorvitch, 1994, Ap.J.Suppl.
C
      common      /LOOM1 / EXEN
      common      /LOOM2 / WNROT,FROT
      common      /LOOM3 / WNUPF,FUPF,WNDNF,FDNF
      common      /LOOM4 / WNUPO,FUPO,WNDNO,FDNO
      common      /LOOM5 / WNUPS,FUPS,WNDNS,FDNS
      common      /LOOM6 / JCOFUN,KCOFUN,JCOOVR,KCOOVR,JCOSEC,KCOSEC,
     $                     JCOROT,KCOROT
      common      /LOOM7 / WVCOLO,WVCOHI
      common      /LOOM8 / FUNDCO,OVERCO,SECNCO,ROTACO
C
C     (These parameters are computed by subroutines WEAVE and FOCA.)
C
      common      /LOOM9 / RC1213
      common      /LOOM10/ ISOSLCT,METHCOW,METHCOF
C
C     RC1213  is the C(12)/C(13) isotopic abundance ratio.
C     ISOSLCT controls which isotopes are included in this calculation:
C     ISOSLCT = 1 means: C(12) only;
C     ISOSLCT = 2 means: C(13) only; and
C     ISOSLCT = 3 means: both C(12) and C(13).
C
C     METHCOF = 1 means: use f-values from Chackerian & Tipping (1983);
C     METHCOF = 2 means: use f-values from "new" Chackerian data;
C     METHCOF = 3 means: use f-values from Goorvitch (1994).
C
C     METHCOW = 1 means: use energies from Farrenq et al.;
C     METHCOW = 2 means: use energies from Coxon & Hajigeorgiou;
C     METHCOW = 3 means: use wave numbers & energies from
C                                                    Goorvitch (1994).
C     .
C     !DASH
      data ( EXEN(  1,J,1),J=1,21) /
     $ 0.00000000D+00, 2.14327110D+03, 4.26006220D+03, 6.35043910D+03,
     $ 8.41446930D+03, 1.04522222D+04, 1.24637686D+04, 1.44491813D+04,
     $ 1.64085346D+04, 1.83419044D+04, 2.02493682D+04, 2.21310050D+04,
     $ 2.39868951D+04, 2.58171199D+04, 2.76217621D+04, 2.94009052D+04,
     $ 3.11546333D+04, 3.28830311D+04, 3.45861834D+04, 3.62641752D+04,
     $ 3.79170909D+04/
      data ( EXEN(  1,J,2),J=1,21) /
     $ 0.00000000D+00, 2.09606690D+03, 4.16681910D+03, 6.21231810D+03,
     $ 8.23262690D+03, 1.02278102D+04, 1.21979340D+04, 1.41430661D+04,
     $ 1.60632756D+04, 1.79586335D+04, 1.98292116D+04, 2.16750837D+04,
     $ 2.34963243D+04, 2.52930094D+04, 2.70652160D+04, 2.88130218D+04,
     $ 3.05365052D+04, 3.22357454D+04, 3.39108214D+04, 3.55618129D+04,
     $ 3.71887987D+04/
      data ( EXEN(  2,J,1),J=1,21) /
     $ 3.84500000D+00, 2.14708110D+03, 4.26383720D+03, 6.35417910D+03,
     $ 8.41817430D+03, 1.04558922D+04, 1.24674036D+04, 1.44527813D+04,
     $ 1.64120997D+04, 1.83454345D+04, 2.02528633D+04, 2.21344652D+04,
     $ 2.39903203D+04, 2.58205102D+04, 2.76251174D+04, 2.94042256D+04,
     $ 3.11579187D+04, 3.28862816D+04, 3.45893990D+04, 3.62673559D+04,
     $ 3.79202367D+04/
      data ( EXEN(  2,J,2),J=1,21) /
     $ 3.67590000D+00, 2.09971010D+03, 4.17042960D+03, 6.21589590D+03,
     $ 8.23617200D+03, 1.02313225D+04, 1.22014136D+04, 1.41465130D+04,
     $ 1.60666899D+04, 1.79620150D+04, 1.98325605D+04, 2.16783999D+04,
     $ 2.34996078D+04, 2.52962603D+04, 2.70684342D+04, 2.88162073D+04,
     $ 3.05396581D+04, 3.22388656D+04, 3.39139091D+04, 3.55648679D+04,
     $ 3.71918211D+04/
      data ( EXEN(  3,J,1),J=1,21) /
     $ 1.15350000D+01, 2.15470100D+03, 4.27138710D+03, 6.36165900D+03,
     $ 8.42558420D+03, 1.04632321D+04, 1.24746736D+04, 1.44599813D+04,
     $ 1.64192297D+04, 1.83524945D+04, 2.02598535D+04, 2.21413854D+04,
     $ 2.39971705D+04, 2.58272905D+04, 2.76318279D+04, 2.94108662D+04,
     $ 3.11644895D+04, 3.28927825D+04, 3.45958301D+04, 3.62737171D+04,
     $ 3.79265281D+04/
      data ( EXEN(  3,J,2),J=1,21) /
     $ 1.10276000D+01, 2.10699640D+03, 4.17765040D+03, 6.22305130D+03,
     $ 8.24326200D+03, 1.02383471D+04, 1.22083728D+04, 1.41534068D+04,
     $ 1.60735183D+04, 1.79687780D+04, 1.98392582D+04, 2.16850322D+04,
     $ 2.35061748D+04, 2.53027619D+04, 2.70748705D+04, 2.88225783D+04,
     $ 3.05459638D+04, 3.22451060D+04, 3.39200842D+04, 3.55709777D+04,
     $ 3.71978657D+04/
      data ( EXEN(  4,J,1),J=1,21) /
     $ 2.30695000D+01, 2.16613050D+03, 4.28271160D+03, 6.37287850D+03,
     $ 8.43669870D+03, 1.04742416D+04, 1.24855781D+04, 1.44707809D+04,
     $ 1.64299243D+04, 1.83630842D+04, 2.02703383D+04, 2.21517653D+04,
     $ 2.40074456D+04, 2.58374607D+04, 2.76418933D+04, 2.94208267D+04,
     $ 3.11743452D+04, 3.29025335D+04, 3.46054763D+04, 3.62832586D+04,
     $ 3.79359649D+04/
      data ( EXEN(  4,J,2),J=1,21) /
     $ 2.20549000D+01, 2.11792540D+03, 4.18848140D+03, 6.23378410D+03,
     $ 8.25389670D+03, 1.02488837D+04, 1.22188113D+04, 1.41637471D+04,
     $ 1.60837606D+04, 1.79789222D+04, 1.98493043D+04, 2.16949803D+04,
     $ 2.35160249D+04, 2.53125140D+04, 2.70845246D+04, 2.88321344D+04,
     $ 3.05554220D+04, 3.22544663D+04, 3.39293466D+04, 3.55801422D+04,
     $ 3.72069323D+04/
      data ( EXEN(  5,J,1),J=1,21) /
     $ 3.84481000D+01, 2.18136920D+03, 4.29781020D+03, 6.38783710D+03,
     $ 8.45151740D+03, 1.04889203D+04, 1.25001168D+04, 1.44851797D+04,
     $ 1.64441831D+04, 1.83772032D+04, 2.02843173D+04, 2.21656045D+04,
     $ 2.40211449D+04, 2.58510203D+04, 2.76553131D+04, 2.94341068D+04,
     $ 3.11874856D+04, 3.29155341D+04, 3.46183373D+04, 3.62959800D+04,
     $ 3.79485466D+04/
      data ( EXEN(  5,J,2),J=1,21) /
     $ 3.67572000D+01, 2.13249690D+03, 4.20292200D+03, 6.24809390D+03,
     $ 8.26807560D+03, 1.02629318D+04, 1.22327286D+04, 1.41775337D+04,
     $ 1.60974163D+04, 1.79924472D+04, 1.98626985D+04, 2.17082438D+04,
     $ 2.35291577D+04, 2.53255162D+04, 2.70973961D+04, 2.88448753D+04,
     $ 3.05680323D+04, 3.22669461D+04, 3.39416958D+04, 3.55923609D+04,
     $ 3.72190205D+04/
      data ( EXEN(  6,J,1),J=1,21) /
     $ 5.76704000D+01, 2.20041640D+03, 4.31668240D+03, 6.40653430D+03,
     $ 8.47003950D+03, 1.05072675D+04, 1.25182891D+04, 1.45031770D+04,
     $ 1.64620056D+04, 1.83948507D+04, 2.03017900D+04, 2.21829023D+04,
     $ 2.40382680D+04, 2.58679686D+04, 2.76720867D+04, 2.94507057D+04,
     $ 3.12039099D+04, 3.29317838D+04, 3.46344124D+04, 3.63118805D+04,
     $ 3.79642726D+04/
      data ( EXEN(  6,J,2),J=1,21) /
     $ 5.51341000D+01, 2.15071020D+03, 4.22097170D+03, 6.26598010D+03,
     $ 8.28579830D+03, 1.02804909D+04, 1.22501242D+04, 1.41947658D+04,
     $ 1.61144849D+04, 1.80093524D+04, 1.98794403D+04, 2.17248222D+04,
     $ 2.35455727D+04, 2.53417678D+04, 2.71134845D+04, 2.88608005D+04,
     $ 3.05837942D+04, 3.22825447D+04, 3.39571313D+04, 3.56076332D+04,
     $ 3.72341297D+04/
      data ( EXEN(  7,J,1),J=1,21) /
     $ 8.07354000D+01, 2.22327140D+03, 4.33932740D+03, 6.42896930D+03,
     $ 8.49226460D+03, 1.05292825D+04, 1.25400942D+04, 1.45247722D+04,
     $ 1.64833909D+04, 1.84160262D+04, 2.03227556D+04, 2.22036582D+04,
     $ 2.40588141D+04, 2.58883050D+04, 2.76922134D+04, 2.94706228D+04,
     $ 3.12236174D+04, 3.29512818D+04, 3.46537009D+04, 3.63309595D+04,
     $ 3.79831421D+04/
      data ( EXEN(  7,J,2),J=1,21) /
     $ 7.71850000D+01, 2.17256480D+03, 4.24263000D+03, 6.28744200D+03,
     $ 8.30706400D+03, 1.03015604D+04, 1.22709974D+04, 1.42154428D+04,
     $ 1.61349658D+04, 1.80296372D+04, 1.98995290D+04, 2.17447147D+04,
     $ 2.35652692D+04, 2.53612684D+04, 2.71327891D+04, 2.88799091D+04,
     $ 3.06027070D+04, 3.23012616D+04, 3.39756524D+04, 3.56259585D+04,
     $ 3.72522592D+04/
      data ( EXEN(  8,J,1),J=1,21) /
     $ 1.07642400D+02, 2.24993340D+03, 4.36574430D+03, 6.45514120D+03,
     $ 8.51819150D+03, 1.05549645D+04, 1.25655313D+04, 1.45499643D+04,
     $ 1.65083382D+04, 1.84407286D+04, 2.03472133D+04, 2.22278711D+04,
     $ 2.40827824D+04, 2.59120286D+04, 2.77156924D+04, 2.94938572D+04,
     $ 3.12466073D+04, 3.29740272D+04, 3.46762019D+04, 3.63532161D+04,
     $ 3.80051544D+04/
      data ( EXEN(  8,J,2),J=1,21) /
     $ 1.02908900D+02, 2.19805970D+03, 4.26789590D+03, 6.31247900D+03,
     $ 8.33187190D+03, 1.03261394D+04, 1.22953475D+04, 1.42395641D+04,
     $ 1.61588582D+04, 1.80533007D+04, 1.99229637D+04, 2.17679207D+04,
     $ 2.35882465D+04, 2.53840170D+04, 2.71553090D+04, 2.89022005D+04,
     $ 3.06247698D+04, 3.23230960D+04, 3.39972583D+04, 3.56473360D+04,
     $ 3.72734083D+04/
      data ( EXEN(  9,J,1),J=1,21) /
     $ 1.38390400D+02, 2.28040120D+03, 4.39593220D+03, 6.48504910D+03,
     $ 8.54781940D+03, 1.05843125D+04, 1.25945993D+04, 1.45787525D+04,
     $ 1.65368464D+04, 1.84689571D+04, 2.03751620D+04, 2.22555401D+04,
     $ 2.41101717D+04, 2.59391383D+04, 2.77425225D+04, 2.95204079D+04,
     $ 3.12728785D+04, 3.30000190D+04, 3.47019144D+04, 3.63786493D+04,
     $ 3.80303083D+04/
      data ( EXEN(  9,J,2),J=1,21) /
     $ 1.32305000D+02, 2.22719410D+03, 4.29676850D+03, 6.34108990D+03,
     $ 8.36022120D+03, 1.03542270D+04, 1.23231735D+04, 1.42671285D+04,
     $ 1.61861610D+04, 1.80803420D+04, 1.99497435D+04, 2.17944391D+04,
     $ 2.36145035D+04, 2.54100126D+04, 2.71810434D+04, 2.89276737D+04,
     $ 3.06499818D+04, 3.23480468D+04, 3.40219480D+04, 3.56717647D+04,
     $ 3.72975760D+04/
      data ( EXEN( 10,J,1),J=1,21) /
     $ 1.72978000D+02, 2.31467390D+03, 4.42988980D+03, 6.51869170D+03,
     $ 8.58114700D+03, 1.06173251D+04, 1.26272970D+04, 1.46111353D+04,
     $ 1.65689144D+04, 1.85007103D+04, 2.04066005D+04, 2.22866639D+04,
     $ 2.41409809D+04, 2.59696329D+04, 2.77727027D+04, 2.95502736D+04,
     $ 3.13024298D+04, 3.30292561D+04, 3.47308371D+04, 3.64072578D+04,
     $ 3.80586026D+04/
      data ( EXEN( 10,J,2),J=1,21) /
     $ 1.65372200D+02, 2.25996680D+03, 4.32924690D+03, 6.37327380D+03,
     $ 8.39211070D+03, 1.03858222D+04, 1.23544744D+04, 1.42981350D+04,
     $ 1.62168733D+04, 1.81107601D+04, 1.99798674D+04, 2.18242689D+04,
     $ 2.36440392D+04, 2.54392544D+04, 2.72099912D+04, 2.89563275D+04,
     $ 3.06783418D+04, 3.23761131D+04, 3.40497205D+04, 3.56992435D+04,
     $ 3.73247612D+04/
      data ( EXEN( 11,J,1),J=1,21) /
     $ 2.11404100D+02, 2.35274990D+03, 4.46761580D+03, 6.55606770D+03,
     $ 8.61817300D+03, 1.06540012D+04, 1.26636232D+04, 1.46471116D+04,
     $ 1.66045409D+04, 1.85359871D+04, 2.04415275D+04, 2.23212413D+04,
     $ 2.41752087D+04, 2.60035112D+04, 2.78062315D+04, 2.95834531D+04,
     $ 3.13352600D+04, 3.30617370D+04, 3.47629688D+04, 3.64390404D+04,
     $ 3.80900361D+04/
      data ( EXEN( 11,J,2),J=1,21) /
     $ 2.02109200D+02, 2.29637670D+03, 4.36532960D+03, 6.40902950D+03,
     $ 8.42753930D+03, 1.04209237D+04, 1.23892488D+04, 1.43325825D+04,
     $ 1.62509938D+04, 1.81445537D+04, 2.00133342D+04, 2.18574089D+04,
     $ 2.36768525D+04, 2.54717409D+04, 2.72421511D+04, 2.89881609D+04,
     $ 3.07098487D+04, 3.24072935D+04, 3.40805746D+04, 3.57297713D+04,
     $ 3.73549626D+04/
      data ( EXEN( 12,J,1),J=1,21) /
     $ 2.53667200D+02, 2.39462790D+03, 4.50910880D+03, 6.59717560D+03,
     $ 8.65889600D+03, 1.06943393D+04, 1.27035763D+04, 1.46866799D+04,
     $ 1.66437244D+04, 1.85747858D+04, 2.04799416D+04, 2.23592707D+04,
     $ 2.42128536D+04, 2.60407717D+04, 2.78431076D+04, 2.96199448D+04,
     $ 3.13713675D+04, 3.30974603D+04, 3.47983080D+04, 3.64739955D+04,
     $ 3.81246072D+04/
      data ( EXEN( 12,J,2),J=1,21) /
     $ 2.42514900D+02, 2.33642240D+03, 4.40501550D+03, 6.44835550D+03,
     $ 8.46650550D+03, 1.04595301D+04, 1.24274956D+04, 1.43704695D+04,
     $ 1.62885212D+04, 1.81817215D+04, 2.00501425D+04, 2.18938576D+04,
     $ 2.37129418D+04, 2.55074709D+04, 2.72775219D+04, 2.90231724D+04,
     $ 3.07445011D+04, 3.24415868D+04, 3.41145089D+04, 3.57633466D+04,
     $ 3.73881790D+04/
      data ( EXEN( 13,J,1),J=1,21) /
     $ 2.99765600D+02, 2.44030620D+03, 4.55436700D+03, 6.64201390D+03,
     $ 8.70331430D+03, 1.07383376D+04, 1.27471548D+04, 1.47298386D+04,
     $ 1.66864633D+04, 1.86171050D+04, 2.05218411D+04, 2.24007506D+04,
     $ 2.42539140D+04, 2.60814126D+04, 2.78833292D+04, 2.96597471D+04,
     $ 3.14107507D+04, 3.31364244D+04, 3.48368531D+04, 3.65121216D+04,
     $ 3.81623143D+04/
      data ( EXEN( 13,J,2),J=1,21) /
     $ 2.86587500D+02, 2.38010250D+03, 4.44830300D+03, 6.49125050D+03,
     $ 8.50900800D+03, 1.05016401D+04, 1.24692131D+04, 1.44117946D+04,
     $ 1.63294540D+04, 1.82222620D+04, 2.00902907D+04, 2.19336138D+04,
     $ 2.37523058D+04, 2.55464429D+04, 2.73161019D+04, 2.90613606D+04,
     $ 3.07822975D+04, 3.24789915D+04, 3.41515219D+04, 3.57999680D+04,
     $ 3.74244088D+04/
      data ( EXEN( 14,J,1),J=1,21) /
     $ 3.49697600D+02, 2.48978310D+03, 4.60338890D+03, 6.69058070D+03,
     $ 8.75142620D+03, 1.07859946D+04, 1.27943569D+04, 1.47765858D+04,
     $ 1.67327558D+04, 1.86629427D+04, 2.05672242D+04, 2.24456792D+04,
     $ 2.42983881D+04, 2.61254324D+04, 2.79268946D+04, 2.97028584D+04,
     $ 3.14534078D+04, 3.31786274D+04, 3.48786022D+04, 3.65534168D+04,
     $ 3.82031556D+04/
      data ( EXEN( 14,J,2),J=1,21) /
     $ 3.34325700D+02, 2.42741530D+03, 4.49519050D+03, 6.53771270D+03,
     $ 8.55504500D+03, 1.05472520D+04, 1.25143998D+04, 1.44565563D+04,
     $ 1.63737906D+04, 1.82661736D+04, 2.01337774D+04, 2.19766756D+04,
     $ 2.37949429D+04, 2.55886553D+04, 2.73578897D+04, 2.91027239D+04,
     $ 3.08232363D+04, 3.25195059D+04, 3.41916120D+04, 3.58396339D+04,
     $ 3.74636505D+04/
      data ( EXEN( 15,J,1),J=1,21) /
     $ 4.03461200D+02, 2.54305670D+03, 4.65617240D+03, 6.74287430D+03,
     $ 8.80322980D+03, 1.08373082D+04, 1.28451806D+04, 1.48269198D+04,
     $ 1.67826000D+04, 1.87122972D+04, 2.06160891D+04, 2.24940546D+04,
     $ 2.43462740D+04, 2.61728290D+04, 2.79738020D+04, 2.97492766D+04,
     $ 3.14993369D+04, 3.32240676D+04, 3.49235535D+04, 3.65978792D+04,
     $ 3.82471293D+04/
      data ( EXEN( 15,J,2),J=1,21) /
     $ 3.85727500D+02, 2.47835910D+03, 4.54567630D+03, 6.58774060D+03,
     $ 8.60461490D+03, 1.05963640D+04, 1.25630540D+04, 1.45047526D+04,
     $ 1.64215292D+04, 1.83134546D+04, 2.01806008D+04, 2.20230414D+04,
     $ 2.38408513D+04, 2.56341063D+04, 2.74028834D+04, 2.91472604D+04,
     $ 3.08673157D+04, 3.25631283D+04, 3.42347775D+04, 3.58823424D+04,
     $ 3.75059022D+04/
      data ( EXEN( 16,J,1),J=1,21) /
     $ 4.61054500D+02, 2.60012490D+03, 4.71271560D+03, 6.79889240D+03,
     $ 8.85872290D+03, 1.08922764D+04, 1.28996240D+04, 1.48808383D+04,
     $ 1.68359938D+04, 1.87651664D+04, 2.06684337D+04, 2.25458747D+04,
     $ 2.43975697D+04, 2.62236004D+04, 2.80240492D+04, 2.97989997D+04,
     $ 3.15485360D+04, 3.32727428D+04, 3.49717048D+04, 3.66455068D+04,
     $ 3.82942332D+04/
      data ( EXEN( 16,J,2),J=1,21) /
     $ 4.40791200D+02, 2.53293200D+03, 4.59975850D+03, 6.64133210D+03,
     $ 8.65771580D+03, 1.06489743D+04, 1.26151737D+04, 1.45563819D+04,
     $ 1.64726680D+04, 1.83641030D+04, 2.02307589D+04, 2.20727094D+04,
     $ 2.38900291D+04, 2.56827941D+04, 2.74510812D+04, 2.91949684D+04,
     $ 3.09145339D+04, 3.26098568D+04, 3.42810164D+04, 3.59280918D+04,
     $ 3.75511621D+04/
      data ( EXEN( 17,J,1),J=1,21) /
     $ 5.22475100D+02, 2.66098550D+03, 4.77301610D+03, 6.85863290D+03,
     $ 8.91790350D+03, 1.09508971D+04, 1.29576848D+04, 1.49383393D+04,
     $ 1.68929350D+04, 1.88215480D+04, 2.07242558D+04, 2.26011373D+04,
     $ 2.44522730D+04, 2.62777443D+04, 2.80776340D+04, 2.98520255D+04,
     $ 3.16010029D+04, 3.33246508D+04, 3.50230541D+04, 3.66962974D+04,
     $ 3.83444651D+04/
      data ( EXEN( 17,J,2),J=1,21) /
     $ 4.99514700D+02, 2.59113210D+03, 4.65743510D+03, 6.69848530D+03,
     $ 8.71434570D+03, 1.07050808D+04, 1.26707570D+04, 1.46114420D+04,
     $ 1.65272050D+04, 1.84181169D+04, 2.02842498D+04, 2.21256774D+04,
     $ 2.39424743D+04, 2.57347166D+04, 2.75024811D+04, 2.92458457D+04,
     $ 3.09648888D+04, 3.26596894D+04, 3.43303267D+04, 3.59768800D+04,
     $ 3.75994282D+04/
      data ( EXEN( 18,J,1),J=1,21) /
     $ 5.87720900D+02, 2.72563610D+03, 4.83707170D+03, 6.92209350D+03,
     $ 8.98076910D+03, 1.10131678D+04, 1.30193607D+04, 1.49994204D+04,
     $ 1.69534214D+04, 1.88814397D+04, 2.07835530D+04, 2.26598401D+04,
     $ 2.45103814D+04, 2.63352586D+04, 2.81345541D+04, 2.99083516D+04,
     $ 3.16567351D+04, 3.33797892D+04, 3.50775988D+04, 3.67502485D+04,
     $ 3.83978226D+04/
      data ( EXEN( 18,J,2),J=1,21) /
     $ 5.61895800D+02, 2.65295710D+03, 4.71870400D+03, 6.75919800D+03,
     $ 8.77450230D+03, 1.07646815D+04, 1.27298017D+04, 1.46699308D+04,
     $ 1.65851380D+04, 1.84754941D+04, 2.03410713D+04, 2.21819433D+04,
     $ 2.39981847D+04, 2.57898716D+04, 2.75570809D+04, 2.92998903D+04,
     $ 3.10183783D+04, 3.27126239D+04, 3.43827063D+04, 3.60287047D+04,
     $ 3.76506982D+04/
      data ( EXEN( 19,J,1),J=1,21) /
     $ 6.56789200D+02, 2.79407430D+03, 4.90487990D+03, 6.98927170D+03,
     $ 9.04731730D+03, 1.10790861D+04, 1.30846491D+04, 1.50640790D+04,
     $ 1.70174504D+04, 1.89448391D+04, 2.08463228D+04, 2.27219805D+04,
     $ 2.45718925D+04, 2.63961405D+04, 2.81948070D+04, 2.99679755D+04,
     $ 3.17157302D+04, 3.34381556D+04, 3.51353365D+04, 3.68073576D+04,
     $ 3.84543033D+04/
      data ( EXEN( 19,J,2),J=1,21) /
     $ 6.27932400D+02, 2.71840470D+03, 4.78356280D+03, 6.82346800D+03,
     $ 8.83818360D+03, 1.08277740D+04, 1.27923055D+04, 1.47318460D+04,
     $ 1.66464647D+04, 1.85362323D+04, 2.04012212D+04, 2.22415049D+04,
     $ 2.40571582D+04, 2.58482570D+04, 2.76148783D+04, 2.93570998D+04,
     $ 3.10750001D+04, 3.27686581D+04, 3.44381529D+04, 3.60835638D+04,
     $ 3.77049699D+04/
      data ( EXEN( 20,J,1),J=1,21) /
     $ 7.29677400D+02, 2.86629750D+03, 4.97643800D+03, 7.06016470D+03,
     $ 9.11754540D+03, 1.11486493D+04, 1.31535475D+04, 1.51323126D+04,
     $ 1.70850193D+04, 1.90117434D+04, 2.09125626D+04, 2.27875559D+04,
     $ 2.46368037D+04, 2.64603875D+04, 2.82583900D+04, 3.00308946D+04,
     $ 3.17779855D+04, 3.34997472D+04, 3.51962646D+04, 3.68676222D+04,
     $ 3.85139044D+04/
      data ( EXEN( 20,J,2),J=1,21) /
     $ 6.97621900D+02, 2.78747270D+03, 4.85200920D+03, 6.89129290D+03,
     $ 8.90538690D+03, 1.08943559D+04, 1.28582661D+04, 1.47971852D+04,
     $ 1.67111827D+04, 1.86003292D+04, 2.04646970D+04, 2.23043597D+04,
     $ 2.41193921D+04, 2.59098702D+04, 2.76758708D+04, 2.94174719D+04,
     $ 3.11347518D+04, 3.28277894D+04, 3.44966640D+04, 3.61414548D+04,
     $ 3.77622408D+04/
      data ( EXEN( 21,J,1),J=1,21) /
     $ 8.06382800D+02, 2.94230280D+03, 5.05174320D+03, 7.13477000D+03,
     $ 9.19145070D+03, 1.12218547D+04, 1.32260530D+04, 1.52041184D+04,
     $ 1.71561253D+04, 1.90821499D+04, 2.09822696D+04, 2.28565636D+04,
     $ 2.47051121D+04, 2.65279968D+04, 2.83253003D+04, 3.00971061D+04,
     $ 3.18434982D+04, 3.35645613D+04, 3.52603801D+04, 3.69310393D+04,
     $ 3.85766231D+04/
      data ( EXEN( 21,J,2),J=1,21) /
     $ 7.70961900D+02, 2.86015830D+03, 4.92404050D+03, 6.96267000D+03,
     $ 8.97610990D+03, 1.09644247D+04, 1.29276808D+04, 1.48659459D+04,
     $ 1.67792894D+04, 1.86677821D+04, 2.05314962D+04, 2.23705052D+04,
     $ 2.41848841D+04, 2.59747087D+04, 2.77400561D+04, 2.94810039D+04,
     $ 3.11976307D+04, 3.28900154D+04, 3.45582371D+04, 3.62023752D+04,
     $ 3.78225084D+04/
      data ( EXEN( 22,J,1),J=1,21) /
     $ 8.86902400D+02, 3.02208730D+03, 5.13079260D+03, 7.21308440D+03,
     $ 9.26903010D+03, 1.12986992D+04, 1.33021627D+04, 1.52794934D+04,
     $ 1.72307656D+04, 1.91560556D+04, 2.10554409D+04, 2.29290005D+04,
     $ 2.47768148D+04, 2.65989654D+04, 2.83955350D+04, 3.01666069D+04,
     $ 3.19122654D+04, 3.36325949D+04, 3.53276803D+04, 3.69976061D+04,
     $ 3.86424566D+04/
      data ( EXEN( 22,J,2),J=1,21) /
     $ 8.47949700D+02, 2.93645900D+03, 4.99965420D+03, 7.03759680D+03,
     $ 9.05034970D+03, 1.10379777D+04, 1.30005470D+04, 1.49381254D+04,
     $ 1.68507823D+04, 1.87385884D+04, 2.06016160D+04, 2.24399387D+04,
     $ 2.42536314D+04, 2.60427699D+04, 2.78074312D+04, 2.95476932D+04,
     $ 3.12636343D+04, 3.29553333D+04, 3.46228695D+04, 3.62663221D+04,
     $ 3.78857699D+04/
      data ( EXEN( 23,J,1),J=1,21) /
     $ 9.71233200D+02, 3.10564790D+03, 5.21358320D+03, 7.29510500D+03,
     $ 9.35028070D+03, 1.13791799D+04, 1.33818736D+04, 1.53584345D+04,
     $ 1.73089371D+04, 1.92334575D+04, 2.11320733D+04, 2.30048636D+04,
     $ 2.48519088D+04, 2.66732903D+04, 2.84690910D+04, 3.02393941D+04,
     $ 3.19842839D+04, 3.37038449D+04, 3.53981619D+04, 3.70673194D+04,
     $ 3.87114016D+04/
      data ( EXEN( 23,J,2),J=1,21) /
     $ 9.28582400D+02, 3.01637200D+03, 5.07884750D+03, 7.11607030D+03,
     $ 9.12810370D+03, 1.11150121D+04, 1.30768619D+04, 1.50137209D+04,
     $ 1.69256584D+04, 1.88127452D+04, 2.06750537D+04, 2.25126574D+04,
     $ 2.43256311D+04, 2.61140508D+04, 2.78779935D+04, 2.96175370D+04,
     $ 3.13327596D+04, 3.30237403D+04, 3.46905584D+04, 3.63332928D+04,
     $ 3.79520226D+04/
      data ( EXEN( 24,J,1),J=1,21) /
     $ 1.05937180D+03, 3.19298140D+03, 5.30011170D+03, 7.38082840D+03,
     $ 9.43519920D+03, 1.14632935D+04, 1.34651823D+04, 1.54409385D+04,
     $ 1.73906365D+04, 1.93143523D+04, 2.12121637D+04, 2.30841497D+04,
     $ 2.49303907D+04, 2.67509682D+04, 2.85459650D+04, 3.03154644D+04,
     $ 3.20595506D+04, 3.37783081D+04, 3.54718217D+04, 3.71401759D+04,
     $ 3.87834549D+04/
      data ( EXEN( 24,J,2),J=1,21) /
     $ 1.01285700D+03, 3.09989420D+03, 5.16161730D+03, 7.19808780D+03,
     $ 9.20936870D+03, 1.11955249D+04, 1.31566225D+04, 1.50927293D+04,
     $ 1.70039148D+04, 1.88902497D+04, 2.07518063D+04, 2.25886583D+04,
     $ 2.44008804D+04, 2.61885486D+04, 2.79517400D+04, 2.96905322D+04,
     $ 3.14050037D+04, 3.30952335D+04, 3.47613007D+04, 3.64032843D+04,
     $ 3.80212634D+04/
      data ( EXEN( 25,J,1),J=1,21) /
     $ 1.15131500D+03, 3.28408450D+03, 5.39037470D+03, 7.47025140D+03,
     $ 9.52378230D+03, 1.15510366D+04, 1.35520856D+04, 1.55270020D+04,
     $ 1.74758604D+04, 1.93987367D+04, 2.12957087D+04, 2.31668554D+04,
     $ 2.50122572D+04, 2.68319958D+04, 2.86261536D+04, 3.03948144D+04,
     $ 3.21380620D+04, 3.38559811D+04, 3.55486563D+04, 3.72161723D+04,
     $ 3.88586131D+04/
      data ( EXEN( 25,J,2),J=1,21) /
     $ 1.10077060D+03, 3.18702260D+03, 5.24796050D+03, 7.28364590D+03,
     $ 9.29414190D+03, 1.12795131D+04, 1.32398257D+04, 1.51751477D+04,
     $ 1.70855484D+04, 1.89710987D+04, 2.08318708D+04, 2.26679383D+04,
     $ 2.44793761D+04, 2.62662602D+04, 2.80286675D+04, 2.97666758D+04,
     $ 3.14803636D+04, 3.31698097D+04, 3.48350933D+04, 3.64762936D+04,
     $ 3.80934893D+04/
      data ( EXEN( 26,J,1),J=1,21) /
     $ 1.24705920D+03, 3.37895360D+03, 5.48436870D+03, 7.56337040D+03,
     $ 9.61602630D+03, 1.16424058D+04, 1.36425799D+04, 1.56166216D+04,
     $ 1.75646053D+04, 1.94866071D+04, 2.13827047D+04, 2.32529771D+04,
     $ 2.50975048D+04, 2.69163694D+04, 2.87096534D+04, 3.04774405D+04,
     $ 3.22198146D+04, 3.39368603D+04, 3.56286623D+04, 3.72953050D+04,
     $ 3.89368727D+04/
      data ( EXEN( 26,J,2),J=1,21) /
     $ 1.19231990D+03, 3.27775400D+03, 5.33787410D+03, 7.37274170D+03,
     $ 9.38241990D+03, 1.13669734D+04, 1.33264684D+04, 1.52609729D+04,
     $ 1.71705561D+04, 1.90552890D+04, 2.09152438D+04, 2.27504942D+04,
     $ 2.45611150D+04, 2.63471823D+04, 2.81087728D+04, 2.98459646D+04,
     $ 3.15588359D+04, 3.32474657D+04, 3.49119332D+04, 3.65523173D+04,
     $ 3.81686969D+04/
      data ( EXEN( 27,J,1),J=1,21) /
     $ 1.34660080D+03, 3.47758510D+03, 5.58209010D+03, 7.66018180D+03,
     $ 9.71192770D+03, 1.17373972D+04, 1.37366616D+04, 1.57097935D+04,
     $ 1.76568676D+04, 1.95779599D+04, 2.14731481D+04, 2.33425112D+04,
     $ 2.51861298D+04, 2.70040854D+04, 2.87964607D+04, 3.05633391D+04,
     $ 3.23048047D+04, 3.40209420D+04, 3.57118357D+04, 3.73775703D+04,
     $ 3.90182299D+04/
      data ( EXEN( 27,J,2),J=1,21) /
     $ 1.28750160D+03, 3.37208510D+03, 5.43135460D+03, 7.46537170D+03,
     $ 9.47419940D+03, 1.14579024D+04, 1.34165472D+04, 1.53502014D+04,
     $ 1.72589344D+04, 1.91428173D+04, 2.10019222D+04, 2.28363227D+04,
     $ 2.46460939D+04, 2.64313115D+04, 2.81920527D+04, 2.99283952D+04,
     $ 3.16404174D+04, 3.33281982D+04, 3.49918167D+04, 3.66313521D+04,
     $ 3.82468830D+04/
      data ( EXEN( 28,J,1),J=1,21) /
     $ 1.44993590D+03, 3.57997510D+03, 5.68353500D+03, 7.76068170D+03,
     $ 9.81148260D+03, 1.18360073D+04, 1.38343268D+04, 1.58065140D+04,
     $ 1.77526434D+04, 1.96727912D+04, 2.15670350D+04, 2.34354539D+04,
     $ 2.52781284D+04, 2.70951401D+04, 2.88865716D+04, 3.06525063D+04,
     $ 3.23930285D+04, 3.41082225D+04, 3.57981730D+04, 3.74629644D+04,
     $ 3.91026809D+04/
      data ( EXEN( 28,J,2),J=1,21) /
     $ 1.38631210D+03, 3.47001230D+03, 5.52839850D+03, 7.56153240D+03,
     $ 9.56947690D+03, 1.15522968D+04, 1.35100585D+04, 1.54428297D+04,
     $ 1.73506799D+04, 1.92336800D+04, 2.10919022D+04, 2.29254203D+04,
     $ 2.47343090D+04, 2.65186444D+04, 2.82785035D+04, 3.00139640D+04,
     $ 3.17251044D+04, 3.34120036D+04, 3.50747406D+04, 3.67133944D+04,
     $ 3.83280440D+04/
      data ( EXEN( 29,J,1),J=1,21) /
     $ 1.55706070D+03, 3.68611970D+03, 5.78869960D+03, 7.86486620D+03,
     $ 9.91468710D+03, 1.19382319D+04, 1.39355716D+04, 1.59067790D+04,
     $ 1.78519288D+04, 1.97710971D+04, 2.16643615D+04, 2.35318012D+04,
     $ 2.53734966D+04, 2.71895293D+04, 2.89799821D+04, 3.07449382D+04,
     $ 3.24844819D+04, 3.41986976D+04, 3.58876699D+04, 3.75514833D+04,
     $ 3.91902218D+04/
      data ( EXEN( 29,J,2),J=1,21) /
     $ 1.48874790D+03, 3.57153210D+03, 5.62900230D+03, 7.66122020D+03,
     $ 9.66824880D+03, 1.16501529D+04, 1.36069988D+04, 1.55388544D+04,
     $ 1.74457890D+04, 1.93278736D+04, 2.11851805D+04, 2.30177833D+04,
     $ 2.48257569D+04, 2.66091774D+04, 2.83681217D+04, 3.01026676D+04,
     $ 3.18128935D+04, 3.34988783D+04, 3.51607010D+04, 3.67984407D+04,
     $ 3.84121762D+04/
      data ( EXEN( 30,J,1),J=1,21) /
     $ 1.66797090D+03, 3.79601480D+03, 5.89757960D+03, 7.97273120D+03,
     $ 1.00215372D+04, 1.20440670D+04, 1.40403918D+04, 1.60105846D+04,
     $ 1.79547197D+04, 1.98728735D+04, 2.17651235D+04, 2.36315490D+04,
     $ 2.54722303D+04, 2.72872491D+04, 2.90766881D+04, 3.08406307D+04,
     $ 3.25791610D+04, 3.42923634D+04, 3.59803225D+04, 3.76431228D+04,
     $ 3.92808483D+04/
      data ( EXEN( 30,J,2),J=1,21) /
     $ 1.59480530D+03, 3.67664060D+03, 5.73316220D+03, 7.76443140D+03,
     $ 9.77051140D+03, 1.17514670D+04, 1.37073644D+04, 1.56382715D+04,
     $ 1.75442579D+04, 1.94253943D+04, 2.12817531D+04, 2.31134080D+04,
     $ 2.49204338D+04, 2.67029067D+04, 2.84609035D+04, 3.01945020D+04,
     $ 3.19037807D+04, 3.35888185D+04, 3.52496943D+04, 3.68864872D+04,
     $ 3.84992759D+04/
      data ( EXEN( 31,J,1),J=1,21) /
     $ 1.78266240D+03, 3.90965620D+03, 6.01017090D+03, 8.08427240D+03,
     $ 1.01320284D+04, 1.21535083D+04, 1.41487833D+04, 1.61179263D+04,
     $ 1.80610118D+04, 1.99781161D+04, 2.18693167D+04, 2.37346930D+04,
     $ 2.55743252D+04, 2.73882952D+04, 2.91766854D+04, 3.09395794D+04,
     $ 3.26770613D+04, 3.43892155D+04, 3.60761265D+04, 3.77378787D+04,
     $ 3.93745562D+04/
      data ( EXEN( 31,J,2),J=1,21) /
     $ 1.70448020D+03, 3.78533410D+03, 5.84087420D+03, 7.87116210D+03,
     $ 9.87626080D+03, 1.18562351D+04, 1.38111513D+04, 1.57410774D+04,
     $ 1.76460827D+04, 1.95262382D+04, 2.13816162D+04, 2.32122905D+04,
     $ 2.50183358D+04, 2.67998283D+04, 2.85568449D+04, 3.02894635D+04,
     $ 3.19977623D+04, 3.36818203D+04, 3.53417165D+04, 3.69775298D+04,
     $ 3.85893391D+04/
      data ( EXEN( 32,J,1),J=1,21) /
     $ 1.90113080D+03, 4.02703940D+03, 6.12646900D+03, 8.19948550D+03,
     $ 1.02461565D+04, 1.22665515D+04, 1.42607417D+04, 1.62287999D+04,
     $ 1.81708008D+04, 2.00868205D+04, 2.19769368D+04, 2.38412288D+04,
     $ 2.56797770D+04, 2.74926631D+04, 2.92799696D+04, 3.10417801D+04,
     $ 3.27781785D+04, 3.44892494D+04, 3.61750773D+04, 3.78357465D+04,
     $ 3.94713410D+04/
      data ( EXEN( 32,J,2),J=1,21) /
     $ 1.81776880D+03, 3.89760850D+03, 5.95213450D+03, 7.98140830D+03,
     $ 9.98549290D+03, 1.19644533D+04, 1.39183556D+04, 1.58472678D+04,
     $ 1.77512594D+04, 1.96304013D+04, 2.14847658D+04, 2.33144267D+04,
     $ 2.51194589D+04, 2.68999384D+04, 2.86559421D+04, 3.03875479D+04,
     $ 3.20948341D+04, 3.37778797D+04, 3.54367635D+04, 3.70715647D+04,
     $ 3.86823618D+04/
      data ( EXEN( 33,J,1),J=1,21) /
     $ 2.02337150D+03, 4.14816000D+03, 6.24646950D+03, 8.31836590D+03,
     $ 1.03639170D+04, 1.23831920D+04, 1.43762623D+04, 1.63432008D+04,
     $ 1.82840821D+04, 2.01989823D+04, 2.20879792D+04, 2.39511520D+04,
     $ 2.57885811D+04, 2.76003483D+04, 2.93865361D+04, 3.11472280D+04,
     $ 3.28825081D+04, 3.45924607D+04, 3.62771705D+04, 3.79367217D+04,
     $ 3.95711981D+04/
      data ( EXEN( 33,J,2),J=1,21) /
     $ 1.93466690D+03, 4.01345970D+03, 6.06693890D+03, 8.09516580D+03,
     $ 1.00982037D+04, 1.20761173D+04, 1.40289730D+04, 1.59568387D+04,
     $ 1.78597838D+04, 1.97378794D+04, 2.15911978D+04, 2.34198126D+04,
     $ 2.52237989D+04, 2.70032326D+04, 2.87581907D+04, 3.04887511D+04,
     $ 3.21949921D+04, 3.38769925D+04, 3.55348313D+04, 3.71685876D+04,
     $ 3.87783398D+04/
      data ( EXEN( 34,J,1),J=1,21) /
     $ 2.14937980D+03, 4.27301320D+03, 6.37016760D+03, 8.44090900D+03,
     $ 1.04853050D+04, 1.25034252D+04, 1.44953406D+04, 1.64611243D+04,
     $ 1.84008509D+04, 2.03145966D+04, 2.22024391D+04, 2.40644577D+04,
     $ 2.59007328D+04, 2.77113460D+04, 2.94963801D+04, 3.12559185D+04,
     $ 3.29900452D+04, 3.46988446D+04, 3.63824012D+04, 3.80407994D+04,
     $ 3.96741229D+04/
      data ( EXEN( 34,J,2),J=1,21) /
     $ 2.05517020D+03, 4.13288340D+03, 6.18528300D+03, 8.21243040D+03,
     $ 1.02143888D+04, 1.21912230D+04, 1.41429994D+04, 1.60697858D+04,
     $ 1.79716518D+04, 1.98486683D+04, 2.17009078D+04, 2.35284438D+04,
     $ 2.53313515D+04, 2.71097067D+04, 2.88635866D+04, 3.05930688D+04,
     $ 3.22982318D+04, 3.39791543D+04, 3.56359155D+04, 3.72685941D+04,
     $ 3.88772688D+04/
      data ( EXEN( 35,J,1),J=1,21) /
     $ 2.27915100D+03, 4.40159430D+03, 6.49755860D+03, 8.56710990D+03,
     $ 1.06103159D+04, 1.26272461D+04, 1.46179717D+04, 1.65825656D+04,
     $ 1.85211025D+04, 2.04336587D+04, 2.23203118D+04, 2.41811411D+04,
     $ 2.60162272D+04, 2.78256515D+04, 2.96094969D+04, 3.13678467D+04,
     $ 3.31007851D+04, 3.48083962D+04, 3.64907648D+04, 3.81479749D+04,
     $ 3.97801104D+04/
      data ( EXEN( 35,J,2),J=1,21) /
     $ 2.17927430D+03, 4.25587520D+03, 6.30716250D+03, 8.33319760D+03,
     $ 1.03340439D+04, 1.23097659D+04, 1.42604302D+04, 1.61861047D+04,
     $ 1.80868588D+04, 1.99627636D+04, 2.18138914D+04, 2.36403160D+04,
     $ 2.54421123D+04, 2.72193563D+04, 2.89721252D+04, 3.07004965D+04,
     $ 3.24045488D+04, 3.40843609D+04, 3.57400116D+04, 3.73715799D+04,
     $ 3.89791443D+04/
      data ( EXEN( 36,J,1),J=1,21) /
     $ 2.41268010D+03, 4.53389820D+03, 6.62863740D+03, 8.69696370D+03,
     $ 1.07389447D+04, 1.27546499D+04, 1.47441506D+04, 1.67075197D+04,
     $ 1.86448320D+04, 2.05561636D+04, 2.24415923D+04, 2.43011974D+04,
     $ 2.61350593D+04, 2.79432598D+04, 2.97258814D+04, 3.14830077D+04,
     $ 3.32147227D+04, 3.49211106D+04, 3.66022560D+04, 3.82582431D+04,
     $ 3.98891556D+04/
      data ( EXEN( 36,J,2),J=1,21) /
     $ 2.30697460D+03, 4.38243050D+03, 6.43257280D+03, 8.45746300D+03,
     $ 1.04571643D+04, 1.24317415D+04, 1.43812610D+04, 1.63057908D+04,
     $ 1.82054003D+04, 2.00801606D+04, 2.19301441D+04, 2.37554244D+04,
     $ 2.55560767D+04, 2.73321769D+04, 2.90838020D+04, 3.08110298D+04,
     $ 3.25139387D+04, 3.41926075D+04, 3.58471150D+04, 3.74775403D+04,
     $ 3.90839617D+04/
      data ( EXEN( 37,J,1),J=1,21) /
     $ 2.54996190D+03, 4.66991990D+03, 6.76339900D+03, 8.83046510D+03,
     $ 1.08711861D+04, 1.28856314D+04, 1.48738722D+04, 1.68359815D+04,
     $ 1.87720341D+04, 2.06821061D+04, 2.25662754D+04, 2.44246213D+04,
     $ 2.62572241D+04, 2.80641657D+04, 2.98455286D+04, 3.16013963D+04,
     $ 3.33318528D+04, 3.50369825D+04, 3.67168698D+04, 3.83715989D+04,
     $ 4.00012533D+04/
      data ( EXEN( 37,J,2),J=1,21) /
     $ 2.43826650D+03, 4.51254470D+03, 6.56150920D+03, 8.58522180D+03,
     $ 1.05837455D+04, 1.25571451D+04, 1.45054871D+04, 1.64288394D+04,
     $ 1.83272716D+04, 2.02008547D+04, 2.20496611D+04, 2.38737646D+04,
     $ 2.56732401D+04, 2.74481637D+04, 2.91986123D+04, 3.09246639D+04,
     $ 3.26263966D+04, 3.43038894D+04, 3.59572211D+04, 3.75864706D+04,
     $ 3.91917163D+04/
      data ( EXEN( 38,J,1),J=1,21) /
     $ 2.69099120D+03, 4.80965400D+03, 6.90183800D+03, 8.96760910D+03,
     $ 1.10070350D+04, 1.30201853D+04, 1.50071312D+04, 1.69679458D+04,
     $ 1.89027036D+04, 2.08114811D+04, 2.26943559D+04, 2.45514075D+04,
     $ 2.63827162D+04, 2.81883639D+04, 2.99684330D+04, 3.17230072D+04,
     $ 3.34521703D+04, 3.51560068D+04, 3.68346009D+04, 3.84880368D+04,
     $ 4.01163982D+04/
      data ( EXEN( 38,J,2),J=1,21) /
     $ 2.57314520D+03, 4.64621290D+03, 6.69396710D+03, 8.71646920D+03,
     $ 1.07137826D+04, 1.26859719D+04, 1.46331037D+04, 1.65552458D+04,
     $ 1.84524680D+04, 2.03248412D+04, 2.21724378D+04, 2.39953316D+04,
     $ 2.57935976D+04, 2.75673118D+04, 2.93165513D+04, 3.10413939D+04,
     $ 3.27419178D+04, 3.44182019D+04, 3.60703250D+04, 3.76983660D+04,
     $ 3.93024033D+04/
      data ( EXEN( 39,J,1),J=1,21) /
     $ 2.83576270D+03, 4.95309530D+03, 7.04394920D+03, 9.10839020D+03,
     $ 1.11464860D+04, 1.31583063D+04, 1.51439223D+04, 1.71034070D+04,
     $ 1.90368351D+04, 2.09442830D+04, 2.28258284D+04, 2.46815507D+04,
     $ 2.65115303D+04, 2.83158490D+04, 3.00945894D+04, 3.18478349D+04,
     $ 3.35756696D+04, 3.52781778D+04, 3.69554437D+04, 3.86075516D+04,
     $ 4.02345849D+04/
      data ( EXEN( 39,J,2),J=1,21) /
     $ 2.71160580D+03, 4.78343030D+03, 6.82994130D+03, 8.85120030D+03,
     $ 1.08472706D+04, 1.28182169D+04, 1.47641057D+04, 1.66850050D+04,
     $ 1.85809844D+04, 2.04521149D+04, 2.22984690D+04, 2.41201205D+04,
     $ 2.59171442D+04, 2.76896164D+04, 2.94376140D+04, 3.11612148D+04,
     $ 3.28604972D+04, 3.45355399D+04, 3.61864217D+04, 3.78132215D+04,
     $ 3.94160176D+04/
      data ( EXEN( 40,J,1),J=1,21) /
     $ 2.98427060D+03, 5.10023810D+03, 7.18972680D+03, 9.25280270D+03,
     $ 1.12895335D+04, 1.32999888D+04, 1.52842398D+04, 1.72423597D+04,
     $ 1.91744231D+04, 2.10805063D+04, 2.29606873D+04, 2.48150452D+04,
     $ 2.66436607D+04, 2.84466154D+04, 3.02239920D+04, 3.19758740D+04,
     $ 3.37023452D+04, 3.54034900D+04, 3.70793928D+04, 3.87301375D+04,
     $ 4.03558077D+04/
      data ( EXEN( 40,J,2),J=1,21) /
     $ 2.85364310D+03, 4.92419180D+03, 6.96942690D+03, 8.98941010D+03,
     $ 1.09842046D+04, 1.29538751D+04, 1.48984883D+04, 1.68181120D+04,
     $ 1.87128158D+04, 2.05826710D+04, 2.24277498D+04, 2.42481261D+04,
     $ 2.60438750D+04, 2.78150724D+04, 2.95617954D+04, 3.12841217D+04,
     $ 3.29821298D+04, 3.46558983D+04, 3.63055061D+04, 3.79310319D+04,
     $ 3.95325541D+04/
      data ( EXEN( 41,J,1),J=1,21) /
     $ 3.13650950D+03, 5.25107680D+03, 7.33916540D+03, 9.40084110D+03,
     $ 1.14361719D+04, 1.34452271D+04, 1.54280782D+04, 1.73847981D+04,
     $ 1.93154617D+04, 2.12201453D+04, 2.30989268D+04, 2.49518854D+04,
     $ 2.67791017D+04, 2.85806574D+04, 3.03566352D+04, 3.21071185D+04,
     $ 3.38321913D+04, 3.55319378D+04, 3.72064423D+04, 3.88557888D+04,
     $ 4.04800608D+04/
      data ( EXEN( 41,J,2),J=1,21) /
     $ 2.99925200D+03, 5.06849210D+03, 7.11241860D+03, 9.13109330D+03,
     $ 1.11245792D+04, 1.30929413D+04, 1.50362460D+04, 1.69545614D+04,
     $ 1.88479570D+04, 2.07165041D+04, 2.25602749D+04, 2.43793434D+04,
     $ 2.61737845D+04, 2.79436744D+04, 2.96890901D+04, 3.14101092D+04,
     $ 3.31068103D+04, 3.47792719D+04, 3.64275729D+04, 3.80517920D+04,
     $ 3.96520075D+04/
      data ( EXEN( 42,J,1),J=1,21) /
     $ 3.29247330D+03, 5.40560550D+03, 7.49225890D+03, 9.55249960D+03,
     $ 1.15863952D+04, 1.35940154D+04, 1.55754314D+04, 1.75307165D+04,
     $ 1.94599453D+04, 2.13631942D+04, 2.32405412D+04, 2.50920654D+04,
     $ 2.69178475D+04, 2.87179692D+04, 3.04925131D+04, 3.22415628D+04,
     $ 3.39652020D+04, 3.56635151D+04, 3.73365863D+04, 3.89844996D+04,
     $ 4.06073383D+04/
      data ( EXEN( 42,J,2),J=1,21) /
     $ 3.14842720D+03, 5.21632590D+03, 7.25891120D+03, 9.27624450D+03,
     $ 1.12683892D+04, 1.32354101D+04, 1.51773737D+04, 1.70943480D+04,
     $ 1.89864027D+04, 2.08536088D+04, 2.26960390D+04, 2.45137669D+04,
     $ 2.63068676D+04, 2.80754172D+04, 2.98194928D+04, 3.15391720D+04,
     $ 3.32345333D+04, 3.49056553D+04, 3.65526168D+04, 3.81754964D+04,
     $ 3.97743725D+04/
      data ( EXEN( 43,J,1),J=1,21) /
     $ 3.45215620D+03, 5.56381820D+03, 7.64900150D+03, 9.70777200D+03,
     $ 1.17401975D+04, 1.37463476D+04, 1.57262937D+04, 1.76801088D+04,
     $ 1.96078678D+04, 2.15096470D+04, 2.33855244D+04, 2.52355792D+04,
     $ 2.70598920D+04, 2.88585447D+04, 3.06316197D+04, 3.23792006D+04,
     $ 3.41013713D+04, 3.57982160D+04, 3.74698188D+04, 3.91162639D+04,
     $ 4.07376343D+04/
      data ( EXEN( 43,J,2),J=1,21) /
     $ 3.30116310D+03, 5.36768780D+03, 7.40889900D+03, 9.42485840D+03,
     $ 1.14156291D+04, 1.33812761D+04, 1.53218658D+04, 1.72374663D+04,
     $ 1.91281473D+04, 2.09939798D+04, 2.28350365D+04, 2.46513911D+04,
     $ 2.64431187D+04, 2.82102953D+04, 2.99529980D+04, 3.16713046D+04,
     $ 3.33652934D+04, 3.50350430D+04, 3.66806322D+04, 3.83021396D+04,
     $ 3.98996435D+04/
      data ( EXEN( 44,J,1),J=1,21) /
     $ 3.61555210D+03, 5.72570890D+03, 7.80938700D+03, 9.86665230D+03,
     $ 1.18975727D+04, 1.39022177D+04, 1.58806587D+04, 1.78329689D+04,
     $ 1.97592230D+04, 2.16594975D+04, 2.35338703D+04, 2.53824206D+04,
     $ 2.72052292D+04, 2.90023777D+04, 3.07739489D+04, 3.25200260D+04,
     $ 3.42406930D+04, 3.59360342D+04, 3.76061337D+04, 3.92510754D+04,
     $ 4.08709424D+04/
      data ( EXEN( 44,J,2),J=1,21) /
     $ 3.45745430D+03, 5.52257220D+03, 7.56237670D+03, 9.57692930D+03,
     $ 1.15662933D+04, 1.35305336D+04, 1.54697167D+04, 1.73839107D+04,
     $ 1.92731852D+04, 2.11376115D+04, 2.29772619D+04, 2.47922104D+04,
     $ 2.65825321D+04, 2.83483030D+04, 3.00896001D+04, 3.18065013D+04,
     $ 3.34990848D+04, 3.51674293D+04, 3.68116134D+04, 3.84317159D+04,
     $ 4.00278149D+04/
      data ( EXEN( 45,J,1),J=1,21) /
     $ 3.78265460D+03, 5.89127120D+03, 7.97340910D+03, 1.00291343D+04,
     $ 1.20585145D+04, 1.40616194D+04, 1.60385204D+04, 1.79892905D+04,
     $ 1.99140047D+04, 2.18127394D+04, 2.36855726D+04, 2.55325834D+04,
     $ 2.73538527D+04, 2.91494620D+04, 3.09194942D+04, 3.26640325D+04,
     $ 3.43831609D+04, 3.60769635D+04, 3.77455245D+04, 3.93889278D+04,
     $ 4.10072564D+04/
      data ( EXEN( 45,J,2),J=1,21) /
     $ 3.61729480D+03, 5.68097330D+03, 7.71933830D+03, 9.73245150D+03,
     $ 1.17203761D+04, 1.36831770D+04, 1.56209207D+04, 1.75336754D+04,
     $ 1.94215108D+04, 2.12844979D+04, 2.31227095D+04, 2.49362192D+04,
     $ 2.67251022D+04, 2.84894346D+04, 3.02292934D+04, 3.19447564D+04,
     $ 3.36359018D+04, 3.53028084D+04, 3.69455548D+04, 3.85642196D+04,
     $ 4.01588808D+04/
      data ( EXEN( 46,J,1),J=1,21) /
     $ 3.95345740D+03, 6.06049880D+03, 8.14106150D+03, 1.01952115D+04,
     $ 1.22230165D+04, 1.42245462D+04, 1.61998721D+04, 1.81490672D+04,
     $ 2.00722065D+04, 2.19693664D+04, 2.38406248D+04, 2.56860612D+04,
     $ 2.75057560D+04, 2.92997912D+04, 3.10682493D+04, 3.28112137D+04,
     $ 3.45287684D+04, 3.62209974D+04, 3.78879849D+04, 3.95298146D+04,
     $ 4.11465696D+04/
      data ( EXEN( 46,J,2),J=1,21) /
     $ 3.78067900D+03, 5.84288530D+03, 7.87977820D+03, 9.89141920D+03,
     $ 1.18778716D+04, 1.38392003D+04, 1.57754720D+04, 1.76867547D+04,
     $ 1.95731181D+04, 2.14346334D+04, 2.32713732D+04, 2.50834114D+04,
     $ 2.68708230D+04, 2.86336841D+04, 3.03720719D+04, 3.20860639D+04,
     $ 3.37757386D+04, 3.54411745D+04, 3.70824503D+04, 3.86996446D+04,
     $ 4.02928353D+04/
      data ( EXEN( 47,J,1),J=1,21) /
     $ 4.12795390D+03, 6.23338510D+03, 8.31233760D+03, 1.03648774D+04,
     $ 1.23910722D+04, 1.43909917D+04, 1.63647074D+04, 1.83122925D+04,
     $ 2.02338218D+04, 2.21293718D+04, 2.39990205D+04, 2.58428472D+04,
     $ 2.76609327D+04, 2.94533586D+04, 3.12202076D+04, 3.29615630D+04,
     $ 3.46775089D+04, 3.63681292D+04, 3.80335081D+04, 3.96737292D+04,
     $ 4.12888756D+04/
      data ( EXEN( 47,J,2),J=1,21) /
     $ 3.94760080D+03, 6.00830220D+03, 8.04369020D+03, 1.00538262D+04,
     $ 1.20387738D+04, 1.39985977D+04, 1.59333645D+04, 1.78431424D+04,
     $ 1.97280012D+04, 2.15880119D+04, 2.34232473D+04, 2.52337811D+04,
     $ 2.70196885D+04, 2.87810457D+04, 3.05179295D+04, 3.22304179D+04,
     $ 3.39185890D+04, 3.55825215D+04, 3.72222940D+04, 3.88379849D+04,
     $ 4.04296723D+04/
      data ( EXEN( 48,J,1),J=1,21) /
     $ 4.30613740D+03, 6.40992340D+03, 8.48723070D+03, 1.05381252D+04,
     $ 1.25626748D+04, 1.45609491D+04, 1.65330196D+04, 1.84789596D+04,
     $ 2.03988439D+04, 2.22927489D+04, 2.41607528D+04, 2.60029349D+04,
     $ 2.78193759D+04, 2.96101574D+04, 3.13753622D+04, 3.31150737D+04,
     $ 3.48293757D+04, 3.65183522D+04, 3.81820874D+04, 3.98206648D+04,
     $ 4.14341674D+04/
      data ( EXEN( 48,J,2),J=1,21) /
     $ 4.11805420D+03, 6.17721790D+03, 8.21106820D+03, 1.02196667D+04,
     $ 1.22030765D+04, 1.41613628D+04, 1.60945921D+04, 1.80028325D+04,
     $ 1.98861538D+04, 2.17446272D+04, 2.35783254D+04, 2.53873221D+04,
     $ 2.71716926D+04, 2.89315130D+04, 3.06668602D+04, 3.23778121D+04,
     $ 3.40644469D+04, 3.57268432D+04, 3.73650795D+04, 3.89792344D+04,
     $ 4.05693856D+04/
      data ( EXEN( 49,J,1),J=1,21) /
     $ 4.48800110D+03, 6.59010690D+03, 8.66573390D+03, 1.07149482D+04,
     $ 1.27378175D+04, 1.47344115D+04, 1.67048019D+04, 1.86490616D+04,
     $ 2.05672658D+04, 2.24594909D+04, 2.43258150D+04, 2.61663173D+04,
     $ 2.79810787D+04, 2.97701809D+04, 3.15337065D+04, 3.32717388D+04,
     $ 3.49843618D+04, 3.66716595D+04, 3.83337158D+04, 3.99706144D+04,
     $ 4.15824382D+04/
      data ( EXEN( 49,J,2),J=1,21) /
     $ 4.29203270D+03, 6.34962610D+03, 8.38190610D+03, 1.03889341D+04,
     $ 1.23707737D+04, 1.43274896D+04, 1.62591485D+04, 1.81658187D+04,
     $ 2.00475698D+04, 2.19044731D+04, 2.37366013D+04, 2.55440282D+04,
     $ 2.73268290D+04, 2.90850798D+04, 3.08188577D+04, 3.25282403D+04,
     $ 3.42133060D+04, 3.58741333D+04, 3.75108007D+04, 3.91233866D+04,
     $ 4.07119690D+04/
      data ( EXEN( 50,J,1),J=1,21) /
     $ 4.67353800D+03, 6.77392860D+03, 8.84784030D+03, 1.08953393D+04,
     $ 1.29164933D+04, 1.49113721D+04, 1.68800471D+04, 1.88225917D+04,
     $ 2.07390807D+04, 2.26295908D+04, 2.44941999D+04, 2.63329875D+04,
     $ 2.81460342D+04, 2.99334219D+04, 3.16952332D+04, 3.34315514D+04,
     $ 3.51424603D+04, 3.68280440D+04, 3.84883864D+04, 4.01235711D+04,
     $ 4.17336808D+04/
      data ( EXEN( 50,J,2),J=1,21) /
     $ 4.46953010D+03, 6.52552050D+03, 8.55619730D+03, 1.05616223D+04,
     $ 1.25418587D+04, 1.44969716D+04, 1.64270274D+04, 1.83320946D+04,
     $ 2.02122427D+04, 2.20675432D+04, 2.38980687D+04, 2.57038930D+04,
     $ 2.74850913D+04, 2.92417398D+04, 3.09739155D+04, 3.26816961D+04,
     $ 3.43651599D+04, 3.60243853D+04, 3.76594510D+04, 3.92704353D+04,
     $ 4.08574159D+04/
      data ( EXEN( 51,J,1),J=1,21) /
     $ 4.86274100D+03, 6.96138130D+03, 9.03354280D+03, 1.10792914D+04,
     $ 1.30986951D+04, 1.50918235D+04, 1.70587483D+04, 1.89995426D+04,
     $ 2.09142814D+04, 2.28030414D+04, 2.46659005D+04, 2.65029382D+04,
     $ 2.83142353D+04, 3.00998734D+04, 3.18599352D+04, 3.35945041D+04,
     $ 3.53036639D+04, 3.69874985D+04, 3.86460919D+04, 4.02795275D+04,
     $ 4.18878880D+04/
      data ( EXEN( 51,J,2),J=1,21) /
     $ 4.65053990D+03, 6.70489450D+03, 8.73393550D+03, 1.07377247D+04,
     $ 1.27163252D+04, 1.46698022D+04, 1.65982223D+04, 1.85016536D+04,
     $ 2.03801661D+04, 2.22338310D+04, 2.40627209D+04, 2.58669098D+04,
     $ 2.76464729D+04, 2.94014863D+04, 3.11320270D+04, 3.28381728D+04,
     $ 3.45200019D+04, 3.61775927D+04, 3.78110239D+04, 3.94203736D+04,
     $ 4.10057197D+04/
      data ( EXEN( 52,J,1),J=1,21) /
     $ 5.05560280D+03, 7.15245790D+03, 9.22283410D+03, 1.12667973D+04,
     $ 1.32844156D+04, 1.52757587D+04, 1.72408980D+04, 1.91799070D+04,
     $ 2.10928606D+04, 2.29798354D+04, 2.48409094D+04, 2.66761622D+04,
     $ 2.84856745D+04, 3.02695279D+04, 3.20278052D+04, 3.37605898D+04,
     $ 3.54679653D+04, 3.71500157D+04, 3.88068249D+04, 4.04384763D+04,
     $ 4.20450525D+04/
      data ( EXEN( 52,J,2),J=1,21) /
     $ 4.83505550D+03, 6.88774150D+03, 8.91511400D+03, 1.09172346D+04,
     $ 1.28941665D+04, 1.48459749D+04, 1.67727264D+04, 1.86744892D+04,
     $ 2.05513332D+04, 2.24033297D+04, 2.42305513D+04, 2.60330721D+04,
     $ 2.78109671D+04, 2.95643126D+04, 3.12931856D+04, 3.29976638D+04,
     $ 3.46778254D+04, 3.63337488D+04, 3.79655126D+04, 3.95731950D+04,
     $ 4.11568736D+04/
      data ( EXEN( 53,J,1),J=1,21) /
     $ 5.25211600D+03, 7.34715090D+03, 9.41570670D+03, 1.14578496D+04,
     $ 1.34736475D+04, 1.54631701D+04, 1.74264890D+04, 1.93636776D+04,
     $ 2.12748109D+04, 2.31599654D+04, 2.50192193D+04, 2.68526521D+04,
     $ 2.86603444D+04, 3.04423781D+04, 3.21988358D+04, 3.39298008D+04,
     $ 3.56353570D+04, 3.73155881D+04, 3.89705780D+04, 4.06004100D+04,
     $ 4.22051668D+04/
      data ( EXEN( 53,J,2),J=1,21) /
     $ 5.02306990D+03, 7.07405480D+03, 9.09972600D+03, 1.11001452D+04,
     $ 1.30753758D+04, 1.50254829D+04, 1.69505330D+04, 1.88505945D+04,
     $ 2.07257373D+04, 2.25760326D+04, 2.44015532D+04, 2.62023730D+04,
     $ 2.79785672D+04, 2.97302120D+04, 3.14573844D+04, 3.31601622D+04,
     $ 3.48386235D+04, 3.64928467D+04, 3.81229103D+04, 3.97288925D+04,
     $ 4.13108709D+04/
      data ( EXEN( 54,J,1),J=1,21) /
     $ 5.45227320D+03, 7.54545270D+03, 9.61215320D+03, 1.16524406D+04,
     $ 1.36663830D+04, 1.56540502D+04, 1.76155136D+04, 1.95508468D+04,
     $ 2.14601246D+04, 2.33434238D+04, 2.52008225D+04, 2.70324001D+04,
     $ 2.88382375D+04, 3.06184163D+04, 3.23730193D+04, 3.41021297D+04,
     $ 3.58058313D+04, 3.74842080D+04, 3.91373434D+04, 4.07653209D+04,
     $ 4.23682230D+04/
      data ( EXEN( 54,J,2),J=1,21) /
     $ 5.21457650D+03, 7.26382730D+03, 9.28776450D+03, 1.12864497D+04,
     $ 1.32599462D+04, 1.52083192D+04, 1.71316352D+04, 1.90299627D+04,
     $ 2.09033714D+04, 2.27519328D+04, 2.45757195D+04, 2.63748056D+04,
     $ 2.81492662D+04, 2.98991775D+04, 3.16246166D+04, 3.33256611D+04,
     $ 3.50023892D+04, 3.66548794D+04, 3.82832100D+04, 3.98874592D+04,
     $ 4.14677044D+04/
      data ( EXEN( 55,J,1),J=1,21) /
     $ 5.65606650D+03, 7.74735570D+03, 9.81216580D+03, 1.18505628D+04,
     $ 1.38626147D+04, 1.58483913D+04, 1.78079642D+04, 1.97414068D+04,
     $ 2.16487941D+04, 2.35302029D+04, 2.53857113D+04, 2.72153987D+04,
     $ 2.90193460D+04, 3.07976348D+04, 3.25503479D+04, 3.42775686D+04,
     $ 3.59793806D+04, 3.76558676D+04, 3.93071134D+04, 4.09332012D+04,
     $ 4.25342135D+04/
      data ( EXEN( 55,J,2),J=1,21) /
     $ 5.40956800D+03, 7.45705220D+03, 9.47922270D+03, 1.14761410D+04,
     $ 1.34478707D+04, 1.53944768D+04, 1.73160259D+04, 1.92125866D+04,
     $ 2.10842285D+04, 2.29310231D+04, 2.47530432D+04, 2.65503628D+04,
     $ 2.83230570D+04, 3.00712020D+04, 3.17948749D+04, 3.34941534D+04,
     $ 3.51691155D+04, 3.68198398D+04, 3.84464046D+04, 4.00488879D+04,
     $ 4.16273671D+04/
      data ( EXEN( 56,J,1),J=1,21) /
     $ 5.86348810D+03, 7.95285210D+03, 1.00157367D+04, 1.20522082D+04,
     $ 1.40623345D+04, 1.60461855D+04, 1.80038328D+04, 1.99353498D+04,
     $ 2.18408116D+04, 2.37202949D+04, 2.55738778D+04, 2.74016399D+04,
     $ 2.92036619D+04, 3.09800257D+04, 3.27308139D+04, 3.44561097D+04,
     $ 3.61559968D+04, 3.78305590D+04, 3.94798801D+04, 4.11040430D+04,
     $ 4.27031302D+04/
      data ( EXEN( 56,J,2),J=1,21) /
     $ 5.60803740D+03, 7.65372220D+03, 9.67409320D+03, 1.16692120D+04,
     $ 1.36391421D+04, 1.55839485D+04, 1.75036981D+04, 1.93984590D+04,
     $ 2.12683014D+04, 2.31132965D+04, 2.49335172D+04, 2.67290374D+04,
     $ 2.84999324D+04, 3.02462783D+04, 3.19681522D+04, 3.36656318D+04,
     $ 3.53387952D+04, 3.69877207D+04, 3.86124868D+04, 4.02131713D+04,
     $ 4.17898517D+04/
      data ( EXEN( 57,J,1),J=1,21) /
     $ 6.07453020D+03, 8.16193380D+03, 1.02228580D+04, 1.22573689D+04,
     $ 1.42655346D+04, 1.62474249D+04, 1.82031115D+04, 2.01326678D+04,
     $ 2.20361690D+04, 2.39136916D+04, 2.57653140D+04, 2.75911157D+04,
     $ 2.93911774D+04, 3.11655809D+04, 3.29144090D+04, 3.46377447D+04,
     $ 3.63356719D+04, 3.80082742D+04, 3.96556353D+04, 4.12778382D+04,
     $ 4.28749651D+04/
      data ( EXEN( 57,J,2),J=1,21) /
     $ 5.80997740D+03, 7.85383010D+03, 9.87236880D+03, 1.18656553D+04,
     $ 1.38337531D+04, 1.57767271D+04, 1.76946442D+04, 1.95875728D+04,
     $ 2.14555828D+04, 2.32987456D+04, 2.51171340D+04, 2.69108221D+04,
     $ 2.86798850D+04, 3.04243990D+04, 3.21444411D+04, 3.38400890D+04,
     $ 3.55114208D+04, 3.71585147D+04, 3.87814492D+04, 4.03803021D+04,
     $ 4.19551508D+04/
      data ( EXEN( 58,J,1),J=1,21) /
     $ 6.28918460D+03, 8.37459270D+03, 1.04335214D+04, 1.24660368D+04,
     $ 1.44722068D+04, 1.64521014D+04, 1.84057922D+04, 2.03333527D+04,
     $ 2.22348581D+04, 2.41103850D+04, 2.59600118D+04, 2.77838179D+04,
     $ 2.95818842D+04, 3.13542924D+04, 3.31011251D+04, 3.48224657D+04,
     $ 3.65183978D+04, 3.81890050D+04, 3.98343709D+04, 4.14545785D+04,
     $ 4.30497099D+04/
      data ( EXEN( 58,J,2),J=1,21) /
     $ 6.01538060D+03, 8.05736840D+03, 1.00740421D+04, 1.20654636D+04,
     $ 1.40316962D+04, 1.59728051D+04, 1.78888570D+04, 1.97799204D+04,
     $ 2.16460653D+04, 2.34873630D+04, 2.53038864D+04, 2.70957095D+04,
     $ 2.88629075D+04, 3.06055568D+04, 3.23237342D+04, 3.40175175D+04,
     $ 3.56869848D+04, 3.73322143D+04, 3.89532843D+04, 4.05502727D+04,
     $ 4.21232568D+04/
      data ( EXEN( 59,J,1),J=1,21) /
     $ 6.50744290D+03, 8.59082070D+03, 1.06477189D+04, 1.26782036D+04,
     $ 1.46823428D+04, 1.66602066D+04, 1.86118666D+04, 2.05373962D+04,
     $ 2.24368707D+04, 2.43103669D+04, 2.61579628D+04, 2.79797383D+04,
     $ 2.97757739D+04, 3.15461516D+04, 3.32909540D+04, 3.50102642D+04,
     $ 3.67041659D+04, 3.83727428D+04, 4.00160784D+04, 4.16342555D+04,
     $ 4.32273562D+04/
      data ( EXEN( 59,J,2),J=1,21) /
     $ 6.22423940D+03, 8.26432960D+03, 1.02791056D+04, 1.22686293D+04,
     $ 1.42329640D+04, 1.61721749D+04, 1.80863289D+04, 1.99754943D+04,
     $ 2.18397412D+04, 2.36791410D+04, 2.54937665D+04, 2.72836918D+04,
     $ 2.90489922D+04, 3.07897439D+04, 3.25060238D+04, 3.41979097D+04,
     $ 3.58654796D+04, 3.75088118D+04, 3.91279845D+04, 4.07230755D+04,
     $ 4.22941620D+04/
      data ( EXEN( 60,J,1),J=1,21) /
     $ 6.72929690D+03, 8.81060930D+03, 1.08654418D+04, 1.28938608D+04,
     $ 1.48959343D+04, 1.68717322D+04, 1.88213262D+04, 2.07447899D+04,
     $ 2.26421984D+04, 2.45136286D+04, 2.63591587D+04, 2.81788683D+04,
     $ 2.99728382D+04, 3.17411502D+04, 3.34838870D+04, 3.52011317D+04,
     $ 3.68929680D+04, 3.85594793D+04, 4.02007493D+04, 4.18168606D+04,
     $ 4.34078953D+04/
      data ( EXEN( 60,J,2),J=1,21) /
     $ 6.43654620D+03, 8.47470600D+03, 1.04875515D+04, 1.24751446D+04,
     $ 1.44375487D+04, 1.63748289D+04, 1.82870521D+04, 2.01742868D+04,
     $ 2.20366029D+04, 2.38740720D+04, 2.56867668D+04, 2.74747615D+04,
     $ 2.92381314D+04, 3.09769526D+04, 3.26913022D+04, 3.43812578D+04,
     $ 3.60468975D+04, 3.76882996D+04, 3.93055420D+04, 4.08987027D+04,
     $ 4.24678586D+04/
      data ( EXEN( 61,J,1),J=1,21) /
     $ 6.95473800D+03, 9.03394990D+03, 1.10866818D+04, 1.31130001D+04,
     $ 1.51129727D+04, 1.70866696D+04, 1.90341625D+04, 2.09555252D+04,
     $ 2.28508326D+04, 2.47201617D+04, 2.65635908D+04, 2.83811994D+04,
     $ 3.01730684D+04, 3.19392796D+04, 3.36799156D+04, 3.53950596D+04,
     $ 3.70847952D+04, 3.87492058D+04, 4.03883750D+04, 4.20023853D+04,
     $ 4.35913188D+04/
      data ( EXEN( 61,J,2),J=1,21) /
     $ 6.65229300D+03, 8.68848980D+03, 1.06993721D+04, 1.26850019D+04,
     $ 1.46454425D+04, 1.65807593D+04, 1.84910189D+04, 2.03762900D+04,
     $ 2.22366426D+04, 2.40721481D+04, 2.58828794D+04, 2.76689107D+04,
     $ 2.94303172D+04, 3.11671751D+04, 3.28795615D+04, 3.45675540D+04,
     $ 3.62312306D+04, 3.78706695D+04, 3.94859488D+04, 4.10771463D+04,
     $ 4.26443388D+04/
      data ( EXEN( 62,J,1),J=1,21) /
     $ 7.18375760D+03, 9.26083390D+03, 1.13114302D+04, 1.33356126D+04,
     $ 1.53334492D+04, 1.73050101D+04, 1.92503669D+04, 2.11695933D+04,
     $ 2.30627646D+04, 2.49299575D+04, 2.67712504D+04, 2.85867229D+04,
     $ 3.03764559D+04, 3.21405310D+04, 3.38790311D+04, 3.55920392D+04,
     $ 3.72796388D+04, 3.89419135D+04, 4.05789466D+04, 4.21908207D+04,
     $ 4.37776176D+04/
      data ( EXEN( 62,J,2),J=1,21) /
     $ 6.87147210D+03, 8.90567300D+03, 1.09145594D+04, 1.28981931D+04,
     $ 1.48566376D+04, 1.67899580D+04, 1.86982213D+04, 2.05814960D+04,
     $ 2.24398522D+04, 2.42733613D+04, 2.60820963D+04, 2.78661313D+04,
     $ 2.96255416D+04, 3.13604034D+04, 3.30707937D+04, 3.47567901D+04,
     $ 3.64184708D+04, 3.80559137D+04, 3.96691970D+04, 4.12583982D+04,
     $ 4.28235944D+04/
      data ( EXEN( 63,J,1),J=1,21) /
     $ 7.41634670D+03, 9.49125250D+03, 1.15396781D+04, 1.35616896D+04,
     $ 1.55573552D+04, 1.75267448D+04, 1.94699304D+04, 2.13869855D+04,
     $ 2.32779855D+04, 2.51430070D+04, 2.69821286D+04, 2.87954299D+04,
     $ 3.05829916D+04, 3.23448956D+04, 3.40812245D+04, 3.57920614D+04,
     $ 3.74774899D+04, 3.91375935D+04, 4.07724552D+04, 4.23821578D+04,
     $ 4.39667828D+04/
      data ( EXEN( 63,J,2),J=1,21) /
     $ 7.09407540D+03, 9.12624770D+03, 1.11331054D+04, 1.31147102D+04,
     $ 1.50711257D+04, 1.70024170D+04, 1.89086512D+04, 2.07898967D+04,
     $ 2.26462237D+04, 2.44777036D+04, 2.62844094D+04, 2.80664153D+04,
     $ 2.98237965D+04, 3.15566293D+04, 3.32649906D+04, 3.49489582D+04,
     $ 3.66086099D+04, 3.82440239D+04, 3.98552782D+04, 4.14424503D+04,
     $ 4.30056172D+04/
      data ( EXEN( 64,J,1),J=1,21) /
     $ 7.65249650D+03, 9.72519670D+03, 1.17714165D+04, 1.37912220D+04,
     $ 1.57846815D+04, 1.77518649D+04, 1.96928441D+04, 2.16076928D+04,
     $ 2.34964863D+04, 2.53593014D+04, 2.71962165D+04, 2.90073112D+04,
     $ 3.07926665D+04, 3.25523642D+04, 3.42864867D+04, 3.59951173D+04,
     $ 3.76783395D+04, 3.93362365D+04, 4.09688917D+04, 4.25763874D+04,
     $ 4.41588053D+04/
      data ( EXEN( 64,J,2),J=1,21) /
     $ 7.32009460D+03, 9.35020560D+03, 1.13550018D+04, 1.33345450D+04,
     $ 1.52888987D+04, 1.72181282D+04, 1.91223004D+04, 2.10014839D+04,
     $ 2.28557488D+04, 2.46851667D+04, 2.64898105D+04, 2.82697544D+04,
     $ 3.00250736D+04, 3.17558445D+04, 3.34621440D+04, 3.51440498D+04,
     $ 3.68016397D+04, 3.84349919D+04, 4.00441843D+04, 4.16292943D+04,
     $ 4.31903988D+04/
      data ( EXEN( 65,J,1),J=1,21) /
     $ 7.89219790D+03, 9.96265750D+03, 1.20066364D+04, 1.40242009D+04,
     $ 1.60154191D+04, 1.79803612D+04, 1.99190989D+04, 2.18317060D+04,
     $ 2.37182579D+04, 2.55788313D+04, 2.74135048D+04, 2.92223579D+04,
     $ 3.10054716D+04, 3.27629276D+04, 3.44948086D+04, 3.62011976D+04,
     $ 3.78821782D+04, 3.95378335D+04, 4.11682468D+04, 4.27735004D+04,
     $ 4.43536757D+04/
      data ( EXEN( 65,J,2),J=1,21) /
     $ 7.54952150D+03, 9.57753840D+03, 1.15802404D+04, 1.35576891D+04,
     $ 1.55099483D+04, 1.74370831D+04, 1.93391605D+04, 2.12162492D+04,
     $ 2.30684192D+04, 2.48957423D+04, 2.66982912D+04, 2.84761402D+04,
     $ 3.02293647D+04, 3.19580408D+04, 3.36622455D+04, 3.53420566D+04,
     $ 3.69975518D+04, 3.86288092D+04, 4.02359067D+04, 4.18189217D+04,
     $ 4.33779309D+04/
      data ( EXEN( 66,J,1),J=1,21) /
     $ 8.13544160D+03, 1.02036255D+04, 1.22453285D+04, 1.42606168D+04,
     $ 1.62495588D+04, 1.82122243D+04, 2.01486855D+04, 2.20590159D+04,
     $ 2.39432910D+04, 2.58015876D+04, 2.76339842D+04, 2.94405606D+04,
     $ 3.12213974D+04, 3.29765766D+04, 3.47061808D+04, 3.64102930D+04,
     $ 3.80889967D+04, 3.97423750D+04, 4.13705111D+04, 4.29734872D+04,
     $ 4.45513847D+04/
      data ( EXEN( 66,J,2),J=1,21) /
     $ 7.78234760D+03, 9.80823770D+03, 1.18088126D+04, 1.37841342D+04,
     $ 1.57342660D+04, 1.76592733D+04, 1.95592232D+04, 2.14341842D+04,
     $ 2.32842265D+04, 2.51094218D+04, 2.69098430D+04, 2.86855643D+04,
     $ 3.04366610D+04, 3.21632094D+04, 3.38652866D+04, 3.55429700D+04,
     $ 3.71963375D+04, 3.88254672D+04, 4.04304368D+04, 4.20113238D+04,
     $ 4.35682047D+04/
      data ( EXEN( 67,J,1),J=1,21) /
     $ 8.38221830D+03, 1.04480914D+04, 1.24874834D+04, 1.45004606D+04,
     $ 1.64870911D+04, 1.84474451D+04, 2.03815945D+04, 2.22896130D+04,
     $ 2.41715762D+04, 2.60275608D+04, 2.78576454D+04, 2.96619097D+04,
     $ 3.14404346D+04, 3.31933018D+04, 3.49205939D+04, 3.66223940D+04,
     $ 3.82987855D+04, 3.99498515D+04, 4.15756751D+04, 4.31763385D+04,
     $ 4.47519227D+04/
      data ( EXEN( 67,J,2),J=1,21) /
     $ 8.01856430D+03, 1.00422948D+04, 1.20407099D+04, 1.40138715D+04,
     $ 1.59618432D+04, 1.78846902D+04, 1.97824797D+04, 2.16552802D+04,
     $ 2.35031620D+04, 2.53261966D+04, 2.71244572D+04, 2.88980179D+04,
     $ 3.06469541D+04, 3.23713419D+04, 3.40712585D+04, 3.57467813D+04,
     $ 3.73979882D+04, 3.90249572D+04, 4.06277661D+04, 4.22064920D+04,
     $ 4.37612115D+04/
      data ( EXEN( 68,J,1),J=1,21) /
     $ 8.63251850D+03, 1.06960457D+04, 1.27330917D+04, 1.47437225D+04,
     $ 1.67280065D+04, 1.86860137D+04, 2.06178163D+04, 2.25234879D+04,
     $ 2.44031039D+04, 2.62567414D+04, 2.80844788D+04, 2.98863958D+04,
     $ 3.16625734D+04, 3.34130933D+04, 3.51380381D+04, 3.68374909D+04,
     $ 3.85115349D+04, 4.01602534D+04, 4.17837291D+04, 4.33820443D+04,
     $ 4.49552800D+04/
      data ( EXEN( 68,J,2),J=1,21) /
     $ 8.25816290D+03, 1.02797011D+04, 1.22759237D+04, 1.42468925D+04,
     $ 1.61926712D+04, 1.81133252D+04, 2.00089214D+04, 2.18795285D+04,
     $ 2.37252169D+04, 2.55460581D+04, 2.73421252D+04, 2.91134924D+04,
     $ 3.08602350D+04, 3.25824294D+04, 3.42801525D+04, 3.59534818D+04,
     $ 3.76024951D+04, 3.92272705D+04, 4.08278855D+04, 4.24044174D+04,
     $ 4.39569426D+04/
      data ( EXEN( 69,J,1),J=1,21) /
     $ 8.88633240D+03, 1.09474788D+04, 1.29821436D+04, 1.49903930D+04,
     $ 1.69722953D+04, 1.89279208D+04, 2.08573413D+04, 2.27606307D+04,
     $ 2.46378644D+04, 2.64891196D+04, 2.83144745D+04, 3.01140091D+04,
     $ 3.18878042D+04, 3.36359416D+04, 3.53585038D+04, 3.70555740D+04,
     $ 3.87272352D+04, 4.03735707D+04, 4.19946633D+04, 4.35905950D+04,
     $ 4.51614466D+04/
      data ( EXEN( 69,J,2),J=1,21) /
     $ 8.50113470D+03, 1.05204478D+04, 1.25144450D+04, 1.44831883D+04,
     $ 1.64267412D+04, 1.83451692D+04, 2.02385394D+04, 2.21069203D+04,
     $ 2.39503824D+04, 2.57689973D+04, 2.75628380D+04, 2.93319788D+04,
     $ 3.10764950D+04, 3.27964630D+04, 3.44919596D+04, 3.61630624D+04,
     $ 3.78098492D+04, 3.94323979D+04, 4.10307862D+04, 4.26050910D+04,
     $ 4.41553887D+04/
      data ( EXEN( 70,J,1),J=1,21) /
     $ 9.14365040D+03, 1.12023808D+04, 1.32346294D+04, 1.52404623D+04,
     $ 1.72199478D+04, 1.91731562D+04, 2.11001596D+04, 2.30010316D+04,
     $ 2.48758479D+04, 2.67246855D+04, 2.85476228D+04, 3.03447397D+04,
     $ 3.21161171D+04, 3.38618367D+04, 3.55819811D+04, 3.72766333D+04,
     $ 3.89458764D+04, 4.05897937D+04, 4.22084677D+04, 4.38019804D+04,
     $ 4.53704126D+04/
      data ( EXEN( 70,J,2),J=1,21) /
     $ 8.74747060D+03, 1.07645258D+04, 1.27562649D+04, 1.47227498D+04,
     $ 1.66640442D+04, 1.85802134D+04, 2.04713247D+04, 2.23374466D+04,
     $ 2.41786495D+04, 2.59950052D+04, 2.77865866D+04, 2.95534681D+04,
     $ 3.12957250D+04, 3.30134336D+04, 3.47066708D+04, 3.63755142D+04,
     $ 3.80200415D+04, 3.96403306D+04, 4.12364589D+04, 4.28085036D+04,
     $ 4.43565409D+04/
      data ( EXEN( 71,J,1),J=1,21) /
     $ 9.40446240D+03, 1.14607418D+04, 1.34905390D+04, 1.54939203D+04,
     $ 1.74709540D+04, 1.94217103D+04, 2.13462613D+04, 2.32446808D+04,
     $ 2.51170444D+04, 2.69634292D+04, 2.87839137D+04, 3.05785777D+04,
     $ 3.23475020D+04, 3.40907685D+04, 3.58084598D+04, 3.75006587D+04,
     $ 3.91674484D+04, 4.08089120D+04, 4.24251321D+04, 4.40161905D+04,
     $ 4.55821678D+04/
      data ( EXEN( 71,J,2),J=1,21) /
     $ 8.99716170D+03, 1.10119262D+04, 1.30013744D+04, 1.49655681D+04,
     $ 1.69045711D+04, 1.88184487D+04, 2.07072682D+04, 2.25710982D+04,
     $ 2.44100091D+04, 2.62240726D+04, 2.80133619D+04, 2.97779511D+04,
     $ 3.15179158D+04, 3.32333320D+04, 3.49242769D+04, 3.65908279D+04,
     $ 3.82330627D+04, 3.98510591D+04, 4.14448946D+04, 4.30146461D+04,
     $ 4.45603898D+04/
      data ( EXEN( 72,J,1),J=1,21) /
     $ 9.66875850D+03, 1.17225518D+04, 1.37498626D+04, 1.57507571D+04,
     $ 1.77253037D+04, 1.96735727D+04, 2.15956362D+04, 2.34915680D+04,
     $ 2.53614438D+04, 2.72053406D+04, 2.90233370D+04, 3.08155127D+04,
     $ 3.25819488D+04, 3.43227269D+04, 3.60379297D+04, 3.77276400D+04,
     $ 3.93919410D+04, 4.10309156D+04, 4.26446464D+04, 4.42332150D+04,
     $ 4.57967020D+04/
      data ( EXEN( 72,J,2),J=1,21) /
     $ 9.25019860D+03, 1.12626397D+04, 1.32497642D+04, 1.52116339D+04,
     $ 1.71483127D+04, 1.90598658D+04, 2.09463607D+04, 2.28078659D+04,
     $ 2.46444519D+04, 2.64561904D+04, 2.82431545D+04, 3.00054186D+04,
     $ 3.17430580D+04, 3.34561490D+04, 3.51447686D+04, 3.68089942D+04,
     $ 3.84489034D+04, 4.00645741D+04, 4.16560837D+04, 4.32235090D+04,
     $ 4.47669260D+04/
      data ( EXEN( 73,J,1),J=1,21) /
     $ 9.93652830D+03, 1.19878005D+04, 1.40125898D+04, 1.60109624D+04,
     $ 1.79829869D+04, 1.99287334D+04, 2.18482741D+04, 2.37416831D+04,
     $ 2.56090357D+04, 2.74504093D+04, 2.92658823D+04, 3.10555346D+04,
     $ 3.28194471D+04, 3.45577016D+04, 3.62703806D+04, 3.79575670D+04,
     $ 3.96193438D+04, 4.12557940D+04, 4.28670000D+04, 4.44530434D+04,
     $ 4.60140046D+04/
      data ( EXEN( 73,J,2),J=1,21) /
     $ 9.50657200D+03, 1.15166569D+04, 1.35014249D+04, 1.54609378D+04,
     $ 1.73952595D+04, 1.93044554D+04, 2.11885927D+04, 2.30477403D+04,
     $ 2.48819685D+04, 2.66913490D+04, 2.84759552D+04, 3.02358612D+04,
     $ 3.19711424D+04, 3.36818752D+04, 3.53681364D+04, 3.70300036D+04,
     $ 3.86675543D+04, 4.02808662D+04, 4.18700168D+04, 4.34350827D+04,
     $ 4.49761399D+04/
      data ( EXEN( 74,J,1),J=1,21) /
     $ 1.02077617D+04, 1.22564776D+04, 1.42787102D+04, 1.62745258D+04,
     $ 1.82439930D+04, 2.01871819D+04, 2.21041647D+04, 2.39950155D+04,
     $ 2.58598099D+04, 2.76986250D+04, 2.95115394D+04, 3.12986329D+04,
     $ 3.30599865D+04, 3.47956820D+04, 3.65058019D+04, 3.81904290D+04,
     $ 3.98496463D+04, 4.14835367D+04, 4.30921825D+04, 4.46756652D+04,
     $ 4.62340650D+04/
      data ( EXEN( 74,J,2),J=1,21) /
     $ 9.76627260D+03, 1.17739685D+04, 1.37563471D+04, 1.57134704D+04,
     $ 1.76454022D+04, 1.95522080D+04, 2.14339549D+04, 2.32907119D+04,
     $ 2.51225494D+04, 2.69295391D+04, 2.87117542D+04, 3.04692692D+04,
     $ 3.22021593D+04, 3.39105008D+04, 3.55943708D+04, 3.72538465D+04,
     $ 3.88890056D+04, 4.04999258D+04, 4.20866842D+04, 4.36493577D+04,
     $ 4.51880220D+04/
      data ( EXEN( 75,J,1),J=1,21) /
     $ 1.04824481D+04, 1.25285726D+04, 1.45482134D+04, 1.65414369D+04,
     $ 1.85083115D+04, 2.04489076D+04, 2.23632974D+04, 2.42515549D+04,
     $ 2.61137557D+04, 2.79499770D+04, 2.97602975D+04, 3.15447970D+04,
     $ 3.33035564D+04, 3.50366576D+04, 3.67441830D+04, 3.84262154D+04,
     $ 4.00828378D+04, 4.17141329D+04, 4.33201831D+04, 4.49010696D+04,
     $ 4.64568726D+04/
      data ( EXEN( 75,J,2),J=1,21) /
     $ 1.00292906D+04, 1.20345647D+04, 1.40145212D+04, 1.59692221D+04,
     $ 1.78987311D+04, 1.98031139D+04, 2.16824376D+04, 2.35367711D+04,
     $ 2.53661849D+04, 2.71707509D+04, 2.89505421D+04, 3.07056330D+04,
     $ 3.24360990D+04, 3.41420164D+04, 3.58234619D+04, 3.74805132D+04,
     $ 3.91132477D+04, 4.07217430D+04, 4.23060763D+04, 4.38663242D+04,
     $ 4.54025623D+04/
      data ( EXEN( 76,J,1),J=1,21) /
     $ 1.07605768D+04, 1.28040749D+04, 1.48210888D+04, 1.68116850D+04,
     $ 1.87759320D+04, 2.07139000D+04, 2.26256615D+04, 2.45112904D+04,
     $ 2.63708624D+04, 2.82044547D+04, 3.00121460D+04, 3.17940162D+04,
     $ 3.35501461D+04, 3.52806176D+04, 3.69855131D+04, 3.86649154D+04,
     $ 4.03189075D+04, 4.19475719D+04, 4.35509909D+04, 4.51292458D+04,
     $ 4.66824164D+04/
      data ( EXEN( 76,J,2),J=1,21) /
     $ 1.02956164D+04, 1.22984360D+04, 1.42759375D+04, 1.62281831D+04,
     $ 1.81552366D+04, 2.00571634D+04, 2.19340310D+04, 2.37859081D+04,
     $ 2.56128654D+04, 2.74149746D+04, 2.91923090D+04, 3.09449429D+04,
     $ 3.26729518D+04, 3.43764119D+04, 3.60554001D+04, 3.77099938D+04,
     $ 3.93402706D+04, 4.09463079D+04, 4.25281829D+04, 4.40859721D+04,
     $ 4.56197510D+04/
      data ( EXEN( 77,J,1),J=1,21) /
     $ 1.10421372D+04, 1.30829737D+04, 1.50973256D+04, 1.70852593D+04,
     $ 1.90468434D+04, 2.09821483D+04, 2.28912462D+04, 2.47742113D+04,
     $ 2.66311192D+04, 2.84620473D+04, 3.02670741D+04, 3.20462796D+04,
     $ 3.37997446D+04, 3.55275511D+04, 3.72297814D+04, 3.89065182D+04,
     $ 4.05578444D+04, 4.21838427D+04, 4.37845951D+04, 4.53601827D+04,
     $ 4.69106853D+04/
      data ( EXEN( 77,J,2),J=1,21) /
     $ 1.05652402D+04, 1.25655724D+04, 1.45405862D+04, 1.64903436D+04,
     $ 1.84149086D+04, 2.03143467D+04, 2.21887252D+04, 2.40381131D+04,
     $ 2.58625808D+04, 2.76622004D+04, 2.94370449D+04, 3.11871888D+04,
     $ 3.29127076D+04, 3.46136774D+04, 3.62901753D+04, 3.79422784D+04,
     $ 3.95700644D+04, 4.11736106D+04, 4.27529942D+04, 4.43082915D+04,
     $ 4.58395780D+04/
      data ( EXEN( 78,J,1),J=1,21) /
     $ 1.13271183D+04, 1.33652581D+04, 1.53769128D+04, 1.73621489D+04,
     $ 1.93210350D+04, 2.12536415D+04, 2.31600407D+04, 2.50403067D+04,
     $ 2.68945153D+04, 2.87227437D+04, 3.05250707D+04, 3.23015762D+04,
     $ 3.40523410D+04, 3.57774470D+04, 3.74769766D+04, 3.91510126D+04,
     $ 4.07996375D+04, 4.24229342D+04, 4.40209844D+04, 4.55938692D+04,
     $ 4.71416683D+04/
      data ( EXEN( 78,J,2),J=1,21) /
     $ 1.08381520D+04, 1.28359640D+04, 1.48084572D+04, 1.67556936D+04,
     $ 1.86777373D+04, 2.05746537D+04, 2.24465102D+04, 2.42933759D+04,
     $ 2.61153212D+04, 2.79124181D+04, 2.96847398D+04, 3.14323608D+04,
     $ 3.31553564D+04, 3.48538030D+04, 3.65277773D+04, 3.81773568D+04,
     $ 3.98026189D+04, 4.14036409D+04, 4.29804999D+04, 4.45332722D+04,
     $ 4.60620330D+04/
      data ( EXEN( 79,J,1),J=1,21) /
     $ 1.16155091D+04, 1.36509171D+04, 1.56598395D+04, 1.76423428D+04,
     $ 1.95984957D+04, 2.15283685D+04, 2.34320337D+04, 2.53095653D+04,
     $ 2.71610393D+04, 2.89865329D+04, 3.07861247D+04, 3.25598948D+04,
     $ 3.43079240D+04, 3.60302943D+04, 3.77270878D+04, 3.93983873D+04,
     $ 4.10442756D+04, 4.26648351D+04, 4.42601476D+04, 4.58302941D+04,
     $ 4.73753540D+04/
      data ( EXEN( 79,J,2),J=1,21) /
     $ 1.11143417D+04, 1.31096006D+04, 1.50795404D+04, 1.70242230D+04,
     $ 1.89437125D+04, 2.08380743D+04, 2.27073760D+04, 2.45516865D+04,
     $ 2.63710764D+04, 2.81656177D+04, 2.99353836D+04, 3.16804486D+04,
     $ 3.34008880D+04, 3.50967783D+04, 3.67681961D+04, 3.84152188D+04,
     $ 4.00379239D+04, 4.16363886D+04, 4.32106898D+04, 4.47609038D+04,
     $ 4.62871057D+04/
      data ( EXEN( 80,J,1),J=1,21) /
     $ 1.19072985D+04, 1.39399395D+04, 1.59460944D+04, 1.79258298D+04,
     $ 1.98792142D+04, 2.18063181D+04, 2.37072141D+04, 2.55819761D+04,
     $ 2.74306801D+04, 2.92534035D+04, 3.10502248D+04, 3.28212242D+04,
     $ 3.45664825D+04, 3.62860814D+04, 3.79801034D+04, 3.96486311D+04,
     $ 4.12917472D+04, 4.29095340D+04, 4.45020732D+04, 4.60694457D+04,
     $ 4.76117308D+04/
      data ( EXEN( 80,J,2),J=1,21) /
     $ 1.13937991D+04, 1.33864722D+04, 1.53538257D+04, 1.72959216D+04,
     $ 1.92128239D+04, 2.11045983D+04, 2.29713122D+04, 2.48130346D+04,
     $ 2.66298362D+04, 2.84217888D+04, 3.01889659D+04, 3.19314419D+04,
     $ 3.36492921D+04, 3.53425929D+04, 3.70114211D+04, 3.86558540D+04,
     $ 4.02759689D+04, 4.18718431D+04, 4.34435534D+04, 4.49911759D+04,
     $ 4.65147856D+04/
      data ( EXEN( 81,J,1),J=1,21) /
     $ 1.22024751D+04, 1.42323140D+04, 1.62356663D+04, 1.82125985D+04,
     $ 2.01631792D+04, 2.20874791D+04, 2.39855705D+04, 2.58575276D+04,
     $ 2.77034264D+04, 2.95233442D+04, 3.13173597D+04, 3.30855529D+04,
     $ 3.48280048D+04, 3.65447971D+04, 3.82360121D+04, 3.99017324D+04,
     $ 4.15420407D+04, 4.31570193D+04, 4.47467497D+04, 4.63113127D+04,
     $ 4.78507873D+04/
      data ( EXEN( 81,J,2),J=1,21) /
     $ 1.16765139D+04, 1.36665683D+04, 1.56313026D+04, 1.75707790D+04,
     $ 1.94850613D+04, 2.13742153D+04, 2.32383084D+04, 2.50774098D+04,
     $ 2.68915900D+04, 2.86809211D+04, 3.04454763D+04, 3.21853302D+04,
     $ 3.39005582D+04, 3.55912365D+04, 3.72574420D+04, 3.88992518D+04,
     $ 4.05167434D+04, 4.21099939D+04, 4.36790801D+04, 4.52240778D+04,
     $ 4.67450621D+04/
      data ( EXEN( 82,J,1),J=1,21) /
     $ 1.25010275D+04, 1.45280292D+04, 1.65285437D+04, 1.85026375D+04,
     $ 2.04503793D+04, 2.23718398D+04, 2.42670914D+04, 2.61362083D+04,
     $ 2.79792665D+04, 2.97963434D+04, 3.15875177D+04, 3.33528694D+04,
     $ 3.50924794D+04, 3.68064296D+04, 3.84948021D+04, 4.01576796D+04,
     $ 4.17951447D+04, 4.34072794D+04, 4.49941654D+04, 4.65558831D+04,
     $ 4.80925115D+04/
      data ( EXEN( 82,J,2),J=1,21) /
     $ 1.19624755D+04, 1.39498785D+04, 1.59119608D+04, 1.78487847D+04,
     $ 1.97604141D+04, 2.16469148D+04, 2.35083542D+04, 2.53448016D+04,
     $ 2.71563274D+04, 2.89430039D+04, 3.07049042D+04, 3.24421030D+04,
     $ 3.41546756D+04, 3.58426984D+04, 3.75062480D+04, 3.91454017D+04,
     $ 4.07602368D+04, 4.23508304D+04, 4.39172592D+04, 4.54595990D+04,
     $ 4.69779245D+04/
      data ( EXEN( 83,J,1),J=1,21) /
     $ 1.28029442D+04, 1.48270735D+04, 1.68247149D+04, 1.87959352D+04,
     $ 2.07408029D+04, 2.26593887D+04, 2.45517652D+04, 2.64180066D+04,
     $ 2.82581889D+04, 3.00723894D+04, 3.18606871D+04, 3.36231619D+04,
     $ 3.53598946D+04, 3.70709672D+04, 3.87564618D+04, 4.04164609D+04,
     $ 4.20510471D+04, 4.36603024D+04, 4.52443083D+04, 4.68031451D+04,
     $ 4.83368916D+04/
      data ( EXEN( 83,J,2),J=1,21) /
     $ 1.22516735D+04, 1.42363921D+04, 1.61957896D+04, 1.81299281D+04,
     $ 2.00388717D+04, 2.19226861D+04, 2.37814389D+04, 2.56151992D+04,
     $ 2.74240377D+04, 2.92080265D+04, 3.09672390D+04, 3.27017496D+04,
     $ 3.44116338D+04, 3.60969678D+04, 3.77578284D+04, 3.93942929D+04,
     $ 4.10064383D+04, 4.25943418D+04, 4.41580799D+04, 4.56977285D+04,
     $ 4.72133619D+04/
      data ( EXEN( 84,J,1),J=1,21) /
     $ 1.31082134D+04, 1.51294351D+04, 1.71241683D+04, 1.90924798D+04,
     $ 2.10344381D+04, 2.29501140D+04, 2.48395801D+04, 2.67029106D+04,
     $ 2.85401816D+04, 3.03514705D+04, 3.21368562D+04, 3.38964185D+04,
     $ 3.56302386D+04, 3.73383980D+04, 3.90209791D+04, 4.06780643D+04,
     $ 4.23097361D+04, 4.39160764D+04, 4.54971665D+04, 4.70530867D+04,
     $ 4.85839156D+04/
      data ( EXEN( 84,J,2),J=1,21) /
     $ 1.25440971D+04, 1.45260985D+04, 1.64827782D+04, 1.84141985D+04,
     $ 2.03204233D+04, 2.22015185D+04, 2.40575517D+04, 2.58885920D+04,
     $ 2.76947102D+04, 2.94759783D+04, 3.12324698D+04, 3.29642591D+04,
     $ 3.46714217D+04, 3.63540339D+04, 3.80121724D+04, 3.96459143D+04,
     $ 4.12553369D+04, 4.28405171D+04, 4.44015313D+04, 4.59384552D+04,
     $ 4.74513633D+04/
      data ( EXEN( 85,J,1),J=1,21) /
     $ 1.34168233D+04, 1.54351022D+04, 1.74268921D+04, 1.93922594D+04,
     $ 2.13312731D+04, 2.32440038D+04, 2.51305242D+04, 2.69909085D+04,
     $ 2.88252328D+04, 3.06335747D+04, 3.24160129D+04, 3.41726274D+04,
     $ 3.59034992D+04, 3.76087101D+04, 3.92883421D+04, 4.09424778D+04,
     $ 4.25711995D+04, 4.41745891D+04, 4.57527279D+04, 4.73056957D+04,
     $ 4.88335712D+04/
      data ( EXEN( 85,J,2),J=1,21) /
     $ 1.28397354D+04, 1.48189867D+04, 1.67729159D+04, 1.87015850D+04,
     $ 2.06050581D+04, 2.24834011D+04, 2.43366817D+04, 2.61649690D+04,
     $ 2.79683338D+04, 2.97468482D+04, 3.15005856D+04, 3.32296206D+04,
     $ 3.49340285D+04, 3.66138857D+04, 3.82692689D+04, 3.99002552D+04,
     $ 4.15069216D+04, 4.30893452D+04, 4.46476022D+04, 4.61817682D+04,
     $ 4.76919176D+04/
      data ( EXEN( 86,J,1),J=1,21) /
     $ 1.37287619D+04, 1.57440629D+04, 1.77328741D+04, 1.96952622D+04,
     $ 2.16312959D+04, 2.35410461D+04, 2.54245854D+04, 2.72819881D+04,
     $ 2.91133304D+04, 3.09186898D+04, 3.26981450D+04, 3.44517763D+04,
     $ 3.61796644D+04, 3.78818911D+04, 3.95585385D+04, 4.12096892D+04,
     $ 4.28354252D+04, 4.44358284D+04, 4.60109800D+04, 4.75609598D+04,
     $ 4.90858460D+04/
      data ( EXEN( 86,J,2),J=1,21) /
     $ 1.31385776D+04, 1.51150460D+04, 1.70661916D+04, 1.89920766D+04,
     $ 2.08927651D+04, 2.27683230D+04, 2.46188179D+04, 2.64443192D+04,
     $ 2.82448976D+04, 3.00206252D+04, 3.17715754D+04, 3.34978229D+04,
     $ 3.51994430D+04, 3.68765121D+04, 3.85291068D+04, 4.01573041D+04,
     $ 4.17611812D+04, 4.33408149D+04, 4.48962814D+04, 4.64276562D+04,
     $ 4.79350133D+04/
      data ( EXEN( 87,J,1),J=1,21) /
     $ 1.40440171D+04, 1.60563050D+04, 1.80421023D+04, 2.00014758D+04,
     $ 2.19344943D+04, 2.38412286D+04, 2.57217515D+04, 2.75761373D+04,
     $ 2.94044622D+04, 3.12068036D+04, 3.29832405D+04, 3.47338529D+04,
     $ 3.64587218D+04, 3.81579288D+04, 3.98315561D+04, 4.14796860D+04,
     $ 4.31024006D+04, 4.46997819D+04, 4.62719106D+04, 4.78188665D+04,
     $ 4.93407276D+04/
      data ( EXEN( 87,J,2),J=1,21) /
     $ 1.34406124D+04, 1.54142650D+04, 1.73625942D+04, 1.92856622D+04,
     $ 2.11835331D+04, 2.30562729D+04, 2.49039492D+04, 2.67266314D+04,
     $ 2.85243903D+04, 3.02972980D+04, 3.20454280D+04, 3.37688549D+04,
     $ 3.54676540D+04, 3.71419018D+04, 3.87916747D+04, 4.04170499D+04,
     $ 4.20181044D+04, 4.35949149D+04, 4.51475575D+04, 4.66761077D+04,
     $ 4.81806393D+04/
      data ( EXEN( 88,J,1),J=1,21) /
     $ 1.43625766D+04, 1.63718161D+04, 1.83545643D+04, 2.03108880D+04,
     $ 2.22408560D+04, 2.41445392D+04, 2.60220102D+04, 2.78733437D+04,
     $ 2.96986157D+04, 3.14979037D+04, 3.32712868D+04, 3.50188449D+04,
     $ 3.67406589D+04, 3.84368107D+04, 4.01073822D+04, 4.17524557D+04,
     $ 4.33721134D+04, 4.49664368D+04, 4.65355069D+04, 4.80794031D+04,
     $ 4.95982033D+04/
      data ( EXEN( 88,J,2),J=1,21) /
     $ 1.37458288D+04, 1.57166328D+04, 1.76621126D+04, 1.95823306D+04,
     $ 2.14773509D+04, 2.33472396D+04, 2.51920643D+04, 2.70118944D+04,
     $ 2.88068007D+04, 3.05768554D+04, 3.23221320D+04, 3.40427051D+04,
     $ 3.57386502D+04, 3.74100433D+04, 3.90569614D+04, 4.06794812D+04,
     $ 4.22776797D+04, 4.38516337D+04, 4.54014191D+04, 4.69271112D+04,
     $ 4.84287838D+04/
      data ( EXEN( 89,J,1),J=1,21) /
     $ 1.46844281D+04, 1.66905841D+04, 1.86702479D+04, 2.06234864D+04,
     $ 2.25503686D+04, 2.44509652D+04, 2.63253491D+04, 2.81735948D+04,
     $ 2.99957785D+04, 3.17919777D+04, 3.35622714D+04, 3.53067396D+04,
     $ 3.70254633D+04, 3.87185242D+04, 4.03860043D+04, 4.20279858D+04,
     $ 4.36445507D+04, 4.52357807D+04, 4.68017563D+04, 4.83425570D+04,
     $ 4.98582604D+04/
      data ( EXEN( 89,J,2),J=1,21) /
     $ 1.40542154D+04, 1.60221377D+04, 1.79647353D+04, 1.98820704D+04,
     $ 2.17742072D+04, 2.36412117D+04, 2.54831518D+04, 2.73000967D+04,
     $ 2.90921173D+04, 3.08592859D+04, 3.26016760D+04, 3.43193622D+04,
     $ 3.60124199D+04, 3.76809253D+04, 3.93249551D+04, 4.09445862D+04,
     $ 4.25398956D+04, 4.41109597D+04, 4.56578545D+04, 4.71806552D+04,
     $ 4.86794352D+04/
      data ( EXEN( 90,J,1),J=1,21) /
     $ 1.50095590D+04, 1.70125962D+04, 1.89891404D+04, 2.09392585D+04,
     $ 2.28630195D+04, 2.47604942D+04, 2.66317556D+04, 2.84768781D+04,
     $ 3.02959379D+04, 3.20890128D+04, 3.38561816D+04, 3.55975244D+04,
     $ 3.73131222D+04, 3.90030566D+04, 4.06674096D+04, 4.23062633D+04,
     $ 4.39196998D+04, 4.55078005D+04, 4.70706458D+04, 4.86083151D+04,
     $ 5.01208858D+04/
      data ( EXEN( 90,J,2),J=1,21) /
     $ 1.43657607D+04, 1.63307686D+04, 1.82704509D+04, 2.01848701D+04,
     $ 2.20740904D+04, 2.39381778D+04, 2.57772001D+04, 2.75912267D+04,
     $ 2.93803286D+04, 3.11445780D+04, 3.28840484D+04, 3.45988145D+04,
     $ 3.62889516D+04, 3.79545361D+04, 3.95956444D+04, 4.12123535D+04,
     $ 4.28047403D+04, 4.43728811D+04, 4.59168520D+04, 4.74367277D+04,
     $ 4.89325818D+04/
      data ( EXEN( 91,J,1),J=1,21) /
     $ 1.53379567D+04, 1.73378398D+04, 1.93112292D+04, 2.12581915D+04,
     $ 2.31787960D+04, 2.50731134D+04, 2.69412168D+04, 2.87831806D+04,
     $ 3.05990812D+04, 3.23889963D+04, 3.41530046D+04, 3.58911865D+04,
     $ 3.76036227D+04, 3.92903949D+04, 4.09515852D+04, 4.25872755D+04,
     $ 4.41975478D+04, 4.57824833D+04, 4.73421625D+04, 4.88766645D+04,
     $ 5.03860665D+04/
      data ( EXEN( 91,J,2),J=1,21) /
     $ 1.46804532D+04, 1.66425136D+04, 1.85792478D+04, 2.04907182D+04,
     $ 2.23769889D+04, 2.42381261D+04, 2.60741976D+04, 2.78852729D+04,
     $ 2.96714229D+04, 3.14327199D+04, 3.31692375D+04, 3.48810502D+04,
     $ 3.65682336D+04, 3.82308637D+04, 3.98690173D+04, 4.14827711D+04,
     $ 4.30722019D+04, 4.46373862D+04, 4.61783996D+04, 4.76953169D+04,
     $ 4.91882115D+04/
      data ( EXEN( 92,J,1),J=1,21) /
     $ 1.56696084D+04, 1.76663022D+04, 1.96365013D+04, 2.15802726D+04,
     $ 2.34976852D+04, 2.53888100D+04, 2.72537199D+04, 2.90924897D+04,
     $ 3.09051955D+04, 3.26919151D+04, 3.44527275D+04, 3.61877128D+04,
     $ 3.78969518D+04, 3.95805262D+04, 4.12385180D+04, 4.28710091D+04,
     $ 4.44780814D+04, 4.60598160D+04, 4.76162932D+04, 4.91475919D+04,
     $ 5.06537892D+04/
      data ( EXEN( 92,J,2),J=1,21) /
     $ 1.49982811D+04, 1.69573612D+04, 1.88911143D+04, 2.07996028D+04,
     $ 2.26828909D+04, 2.45410449D+04, 2.63741326D+04, 2.81822234D+04,
     $ 2.99653884D+04, 3.17236999D+04, 3.34572314D+04, 3.51660576D+04,
     $ 3.68502539D+04, 3.85098965D+04, 4.01450620D+04, 4.17558271D+04,
     $ 4.33422686D+04, 4.49044628D+04, 4.64424853D+04, 4.79564107D+04,
     $ 4.94463122D+04/
      data ( EXEN( 93,J,1),J=1,21) /
     $ 1.60045011D+04, 1.79979704D+04, 1.99649440D+04, 2.19054889D+04,
     $ 2.38196742D+04, 2.57075709D+04, 2.75692519D+04, 2.94047921D+04,
     $ 3.12142676D+04, 3.29977563D+04, 3.47553371D+04, 3.64870902D+04,
     $ 3.81930964D+04, 3.98734373D+04, 4.15281948D+04, 4.31574510D+04,
     $ 4.47612874D+04, 4.63397852D+04, 4.78930246D+04, 4.94210841D+04,
     $ 5.09240406D+04/
      data ( EXEN( 93,J,2),J=1,21) /
     $ 1.53192327D+04, 1.72752995D+04, 1.92060385D+04, 2.11115121D+04,
     $ 2.29917847D+04, 2.48469223D+04, 2.66769930D+04, 2.84820663D+04,
     $ 3.02622131D+04, 3.20175058D+04, 3.37480181D+04, 3.54538245D+04,
     $ 3.71350005D+04, 3.87916223D+04, 4.04237664D+04, 4.20315095D+04,
     $ 4.36149282D+04, 4.51740989D+04, 4.67090970D+04, 4.82199970D+04,
     $ 4.97068719D+04/
      data ( EXEN( 94,J,1),J=1,21) /
     $ 1.63426219D+04, 1.83328314D+04, 2.02965441D+04, 2.22338272D+04,
     $ 2.41447498D+04, 2.60293830D+04, 2.78877997D+04, 2.97200748D+04,
     $ 3.15262845D+04, 3.33065066D+04, 3.50608203D+04, 3.67893054D+04,
     $ 3.84920431D+04, 4.01691148D+04, 4.18206024D+04, 4.34465877D+04,
     $ 4.50471525D+04, 4.66223776D+04, 4.81723431D+04, 4.96971274D+04,
     $ 5.11968072D+04/
      data ( EXEN( 94,J,2),J=1,21) /
     $ 1.56432959D+04, 1.75963165D+04, 1.95240085D+04, 2.14264342D+04,
     $ 2.33036581D+04, 2.51557464D+04, 2.69827670D+04, 2.87847895D+04,
     $ 3.05618850D+04, 3.23141258D+04, 3.40415856D+04, 3.57443389D+04,
     $ 3.74224614D+04, 3.90760289D+04, 4.07051182D+04, 4.23098059D+04,
     $ 4.38901685D+04, 4.54462822D+04, 4.69782224D+04, 4.84860634D+04,
     $ 4.99698780D+04/
      data ( EXEN( 95,J,1),J=1,21) /
     $ 1.66839575D+04, 1.86708718D+04, 2.06312884D+04, 2.25652744D+04,
     $ 2.44728988D+04, 2.63542330D+04, 2.82093499D+04, 3.00383243D+04,
     $ 3.18412327D+04, 3.36181527D+04, 3.53691635D+04, 3.70943452D+04,
     $ 3.87937786D+04, 4.04675453D+04, 4.21157271D+04, 4.37384059D+04,
     $ 4.53356631D+04, 4.69075796D+04, 4.84542352D+04, 4.99757082D+04,
     $ 5.14720751D+04/
      data ( EXEN( 95,J,2),J=1,21) /
     $ 1.59704588D+04, 1.79204002D+04, 1.98450121D+04, 2.17443569D+04,
     $ 2.36184991D+04, 2.54675049D+04, 2.72914423D+04, 2.90903809D+04,
     $ 3.08643919D+04, 3.26135475D+04, 3.43379216D+04, 3.60375886D+04,
     $ 3.77126241D+04, 3.93631042D+04, 4.09891053D+04, 4.25907041D+04,
     $ 4.41679771D+04, 4.57210003D+04, 4.72498490D+04, 4.87545974D+04,
     $ 5.02353181D+04/
      data ( EXEN( 96,J,1),J=1,21) /
     $ 1.70284947D+04, 1.90120785D+04, 2.09691635D+04, 2.28998169D+04,
     $ 2.48041078D+04, 2.66821076D+04, 2.85338891D+04, 3.03595274D+04,
     $ 3.21590988D+04, 3.39326811D+04, 3.56803534D+04, 3.74021958D+04,
     $ 3.90982892D+04, 4.07687152D+04, 4.24135554D+04, 4.40328917D+04,
     $ 4.56268054D+04, 4.71953774D+04, 4.87386871D+04, 5.02568128D+04,
     $ 5.17498307D+04/
      data ( EXEN( 96,J,2),J=1,21) /
     $ 1.63007091D+04, 1.82475384D+04, 2.01690372D+04, 2.20652680D+04,
     $ 2.39362954D+04, 2.57821856D+04, 2.76030067D+04, 2.93988282D+04,
     $ 3.11697214D+04, 3.29157587D+04, 3.46370137D+04, 3.63335611D+04,
     $ 3.80054763D+04, 3.96528355D+04, 4.12757151D+04, 4.28741916D+04,
     $ 4.44483415D+04, 4.59982407D+04, 4.75239644D+04, 4.90255865D+04,
     $ 5.05031796D+04/
      data ( EXEN( 97,J,1),J=1,21) /
     $ 1.73762198D+04, 1.93564378D+04, 2.13101560D+04, 2.32374414D+04,
     $ 2.51383633D+04, 2.70129931D+04, 2.88614038D+04, 3.06836703D+04,
     $ 3.24798691D+04, 3.42500780D+04, 3.59943762D+04, 3.77128436D+04,
     $ 3.94055613D+04, 4.10726107D+04, 4.27140735D+04, 4.43300314D+04,
     $ 4.59205658D+04, 4.74857571D+04, 4.90256850D+04, 5.05404272D+04,
     $ 5.20300599D+04/
      data ( EXEN( 97,J,2),J=1,21) /
     $ 1.66340345D+04, 1.85777186D+04, 2.04960713D+04, 2.23891551D+04,
     $ 2.42570346D+04, 2.60997761D+04, 2.79174477D+04, 2.97101190D+04,
     $ 3.14778612D+04, 3.32207468D+04, 3.49388495D+04, 3.66322440D+04,
     $ 3.83010056D+04, 3.99452104D+04, 4.15649350D+04, 4.31602557D+04,
     $ 4.47312490D+04, 4.62779907D+04, 4.78005557D+04, 4.92990180D+04,
     $ 5.07734498D+04/
      data ( EXEN( 98,J,1),J=1,21) /
     $ 1.77271195D+04, 1.97039363D+04, 2.16542522D+04, 2.35781342D+04,
     $ 2.54756517D+04, 2.73468760D+04, 2.91918802D+04, 3.10107394D+04,
     $ 3.28035300D+04, 3.45703298D+04, 3.63112181D+04, 3.80262749D+04,
     $ 3.97155810D+04, 4.13792180D+04, 4.30172675D+04, 4.46298111D+04,
     $ 4.62169301D+04, 4.77787048D+04, 4.93152147D+04, 5.08265374D+04,
     $ 5.23127487D+04/
      data ( EXEN( 98,J,2),J=1,21) /
     $ 1.69704226D+04, 1.89109286D+04, 2.08261021D+04, 2.27160058D+04,
     $ 2.45807043D+04, 2.64202639D+04, 2.82347528D+04, 3.00242406D+04,
     $ 3.17887987D+04, 3.35284994D+04, 3.52434164D+04, 3.69336245D+04,
     $ 3.85991991D+04, 4.02402163D+04, 4.18567524D+04, 4.34488838D+04,
     $ 4.50166869D+04, 4.65602374D+04, 4.80796102D+04, 4.95748790D+04,
     $ 5.10461157D+04/
      data ( EXEN( 99,J,1),J=1,21) /
     $ 1.80811798D+04, 2.00545602D+04, 2.20014383D+04, 2.39218815D+04,
     $ 2.58159590D+04, 2.76837423D+04, 2.95253046D+04, 3.13407208D+04,
     $ 3.31300675D+04, 3.48934226D+04, 3.66308652D+04, 3.83424755D+04,
     $ 4.00283343D+04, 4.16885231D+04, 4.33231233D+04, 4.49322167D+04,
     $ 4.65158842D+04, 4.80742063D+04, 4.96072620D+04, 5.11151290D+04,
     $ 5.25978826D+04/
      data ( EXEN( 99,J,2),J=1,21) /
     $ 1.73098608D+04, 1.92471556D+04, 2.11591170D+04, 2.30458075D+04,
     $ 2.49072918D+04, 2.67436364D+04, 2.85549094D+04, 3.03411805D+04,
     $ 3.21025211D+04, 3.38390035D+04, 3.55507016D+04, 3.72376900D+04,
     $ 3.89000442D+04, 4.05378402D+04, 4.21511543D+04, 4.37400630D+04,
     $ 4.53046424D+04, 4.68449681D+04, 4.83611149D+04, 4.98531564D+04,
     $ 5.13211644D+04/
      data ( EXEN(100,J,1),J=1,21) /
     $ 1.84383871D+04, 2.04082955D+04, 2.23517005D+04, 2.42686694D+04,
     $ 2.61592714D+04, 2.80235781D+04, 2.98616628D+04, 3.16736004D+04,
     $ 3.34594676D+04, 3.52193422D+04, 3.69533035D+04, 3.86614315D+04,
     $ 4.03438071D+04, 4.20005117D+04, 4.36316268D+04, 4.52372339D+04,
     $ 4.68174140D+04, 4.83722473D+04, 4.99018128D+04, 5.14061877D+04,
     $ 5.28854474D+04/
      data ( EXEN(100,J,2),J=1,21) /
     $ 1.76523365D+04, 1.95863871D+04, 2.14951032D+04, 2.33785474D+04,
     $ 2.52367845D+04, 2.70698808D+04, 2.88779047D+04, 3.06609259D+04,
     $ 3.24190156D+04, 3.41522465D+04, 3.58606923D+04, 3.75444276D+04,
     $ 3.92035279D+04, 4.08380693D+04, 4.24481279D+04, 4.40337802D+04,
     $ 4.55951023D+04, 4.71321696D+04, 4.86450568D+04, 5.01338372D+04,
     $ 5.15985826D+04/
      data ( EXEN(101,J,1),J=1,21) /
     $ 1.87987272D+04, 2.07651284D+04, 2.27050248D+04, 2.46184838D+04,
     $ 2.65055749D+04, 2.83663694D+04, 3.02009409D+04, 3.20093643D+04,
     $ 3.37917162D+04, 3.55480746D+04, 3.72785186D+04, 3.89831285D+04,
     $ 4.06619850D+04, 4.23151695D+04, 4.39427635D+04, 4.55448484D+04,
     $ 4.71215049D+04, 4.86728133D+04, 5.01988523D+04, 5.16996990D+04,
     $ 5.31754284D+04/
      data ( EXEN(101,J,2),J=1,21) /
     $ 1.79978368D+04, 1.99286102D+04, 2.18340479D+04, 2.37142127D+04,
     $ 2.55691693D+04, 2.73989842D+04, 2.92037257D+04, 3.09834637D+04,
     $ 3.27382693D+04, 3.44682153D+04, 3.61733754D+04, 3.78538242D+04,
     $ 3.95096372D+04, 4.11408904D+04, 4.27476600D+04, 4.43300224D+04,
     $ 4.58880535D+04, 4.74218287D+04, 4.89314225D+04, 5.04169082D+04,
     $ 5.18783571D+04/
      data ( EXEN(102,J,1),J=1,21) /
     $ 1.91621861D+04, 2.11250445D+04, 2.30613969D+04, 2.49713106D+04,
     $ 2.68548551D+04, 2.87121019D+04, 3.05431245D+04, 3.23479979D+04,
     $ 3.41267989D+04, 3.58796053D+04, 3.76064963D+04, 3.93075522D+04,
     $ 4.09828537D+04, 4.26324822D+04, 4.42565190D+04, 4.58550455D+04,
     $ 4.74281425D+04, 4.89758898D+04, 5.04983660D+04, 5.19956482D+04,
     $ 5.34678109D+04/
      data ( EXEN(102,J,2),J=1,21) /
     $ 1.83463488D+04, 2.02738119D+04, 2.21759381D+04, 2.40527904D+04,
     $ 2.59044334D+04, 2.77309337D+04, 2.95323596D+04, 3.13087810D+04,
     $ 3.30602692D+04, 3.47868969D+04, 3.64887378D+04, 3.81658666D+04,
     $ 3.98183588D+04, 4.14462904D+04, 4.30497374D+04, 4.46287762D+04,
     $ 4.61834827D+04, 4.77139321D+04, 4.92201988D+04, 5.07023558D+04,
     $ 5.21604744D+04/
      data ( EXEN(103,J,1),J=1,21) /
     $ 1.95287495D+04, 2.14880298D+04, 2.34208027D+04, 2.53271355D+04,
     $ 2.72070978D+04, 2.90607613D+04, 3.08881993D+04, 3.26894871D+04,
     $ 3.44647012D+04, 3.62139198D+04, 3.79372221D+04, 3.96346881D+04,
     $ 4.13063987D+04, 4.29524351D+04, 4.45728787D+04, 4.61678108D+04,
     $ 4.77373119D+04, 4.92814619D+04, 5.08003392D+04, 5.22940205D+04,
     $ 5.37625801D+04/
      data ( EXEN(103,J,2),J=1,21) /
     $ 1.86978596D+04, 2.06219792D+04, 2.25207609D+04, 2.43942674D+04,
     $ 2.62425636D+04, 2.80657160D+04, 2.98637930D+04, 3.16368645D+04,
     $ 3.33850019D+04, 3.51082779D+04, 3.68067663D+04, 3.84805417D+04,
     $ 4.01296796D+04, 4.17542559D+04, 4.33543468D+04, 4.49300284D+04,
     $ 4.64813765D+04, 4.80084664D+04, 4.95113722D+04, 5.09901667D+04,
     $ 5.24449210D+04/
      data ( EXEN(104,J,1),J=1,21) /
     $ 1.98984030D+04, 2.18540697D+04, 2.37832275D+04, 2.56859439D+04,
     $ 2.75622885D+04, 2.94123330D+04, 3.12361508D+04, 3.30338171D+04,
     $ 3.48054088D+04, 3.65510037D+04, 3.82706812D+04, 3.99645214D+04,
     $ 4.16326050D+04, 4.32750134D+04, 4.48918278D+04, 4.64831293D+04,
     $ 4.80489984D+04, 4.95895149D+04, 5.11047568D+04, 5.25948008D+04,
     $ 5.40597209D+04/
      data ( EXEN(104,J,2),J=1,21) /
     $ 1.90523558D+04, 2.09730990D+04, 2.28685029D+04, 2.47386305D+04,
     $ 2.65835466D+04, 2.84033179D+04, 3.01980127D+04, 3.19677010D+04,
     $ 3.37124543D+04, 3.54323452D+04, 3.71274475D+04, 3.87978360D+04,
     $ 4.04435860D+04, 4.20647735D+04, 4.36614745D+04, 4.52337652D+04,
     $ 4.67817213D+04, 4.83054179D+04, 4.98049289D+04, 5.12803270D+04,
     $ 5.27316831D+04/
      data ( EXEN(105,J,1),J=1,21) /
     $ 2.02711322D+04, 2.22231498D+04, 2.41486570D+04, 2.60477214D+04,
     $ 2.79204127D+04, 2.97668024D+04, 3.15869642D+04, 3.33809734D+04,
     $ 3.51489067D+04, 3.68908421D+04, 3.86068590D+04, 4.02970374D+04,
     $ 4.19614581D+04, 4.36002023D+04, 4.52133513D+04, 4.68009860D+04,
     $ 4.83631870D+04, 4.99000336D+04, 5.14116039D+04, 5.28979741D+04,
     $ 5.43592181D+04/
      data ( EXEN(105,J,2),J=1,21) /
     $ 1.94098243D+04, 2.13271578D+04, 2.32191509D+04, 2.50858664D+04,
     $ 2.69273692D+04, 2.87437260D+04, 3.05350053D+04, 3.23012770D+04,
     $ 3.40426127D+04, 3.57590851D+04, 3.74507679D+04, 3.91177359D+04,
     $ 4.07600645D+04, 4.23778295D+04, 4.39711071D+04, 4.55399732D+04,
     $ 4.70845035D+04, 4.86047729D+04, 5.01008553D+04, 5.15728231D+04,
     $ 5.30207470D+04/
      data ( EXEN(106,J,1),J=1,21) /
     $ 2.06469223D+04, 2.25952553D+04, 2.45170764D+04, 2.64124532D+04,
     $ 2.82814554D+04, 3.01241548D+04, 3.19406249D+04, 3.37309411D+04,
     $ 3.54951801D+04, 3.72334201D+04, 3.89457404D+04, 4.06322210D+04,
     $ 4.22929428D+04, 4.39279868D+04, 4.55374342D+04, 4.71213660D+04,
     $ 4.86798625D+04, 5.02130029D+04, 5.17208651D+04, 5.32035251D+04,
     $ 5.46610565D+04/
      data ( EXEN(106,J,2),J=1,21) /
     $ 1.97702516D+04, 2.16841424D+04, 2.35726914D+04, 2.54359616D+04,
     $ 2.72740178D+04, 2.90869269D+04, 3.08747573D+04, 3.26375791D+04,
     $ 3.43754638D+04, 3.60884841D+04, 3.77767139D+04, 3.94402278D+04,
     $ 4.10791014D+04, 4.26934103D+04, 4.42832307D+04, 4.58486385D+04,
     $ 4.73897092D+04, 4.89065176D+04, 5.03991375D+04, 5.18676410D+04,
     $ 5.33120986D+04/
      data ( EXEN(107,J,1),J=1,21) /
     $ 2.10257586D+04, 2.29703715D+04, 2.48884709D+04, 2.67801245D+04,
     $ 2.86454019D+04, 3.04843752D+04, 3.22971178D+04, 3.40837052D+04,
     $ 3.58442141D+04, 3.75787228D+04, 3.92873105D+04, 4.09700573D+04,
     $ 4.26270440D+04, 4.42583516D+04, 4.58640613D+04, 4.74442539D+04,
     $ 4.89990096D+04, 5.05284074D+04, 5.20325251D+04, 5.35114383D+04,
     $ 5.49652205D+04/
      data ( EXEN(107,J,2),J=1,21) /
     $ 2.01336242D+04, 2.20440391D+04, 2.39291109D+04, 2.57889025D+04,
     $ 2.76234788D+04, 2.94329068D+04, 3.12172550D+04, 3.29765934D+04,
     $ 3.47109936D+04, 3.64205284D+04, 3.81052716D+04, 3.97652979D+04,
     $ 4.14006828D+04, 4.30115020D+04, 4.45978315D+04, 4.61597472D+04,
     $ 4.76973244D+04, 4.92106380D+04, 5.06997613D+04, 5.21647666D+04,
     $ 5.36057239D+04/
      data ( EXEN(108,J,1),J=1,21) /
     $ 2.14076261D+04, 2.33484834D+04, 2.52628255D+04, 2.71507202D+04,
     $ 2.90122372D+04, 3.08474486D+04, 3.26564279D+04, 3.44392506D+04,
     $ 3.61959935D+04, 3.79267349D+04, 3.96315540D+04, 4.13105310D+04,
     $ 4.29637465D+04, 4.45912816D+04, 4.61932173D+04, 4.77696344D+04,
     $ 4.93206129D+04, 5.08462317D+04, 5.23465683D+04, 5.38216983D+04,
     $ 5.52716946D+04/
      data ( EXEN(108,J,2),J=1,21) /
     $ 2.04999284D+04, 2.24068343D+04, 2.42883956D+04, 2.61446753D+04,
     $ 2.79757385D+04, 2.97816521D+04, 3.15624846D+04, 3.33183062D+04,
     $ 3.50491885D+04, 3.67552042D+04, 3.84364272D+04, 4.00929324D+04,
     $ 4.17247949D+04, 4.33320906D+04, 4.49148955D+04, 4.64732852D+04,
     $ 4.80073352D+04, 4.95171199D+04, 5.10027128D+04, 5.24641857D+04,
     $ 5.39016085D+04/
      data ( EXEN(109,J,1),J=1,21) /
     $ 2.17925099D+04, 2.37295759D+04, 2.56401251D+04, 2.75242252D+04,
     $ 2.93819461D+04, 3.12133598D+04, 3.30185399D+04, 3.47975620D+04,
     $ 3.65505030D+04, 3.82774412D+04, 3.99784556D+04, 4.16536266D+04,
     $ 4.33030348D+04, 4.49267611D+04, 4.65248866D+04, 4.80974918D+04,
     $ 4.96446568D+04, 5.11664601D+04, 5.26629792D+04, 5.41342892D+04,
     $ 5.55804629D+04/
      data ( EXEN(109,J,2),J=1,21) /
     $ 2.08691506D+04, 2.27725142D+04, 2.46505318D+04, 2.65032664D+04,
     $ 2.83307831D+04, 3.01331488D+04, 3.19104323D+04, 3.36627036D+04,
     $ 3.53900344D+04, 3.70924975D+04, 3.87701668D+04, 4.04231170D+04,
     $ 4.20514235D+04, 4.36551620D+04, 4.52344084D+04, 4.67892384D+04,
     $ 4.83197271D+04, 4.98259491D+04, 5.13079775D+04, 5.27658840D+04,
     $ 5.41997382D+04/
      data ( EXEN(110,J,1),J=1,21) /
     $ 2.21803947D+04, 2.41136339D+04, 2.60203545D+04, 2.79006243D+04,
     $ 2.97545133D+04, 3.15820935D+04, 3.33834386D+04, 3.51586242D+04,
     $ 3.69077273D+04, 3.86308261D+04, 4.03279999D+04, 4.19993287D+04,
     $ 4.36448933D+04, 4.52647747D+04, 4.68590536D+04, 4.84278106D+04,
     $ 4.99711255D+04, 5.14890769D+04, 5.29817418D+04, 5.44491952D+04,
     $ 5.58915095D+04/
      data ( EXEN(110,J,2),J=1,21) /
     $ 2.12412767D+04, 2.31410649D+04, 2.50155055D+04, 2.68646616D+04,
     $ 2.86885985D+04, 3.04873830D+04, 3.22610839D+04, 3.40097714D+04,
     $ 3.57335172D+04, 3.74323941D+04, 3.91064760D+04, 4.07558377D+04,
     $ 4.23805544D+04, 4.39807019D+04, 4.55563560D+04, 4.71075923D+04,
     $ 4.86344860D+04, 5.01371112D+04, 5.16155410D+04, 5.30698469D+04,
     $ 5.45000983D+04/
      data ( EXEN(111,J,1),J=1,21) /
     $ 2.25712652D+04, 2.45006420D+04, 2.64034984D+04, 2.82799022D+04,
     $ 3.01299234D+04, 3.19536342D+04, 3.37511084D+04, 3.55224216D+04,
     $ 3.72676508D+04, 3.89868741D+04, 4.06801711D+04, 4.23476216D+04,
     $ 4.39893065D+04, 4.56053065D+04, 4.71957025D+04, 4.87605749D+04,
     $ 5.03000033D+04, 5.18140661D+04, 5.33028402D+04, 5.47664003D+04,
     $ 5.62048184D+04/
      data ( EXEN(111,J,2),J=1,21) /
     $ 2.16162928D+04, 2.35124723D+04, 2.53833027D+04, 2.72288470D+04,
     $ 2.90491706D+04, 3.08443405D+04, 3.26144254D+04, 3.43594956D+04,
     $ 3.60796228D+04, 3.77748799D+04, 3.94453408D+04, 4.10910801D+04,
     $ 4.27121734D+04, 4.43086961D+04, 4.58807240D+04, 4.74283327D+04,
     $ 4.89515972D+04, 5.04505916D+04, 5.19253888D+04, 5.33760599D+04,
     $ 5.48026743D+04/
      data ( EXEN(112,J,1),J=1,21) /
     $ 2.29651060D+04, 2.48905848D+04, 2.67895412D+04, 2.86620432D+04,
     $ 3.05081609D+04, 3.23279665D+04, 3.41215338D+04, 3.58889385D+04,
     $ 3.76302577D+04, 3.93455696D+04, 4.10349535D+04, 4.26984896D+04,
     $ 4.43362584D+04, 4.59483407D+04, 4.75348174D+04, 4.90957687D+04,
     $ 5.06312740D+04, 5.21414117D+04, 5.36262583D+04, 5.50858882D+04,
     $ 5.65203733D+04/
      data ( EXEN(112,J,2),J=1,21) /
     $ 2.19941848D+04, 2.38867224D+04, 2.57539091D+04, 2.75958084D+04,
     $ 2.94124853D+04, 3.12040071D+04, 3.29704425D+04, 3.47118619D+04,
     $ 3.64283369D+04, 3.81199405D+04, 3.97867466D+04, 4.14288299D+04,
     $ 4.30462658D+04, 4.46391298D+04, 4.62074977D+04, 4.77514449D+04,
     $ 4.92710462D+04, 5.07663757D+04, 5.22375061D+04, 5.36845083D+04,
     $ 5.51074513D+04/
C
      call HI ('COEXEN')
C     !BEG
C     !END
      call BYE ('COEXEN')
C
      end
