      subroutine COROTN
C
C     Rudolf Loeser, 1994 Aug 16
C---- Does nothing - just contains data statements
C
C     Initializes CO rotational band arrays with Goorvitch 1994 data.
C     !DASH
      save
C     !DASH
      integer J
C     !COM
C---- LOOM        as of 1994 Dec 16
      integer     JCOLMF,KCOLMF,JCOLMO,KCOLMO,JCOLMS,KCOLMS,
     $            JCOLMR,KCOLMR,JCOMAX,KCOMAX
      parameter   (JCOLMF=111, KCOLMF=20)
      parameter   (JCOLMO=111, KCOLMO=13)
      parameter   (JCOLMS=111, KCOLMS=12)
      parameter   (JCOLMR=53,  KCOLMR=21)
      parameter   (JCOMAX=max(JCOLMF,JCOLMO,JCOLMS,JCOLMR))
      parameter   (KCOMAX=max(KCOLMF,KCOLMO,KCOLMS,KCOLMR))
C     (Be sure to recompile all users of LOOM when changing any
C     of the above parameter values!)
      real*8      WNUPF,WNDNF,WNUPO,WNDNO,WNUPS,WNDNS,WNROT,
     $            FUPF ,FDNF ,FUPO ,FDNO ,FUPS ,FDNS ,FROT ,
     $            EXEN,WVCOLO,WVCOHI,RC1213
      integer     JCOFUN,KCOFUN,JCOOVR,KCOOVR,JCOSEC,KCOSEC,
     $            JCOROT,KCOROT,ISOSLCT,METHCOW,METHCOF
      logical     FUNDCO,OVERCO,SECNCO,ROTACO
C
      dimension   WNUPF(JCOLMF,KCOLMF,2), WNDNF(JCOLMF,KCOLMF,2),
     $            WNUPO(JCOLMO,KCOLMO,2), WNDNO(JCOLMO,KCOLMO,2),
     $            WNUPS(JCOLMS,KCOLMS,2), WNDNS(JCOLMS,KCOLMS,2),
     $            WNROT(JCOLMR,KCOLMR,2),
     $            FUPF(JCOLMF,KCOLMF,2),  FDNF(JCOLMF,KCOLMF,2),
     $            FUPO(JCOLMO,KCOLMO,2),  FDNO(JCOLMO,KCOLMO,2),
     $            FUPS(JCOLMS,KCOLMS,2),  FDNS(JCOLMS,KCOLMS,2),
     $            FROT(JCOLMR,KCOLMR,2),
     $            EXEN(JCOMAX+1,KCOMAX,2)
      dimension   FUNDCO(2),OVERCO(2),SECNCO(2),ROTACO(2),
     $            JCOFUN(2),KCOFUN(2),JCOOVR(2),KCOOVR(2),
     $            JCOSEC(2),KCOSEC(2),JCOROT(2),KCOROT(2)
C
C     Carbon Monoxide lines:  wavenumbers and oscillator strengths.
C
C     WNROT, etc., are for rotational lines     : j'-j=+1, v'-v=0;
C     WNUPF, etc., are for fundamental lines    : j'-j=+1, v'-v=1;
C     WNDNF, etc., are for fundamental lines    : j'-j=-1, v'-v=1;
C     WNUPO, etc., are for first overtone lines : j'-j=+1, v'-v=2;
C     WNDNO, etc., are for first overtone lines : j'-j=-1, v'-v=2;
C     WNUPS, etc., are for second overtone lines: j'-j=+1, v'-v=3;
C     WNDNS, etc., are for second overtone lines: j'-j=-1, v'-v=3.
C
C     This is how the array indices relate to the quantum numbers:
C
C     1. index J corresponds to quantum number j -
C                in WNROT, etc., j = J-1, j' = J
C                in WNUPF, etc., j = J-1, j' = J
C                in WNDNF, etc., j = J  , j' = J-1
C                in WNUPO, etc., j = J-1, j' = J
C                in WNDNO, etc., j = J  , j' = J-1
C                in WNUPS, etc., j = J-1, j' = J
C                in WNDNS, etc., j = J  , j' = J-1
C
C     2. index K corresponds to quantum number v (=nu) -
C                in WNROT, etc.,                 v = K-1, v' = K-1
C                in WNUPF, etc. and WNDNF, etc., v = K-1, v' = K
C                in WNUPO, etc. and WNDNO, etc., v = K-1, v' = K+1
C                in WNUPS, etc. and WNDNS, etc., v = K-1, v' = K+2
C
C     3. index L identifies the Carbon isotope -
C                L=1 for Carbon-12, L=2 for Carbon-13.
C
C     Wavenumbers and energies from:
C        Farrenq, R., Guelachvili, G., Sauval, A.J., Grevesse, N.,
C        and Farmer, C.B. 1991,
C        J.Molec.Spectrosc., 149, 375
C       or
C        Coxon, J.A., and Hajigeorgiou, P.G. 1992,
C        Can.J.Phys., 70, 40-54
C       or
C        Goorvitch, 1994, Ap.J.Suppl.
C     f-values from:
C        Chackerian, C., Jr, and Tipping, R. H. 1983
C        J.Molec.Spectros., 99, 431
C       or
C        "improved" Chackerian
C       or
C        Goorvitch, 1994, Ap.J.Suppl.
C
      common      /LOOM1 / EXEN
      common      /LOOM2 / WNROT,FROT
      common      /LOOM3 / WNUPF,FUPF,WNDNF,FDNF
      common      /LOOM4 / WNUPO,FUPO,WNDNO,FDNO
      common      /LOOM5 / WNUPS,FUPS,WNDNS,FDNS
      common      /LOOM6 / JCOFUN,KCOFUN,JCOOVR,KCOOVR,JCOSEC,KCOSEC,
     $                     JCOROT,KCOROT
      common      /LOOM7 / WVCOLO,WVCOHI
      common      /LOOM8 / FUNDCO,OVERCO,SECNCO,ROTACO
C
C     (These parameters are computed by subroutines WEAVE and FOCA.)
C
      common      /LOOM9 / RC1213
      common      /LOOM10/ ISOSLCT,METHCOW,METHCOF
C
C     RC1213  is the C(12)/C(13) isotopic abundance ratio.
C     ISOSLCT controls which isotopes are included in this calculation:
C     ISOSLCT = 1 means: C(12) only;
C     ISOSLCT = 2 means: C(13) only; and
C     ISOSLCT = 3 means: both C(12) and C(13).
C
C     METHCOF = 1 means: use f-values from Chackerian & Tipping (1983);
C     METHCOF = 2 means: use f-values from "new" Chackerian data;
C     METHCOF = 3 means: use f-values from Goorvitch (1994).
C
C     METHCOW = 1 means: use energies from Farrenq et al.;
C     METHCOW = 2 means: use energies from Coxon & Hajigeorgiou;
C     METHCOW = 3 means: use wave numbers & energies from
C                                                    Goorvitch (1994).
C     .
C     !DASH
      data (WNROT( 1,J,1),J=1,21) /
     $ 3.84500000D+00, 3.81000000D+00, 3.77500000D+00, 3.74000000D+00,
     $ 3.70500000D+00, 3.67000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT( 1,J,1),J=1,21) /
     $ 2.191D-08, 1.295D-08, 6.373D-09, 2.125D-09, 1.583D-10, 4.299D-10,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT( 1,J,2),J=1,21) /
     $ 3.67590000D+00, 3.64320000D+00, 3.61050000D+00, 3.57780000D+00,
     $ 3.54510000D+00, 3.51240000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT( 1,J,2),J=1,21) /
     $ 2.108D-08, 1.265D-08, 6.397D-09, 2.277D-09, 2.450D-10, 2.630D-10,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT( 2,J,1),J=1,21) /
     $ 7.68990000D+00, 7.61990000D+00, 7.54990000D+00, 7.47990000D+00,
     $ 7.40990000D+00, 7.33990000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT( 2,J,1),J=1,21) /
     $ 2.920D-08, 1.725D-08, 8.487D-09, 2.828D-09, 2.095D-10, 5.757D-10,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT( 2,J,2),J=1,21) /
     $ 7.35170000D+00, 7.28630000D+00, 7.22080000D+00, 7.15540000D+00,
     $ 7.09000000D+00, 7.02460000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT( 2,J,2),J=1,21) /
     $ 2.808D-08, 1.685D-08, 8.520D-09, 3.030D-09, 3.249D-10, 3.523D-10,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT( 3,J,1),J=1,21) /
     $ 1.15345000D+01, 1.14295000D+01, 1.13245000D+01, 1.12195000D+01,
     $ 1.11145000D+01, 1.10095000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT( 3,J,1),J=1,21) /
     $ 3.938D-08, 2.326D-08, 1.144D-08, 3.804D-09, 2.794D-10, 7.830D-10,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT( 3,J,2),J=1,21) /
     $ 1.10272000D+01, 1.09291000D+01, 1.08309000D+01, 1.07328000D+01,
     $ 1.06347000D+01, 1.05366000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT( 3,J,2),J=1,21) /
     $ 3.788D-08, 2.272D-08, 1.148D-08, 4.078D-09, 4.346D-10, 4.802D-10,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT( 4,J,1),J=1,21) /
     $ 1.53787000D+01, 1.52386000D+01, 1.50986000D+01, 1.49586000D+01,
     $ 1.48186000D+01, 1.46787000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT( 4,J,1),J=1,21) /
     $ 4.993D-08, 2.949D-08, 1.449D-08, 4.809D-09, 3.486D-10, 1.005D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT( 4,J,2),J=1,21) /
     $ 1.47023000D+01, 1.45715000D+01, 1.44406000D+01, 1.43098000D+01,
     $ 1.41789000D+01, 1.40481000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT( 4,J,2),J=1,21) /
     $ 4.803D-08, 2.880D-08, 1.454D-08, 5.156D-09, 5.446D-10, 6.173D-10,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT( 5,J,1),J=1,21) /
     $ 1.92222000D+01, 1.90472000D+01, 1.88722000D+01, 1.86972000D+01,
     $ 1.85222000D+01, 1.83472000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT( 5,J,1),J=1,21) /
     $ 6.056D-08, 3.574D-08, 1.753D-08, 5.808D-09, 4.140D-10, 1.238D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT( 5,J,2),J=1,21) /
     $ 1.83769000D+01, 1.82133000D+01, 1.80498000D+01, 1.78862000D+01,
     $ 1.77227000D+01, 1.75591000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT( 5,J,2),J=1,21) /
     $ 5.826D-08, 3.491D-08, 1.761D-08, 6.232D-09, 6.506D-10, 7.622D-10,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT( 6,J,1),J=1,21) /
     $ 2.30651000D+01, 2.28550000D+01, 2.26450000D+01, 2.24350000D+01,
     $ 2.22250000D+01, 2.20151000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT( 6,J,1),J=1,21) /
     $ 7.118D-08, 4.198D-08, 2.057D-08, 6.792D-09, 4.742D-10, 1.482D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT( 6,J,2),J=1,21) /
     $ 2.20508000D+01, 2.18545000D+01, 2.16582000D+01, 2.14620000D+01,
     $ 2.12657000D+01, 2.10695000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT( 6,J,2),J=1,21) /
     $ 6.849D-08, 4.102D-08, 2.066D-08, 7.293D-09, 7.505D-10, 9.155D-10,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT( 7,J,1),J=1,21) /
     $ 2.69070000D+01, 2.66620000D+01, 2.64169000D+01, 2.61719000D+01,
     $ 2.59270000D+01, 2.56820000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT( 7,J,1),J=1,21) /
     $ 8.177D-08, 4.818D-08, 2.358D-08, 7.754D-09, 5.279D-10, 1.739D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT( 7,J,2),J=1,21) /
     $ 2.57239000D+01, 2.54949000D+01, 2.52659000D+01, 2.50369000D+01,
     $ 2.48080000D+01, 2.45790000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT( 7,J,2),J=1,21) /
     $ 7.869D-08, 4.708D-08, 2.369D-08, 8.331D-09, 8.431D-10, 1.078D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT( 8,J,1),J=1,21) /
     $ 3.07479000D+01, 3.04679000D+01, 3.01879000D+01, 2.99079000D+01,
     $ 2.96279000D+01, 2.93479000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT( 8,J,1),J=1,21) /
     $ 9.227D-08, 5.431D-08, 2.653D-08, 8.687D-09, 5.743D-10, 2.011D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT( 8,J,2),J=1,21) /
     $ 2.93961000D+01, 2.91344000D+01, 2.88726000D+01, 2.86110000D+01,
     $ 2.83493000D+01, 2.80876000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT( 8,J,2),J=1,21) /
     $ 8.880D-08, 5.308D-08, 2.667D-08, 9.347D-09, 9.267D-10, 1.252D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT( 9,J,1),J=1,21) /
     $ 3.45877000D+01, 3.42726000D+01, 3.39576000D+01, 3.36426000D+01,
     $ 3.33276000D+01, 3.30127000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT( 9,J,1),J=1,21) /
     $ 1.026D-07, 6.035D-08, 2.942D-08, 9.582D-09, 6.124D-10, 2.301D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT( 9,J,2),J=1,21) /
     $ 3.30672000D+01, 3.27727000D+01, 3.24783000D+01, 3.21839000D+01,
     $ 3.18895000D+01, 3.15952000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT( 9,J,2),J=1,21) /
     $ 9.882D-08, 5.900D-08, 2.959D-08, 1.032D-08, 1.000D-09, 1.439D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(10,J,1),J=1,21) /
     $ 3.84261000D+01, 3.80760000D+01, 3.77260000D+01, 3.73760000D+01,
     $ 3.70260000D+01, 3.66761000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(10,J,1),J=1,21) /
     $ 1.129D-07, 6.632D-08, 3.226D-08, 1.045D-08, 6.416D-10, 2.611D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(10,J,2),J=1,21) /
     $ 3.67371000D+01, 3.64099000D+01, 3.60828000D+01, 3.57556000D+01,
     $ 3.54285000D+01, 3.51015000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(10,J,2),J=1,21) /
     $ 1.087D-07, 6.484D-08, 3.246D-08, 1.127D-08, 1.063D-09, 1.641D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(11,J,1),J=1,21) /
     $ 4.22631000D+01, 4.18780000D+01, 4.14930000D+01, 4.11080000D+01,
     $ 4.07230000D+01, 4.03380000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(11,J,1),J=1,21) /
     $ 1.230D-07, 7.219D-08, 3.502D-08, 1.127D-08, 6.614D-10, 2.942D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(11,J,2),J=1,21) /
     $ 4.04056000D+01, 4.00457000D+01, 3.96859000D+01, 3.93260000D+01,
     $ 3.89662000D+01, 3.86065000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(11,J,2),J=1,21) /
     $ 1.185D-07, 7.062D-08, 3.526D-08, 1.217D-08, 1.114D-09, 1.859D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(12,J,1),J=1,21) /
     $ 4.60984000D+01, 4.56783000D+01, 4.52583000D+01, 4.48383000D+01,
     $ 4.44183000D+01, 4.39984000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(12,J,1),J=1,21) /
     $ 1.330D-07, 7.791D-08, 3.770D-08, 1.205D-08, 6.713D-10, 3.299D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(12,J,2),J=1,21) /
     $ 4.40727000D+01, 4.36801000D+01, 4.32875000D+01, 4.28950000D+01,
     $ 4.25024000D+01, 4.21100000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(12,J,2),J=1,21) /
     $ 1.282D-07, 7.626D-08, 3.798D-08, 1.303D-08, 1.153D-09, 2.095D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(13,J,1),J=1,21) /
     $ 4.99320000D+01, 4.94769000D+01, 4.90219000D+01, 4.85669000D+01,
     $ 4.81119000D+01, 4.76570000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(13,J,1),J=1,21) /
     $ 1.429D-07, 8.356D-08, 4.028D-08, 1.278D-08, 6.716D-10, 3.684D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(13,J,2),J=1,21) /
     $ 4.77381000D+01, 4.73128000D+01, 4.68875000D+01, 4.64623000D+01,
     $ 4.60370000D+01, 4.56119000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(13,J,2),J=1,21) /
     $ 1.377D-07, 8.180D-08, 4.064D-08, 1.385D-08, 1.179D-09, 2.353D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(14,J,1),J=1,21) /
     $ 5.37636000D+01, 5.32736000D+01, 5.27835000D+01, 5.22935000D+01,
     $ 5.18035000D+01, 5.13136000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(14,J,1),J=1,21) /
     $ 1.526D-07, 8.904D-08, 4.281D-08, 1.346D-08, 6.615D-10, 4.100D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(14,J,2),J=1,21) /
     $ 5.14018000D+01, 5.09438000D+01, 5.04858000D+01, 5.00278000D+01,
     $ 4.95699000D+01, 4.91120000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(14,J,2),J=1,21) /
     $ 1.470D-07, 8.722D-08, 4.319D-08, 1.461D-08, 1.192D-09, 2.634D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(15,J,1),J=1,21) /
     $ 5.75933000D+01, 5.70682000D+01, 5.65431000D+01, 5.60181000D+01,
     $ 5.54932000D+01, 5.49682000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(15,J,1),J=1,21) /
     $ 1.620D-07, 9.438D-08, 4.521D-08, 1.408D-08, 6.417D-10, 4.548D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(15,J,2),J=1,21) /
     $ 5.50637000D+01, 5.45729000D+01, 5.40822000D+01, 5.35915000D+01,
     $ 5.31009000D+01, 5.26103000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(15,J,2),J=1,21) /
     $ 1.562D-07, 9.248D-08, 4.566D-08, 1.533D-08, 1.191D-09, 2.941D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(16,J,1),J=1,21) /
     $ 6.14207000D+01, 6.08606000D+01, 6.03005000D+01, 5.97405000D+01,
     $ 5.91806000D+01, 5.86206000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(16,J,1),J=1,21) /
     $ 1.713D-07, 9.958D-08, 4.752D-08, 1.465D-08, 6.126D-10, 5.035D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(16,J,2),J=1,21) /
     $ 5.87235000D+01, 5.82000000D+01, 5.76766000D+01, 5.71532000D+01,
     $ 5.66299000D+01, 5.61065000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(16,J,2),J=1,21) /
     $ 1.652D-07, 9.761D-08, 4.800D-08, 1.598D-08, 1.177D-09, 3.277D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(17,J,1),J=1,21) /
     $ 6.52457000D+01, 6.46507000D+01, 6.40556000D+01, 6.34606000D+01,
     $ 6.28656000D+01, 6.22707000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(17,J,1),J=1,21) /
     $ 1.804D-07, 1.046D-07, 4.970D-08, 1.516D-08, 5.742D-10, 5.564D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(17,J,2),J=1,21) /
     $ 6.23812000D+01, 6.18250000D+01, 6.12688000D+01, 6.07127000D+01,
     $ 6.01567000D+01, 5.96007000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(17,J,2),J=1,21) /
     $ 1.740D-07, 1.026D-07, 5.027D-08, 1.658D-08, 1.150D-09, 3.645D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(18,J,1),J=1,21) /
     $ 6.90683000D+01, 6.84382000D+01, 6.78082000D+01, 6.71782000D+01,
     $ 6.65482000D+01, 6.59183000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(18,J,1),J=1,21) /
     $ 1.892D-07, 1.095D-07, 5.177D-08, 1.561D-08, 5.283D-10, 6.140D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(18,J,2),J=1,21) /
     $ 6.60366000D+01, 6.54477000D+01, 6.48588000D+01, 6.42700000D+01,
     $ 6.36812000D+01, 6.30925000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(18,J,2),J=1,21) /
     $ 1.826D-07, 1.074D-07, 5.243D-08, 1.712D-08, 1.110D-09, 4.049D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(19,J,1),J=1,21) /
     $ 7.28882000D+01, 7.22231000D+01, 7.15581000D+01, 7.08931000D+01,
     $ 7.02281000D+01, 6.95632000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(19,J,1),J=1,21) /
     $ 1.978D-07, 1.142D-07, 5.373D-08, 1.599D-08, 4.749D-10, 6.762D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(19,J,2),J=1,21) /
     $ 6.96895000D+01, 6.90679000D+01, 6.84464000D+01, 6.78248000D+01,
     $ 6.72034000D+01, 6.65819000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(19,J,2),J=1,21) /
     $ 1.909D-07, 1.121D-07, 5.446D-08, 1.759D-08, 1.058D-09, 4.489D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(20,J,1),J=1,21) /
     $ 7.67054000D+01, 7.60053000D+01, 7.53052000D+01, 7.46052000D+01,
     $ 7.39053000D+01, 7.32054000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(20,J,1),J=1,21) /
     $ 2.061D-07, 1.186D-07, 5.554D-08, 1.631D-08, 4.162D-10, 7.441D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(20,J,2),J=1,21) /
     $ 7.33400000D+01, 7.26857000D+01, 7.20314000D+01, 7.13771000D+01,
     $ 7.07229000D+01, 7.00688000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(20,J,2),J=1,21) /
     $ 1.991D-07, 1.166D-07, 5.638D-08, 1.800D-08, 9.938D-10, 4.972D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(21,J,1),J=1,21) /
     $ 8.05196000D+01, 7.97845000D+01, 7.90494000D+01, 7.83144000D+01,
     $ 7.75795000D+01, 7.68446000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(21,J,1),J=1,21) /
     $ 2.142D-07, 1.230D-07, 5.724D-08, 1.656D-08, 3.534D-10, 8.176D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(21,J,2),J=1,21) /
     $ 7.69877000D+01, 7.63007000D+01, 7.56137000D+01, 7.49268000D+01,
     $ 7.42398000D+01, 7.35530000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(21,J,2),J=1,21) /
     $ 2.070D-07, 1.209D-07, 5.817D-08, 1.834D-08, 9.195D-10, 5.500D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(22,J,1),J=1,21) /
     $ 8.43307000D+01, 8.35606000D+01, 8.27906000D+01, 8.20206000D+01,
     $ 8.12506000D+01, 8.04807000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(22,J,1),J=1,21) /
     $ 2.220D-07, 1.270D-07, 5.881D-08, 1.674D-08, 2.884D-10, 8.977D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(22,J,2),J=1,21) /
     $ 8.06327000D+01, 7.99129000D+01, 7.91932000D+01, 7.84736000D+01,
     $ 7.77539000D+01, 7.70344000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(22,J,2),J=1,21) /
     $ 2.146D-07, 1.250D-07, 5.984D-08, 1.862D-08, 8.363D-10, 6.077D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(23,J,1),J=1,21) /
     $ 8.81387000D+01, 8.73335000D+01, 8.65285000D+01, 8.57235000D+01,
     $ 8.49185000D+01, 8.41136000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(23,J,1),J=1,21) /
     $ 2.296D-07, 1.309D-07, 6.022D-08, 1.685D-08, 2.236D-10, 9.844D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(23,J,2),J=1,21) /
     $ 8.42747000D+01, 8.35222000D+01, 8.27698000D+01, 8.20174000D+01,
     $ 8.12651000D+01, 8.05128000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(23,J,2),J=1,21) /
     $ 2.220D-07, 1.289D-07, 6.138D-08, 1.882D-08, 7.458D-10, 6.709D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(24,J,1),J=1,21) /
     $ 9.19432000D+01, 9.11031000D+01, 9.02630000D+01, 8.94230000D+01,
     $ 8.85830000D+01, 8.77431000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(24,J,1),J=1,21) /
     $ 2.368D-07, 1.346D-07, 6.151D-08, 1.689D-08, 1.614D-10, 1.079D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(24,J,2),J=1,21) /
     $ 8.79136000D+01, 8.71284000D+01, 8.63433000D+01, 8.55582000D+01,
     $ 8.47731000D+01, 8.39882000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(24,J,2),J=1,21) /
     $ 2.291D-07, 1.326D-07, 6.279D-08, 1.895D-08, 6.496D-10, 7.400D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(25,J,1),J=1,21) /
     $ 9.57442000D+01, 9.48691000D+01, 9.39940000D+01, 9.31190000D+01,
     $ 9.22440000D+01, 9.13691000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(25,J,1),J=1,21) /
     $ 2.437D-07, 1.380D-07, 6.263D-08, 1.687D-08, 1.048D-10, 1.181D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(25,J,2),J=1,21) /
     $ 9.15493000D+01, 9.07314000D+01, 8.99136000D+01, 8.90958000D+01,
     $ 8.82780000D+01, 8.74603000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(25,J,2),J=1,21) /
     $ 2.359D-07, 1.362D-07, 6.404D-08, 1.901D-08, 5.500D-10, 8.155D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(26,J,1),J=1,21) /
     $ 9.95416000D+01, 9.86315000D+01, 9.77214000D+01, 9.68114000D+01,
     $ 9.59014000D+01, 9.49915000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(26,J,1),J=1,21) /
     $ 2.504D-07, 1.412D-07, 6.363D-08, 1.677D-08, 5.688D-11, 1.292D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(26,J,2),J=1,21) /
     $ 9.51817000D+01, 9.43311000D+01, 9.34805000D+01, 9.26300000D+01,
     $ 9.17795000D+01, 9.09291000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(26,J,2),J=1,21) /
     $ 2.425D-07, 1.395D-07, 6.516D-08, 1.900D-08, 4.494D-10, 8.978D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(27,J,1),J=1,21) /
     $ 1.03335100D+02, 1.02390000D+02, 1.01444900D+02, 1.00499900D+02,
     $ 9.95549000D+01, 9.86100000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(27,J,1),J=1,21) /
     $ 2.566D-07, 1.442D-07, 6.445D-08, 1.660D-08, 2.136D-11, 1.413D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(27,J,2),J=1,21) /
     $ 9.88105000D+01, 9.79272000D+01, 9.70439000D+01, 9.61607000D+01,
     $ 9.52775000D+01, 9.43944000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(27,J,2),J=1,21) /
     $ 2.487D-07, 1.425D-07, 6.613D-08, 1.892D-08, 3.509D-10, 9.877D-09,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(28,J,1),J=1,21) /
     $ 1.07124700D+02, 1.06144600D+02, 1.05164500D+02, 1.04184500D+02,
     $ 1.03204500D+02, 1.02224600D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(28,J,1),J=1,21) /
     $ 2.625D-07, 1.469D-07, 6.513D-08, 1.636D-08, 2.164D-12, 1.543D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(28,J,2),J=1,21) /
     $ 1.02435800D+02, 1.01519800D+02, 1.00603800D+02, 9.96878000D+01,
     $ 9.87719000D+01, 9.78561000D+01, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(28,J,2),J=1,21) /
     $ 2.547D-07, 1.454D-07, 6.695D-08, 1.876D-08, 2.575D-10, 1.086D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(29,J,1),J=1,21) /
     $ 1.10910200D+02, 1.09895100D+02, 1.08880000D+02, 1.07865000D+02,
     $ 1.06850000D+02, 1.05835100D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(29,J,1),J=1,21) /
     $ 2.682D-07, 1.494D-07, 6.563D-08, 1.606D-08, 3.663D-12, 1.684D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(29,J,2),J=1,21) /
     $ 1.06057300D+02, 1.05108600D+02, 1.04159900D+02, 1.03211200D+02,
     $ 1.02262600D+02, 1.01314000D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(29,J,2),J=1,21) /
     $ 2.604D-07, 1.480D-07, 6.761D-08, 1.854D-08, 1.726D-10, 1.192D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(30,J,1),J=1,21) /
     $ 1.14691500D+02, 1.13641400D+02, 1.12591300D+02, 1.11541200D+02,
     $ 1.10491300D+02, 1.09441300D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(30,J,1),J=1,21) /
     $ 2.736D-07, 1.517D-07, 6.600D-08, 1.569D-08, 3.064D-11, 1.837D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(30,J,2),J=1,21) /
     $ 1.09675000D+02, 1.08693500D+02, 1.07712100D+02, 1.06730700D+02,
     $ 1.05749400D+02, 1.04768100D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(30,J,2),J=1,21) /
     $ 2.658D-07, 1.504D-07, 6.814D-08, 1.825D-08, 1.000D-10, 1.308D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(31,J,1),J=1,21) /
     $ 1.18468400D+02, 1.17383200D+02, 1.16298100D+02, 1.15213100D+02,
     $ 1.14128100D+02, 1.13043200D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(31,J,1),J=1,21) /
     $ 2.785D-07, 1.537D-07, 6.620D-08, 1.526D-08, 8.830D-11, 2.003D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(31,J,2),J=1,21) /
     $ 1.13288600D+02, 1.12274400D+02, 1.11260300D+02, 1.10246200D+02,
     $ 1.09232100D+02, 1.08218200D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(31,J,2),J=1,21) /
     $ 2.707D-07, 1.525D-07, 6.851D-08, 1.790D-08, 4.403D-11, 1.434D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(32,J,1),J=1,21) /
     $ 1.22240700D+02, 1.21120600D+02, 1.20000500D+02, 1.18880400D+02,
     $ 1.17760400D+02, 1.16640500D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(32,J,1),J=1,21) /
     $ 2.830D-07, 1.554D-07, 6.624D-08, 1.476D-08, 1.822D-10, 2.181D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(32,J,2),J=1,21) /
     $ 1.16898100D+02, 1.15851200D+02, 1.14804300D+02, 1.13757500D+02,
     $ 1.12710800D+02, 1.11664100D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(32,J,2),J=1,21) /
     $ 2.754D-07, 1.544D-07, 6.871D-08, 1.748D-08, 9.243D-12, 1.571D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(33,J,1),J=1,21) /
     $ 1.26008400D+02, 1.24853200D+02, 1.23698100D+02, 1.22543100D+02,
     $ 1.21388100D+02, 1.20233100D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(33,J,1),J=1,21) /
     $ 2.872D-07, 1.568D-07, 6.612D-08, 1.421D-08, 3.188D-10, 2.374D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(33,J,2),J=1,21) /
     $ 1.20503300D+02, 1.19423700D+02, 1.18344100D+02, 1.17264600D+02,
     $ 1.16185100D+02, 1.15105700D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(33,J,2),J=1,21) /
     $ 2.797D-07, 1.562D-07, 6.877D-08, 1.698D-08, 6.232D-13, 1.718D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(34,J,1),J=1,21) /
     $ 1.29771200D+02, 1.28581100D+02, 1.27391000D+02, 1.26200900D+02,
     $ 1.25010900D+02, 1.23820900D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(34,J,1),J=1,21) /
     $ 2.910D-07, 1.581D-07, 6.584D-08, 1.360D-08, 5.040D-10, 2.582D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(34,J,2),J=1,21) /
     $ 1.24104100D+02, 1.22991800D+02, 1.21879500D+02, 1.20767200D+02,
     $ 1.19655100D+02, 1.18542900D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(34,J,2),J=1,21) /
     $ 2.836D-07, 1.575D-07, 6.867D-08, 1.643D-08, 2.358D-11, 1.879D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(35,J,1),J=1,21) /
     $ 1.33529100D+02, 1.32303900D+02, 1.31078800D+02, 1.29853700D+02,
     $ 1.28628700D+02, 1.27403800D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(35,J,1),J=1,21) /
     $ 2.945D-07, 1.590D-07, 6.539D-08, 1.294D-08, 7.455D-10, 2.806D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(35,J,2),J=1,21) /
     $ 1.27700300D+02, 1.26555300D+02, 1.25410300D+02, 1.24265400D+02,
     $ 1.23120400D+02, 1.21975600D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(35,J,2),J=1,21) /
     $ 2.872D-07, 1.587D-07, 6.842D-08, 1.583D-08, 8.393D-11, 2.054D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(36,J,1),J=1,21) /
     $ 1.37281800D+02, 1.36021700D+02, 1.34761600D+02, 1.33501500D+02,
     $ 1.32241500D+02, 1.30981500D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(36,J,1),J=1,21) /
     $ 2.976D-07, 1.596D-07, 6.480D-08, 1.224D-08, 1.051D-09, 3.048D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(36,J,2),J=1,21) /
     $ 1.31291900D+02, 1.30114200D+02, 1.28936500D+02, 1.27758800D+02,
     $ 1.26581200D+02, 1.25403600D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(36,J,2),J=1,21) /
     $ 2.906D-07, 1.596D-07, 6.801D-08, 1.515D-08, 1.879D-10, 2.242D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(37,J,1),J=1,21) /
     $ 1.41029300D+02, 1.39734200D+02, 1.38439100D+02, 1.37144000D+02,
     $ 1.35848900D+02, 1.34553900D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(37,J,1),J=1,21) /
     $ 3.003D-07, 1.600D-07, 6.404D-08, 1.149D-08, 1.427D-09, 3.308D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(37,J,2),J=1,21) /
     $ 1.34878700D+02, 1.33668300D+02, 1.32457800D+02, 1.31247400D+02,
     $ 1.30037100D+02, 1.28826800D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(37,J,2),J=1,21) /
     $ 2.934D-07, 1.601D-07, 6.745D-08, 1.444D-08, 3.423D-10, 2.445D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(38,J,1),J=1,21) /
     $ 1.44771400D+02, 1.43441300D+02, 1.42111100D+02, 1.40781000D+02,
     $ 1.39451000D+02, 1.38121000D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(38,J,1),J=1,21) /
     $ 3.025D-07, 1.601D-07, 6.315D-08, 1.070D-08, 1.884D-09, 3.587D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(38,J,2),J=1,21) /
     $ 1.38460600D+02, 1.37217400D+02, 1.35974200D+02, 1.34731100D+02,
     $ 1.33488000D+02, 1.32245000D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(38,J,2),J=1,21) /
     $ 2.960D-07, 1.605D-07, 6.675D-08, 1.368D-08, 5.541D-10, 2.664D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(39,J,1),J=1,21) /
     $ 1.48508000D+02, 1.47142800D+02, 1.45777700D+02, 1.44412600D+02,
     $ 1.43047500D+02, 1.41682500D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(39,J,1),J=1,21) /
     $ 3.044D-07, 1.599D-07, 6.208D-08, 9.891D-09, 2.430D-09, 3.887D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(39,J,2),J=1,21) /
     $ 1.42037300D+02, 1.40761400D+02, 1.39485600D+02, 1.38209700D+02,
     $ 1.36934000D+02, 1.35658200D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(39,J,2),J=1,21) /
     $ 2.982D-07, 1.606D-07, 6.588D-08, 1.288D-08, 8.313D-10, 2.900D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(40,J,1),J=1,21) /
     $ 1.52238800D+02, 1.50838700D+02, 1.49438500D+02, 1.48038400D+02,
     $ 1.46638300D+02, 1.45238300D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(40,J,1),J=1,21) /
     $ 3.059D-07, 1.595D-07, 6.087D-08, 9.054D-09, 3.076D-09, 4.210D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(40,J,2),J=1,21) /
     $ 1.45608900D+02, 1.44300300D+02, 1.42991700D+02, 1.41683200D+02,
     $ 1.40374600D+02, 1.39066200D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(40,J,2),J=1,21) /
     $ 2.999D-07, 1.605D-07, 6.487D-08, 1.204D-08, 1.182D-09, 3.154D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(41,J,1),J=1,21) /
     $ 1.55963900D+02, 1.54528700D+02, 1.53093500D+02, 1.51658400D+02,
     $ 1.50223300D+02, 1.48788300D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(41,J,1),J=1,21) /
     $ 3.070D-07, 1.588D-07, 5.953D-08, 8.201D-09, 3.830D-09, 4.556D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(41,J,2),J=1,21) /
     $ 1.49175200D+02, 1.47833800D+02, 1.46492500D+02, 1.45151300D+02,
     $ 1.43810000D+02, 1.42468800D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(41,J,2),J=1,21) /
     $ 3.014D-07, 1.601D-07, 6.372D-08, 1.117D-08, 1.614D-09, 3.428D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(42,J,1),J=1,21) /
     $ 1.59682900D+02, 1.58212700D+02, 1.56742600D+02, 1.55272400D+02,
     $ 1.53802300D+02, 1.52332200D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(42,J,1),J=1,21) /
     $ 3.077D-07, 1.578D-07, 5.805D-08, 7.340D-09, 4.705D-09, 4.925D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(42,J,2),J=1,21) /
     $ 1.52735900D+02, 1.51361900D+02, 1.49987900D+02, 1.48613900D+02,
     $ 1.47239900D+02, 1.45866000D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(42,J,2),J=1,21) /
     $ 3.024D-07, 1.595D-07, 6.242D-08, 1.027D-08, 2.137D-09, 3.723D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(43,J,1),J=1,21) /
     $ 1.63395800D+02, 1.61890700D+02, 1.60385500D+02, 1.58880300D+02,
     $ 1.57375200D+02, 1.55870100D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(43,J,1),J=1,21) /
     $ 3.080D-07, 1.566D-07, 5.642D-08, 6.478D-09, 5.711D-09, 5.322D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(43,J,2),J=1,21) /
     $ 1.56291100D+02, 1.54884400D+02, 1.53477600D+02, 1.52070900D+02,
     $ 1.50664200D+02, 1.49257500D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(43,J,2),J=1,21) /
     $ 3.031D-07, 1.586D-07, 6.100D-08, 9.360D-09, 2.761D-09, 4.039D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(44,J,1),J=1,21) /
     $ 1.67102500D+02, 1.65562300D+02, 1.64022100D+02, 1.62482000D+02,
     $ 1.60941800D+02, 1.59401700D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(44,J,1),J=1,21) /
     $ 3.079D-07, 1.551D-07, 5.468D-08, 5.624D-09, 6.861D-09, 5.747D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(44,J,2),J=1,21) /
     $ 1.59840600D+02, 1.58401100D+02, 1.56961700D+02, 1.55522200D+02,
     $ 1.54082800D+02, 1.52643400D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(44,J,2),J=1,21) /
     $ 3.033D-07, 1.574D-07, 5.944D-08, 8.438D-09, 3.497D-09, 4.377D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(45,J,1),J=1,21) /
     $ 1.70802800D+02, 1.69227600D+02, 1.67652400D+02, 1.66077200D+02,
     $ 1.64502000D+02, 1.62926900D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(45,J,1),J=1,21) /
     $ 3.074D-07, 1.533D-07, 5.281D-08, 4.789D-09, 8.167D-09, 6.200D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(45,J,2),J=1,21) /
     $ 1.63384200D+02, 1.61912000D+02, 1.60439800D+02, 1.58967600D+02,
     $ 1.57495500D+02, 1.56023300D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(45,J,2),J=1,21) /
     $ 3.033D-07, 1.560D-07, 5.774D-08, 7.515D-09, 4.353D-09, 4.740D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(46,J,1),J=1,21) /
     $ 1.74496500D+02, 1.72886300D+02, 1.71276100D+02, 1.69665900D+02,
     $ 1.68055700D+02, 1.66445500D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(46,J,1),J=1,21) /
     $ 3.065D-07, 1.512D-07, 5.082D-08, 3.982D-09, 9.643D-09, 6.685D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(46,J,2),J=1,21) /
     $ 1.66921800D+02, 1.65416900D+02, 1.63912000D+02, 1.62407100D+02,
     $ 1.60902200D+02, 1.59397300D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(46,J,2),J=1,21) /
     $ 3.027D-07, 1.543D-07, 5.593D-08, 6.598D-09, 5.343D-09, 5.130D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(47,J,1),J=1,21) /
     $ 1.78183500D+02, 1.76538300D+02, 1.74893100D+02, 1.73247800D+02,
     $ 1.71602600D+02, 1.69957400D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(47,J,1),J=1,21) /
     $ 3.052D-07, 1.489D-07, 4.874D-08, 3.215D-09, 1.130D-08, 7.202D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(47,J,2),J=1,21) /
     $ 1.70453300D+02, 1.68915700D+02, 1.67378100D+02, 1.65840400D+02,
     $ 1.64302800D+02, 1.62765200D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(47,J,2),J=1,21) /
     $ 3.019D-07, 1.524D-07, 5.401D-08, 5.697D-09, 6.477D-09, 5.547D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(48,J,1),J=1,21) /
     $ 1.81863700D+02, 1.80183500D+02, 1.78503200D+02, 1.76823000D+02,
     $ 1.75142700D+02, 1.73462400D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(48,J,1),J=1,21) /
     $ 3.034D-07, 1.464D-07, 4.655D-08, 2.499D-09, 1.316D-08, 7.754D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(48,J,2),J=1,21) /
     $ 1.73978600D+02, 1.72408200D+02, 1.70837900D+02, 1.69267500D+02,
     $ 1.67697100D+02, 1.66126800D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(48,J,2),J=1,21) /
     $ 3.007D-07, 1.502D-07, 5.198D-08, 4.821D-09, 7.768D-09, 5.993D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(49,J,1),J=1,21) /
     $ 1.85536900D+02, 1.83821700D+02, 1.82106400D+02, 1.80391100D+02,
     $ 1.78675800D+02, 1.76960500D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(49,J,1),J=1,21) /
     $ 3.012D-07, 1.436D-07, 4.428D-08, 1.846D-09, 1.523D-08, 8.341D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(49,J,2),J=1,21) /
     $ 1.77497400D+02, 1.75894400D+02, 1.74291300D+02, 1.72688200D+02,
     $ 1.71085100D+02, 1.69482000D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(49,J,2),J=1,21) /
     $ 2.991D-07, 1.478D-07, 4.986D-08, 3.981D-09, 9.231D-09, 6.468D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(50,J,1),J=1,21) /
     $ 1.89203000D+02, 1.87452800D+02, 1.85702500D+02, 1.83952100D+02,
     $ 1.82201800D+02, 1.80451500D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(50,J,1),J=1,21) /
     $ 2.987D-07, 1.406D-07, 4.192D-08, 1.270D-09, 1.754D-08, 8.968D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(50,J,2),J=1,21) /
     $ 1.81009800D+02, 1.79374000D+02, 1.77738200D+02, 1.76102400D+02,
     $ 1.74466500D+02, 1.72830700D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(50,J,2),J=1,21) /
     $ 2.971D-07, 1.453D-07, 4.763D-08, 3.189D-09, 1.088D-08, 6.976D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(51,J,1),J=1,21) /
     $ 1.92861800D+02, 1.91076600D+02, 1.89291300D+02, 1.87505900D+02,
     $ 1.85720500D+02, 1.83935100D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(51,J,1),J=1,21) /
     $ 2.958D-07, 1.374D-07, 3.950D-08, 7.825D-10, 2.008D-08, 9.634D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(51,J,2),J=1,21) /
     $ 1.84515500D+02, 1.82847000D+02, 1.81178500D+02, 1.79509900D+02,
     $ 1.77841300D+02, 1.76172700D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(51,J,2),J=1,21) /
     $ 2.948D-07, 1.424D-07, 4.533D-08, 2.454D-09, 1.272D-08, 7.517D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(52,J,1),J=1,21) /
     $ 1.96513200D+02, 1.94693000D+02, 1.92872600D+02, 1.91052300D+02,
     $ 1.89231800D+02, 1.87411400D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(52,J,1),J=1,21) /
     $ 2.925D-07, 1.340D-07, 3.702D-08, 4.000D-10, 2.289D-08, 1.034D-07,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(52,J,2),J=1,21) /
     $ 1.88014500D+02, 1.86313200D+02, 1.84612000D+02, 1.82910600D+02,
     $ 1.81209300D+02, 1.79508000D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(52,J,2),J=1,21) /
     $ 2.920D-07, 1.393D-07, 4.294D-08, 1.790D-09, 1.478D-08, 8.094D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(53,J,1),J=1,21) /
     $ 2.00157100D+02, 1.98301800D+02, 1.96446500D+02, 1.94591100D+02,
     $ 1.92735600D+02, 1.90880100D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(53,J,1),J=1,21) /
     $ 2.889D-07, 1.303D-07, 3.450D-08, 1.370D-10, 2.598D-08, 1.110D-07,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
      data (WNROT(53,J,2),J=1,21) /
     $ 1.91506500D+02, 1.89772600D+02, 1.88038600D+02, 1.86304500D+02,
     $ 1.84570400D+02, 1.82836300D+02, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00, 0.00000000D+00, 0.00000000D+00, 0.00000000D+00,
     $ 0.00000000D+00/
      data ( FROT(53,J,2),J=1,21) /
     $ 2.890D-07, 1.360D-07, 4.050D-08, 1.210D-09, 1.707D-08, 8.709D-08,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00, 0.000D+00,
     $ 0.000D+00, 0.000D+00, 0.000D+00/
C
      call HI ('COROTN')
C     !BEG
C     !END
      call BYE ('COROTN')
C
      end
