      subroutine FIZMO
     $(N,X,RZM,HND,XNE,ABDEL,ETA,FTC,FMC)
C
C     Rudolf Loeser, 1972 Sep 07
C---- Computes FMC - contribution of electrons from metals in the
C                    table, relative to the total electron density
C              FTC - sum of FMC
C     (This is version 2 of FIZMO.)
C     !DASH
      save
C     !DASH
      real*8 ABDEL, ABM, ETA, FMC, FTC, HND, RZM, X, XNE, ZERO, dummy
      integer I, KODE, L, N
      character ZSYM*3
C     !COM
C---- DLIT        as of 1999 Jan 29
      real*8      DLIT, ORD
      dimension   DLIT(19), ORD(11)
      equivalence (DLIT(1), ORD(1))
      common      /DLIT/ DLIT
C     Floating point literals.
      equivalence (DLIT( 1),ZERO  )
C
C---- ELEMENT     as of 1998 Aug 17
      integer     NELX
      parameter   (NELX=50)
C     (Remember to recompile all users when changing NELX)
      real*8      ELABD,ELCHI,ELLU1,ELLU2,ELABL,ELDEF
      integer     LATNO,LDEFR,NMT,NMTMAX
      logical     LATEM
      character   ELSYM*3, ELSUB*3
      dimension   ELSYM(NELX),ELSUB(NELX),ELABD(NELX),ELCHI(NELX),
     $            ELLU1(NELX),ELLU2(NELX),ELABL(NELX),ELDEF(NELX),
     $            LATNO(NELX),LDEFR(NELX),LATEM(NELX)
C
      common      /ELEMNT0/ NMT,NMTMAX
      common      /ELEMNT1/ ELSYM,ELSUB
      common      /ELEMNT2/ ELABD,ELCHI,ELLU1,ELLU2,ELABL,ELDEF
      common      /ELEMNT3/ LATNO,LDEFR
      common      /ELEMNT4/ LATEM
C
C     Element data tables:
C             ELSYM - element symbol;
C             ELSUB - (Scratch storage for I.D. symbols);
C             ELABD - abundance (w.r.t. Hydrogen);
C             ELCHI - Chi, i.e. ionization potential;
C             ELLU1 - U-I partition function;
C             ELLU2 - U-II partition function;
C             ELABL - logarithmic abundance;
C             ELDEF - defaults values of logarithmic abundance;
C             LATNO - atomic number; and
C             LDEFR - default values sources codes.
C             LATEM - "metal" designator
C     .
C     !DASH
C     !EJECT
      external FRANK, LUNA, ROWSUM, ZERO1, HI, BYE
C
      dimension X(*)
C
C               RZM(N), HND(N), XNE(N), ETA(N,NMT), FMC(N,NMT), FTC(N),
      dimension RZM(*), HND(*), XNE(*), ETA(N,*),   FMC(N,*),   FTC(*),
C
C               ABDEL(N)
     $          ABDEL(*)
C
      call HI ('FIZMO')
C     !BEG
      call ZERO1      (FMC,(N*NMT))
C
      do 101 L = 1,NMT
        if(LATEM(L)) then
          call FRANK  (ZSYM,L,ABM,dummy,dummy,dummy,KODE)
          if(ABM.gt.ZERO) then
C
            call LUNA (X,ZSYM,ABM,ABDEL)
            do 100 I = 1,N
              FMC(I,L) = (HND(I)*RZM(I)*ABDEL(I)*ETA(I,L))/XNE(I)
  100       continue
C
          end if
        end if
  101 continue
C
      do 102 I = 1,N
        call ROWSUM   (FMC(I,1),N,N,1,NMT,FTC(I))
  102 continue
C     !END
      call BYE ('FIZMO')
C
      return
      end
