      subroutine GUINEA
     $(X,XNE,XNE0,TE,CPR,CHI,XPBL,W1,W2,XNK,SLVLS,ABEL,N,ZME,ETA)
C
C     Rudolf Loeser, 1978 Aug 12
C---- Computes ZME and ETA, for PEARL.
C     !DASH
      save
C     !DASH
      real*8 ABEL, ABUN, CHI, CPR, ETA, SLVLS, TE, W1, W2, X, XNE, XNE0,
     $       XNK, XPBL, ZME, dummy
      integer J, KODE, N
      logical ZABUN
      character SYM*3
C     !COM
C---- ELEMENT     as of 1998 Aug 17
      integer     NELX
      parameter   (NELX=50)
C     (Remember to recompile all users when changing NELX)
      real*8      ELABD,ELCHI,ELLU1,ELLU2,ELABL,ELDEF
      integer     LATNO,LDEFR,NMT,NMTMAX
      logical     LATEM
      character   ELSYM*3, ELSUB*3
      dimension   ELSYM(NELX),ELSUB(NELX),ELABD(NELX),ELCHI(NELX),
     $            ELLU1(NELX),ELLU2(NELX),ELABL(NELX),ELDEF(NELX),
     $            LATNO(NELX),LDEFR(NELX),LATEM(NELX)
C
      common      /ELEMNT0/ NMT,NMTMAX
      common      /ELEMNT1/ ELSYM,ELSUB
      common      /ELEMNT2/ ELABD,ELCHI,ELLU1,ELLU2,ELABL,ELDEF
      common      /ELEMNT3/ LATNO,LDEFR
      common      /ELEMNT4/ LATEM
C
C     Element data tables:
C             ELSYM - element symbol;
C             ELSUB - (Scratch storage for I.D. symbols);
C             ELABD - abundance (w.r.t. Hydrogen);
C             ELCHI - Chi, i.e. ionization potential;
C             ELLU1 - U-I partition function;
C             ELLU2 - U-II partition function;
C             ELABL - logarithmic abundance;
C             ELDEF - defaults values of logarithmic abundance;
C             LATNO - atomic number; and
C             LDEFR - default values sources codes.
C             LATEM - "metal" designator
C     .
C     !DASH
C     !EJECT
      external NATASHA, ZERO1, FRANK, GIZMO, LUNA, MULSUM, NAUGHTD,
     $         HI, BYE
C
      dimension X(*)
C
C               ETA(N,NMT), CPR(N,NMT), CHI(NMT), TE(N), W1(N), XNE(N),
      dimension ETA(N,*),   CPR(N,*),   CHI(*),   TE(*), W1(*), XNE(*),
C
C               W2(N), ZME(N), XNE0(N), XPBL(Lenpbl), XNK(N), SLVLS(N),
     $          W2(*), ZME(*), XNE0(*), XPBL(*),      XNK(*), SLVLS(*),
C
C               ABEL(N)
     $          ABEL(*)
C
      call HI ('GUINEA')
C     !BEG
C---- Initialize
      call ZERO1        (ETA, (N*NMT))
      call ZERO1        (ZME, N)
C---- Initialize intermediates for ETA calculation
      call NATASHA      (TE, W1, W2, N)
C---- Loop over all elements
      do 100 J = 1,NMT
        if(LATEM(J)) then
C----     Select "metals" only
C
C----     Get element symbol and set up abundance table
          call FRANK    (SYM, J, ABUN, dummy, dummy, dummy, KODE)
          call LUNA     (X, SYM, ABUN, ABEL)
          call NAUGHTD  (ABEL, 1, N, ZABUN)
C
          if((KODE.gt.0).and.(.not.ZABUN)) then
C----       Compute ETA
            call GIZMO  (XNE, XNE0, N, XPBL, W1, W2, XNK, SLVLS, SYM,
     $                   CPR(1,J), CHI(J), ETA(1,J))
C----       Add contribution to ZME
            call MULSUM (ETA(1,J), ABEL, ZME, N)
          end if
C
        end if
  100 continue
C     !END
      call BYE ('GUINEA')
C
      return
      end
