      subroutine SUMTERM
     $(IU,IL,T,SIGMA,TERM,LAB,M)
C
C     Rudolf Loeser, 1990 Nov 02
C---- Computes SIGMA, the sum of terms needed for the computation
C     of the collisonal excitation rate, for Hydrogen.
C
C     Based on:  Giovanardi, Natta, and Pella (1987),
C                  Astron.Astrophys.Suppl.,70,269-280, and
C                Giovanardi and Palla (1989),
C                  Astron.Astrophys.Suppl.,77,157-160.
C
C---- Also returned are M, the number of terms in the sum, and the
C     values of these TERMs and their LABels. (The arrays TERM and
C     LAB must each have room for at least 12 values.)
C     !DASH
      save
C     !DASH
      real*8 A, C, DT, HNDRD, ONE, P, PT, SIGMA, T, T1, T2, T3, TERM,
     $       TQ, TS, X, YLO, YUP, Z, ZERO
      integer IL, IN, INDEX, IU, J, JL, JU, K, M
      character LAB*7, Q*7
C     !COM
C---- DLIT        as of 1999 Jan 29
      real*8      DLIT, ORD
      dimension   DLIT(19), ORD(11)
      equivalence (DLIT(1), ORD(1))
      common      /DLIT/ DLIT
C     Floating point literals.
      equivalence (DLIT( 1),ZERO  )
      equivalence (DLIT( 2),ONE   )
C     !DASH
      external HI, BYE
C
C               TERM(12), LAB(12)
      dimension TERM(*),  LAB(*)
C
      dimension INDEX(15,15), JU(105), JL(105), C(4,200,2), A(200),
     $          Q(200)
C
C
      data T1,T2,T3,DT /6.D3, 5.5D4, 7.2D4, 1.7D4/
      data P,HNDRD     /2.2D0, 1.D2/
C     !EJECT
C
C     The mapping of transition doublets  >>   single indices:
C
C       l =   1   2   3   4   5   6   7   8   9  10  11  12  13  14  15
C
C  u =  1     x
C       2     1   x
C       3     2   3   x
C       4     4   5   6   x
C       5     7   8   9  10   x
C       6    11  12  13  14  15   x
C       7    16  17  18  19  20  21   x
C       8    22  23  24  25  26  27  28   x
C       9    29  30  31  32  33  34  35  36   x
C      10    37  38  39  40  41  42  43  44  45   x
C      11    46  47  48  49  50  51  52  53  54  55   x
C      12    56  57  58  59  60  61  62  63  64  65  66   x
C      13    67  68  69  70  71  72  73  74  75  76  77  78   x
C      14    79  80  81  82  83  84  85  86  87  88  89  90  91   x
C      15    92  93  94  95  96  97  98  99 100 101 102 103 104 105   x
C
C
      data      INDEX /
     $   0, 1, 2, 4,  7, 11, 16, 22, 29, 37, 46, 56, 67, 79,  92,
     $   0, 0, 3, 5,  8, 12, 17, 23, 30, 38, 47, 57, 68, 80,  93,
     $   0, 0, 0, 6,  9, 13, 18, 24, 31, 39, 48, 58, 69, 81,  94,
     $   0, 0, 0, 0, 10, 14, 19, 25, 32, 40, 49, 59, 70, 82,  95,
     $   0, 0, 0, 0,  0, 15, 20, 26, 33, 41, 50, 60, 71, 83,  96,
     $   0, 0, 0, 0,  0,  0, 21, 27, 34, 42, 51, 61, 72, 84,  97,
     $   0, 0, 0, 0,  0,  0,  0, 28, 35, 43, 52, 62, 73, 85,  98,
     $   0, 0, 0, 0,  0,  0,  0,  0, 36, 44, 53, 63, 74, 86,  99,
     $   0, 0, 0, 0,  0,  0,  0,  0,  0, 45, 54, 64, 75, 87, 100,
     $   0, 0, 0, 0,  0,  0,  0,  0,  0,  0, 55, 65, 76, 88, 101,
     $   0, 0, 0, 0,  0,  0,  0,  0,  0,  0,  0, 66, 77, 89, 102,
     $   0, 0, 0, 0,  0,  0,  0,  0,  0,  0,  0,  0, 78, 90, 103,
     $   0, 0, 0, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 91, 104,
     $   0, 0, 0, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 105,
     $   0, 0, 0, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   0/
C     !EJECT
C
C----           Transition [ 2, 1]
      data      JL(  1),JU(  1) /1, 2/
C     1s - 2s
      data      Q(  1) /'1s - 2s'/
      data      A(  1) /1.3D-7/
      data      (C(I,  1,1),I=1,4) /
     $           2.302D-01,  5.248D-06, -1.144D-10,  8.240D-16 /
      data      (C(I,  1,2),I=1,4) /
     $           2.694D-01,  7.883D-07, -1.394D-12,  1.451D-18 /
C     1s - 2p
      data      Q(  2) /'1s - 2p'/
      data      A(  2) /-5.6D-8/
      data      (C(I,  2,1),I=1,4) /
     $           3.440D-01,  1.293D-05,  5.124D-12,  4.473D-17 /
      data      (C(I,  2,2),I=1,4) /
     $           3.162D-01,  1.472D-05, -8.275D-12, -8.794D-19 /
C
C----           Transition [ 3, 1]
      data      JL(  2),JU(  2) /3,5/
C     1s - 3s
      data      Q(  3) /'1s - 3s'/
      data      A(  3) /3.7D-7/
      data      (C(I,  3,1),I=1,4) /
     $           5.462D-02, -1.099D-06,  2.457D-11, -1.528D-16 /
      data      (C(I,  3,2),I=1,4) /
     $           3.337D-02,  2.223D-07, -2.794D-13,  1.516D-19 /
C     1s - 3p
      data      Q(  4) /'1s - 3p'/
      data      A(  4) /2.4D-7/
      data      (C(I,  4,1),I=1,4) /
     $           9.042D-02, -2.268D-07,  6.149D-11, -4.099D-16 /
      data      (C(I,  4,2),I=1,4) /
     $           6.985D-02,  2.538D-06, -8.729D-13, -1.291D-18 /
C     1s - 3d
      data      Q(  5) /'1s - 3d'/
      data      A(  5) /3.7D-7/
      data      (C(I,  5,1),I=1,4) /
     $           4.838D-02,  8.560D-07, -2.544D-12,  5.093D-18 /
      data      (C(I,  5,2),I=1,4) /
     $           5.015D-02,  7.876D-07, -2.072D-12,  1.902D-18 /
C
C----           Transition [ 3, 2]
      data      JL(  3),JU(  3) /6,11/
C     2s - 3s
      data      Q(  6) /'2s - 3s'/
      data      A(  6) /1.1D-7/
      data      (C(I,  6,1),I=1,4) /
     $           1.514D+00, -3.056D-05,  1.199D-09, -8.325D-15 /
      data      (C(I,  6,2),I=1,4) /
     $           6.311D-01,  2.881D-05, -5.372D-11,  4.095D-17 /
C     2s - 3p
      data      Q(  7) /'2s - 3p'/
      data      A(  7) /3.3D-7/
      data      (C(I,  7,1),I=1,4) /
     $           2.569D+00, -4.514D-05,  2.527D-09, -1.456D-14 /
      data      (C(I,  7,2),I=1,4) /
     $          -1.334D+00,  1.229D-04, -9.676D-11,  2.842D-17 /
C     2s - 3d
      data      Q(  8) /'2s - 3d'/
      data      A(  8) /3.2D-7/
      data      (C(I,  8,1),I=1,4) /
     $           1.259D+00,  2.844D-04, -1.777D-09,  5.951D-15 /
      data      (C(I,  8,2),I=1,4) /
     $           5.567D+00,  1.494D-04, -3.692D-10,  3.280D-16 /
C     2p - 3s
      data      Q(  9) /'2p - 3s'/
      data      A(  9) /4.5D-7/
      data      (C(I,  9,1),I=1,4) /
     $           2.107D+00,  2.528D-05, -2.555D-10,  1.733D-15 /
      data      (C(I,  9,2),I=1,4) /
     $           2.325D+00,  1.361D-05, -2.702D-11,  2.397D-17 /
C     2p - 3p
      data      Q( 10) /'2p - 3p'/
      data      A( 10) /3.1D-7/
      data      (C(I, 10,1),I=1,4) /
     $           6.986D+00,  6.171D-05,  1.744D-09, -1.489D-14 /
      data      (C(I, 10,2),I=1,4) /
     $           6.984D+00,  1.260D-04, -3.014D-10,  2.655D-16 /
C     2p - 3d
      data      Q( 11) /'2p - 3d'/
      data      A( 11) /2.1D-7/
      data      (C(I, 11,1),I=1,4) /
     $           8.097D+00,  6.393D-04,  8.716D-09, -6.960D-14 /
      data      (C(I, 11,2),I=1,4) /
     $           2.922D+00,  1.089D-03, -1.705D-09,  1.237D-15 /
C
C----           Transition [ 4, 1]
      data      JL(  4),JU(  4) /12,15/
C     1s - 4s
      data      Q( 12) /'1s - 4s'/
      data      A( 12) /2.1D-7/
      data      (C(I, 12,1),I=1,4) /
     $           1.909D-04,  1.983D-07, -8.325D-13,  1.128D-18 /
      data      (C(I, 12,2),I=1,4) /
     $           2.867D-03,  1.222D-07, -2.323D-13,  1.865D-19 /
C     1s - 4p
      data      Q( 13) /'1s - 4p'/
      data      A( 13) /3.7D-7/
      data      (C(I, 13,1),I=1,4) /
     $           1.527D-03,  1.001D-06, -2.192D-12,  9.348D-18 /
      data      (C(I, 13,2),I=1,4) /
     $           1.958D-03,  9.525D-07, -9.668D-13,  4.807D-19 /
C     1s - 4d
      data      Q( 14) /'1s - 4d'/
      data      A( 14) /4.5D-7/
      data      (C(I, 14,1),I=1,4) /
     $           1.339D-03,  6.470D-07, -4.397D-12,  1.736D-17 /
      data      (C(I, 14,2),I=1,4) /
     $           1.007D-02,  3.508D-07, -8.024D-13,  6.764D-19 /
C     1s - 4f
      data      Q( 15) /'1s - 4f'/
      data      A( 15) /1.1D-6/
      data      (C(I, 15,1),I=1,4) /
     $           3.266D-03,  3.908D-07, -8.778D-12,  6.171D-17 /
      data      (C(I, 15,2),I=1,4) /
     $           9.103D-03, -6.105D-09, -6.191D-15,  1.268D-20 /
C
C----           Transition [ 4, 2]
      data      JL(  5),JU(  5) /16,23/
C     2s - 4s
      data      Q( 16) /'2s - 4s'/
      data      A( 16) /5.8D-7/
      data      (C(I, 16,1),I=1,4) /
     $           1.762D-02,  8.683D-06, -4.800D-11,  1.810D-16 /
      data      (C(I, 16,2),I=1,4) /
     $           1.210D-01,  5.439D-06, -1.103D-11,  9.116D-18 /
C     2s - 4p
      data      Q( 17) /'2s - 4p'/
      data      A( 17) /6.7D-7/
      data      (C(I, 17,1),I=1,4) /
     $           6.398D-02,  2.578D-05, -8.551D-11,  6.504D-16 /
      data      (C(I, 17,2),I=1,4) /
     $          -2.905D-02,  2.640D-05, -3.072D-11,  1.769D-17 /
C     2s - 4d
      data      Q( 18) /'2s - 4d'/
      data      A( 18) /6.5D-7/
      data      (C(I, 18,1),I=1,4) /
     $           1.125D-01,  4.732D-05, -4.285D-10,  1.971D-15 /
      data      (C(I, 18,2),I=1,4) /
     $           9.485D-01,  1.785D-05, -4.590D-11,  4.181D-17 /
C     2s - 4f
      data      Q( 19) /'2s - 4f'/
      data      A( 19) /6.3D-7/
      data      (C(I, 19,1),I=1,4) /
     $           1.140D-01,  5.154D-05, -4.757D-10,  1.989D-15 /
      data      (C(I, 19,2),I=1,4) /
     $           1.191D+00,  1.544D-05, -4.739D-11,  4.605D-17 /
C     2p - 4s
      data      Q( 20) /'2p - 4s'/
      data      A( 20) /6.7D-7/
      data      (C(I, 20,1),I=1,4) /
     $           5.237D-02,  2.123D-05, -2.176D-10,  1.027D-15 /
      data      (C(I, 20,2),I=1,4) /
     $           4.788D-01,  5.979D-06, -1.667D-11,  1.605D-17 /
C     2p - 4p
      data      Q( 21) /'2p - 4p'/
      data      A( 21) /6.2D-7/
      data      (C(I, 21,1),I=1,4) /
     $           1.798D-01,  8.300D-05, -6.927D-10,  2.843D-15 /
      data      (C(I, 21,2),I=1,4) /
     $           1.738D+00,  3.133D-05, -8.425D-11,  7.825D-17 /
C     2p - 4d
      data      Q( 22) /'2p - 4d'/
      data      A( 22) /0.D0/
      data      (C(I, 22,1),I=1,4) /
     $           1.591D-02,  1.673D-04,  9.135D-10, -1.037D-14 /
      data      (C(I, 22,2),I=1,4) /
     $           1.004D+00,  1.889D-04, -3.433D-10,  2.692D-16 /
C     2p - 4f
      data      Q( 23) /'2p - 4f'/
      data      A( 23) /4.9D-7/
      data      (C(I, 23,1),I=1,4) /
     $           2.254D-01,  1.365D-04, -7.926D-10,  1.760D-15 /
      data      (C(I, 23,2),I=1,4) /
     $           2.785D+00,  6.406D-05, -1.773D-10,  1.638D-16 /
C
C----           Transition [ 4, 3]
      data      JL(  6),JU(  6) /24, 35/
C     3s - 4s
      data      Q( 24) /'3s - 4s'/
      data      A( 24) /-2.9D-6/
      data      (C(I, 24,1),I=1,4) /
     $          -3.207D-01,  9.244D-05,  2.640D-09, -2.373D-14 /
      data      (C(I, 24,2),I=1,4) /
     $           5.697D-01,  1.740D-04, -3.941D-10,  3.383D-16 /
C     3s - 4p
      data      Q( 25) /'3s - 4p'/
      data      A( 25) /-1.3D-6/
      data      (C(I, 25,1),I=1,4) /
     $          -3.391D-01,  1.439D-04,  6.033D-09, -3.777D-14 /
      data      (C(I, 25,2),I=1,4) /
     $          -9.335D+00,  5.521D-04, -5.967D-10,  3.066D-16 /
C     3s - 4d
      data      Q( 26) /'3s - 4d'/
      data      A( 26) /-1.3D-6/
      data      (C(I, 26,1),I=1,4) /
     $          -7.739D-01,  3.623D-04,  5.026D-09, -5.334D-14 /
      data      (C(I, 26,2),I=1,4) /
     $           5.641D+00,  4.317D-04, -1.094D-09,  9.844D-16 /
C     3s - 4f
      data      Q( 27) /'3s - 4f'/
      data      A( 27) /6.3D-7/
      data      (C(I, 27,1),I=1,4) /
     $           5.916D-01,  8.966D-04, -1.047D-08,  5.520D-14 /
      data      (C(I, 27,2),I=1,4) /
     $           1.721D+01,  2.360D-04, -6.574D-10,  6.176D-16 /
C     3p - 4s
      data      Q( 28) /'3p - 4s'/
      data      A( 28) /3.D-7/
      data      (C(I, 28,1),I=1,4) /
     $          -6.866D-04,  2.012D-04, -7.084D-10,  1.046D-15 /
      data      (C(I, 28,2),I=1,4) /
     $           2.290D+00,  1.391D-04, -2.365D-10,  1.857D-16 /
C     3p - 4p
      data      Q( 29) /'3p - 4p'/
      data      A( 29) /-3.3D-7/
      data      (C(I, 29,1),I=1,4) /
     $          -8.174D-01,  7.898D-04,  3.420D-09, -5.299D-14 /
      data      (C(I, 29,2),I=1,4) /
     $           1.220D+01,  6.924D-04, -1.698D-09,  1.512D-15 /
C     3p - 4d
      data      Q( 30) /'3p - 4d'/
      data      A( 30) /-1.1D-6/
      data      (C(I, 30,1),I=1,4) /
     $          -2.328D+00,  1.173D-03,  2.980D-08, -2.176D-13 /
      data      (C(I, 30,2),I=1,4) /
     $          -2.813D+01,  2.839D-03, -4.071D-09,  2.739D-15 /
C     3p - 4f
      data      Q( 31) /'3p - 4f'/
      data      A( 31) /3.3D-7/
      data      (C(I, 31,1),I=1,4) /
     $           2.395D-01,  3.736D-03, -2.458D-08,  6.950D-14 /
      data      (C(I, 31,2),I=1,4) /
     $           7.244D+01,  1.596D-03, -4.378D-09,  4.085D-15 /
C     3d - 4s
      data      Q( 32) /'3d - 4s'/
      data      A( 32) /9.2D-7/
      data      (C(I, 32,1),I=1,4) /
     $           4.602D-01,  3.451D-04, -6.086D-09,  3.823D-14 /
      data      (C(I, 32,2),I=1,4) /
     $           6.804D+00,  1.948D-05, -7.904D-11,  8.451D-17 /
C     3d - 4p
      data      Q( 33) /'3d - 4p'/
      data      A( 33) /8.3D-7/
      data      (C(I, 33,1),I=1,4) /
     $           1.456D+00,  1.303D-03, -2.048D-08,  1.240D-13 /
      data      (C(I, 33,2),I=1,4) /
     $           2.532D+01,  1.621D-04, -4.722D-10,  4.641D-16 /
C     3d - 4d
      data      Q( 34) /'3d - 4d'/
      data      A( 34) /3.2D-7/
      data      (C(I, 34,1),I=1,4) /
     $           1.424D-01,  2.943D-03, -1.984D-08,  5.541D-14 /
      data      (C(I, 34,2),I=1,4) /
     $           5.947D+01,  1.183D-03, -3.338D-09,  3.153D-15 /
C     3d - 4f
      data      Q( 35) /'3d - 4f'/
      data      A( 35) /-5.7D-7/
      data      (C(I, 35,1),I=1,4) /
     $          -1.121D+01,  8.600D-03,  8.986D-08, -8.662D-13 /
      data      (C(I, 35,2),I=1,4) /
     $           2.948D+01,  1.147D-02, -2.131D-08,  1.690D-14 /
C
C----           Transition [ 5, 1]
      data      JL(  7),JU(  7) /36, 36/
C     1s - 5
      data      Q( 36) /'1s - 5 '/
      data      A( 36) /6.3D-7/
      data      (C(I, 36,1),I=1,4) /
     $           2.035D-02,  6.076D-07, -2.175D-13, -2.495D-18 /
      data      (C(I, 36,2),I=1,4) /
     $           2.002D-02,  6.325D-07, -7.070D-13,  4.096D-19 /
C
C----           Transition [ 5, 2]
      data      JL(  8),JU(  8) /37, 38/
C     2s - 5
      data      Q( 37) /'2s - 5 '/
      data      A( 37) /0.D0/
      data      (C(I, 37,1),I=1,4) /
     $           3.647D-01,  7.145D-05, -5.516D-10,  2.257D-15 /
      data      (C(I, 37,2),I=1,4) /
     $           1.483D+00,  3.251D-05, -7.279D-11,  6.337D-17 /
C     2p - 5
      data      Q( 38) /'2p - 5 '/
      data      A( 38) /-8.1D-8/
      data      (C(I, 38,1),I=1,4) /
     $           1.094D+00,  2.143D-04, -1.655D-09,  6.771D-15 /
      data      (C(I, 38,2),I=1,4) /
     $           4.449D+00,  9.754D-05, -2.184D-10,  1.901D-16 /
C
C----           Transition [ 5, 3]
      data      JL(  9),JU(  9) /39, 41/
C     3s - 5
      data      Q( 39) /'3s - 5 '/
      data      A( 39) /0.D0/
      data      (C(I, 39,1),I=1,4) /
     $           2.928D+01,  6.550D-04, -8.590D-09,  4.996D-14 /
      data      (C(I, 39,2),I=1,4) /
     $           3.970D+01,  1.720D-04, -3.724D-10,  3.239D-16 /
C     3p - 5
      data      Q( 40) /'3p - 5 '/
      data      A( 40) /0.D0/
      data      (C(I, 40,1),I=1,4) /
     $           9.375D+01,  2.382D-03, -3.124D-08,  1.817D-13 /
      data      (C(I, 40,2),I=1,4) /
     $           1.316D+02,  6.255D-04, -1.354D-09,  1.178D-15 /
C     3d - 5
      data      Q( 41) /'3d - 5 '/
      data      A( 41) /0.D0/
      data      (C(I, 41,1),I=1,4) /
     $           2.332D+02,  4.300D-03, -5.639D-08,  3.279D-13 /
      data      (C(I, 41,2),I=1,4) /
     $           3.016D+02,  1.129D-03, -2.445D-09,  2.126D-15 /
C
C----           Transition [ 5, 4]
      data      JL( 10),JU( 10) /42, 45/
C     4s - 5
      data      Q( 42) /'4s - 5 '/
      data      A( 42) /0.D0/
      data      (C(I, 42,1),I=1,4) /
     $           2.555D+02,  1.523D-02, -2.326D-07,  1.438D-12 /
      data      (C(I, 42,2),I=1,4) /
     $           3.560D+02,  5.331D-03, -1.698D-08,  1.837D-14 /
C     4p - 5
      data      Q( 43) /'4p - 5 '/
      data      A( 43) /0.D0/
      data      (C(I, 43,1),I=1,4) /
     $           9.393D+02,  5.559D-02, -8.491D-07,  5.251D-12 /
      data      (C(I, 43,2),I=1,4) /
     $           1.306D+03,  1.946D-02, -6.199D-08,  6.707D-14 /
C     4d - 5
      data      Q( 44) /'4d - 5 '/
      data      A( 44) /0.D0/
      data      (C(I, 44,1),I=1,4) /
     $           1.469D+03,  1.284D-01, -1.962D-06,  1.213D-11 /
      data      (C(I, 44,2),I=1,4) /
     $           2.317D+03,  4.497D-02, -1.432D-07,  1.550D-13 /
C     4f - 5
      data      Q( 45) /'4f - 5 '/
      data      A( 45) /0.D0/
      data      (C(I, 45,1),I=1,4) /
     $           1.475D+03,  2.653D-01, -4.053D-06,  2.506D-11 /
      data      (C(I, 45,2),I=1,4) /
     $           3.225D+03,  9.290D-02, -2.959D-07,  3.201D-13 /
C
C----           Transition [ 6, 1]
      data      JL( 11),JU( 11) /46, 46/
C     1s - 6
      data      Q( 46) /'1s - 6 '/
      data      A( 46) /4.5D-7/
      data      (C(I, 46,1),I=1,4) /
     $           1.136D-02,  3.428D-07, -1.467D-13, -1.300D-18 /
      data      (C(I, 46,2),I=1,4) /
     $           1.123D-02,  3.549D-07, -3.998D-13,  2.331D-19 /
C
C----           Transition [ 6, 2]
      data      JL( 12),JU( 12) /47, 48/
C     2s - 6
      data      Q( 47) /'2s - 6 '/
      data      A( 47) /2.4D-7/
      data      (C(I, 47,1),I=1,4) /
     $           1.793D-01,  3.599D-05, -2.848D-10,  1.189D-15 /
      data      (C(I, 47,2),I=1,4) /
     $           7.466D-01,  1.605D-05, -3.611D-11,  3.149D-17 /
C     2p - 6
      data      Q( 48) /'2p - 6 '/
      data      A( 48) /0.D0/
      data      (C(I, 48,1),I=1,4) /
     $           5.379D-01,  1.080D-04, -8.544D-10,  3.566D-15 /
      data      (C(I, 48,2),I=1,4) /
     $           2.240D+00,  4.814D-05, -1.083D-10,  9.448D-17 /
C
C----           Transition [ 6, 3]
      data      JL( 13),JU( 13) /49, 51/
C     3s - 6
      data      Q( 49) /'3s - 6 '/
      data      A( 49) /0.D0/
      data      (C(I, 49,1),I=1,4) /
     $           5.342D-01,  3.320D-04, -3.031D-09,  1.350D-14 /
      data      (C(I, 49,2),I=1,4) /
     $           6.269D+00,  1.223D-04, -2.925D-10,  2.617D-16 /
C     3p - 6
      data      Q( 50) /'3p - 6 '/
      data      A( 50) /0.D0/
      data      (C(I, 50,1),I=1,4) /
     $           1.729D+00,  1.075D-03, -9.810D-09,  4.370D-14 /
      data      (C(I, 50,2),I=1,4) /
     $           2.029D+01,  3.957D-04, -9.468D-10,  8.471D-16 /
C     3d - 6
      data      Q( 51) /'3d - 6 '/
      data      A( 51) /0.D0/
      data      (C(I, 51,1),I=1,4) /
     $           3.481D+00,  2.163D-03, -1.975D-08,  8.799D-14 /
      data      (C(I, 51,2),I=1,4) /
     $           4.085D+01,  7.967D-04, -1.906D-09,  1.705D-15 /
C
C----           Transition [ 6, 4]
      data      JL( 14),JU( 14) /52, 55/
C     4s - 6
      data      Q( 52) /'4s - 6 '/
      data      A( 52) /0.D0/
      data      (C(I, 52,1),I=1,4) /
     $           7.880D+01,  2.140D-03, -3.123D-08,  1.896D-13 /
      data      (C(I, 52,2),I=1,4) /
     $           1.131D+02,  4.513D-04, -1.007D-09,  8.872D-16 /
C     4p - 6
      data      Q( 53) /'4p - 6 '/
      data      A( 53) /0.D0/
      data      (C(I, 53,1),I=1,4) /
     $           2.445D+02,  7.474D-03, -1.091D-07,  6.621D-13 /
      data      (C(I, 53,2),I=1,4) /
     $           3.645D+02,  1.576D-03, -3.518D-09,  3.099D-15 /
C     4d - 6
      data      Q( 54) /'4d - 6 '/
      data      A( 54) /0.D0/
      data      (C(I, 54,1),I=1,4) /
     $           4.677D+02,  1.487D-02, -2.170D-07,  1.317D-12 /
      data      (C(I, 54,2),I=1,4) /
     $           7.064D+02,  3.136D-03, -7.000D-09,  6.166D-15 /
C     4f - 6
      data      Q( 55) /'4f - 6 '/
      data      A( 55) /0.D0/
      data      (C(I, 55,1),I=1,4) /
     $           1.003D+03,  1.995D-02, -2.911D-07,  1.767D-12 /
      data      (C(I, 55,2),I=1,4) /
     $           1.323D+03,  4.207D-03, -9.389D-09,  8.270D-15 /
C
C----           Transition [ 6, 5]
      data      JL( 15),JU( 15) /56, 56/
C     5 - 6
      data      Q( 56) /' 5 - 6 '/
      data      A( 56) /0.D0/
      data      (C(I, 56,1),I=1,4) /
     $          -9.122D+02,  1.260D+00, -1.070D-05,  4.290D-11 /
      data      (C(I, 56,2),I=1,4) /
     $           2.166D+04,  4.690D-01, -1.122D-06,  1.008D-12 /
C
C----           Transition [ 7, 1]
      data      JL( 16),JU( 16) /57, 57/
C     1s - 7
      data      Q( 57) /'1s - 7 '/
      data      A( 57) /3.1D-7/
      data      (C(I, 57,1),I=1,4) /
     $           6.999D-03,  2.126D-07, -9.963D-14, -7.672D-19 /
      data      (C(I, 57,2),I=1,4) /
     $           6.940D-03,  2.194D-07, -2.483D-13,  1.453D-19 /
C
C----           Transition [ 7, 2]
      data      JL( 17),JU( 17) /58, 59/
C     2s - 7
      data      Q( 58) /'2s - 7 '/
      data      A( 58) /3.8D-7/
      data      (C(I, 58,1),I=1,4) /
     $           1.027D-01,  2.090D-05, -1.675D-10,  7.056D-16 /
      data      (C(I, 58,2),I=1,4) /
     $           4.333D-01,  9.222D-06, -2.081D-11,  1.817D-17 /
C     2p - 7
      data      Q( 59) /'2p - 7 '/
      data      A( 59) /2.1D-7/
      data      (C(I, 59,1),I=1,4) /
     $           3.080D-01,  6.270D-05, -5.024D-10,  2.117D-15 /
      data      (C(I, 59,2),I=1,4) /
     $           1.300D+00,  2.767D-05, -6.243D-11,  5.450D-17 /
C
C----           Transition [ 7, 3]
      data      JL( 18),JU( 18) /60, 62/
C     3s - 7
      data      Q( 60) /'3s - 7 '/
      data      A( 60) /0.D0/
      data      (C(I, 60,1),I=1,4) /
     $           2.760D-01,  1.686D-04, -1.584D-09,  7.202D-15 /
      data      (C(I, 60,2),I=1,4) /
     $           3.203D+00,  6.023D-05, -1.451D-10,  1.301D-16 /
C     3p - 7
      data      Q( 61) /'3p - 7 '/
      data      A( 61) /0.D0/
      data      (C(I, 61,1),I=1,4) /
     $           8.934D-01,  5.457D-04, -5.125D-09,  2.331D-14 /
      data      (C(I, 61,2),I=1,4) /
     $           1.037D+01,  1.950D-04, -4.696D-10,  4.212D-16 /
C     3d - 7
      data      Q( 62) /'3d - 7 '/
      data      A( 62) /0.D0/
      data      (C(I, 62,1),I=1,4) /
     $           1.799D+00,  1.099D-03, -1.032D-08,  4.693D-14 /
      data      (C(I, 62,2),I=1,4) /
     $           2.087D+01,  3.925D-04, -9.455D-10,  8.479D-16 /
C
C----           Transition [ 7, 4]
      data      JL( 19),JU( 19) /63, 66/
C     4s - 7
      data      Q( 63) /'4s - 7 '/
      data      A( 63) /0.D0/
      data      (C(I, 63,1),I=1,4) /
     $           7.059D-01,  9.385D-04, -9.491D-09,  4.473D-14 /
      data      (C(I, 63,2),I=1,4) /
     $           1.757D+01,  2.978D-04, -7.355D-10,  6.671D-16 /
C     4p - 7
      data      Q( 64) /'4p - 7 '/
      data      A( 64) /0.D0/
      data      (C(I, 64,1),I=1,4) /
     $           2.363D+00,  3.142D-03, -3.177D-08,  1.498D-13 /
      data      (C(I, 64,2),I=1,4) /
     $           5.881D+01,  9.968D-04, -2.462D-09,  2.233D-15 /
C     4d - 7
      data      Q( 65) /'4d - 7 '/
      data      A( 65) /0.D0/
      data      (C(I, 65,1),I=1,4) /
     $           4.527D+00,  6.019D-03, -6.087D-08,  2.869D-13 /
      data      (C(I, 65,2),I=1,4) /
     $           1.127D+02,  1.910D-03, -4.716D-09,  4.278D-15 /
C     4f - 7
      data      Q( 66) /'4f - 7 '/
      data      A( 66) /0.D0/
      data      (C(I, 66,1),I=1,4) /
     $           7.765D+00,  1.032D-02, -1.044D-07,  4.920D-13 /
      data      (C(I, 66,2),I=1,4) /
     $           1.932D+02,  3.275D-03, -8.090D-09,  7.338D-15 /
C
C----           Transition [ 7, 5]
      data      JL( 20),JU( 20) /67, 67/
C     5 - 7
      data      Q( 67) /' 5 - 7 '/
      data      A( 67) /0.D0/
      data      (C(I, 67,1),I=1,4) /
     $           3.959D+01,  2.108D-01, -2.162D-06,  1.020D-11 /
      data      (C(I, 67,2),I=1,4) /
     $           3.874D+03,  6.443D-02, -1.596D-07,  1.452D-13 /
C
C----           Transition [ 7, 6]
      data      JL( 21),JU( 21) /68, 68/
C     6 - 7
      data      Q( 68) /' 6 - 7 '/
      data      A( 68) /0.D0/
      data      (C(I, 68,1),I=1,4) /
     $          -3.431D+03,  4.116D+00, -3.853D-05,  1.679D-10 /
      data      (C(I, 68,2),I=1,4) /
     $           7.146D+04,  1.379D+00, -3.346D-06,  3.023D-12 /
C
C----           Transition [ 8, 1]
      data      JL( 22),JU( 22) /69, 69/
C     1s - 8
      data      Q( 69) /'1s - 8 '/
      data      A( 69) /2.4D-7/
      data      (C(I, 69,1),I=1,4) /
     $           4.624D-03,  1.410D-07, -6.969D-14, -4.927D-19 /
      data      (C(I, 69,2),I=1,4) /
     $           4.593D-03,  1.453D-07, -1.648D-13,  9.667D-20 /
C
C----           Transition [ 8, 2]
      data      JL( 23),JU( 23) /70, 71/
C     2s - 8
      data      Q( 70) /'2s - 8 '/
      data      A( 70) /4.6D-7/
      data      (C(I, 70,1),I=1,4) /
     $           6.476D-02,  1.330D-05, -1.073D-10,  4.546D-16 /
      data      (C(I, 70,2),I=1,4) /
     $           2.755D-01,  5.832D-06, -1.318D-11,  1.151D-17 /
C     2p - 8
      data      Q( 71) /'2p - 8 '/
      data      A( 71) /2.9D-7/
      data      (C(I, 71,1),I=1,4) /
     $           1.943D-01,  3.989D-05, -3.220D-10,  1.364D-15 /
      data      (C(I, 71,2),I=1,4) /
     $           8.266D-01,  1.750D-05, -3.955D-11,  3.458D-17 /
C
C----           Transition [ 8, 3]
      data      JL( 24),JU( 24) /72, 74/
C     3s - 8
      data      Q( 72) /'3s - 8 '/
      data      A( 72) /0.D0/
      data      (C(I, 72,1),I=1,4) /
     $           1.633D-01,  9.909D-05, -9.445D-10,  4.340D-15 /
      data      (C(I, 72,2),I=1,4) /
     $           1.888D+00,  3.482D-05, -8.421D-11,  7.561D-17 /
C     3p - 8
      data      Q( 73) /'3p - 8 '/
      data      A( 73) /0.D0/
      data      (C(I, 73,1),I=1,4) /
     $           5.286D-01,  3.207D-04, -3.057D-09,  1.405D-14 /
      data      (C(I, 73,2),I=1,4) /
     $           6.112D+00,  1.127D-04, -2.725D-10,  2.447D-16 /
C     3d - 8
      data      Q( 74) /'3d - 8 '/
      data      A( 74) /0.D0/
      data      (C(I, 74,1),I=1,4) /
     $           1.064D+00,  6.457D-04, -6.155D-09,  2.828D-14 /
      data      (C(I, 74,2),I=1,4) /
     $           1.231D+01,  2.269D-04, -5.487D-10,  4.927D-16 /
C
C----           Transition [ 8, 4]
      data      JL( 25),JU( 25) /75, 78/
C     4s - 8
      data      Q( 75) /'4s - 8 '/
      data      A( 75) /0.D0/
      data      (C(I, 75,1),I=1,4) /
     $           4.012D-01,  4.747D-04, -4.937D-09,  2.371D-14 /
      data      (C(I, 75,2),I=1,4) /
     $           8.960D+00,  1.452D-04, -3.616D-10,  3.289D-16 /
C     4p - 8
      data      Q( 76) /'4p - 8 '/
      data      A( 76) /0.D0/
      data      (C(I, 76,1),I=1,4) /
     $           1.343D+00,  1.589D-03, -1.653D-08,  7.939D-14 /
      data      (C(I, 76,2),I=1,4) /
     $           3.000D+01,  4.862D-04, -1.211D-09,  1.101D-15 /
C     4d - 8
      data      Q( 77) /'4d - 8 '/
      data      A( 77) /0.D0/
      data      (C(I, 77,1),I=1,4) /
     $           2.573D+00,  3.044D-03, -3.166D-08,  1.521D-13 /
      data      (C(I, 77,2),I=1,4) /
     $           5.746D+01,  9.314D-04, -2.319D-09,  2.109D-15 /
C     4f - 8
      data      Q( 78) /'4f - 8 '/
      data      A( 78) /0.D0/
      data      (C(I, 78,1),I=1,4) /
     $           4.413D+00,  5.222D-03, -5.431D-08,  2.609D-13 /
      data      (C(I, 78,2),I=1,4) /
     $           9.856D+01,  1.598D-03, -3.977D-09,  3.618D-15 /
C
C----           Transition [ 8, 5]
      data      JL( 26),JU( 26) /79, 79/
C     5 - 8
      data      Q( 79) /' 5 - 8 '/
      data      A( 79) /0.D0/
      data      (C(I, 79,1),I=1,4) /
     $           3.691D+01,  7.806D-02, -8.485D-07,  4.166D-12 /
      data      (C(I, 79,2),I=1,4) /
     $           1.465D+03,  2.207D-02, -5.556D-08,  5.082D-14 /
C
C----           Transition [ 8, 6]
      data      JL( 27),JU( 27) /80, 80/
C     6 - 8
      data      Q( 80) /' 6 - 8 '/
      data      A( 80) /0.D0/
      data      (C(I, 80,1),I=1,4) /
     $           4.397D+01,  6.434D-01, -7.008D-06,  3.431D-11 /
      data      (C(I, 80,2),I=1,4) /
     $           1.187D+04,  1.794D-01, -4.501D-07,  4.118D-13 /
C
C----           Transition [ 8, 7]
      data      JL( 28),JU( 28) /81, 81/
C     7 - 8
      data      Q( 81) /' 7 - 8 '/
      data      A( 81) /0.D0/
      data      (C(I, 81,1),I=1,4) /
     $          -9.280D+03,  1.116D+01, -1.122D-04,  5.167D-10 /
      data      (C(I, 81,2),I=1,4) /
     $           1.954D+05,  3.426D+00, -8.397D-06,  7.624D-12 /
C
C----           Transition [ 9, 1]
      data      JL( 29),JU( 29) /82, 82/
C     1s - 9
      data      Q( 82) /'1s - 9 '/
      data      A( 82) /1.4D-7/
      data      (C(I, 82,1),I=1,4) /
     $           3.217D-03,  9.836D-08, -5.031D-14, -3.361D-19 /
      data      (C(I, 82,2),I=1,4) /
     $           3.199D-03,  1.012D-07, -1.150D-13,  6.758D-20 /
C
C----           Transition [ 9, 2]
      data      JL( 30),JU( 30) /83, 84/
C     2s - 9
      data      Q( 83) /'2s - 9 '/
      data      A( 83) /8.1D-7/
      data      (C(I, 83,1),I=1,4) /
     $           4.366D-02,  9.020D-06, -7.313D-11,  3.108D-16 /
      data      (C(I, 83,2),I=1,4) /
     $           1.868D-01,  3.940D-06, -8.916D-12,  7.790D-18 /
C     2p - 9
      data      Q( 84) /'2p - 9 '/
      data      A( 84) /3.3D-7/
      data      (C(I, 84,1),I=1,4) /
     $           1.310D-01,  2.706D-05, -2.194D-10,  9.325D-16 /
      data      (C(I, 84,2),I=1,4) /
     $           5.604D-01,  1.182D-05, -2.675D-11,  2.337D-17 /
C
C----           Transition [ 9, 3]
      data      JL( 31),JU( 31) /85, 87/
C     3s - 9
      data      Q( 85) /'3s - 9 '/
      data      A( 85) /0.D0/
      data      (C(I, 85,1),I=1,4) /
     $           1.055D-01,  6.385D-05, -6.139D-10,  2.838D-15 /
      data      (C(I, 85,2),I=1,4) /
     $           1.219D+00,  2.221D-05, -5.384D-11,  4.839D-17 /
C     3p - 9
      data      Q( 86) /'3p - 9 '/
      data      A( 86) /0.D0/
      data      (C(I, 86,1),I=1,4) /
     $           3.416D-01,  2.066D-04, -1.987D-09,  9.187D-15 /
      data      (C(I, 86,2),I=1,4) /
     $           3.945D+00,  7.189D-05, -1.743D-10,  1.566D-16 /
C     3d - 9
      data      Q( 87) /'3d - 9 '/
      data      A( 87) /0.D0/
      data      (C(I, 87,1),I=1,4) /
     $           6.877D-01,  4.160D-04, -4.000D-09,  1.850D-14 /
      data      (C(I, 87,2),I=1,4) /
     $           7.942D+00,  1.447D-04, -3.508D-10,  3.153D-16 /
C
C----           Transition [ 9, 4]
      data      JL( 32),JU( 32) /88, 91/
C     4s - 9
      data      Q( 88) /'4s - 9 '/
      data      A( 88) /0.D0/
      data      (C(I, 88,1),I=1,4) /
     $           2.497D-01,  2.796D-04, -2.952D-09,  1.432D-14 /
      data      (C(I, 88,2),I=1,4) /
     $           5.301D+00,  8.379D-05, -2.096D-10,  1.909D-16 /
C     4p - 9
      data      Q( 89) /'4p - 9 '/
      data      A( 89) /0.D0/
      data      (C(I, 89,1),I=1,4) /
     $           8.359D-01,  9.359D-04, -9.882D-09,  4.794D-14 /
      data      (C(I, 89,2),I=1,4) /
     $           1.775D+01,  2.805D-04, -7.017D-10,  6.392D-16 /
C     4d - 9
      data      Q( 90) /'4d - 9 '/
      data      A( 90) /0.D0/
      data      (C(I, 90,1),I=1,4) /
     $           1.601D+00,  1.793D-03, -1.893D-08,  9.183D-14 /
      data      (C(I, 90,2),I=1,4) /
     $           3.399D+01,  5.374D-04, -1.344D-09,  1.224D-15 /
C     4f - 9
      data      Q( 91) /'4f - 9 '/
      data      A( 91) /0.D0/
      data      (C(I, 91,1),I=1,4) /
     $           2.747D+00,  3.075D-03, -3.247D-08,  1.575D-13 /
      data      (C(I, 91,2),I=1,4) /
     $           5.831D+01,  9.217D-04, -2.306D-09,  2.100D-15 /
C
C----           Transition [ 9, 5]
      data      JL( 33),JU( 33) /92, 92/
C     5 - 9
      data      Q( 92) /' 5 - 9 '/
      data      A( 92) /0.D0/
      data      (C(I, 92,1),I=1,4) /
     $           2.352D+01,  3.911D-02, -4.365D-07,  2.179D-12 /
      data      (C(I, 92,2),I=1,4) /
     $           7.410D+02,  1.062D-02, -2.698D-08,  2.476D-14 /
C
C----           Transition [ 9, 6]
      data      JL( 34),JU( 34) /93, 93/
C     6 - 9
      data      Q( 93) /' 6 - 9 '/
      data      A( 93) /0.D0/
      data      (C(I, 93,1),I=1,4) /
     $           8.927D+01,  2.325D-01, -2.667D-06,  1.350D-11 /
      data      (C(I, 93,2),I=1,4) /
     $           4.380D+03,  5.990D-02, -1.527D-07,  1.405D-13 /
C
C----           Transition [ 9, 7]
      data      JL( 35),JU( 35) /94, 94/
C     7 - 9
      data      Q( 94) /' 7 - 9 '/
      data      A( 94) /0.D0/
      data      (C(I, 94,1),I=1,4) /
     $           6.658D+01,  1.651D+00, -1.884D-05,  9.487D-11 /
      data      (C(I, 94,2),I=1,4) /
     $           3.057D+04,  4.266D-01, -1.080D-06,  9.917D-13 /
C
C----           Transition [ 9, 8]
      data      JL( 36),JU( 36) /95, 95/
C     8 - 9
      data      Q( 95) /' 8 - 9 '/
      data      A( 95) /0.D0/
      data      (C(I, 95,1),I=1,4) /
     $          -2.069D+04,  2.637D+01, -2.802D-04,  1.342D-09 /
      data      (C(I, 95,2),I=1,4) /
     $           4.651D+05,  7.527D+00, -1.859D-05,  1.694D-11 /
C
C----           Transition [10, 1]
      data      JL( 37),JU( 37) /96, 96/
C     1s - 10
      data      Q( 96) /'1s - 10'/
      data      A( 96) /8.9D-8/
      data      (C(I, 96,1),I=1,4) /
     $           2.329D-03,  7.135D-08, -3.737D-14, -2.400D-19 /
      data      (C(I, 96,2),I=1,4) /
     $           2.318D-03,  7.334D-08, -8.349D-14,  4.910D-20 /
C
C----           Transition [10, 2]
      data      JL( 38),JU( 38) /97, 98/
C     2s - 10
      data      Q( 97) /'2s - 10'/
      data      A( 97) /5.6D-7/
      data      (C(I, 97,1),I=1,4) /
     $           3.092D-02,  6.415D-06, -5.217D-11,  2.223D-16 /
      data      (C(I, 97,2),I=1,4) /
     $           1.328D-01,  2.795D-06, -6.329D-12,  5.531D-18 /
C     2p - 10
      data      Q( 98) /'2p - 10'/
      data      A( 98) /3.7D-7/
      data      (C(I, 98,1),I=1,4) /
     $           9.276D-02,  1.925D-05, -1.565D-10,  6.668D-16 /
      data      (C(I, 98,2),I=1,4) /
     $           3.984D-01,  8.384D-06, -1.899D-11,  1.659D-17 /
C
C----           Transition [10, 3]
      data      JL( 39),JU( 39) /99, 101/
C     3s - 10
      data      Q( 99) /'3s - 10'/
      data      A( 99) /0.D0/
      data      (C(I, 99,1),I=1,4) /
     $           7.256D-02,  4.383D-05, -4.239D-10,  1.967D-15 /
      data      (C(I, 99,2),I=1,4) /
     $           8.377D-01,  1.515D-05, -3.678D-11,  3.307D-17 /
C     3p - 10
      data      Q(100) /'3p - 10'/
      data      A(100) /0.D0/
      data      (C(I,100,1),I=1,4) /
     $           2.348D-01,  1.419D-04, -1.372D-09,  6.368D-15 /
      data      (C(I,100,2),I=1,4) /
     $           2.711D+00,  4.903D-05, -1.190D-10,  1.070D-16 /
C     3d - 10
      data      Q(101) /'3d - 10'/
      data      A(101) /0.D0/
      data      (C(I,101,1),I=1,4) /
     $           4.728D-01,  2.856D-04, -2.762D-09,  1.282D-14 /
      data      (C(I,101,2),I=1,4) /
     $           5.458D+00,  9.872D-05, -2.397D-10,  2.155D-16 /
C
C----           Transition [10, 4]
      data      JL( 40),JU( 40) /102, 105/
C     4s - 10
      data      Q(102) /'4s - 10'/
      data      A(102) /0.D0/
      data      (C(I,102,1),I=1,4) /
     $           1.667D-01,  1.810D-04, -1.928D-09,  9.410D-15 /
      data      (C(I,102,2),I=1,4) /
     $           3.440D+00,  5.355D-05, -1.343D-10,  1.225D-16 /
C     4p - 10
      data      Q(103) /'4p - 10'/
      data      A(103) /0.D0/
      data      (C(I,103,1),I=1,4) /
     $           5.582D-01,  6.058D-04, -6.456D-09,  3.150D-14 /
      data      (C(I,103,2),I=1,4) /
     $           1.152D+01,  1.793D-04, -4.497D-10,  4.101D-16 /
C     4d - 10
      data      Q(104) /'4d - 10'/
      data      A(104) /0.D0/
      data      (C(I,104,1),I=1,4) /
     $           1.069D+00,  1.160D-03, -1.237D-08,  6.034D-14 /
      data      (C(I,104,2),I=1,4) /
     $           2.206D+01,  3.434D-04, -8.615D-10,  7.856D-16 /
C     4f - 10
      data      Q(105) /'4f - 10'/
      data      A(105) /0.D0/
      data      (C(I,105,1),I=1,4) /
     $           1.834D+00,  1.991D-03, -2.121D-08,  1.035D-13 /
      data      (C(I,105,2),I=1,4) /
     $           3.784D+01,  5.890D-04, -1.478D-09,  1.347D-15 /
C
C----           Transition [10, 5]
      data      JL( 41),JU( 41) /106, 106/
C     5 - 10
      data      Q(106) /' 5 - 10'/
      data      A(106) /0.D0/
      data      (C(I,106,1),I=1,4) /
     $           1.542D+01,  2.296D-02, -2.601D-07,  1.310D-12 /
      data      (C(I,106,2),I=1,4) /
     $           4.374D+02,  6.096D-03, -1.556D-08,  1.430D-14 /
C
C----           Transition [10, 6]
      data      JL( 42),JU( 42) /107, 107/
C     6 - 10
      data      Q(107) /' 6 - 10'/
      data      A(107) /0.D0/
      data      (C(I,107,1),I=1,4) /
     $           6.153D+01,  1.152D-01, -1.354D-06,  6.957D-12 /
      data      (C(I,107,2),I=1,4) /
     $           2.192D+03,  2.846D-02, -7.324D-08,  6.759D-14 /
C
C----           Transition [10, 7]
      data      JL( 43),JU( 43) /108, 108/
C     7 - 10
      data      Q(108) /' 7 - 10'/
      data      A(108) /0.D0/
      data      (C(I,108,1),I=1,4) /
     $           2.172D+02,  5.833D-01, -6.977D-06,  3.615D-11 /
      data      (C(I,108,2),I=1,4) /
     $           1.103D+04,  1.392D-01, -3.582D-07,  3.309D-13 /
C
C----           Transition [10, 8]
      data      JL( 44),JU( 44) /109, 109/
C     8 - 10
      data      Q(109) /' 8 - 10'/
      data      A(109) /0.D0/
      data      (C(I,109,1),I=1,4) /
     $           2.055D+02,  3.731D+00, -4.420D-05,  2.276D-10 /
      data      (C(I,109,2),I=1,4) /
     $           6.930D+04,  9.038D-01, -2.302D-06,  2.121D-12 /
C
C----           Transition [10, 9]
      data      JL( 45),JU( 45) /110, 110/
C     9 - 10
      data      Q(110) /' 9 - 10'/
      data      A(110) /0.D0/
      data      (C(I,110,1),I=1,4) /
     $          -4.032D+04,  5.614D+01, -6.231D-04,  3.073D-09 /
      data      (C(I,110,2),I=1,4) /
     $           9.956D+05,  1.506D+01, -3.741D-05,  3.418D-11 /
C
C----           Transition [11, 1]
      data      JL( 46),JU( 46) /111, 111/
C     1s - 11
      data      Q(111) /'1s - 11'/
      data      A(111) /0.D0/
      data      (C(I,111,1),I=1,4) /
     $           1.741D-03,  5.342D-08, -2.845D-14, -1.775D-19 /
      data      (C(I,111,2),I=1,4) /
     $           1.727D-03,  5.493D-08, -6.270D-14,  3.695D-20 /
C
C----           Transition [11, 2]
      data      JL( 47),JU( 47) /112, 113/
C     2s - 11
      data      Q(112) /'2s - 11'/
      data      A(112) /0.D0/
      data      (C(I,112,1),I=1,4) /
     $           4.162D-02,  8.661D-06, -7.060D-11,  3.013D-16 /
      data      (C(I,112,2),I=1,4) /
     $           1.793D-01,  3.766D-06, -8.534D-12,  7.458D-18 /
C     2p - 11
      data      Q(113) /'2p - 11'/
      data      A(113) /0.D0/
      data      (C(I,113,1),I=1,4) /
     $           4.935D-02,  1.027D-05, -8.372D-11,  3.572D-16 /
      data      (C(I,113,2),I=1,4) /
     $           2.126D-01,  4.466D-06, -1.012D-11,  8.844D-18 /
C
C----           Transition [11, 3]
      data      JL( 48),JU( 48) /114, 116/
C     3s - 11
      data      Q(114) /'3s - 11'/
      data      A(114) /0.D0/
      data      (C(I,114,1),I=1,4) /
     $           5.223D-02,  3.153D-05, -3.061D-10,  1.425D-15 /
      data      (C(I,114,2),I=1,4) /
     $           6.030D-01,  1.085D-05, -2.636D-11,  2.371D-17 /
C     3p - 11
      data      Q(115) /'3p - 11'/
      data      A(115) /0.D0/
      data      (C(I,115,1),I=1,4) /
     $           1.690D-01,  1.020D-04, -9.908D-10,  4.611D-15 /
      data      (C(I,115,2),I=1,4) /
     $           1.952D+00,  3.511D-05, -8.533D-11,  7.675D-17 /
C     3d - 11
      data      Q(116) /'3d - 11'/
      data      A(116) /0.D0/
      data      (C(I,116,1),I=1,4) /
     $           3.403D-01,  2.055D-04, -1.995D-09,  9.283D-15 /
      data      (C(I,116,2),I=1,4) /
     $           3.929D+00,  7.068D-05, -1.718D-10,  1.545D-16 /
C
C----           Transition [11, 4]
      data      JL( 49),JU( 49) /117, 120/
C     4s - 11
      data      Q(117) /'4s - 11'/
      data      A(117) /0.D0/
      data      (C(I,117,1),I=1,4) /
     $           1.174D-01,  1.249D-04, -1.340D-09,  6.562D-15 /
      data      (C(I,117,2),I=1,4) /
     $           2.379D+00,  3.665D-05, -9.214D-11,  8.407D-17 /
C     4p - 11
      data      Q(118) /'4p - 11'/
      data      A(118) /0.D0/
      data      (C(I,118,1),I=1,4) /
     $           3.931D-01,  4.183D-04, -4.484D-09,  2.197D-14 /
      data      (C(I,118,2),I=1,4) /
     $           7.966D+00,  1.227D-04, -3.085D-10,  2.815D-16 /
C     4d - 11
      data      Q(119) /'4d - 11'/
      data      A(119) /0.D0/
      data      (C(I,119,1),I=1,4) /
     $           7.529D-01,  8.012D-04, -8.590D-09,  4.208D-14 /
      data      (C(I,119,2),I=1,4) /
     $           1.526D+01,  2.351D-04, -5.909D-10,  5.392D-16 /
C     4f - 11
      data      Q(120) /'4f - 11'/
      data      A(120) /0.D0/
      data      (C(I,120,1),I=1,4) /
     $           1.291D+00,  1.374D-03, -1.473D-08,  7.218D-14 /
      data      (C(I,120,2),I=1,4) /
     $           2.617D+01,  4.032D-04, -1.014D-09,  9.248D-16 /
C
C----           Transition [11, 5]
      data      JL( 50),JU( 50) /121, 121/
C     5 - 11
      data      Q(121) /' 5 - 11'/
      data      A(121) /0.D0/
      data      (C(I,121,1),I=1,4) /
     $           1.062D+01,  1.487D-02, -1.699D-07,  8.608D-13 /
      data      (C(I,121,2),I=1,4) /
     $           2.841D+02,  3.889D-03, -9.962D-09,  9.167D-15 /
C
C----           Transition [11, 6]
      data      JL( 51),JU( 51) /122, 122/
C     6 - 11
      data      Q(122) /' 6 - 11'/
      data      A(122) /0.D0/
      data      (C(I,122,1),I=1,4) /
     $           4.165D+01,  6.729D-02, -8.024D-07,  4.156D-12 /
      data      (C(I,122,2),I=1,4) /
     $           1.288D+03,  1.621D-02, -4.197D-08,  3.881D-14 /
C
C----           Transition [11, 7]
      data      JL( 52),JU( 52) /123, 123/
C     7 - 11
      data      Q(123) /' 7 - 11'/
      data      A(123) /0.D0/
      data      (C(I,123,1),I=1,4) /
     $           1.535D+02,  2.858D-01, -3.499D-06,  1.838D-11 /
      data      (C(I,123,2),I=1,4) /
     $           5.458D+03,  6.530D-02, -1.696D-07,  1.572D-13 /
C
C----           Transition [11, 8]
      data      JL( 53),JU( 53) /124, 124/
C     8 - 11
      data      Q(124) /' 8 - 11'/
      data      A(124) /0.D0/
      data      (C(I,124,1),I=1,4) /
     $           5.123D+02,  1.292D+00, -1.599D-05,  8.442D-11 /
      data      (C(I,124,2),I=1,4) /
     $           2.450D+04,  2.891D-01, -7.487D-07,  6.939D-13 /
C
C----           Transition [11, 9]
      data      JL( 54),JU( 54) /125, 125/
C     9 - 11
      data      Q(125) /' 9 - 11'/
      data      A(125) /0.D0/
      data      (C(I,125,1),I=1,4) /
     $           6.989D+02,  7.655D+00, -9.352D-05,  4.903D-10 /
      data      (C(I,125,2),I=1,4) /
     $           1.425D+05,  1.754D+00, -4.489D-06,  4.146D-12 /
C
C----           Transition [11,10]
      data      JL( 55),JU( 55) /126, 126/
C     10 - 11
      data      Q(126) /'10 - 11'/
      data      A(126) /0.D0/
      data      (C(I,126,1),I=1,4) /
     $          -7.097D+04,  1.101D+02, -1.266D-03,  6.390D-09 /
      data      (C(I,126,2),I=1,4) /
     $           1.961D+06,  2.798D+01, -6.982D-05,  6.394D-11 /
C
C----           Transition [12, 1]
      data      JL( 56),JU( 56) /127, 127/
C     1s - 12
      data      Q(127) /'1s - 12'/
      data      A(127) /0.D0/
      data      (C(I,127,1),I=1,4) /
     $           1.336D-03,  4.103D-08, -2.213D-14, -1.351D-19 /
      data      (C(I,127,2),I=1,4) /
     $           1.326D-03,  4.218D-08, -4.821D-14,  2.844D-20 /
C
C----           Transition [12, 2]
      data      JL( 57),JU( 57) /128, 129/
C     2s - 12
      data      Q(128) /'2s - 12'/
      data      A(128) /0.D0/
      data      (C(I,128,1),I=1,4) /
     $           3.155D-02,  6.580D-06, -5.373D-11,  2.295D-16 /
      data      (C(I,128,2),I=1,4) /
     $           1.362D-01,  2.857D-06, -6.477D-12,  5.661D-18 /
C     2p - 12
      data      Q(129) /'2p - 12'/
      data      A(129) /0.D0/
      data      (C(I,129,1),I=1,4) /
     $           3.741D-02,  7.803D-06, -6.371D-11,  2.722D-16 /
      data      (C(I,129,2),I=1,4) /
     $           1.615D-01,  3.388D-06, -7.680D-12,  6.713D-18 /
C
C----           Transition [12, 3]
      data      JL( 58),JU( 58) /130, 132/
C     3s - 12
      data      Q(130) /'3s - 12'/
      data      A(130) /0.D0/
      data      (C(I,130,1),I=1,4) /
     $           3.895D-02,  2.351D-05, -2.289D-10,  1.067D-15 /
      data      (C(I,130,2),I=1,4) /
     $           4.497D-01,  8.059D-06, -1.960D-11,  1.764D-17 /
C     3p - 12
      data      Q(131) /'3p - 12'/
      data      A(131) /0.D0/
      data      (C(I,131,1),I=1,4) /
     $           1.261D-01,  7.608D-05, -7.407D-10,  3.454D-15 /
      data      (C(I,131,2),I=1,4) /
     $           1.456D+00,  2.608D-05, -6.345D-11,  5.708D-17 /
C     3d - 12
      data      Q(132) /'3d - 12'/
      data      A(132) /0.D0/
      data      (C(I,132,1),I=1,4) /
     $           2.538D-01,  1.532D-04, -1.491D-09,  6.954D-15 /
      data      (C(I,132,2),I=1,4) /
     $           2.931D+00,  5.252D-05, -1.277D-10,  1.149D-16 /
C
C----           Transition [12, 4]
      data      JL( 59),JU( 59) /133, 136/
C     4s - 12
      data      Q(133) /'4s - 12'/
      data      A(133) /0.D0/
      data      (C(I,133,1),I=1,4) /
     $           8.609D-02,  9.041D-05, -9.735D-10,  4.781D-15 /
      data      (C(I,133,2),I=1,4) /
     $           1.724D+00,  2.636D-05, -6.637D-11,  6.058D-17 /
C     4p - 12
      data      Q(134) /'4p - 12'/
      data      A(134) /0.D0/
      data      (C(I,134,1),I=1,4) /
     $           2.882D-01,  3.027D-04, -3.259D-09,  1.601D-14 /
      data      (C(I,134,2),I=1,4) /
     $           5.771D+00,  8.825D-05, -2.222D-10,  2.028D-16 /
C     4d - 12
      data      Q(135) /'4d - 12'/
      data      A(135) /0.D0/
      data      (C(I,135,1),I=1,4) /
     $           5.521D-01,  5.798D-04, -6.243D-09,  3.066D-14 /
      data      (C(I,135,2),I=1,4) /
     $           1.106D+01,  1.691D-04, -4.256D-10,  3.885D-16 /
C     4f - 12
      data      Q(136) /'4f - 12'/
      data      A(136) /0.D0/
      data      (C(I,136,1),I=1,4) /
     $           9.470D-01,  9.945D-04, -1.071D-08,  5.260D-14 /
      data      (C(I,136,2),I=1,4) /
     $           1.896D+01,  2.900D-04, -7.300D-10,  6.664D-16 /
C
C----           Transition [12, 5]
      data      JL( 60),JU( 60) /137, 137/
C     5 - 12
      data      Q(137) /' 5 - 12'/
      data      A(137) /0.D0/
      data      (C(I,137,1),I=1,4) /
     $           7.642D+00,  1.029D-02, -1.183D-07,  6.014D-13 /
      data      (C(I,137,2),I=1,4) /
     $           1.969D+02,  2.663D-03, -6.838D-09,  6.297D-15 /
C
C----           Transition [12, 6]
      data      JL( 61),JU( 61) /138, 138/
C     6 - 12
      data      Q(138) /' 6 - 12'/
      data      A(138) /0.D0/
      data      (C(I,138,1),I=1,4) /
     $           2.923D+01,  4.349D-02, -5.232D-07,  2.724D-12 /
      data      (C(I,138,2),I=1,4) /
     $           8.351D+02,  1.031D-02, -2.678D-08,  2.480D-14 /
C
C----           Transition [12, 7]
      data      JL( 62),JU( 62) /139, 139/
C     7 - 12
      data      Q(139) /' 7 - 12'/
      data      A(139) /0.D0/
      data      (C(I,139,1),I=1,4) /
     $           1.049D+02,  1.660D-01, -2.060D-06,  1.090D-11 /
      data      (C(I,139,2),I=1,4) /
     $           3.189D+03,  3.693D-02, -9.653D-08,  8.966D-14 /
C
C----           Transition [12, 8]
      data      JL( 63),JU( 63) /140, 140/
C     8 - 12
      data      Q(140) /' 8 - 12'/
      data      A(140) /0.D0/
      data      (C(I,140,1),I=1,4) /
     $           3.578D+02,  6.265D-01, -7.922D-06,  4.235D-11 /
      data      (C(I,140,2),I=1,4) /
     $           1.200D+04,  1.340D-01, -3.505D-07,  3.260D-13 /
C
C----           Transition [12, 9]
      data      JL( 64),JU( 64) /141, 141/
C     9 - 12
      data      Q(141) /' 9 - 12'/
      data      A(141) /0.D0/
      data      (C(I,141,1),I=1,4) /
     $           1.141D+03,  2.605D+00, -3.313D-05,  1.777D-10 /
      data      (C(I,141,2),I=1,4) /
     $           4.949D+04,  5.510D-01, -1.435D-06,  1.333D-12 /
C
C----           Transition [12,10]
      data      JL( 65),JU( 65) /142, 142/
C     10 - 12
      data      Q(142) /'10 - 12'/
      data      A(142) /0.D0/
      data      (C(I,142,1),I=1,4) /
     $           2.018D+03,  1.455D+01, -1.824D-04,  9.708D-10 /
      data      (C(I,142,2),I=1,4) /
     $           2.715D+05,  3.175D+00, -8.158D-06,  7.551D-12 /
C
C----           Transition [12,11]
      data      JL( 66),JU( 66) /143, 143/
C     11 - 12
      data      Q(143) /'11 - 12'/
      data      A(143) /0.D0/
      data      (C(I,143,1),I=1,4) /
     $          -1.150D+05,  2.020D+02, -2.392D-03,  1.231D-08 /
      data      (C(I,143,2),I=1,4) /
     $           3.613D+06,  4.898D+01, -1.227D-04,  1.125D-10 /
C
C----           Transition [13, 1]
      data      JL( 67),JU( 67) /144, 144/
C     1s - 13
      data      Q(144) /'1s - 13'/
      data      A(144) /0.D0/
      data      (C(I,144,1),I=1,4) /
     $           1.048D-03,  3.220D-08, -1.754D-14, -1.053D-19 /
      data      (C(I,144,2),I=1,4) /
     $           1.040D-03,  3.310D-08, -3.786D-14,  2.236D-20 /
C
C----           Transition [13, 2]
      data      JL( 68),JU( 68) /145, 146/
C     2s - 13
      data      Q(145) /'2s - 13'/
      data      A(145) /0.D0/
      data      (C(I,145,1),I=1,4) /
     $           2.450D-02,  5.121D-06, -4.186D-11,  1.790D-16 /
      data      (C(I,145,2),I=1,4) /
     $           1.059D-01,  2.221D-06, -5.036D-12,  4.402D-18 /
C     2p - 13
      data      Q(146) /'2p - 13'/
      data      A(146) /0.D0/
      data      (C(I,146,1),I=1,4) /
     $           2.906D-02,  6.072D-06, -4.964D-11,  2.123D-16 /
      data      (C(I,146,2),I=1,4) /
     $           1.256D-01,  2.634D-06, -5.972D-12,  5.220D-18 /
C
C----           Transition [13, 3]
      data      JL( 69),JU( 69) /147, 149/
C     3s - 13
      data      Q(147) /'3s - 13'/
      data      A(147) /0.D0/
      data      (C(I,147,1),I=1,4) /
     $           2.988D-02,  1.803D-05, -1.759D-10,  8.214D-16 /
      data      (C(I,147,2),I=1,4) /
     $           3.451D-01,  6.166D-06, -1.501D-11,  1.350D-17 /
C     3p - 13
      data      Q(148) /'3p - 13'/
      data      A(148) /0.D0/
      data      (C(I,148,1),I=1,4) /
     $           9.671D-02,  5.835D-05, -5.694D-10,  2.659D-15 /
      data      (C(I,148,2),I=1,4) /
     $           1.117D+00,  1.996D-05, -4.857D-11,  4.371D-17 /
C     3d - 13
      data      Q(149) /'3d - 13'/
      data      A(149) /0.D0/
      data      (C(I,149,1),I=1,4) /
     $           1.947D-01,  1.175D-04, -1.146D-09,  5.353D-15 /
      data      (C(I,149,2),I=1,4) /
     $           2.249D+00,  4.018D-05, -9.779D-11,  8.800D-17 /
C
C----           Transition [13, 4]
      data      JL( 70),JU( 70) /150, 153/
C     4s - 13
      data      Q(150) /'4s - 13'/
      data      A(150) /0.D0/
      data      (C(I,150,1),I=1,4) /
     $           6.518D-02,  6.781D-05, -7.324D-10,  3.604D-15 /
      data      (C(I,150,2),I=1,4) /
     $           1.294D+00,  1.968D-05, -4.961D-11,  4.530D-17 /
C     4p - 13
      data      Q(151) /'4p - 13'/
      data      A(151) /0.D0/
      data      (C(I,151,1),I=1,4) /
     $           2.182D-01,  2.270D-04, -2.452D-09,  1.207D-14 /
      data      (C(I,151,2),I=1,4) /
     $           4.332D+00,  6.589D-05, -1.661D-10,  1.517D-16 /
C     4d - 13
      data      Q(152) /'4d - 13'/
      data      A(152) /0.D0/
      data      (C(I,152,1),I=1,4) /
     $           4.180D-01,  4.349D-04, -4.697D-09,  2.311D-14 /
      data      (C(I,152,2),I=1,4) /
     $           8.299D+00,  1.262D-04, -3.181D-10,  2.905D-16 /
C     4f - 13
      data      Q(153) /'4f - 13'/
      data      A(153) /0.D0/
      data      (C(I,153,1),I=1,4) /
     $           7.169D-01,  7.459D-04, -8.056D-09,  3.965D-14 /
      data      (C(I,153,2),I=1,4) /
     $           1.423D+01,  2.165D-04, -5.457D-10,  4.983D-16 /
C
C----           Transition [13, 5]
      data      JL( 71),JU( 71) /154, 154/
C     5 - 13
      data      Q(154) /' 5 - 13'/
      data      A(154) /0.D0/
      data      (C(I,154,1),I=1,4) /
     $           5.695D+00,  7.464D-03, -8.621D-08,  4.394D-13 /
      data      (C(I,154,2),I=1,4) /
     $           1.431D+02,  1.918D-03, -4.935D-09,  4.547D-15 /
C
C----           Transition [13, 6]
      data      JL( 72),JU( 72) /155, 155/
C     6 - 13
      data      Q(155) /' 6 - 13'/
      data      A(155) /0.D0/
      data      (C(I,155,1),I=1,4) /
     $           2.130D+01,  3.008D-02, -3.641D-07,  1.902D-12 /
      data      (C(I,155,2),I=1,4) /
     $           5.790D+02,  7.050D-03, -1.837D-08,  1.702D-14 /
C
C----           Transition [13, 7]
      data      JL( 73),JU( 73) /156, 156/
C     7 - 13
      data      Q(156) /' 7 - 13'/
      data      A(156) /0.D0/
      data      (C(I,156,1),I=1,4) /
     $           7.412D+01,  1.070D-01, -1.339D-06,  7.118D-12 /
      data      (C(I,156,2),I=1,4) /
     $           2.062D+03,  2.338D-02, -6.136D-08,  5.707D-14 /
C
C----           Transition [13, 8]
      data      JL( 74),JU( 74) /157, 157/
C     8 - 13
      data      Q(157) /' 8 - 13'/
      data      A(157) /0.D0/
      data      (C(I,157,1),I=1,4) /
     $           2.438D+02,  3.616D-01, -4.633D-06,  2.494D-11 /
      data      (C(I,157,2),I=1,4) /
     $           6.970D+03,  7.523D-02, -1.981D-07,  1.846D-13 /
C
C----           Transition [13, 9]
      data      JL( 75),JU( 75) /158, 158/
C     9 - 13
      data      Q(158) /' 9 - 13'/
      data      A(158) /0.D0/
      data      (C(I,158,1),I=1,4) /
     $           7.755D+02,  1.250D+00, -1.624D-05,  8.808D-11 /
      data      (C(I,158,2),I=1,4) /
     $           2.401D+04,  2.526D-01, -6.645D-07,  6.196D-13 /
C
C----           Transition [13,10]
      data      JL( 76),JU( 76) /159, 159/
C     10 - 13
      data      Q(159) /'10 - 13'/
      data      A(159) /0.D0/
      data      (C(I,159,1),I=1,4) /
     $           2.383D+03,  4.875D+00, -6.348D-05,  3.449D-10 /
      data      (C(I,159,2),I=1,4) /
     $           9.279D+04,  9.821D-01, -2.567D-06,  2.390D-12 /
C
C----           Transition [13,11]
      data      JL( 77),JU( 77) /160, 160/
C     11 - 13
      data      Q(160) /'11 - 13'/
      data      A(160) /0.D0/
      data      (C(I,160,1),I=1,4) /
     $           4.988D+03,  2.601D+01, -3.334D-04,  1.797D-09 /
      data      (C(I,160,2),I=1,4) /
     $           4.861D+05,  5.434D+00, -1.401D-05,  1.299D-11 /
C
C----           Transition [13,12]
      data      JL( 78),JU( 78) /161, 161/
C     12 - 13
      data      Q(161) /'12 - 13'/
      data      A(161) /0.D0/
      data      (C(I,161,1),I=1,4) /
     $          -1.737D+05,  3.511D+02, -4.263D-03,  2.227D-08 /
      data      (C(I,161,2),I=1,4) /
     $           6.300D+06,  8.163D+01, -2.051D-04,  1.884D-10 /
C
C----           Transition [14, 1]
      data      JL( 79),JU( 79) /162, 162/
C     1s - 14
      data      Q(162) /'1s - 14'/
      data      A(162) /0.D0/
      data      (C(I,162,1),I=1,4) /
     $           8.369D-04,  2.574D-08, -1.413D-14, -8.368D-20 /
      data      (C(I,162,2),I=1,4) /
     $           8.305D-04,  2.645D-08, -3.028D-14,  1.790D-20 /
C
C----           Transition [14, 2]
      data      JL( 80),JU( 80) /163, 164/
C     2s - 14
      data      Q(163) /'2s - 14'/
      data      A(163) /0.D0/
      data      (C(I,163,1),I=1,4) /
     $           1.943D-02,  4.066D-06, -3.327D-11,  1.424D-16 /
      data      (C(I,163,2),I=1,4) /
     $           8.411D-02,  1.762D-06, -3.996D-12,  3.493D-18 /
C     2p - 14
      data      Q(164) /'2p - 14'/
      data      A(164) /0.D0/
      data      (C(I,164,1),I=1,4) /
     $           2.304D-02,  4.821D-06, -3.945D-11,  1.688D-16 /
      data      (C(I,164,2),I=1,4) /
     $           9.973D-02,  2.089D-06, -4.738D-12,  4.142D-18 /
C
C----           Transition [14, 3]
      data      JL( 81),JU( 81) /165, 167/
C     3s - 14
      data      Q(165) /'3s - 14'/
      data      A(165) /0.D0/
      data      (C(I,165,1),I=1,4) /
     $           2.346D-02,  1.415D-05, -1.383D-10,  6.466D-16 /
      data      (C(I,165,2),I=1,4) /
     $           2.709D-01,  4.831D-06, -1.176D-11,  1.059D-17 /
C     3p - 14
      data      Q(166) /'3p - 14'/
      data      A(166) /0.D0/
      data      (C(I,166,1),I=1,4) /
     $           7.593D-02,  4.580D-05, -4.477D-10,  2.093D-15 /
      data      (C(I,166,2),I=1,4) /
     $           8.769D-01,  1.563D-05, -3.807D-11,  3.426D-17 /
C     3d - 14
      data      Q(167) /'3d - 14'/
      data      A(167) /0.D0/
      data      (C(I,167,1),I=1,4) /
     $           1.529D-01,  9.222D-05, -9.013D-10,  4.213D-15 /
      data      (C(I,167,2),I=1,4) /
     $           1.766D+00,  3.148D-05, -7.665D-11,  6.899D-17 /
C
C----           Transition [14, 4]
      data      JL( 82),JU( 82) /168, 171/
C     4s - 14
      data      Q(168) /'4s - 14'/
      data      A(168) /0.D0/
      data      (C(I,168,1),I=1,4) /
     $           5.063D-02,  5.231D-05, -5.664D-10,  2.791D-15 /
      data      (C(I,168,2),I=1,4) /
     $           9.990D-01,  1.513D-05, -3.817D-11,  3.487D-17 /
C     4p - 14
      data      Q(169) /'4p - 14'/
      data      A(169) /0.D0/
      data      (C(I,169,1),I=1,4) /
     $           1.695D-01,  1.751D-04, -1.896D-09,  9.345D-15 /
      data      (C(I,169,2),I=1,4) /
     $           3.344D+00,  5.066D-05, -1.278D-10,  1.167D-16 /
C     4d - 14
      data      Q(170) /'4d - 14'/
      data      A(170) /0.D0/
      data      (C(I,170,1),I=1,4) /
     $           3.247D-01,  3.355D-04, -3.632D-09,  1.790D-14 /
      data      (C(I,170,2),I=1,4) /
     $           6.406D+00,  9.705D-05, -2.448D-10,  2.236D-16 /
C     4f - 14
      data      Q(171) /'4f - 14'/
      data      A(171) /0.D0/
      data      (C(I,171,1),I=1,4) /
     $           5.570D-01,  5.755D-04, -6.230D-09,  3.071D-14 /
      data      (C(I,171,2),I=1,4) /
     $           1.099D+01,  1.665D-04, -4.199D-10,  3.835D-16 /
C
C----           Transition [14, 5]
      data      JL( 83),JU( 83) /172, 172/
C     5 - 14
      data      Q(172) /' 5 - 14'/
      data      A(172) /0.D0/
      data      (C(I,172,1),I=1,4) /
     $           4.368D+00,  5.617D-03, -6.508D-08,  3.323D-13 /
      data      (C(I,172,2),I=1,4) /
     $           1.078D+02,  1.436D-03, -3.698D-09,  3.409D-15 /
C
C----           Transition [14, 6]
      data      JL( 84),JU( 84) /173, 173/
C     6 - 14
      data      Q(173) /' 6 - 14'/
      data      A(173) /0.D0/
      data      (C(I,173,1),I=1,4) /
     $           1.603D+01,  2.185D-02, -2.656D-07,  1.391D-12 /
      data      (C(I,173,2),I=1,4) /
     $           4.213D+02,  5.079D-03, -1.326D-08,  1.229D-14 /
C
C----           Transition [14, 7]
      data      JL( 85),JU( 85) /174, 174/
C     7 - 14
      data      Q(174) /' 7 - 14'/
      data      A(174) /0.D0/
      data      (C(I,174,1),I=1,4) /
     $           5.428D+01,  7.389D-02, -9.304D-07,  4.963D-12 /
      data      (C(I,174,2),I=1,4) /
     $           1.429D+03,  1.595D-02, -4.200D-08,  3.910D-14 /
C
C----           Transition [14, 8]
      data      JL( 86),JU( 86) /175, 175/
C     8 - 14
      data      Q(175) /' 8 - 14'/
      data      A(175) /0.D0/
      data      (C(I,175,1),I=1,4) /
     $           1.721D+02,  2.322D-01, -3.000D-06,  1.622D-11 /
      data      (C(I,175,2),I=1,4) /
     $           4.493D+03,  4.741D-02, -1.254D-07,  1.170D-13 /
C
C----           Transition [14, 9]
      data      JL( 87),JU( 87) /176, 176/
C     9 - 14
      data      Q(176) /' 9 - 14'/
      data      A(176) /0.D0/
      data      (C(I,176,1),I=1,4) /
     $           5.234D+02,  7.175D-01, -9.437D-06,  5.153D-11 /
      data      (C(I,176,2),I=1,4) /
     $           1.386D+04,  1.408D-01, -3.729D-07,  3.485D-13 /
C
C----           Transition [14,10]
      data      JL( 88),JU( 88) /177, 177/
C     10 - 14
      data      Q(177) /'10 - 14'/
      data      A(177) /0.D0/
      data      (C(I,177,1),I=1,4) /
     $           1.569D+03,  2.319D+00, -3.081D-05,  1.691D-10 /
      data      (C(I,177,2),I=1,4) /
     $           4.460D+04,  4.458D-01, -1.178D-06,  1.100D-12 /
C
C----           Transition [14,11]
      data      JL( 89),JU( 89) /178, 178/
C     11 - 14
      data      Q(178) /'11 - 14'/
      data      A(178) /0.D0/
      data      (C(I,178,1),I=1,4) /
     $           4.675D+03,  8.595D+00, -1.142D-04,  6.273D-10 /
      data      (C(I,178,2),I=1,4) /
     $           1.638D+05,  1.658D+00, -4.348D-06,  4.054D-12 /
C
C----           Transition [14,12]
      data      JL( 90),JU( 90) /179, 179/
C     12 - 14
      data      Q(179) /'12 - 14'/
      data      A(179) /0.D0/
      data      (C(I,179,1),I=1,4) /
     $           1.094D+04,  4.419D+01, -5.774D-04,  3.146D-09 /
      data      (C(I,179,2),I=1,4) /
     $           8.271D+05,  8.881D+00, -2.296D-05,  2.131D-11 /
C
C----           Transition [14,13]
      data      JL( 91),JU( 91) /180, 180/
C     13 - 14
      data      Q(180) /'13 - 14'/
      data      A(180) /0.D0/
      data      (C(I,180,1),I=1,4) /
     $          -2.459D+05,  5.829D+02, -7.233D-03,  3.830D-08 /
      data      (C(I,180,2),I=1,4) /
     $           1.049D+07,  1.305D+02, -3.288D-04,  3.025D-10 /
C
C----           Transition [15, 1]
      data      JL( 92),JU( 92) /181, 181/
C     1s - 15
      data      Q(181) /'1s - 15'/
      data      A(181) /0.D0/
      data      (C(I,181,1),I=1,4) /
     $           6.791D-04,  2.090D-08, -1.154D-14, -6.763D-20 /
      data      (C(I,181,2),I=1,4) /
     $           6.740D-04,  2.147D-08, -2.460D-14,  1.455D-20 /
C
C----           Transition [15, 2]
      data      JL( 93),JU( 93) /182, 183/
C     2s - 15
      data      Q(182) /'2s - 15'/
      data      A(182) /0.D0/
      data      (C(I,182,1),I=1,4) /
     $           1.567D-02,  3.283D-06, -2.689D-11,  1.151D-16 /
      data      (C(I,182,2),I=1,4) /
     $           6.791D-02,  1.422D-06, -3.225D-12,  2.820D-18 /
C     2p - 15
      data      Q(183) /'2p - 15'/
      data      A(183) /0.D0/
      data      (C(I,183,1),I=1,4) /
     $           1.858D-02,  3.893D-06, -3.188D-11,  1.365D-16 /
      data      (C(I,183,2),I=1,4) /
     $           8.053D-02,  1.686D-06, -3.825D-12,  3.344D-18 /
C
C----           Transition [15, 3]
      data      JL( 94),JU( 94) /184, 186/
C     3s - 15
      data      Q(184) /'3s - 15'/
      data      A(184) /0.D0/
      data      (C(I,184,1),I=1,4) /
     $           1.877D-02,  1.133D-05, -1.108D-10,  5.185D-16 /
      data      (C(I,184,2),I=1,4) /
     $           2.169D-01,  3.860D-06, -9.403D-12,  8.463D-18 /
C     3p - 15
      data      Q(185) /'3p - 15'/
      data      A(185) /0.D0/
      data      (C(I,185,1),I=1,4) /
     $           6.076D-02,  3.665D-05, -3.587D-10,  1.678D-15 /
      data      (C(I,185,2),I=1,4) /
     $           7.019D-01,  1.249D-05, -3.043D-11,  2.739D-17 /
C     3d - 15
      data      Q(186) /'3d - 15'/
      data      A(186) /0.D0/
      data      (C(I,186,1),I=1,4) /
     $           1.223D-01,  7.380D-05, -7.222D-10,  3.379D-15 /
      data      (C(I,186,2),I=1,4) /
     $           1.413D+00,  2.515D-05, -6.127D-11,  5.515D-17 /
C
C----           Transition [15, 4]
      data      JL( 95),JU( 95) /187, 190/
C     4s - 15
      data      Q(187) /'4s - 15'/
      data      A(187) /0.D0/
      data      (C(I,187,1),I=1,4) /
     $           4.018D-02,  4.130D-05, -4.479D-10,  2.210D-15 /
      data      (C(I,187,2),I=1,4) /
     $           7.890D-01,  1.191D-05, -3.007D-11,  2.747D-17 /
C     4p - 15
      data      Q(188) /'4p - 15'/
      data      A(188) /0.D0/
      data      (C(I,188,1),I=1,4) /
     $           1.345D-01,  1.383D-04, -1.499D-09,  7.399D-15 /
      data      (C(I,188,2),I=1,4) /
     $           2.641D+00,  3.988D-05, -1.007D-10,  9.197D-17 /
C     4d - 15
      data      Q(189) /'4d - 15'/
      data      A(189) /0.D0/
      data      (C(I,189,1),I=1,4) /
     $           2.577D-01,  2.648D-04, -2.872D-09,  1.417D-14 /
      data      (C(I,189,2),I=1,4) /
     $           5.060D+00,  7.640D-05, -1.928D-10,  1.762D-16 /
C     4f - 15
      data      Q(190) /'4f - 15'/
      data      A(190) /0.D0/
      data      (C(I,190,1),I=1,4) /
     $           4.420D-01,  4.543D-04, -4.927D-09,  2.431D-14 /
      data      (C(I,190,2),I=1,4) /
     $           8.678D+00,  1.310D-04, -3.308D-10,  3.022D-16 /
C
C----           Transition [15, 5]
      data      JL( 96),JU( 96) /191, 191/
C     5 - 15
      data      Q(191) /' 5 - 15'/
      data      A(191) /0.D0/
      data      (C(I,191,1),I=1,4) /
     $           3.430D+00,  4.348D-03, -5.051D-08,  2.583D-13 /
      data      (C(I,191,2),I=1,4) /
     $           8.353D+01,  1.107D-03, -2.854D-09,  2.632D-15 /
C
C----           Transition [15, 6]
      data      JL( 97),JU( 97) /192, 192/
C     6 - 15
      data      Q(192) /' 6 - 15'/
      data      A(192) /0.D0/
      data      (C(I,192,1),I=1,4) /
     $           1.239D+01,  1.647D-02, -2.008D-07,  1.054D-12 /
      data      (C(I,192,2),I=1,4) /
     $           3.179D+02,  3.804D-03, -9.944D-09,  9.226D-15 /
C
C----           Transition [15, 7]
      data      JL( 98),JU( 98) /193, 193/
C     7 - 15
      data      Q(193) /' 7 - 15'/
      data      A(193) /0.D0/
      data      (C(I,193,1),I=1,4) /
     $           4.103D+01,  5.366D-02, -6.786D-07,  3.629D-12 /
      data      (C(I,193,2),I=1,4) /
     $           1.039D+03,  1.148D-02, -3.029D-08,  2.282D-14 /
C
C----           Transition [15, 8]
      data      JL( 99),JU( 99) /194, 194/
C     8 - 15
      data      Q(194) /' 8 - 15'/
      data      A(194) /0.D0/
      data      (C(I,194,1),I=1,4) /
     $           1.260D+02,  1.601D-01, -2.081D-06,  1.129D-11 /
      data      (C(I,194,2),I=1,4) /
     $           3.106D+03,  3.226D-02, -8.559D-08,  7.997D-14 /
C
C----           Transition [15, 9]
      data      JL(100),JU(100) /195, 195/
C     9 - 15
      data      Q(195) /' 9 - 15'/
      data      A(195) /0.D0/
      data      (C(I,195,1),I=1,4) /
     $           3.677D+02,  4.590D-01, -6.087D-06,  3.338D-11 /
      data      (C(I,195,2),I=1,4) /
     $           8.904D+03,  8.835D-02, -2.350D-07,  2.200D-13 /
C
C----           Transition [15,10]
      data      JL(101),JU(101) /196, 196/
C     10 - 15
      data      Q(196) /'10 - 15'/
      data      A(196) /0.D0/
      data      (C(I,196,1),I=1,4) /
     $           1.046D+03,  1.323D+00, -1.779D-05,  9.830D-11 /
      data      (C(I,196,2),I=1,4) /
     $           2.561D+04,  2.468D-01, -6.566D-07,  6.150D-13 /
C
C----           Transition [15,11]
      data      JL(102),JU(102) /197, 197/
C     11 - 15
      data      Q(197) /'11 - 15'/
      data      A(197) /0.D0/
      data      (C(I,197,1),I=1,4) /
     $           2.986D+03,  4.054D+00, -5.491D-05,  3.046D-10 /
      data      (C(I,197,2),I=1,4) /
     $           7.810D+04,  7.456D-01, -1.976D-06,  1.850D-12 /
C
C----           Transition [15,12]
      data      JL(103),JU(103) /198, 198/
C     12 - 15
      data      Q(198) /'12 - 15'/
      data      A(198) /0.D0/
      data      (C(I,198,1),I=1,4) /
     $           8.673D+03,  1.442D+01, -1.950D-04,  1.082D-09 /
      data      (C(I,198,2),I=1,4) /
     $           2.753D+05,  2.676D+00, -7.037D-06,  6.571D-12 /
C
C----           Transition [15,13]
      data      JL(104),JU(104) /199, 199/
C     13 - 15
      data      Q(199) /'13 - 15'/
      data      A(199) /0.D0/
      data      (C(I,199,1),I=1,4) /
     $           2.191D+04,  7.194D+01, -9.561D-04,  5.259D-09 /
      data      (C(I,199,2),I=1,4) /
     $           1.348D+06,  1.396D+01, -3.617D-05,  3.361D-11 /
C
C----           Transition [15,14]
      data      JL(105),JU(105) /200, 200/
C     14 - 15
      data      Q(200) /'14 - 15'/
      data      A(200) /0.D0/
      data      (C(I,200,1),I=1,4) /
     $          -3.273D+05,  9.312D+02, -1.178D-02,  6.306D-08 /
      data      (C(I,200,2),I=1,4) /
     $           1.680D+07,  2.016D+02, -5.089D-04,  4.687D-10 /
C     !EJECT
C
      call HI ('SUMTERM')
C     !BEG
C---- Set up regime index: K=1: lo temp, K=3: hi temp, K=2: overlap
      K = 2
      if(T.le.T2) then
        K = 1
      else if(T.ge.T3) then
        K = 3
      end if
C---- Set up powers of T
      TS = T*T
      TQ = T*TS
C---- Get index of data for this transition
C     (Assume: 2 .le. IU .le 15, IL .lt. IU)
      IN = INDEX(IU,IL)
C
C---- Compute sum (and save terms and labels)
      M = 0
      SIGMA = ZERO
      do 104 J = JL(IN),JU(IN)
        if(K.lt.3) then
C----     Compute lo-temp term
          YUP = C(1,J,1)+C(2,J,1)*T+C(3,J,1)*TS+C(4,J,1)*TQ
          if((T.lt.T1).and.(A(J).ne.ZERO)) then
            PT  = (T1-T)**P
            Z   = (A(J)*PT)/HNDRD
            YUP = YUP/(ONE+Z)
          end if
        end if
        if(K.gt.1) then
C----     Compute hi-temp term
          YLO = C(1,J,2)+C(2,J,2)*T+C(3,J,2)*TS+C(4,J,2)*TQ
        end if
C
        goto (100, 101, 102), K
  100   continue
          X = YUP
          goto 103
  101   continue
          X = ((T3-T)*YUP+(T-T2)*YLO)/DT
          goto 103
  102   continue
          X = YLO
  103   continue
C
        M = M+1
        LAB(M)  = Q(J)
        TERM(M) = X
        SIGMA   = SIGMA+X
C
  104 continue
C     !END
      call BYE ('SUMTERM')
C
      return
      end
