      subroutine COFUND
C
C     Rudolf Loeser, 1994 Aug 16
C---- Does nothing - just contains data statements
C
C     Initializes CO fundamental band arrays with Goorvitch 1994 data.
C     !DASH
      save
C     !DASH
      integer J
C     !COM
C---- LOOM        as of 1994 Dec 16
      integer     JCOLMF,KCOLMF,JCOLMO,KCOLMO,JCOLMS,KCOLMS,
     $            JCOLMR,KCOLMR,JCOMAX,KCOMAX
      parameter   (JCOLMF=111, KCOLMF=20)
      parameter   (JCOLMO=111, KCOLMO=13)
      parameter   (JCOLMS=111, KCOLMS=12)
      parameter   (JCOLMR=53,  KCOLMR=21)
      parameter   (JCOMAX=max(JCOLMF,JCOLMO,JCOLMS,JCOLMR))
      parameter   (KCOMAX=max(KCOLMF,KCOLMO,KCOLMS,KCOLMR))
C     (Be sure to recompile all users of LOOM when changing any
C     of the above parameter values!)
      real*8      WNUPF,WNDNF,WNUPO,WNDNO,WNUPS,WNDNS,WNROT,
     $            FUPF ,FDNF ,FUPO ,FDNO ,FUPS ,FDNS ,FROT ,
     $            EXEN,WVCOLO,WVCOHI,RC1213
      integer     JCOFUN,KCOFUN,JCOOVR,KCOOVR,JCOSEC,KCOSEC,
     $            JCOROT,KCOROT,ISOSLCT,METHCOW,METHCOF
      logical     FUNDCO,OVERCO,SECNCO,ROTACO
C
      dimension   WNUPF(JCOLMF,KCOLMF,2), WNDNF(JCOLMF,KCOLMF,2),
     $            WNUPO(JCOLMO,KCOLMO,2), WNDNO(JCOLMO,KCOLMO,2),
     $            WNUPS(JCOLMS,KCOLMS,2), WNDNS(JCOLMS,KCOLMS,2),
     $            WNROT(JCOLMR,KCOLMR,2),
     $            FUPF(JCOLMF,KCOLMF,2),  FDNF(JCOLMF,KCOLMF,2),
     $            FUPO(JCOLMO,KCOLMO,2),  FDNO(JCOLMO,KCOLMO,2),
     $            FUPS(JCOLMS,KCOLMS,2),  FDNS(JCOLMS,KCOLMS,2),
     $            FROT(JCOLMR,KCOLMR,2),
     $            EXEN(JCOMAX+1,KCOMAX,2)
      dimension   FUNDCO(2),OVERCO(2),SECNCO(2),ROTACO(2),
     $            JCOFUN(2),KCOFUN(2),JCOOVR(2),KCOOVR(2),
     $            JCOSEC(2),KCOSEC(2),JCOROT(2),KCOROT(2)
C
C     Carbon Monoxide lines:  wavenumbers and oscillator strengths.
C
C     WNROT, etc., are for rotational lines     : j'-j=+1, v'-v=0;
C     WNUPF, etc., are for fundamental lines    : j'-j=+1, v'-v=1;
C     WNDNF, etc., are for fundamental lines    : j'-j=-1, v'-v=1;
C     WNUPO, etc., are for first overtone lines : j'-j=+1, v'-v=2;
C     WNDNO, etc., are for first overtone lines : j'-j=-1, v'-v=2;
C     WNUPS, etc., are for second overtone lines: j'-j=+1, v'-v=3;
C     WNDNS, etc., are for second overtone lines: j'-j=-1, v'-v=3.
C
C     This is how the array indices relate to the quantum numbers:
C
C     1. index J corresponds to quantum number j -
C                in WNROT, etc., j = J-1, j' = J
C                in WNUPF, etc., j = J-1, j' = J
C                in WNDNF, etc., j = J  , j' = J-1
C                in WNUPO, etc., j = J-1, j' = J
C                in WNDNO, etc., j = J  , j' = J-1
C                in WNUPS, etc., j = J-1, j' = J
C                in WNDNS, etc., j = J  , j' = J-1
C
C     2. index K corresponds to quantum number v (=nu) -
C                in WNROT, etc.,                 v = K-1, v' = K-1
C                in WNUPF, etc. and WNDNF, etc., v = K-1, v' = K
C                in WNUPO, etc. and WNDNO, etc., v = K-1, v' = K+1
C                in WNUPS, etc. and WNDNS, etc., v = K-1, v' = K+2
C
C     3. index L identifies the Carbon isotope -
C                L=1 for Carbon-12, L=2 for Carbon-13.
C
C     Wavenumbers and energies from:
C        Farrenq, R., Guelachvili, G., Sauval, A.J., Grevesse, N.,
C        and Farmer, C.B. 1991,
C        J.Molec.Spectrosc., 149, 375
C       or
C        Coxon, J.A., and Hajigeorgiou, P.G. 1992,
C        Can.J.Phys., 70, 40-54
C       or
C        Goorvitch, 1994, Ap.J.Suppl.
C     f-values from:
C        Chackerian, C., Jr, and Tipping, R. H. 1983
C        J.Molec.Spectros., 99, 431
C       or
C        "improved" Chackerian
C       or
C        Goorvitch, 1994, Ap.J.Suppl.
C
      common      /LOOM1 / EXEN
      common      /LOOM2 / WNROT,FROT
      common      /LOOM3 / WNUPF,FUPF,WNDNF,FDNF
      common      /LOOM4 / WNUPO,FUPO,WNDNO,FDNO
      common      /LOOM5 / WNUPS,FUPS,WNDNS,FDNS
      common      /LOOM6 / JCOFUN,KCOFUN,JCOOVR,KCOOVR,JCOSEC,KCOSEC,
     $                     JCOROT,KCOROT
      common      /LOOM7 / WVCOLO,WVCOHI
      common      /LOOM8 / FUNDCO,OVERCO,SECNCO,ROTACO
C
C     (These parameters are computed by subroutines WEAVE and FOCA.)
C
      common      /LOOM9 / RC1213
      common      /LOOM10/ ISOSLCT,METHCOW,METHCOF
C
C     RC1213  is the C(12)/C(13) isotopic abundance ratio.
C     ISOSLCT controls which isotopes are included in this calculation:
C     ISOSLCT = 1 means: C(12) only;
C     ISOSLCT = 2 means: C(13) only; and
C     ISOSLCT = 3 means: both C(12) and C(13).
C
C     METHCOF = 1 means: use f-values from Chackerian & Tipping (1983);
C     METHCOF = 2 means: use f-values from "new" Chackerian data;
C     METHCOF = 3 means: use f-values from Goorvitch (1994).
C
C     METHCOW = 1 means: use energies from Farrenq et al.;
C     METHCOW = 2 means: use energies from Coxon & Hajigeorgiou;
C     METHCOW = 3 means: use wave numbers & energies from
C                                                    Goorvitch (1994).
C     .
C     !DASH
      data (WNUPF(  1,J,1),J=1,20) /
     $ 2.14708110D+03, 2.12056610D+03, 2.09411690D+03, 2.06773530D+03,
     $ 2.04142290D+03, 2.01518150D+03, 1.98901280D+03, 1.96291840D+03,
     $ 1.93689990D+03, 1.91095900D+03, 1.88509700D+03, 1.85931530D+03,
     $ 1.83361510D+03, 1.80799750D+03, 1.78246340D+03, 1.75701350D+03,
     $ 1.73164830D+03, 1.70636800D+03, 1.68117250D+03, 1.65606150D+03/
      data ( FUPF(  1,J,1),J=1,20) /
     $ 1.142D-05, 2.248D-05, 3.319D-05, 4.354D-05, 5.353D-05, 6.317D-05,
     $ 7.247D-05, 8.141D-05, 9.001D-05, 9.827D-05, 1.062D-04, 1.138D-04,
     $ 1.210D-04, 1.279D-04, 1.345D-04, 1.407D-04, 1.465D-04, 1.521D-04,
     $ 1.572D-04, 1.620D-04/
      data (WNDNF(  1,J,1),J=1,20) /
     $ 2.13942610D+03, 2.11298100D+03, 2.08660190D+03, 2.06029020D+03,
     $ 2.03404780D+03, 2.00787640D+03, 1.98177770D+03, 1.95575320D+03,
     $ 1.92980470D+03, 1.90393370D+03, 1.87814170D+03, 1.85242990D+03,
     $ 1.82679960D+03, 1.80125200D+03, 1.77578770D+03, 1.75040770D+03,
     $ 1.72511230D+03, 1.69990180D+03, 1.67477620D+03, 1.64973500D+03/
      data ( FDNF(  1,J,1),J=1,20) /
     $ 3.790D-06, 7.463D-06, 1.102D-05, 1.446D-05, 1.778D-05, 2.098D-05,
     $ 2.407D-05, 2.705D-05, 2.991D-05, 3.265D-05, 3.530D-05, 3.780D-05,
     $ 4.023D-05, 4.253D-05, 4.470D-05, 4.677D-05, 4.873D-05, 5.057D-05,
     $ 5.230D-05, 5.390D-05/
      data (WNUPF(  1,J,2),J=1,20) /
     $ 2.09971010D+03, 2.07436270D+03, 2.04907680D+03, 2.02385390D+03,
     $ 1.99869560D+03, 1.97360350D+03, 1.94857900D+03, 1.92362390D+03,
     $ 1.89873940D+03, 1.87392710D+03, 1.84918820D+03, 1.82452420D+03,
     $ 1.79993600D+03, 1.77542480D+03, 1.75099130D+03, 1.72663640D+03,
     $ 1.70236040D+03, 1.67816370D+03, 1.65404640D+03, 1.63000830D+03/
      data ( FUPF(  1,J,2),J=1,20) /
     $ 1.092D-05, 2.150D-05, 3.176D-05, 4.168D-05, 5.127D-05, 6.052D-05,
     $ 6.945D-05, 7.805D-05, 8.634D-05, 9.430D-05, 1.019D-04, 1.093D-04,
     $ 1.163D-04, 1.230D-04, 1.293D-04, 1.354D-04, 1.411D-04, 1.465D-04,
     $ 1.516D-04, 1.563D-04/
      data (WNDNF(  1,J,2),J=1,20) /
     $ 2.09239100D+03, 2.06710900D+03, 2.04188850D+03, 2.01673100D+03,
     $ 1.99163820D+03, 1.96661140D+03, 1.94165240D+03, 1.91676260D+03,
     $ 1.89194350D+03, 1.86719660D+03, 1.84252310D+03, 1.81792440D+03,
     $ 1.79340160D+03, 1.76895570D+03, 1.74458760D+03, 1.72029790D+03,
     $ 1.69608720D+03, 1.67195580D+03, 1.64790380D+03, 1.62393090D+03/
      data ( FDNF(  1,J,2),J=1,20) /
     $ 3.623D-06, 7.140D-06, 1.055D-05, 1.384D-05, 1.703D-05, 2.010D-05,
     $ 2.307D-05, 2.593D-05, 2.869D-05, 3.134D-05, 3.387D-05, 3.633D-05,
     $ 3.867D-05, 4.087D-05, 4.300D-05, 4.503D-05, 4.693D-05, 4.873D-05,
     $ 5.043D-05, 5.200D-05/
      data (WNUPF(  2,J,1),J=1,20) /
     $ 2.15085600D+03, 2.12430600D+03, 2.09782180D+03, 2.07140510D+03,
     $ 2.04505780D+03, 2.01878140D+03, 1.99257770D+03, 1.96644830D+03,
     $ 1.94039490D+03, 1.91441900D+03, 1.88852200D+03, 1.86270540D+03,
     $ 1.83697030D+03, 1.81131780D+03, 1.78574870D+03, 1.76026390D+03,
     $ 1.73486380D+03, 1.70954850D+03, 1.68431810D+03, 1.65917220D+03/
      data ( FUPF(  2,J,1),J=1,20) /
     $ 7.627D-06, 1.501D-05, 2.217D-05, 2.908D-05, 3.577D-05, 4.220D-05,
     $ 4.840D-05, 5.437D-05, 6.010D-05, 6.560D-05, 7.090D-05, 7.593D-05,
     $ 8.077D-05, 8.537D-05, 8.977D-05, 9.390D-05, 9.780D-05, 1.015D-04,
     $ 1.049D-04, 1.081D-04/
      data (WNDNF(  2,J,1),J=1,20) /
     $ 2.13554620D+03, 2.10913620D+03, 2.08279200D+03, 2.05651530D+03,
     $ 2.03030800D+03, 2.00417150D+03, 1.97810780D+03, 1.95211830D+03,
     $ 1.92620480D+03, 1.90036880D+03, 1.87461170D+03, 1.84893490D+03,
     $ 1.82333960D+03, 1.79782690D+03, 1.77239760D+03, 1.74705260D+03,
     $ 1.72179210D+03, 1.69661650D+03, 1.67152580D+03, 1.64651960D+03/
      data ( FDNF(  2,J,1),J=1,20) /
     $ 4.540D-06, 8.940D-06, 1.320D-05, 1.732D-05, 2.130D-05, 2.514D-05,
     $ 2.884D-05, 3.240D-05, 3.584D-05, 3.912D-05, 4.228D-05, 4.530D-05,
     $ 4.820D-05, 5.096D-05, 5.358D-05, 5.606D-05, 5.840D-05, 6.062D-05,
     $ 6.268D-05, 6.460D-05/
      data (WNUPF(  2,J,2),J=1,20) /
     $ 2.10332040D+03, 2.07794030D+03, 2.05262170D+03, 2.02736610D+03,
     $ 2.00217510D+03, 1.97705030D+03, 1.95199320D+03, 1.92700530D+03,
     $ 1.90208810D+03, 1.87724310D+03, 1.85247160D+03, 1.82777490D+03,
     $ 1.80315410D+03, 1.77861020D+03, 1.75414410D+03, 1.72975650D+03,
     $ 1.70544790D+03, 1.68121860D+03, 1.65706870D+03, 1.63299790D+03/
      data ( FUPF(  2,J,2),J=1,20) /
     $ 7.290D-06, 1.436D-05, 2.121D-05, 2.783D-05, 3.423D-05, 4.043D-05,
     $ 4.637D-05, 5.213D-05, 5.763D-05, 6.297D-05, 6.807D-05, 7.293D-05,
     $ 7.763D-05, 8.210D-05, 8.633D-05, 9.037D-05, 9.420D-05, 9.777D-05,
     $ 1.012D-04, 1.043D-04/
      data (WNDNF(  2,J,2),J=1,20) /
     $ 2.08868250D+03, 2.06343320D+03, 2.03824540D+03, 2.01312070D+03,
     $ 1.98806050D+03, 1.96306650D+03, 1.93814020D+03, 1.91328310D+03,
     $ 1.88849670D+03, 1.86378250D+03, 1.83914170D+03, 1.81457570D+03,
     $ 1.79008550D+03, 1.76567230D+03, 1.74133680D+03, 1.71707980D+03,
     $ 1.69290180D+03, 1.66880310D+03, 1.64478360D+03, 1.62084340D+03/
      data ( FDNF(  2,J,2),J=1,20) /
     $ 4.342D-06, 8.552D-06, 1.263D-05, 1.658D-05, 2.040D-05, 2.408D-05,
     $ 2.764D-05, 3.106D-05, 3.438D-05, 3.754D-05, 4.060D-05, 4.352D-05,
     $ 4.632D-05, 4.900D-05, 5.154D-05, 5.396D-05, 5.624D-05, 5.840D-05,
     $ 6.044D-05, 6.234D-05/
      data (WNUPF(  3,J,1),J=1,20) /
     $ 2.15459560D+03, 2.12801050D+03, 2.10149140D+03, 2.07503970D+03,
     $ 2.04865740D+03, 2.02234600D+03, 1.99610730D+03, 1.96994300D+03,
     $ 1.94385460D+03, 1.91784370D+03, 1.89191180D+03, 1.86606020D+03,
     $ 1.84029020D+03, 1.81460270D+03, 1.78899880D+03, 1.76347910D+03,
     $ 1.73804400D+03, 1.71269380D+03, 1.68742850D+03, 1.66224780D+03/
      data ( FUPF(  3,J,1),J=1,20) /
     $ 6.876D-06, 1.354D-05, 1.999D-05, 2.622D-05, 3.224D-05, 3.804D-05,
     $ 4.362D-05, 4.900D-05, 5.418D-05, 5.914D-05, 6.390D-05, 6.844D-05,
     $ 7.280D-05, 7.694D-05, 8.088D-05, 8.460D-05, 8.812D-05, 9.144D-05,
     $ 9.450D-05, 9.738D-05/
      data (WNDNF(  3,J,1),J=1,20) /
     $ 2.13163160D+03, 2.10525660D+03, 2.07894740D+03, 2.05270580D+03,
     $ 2.02653340D+03, 2.00043200D+03, 1.97440320D+03, 1.94844880D+03,
     $ 1.92257020D+03, 1.89676920D+03, 1.87104710D+03, 1.84540530D+03,
     $ 1.81984500D+03, 1.79436720D+03, 1.76897290D+03, 1.74366280D+03,
     $ 1.71843730D+03, 1.69329660D+03, 1.66824080D+03, 1.64326950D+03/
      data ( FDNF(  3,J,1),J=1,20) /
     $ 4.854D-06, 9.559D-06, 1.411D-05, 1.853D-05, 2.277D-05, 2.689D-05,
     $ 3.084D-05, 3.466D-05, 3.833D-05, 4.186D-05, 4.523D-05, 4.847D-05,
     $ 5.157D-05, 5.451D-05, 5.733D-05, 5.999D-05, 6.250D-05, 6.487D-05,
     $ 6.709D-05, 6.914D-05/
      data (WNUPF(  3,J,2),J=1,20) /
     $ 2.10689780D+03, 2.08148500D+03, 2.05613370D+03, 2.03084540D+03,
     $ 2.00562170D+03, 1.98046410D+03, 1.95537430D+03, 1.93035380D+03,
     $ 1.90540390D+03, 1.88052630D+03, 1.85572210D+03, 1.83099270D+03,
     $ 1.80633920D+03, 1.78176270D+03, 1.75726400D+03, 1.73284370D+03,
     $ 1.70850250D+03, 1.68424060D+03, 1.66005800D+03, 1.63595460D+03/
      data ( FUPF(  3,J,2),J=1,20) /
     $ 6.574D-06, 1.295D-05, 1.913D-05, 2.510D-05, 3.086D-05, 3.644D-05,
     $ 4.180D-05, 4.698D-05, 5.196D-05, 5.674D-05, 6.134D-05, 6.574D-05,
     $ 6.996D-05, 7.398D-05, 7.780D-05, 8.142D-05, 8.486D-05, 8.810D-05,
     $ 9.114D-05, 9.396D-05/
      data (WNDNF(  3,J,2),J=1,20) /
     $ 2.08494150D+03, 2.05972500D+03, 2.03456990D+03, 2.00947790D+03,
     $ 1.98445050D+03, 1.95948910D+03, 1.93459550D+03, 1.90977120D+03,
     $ 1.88501750D+03, 1.86033590D+03, 1.83572780D+03, 1.81119450D+03,
     $ 1.78673710D+03, 1.76235650D+03, 1.73805370D+03, 1.71382940D+03,
     $ 1.68968400D+03, 1.66561790D+03, 1.64163110D+03, 1.61772350D+03/
      data ( FDNF(  3,J,2),J=1,20) /
     $ 4.641D-06, 9.146D-06, 1.351D-05, 1.773D-05, 2.181D-05, 2.576D-05,
     $ 2.957D-05, 3.323D-05, 3.677D-05, 4.017D-05, 4.343D-05, 4.656D-05,
     $ 4.956D-05, 5.241D-05, 5.514D-05, 5.774D-05, 6.020D-05, 6.251D-05,
     $ 6.469D-05, 6.671D-05/
      data (WNUPF(  4,J,1),J=1,20) /
     $ 2.15829970D+03, 2.13167970D+03, 2.10512550D+03, 2.07863890D+03,
     $ 2.05222160D+03, 2.02587520D+03, 1.99960150D+03, 1.97340220D+03,
     $ 1.94727890D+03, 1.92123310D+03, 1.89526620D+03, 1.86937970D+03,
     $ 1.84357470D+03, 1.81785230D+03, 1.79221350D+03, 1.76665880D+03,
     $ 1.74118890D+03, 1.71580380D+03, 1.69050360D+03, 1.66528800D+03/
      data ( FUPF(  4,J,1),J=1,20) /
     $ 6.563D-06, 1.292D-05, 1.907D-05, 2.501D-05, 3.076D-05, 3.629D-05,
     $ 4.161D-05, 4.674D-05, 5.167D-05, 5.641D-05, 6.094D-05, 6.529D-05,
     $ 6.943D-05, 7.337D-05, 7.713D-05, 8.067D-05, 8.401D-05, 8.717D-05,
     $ 9.010D-05, 9.283D-05/
      data (WNDNF(  4,J,1),J=1,20) /
     $ 2.12768240D+03, 2.10134240D+03, 2.07506830D+03, 2.04886160D+03,
     $ 2.02272430D+03, 1.99665780D+03, 1.97066410D+03, 1.94474460D+03,
     $ 1.91890110D+03, 1.89313510D+03, 1.86744800D+03, 1.84184110D+03,
     $ 1.81631580D+03, 1.79087300D+03, 1.76551370D+03, 1.74023850D+03,
     $ 1.71504790D+03, 1.68994220D+03, 1.66492130D+03, 1.63998500D+03/
      data ( FDNF(  4,J,1),J=1,20) /
     $ 5.023D-06, 9.893D-06, 1.461D-05, 1.917D-05, 2.358D-05, 2.783D-05,
     $ 3.193D-05, 3.588D-05, 3.968D-05, 4.333D-05, 4.683D-05, 5.019D-05,
     $ 5.340D-05, 5.646D-05, 5.938D-05, 6.213D-05, 6.473D-05, 6.720D-05,
     $ 6.949D-05, 7.163D-05/
      data (WNUPF(  4,J,2),J=1,20) /
     $ 2.11044210D+03, 2.08499650D+03, 2.05961250D+03, 2.03429150D+03,
     $ 2.00903510D+03, 1.98384490D+03, 1.95872240D+03, 1.93366910D+03,
     $ 1.90868660D+03, 1.88377630D+03, 1.85893950D+03, 1.83417740D+03,
     $ 1.80949130D+03, 1.78488210D+03, 1.76035070D+03, 1.73589790D+03,
     $ 1.71152400D+03, 1.68722950D+03, 1.66301430D+03, 1.63887830D+03/
      data ( FUPF(  4,J,2),J=1,20) /
     $ 6.274D-06, 1.236D-05, 1.824D-05, 2.394D-05, 2.944D-05, 3.476D-05,
     $ 3.989D-05, 4.481D-05, 4.957D-05, 5.413D-05, 5.850D-05, 6.270D-05,
     $ 6.671D-05, 7.054D-05, 7.419D-05, 7.764D-05, 8.091D-05, 8.399D-05,
     $ 8.689D-05, 8.957D-05/
      data (WNDNF(  4,J,2),J=1,20) /
     $ 2.08116820D+03, 2.05598440D+03, 2.03086210D+03, 2.00580280D+03,
     $ 1.98080810D+03, 1.95587950D+03, 1.93101860D+03, 1.90622690D+03,
     $ 1.88150590D+03, 1.85685710D+03, 1.83228170D+03, 1.80778110D+03,
     $ 1.78335630D+03, 1.75900840D+03, 1.73473830D+03, 1.71054670D+03,
     $ 1.68643400D+03, 1.66240050D+03, 1.63844640D+03, 1.61457150D+03/
      data ( FDNF(  4,J,2),J=1,20) /
     $ 4.804D-06, 9.466D-06, 1.398D-05, 1.836D-05, 2.258D-05, 2.667D-05,
     $ 3.061D-05, 3.441D-05, 3.807D-05, 4.159D-05, 4.497D-05, 4.821D-05,
     $ 5.132D-05, 5.429D-05, 5.711D-05, 5.980D-05, 6.234D-05, 6.474D-05,
     $ 6.701D-05, 6.911D-05/
      data (WNUPF(  5,J,1),J=1,20) /
     $ 2.16196820D+03, 2.13531320D+03, 2.10872410D+03, 2.08220250D+03,
     $ 2.05575010D+03, 2.02936880D+03, 2.00306020D+03, 1.97682590D+03,
     $ 1.95066760D+03, 1.92458680D+03, 1.89858500D+03, 1.87266360D+03,
     $ 1.84682370D+03, 1.82106640D+03, 1.79539270D+03, 1.76980310D+03,
     $ 1.74429820D+03, 1.71887830D+03, 1.69354320D+03, 1.66829260D+03/
      data ( FUPF(  5,J,1),J=1,20) /
     $ 6.392D-06, 1.259D-05, 1.858D-05, 2.437D-05, 2.996D-05, 3.533D-05,
     $ 4.053D-05, 4.552D-05, 5.032D-05, 5.492D-05, 5.933D-05, 6.356D-05,
     $ 6.759D-05, 7.142D-05, 7.508D-05, 7.852D-05, 8.177D-05, 8.484D-05,
     $ 8.768D-05, 9.033D-05/
      data (WNDNF(  5,J,1),J=1,20) /
     $ 2.12369880D+03, 2.09739380D+03, 2.07115470D+03, 2.04498310D+03,
     $ 2.01888070D+03, 1.99284930D+03, 1.96689060D+03, 1.94100610D+03,
     $ 1.91519760D+03, 1.88946660D+03, 1.86381440D+03, 1.83824260D+03,
     $ 1.81275220D+03, 1.78734440D+03, 1.76202010D+03, 1.73677990D+03,
     $ 1.71162430D+03, 1.68655350D+03, 1.66156760D+03, 1.63666610D+03/
      data ( FDNF(  5,J,1),J=1,20) /
     $ 5.127D-06, 1.010D-05, 1.491D-05, 1.957D-05, 2.407D-05, 2.841D-05,
     $ 3.260D-05, 3.664D-05, 4.052D-05, 4.425D-05, 4.783D-05, 5.125D-05,
     $ 5.453D-05, 5.765D-05, 6.064D-05, 6.345D-05, 6.613D-05, 6.865D-05,
     $ 7.098D-05, 7.318D-05/
      data (WNUPF(  5,J,2),J=1,20) /
     $ 2.11395300D+03, 2.08847480D+03, 2.06305810D+03, 2.03770440D+03,
     $ 2.01241530D+03, 1.98719240D+03, 1.96203720D+03, 1.93695130D+03,
     $ 1.91193610D+03, 1.88699310D+03, 1.86212360D+03, 1.83732890D+03,
     $ 1.81261020D+03, 1.78796830D+03, 1.76340430D+03, 1.73891890D+03,
     $ 1.71451240D+03, 1.69018520D+03, 1.66593740D+03, 1.64176880D+03/
      data ( FUPF(  5,J,2),J=1,20) /
     $ 6.111D-06, 1.203D-05, 1.778D-05, 2.332D-05, 2.868D-05, 3.386D-05,
     $ 3.883D-05, 4.364D-05, 4.827D-05, 5.270D-05, 5.696D-05, 6.104D-05,
     $ 6.494D-05, 6.867D-05, 7.221D-05, 7.558D-05, 7.876D-05, 8.174D-05,
     $ 8.454D-05, 8.716D-05/
      data (WNDNF(  5,J,2),J=1,20) /
     $ 2.07736280D+03, 2.05221170D+03, 2.02712210D+03, 2.00209550D+03,
     $ 1.97713350D+03, 1.95223770D+03, 1.92740950D+03, 1.90265050D+03,
     $ 1.87796230D+03, 1.85334610D+03, 1.82880350D+03, 1.80433550D+03,
     $ 1.77994350D+03, 1.75562830D+03, 1.73139090D+03, 1.70723190D+03,
     $ 1.68315190D+03, 1.65915110D+03, 1.63522960D+03, 1.61138730D+03/
      data ( FDNF(  5,J,2),J=1,20) /
     $ 4.905D-06, 9.664D-06, 1.427D-05, 1.874D-05, 2.305D-05, 2.723D-05,
     $ 3.125D-05, 3.513D-05, 3.887D-05, 4.246D-05, 4.592D-05, 4.924D-05,
     $ 5.241D-05, 5.545D-05, 5.834D-05, 6.108D-05, 6.368D-05, 6.615D-05,
     $ 6.845D-05, 7.061D-05/
      data (WNUPF(  6,J,1),J=1,20) /
     $ 2.16560100D+03, 2.13891100D+03, 2.11228690D+03, 2.08573030D+03,
     $ 2.05924300D+03, 2.03282670D+03, 2.00648310D+03, 1.98021390D+03,
     $ 1.95402060D+03, 1.92790490D+03, 1.90186820D+03, 1.87591180D+03,
     $ 1.85003700D+03, 1.82424480D+03, 1.79853610D+03, 1.77291170D+03,
     $ 1.74737190D+03, 1.72191710D+03, 1.69654710D+03, 1.67126170D+03/
      data ( FUPF(  6,J,1),J=1,20) /
     $ 6.288D-06, 1.238D-05, 1.827D-05, 2.396D-05, 2.945D-05, 3.475D-05,
     $ 3.985D-05, 4.476D-05, 4.948D-05, 5.401D-05, 5.834D-05, 6.248D-05,
     $ 6.645D-05, 7.021D-05, 7.380D-05, 7.718D-05, 8.037D-05, 8.338D-05,
     $ 8.616D-05, 8.877D-05/
      data (WNDNF(  6,J,1),J=1,20) /
     $ 2.11968100D+03, 2.09341100D+03, 2.06720690D+03, 2.04107030D+03,
     $ 2.01500290D+03, 1.98900650D+03, 1.96308280D+03, 1.93723340D+03,
     $ 1.91145990D+03, 1.88576380D+03, 1.86014670D+03, 1.83460990D+03,
     $ 1.80915450D+03, 1.78378170D+03, 1.75849230D+03, 1.73328700D+03,
     $ 1.70816640D+03, 1.68313060D+03, 1.65817960D+03, 1.63331310D+03/
      data ( FDNF(  6,J,1),J=1,20) /
     $ 5.196D-06, 1.023D-05, 1.512D-05, 1.983D-05, 2.439D-05, 2.880D-05,
     $ 3.305D-05, 3.713D-05, 4.107D-05, 4.485D-05, 4.848D-05, 5.196D-05,
     $ 5.529D-05, 5.846D-05, 6.149D-05, 6.435D-05, 6.706D-05, 6.962D-05,
     $ 7.199D-05, 7.423D-05/
      data (WNUPF(  6,J,2),J=1,20) /
     $ 2.11743070D+03, 2.09191970D+03, 2.06647030D+03, 2.04108390D+03,
     $ 2.01576210D+03, 1.99050650D+03, 1.96531870D+03, 1.94020010D+03,
     $ 1.91515220D+03, 1.89017660D+03, 1.86527440D+03, 1.84044710D+03,
     $ 1.81569570D+03, 1.79102120D+03, 1.76642460D+03, 1.74190650D+03,
     $ 1.71746740D+03, 1.69310770D+03, 1.66882720D+03, 1.64462600D+03/
      data ( FUPF(  6,J,2),J=1,20) /
     $ 6.012D-06, 1.184D-05, 1.748D-05, 2.294D-05, 2.821D-05, 3.329D-05,
     $ 3.819D-05, 4.291D-05, 4.745D-05, 5.182D-05, 5.600D-05, 6.002D-05,
     $ 6.385D-05, 6.751D-05, 7.098D-05, 7.428D-05, 7.740D-05, 8.034D-05,
     $ 8.309D-05, 8.565D-05/
      data (WNDNF(  6,J,2),J=1,20) /
     $ 2.07352530D+03, 2.04840700D+03, 2.02335010D+03, 1.99835620D+03,
     $ 1.97342690D+03, 1.94856380D+03, 1.92376830D+03, 1.89904210D+03,
     $ 1.87438660D+03, 1.84980310D+03, 1.82529320D+03, 1.80085800D+03,
     $ 1.77649860D+03, 1.75221610D+03, 1.72801140D+03, 1.70388510D+03,
     $ 1.67983780D+03, 1.65586960D+03, 1.63198090D+03, 1.60817120D+03/
      data ( FDNF(  6,J,2),J=1,20) /
     $ 4.970D-06, 9.792D-06, 1.446D-05, 1.899D-05, 2.337D-05, 2.759D-05,
     $ 3.168D-05, 3.561D-05, 3.941D-05, 4.305D-05, 4.655D-05, 4.992D-05,
     $ 5.314D-05, 5.622D-05, 5.915D-05, 6.194D-05, 6.458D-05, 6.708D-05,
     $ 6.942D-05, 7.162D-05/
      data (WNUPF(  7,J,1),J=1,20) /
     $ 2.16919790D+03, 2.14247290D+03, 2.11581380D+03, 2.08922230D+03,
     $ 2.06270000D+03, 2.03624870D+03, 2.00987020D+03, 1.98356600D+03,
     $ 1.95733780D+03, 1.93118710D+03, 1.90511550D+03, 1.87912420D+03,
     $ 1.85321440D+03, 1.82738740D+03, 1.80164380D+03, 1.77598450D+03,
     $ 1.75040980D+03, 1.72492010D+03, 1.69951520D+03, 1.67419490D+03/
      data ( FUPF(  7,J,1),J=1,20) /
     $ 6.220D-06, 1.225D-05, 1.807D-05, 2.370D-05, 2.913D-05, 3.437D-05,
     $ 3.941D-05, 4.426D-05, 4.892D-05, 5.339D-05, 5.767D-05, 6.177D-05,
     $ 6.568D-05, 6.940D-05, 7.294D-05, 7.628D-05, 7.946D-05, 8.238D-05,
     $ 8.515D-05, 8.769D-05/
      data (WNDNF(  7,J,1),J=1,20) /
     $ 2.11562900D+03, 2.08939400D+03, 2.06322490D+03, 2.03712340D+03,
     $ 2.01109100D+03, 1.98512960D+03, 1.95924090D+03, 1.93342650D+03,
     $ 1.90768800D+03, 1.88202700D+03, 1.85644490D+03, 1.83094300D+03,
     $ 1.80552270D+03, 1.78018480D+03, 1.75493040D+03, 1.72976020D+03,
     $ 1.70467450D+03, 1.67967370D+03, 1.65475760D+03, 1.62992600D+03/
      data ( FDNF(  7,J,1),J=1,20) /
     $ 5.243D-06, 1.033D-05, 1.525D-05, 2.001D-05, 2.462D-05, 2.907D-05,
     $ 3.335D-05, 3.748D-05, 4.146D-05, 4.528D-05, 4.895D-05, 5.246D-05,
     $ 5.582D-05, 5.903D-05, 6.209D-05, 6.498D-05, 6.773D-05, 7.033D-05,
     $ 7.273D-05, 7.500D-05/
      data (WNUPF(  7,J,2),J=1,20) /
     $ 2.12087470D+03, 2.09533110D+03, 2.06984900D+03, 2.04442990D+03,
     $ 2.01907540D+03, 1.99378720D+03, 1.96856660D+03, 1.94341540D+03,
     $ 1.91833480D+03, 1.89332650D+03, 1.86839170D+03, 1.84353180D+03,
     $ 1.81874770D+03, 1.79404070D+03, 1.76941140D+03, 1.74486070D+03,
     $ 1.72038900D+03, 1.69599660D+03, 1.67168360D+03, 1.64744980D+03/
      data ( FUPF(  7,J,2),J=1,20) /
     $ 5.945D-06, 1.171D-05, 1.729D-05, 2.268D-05, 2.789D-05, 3.292D-05,
     $ 3.776D-05, 4.243D-05, 4.692D-05, 5.123D-05, 5.536D-05, 5.932D-05,
     $ 6.311D-05, 6.672D-05, 7.015D-05, 7.342D-05, 7.649D-05, 7.938D-05,
     $ 8.208D-05, 8.462D-05/
      data (WNDNF(  7,J,2),J=1,20) /
     $ 2.06965590D+03, 2.04457030D+03, 2.01954610D+03, 1.99458500D+03,
     $ 1.96968840D+03, 1.94485800D+03, 1.92009530D+03, 1.89540180D+03,
     $ 1.87077900D+03, 1.84622830D+03, 1.82175100D+03, 1.79734850D+03,
     $ 1.77302190D+03, 1.74877210D+03, 1.72460010D+03, 1.70050650D+03,
     $ 1.67649180D+03, 1.65255640D+03, 1.62870030D+03, 1.60492320D+03/
      data ( FDNF(  7,J,2),J=1,20) /
     $ 5.015D-06, 9.880D-06, 1.460D-05, 1.917D-05, 2.359D-05, 2.785D-05,
     $ 3.197D-05, 3.595D-05, 3.977D-05, 4.346D-05, 4.700D-05, 5.040D-05,
     $ 5.365D-05, 5.676D-05, 5.973D-05, 6.255D-05, 6.522D-05, 6.773D-05,
     $ 7.013D-05, 7.233D-05/
      data (WNUPF(  8,J,1),J=1,20) /
     $ 2.17275880D+03, 2.14599880D+03, 2.11930470D+03, 2.09267820D+03,
     $ 2.06612090D+03, 2.03963470D+03, 2.01322120D+03, 1.98688210D+03,
     $ 1.96061890D+03, 1.93443330D+03, 1.90832680D+03, 1.88230060D+03,
     $ 1.85635590D+03, 1.83049390D+03, 1.80471550D+03, 1.77902130D+03,
     $ 1.75341170D+03, 1.72788710D+03, 1.70244740D+03, 1.67709220D+03/
      data ( FUPF(  8,J,1),J=1,20) /
     $ 6.173D-06, 1.215D-05, 1.793D-05, 2.351D-05, 2.891D-05, 3.410D-05,
     $ 3.910D-05, 4.391D-05, 4.853D-05, 5.296D-05, 5.720D-05, 6.126D-05,
     $ 6.514D-05, 6.880D-05, 7.233D-05, 7.567D-05, 7.873D-05, 8.167D-05,
     $ 8.440D-05, 8.693D-05/
      data (WNDNF(  8,J,1),J=1,20) /
     $ 2.11154300D+03, 2.08534310D+03, 2.05920900D+03, 2.03314250D+03,
     $ 2.00714510D+03, 1.98121880D+03, 1.95536510D+03, 1.92958570D+03,
     $ 1.90388220D+03, 1.87825620D+03, 1.85270910D+03, 1.82724230D+03,
     $ 1.80185690D+03, 1.77655410D+03, 1.75133470D+03, 1.72619940D+03,
     $ 1.70114870D+03, 1.67618290D+03, 1.65130180D+03, 1.62650510D+03/
      data ( FDNF(  8,J,1),J=1,20) /
     $ 5.276D-06, 1.039D-05, 1.535D-05, 2.015D-05, 2.478D-05, 2.925D-05,
     $ 3.357D-05, 3.773D-05, 4.174D-05, 4.558D-05, 4.928D-05, 5.282D-05,
     $ 5.621D-05, 5.941D-05, 6.253D-05, 6.541D-05, 6.818D-05, 7.082D-05,
     $ 7.324D-05, 7.553D-05/
      data (WNUPF(  8,J,2),J=1,20) /
     $ 2.12428520D+03, 2.09870890D+03, 2.07319400D+03, 2.04774220D+03,
     $ 2.02235510D+03, 1.99703410D+03, 1.97178090D+03, 1.94659700D+03,
     $ 1.92148380D+03, 1.89644290D+03, 1.87147540D+03, 1.84658280D+03,
     $ 1.82176620D+03, 1.79702650D+03, 1.77236460D+03, 1.74778130D+03,
     $ 1.72327700D+03, 1.69885200D+03, 1.67450640D+03, 1.65024000D+03/
      data ( FUPF(  8,J,2),J=1,20) /
     $ 5.900D-06, 1.162D-05, 1.716D-05, 2.251D-05, 2.767D-05, 3.266D-05,
     $ 3.747D-05, 4.209D-05, 4.654D-05, 5.081D-05, 5.491D-05, 5.884D-05,
     $ 6.259D-05, 6.617D-05, 6.960D-05, 7.280D-05, 7.587D-05, 7.873D-05,
     $ 8.140D-05, 8.387D-05/
      data (WNDNF(  8,J,2),J=1,20) /
     $ 2.06575470D+03, 2.04070180D+03, 2.01571040D+03, 1.99078200D+03,
     $ 1.96591820D+03, 1.94112050D+03, 1.91639050D+03, 1.89172970D+03,
     $ 1.86713960D+03, 1.84262170D+03, 1.81817720D+03, 1.79380740D+03,
     $ 1.76951340D+03, 1.74529640D+03, 1.72115710D+03, 1.69709620D+03,
     $ 1.67311420D+03, 1.64921140D+03, 1.62538800D+03, 1.60164360D+03/
      data ( FDNF(  8,J,2),J=1,20) /
     $ 5.047D-06, 9.947D-06, 1.469D-05, 1.929D-05, 2.374D-05, 2.804D-05,
     $ 3.218D-05, 3.619D-05, 4.005D-05, 4.375D-05, 4.732D-05, 5.074D-05,
     $ 5.402D-05, 5.716D-05, 6.012D-05, 6.300D-05, 6.571D-05, 6.824D-05,
     $ 7.065D-05, 7.288D-05/
      data (WNUPF(  9,J,1),J=1,20) /
     $ 2.17628350D+03, 2.14948850D+03, 2.12275950D+03, 2.09609790D+03,
     $ 2.06950570D+03, 2.04298450D+03, 2.01653610D+03, 1.99016200D+03,
     $ 1.96386390D+03, 1.93764340D+03, 1.91150190D+03, 1.88544080D+03,
     $ 1.85946130D+03, 1.83356440D+03, 1.80775110D+03, 1.78202200D+03,
     $ 1.75637760D+03, 1.73081810D+03, 1.70534350D+03, 1.67995330D+03/
      data ( FUPF(  9,J,1),J=1,20) /
     $ 6.141D-06, 1.208D-05, 1.783D-05, 2.338D-05, 2.874D-05, 3.390D-05,
     $ 3.887D-05, 4.365D-05, 4.824D-05, 5.265D-05, 5.686D-05, 6.088D-05,
     $ 6.476D-05, 6.841D-05, 7.188D-05, 7.518D-05, 7.824D-05, 8.118D-05,
     $ 8.388D-05, 8.635D-05/
      data (WNDNF(  9,J,1),J=1,20) /
     $ 2.10742320D+03, 2.08125830D+03, 2.05515930D+03, 2.02912770D+03,
     $ 2.00316550D+03, 1.97727410D+03, 1.95145550D+03, 1.92571110D+03,
     $ 1.90004260D+03, 1.87445160D+03, 1.84893960D+03, 1.82350780D+03,
     $ 1.79815740D+03, 1.77288960D+03, 1.74770520D+03, 1.72260490D+03,
     $ 1.69758920D+03, 1.67265830D+03, 1.64781220D+03, 1.62305050D+03/
      data ( FDNF(  9,J,1),J=1,20) /
     $ 5.300D-06, 1.044D-05, 1.542D-05, 2.024D-05, 2.489D-05, 2.939D-05,
     $ 3.373D-05, 3.791D-05, 4.194D-05, 4.581D-05, 4.952D-05, 5.311D-05,
     $ 5.647D-05, 5.974D-05, 6.284D-05, 6.579D-05, 6.858D-05, 7.121D-05,
     $ 7.363D-05, 7.595D-05/
      data (WNUPF(  9,J,2),J=1,20) /
     $ 2.12766180D+03, 2.10205280D+03, 2.07650530D+03, 2.05102080D+03,
     $ 2.02560100D+03, 2.00024730D+03, 1.97496150D+03, 1.94974490D+03,
     $ 1.92459900D+03, 1.89952540D+03, 1.87452540D+03, 1.84960010D+03,
     $ 1.82475090D+03, 1.79997860D+03, 1.77528410D+03, 1.75066820D+03,
     $ 1.72613130D+03, 1.70167370D+03, 1.67729550D+03, 1.65299650D+03/
      data ( FUPF(  9,J,2),J=1,20) /
     $ 5.868D-06, 1.155D-05, 1.706D-05, 2.238D-05, 2.752D-05, 3.247D-05,
     $ 3.725D-05, 4.185D-05, 4.627D-05, 5.051D-05, 5.458D-05, 5.848D-05,
     $ 6.224D-05, 6.576D-05, 6.912D-05, 7.235D-05, 7.535D-05, 7.824D-05,
     $ 8.088D-05, 8.335D-05/
      data (WNDNF(  9,J,2),J=1,20) /
     $ 2.06182190D+03, 2.03680180D+03, 2.01184310D+03, 1.98694740D+03,
     $ 1.96211630D+03, 1.93735130D+03, 1.91265410D+03, 1.88802600D+03,
     $ 1.86346870D+03, 1.83898340D+03, 1.81457170D+03, 1.79023460D+03,
     $ 1.76597340D+03, 1.74178910D+03, 1.71768240D+03, 1.69365430D+03,
     $ 1.66970500D+03, 1.64583490D+03, 1.62204420D+03, 1.59833250D+03/
      data ( FDNF(  9,J,2),J=1,20) /
     $ 5.071D-06, 9.989D-06, 1.476D-05, 1.938D-05, 2.385D-05, 2.817D-05,
     $ 3.234D-05, 3.636D-05, 4.024D-05, 4.397D-05, 4.756D-05, 5.100D-05,
     $ 5.432D-05, 5.747D-05, 6.047D-05, 6.332D-05, 6.605D-05, 6.858D-05,
     $ 7.100D-05, 7.326D-05/
      data (WNUPF( 10,J,1),J=1,20) /
     $ 2.17977190D+03, 2.15294190D+03, 2.12617790D+03, 2.09948140D+03,
     $ 2.07285420D+03, 2.04629810D+03, 2.01981460D+03, 1.99340560D+03,
     $ 1.96707260D+03, 1.94081720D+03, 1.91464080D+03, 1.88854480D+03,
     $ 1.86253030D+03, 1.83659860D+03, 1.81075040D+03, 1.78498640D+03,
     $ 1.75930710D+03, 1.73371280D+03, 1.70820330D+03, 1.68277830D+03/
      data ( FUPF( 10,J,1),J=1,20) /
     $ 6.116D-06, 1.203D-05, 1.776D-05, 2.329D-05, 2.862D-05, 3.376D-05,
     $ 3.871D-05, 4.346D-05, 4.803D-05, 5.242D-05, 5.663D-05, 6.063D-05,
     $ 6.442D-05, 6.811D-05, 7.153D-05, 7.479D-05, 7.789D-05, 8.079D-05,
     $ 8.342D-05, 8.595D-05/
      data (WNDNF( 10,J,1),J=1,20) /
     $ 2.10326970D+03, 2.07713990D+03, 2.05107590D+03, 2.02507930D+03,
     $ 1.99915210D+03, 1.97329580D+03, 1.94751210D+03, 1.92180280D+03,
     $ 1.89616940D+03, 1.87061340D+03, 1.84513640D+03, 1.81973960D+03,
     $ 1.79442430D+03, 1.76919150D+03, 1.74404210D+03, 1.71897680D+03,
     $ 1.69399610D+03, 1.66910020D+03, 1.64428900D+03, 1.61956220D+03/
      data ( FDNF( 10,J,1),J=1,20) /
     $ 5.319D-06, 1.048D-05, 1.547D-05, 2.031D-05, 2.498D-05, 2.950D-05,
     $ 3.385D-05, 3.805D-05, 4.209D-05, 4.598D-05, 4.971D-05, 5.329D-05,
     $ 5.671D-05, 5.995D-05, 6.310D-05, 6.605D-05, 6.881D-05, 7.148D-05,
     $ 7.395D-05, 7.624D-05/
      data (WNUPF( 10,J,2),J=1,20) /
     $ 2.13100450D+03, 2.10536280D+03, 2.07978260D+03, 2.05426550D+03,
     $ 2.02881290D+03, 2.00342660D+03, 1.97810810D+03, 1.95285880D+03,
     $ 1.92768040D+03, 1.90257410D+03, 1.87754140D+03, 1.85258360D+03,
     $ 1.82770170D+03, 1.80289680D+03, 1.77816970D+03, 1.75352120D+03,
     $ 1.72895170D+03, 1.70446150D+03, 1.68005070D+03, 1.65571910D+03/
      data ( FUPF( 10,J,2),J=1,20) /
     $ 5.842D-06, 1.151D-05, 1.699D-05, 2.228D-05, 2.740D-05, 3.234D-05,
     $ 3.709D-05, 4.166D-05, 4.607D-05, 5.029D-05, 5.432D-05, 5.821D-05,
     $ 6.195D-05, 6.547D-05, 6.879D-05, 7.200D-05, 7.500D-05, 7.784D-05,
     $ 8.047D-05, 8.295D-05/
      data (WNDNF( 10,J,2),J=1,20) /
     $ 2.05785750D+03, 2.03287020D+03, 2.00794420D+03, 1.98308130D+03,
     $ 1.95828290D+03, 1.93355070D+03, 1.90888620D+03, 1.88429090D+03,
     $ 1.85976630D+03, 1.83531380D+03, 1.81093470D+03, 1.78663040D+03,
     $ 1.76240190D+03, 1.73825030D+03, 1.71417640D+03, 1.69018090D+03,
     $ 1.66626440D+03, 1.64242700D+03, 1.61866890D+03, 1.59498990D+03/
      data ( FDNF( 10,J,2),J=1,20) /
     $ 5.086D-06, 1.002D-05, 1.481D-05, 1.945D-05, 2.393D-05, 2.827D-05,
     $ 3.245D-05, 3.649D-05, 4.039D-05, 4.413D-05, 4.771D-05, 5.119D-05,
     $ 5.452D-05, 5.767D-05, 6.071D-05, 6.357D-05, 6.629D-05, 6.886D-05,
     $ 7.129D-05, 7.357D-05/
      data (WNUPF( 11,J,1),J=1,20) /
     $ 2.18322380D+03, 2.15635890D+03, 2.12955980D+03, 2.10282840D+03,
     $ 2.07616620D+03, 2.04957510D+03, 2.02305670D+03, 1.99661280D+03,
     $ 1.97024490D+03, 1.94395450D+03, 1.91774320D+03, 1.89161230D+03,
     $ 1.86556300D+03, 1.83959630D+03, 1.81371330D+03, 1.78791440D+03,
     $ 1.76220030D+03, 1.73657110D+03, 1.71102670D+03, 1.68556680D+03/
      data ( FUPF( 11,J,1),J=1,20) /
     $ 6.095D-06, 1.200D-05, 1.770D-05, 2.322D-05, 2.853D-05, 3.365D-05,
     $ 3.859D-05, 4.332D-05, 4.786D-05, 5.224D-05, 5.643D-05, 6.043D-05,
     $ 6.424D-05, 6.786D-05, 7.129D-05, 7.452D-05, 7.757D-05, 8.048D-05,
     $ 8.310D-05, 8.562D-05/
      data (WNDNF( 11,J,1),J=1,20) /
     $ 2.09908270D+03, 2.07298790D+03, 2.04695890D+03, 2.02099740D+03,
     $ 1.99510520D+03, 1.96928390D+03, 1.94353530D+03, 1.91786100D+03,
     $ 1.89226260D+03, 1.86674170D+03, 1.84129970D+03, 1.81593790D+03,
     $ 1.79065760D+03, 1.76545990D+03, 1.74034550D+03, 1.71531520D+03,
     $ 1.69036950D+03, 1.66550860D+03, 1.64073240D+03, 1.61604060D+03/
      data ( FDNF( 11,J,1),J=1,20) /
     $ 5.330D-06, 1.050D-05, 1.551D-05, 2.036D-05, 2.504D-05, 2.957D-05,
     $ 3.393D-05, 3.814D-05, 4.220D-05, 4.609D-05, 4.983D-05, 5.343D-05,
     $ 5.687D-05, 6.013D-05, 6.326D-05, 6.622D-05, 6.904D-05, 7.170D-05,
     $ 7.417D-05, 7.648D-05/
      data (WNUPF( 11,J,2),J=1,20) /
     $ 2.13431320D+03, 2.10863880D+03, 2.08302590D+03, 2.05747610D+03,
     $ 2.03199090D+03, 2.00657190D+03, 1.98122070D+03, 1.95593880D+03,
     $ 1.93072770D+03, 1.90558880D+03, 1.88052340D+03, 1.85553300D+03,
     $ 1.83061850D+03, 1.80578100D+03, 1.78102130D+03, 1.75634020D+03,
     $ 1.73173810D+03, 1.70721540D+03, 1.68277200D+03, 1.65840770D+03/
      data ( FUPF( 11,J,2),J=1,20) /
     $ 5.829D-06, 1.147D-05, 1.694D-05, 2.222D-05, 2.731D-05, 3.223D-05,
     $ 3.697D-05, 4.153D-05, 4.591D-05, 5.010D-05, 5.414D-05, 5.800D-05,
     $ 6.171D-05, 6.524D-05, 6.857D-05, 7.171D-05, 7.471D-05, 7.752D-05,
     $ 8.014D-05, 8.262D-05/
      data (WNDNF( 11,J,2),J=1,20) /
     $ 2.05386180D+03, 2.02890720D+03, 2.00401400D+03, 1.97918380D+03,
     $ 1.95441820D+03, 1.92971870D+03, 1.90508690D+03, 1.88052430D+03,
     $ 1.85603250D+03, 1.83161270D+03, 1.80726640D+03, 1.78299480D+03,
     $ 1.75879910D+03, 1.73468020D+03, 1.71063900D+03, 1.68667630D+03,
     $ 1.66279240D+03, 1.63898780D+03, 1.61526240D+03, 1.59161600D+03/
      data ( FDNF( 11,J,2),J=1,20) /
     $ 5.100D-06, 1.005D-05, 1.484D-05, 1.950D-05, 2.399D-05, 2.834D-05,
     $ 3.254D-05, 3.659D-05, 4.049D-05, 4.426D-05, 4.787D-05, 5.135D-05,
     $ 5.465D-05, 5.783D-05, 6.087D-05, 6.374D-05, 6.648D-05, 6.909D-05,
     $ 7.152D-05, 7.378D-05/
      data (WNUPF( 12,J,1),J=1,20) /
     $ 2.18663900D+03, 2.15973920D+03, 2.13290510D+03, 2.10613870D+03,
     $ 2.07944160D+03, 2.05281560D+03, 2.02626230D+03, 1.99978340D+03,
     $ 1.97338050D+03, 1.94705530D+03, 1.92080910D+03, 1.89464320D+03,
     $ 1.86855910D+03, 1.84255750D+03, 1.81663960D+03, 1.79080590D+03,
     $ 1.76505690D+03, 1.73939280D+03, 1.71381350D+03, 1.68831880D+03/
      data ( FUPF( 12,J,1),J=1,20) /
     $ 6.083D-06, 1.197D-05, 1.767D-05, 2.317D-05, 2.847D-05, 3.357D-05,
     $ 3.849D-05, 4.322D-05, 4.774D-05, 5.209D-05, 5.626D-05, 6.026D-05,
     $ 6.404D-05, 6.765D-05, 7.109D-05, 7.430D-05, 7.735D-05, 8.022D-05,
     $ 8.287D-05, 8.535D-05/
      data (WNDNF( 12,J,1),J=1,20) /
     $ 2.09486230D+03, 2.06880250D+03, 2.04280860D+03, 2.01688210D+03,
     $ 1.99102490D+03, 1.96523870D+03, 1.93952510D+03, 1.91388590D+03,
     $ 1.88832250D+03, 1.86283660D+03, 1.83742970D+03, 1.81210290D+03,
     $ 1.78685770D+03, 1.76169490D+03, 1.73661560D+03, 1.71162030D+03,
     $ 1.68670960D+03, 1.66188370D+03, 1.63714240D+03, 1.61248560D+03/
      data ( FDNF( 12,J,1),J=1,20) /
     $ 5.340D-06, 1.052D-05, 1.553D-05, 2.039D-05, 2.509D-05, 2.962D-05,
     $ 3.400D-05, 3.822D-05, 4.228D-05, 4.620D-05, 4.992D-05, 5.352D-05,
     $ 5.700D-05, 6.028D-05, 6.340D-05, 6.640D-05, 6.920D-05, 7.184D-05,
     $ 7.432D-05, 7.668D-05/
      data (WNUPF( 12,J,2),J=1,20) /
     $ 2.13758760D+03, 2.11188060D+03, 2.08623500D+03, 2.06065250D+03,
     $ 2.03513460D+03, 2.00968290D+03, 1.98429910D+03, 1.95898450D+03,
     $ 1.93374080D+03, 1.90856920D+03, 1.88347130D+03, 1.85844820D+03,
     $ 1.83350110D+03, 1.80863100D+03, 1.78383880D+03, 1.75912510D+03,
     $ 1.73449040D+03, 1.70993510D+03, 1.68545910D+03, 1.66106230D+03/
      data ( FUPF( 12,J,2),J=1,20) /
     $ 5.813D-06, 1.145D-05, 1.690D-05, 2.217D-05, 2.725D-05, 3.216D-05,
     $ 3.688D-05, 4.143D-05, 4.578D-05, 5.000D-05, 5.400D-05, 5.787D-05,
     $ 6.152D-05, 6.504D-05, 6.835D-05, 7.152D-05, 7.448D-05, 7.730D-05,
     $ 7.991D-05, 8.235D-05/
      data (WNDNF( 12,J,2),J=1,20) /
     $ 2.04983490D+03, 2.02491300D+03, 2.00005250D+03, 1.97525510D+03,
     $ 1.95052220D+03, 1.92585540D+03, 1.90125640D+03, 1.87672660D+03,
     $ 1.85226750D+03, 1.82788050D+03, 1.80356690D+03, 1.77932810D+03,
     $ 1.75516510D+03, 1.73107890D+03, 1.70707050D+03, 1.68314050D+03,
     $ 1.65928930D+03, 1.63551740D+03, 1.61182470D+03, 1.58821100D+03/
      data ( FDNF( 12,J,2),J=1,20) /
     $ 5.108D-06, 1.006D-05, 1.487D-05, 1.953D-05, 2.404D-05, 2.839D-05,
     $ 3.260D-05, 3.666D-05, 4.056D-05, 4.432D-05, 4.796D-05, 5.144D-05,
     $ 5.476D-05, 5.796D-05, 6.100D-05, 6.392D-05, 6.664D-05, 6.924D-05,
     $ 7.168D-05, 7.396D-05/
      data (WNUPF( 13,J,1),J=1,20) /
     $ 2.19001750D+03, 2.16308270D+03, 2.13621370D+03, 2.10941230D+03,
     $ 2.08268030D+03, 2.05601930D+03, 2.02943100D+03, 2.00291720D+03,
     $ 1.97647940D+03, 1.95011930D+03, 1.92383820D+03, 1.89763750D+03,
     $ 1.87151840D+03, 1.84548200D+03, 1.81952920D+03, 1.79366060D+03,
     $ 1.76787680D+03, 1.74217780D+03, 1.71656370D+03, 1.69103410D+03/
      data ( FUPF( 13,J,1),J=1,20) /
     $ 6.076D-06, 1.196D-05, 1.764D-05, 2.313D-05, 2.842D-05, 3.352D-05,
     $ 3.842D-05, 4.312D-05, 4.768D-05, 5.200D-05, 5.616D-05, 6.012D-05,
     $ 6.392D-05, 6.752D-05, 7.092D-05, 7.412D-05, 7.716D-05, 8.000D-05,
     $ 8.264D-05, 8.512D-05/
      data (WNDNF( 13,J,1),J=1,20) /
     $ 2.09060870D+03, 2.06458390D+03, 2.03862500D+03, 2.01273360D+03,
     $ 1.98691140D+03, 1.96116020D+03, 1.93548170D+03, 1.90987750D+03,
     $ 1.88434920D+03, 1.85889830D+03, 1.83352640D+03, 1.80823470D+03,
     $ 1.78302450D+03, 1.75789680D+03, 1.73285250D+03, 1.70789230D+03,
     $ 1.68301660D+03, 1.65822560D+03, 1.63351940D+03, 1.60889750D+03/
      data ( FDNF( 13,J,1),J=1,20) /
     $ 5.344D-06, 1.053D-05, 1.555D-05, 2.041D-05, 2.511D-05, 2.966D-05,
     $ 3.404D-05, 3.826D-05, 4.233D-05, 4.626D-05, 5.000D-05, 5.363D-05,
     $ 5.707D-05, 6.037D-05, 6.352D-05, 6.648D-05, 6.930D-05, 7.200D-05,
     $ 7.448D-05, 7.681D-05/
      data (WNUPF( 13,J,2),J=1,20) /
     $ 2.14082780D+03, 2.11508800D+03, 2.08940970D+03, 2.06379460D+03,
     $ 2.03824400D+03, 2.01275970D+03, 1.98734320D+03, 1.96199600D+03,
     $ 1.93671960D+03, 1.91151540D+03, 1.88638490D+03, 1.86132920D+03,
     $ 1.83634950D+03, 1.81144680D+03, 1.78662190D+03, 1.76187570D+03,
     $ 1.73720840D+03, 1.71262050D+03, 1.68811190D+03, 1.66368250D+03/
      data ( FUPF( 13,J,2),J=1,20) /
     $ 5.808D-06, 1.143D-05, 1.688D-05, 2.213D-05, 2.721D-05, 3.210D-05,
     $ 3.681D-05, 4.136D-05, 4.572D-05, 4.988D-05, 5.392D-05, 5.776D-05,
     $ 6.140D-05, 6.488D-05, 6.820D-05, 7.136D-05, 7.432D-05, 7.712D-05,
     $ 7.972D-05, 8.212D-05/
      data (WNDNF( 13,J,2),J=1,20) /
     $ 2.04577680D+03, 2.02088770D+03, 1.99605990D+03, 1.97129520D+03,
     $ 1.94659510D+03, 1.92196110D+03, 1.89739480D+03, 1.87289780D+03,
     $ 1.84847140D+03, 1.82411710D+03, 1.79983630D+03, 1.77563020D+03,
     $ 1.75150000D+03, 1.72744660D+03, 1.70347090D+03, 1.67957360D+03,
     $ 1.65575520D+03, 1.63201600D+03, 1.60835600D+03, 1.58477500D+03/
      data ( FDNF( 13,J,2),J=1,20) /
     $ 5.111D-06, 1.008D-05, 1.489D-05, 1.955D-05, 2.406D-05, 2.843D-05,
     $ 3.264D-05, 3.670D-05, 4.063D-05, 4.441D-05, 4.804D-05, 5.152D-05,
     $ 5.485D-05, 5.804D-05, 6.111D-05, 6.400D-05, 6.678D-05, 6.937D-05,
     $ 7.181D-05, 7.411D-05/
      data (WNUPF( 14,J,1),J=1,20) /
     $ 2.19335910D+03, 2.16638930D+03, 2.13948540D+03, 2.11264900D+03,
     $ 2.08588200D+03, 2.05918610D+03, 2.03256290D+03, 2.00601410D+03,
     $ 1.97954140D+03, 1.95314640D+03, 1.92683040D+03, 1.90059480D+03,
     $ 1.87444090D+03, 1.84836960D+03, 1.82238200D+03, 1.79647850D+03,
     $ 1.77065980D+03, 1.74492600D+03, 1.71927700D+03, 1.69371250D+03/
      data ( FUPF( 14,J,1),J=1,20) /
     $ 6.070D-06, 1.194D-05, 1.762D-05, 2.310D-05, 2.839D-05, 3.348D-05,
     $ 3.837D-05, 4.307D-05, 4.759D-05, 5.193D-05, 5.607D-05, 6.004D-05,
     $ 6.381D-05, 6.737D-05, 7.078D-05, 7.400D-05, 7.704D-05, 7.985D-05,
     $ 8.248D-05, 8.493D-05/
      data (WNDNF( 14,J,1),J=1,20) /
     $ 2.08632190D+03, 2.06033220D+03, 2.03440830D+03, 2.00855190D+03,
     $ 1.98276480D+03, 1.95704870D+03, 1.93140520D+03, 1.90583600D+03,
     $ 1.88034280D+03, 1.85492700D+03, 1.82959010D+03, 1.80433350D+03,
     $ 1.77915830D+03, 1.75406570D+03, 1.72905640D+03, 1.70413120D+03,
     $ 1.67929050D+03, 1.65453460D+03, 1.62986330D+03, 1.60527640D+03/
      data ( FDNF( 14,J,1),J=1,20) /
     $ 5.348D-06, 1.053D-05, 1.556D-05, 2.043D-05, 2.513D-05, 2.968D-05,
     $ 3.407D-05, 3.831D-05, 4.238D-05, 4.631D-05, 5.007D-05, 5.366D-05,
     $ 5.714D-05, 6.045D-05, 6.359D-05, 6.659D-05, 6.941D-05, 7.207D-05,
     $ 7.459D-05, 7.693D-05/
      data (WNUPF( 14,J,2),J=1,20) /
     $ 2.14403350D+03, 2.11826100D+03, 2.09255010D+03, 2.06690220D+03,
     $ 2.04131900D+03, 2.01580200D+03, 1.99035280D+03, 1.96497300D+03,
     $ 1.93966400D+03, 1.91442720D+03, 1.88926400D+03, 1.86417570D+03,
     $ 1.83916340D+03, 1.81422810D+03, 1.78937070D+03, 1.76459190D+03,
     $ 1.73989200D+03, 1.71527160D+03, 1.69073040D+03, 1.66626840D+03/
      data ( FUPF( 14,J,2),J=1,20) /
     $ 5.800D-06, 1.142D-05, 1.686D-05, 2.210D-05, 2.717D-05, 3.206D-05,
     $ 3.677D-05, 4.130D-05, 4.563D-05, 4.981D-05, 5.381D-05, 5.767D-05,
     $ 6.130D-05, 6.478D-05, 6.807D-05, 7.122D-05, 7.419D-05, 7.696D-05,
     $ 7.956D-05, 8.196D-05/
      data (WNDNF( 14,J,2),J=1,20) /
     $ 2.04168780D+03, 2.01683140D+03, 1.99203640D+03, 1.96730440D+03,
     $ 1.94263710D+03, 1.91803580D+03, 1.89350230D+03, 1.86903800D+03,
     $ 1.84464440D+03, 1.82032290D+03, 1.79607480D+03, 1.77190150D+03,
     $ 1.74780400D+03, 1.72378340D+03, 1.69984040D+03, 1.67597590D+03,
     $ 1.65219020D+03, 1.62848370D+03, 1.60485640D+03, 1.58130810D+03/
      data ( FDNF( 14,J,2),J=1,20) /
     $ 5.117D-06, 1.008D-05, 1.490D-05, 1.957D-05, 2.408D-05, 2.845D-05,
     $ 3.267D-05, 3.672D-05, 4.066D-05, 4.445D-05, 4.807D-05, 5.159D-05,
     $ 5.493D-05, 5.814D-05, 6.117D-05, 6.410D-05, 6.686D-05, 6.945D-05,
     $ 7.193D-05, 7.421D-05/
      data (WNUPF( 15,J,1),J=1,20) /
     $ 2.19666370D+03, 2.16965890D+03, 2.14272000D+03, 2.11584870D+03,
     $ 2.08904670D+03, 2.06231580D+03, 2.03565770D+03, 2.00907400D+03,
     $ 1.98256640D+03, 1.95613650D+03, 1.92978560D+03, 1.90351510D+03,
     $ 1.87732630D+03, 1.85122020D+03, 1.82519770D+03, 1.79925940D+03,
     $ 1.77340590D+03, 1.74763720D+03, 1.72195340D+03, 1.69635400D+03/
      data ( FUPF( 15,J,1),J=1,20) /
     $ 6.066D-06, 1.193D-05, 1.761D-05, 2.309D-05, 2.836D-05, 3.345D-05,
     $ 3.834D-05, 4.303D-05, 4.755D-05, 5.186D-05, 5.600D-05, 5.997D-05,
     $ 6.372D-05, 6.731D-05, 7.069D-05, 7.390D-05, 7.690D-05, 7.972D-05,
     $ 8.234D-05, 8.476D-05/
      data (WNDNF( 15,J,1),J=1,20) /
     $ 2.08200220D+03, 2.05604760D+03, 2.03015870D+03, 2.00433740D+03,
     $ 1.97858530D+03, 1.95290420D+03, 1.92729580D+03, 1.90176160D+03,
     $ 1.87630340D+03, 1.85092270D+03, 1.82562090D+03, 1.80039930D+03,
     $ 1.77525920D+03, 1.75020160D+03, 1.72522740D+03, 1.70033720D+03,
     $ 1.67553160D+03, 1.65081070D+03, 1.62617440D+03, 1.60162250D+03/
      data ( FDNF( 15,J,1),J=1,20) /
     $ 5.348D-06, 1.054D-05, 1.556D-05, 2.044D-05, 2.515D-05, 2.969D-05,
     $ 3.410D-05, 3.832D-05, 4.239D-05, 4.632D-05, 5.010D-05, 5.371D-05,
     $ 5.716D-05, 6.048D-05, 6.365D-05, 6.665D-05, 6.945D-05, 7.216D-05,
     $ 7.465D-05, 7.700D-05/
      data (WNUPF( 15,J,2),J=1,20) /
     $ 2.14720450D+03, 2.12139940D+03, 2.09565580D+03, 2.06997520D+03,
     $ 2.04435940D+03, 2.01880970D+03, 1.99332790D+03, 1.96791540D+03,
     $ 1.94257380D+03, 1.91730440D+03, 1.89210860D+03, 1.86698770D+03,
     $ 1.84194280D+03, 1.81697490D+03, 1.79208490D+03, 1.76727350D+03,
     $ 1.74254110D+03, 1.71788810D+03, 1.69331430D+03, 1.66881970D+03/
      data ( FUPF( 15,J,2),J=1,20) /
     $ 5.797D-06, 1.141D-05, 1.685D-05, 2.209D-05, 2.715D-05, 3.203D-05,
     $ 3.672D-05, 4.124D-05, 4.559D-05, 4.976D-05, 5.376D-05, 5.759D-05,
     $ 6.121D-05, 6.469D-05, 6.800D-05, 7.110D-05, 7.407D-05, 7.683D-05,
     $ 7.941D-05, 8.183D-05/
      data (WNDNF( 15,J,2),J=1,20) /
     $ 2.03756790D+03, 2.01274430D+03, 1.98798200D+03, 1.96328280D+03,
     $ 1.93864820D+03, 1.91407970D+03, 1.88957890D+03, 1.86514740D+03,
     $ 1.84078650D+03, 1.81649780D+03, 1.79228250D+03, 1.76814190D+03,
     $ 1.74407720D+03, 1.72008930D+03, 1.69617920D+03, 1.67234740D+03,
     $ 1.64859440D+03, 1.62492060D+03, 1.60132600D+03, 1.57781040D+03/
      data ( FDNF( 15,J,2),J=1,20) /
     $ 5.116D-06, 1.009D-05, 1.490D-05, 1.957D-05, 2.409D-05, 2.846D-05,
     $ 3.268D-05, 3.674D-05, 4.068D-05, 4.448D-05, 4.810D-05, 5.161D-05,
     $ 5.497D-05, 5.816D-05, 6.123D-05, 6.413D-05, 6.690D-05, 6.952D-05,
     $ 7.200D-05, 7.429D-05/
      data (WNUPF( 16,J,1),J=1,20) /
     $ 2.19993100D+03, 2.17289120D+03, 2.14591740D+03, 2.11901110D+03,
     $ 2.09217420D+03, 2.06540830D+03, 2.03871530D+03, 2.01209670D+03,
     $ 1.98555420D+03, 1.95908940D+03, 1.93270360D+03, 1.90639830D+03,
     $ 1.88017460D+03, 1.85403370D+03, 1.82797630D+03, 1.80200320D+03,
     $ 1.77611480D+03, 1.75031120D+03, 1.72459250D+03, 1.69895830D+03/
      data ( FUPF( 16,J,1),J=1,20) /
     $ 6.065D-06, 1.193D-05, 1.760D-05, 2.307D-05, 2.835D-05, 3.342D-05,
     $ 3.832D-05, 4.300D-05, 4.752D-05, 5.184D-05, 5.597D-05, 5.990D-05,
     $ 6.365D-05, 6.723D-05, 7.061D-05, 7.381D-05, 7.681D-05, 7.961D-05,
     $ 8.223D-05, 8.465D-05/
      data (WNDNF( 16,J,1),J=1,20) /
     $ 2.07764970D+03, 2.05173010D+03, 2.02587630D+03, 2.00009000D+03,
     $ 1.97437300D+03, 1.94872690D+03, 1.92315350D+03, 1.89765450D+03,
     $ 1.87223130D+03, 1.84688570D+03, 1.82161890D+03, 1.79643240D+03,
     $ 1.77132740D+03, 1.74630480D+03, 1.72136570D+03, 1.69651060D+03,
     $ 1.67173990D+03, 1.64705400D+03, 1.62245280D+03, 1.59793580D+03/
      data ( FDNF( 16,J,1),J=1,20) /
     $ 5.348D-06, 1.054D-05, 1.557D-05, 2.044D-05, 2.515D-05, 2.970D-05,
     $ 3.409D-05, 3.833D-05, 4.239D-05, 4.633D-05, 5.012D-05, 5.373D-05,
     $ 5.718D-05, 6.052D-05, 6.367D-05, 6.667D-05, 6.952D-05, 7.218D-05,
     $ 7.470D-05, 7.706D-05/
      data (WNUPF( 16,J,2),J=1,20) /
     $ 2.15034090D+03, 2.12450310D+03, 2.09872680D+03, 2.07301360D+03,
     $ 2.04736500D+03, 2.02178270D+03, 1.99626830D+03, 1.97082310D+03,
     $ 1.94544880D+03, 1.92014680D+03, 1.89491840D+03, 1.86976490D+03,
     $ 1.84468750D+03, 1.81968700D+03, 1.79476450D+03, 1.76992050D+03,
     $ 1.74515550D+03, 1.72046990D+03, 1.69586360D+03, 1.67133640D+03/
      data ( FUPF( 16,J,2),J=1,20) /
     $ 5.794D-06, 1.141D-05, 1.684D-05, 2.208D-05, 2.714D-05, 3.201D-05,
     $ 3.671D-05, 4.123D-05, 4.555D-05, 4.971D-05, 5.371D-05, 5.752D-05,
     $ 6.116D-05, 6.465D-05, 6.790D-05, 7.103D-05, 7.397D-05, 7.674D-05,
     $ 7.932D-05, 8.171D-05/
      data (WNDNF( 16,J,2),J=1,20) /
     $ 2.03341740D+03, 2.00862650D+03, 1.98389700D+03, 1.95923050D+03,
     $ 1.93462860D+03, 1.91009290D+03, 1.88562490D+03, 1.86122610D+03,
     $ 1.83689800D+03, 1.81264200D+03, 1.78845950D+03, 1.76435170D+03,
     $ 1.74031980D+03, 1.71636470D+03, 1.69248730D+03, 1.66868820D+03,
     $ 1.64496800D+03, 1.62132700D+03, 1.59776510D+03, 1.57428220D+03/
      data ( FDNF( 16,J,2),J=1,20) /
     $ 5.118D-06, 1.009D-05, 1.490D-05, 1.958D-05, 2.410D-05, 2.847D-05,
     $ 3.270D-05, 3.676D-05, 4.070D-05, 4.448D-05, 4.812D-05, 5.164D-05,
     $ 5.497D-05, 5.818D-05, 6.127D-05, 6.418D-05, 6.694D-05, 6.958D-05,
     $ 7.203D-05, 7.436D-05/
      data (WNUPF( 17,J,1),J=1,20) /
     $ 2.20316100D+03, 2.17608620D+03, 2.14907740D+03, 2.12213620D+03,
     $ 2.09526430D+03, 2.06846360D+03, 2.04173560D+03, 2.01508210D+03,
     $ 1.98850470D+03, 1.96200490D+03, 1.93558430D+03, 1.90924410D+03,
     $ 1.88298560D+03, 1.85680980D+03, 1.83071760D+03, 1.80470960D+03,
     $ 1.77878640D+03, 1.75294800D+03, 1.72719440D+03, 1.70152530D+03/
      data ( FUPF( 17,J,1),J=1,20) /
     $ 6.064D-06, 1.193D-05, 1.760D-05, 2.307D-05, 2.834D-05, 3.342D-05,
     $ 3.830D-05, 4.300D-05, 4.748D-05, 5.179D-05, 5.591D-05, 5.985D-05,
     $ 6.361D-05, 6.718D-05, 7.055D-05, 7.373D-05, 7.673D-05, 7.955D-05,
     $ 8.212D-05, 8.455D-05/
      data (WNDNF( 17,J,1),J=1,20) /
     $ 2.07326460D+03, 2.04738000D+03, 2.02156120D+03, 1.99581000D+03,
     $ 1.97012800D+03, 1.94451700D+03, 1.91897870D+03, 1.89351470D+03,
     $ 1.86812660D+03, 1.84281600D+03, 1.81758430D+03, 1.79243290D+03,
     $ 1.76736290D+03, 1.74237550D+03, 1.71747140D+03, 1.69265130D+03,
     $ 1.66791570D+03, 1.64326480D+03, 1.61869860D+03, 1.59421660D+03/
      data ( FDNF( 17,J,1),J=1,20) /
     $ 5.346D-06, 1.053D-05, 1.556D-05, 2.043D-05, 2.514D-05, 2.969D-05,
     $ 3.409D-05, 3.831D-05, 4.240D-05, 4.634D-05, 5.011D-05, 5.374D-05,
     $ 5.720D-05, 6.051D-05, 6.369D-05, 6.669D-05, 6.954D-05, 7.223D-05,
     $ 7.474D-05, 7.709D-05/
      data (WNUPF( 17,J,2),J=1,20) /
     $ 2.15344240D+03, 2.12757190D+03, 2.10176290D+03, 2.07601700D+03,
     $ 2.05033580D+03, 2.02472090D+03, 1.99917380D+03, 1.97369600D+03,
     $ 1.94828910D+03, 1.92295450D+03, 1.89769350D+03, 1.87250740D+03,
     $ 1.84739730D+03, 1.82236430D+03, 1.79740920D+03, 1.77253260D+03,
     $ 1.74773510D+03, 1.72301690D+03, 1.69837800D+03, 1.67381820D+03/
      data ( FUPF( 17,J,2),J=1,20) /
     $ 5.794D-06, 1.141D-05, 1.684D-05, 2.207D-05, 2.713D-05, 3.200D-05,
     $ 3.670D-05, 4.121D-05, 4.555D-05, 4.970D-05, 5.367D-05, 5.748D-05,
     $ 6.112D-05, 6.458D-05, 6.785D-05, 7.097D-05, 7.391D-05, 7.664D-05,
     $ 7.921D-05, 8.161D-05/
      data (WNDNF( 17,J,2),J=1,20) /
     $ 2.02923620D+03, 2.00447810D+03, 1.97978130D+03, 1.95514760D+03,
     $ 1.93057850D+03, 1.90607550D+03, 1.88164030D+03, 1.85727420D+03,
     $ 1.83297890D+03, 1.80875570D+03, 1.78460600D+03, 1.76053100D+03,
     $ 1.73653180D+03, 1.71260950D+03, 1.68876480D+03, 1.66499850D+03,
     $ 1.64131110D+03, 1.61770280D+03, 1.59417360D+03, 1.57072340D+03/
      data ( FDNF( 17,J,2),J=1,20) /
     $ 5.117D-06, 1.009D-05, 1.490D-05, 1.957D-05, 2.409D-05, 2.847D-05,
     $ 3.269D-05, 3.677D-05, 4.071D-05, 4.449D-05, 4.814D-05, 5.163D-05,
     $ 5.500D-05, 5.820D-05, 6.129D-05, 6.420D-05, 6.697D-05, 6.960D-05,
     $ 7.209D-05, 7.440D-05/
      data (WNUPF( 18,J,1),J=1,20) /
     $ 2.20635350D+03, 2.17924380D+03, 2.15220000D+03, 2.12522380D+03,
     $ 2.09831700D+03, 2.07148130D+03, 2.04471840D+03, 2.01803000D+03,
     $ 1.99141770D+03, 1.96488300D+03, 1.93842750D+03, 1.91205250D+03,
     $ 1.88575910D+03, 1.85954840D+03, 1.83342140D+03, 1.80737860D+03,
     $ 1.78142050D+03, 1.75554730D+03, 1.72975880D+03, 1.70405480D+03/
      data ( FUPF( 18,J,1),J=1,20) /
     $ 6.066D-06, 1.193D-05, 1.760D-05, 2.307D-05, 2.834D-05, 3.340D-05,
     $ 3.829D-05, 4.297D-05, 4.749D-05, 5.177D-05, 5.589D-05, 5.983D-05,
     $ 6.357D-05, 6.714D-05, 7.049D-05, 7.369D-05, 7.666D-05, 7.946D-05,
     $ 8.206D-05, 8.446D-05/
      data (WNDNF( 18,J,1),J=1,20) /
     $ 2.06884690D+03, 2.04299740D+03, 2.01721360D+03, 1.99149740D+03,
     $ 1.96585050D+03, 1.94027460D+03, 1.91477130D+03, 1.88934240D+03,
     $ 1.86398940D+03, 1.83871390D+03, 1.81351730D+03, 1.78840090D+03,
     $ 1.76336600D+03, 1.73841360D+03, 1.71354460D+03, 1.68875960D+03,
     $ 1.66405910D+03, 1.63944320D+03, 1.61491200D+03, 1.59046500D+03/
      data ( FDNF( 18,J,1),J=1,20) /
     $ 5.343D-06, 1.053D-05, 1.556D-05, 2.042D-05, 2.513D-05, 2.968D-05,
     $ 3.408D-05, 3.832D-05, 4.241D-05, 4.632D-05, 5.011D-05, 5.373D-05,
     $ 5.722D-05, 6.051D-05, 6.370D-05, 6.670D-05, 6.954D-05, 7.224D-05,
     $ 7.476D-05, 7.711D-05/
      data (WNUPF( 18,J,2),J=1,20) /
     $ 2.15650890D+03, 2.13060570D+03, 2.10476410D+03, 2.07898550D+03,
     $ 2.05327170D+03, 2.02762400D+03, 2.00204430D+03, 1.97653390D+03,
     $ 1.95109440D+03, 1.92572710D+03, 1.90043350D+03, 1.87521490D+03,
     $ 1.85007220D+03, 1.82500660D+03, 1.80001890D+03, 1.77510980D+03,
     $ 1.75027980D+03, 1.72552900D+03, 1.70085750D+03, 1.67626510D+03/
      data ( FUPF( 18,J,2),J=1,20) /
     $ 5.794D-06, 1.141D-05, 1.684D-05, 2.207D-05, 2.713D-05, 3.200D-05,
     $ 3.669D-05, 4.120D-05, 4.551D-05, 4.969D-05, 5.366D-05, 5.746D-05,
     $ 6.109D-05, 6.454D-05, 6.783D-05, 7.091D-05, 7.383D-05, 7.657D-05,
     $ 7.914D-05, 8.151D-05/
      data (WNDNF( 18,J,2),J=1,20) /
     $ 2.02502470D+03, 2.00029920D+03, 1.97563530D+03, 1.95103430D+03,
     $ 1.92649790D+03, 1.90202770D+03, 1.87762520D+03, 1.85329200D+03,
     $ 1.82902940D+03, 1.80483900D+03, 1.78072210D+03, 1.75667990D+03,
     $ 1.73271350D+03, 1.70882390D+03, 1.68501200D+03, 1.66127850D+03,
     $ 1.63762380D+03, 1.61404830D+03, 1.59055180D+03, 1.56713430D+03/
      data ( FDNF( 18,J,2),J=1,20) /
     $ 5.114D-06, 1.008D-05, 1.489D-05, 1.957D-05, 2.409D-05, 2.846D-05,
     $ 3.268D-05, 3.676D-05, 4.070D-05, 4.449D-05, 4.814D-05, 5.162D-05,
     $ 5.500D-05, 5.822D-05, 6.130D-05, 6.422D-05, 6.700D-05, 6.962D-05,
     $ 7.211D-05, 7.441D-05/
      data (WNUPF( 19,J,1),J=1,20) /
     $ 2.20950830D+03, 2.18236360D+03, 2.15528490D+03, 2.12827380D+03,
     $ 2.10133200D+03, 2.07446140D+03, 2.04766350D+03, 2.02094020D+03,
     $ 1.99429300D+03, 1.96772350D+03, 1.94123310D+03, 1.91482320D+03,
     $ 1.88849500D+03, 1.86224950D+03, 1.83608760D+03, 1.81001000D+03,
     $ 1.78401700D+03, 1.75810900D+03, 1.73228570D+03, 1.70654670D+03/
      data ( FUPF( 19,J,1),J=1,20) /
     $ 6.068D-06, 1.194D-05, 1.760D-05, 2.307D-05, 2.835D-05, 3.341D-05,
     $ 3.830D-05, 4.297D-05, 4.746D-05, 5.178D-05, 5.589D-05, 5.981D-05,
     $ 6.354D-05, 6.711D-05, 7.046D-05, 7.365D-05, 7.662D-05, 7.941D-05,
     $ 8.200D-05, 8.438D-05/
      data (WNDNF( 19,J,1),J=1,20) /
     $ 2.06439690D+03, 2.03858240D+03, 2.01283370D+03, 1.98715260D+03,
     $ 1.96154070D+03, 1.93599980D+03, 1.91053160D+03, 1.88513770D+03,
     $ 1.85981980D+03, 1.83457940D+03, 1.80941790D+03, 1.78433660D+03,
     $ 1.75933680D+03, 1.73441950D+03, 1.70958550D+03, 1.68483560D+03,
     $ 1.66017010D+03, 1.63558930D+03, 1.61109310D+03, 1.58668110D+03/
      data ( FDNF( 19,J,1),J=1,20) /
     $ 5.341D-06, 1.052D-05, 1.555D-05, 2.041D-05, 2.512D-05, 2.967D-05,
     $ 3.405D-05, 3.831D-05, 4.238D-05, 4.631D-05, 5.010D-05, 5.372D-05,
     $ 5.721D-05, 6.051D-05, 6.369D-05, 6.669D-05, 6.954D-05, 7.223D-05,
     $ 7.477D-05, 7.713D-05/
      data (WNUPF( 19,J,2),J=1,20) /
     $ 2.15954030D+03, 2.13360440D+03, 2.10773010D+03, 2.08191890D+03,
     $ 2.05617230D+03, 2.03049210D+03, 2.00487970D+03, 1.97933670D+03,
     $ 1.95386450D+03, 1.92846470D+03, 1.90313850D+03, 1.87788720D+03,
     $ 1.85271200D+03, 1.82761390D+03, 1.80259360D+03, 1.77765190D+03,
     $ 1.75278930D+03, 1.72800600D+03, 1.70330190D+03, 1.67867690D+03/
      data ( FUPF( 19,J,2),J=1,20) /
     $ 5.797D-06, 1.141D-05, 1.684D-05, 2.207D-05, 2.714D-05, 3.200D-05,
     $ 3.668D-05, 4.119D-05, 4.551D-05, 4.968D-05, 5.365D-05, 5.743D-05,
     $ 6.105D-05, 6.451D-05, 6.778D-05, 7.086D-05, 7.378D-05, 7.654D-05,
     $ 7.908D-05, 8.146D-05/
      data (WNDNF( 19,J,2),J=1,20) /
     $ 2.02078280D+03, 1.99609010D+03, 1.97145890D+03, 1.94689070D+03,
     $ 1.92238710D+03, 1.89794960D+03, 1.87357990D+03, 1.84927940D+03,
     $ 1.82504970D+03, 1.80089200D+03, 1.77680790D+03, 1.75279840D+03,
     $ 1.72886480D+03, 1.70500810D+03, 1.68122900D+03, 1.65752820D+03,
     $ 1.63390630D+03, 1.61036350D+03, 1.58689980D+03, 1.56351500D+03/
      data ( FDNF( 19,J,2),J=1,20) /
     $ 5.110D-06, 1.007D-05, 1.488D-05, 1.956D-05, 2.407D-05, 2.844D-05,
     $ 3.267D-05, 3.674D-05, 4.069D-05, 4.446D-05, 4.813D-05, 5.162D-05,
     $ 5.497D-05, 5.821D-05, 6.128D-05, 6.421D-05, 6.700D-05, 6.962D-05,
     $ 7.210D-05, 7.444D-05/
      data (WNUPF( 20,J,1),J=1,20) /
     $ 2.21262530D+03, 2.18544570D+03, 2.15833200D+03, 2.13128590D+03,
     $ 2.10430920D+03, 2.07740370D+03, 2.05057090D+03, 2.02381270D+03,
     $ 1.99713060D+03, 1.97052620D+03, 1.94400100D+03, 1.91755620D+03,
     $ 1.89119310D+03, 1.86491280D+03, 1.83871610D+03, 1.81260360D+03,
     $ 1.78657580D+03, 1.76063290D+03, 1.73477480D+03, 1.70900090D+03/
      data ( FUPF( 20,J,1),J=1,20) /
     $ 6.069D-06, 1.194D-05, 1.761D-05, 2.308D-05, 2.836D-05, 3.341D-05,
     $ 3.831D-05, 4.297D-05, 4.746D-05, 5.177D-05, 5.587D-05, 5.979D-05,
     $ 6.354D-05, 6.708D-05, 7.044D-05, 7.362D-05, 7.656D-05, 7.936D-05,
     $ 8.195D-05, 8.431D-05/
      data (WNDNF( 20,J,1),J=1,20) /
     $ 2.05991470D+03, 2.03413520D+03, 2.00842150D+03, 1.98277540D+03,
     $ 1.95719860D+03, 1.93169280D+03, 1.90625970D+03, 1.88090090D+03,
     $ 1.85561810D+03, 1.83041270D+03, 1.80528630D+03, 1.78024010D+03,
     $ 1.75527540D+03, 1.73039320D+03, 1.70559430D+03, 1.68087940D+03,
     $ 1.65624900D+03, 1.63170330D+03, 1.60724210D+03, 1.58286510D+03/
      data ( FDNF( 20,J,1),J=1,20) /
     $ 5.337D-06, 1.051D-05, 1.553D-05, 2.040D-05, 2.510D-05, 2.966D-05,
     $ 3.405D-05, 3.827D-05, 4.237D-05, 4.629D-05, 5.007D-05, 5.371D-05,
     $ 5.717D-05, 6.049D-05, 6.366D-05, 6.668D-05, 6.954D-05, 7.222D-05,
     $ 7.476D-05, 7.712D-05/
      data (WNUPF( 20,J,2),J=1,20) /
     $ 2.16253640D+03, 2.13656790D+03, 2.11066090D+03, 2.08481700D+03,
     $ 2.05903780D+03, 2.03332490D+03, 2.00767980D+03, 1.98210420D+03,
     $ 1.95659940D+03, 1.93116700D+03, 1.90580820D+03, 1.88052440D+03,
     $ 1.85531660D+03, 1.83018590D+03, 1.80513310D+03, 1.78015880D+03,
     $ 1.75526360D+03, 1.73044770D+03, 1.70571110D+03, 1.68105350D+03/
      data ( FUPF( 20,J,2),J=1,20) /
     $ 5.800D-06, 1.141D-05, 1.685D-05, 2.208D-05, 2.713D-05, 3.200D-05,
     $ 3.669D-05, 4.118D-05, 4.551D-05, 4.967D-05, 5.364D-05, 5.744D-05,
     $ 6.105D-05, 6.449D-05, 6.774D-05, 7.085D-05, 7.377D-05, 7.649D-05,
     $ 7.903D-05, 8.138D-05/
      data (WNDNF( 20,J,2),J=1,20) /
     $ 2.01651070D+03, 1.99185080D+03, 1.96725240D+03, 1.94271690D+03,
     $ 1.91824600D+03, 1.89384140D+03, 1.86950440D+03, 1.84523670D+03,
     $ 1.82103980D+03, 1.79691490D+03, 1.77286360D+03, 1.74888690D+03,
     $ 1.72498610D+03, 1.70116210D+03, 1.67741580D+03, 1.65374790D+03,
     $ 1.63015870D+03, 1.60664860D+03, 1.58321770D+03, 1.55986560D+03/
      data ( FDNF( 20,J,2),J=1,20) /
     $ 5.107D-06, 1.007D-05, 1.487D-05, 1.954D-05, 2.406D-05, 2.844D-05,
     $ 3.266D-05, 3.673D-05, 4.066D-05, 4.444D-05, 4.810D-05, 5.161D-05,
     $ 5.498D-05, 5.820D-05, 6.127D-05, 6.420D-05, 6.698D-05, 6.961D-05,
     $ 7.210D-05, 7.441D-05/
      data (WNUPF( 21,J,1),J=1,20) /
     $ 2.21570440D+03, 2.18848990D+03, 2.16134120D+03, 2.13426020D+03,
     $ 2.10724850D+03, 2.08030800D+03, 2.05344040D+03, 2.02664730D+03,
     $ 1.99993030D+03, 1.97329100D+03, 1.94673090D+03, 1.92025130D+03,
     $ 1.89385330D+03, 1.86753820D+03, 1.84130660D+03, 1.81515930D+03,
     $ 1.78909670D+03, 1.76311900D+03, 1.73722590D+03, 1.71141720D+03/
      data ( FUPF( 21,J,1),J=1,20) /
     $ 6.073D-06, 1.195D-05, 1.762D-05, 2.309D-05, 2.837D-05, 3.344D-05,
     $ 3.832D-05, 4.298D-05, 4.746D-05, 5.178D-05, 5.588D-05, 5.980D-05,
     $ 6.351D-05, 6.707D-05, 7.041D-05, 7.359D-05, 7.654D-05, 7.932D-05,
     $ 8.190D-05, 8.427D-05/
      data (WNDNF( 21,J,1),J=1,20) /
     $ 2.05540030D+03, 2.02965590D+03, 2.00397730D+03, 1.97836630D+03,
     $ 1.95282450D+03, 1.92735380D+03, 1.90195570D+03, 1.87663200D+03,
     $ 1.85138420D+03, 1.82621400D+03, 1.80112270D+03, 1.77611160D+03,
     $ 1.75118200D+03, 1.72633490D+03, 1.70157110D+03, 1.67689130D+03,
     $ 1.65229590D+03, 1.62778520D+03, 1.60335900D+03, 1.57901710D+03/
      data ( FDNF( 21,J,1),J=1,20) /
     $ 5.330D-06, 1.050D-05, 1.552D-05, 2.038D-05, 2.509D-05, 2.963D-05,
     $ 3.402D-05, 3.826D-05, 4.233D-05, 4.626D-05, 5.005D-05, 5.367D-05,
     $ 5.714D-05, 6.047D-05, 6.363D-05, 6.665D-05, 6.951D-05, 7.221D-05,
     $ 7.474D-05, 7.709D-05/
      data (WNUPF( 21,J,2),J=1,20) /
     $ 2.16549710D+03, 2.13949590D+03, 2.11355620D+03, 2.08767970D+03,
     $ 2.06186780D+03, 2.03612230D+03, 2.01044460D+03, 1.98483630D+03,
     $ 1.95929900D+03, 1.93383390D+03, 1.90844260D+03, 1.88312610D+03,
     $ 1.85788580D+03, 1.83272250D+03, 1.80763710D+03, 1.78263040D+03,
     $ 1.75770260D+03, 1.73285410D+03, 1.70808490D+03, 1.68339480D+03/
      data ( FUPF( 21,J,2),J=1,20) /
     $ 5.802D-06, 1.142D-05, 1.686D-05, 2.209D-05, 2.715D-05, 3.200D-05,
     $ 3.668D-05, 4.120D-05, 4.551D-05, 4.966D-05, 5.363D-05, 5.741D-05,
     $ 6.105D-05, 6.449D-05, 6.773D-05, 7.083D-05, 7.373D-05, 7.646D-05,
     $ 7.900D-05, 8.134D-05/
      data (WNDNF( 21,J,2),J=1,20) /
     $ 2.01220870D+03, 1.98758150D+03, 1.96301580D+03, 1.93851310D+03,
     $ 1.91407500D+03, 1.88970310D+03, 1.86539890D+03, 1.84116400D+03,
     $ 1.81699980D+03, 1.79290780D+03, 1.76888920D+03, 1.74494540D+03,
     $ 1.72107740D+03, 1.69728620D+03, 1.67357270D+03, 1.64993750D+03,
     $ 1.62638110D+03, 1.60290380D+03, 1.57950560D+03, 1.55618630D+03/
      data ( FDNF( 21,J,2),J=1,20) /
     $ 5.102D-06, 1.006D-05, 1.486D-05, 1.953D-05, 2.405D-05, 2.840D-05,
     $ 3.263D-05, 3.670D-05, 4.063D-05, 4.442D-05, 4.807D-05, 5.158D-05,
     $ 5.493D-05, 5.816D-05, 6.123D-05, 6.419D-05, 6.695D-05, 6.960D-05,
     $ 7.209D-05, 7.442D-05/
      data (WNUPF( 22,J,1),J=1,20) /
     $ 2.21874550D+03, 2.19149590D+03, 2.16431230D+03, 2.13719630D+03,
     $ 2.11014980D+03, 2.08317430D+03, 2.05627180D+03, 2.02944370D+03,
     $ 2.00269190D+03, 1.97601770D+03, 1.94942270D+03, 1.92290830D+03,
     $ 1.89647550D+03, 1.87012550D+03, 1.84385910D+03, 1.81767700D+03,
     $ 1.79157960D+03, 1.76556700D+03, 1.73963910D+03, 1.71379550D+03/
      data ( FUPF( 22,J,1),J=1,20) /
     $ 6.077D-06, 1.195D-05, 1.763D-05, 2.310D-05, 2.837D-05, 3.344D-05,
     $ 3.833D-05, 4.300D-05, 4.749D-05, 5.179D-05, 5.588D-05, 5.979D-05,
     $ 6.351D-05, 6.705D-05, 7.040D-05, 7.356D-05, 7.651D-05, 7.928D-05,
     $ 8.186D-05, 8.421D-05/
      data (WNDNF( 22,J,1),J=1,20) /
     $ 2.05085410D+03, 2.02514470D+03, 1.99950120D+03, 1.97392520D+03,
     $ 1.94841850D+03, 1.92298280D+03, 1.89761980D+03, 1.87233120D+03,
     $ 1.84711850D+03, 1.82198340D+03, 1.79692720D+03, 1.77195120D+03,
     $ 1.74705670D+03, 1.72224470D+03, 1.69751600D+03, 1.67287130D+03,
     $ 1.64831100D+03, 1.62383530D+03, 1.59944420D+03, 1.57513720D+03/
      data ( FDNF( 22,J,1),J=1,20) /
     $ 5.324D-06, 1.049D-05, 1.551D-05, 2.036D-05, 2.507D-05, 2.960D-05,
     $ 3.398D-05, 3.822D-05, 4.231D-05, 4.622D-05, 5.000D-05, 5.364D-05,
     $ 5.711D-05, 6.044D-05, 6.360D-05, 6.662D-05, 6.949D-05, 7.218D-05,
     $ 7.471D-05, 7.709D-05/
      data (WNUPF( 22,J,2),J=1,20) /
     $ 2.16842230D+03, 2.14238840D+03, 2.11641610D+03, 2.09050690D+03,
     $ 2.06466240D+03, 2.03888420D+03, 2.01317390D+03, 1.98753300D+03,
     $ 1.96196300D+03, 1.93646530D+03, 1.91104140D+03, 1.88569240D+03,
     $ 1.86041950D+03, 1.83522360D+03, 1.81010570D+03, 1.78506640D+03,
     $ 1.76010610D+03, 1.73522500D+03, 1.71042330D+03, 1.68570050D+03/
      data ( FUPF( 22,J,2),J=1,20) /
     $ 5.807D-06, 1.143D-05, 1.687D-05, 2.210D-05, 2.716D-05, 3.202D-05,
     $ 3.670D-05, 4.121D-05, 4.553D-05, 4.967D-05, 5.363D-05, 5.742D-05,
     $ 6.105D-05, 6.447D-05, 6.772D-05, 7.081D-05, 7.370D-05, 7.642D-05,
     $ 7.895D-05, 8.130D-05/
      data (WNDNF( 22,J,2),J=1,20) /
     $ 2.00787670D+03, 1.98328230D+03, 1.95874930D+03, 1.93427940D+03,
     $ 1.90987410D+03, 1.88553490D+03, 1.86126350D+03, 1.83706140D+03,
     $ 1.81293000D+03, 1.78887080D+03, 1.76488500D+03, 1.74097400D+03,
     $ 1.71713880D+03, 1.69338040D+03, 1.66969970D+03, 1.64609730D+03,
     $ 1.62257370D+03, 1.59912920D+03, 1.57576370D+03, 1.55247710D+03/
      data ( FDNF( 22,J,2),J=1,20) /
     $ 5.098D-06, 1.005D-05, 1.485D-05, 1.951D-05, 2.402D-05, 2.838D-05,
     $ 3.260D-05, 3.667D-05, 4.060D-05, 4.440D-05, 4.804D-05, 5.156D-05,
     $ 5.491D-05, 5.813D-05, 6.122D-05, 6.416D-05, 6.693D-05, 6.958D-05,
     $ 7.207D-05, 7.440D-05/
      data (WNUPF( 23,J,1),J=1,20) /
     $ 2.22174830D+03, 2.19446380D+03, 2.16724520D+03, 2.14009430D+03,
     $ 2.11301280D+03, 2.08600240D+03, 2.05906490D+03, 2.03220200D+03,
     $ 2.00541520D+03, 1.97870620D+03, 1.95207640D+03, 1.92552710D+03,
     $ 1.89905950D+03, 1.87267460D+03, 1.84637340D+03, 1.82015650D+03,
     $ 1.79402420D+03, 1.76797680D+03, 1.74201400D+03, 1.71613550D+03/
      data ( FUPF( 23,J,1),J=1,20) /
     $ 6.082D-06, 1.196D-05, 1.764D-05, 2.311D-05, 2.838D-05, 3.347D-05,
     $ 3.833D-05, 4.302D-05, 4.749D-05, 5.180D-05, 5.589D-05, 5.980D-05,
     $ 6.353D-05, 6.707D-05, 7.040D-05, 7.356D-05, 7.651D-05, 7.927D-05,
     $ 8.182D-05, 8.418D-05/
      data (WNDNF( 23,J,1),J=1,20) /
     $ 2.04627610D+03, 2.02060180D+03, 1.99499330D+03, 1.96945230D+03,
     $ 1.94398070D+03, 1.91858010D+03, 1.89325210D+03, 1.86799860D+03,
     $ 1.84282110D+03, 1.81772100D+03, 1.79269990D+03, 1.76775900D+03,
     $ 1.74289960D+03, 1.71812270D+03, 1.69342910D+03, 1.66881950D+03,
     $ 1.64429440D+03, 1.61985380D+03, 1.59549770D+03, 1.57122570D+03/
      data ( FDNF( 23,J,1),J=1,20) /
     $ 5.319D-06, 1.048D-05, 1.549D-05, 2.034D-05, 2.504D-05, 2.957D-05,
     $ 3.396D-05, 3.819D-05, 4.226D-05, 4.619D-05, 4.996D-05, 5.360D-05,
     $ 5.706D-05, 6.040D-05, 6.357D-05, 6.657D-05, 6.945D-05, 7.215D-05,
     $ 7.468D-05, 7.704D-05/
      data (WNUPF( 23,J,2),J=1,20) /
     $ 2.17131180D+03, 2.14524530D+03, 2.11924030D+03, 2.09329840D+03,
     $ 2.06742120D+03, 2.04161040D+03, 2.01586740D+03, 1.99019390D+03,
     $ 1.96459130D+03, 1.93906110D+03, 1.91360460D+03, 1.88822300D+03,
     $ 1.86291750D+03, 1.83768910D+03, 1.81253870D+03, 1.78746680D+03,
     $ 1.76247390D+03, 1.73756030D+03, 1.71272600D+03, 1.68797060D+03/
      data ( FUPF( 23,J,2),J=1,20) /
     $ 5.811D-06, 1.143D-05, 1.688D-05, 2.211D-05, 2.718D-05, 3.204D-05,
     $ 3.671D-05, 4.122D-05, 4.556D-05, 4.969D-05, 5.364D-05, 5.742D-05,
     $ 6.104D-05, 6.447D-05, 6.771D-05, 7.080D-05, 7.369D-05, 7.640D-05,
     $ 7.893D-05, 8.127D-05/
      data (WNDNF( 23,J,2),J=1,20) /
     $ 2.00351490D+03, 1.97895330D+03, 1.95445310D+03, 1.93001590D+03,
     $ 1.90564330D+03, 1.88133700D+03, 1.85709840D+03, 1.83292900D+03,
     $ 1.80883040D+03, 1.78480400D+03, 1.76085110D+03, 1.73697280D+03,
     $ 1.71317040D+03, 1.68944490D+03, 1.66579700D+03, 1.64222740D+03,
     $ 1.61873660D+03, 1.59532490D+03, 1.57199210D+03, 1.54873830D+03/
      data ( FDNF( 23,J,2),J=1,20) /
     $ 5.091D-06, 1.004D-05, 1.483D-05, 1.949D-05, 2.400D-05, 2.836D-05,
     $ 3.257D-05, 3.664D-05, 4.057D-05, 4.436D-05, 4.800D-05, 5.151D-05,
     $ 5.487D-05, 5.811D-05, 6.117D-05, 6.411D-05, 6.689D-05, 6.953D-05,
     $ 7.202D-05, 7.436D-05/
      data (WNUPF( 24,J,1),J=1,20) /
     $ 2.22471270D+03, 2.19739320D+03, 2.17013970D+03, 2.14295380D+03,
     $ 2.11583740D+03, 2.08879210D+03, 2.06181970D+03, 2.03492190D+03,
     $ 2.00810020D+03, 1.98135640D+03, 1.95469170D+03, 1.92810750D+03,
     $ 1.90160510D+03, 1.87518540D+03, 1.84884940D+03, 1.82259760D+03,
     $ 1.79643050D+03, 1.77034820D+03, 1.74435060D+03, 1.71843720D+03/
      data ( FUPF( 24,J,1),J=1,20) /
     $ 6.087D-06, 1.197D-05, 1.765D-05, 2.313D-05, 2.840D-05, 3.347D-05,
     $ 3.836D-05, 4.302D-05, 4.751D-05, 5.181D-05, 5.589D-05, 5.981D-05,
     $ 6.353D-05, 6.706D-05, 7.040D-05, 7.353D-05, 7.649D-05, 7.923D-05,
     $ 8.179D-05, 8.413D-05/
      data (WNDNF( 24,J,1),J=1,20) /
     $ 2.04166640D+03, 2.01602720D+03, 1.99045370D+03, 1.96494780D+03,
     $ 1.93951120D+03, 1.91414570D+03, 1.88885290D+03, 1.86363440D+03,
     $ 1.83849200D+03, 1.81342700D+03, 1.78844100D+03, 1.76353530D+03,
     $ 1.73871100D+03, 1.71396920D+03, 1.68931070D+03, 1.66473620D+03,
     $ 1.64024610D+03, 1.61584060D+03, 1.59151960D+03, 1.56728260D+03/
      data ( FDNF( 24,J,1),J=1,20) /
     $ 5.312D-06, 1.047D-05, 1.547D-05, 2.032D-05, 2.500D-05, 2.953D-05,
     $ 3.392D-05, 3.814D-05, 4.222D-05, 4.614D-05, 4.992D-05, 5.355D-05,
     $ 5.702D-05, 6.035D-05, 6.351D-05, 6.653D-05, 6.941D-05, 7.210D-05,
     $ 7.463D-05, 7.700D-05/
      data (WNUPF( 24,J,2),J=1,20) /
     $ 2.17416560D+03, 2.14806640D+03, 2.12202870D+03, 2.09605410D+03,
     $ 2.07014430D+03, 2.04430080D+03, 2.01852530D+03, 1.99281910D+03,
     $ 1.96718390D+03, 1.94162110D+03, 1.91613200D+03, 1.89071780D+03,
     $ 1.86537980D+03, 1.84011890D+03, 1.81493580D+03, 1.78983140D+03,
     $ 1.76480600D+03, 1.73985980D+03, 1.71499290D+03, 1.69020490D+03/
      data ( FUPF( 24,J,2),J=1,20) /
     $ 5.817D-06, 1.144D-05, 1.689D-05, 2.213D-05, 2.719D-05, 3.206D-05,
     $ 3.674D-05, 4.123D-05, 4.555D-05, 4.970D-05, 5.366D-05, 5.745D-05,
     $ 6.104D-05, 6.447D-05, 6.772D-05, 7.079D-05, 7.368D-05, 7.638D-05,
     $ 7.891D-05, 8.123D-05/
      data (WNDNF( 24,J,2),J=1,20) /
     $ 1.99912350D+03, 1.97459470D+03, 1.95012720D+03, 1.92572280D+03,
     $ 1.90138300D+03, 1.87710940D+03, 1.85290360D+03, 1.82876710D+03,
     $ 1.80470130D+03, 1.78070760D+03, 1.75678750D+03, 1.73294210D+03,
     $ 1.70917250D+03, 1.68547980D+03, 1.66186470D+03, 1.63832790D+03,
     $ 1.61486990D+03, 1.59149090D+03, 1.56819100D+03, 1.54496980D+03/
      data ( FDNF( 24,J,2),J=1,20) /
     $ 5.086D-06, 1.003D-05, 1.481D-05, 1.947D-05, 2.398D-05, 2.833D-05,
     $ 3.253D-05, 3.661D-05, 4.053D-05, 4.433D-05, 4.796D-05, 5.147D-05,
     $ 5.484D-05, 5.806D-05, 6.114D-05, 6.406D-05, 6.686D-05, 6.951D-05,
     $ 7.200D-05, 7.433D-05/
      data (WNUPF( 25,J,1),J=1,20) /
     $ 2.22763860D+03, 2.20028420D+03, 2.17299570D+03, 2.14577490D+03,
     $ 2.11862350D+03, 2.09154330D+03, 2.06453600D+03, 2.03760330D+03,
     $ 2.01074670D+03, 1.98396800D+03, 1.95726840D+03, 1.93064940D+03,
     $ 1.90411220D+03, 1.87765770D+03, 1.85128680D+03, 1.82500020D+03,
     $ 1.79879830D+03, 1.77268120D+03, 1.74664870D+03, 1.72070040D+03/
      data ( FUPF( 25,J,1),J=1,20) /
     $ 6.094D-06, 1.198D-05, 1.767D-05, 2.314D-05, 2.843D-05, 3.349D-05,
     $ 3.837D-05, 4.306D-05, 4.753D-05, 5.182D-05, 5.592D-05, 5.984D-05,
     $ 6.355D-05, 6.706D-05, 7.039D-05, 7.353D-05, 7.649D-05, 7.922D-05,
     $ 8.178D-05, 8.410D-05/
      data (WNDNF( 25,J,1),J=1,20) /
     $ 2.03702530D+03, 2.01142110D+03, 1.98588270D+03, 1.96041180D+03,
     $ 1.93501030D+03, 1.90967990D+03, 1.88442210D+03, 1.85923880D+03,
     $ 1.83413140D+03, 1.80910160D+03, 1.78415070D+03, 1.75928010D+03,
     $ 1.73449090D+03, 1.70978430D+03, 1.68516090D+03, 1.66062150D+03,
     $ 1.63616650D+03, 1.61179610D+03, 1.58751010D+03, 1.56330810D+03/
      data ( FDNF( 25,J,1),J=1,20) /
     $ 5.306D-06, 1.046D-05, 1.545D-05, 2.029D-05, 2.498D-05, 2.951D-05,
     $ 3.388D-05, 3.810D-05, 4.218D-05, 4.610D-05, 4.988D-05, 5.349D-05,
     $ 5.698D-05, 6.029D-05, 6.347D-05, 6.649D-05, 6.935D-05, 7.206D-05,
     $ 7.459D-05, 7.696D-05/
      data (WNUPF( 25,J,2),J=1,20) /
     $ 2.17698340D+03, 2.15085150D+03, 2.12478110D+03, 2.09877390D+03,
     $ 2.07283150D+03, 2.04695530D+03, 2.02114710D+03, 1.99540840D+03,
     $ 1.96974060D+03, 1.94414510D+03, 1.91862350D+03, 1.89317670D+03,
     $ 1.86780620D+03, 1.84251270D+03, 1.81729710D+03, 1.79216010D+03,
     $ 1.76710220D+03, 1.74212340D+03, 1.71722390D+03, 1.69240340D+03/
      data ( FUPF( 25,J,2),J=1,20) /
     $ 5.820D-06, 1.145D-05, 1.690D-05, 2.214D-05, 2.720D-05, 3.208D-05,
     $ 3.676D-05, 4.127D-05, 4.557D-05, 4.971D-05, 5.367D-05, 5.745D-05,
     $ 6.106D-05, 6.449D-05, 6.771D-05, 7.080D-05, 7.367D-05, 7.637D-05,
     $ 7.888D-05, 8.120D-05/
      data (WNDNF( 25,J,2),J=1,20) /
     $ 1.99470270D+03, 1.97020650D+03, 1.94577180D+03, 1.92140020D+03,
     $ 1.89709320D+03, 1.87285240D+03, 1.84867930D+03, 1.82457560D+03,
     $ 1.80054260D+03, 1.77658180D+03, 1.75269450D+03, 1.72888190D+03,
     $ 1.70514510D+03, 1.68148520D+03, 1.65790300D+03, 1.63439900D+03,
     $ 1.61097380D+03, 1.58762760D+03, 1.56436040D+03, 1.54117200D+03/
      data ( FDNF( 25,J,2),J=1,20) /
     $ 5.078D-06, 1.001D-05, 1.480D-05, 1.945D-05, 2.394D-05, 2.829D-05,
     $ 3.251D-05, 3.657D-05, 4.049D-05, 4.427D-05, 4.792D-05, 5.143D-05,
     $ 5.478D-05, 5.800D-05, 6.108D-05, 6.402D-05, 6.682D-05, 6.945D-05,
     $ 7.194D-05, 7.429D-05/
      data (WNUPF( 26,J,1),J=1,20) /
     $ 2.23052580D+03, 2.20313650D+03, 2.17581300D+03, 2.14855730D+03,
     $ 2.12137100D+03, 2.09425580D+03, 2.06721360D+03, 2.04024600D+03,
     $ 2.01335460D+03, 1.98654090D+03, 1.95980650D+03, 1.93315270D+03,
     $ 1.90658060D+03, 1.88009130D+03, 1.85368560D+03, 1.82736420D+03,
     $ 1.80112740D+03, 1.77497540D+03, 1.74890810D+03, 1.72292490D+03/
      data ( FUPF( 26,J,1),J=1,20) /
     $ 6.100D-06, 1.199D-05, 1.768D-05, 2.316D-05, 2.845D-05, 3.353D-05,
     $ 3.839D-05, 4.308D-05, 4.757D-05, 5.184D-05, 5.594D-05, 5.984D-05,
     $ 6.355D-05, 6.708D-05, 7.039D-05, 7.353D-05, 7.647D-05, 7.922D-05,
     $ 8.176D-05, 8.408D-05/
      data (WNDNF( 26,J,1),J=1,20) /
     $ 2.03235280D+03, 2.00678360D+03, 1.98128030D+03, 1.95584450D+03,
     $ 1.93047810D+03, 1.90518270D+03, 1.87996000D+03, 1.85481180D+03,
     $ 1.82973950D+03, 1.80474480D+03, 1.77982910D+03, 1.75499360D+03,
     $ 1.73023960D+03, 1.70556800D+03, 1.68097980D+03, 1.65647550D+03,
     $ 1.63205560D+03, 1.60772020D+03, 1.58346930D+03, 1.55930230D+03/
      data ( FDNF( 26,J,1),J=1,20) /
     $ 5.298D-06, 1.044D-05, 1.543D-05, 2.026D-05, 2.494D-05, 2.947D-05,
     $ 3.385D-05, 3.806D-05, 4.213D-05, 4.606D-05, 4.983D-05, 5.345D-05,
     $ 5.692D-05, 6.025D-05, 6.342D-05, 6.643D-05, 6.930D-05, 7.200D-05,
     $ 7.455D-05, 7.691D-05/
      data (WNUPF( 26,J,2),J=1,20) /
     $ 2.17976510D+03, 2.15360060D+03, 2.12749760D+03, 2.10145770D+03,
     $ 2.07548260D+03, 2.04957380D+03, 2.02373290D+03, 1.99796160D+03,
     $ 1.97226120D+03, 1.94663320D+03, 1.92107890D+03, 1.89559960D+03,
     $ 1.87019650D+03, 1.84487040D+03, 1.81962230D+03, 1.79445280D+03,
     $ 1.76936230D+03, 1.74435100D+03, 1.71941890D+03, 1.69456570D+03/
      data ( FUPF( 26,J,2),J=1,20) /
     $ 5.827D-06, 1.146D-05, 1.692D-05, 2.216D-05, 2.722D-05, 3.210D-05,
     $ 3.678D-05, 4.127D-05, 4.561D-05, 4.975D-05, 5.369D-05, 5.747D-05,
     $ 6.108D-05, 6.449D-05, 6.773D-05, 7.078D-05, 7.367D-05, 7.637D-05,
     $ 7.886D-05, 8.120D-05/
      data (WNDNF( 26,J,2),J=1,20) /
     $ 1.99025240D+03, 1.96578900D+03, 1.94138710D+03, 1.91704820D+03,
     $ 1.89277400D+03, 1.86856600D+03, 1.84442570D+03, 1.82035480D+03,
     $ 1.79635460D+03, 1.77242660D+03, 1.74857210D+03, 1.72479230D+03,
     $ 1.70108840D+03, 1.67746130D+03, 1.65391190D+03, 1.63044080D+03,
     $ 1.60704840D+03, 1.58373500D+03, 1.56050060D+03, 1.53734490D+03/
      data ( FDNF( 26,J,2),J=1,20) /
     $ 5.074D-06, 1.000D-05, 1.478D-05, 1.942D-05, 2.391D-05, 2.826D-05,
     $ 3.247D-05, 3.653D-05, 4.045D-05, 4.423D-05, 4.787D-05, 5.138D-05,
     $ 5.474D-05, 5.796D-05, 6.104D-05, 6.398D-05, 6.675D-05, 6.942D-05,
     $ 7.191D-05, 7.425D-05/
      data (WNUPF( 27,J,1),J=1,20) /
     $ 2.23337430D+03, 2.20595000D+03, 2.17859160D+03, 2.15130090D+03,
     $ 2.12407960D+03, 2.09692950D+03, 2.06985240D+03, 2.04284990D+03,
     $ 2.01592360D+03, 1.98907510D+03, 1.96230590D+03, 1.93561720D+03,
     $ 1.90901030D+03, 1.88248610D+03, 1.85604560D+03, 1.82968940D+03,
     $ 1.80341780D+03, 1.77723090D+03, 1.75112870D+03, 1.72511060D+03/
      data ( FUPF( 27,J,1),J=1,20) /
     $ 6.106D-06, 1.201D-05, 1.770D-05, 2.319D-05, 2.847D-05, 3.355D-05,
     $ 3.842D-05, 4.309D-05, 4.758D-05, 5.187D-05, 5.596D-05, 5.987D-05,
     $ 6.357D-05, 6.709D-05, 7.042D-05, 7.355D-05, 7.647D-05, 7.921D-05,
     $ 8.174D-05, 8.406D-05/
      data (WNDNF( 27,J,1),J=1,20) /
     $ 2.02764910D+03, 2.00211500D+03, 1.97664670D+03, 1.95124600D+03,
     $ 1.92591460D+03, 1.90065430D+03, 1.87546670D+03, 1.85035360D+03,
     $ 1.82531650D+03, 1.80035690D+03, 1.77547620D+03, 1.75067590D+03,
     $ 1.72595700D+03, 1.70132060D+03, 1.67676750D+03, 1.65229840D+03,
     $ 1.62791360D+03, 1.60361330D+03, 1.57939740D+03, 1.55526550D+03/
      data ( FDNF( 27,J,1),J=1,20) /
     $ 5.291D-06, 1.043D-05, 1.541D-05, 2.024D-05, 2.491D-05, 2.944D-05,
     $ 3.380D-05, 3.802D-05, 4.209D-05, 4.600D-05, 4.976D-05, 5.338D-05,
     $ 5.685D-05, 6.018D-05, 6.335D-05, 6.638D-05, 6.924D-05, 7.195D-05,
     $ 7.449D-05, 7.685D-05/
      data (WNUPF( 27,J,2),J=1,20) /
     $ 2.18251070D+03, 2.15631350D+03, 2.13017780D+03, 2.10410520D+03,
     $ 2.07809750D+03, 2.05215610D+03, 2.02628260D+03, 2.00047860D+03,
     $ 1.97474560D+03, 1.94908500D+03, 1.92349810D+03, 1.89798630D+03,
     $ 1.87255060D+03, 1.84719200D+03, 1.82191130D+03, 1.79670930D+03,
     $ 1.77158620D+03, 1.74654240D+03, 1.72157770D+03, 1.69669190D+03/
      data ( FUPF( 27,J,2),J=1,20) /
     $ 5.832D-06, 1.147D-05, 1.693D-05, 2.217D-05, 2.725D-05, 3.211D-05,
     $ 3.681D-05, 4.130D-05, 4.562D-05, 4.975D-05, 5.372D-05, 5.749D-05,
     $ 6.109D-05, 6.451D-05, 6.774D-05, 7.079D-05, 7.366D-05, 7.636D-05,
     $ 7.887D-05, 8.117D-05/
      data (WNDNF( 27,J,2),J=1,20) /
     $ 1.98577290D+03, 1.96134230D+03, 1.93697310D+03, 1.91266700D+03,
     $ 1.88842550D+03, 1.86425030D+03, 1.84014280D+03, 1.81610470D+03,
     $ 1.79213730D+03, 1.76824220D+03, 1.74442050D+03, 1.72067360D+03,
     $ 1.69700250D+03, 1.67340820D+03, 1.64989160D+03, 1.62645330D+03,
     $ 1.60309380D+03, 1.57981310D+03, 1.55661150D+03, 1.53348860D+03/
      data ( FDNF( 27,J,2),J=1,20) /
     $ 5.065D-06, 9.987D-06, 1.476D-05, 1.940D-05, 2.389D-05, 2.824D-05,
     $ 3.244D-05, 3.649D-05, 4.040D-05, 4.418D-05, 4.782D-05, 5.133D-05,
     $ 5.467D-05, 5.791D-05, 6.098D-05, 6.391D-05, 6.671D-05, 6.935D-05,
     $ 7.185D-05, 7.418D-05/
      data (WNUPF( 28,J,1),J=1,20) /
     $ 2.23618380D+03, 2.20872450D+03, 2.18133110D+03, 2.15400550D+03,
     $ 2.12674930D+03, 2.09956430D+03, 2.07245230D+03, 2.04541480D+03,
     $ 2.01845370D+03, 1.99157030D+03, 1.96476620D+03, 1.93804270D+03,
     $ 1.91140090D+03, 1.88484200D+03, 1.85836670D+03, 1.83197560D+03,
     $ 1.80566920D+03, 1.77944750D+03, 1.75331040D+03, 1.72725730D+03/
      data ( FUPF( 28,J,1),J=1,20) /
     $ 6.113D-06, 1.202D-05, 1.771D-05, 2.320D-05, 2.849D-05, 3.356D-05,
     $ 3.845D-05, 4.313D-05, 4.762D-05, 5.189D-05, 5.598D-05, 5.989D-05,
     $ 6.360D-05, 6.711D-05, 7.042D-05, 7.355D-05, 7.647D-05, 7.920D-05,
     $ 8.173D-05, 8.404D-05/
      data (WNDNF( 28,J,1),J=1,20) /
     $ 2.02291440D+03, 1.99741530D+03, 1.97198210D+03, 1.94661640D+03,
     $ 1.92132010D+03, 1.89609490D+03, 1.87094240D+03, 1.84586440D+03,
     $ 1.82086240D+03, 1.79593790D+03, 1.77109240D+03, 1.74632720D+03,
     $ 1.72164350D+03, 1.69704220D+03, 1.67252420D+03, 1.64809020D+03,
     $ 1.62374050D+03, 1.59947530D+03, 1.57529450D+03, 1.55119760D+03/
      data ( FDNF( 28,J,1),J=1,20) /
     $ 5.282D-06, 1.041D-05, 1.539D-05, 2.021D-05, 2.488D-05, 2.939D-05,
     $ 3.375D-05, 3.796D-05, 4.204D-05, 4.595D-05, 4.972D-05, 5.333D-05,
     $ 5.681D-05, 6.012D-05, 6.328D-05, 6.632D-05, 6.918D-05, 7.188D-05,
     $ 7.442D-05, 7.679D-05/
      data (WNUPF( 28,J,2),J=1,20) /
     $ 2.18521990D+03, 2.15899000D+03, 2.13282170D+03, 2.10671650D+03,
     $ 2.08067600D+03, 2.05470200D+03, 2.02879590D+03, 2.00295930D+03,
     $ 1.97719370D+03, 1.95150050D+03, 1.92588100D+03, 1.90033670D+03,
     $ 1.87486840D+03, 1.84947730D+03, 1.82416410D+03, 1.79892940D+03,
     $ 1.77377380D+03, 1.74869740D+03, 1.72370020D+03, 1.69878180D+03/
      data ( FUPF( 28,J,2),J=1,20) /
     $ 5.838D-06, 1.149D-05, 1.695D-05, 2.220D-05, 2.727D-05, 3.215D-05,
     $ 3.684D-05, 4.133D-05, 4.565D-05, 4.978D-05, 5.375D-05, 5.751D-05,
     $ 6.111D-05, 6.453D-05, 6.775D-05, 7.080D-05, 7.367D-05, 7.635D-05,
     $ 7.885D-05, 8.115D-05/
      data (WNDNF( 28,J,2),J=1,20) /
     $ 1.98126430D+03, 1.95686650D+03, 1.93253010D+03, 1.90825670D+03,
     $ 1.88404800D+03, 1.85990560D+03, 1.83583090D+03, 1.81182560D+03,
     $ 1.78789100D+03, 1.76402870D+03, 1.74023980D+03, 1.71652570D+03,
     $ 1.69288750D+03, 1.66932610D+03, 1.64584230D+03, 1.62243690D+03,
     $ 1.59911010D+03, 1.57586230D+03, 1.55269340D+03, 1.52960330D+03/
      data ( FDNF( 28,J,2),J=1,20) /
     $ 5.058D-06, 9.974D-06, 1.474D-05, 1.937D-05, 2.386D-05, 2.819D-05,
     $ 3.239D-05, 3.644D-05, 4.035D-05, 4.412D-05, 4.777D-05, 5.126D-05,
     $ 5.461D-05, 5.784D-05, 6.091D-05, 6.386D-05, 6.665D-05, 6.930D-05,
     $ 7.179D-05, 7.412D-05/
      data (WNUPF( 29,J,1),J=1,20) /
     $ 2.23895410D+03, 2.21145990D+03, 2.18403160D+03, 2.15667100D+03,
     $ 2.12937990D+03, 2.10215990D+03, 2.07501300D+03, 2.04794070D+03,
     $ 2.02094460D+03, 1.99402640D+03, 1.96718750D+03, 1.94042910D+03,
     $ 1.91375250D+03, 1.88715880D+03, 1.86064860D+03, 1.83422270D+03,
     $ 1.80788150D+03, 1.78162490D+03, 1.75545290D+03, 1.72936500D+03/
      data ( FUPF( 29,J,1),J=1,20) /
     $ 6.119D-06, 1.203D-05, 1.774D-05, 2.323D-05, 2.851D-05, 3.360D-05,
     $ 3.847D-05, 4.316D-05, 4.763D-05, 5.193D-05, 5.602D-05, 5.991D-05,
     $ 6.361D-05, 6.712D-05, 7.042D-05, 7.356D-05, 7.647D-05, 7.919D-05,
     $ 8.172D-05, 8.402D-05/
      data (WNDNF( 29,J,1),J=1,20) /
     $ 2.01814880D+03, 1.99268480D+03, 1.96728660D+03, 1.94195600D+03,
     $ 1.91669470D+03, 1.89150460D+03, 1.86638720D+03, 1.84134430D+03,
     $ 1.81637740D+03, 1.79148800D+03, 1.76667770D+03, 1.74194760D+03,
     $ 1.71729900D+03, 1.69273290D+03, 1.66825010D+03, 1.64385120D+03,
     $ 1.61953670D+03, 1.59530660D+03, 1.57116080D+03, 1.54709890D+03/
      data ( FDNF( 29,J,1),J=1,20) /
     $ 5.275D-06, 1.040D-05, 1.537D-05, 2.019D-05, 2.485D-05, 2.936D-05,
     $ 3.371D-05, 3.792D-05, 4.198D-05, 4.590D-05, 4.964D-05, 5.327D-05,
     $ 5.673D-05, 6.005D-05, 6.322D-05, 6.624D-05, 6.910D-05, 7.181D-05,
     $ 7.436D-05, 7.673D-05/
      data (WNUPF( 29,J,2),J=1,20) /
     $ 2.18789270D+03, 2.16163010D+03, 2.13542910D+03, 2.10929120D+03,
     $ 2.08321820D+03, 2.05721150D+03, 2.03127270D+03, 2.00540350D+03,
     $ 1.97960530D+03, 1.95387950D+03, 1.92822750D+03, 1.90265060D+03,
     $ 1.87714970D+03, 1.85172610D+03, 1.82638030D+03, 1.80111320D+03,
     $ 1.77592500D+03, 1.75081600D+03, 1.72578620D+03, 1.70083510D+03/
      data ( FUPF( 29,J,2),J=1,20) /
     $ 5.846D-06, 1.150D-05, 1.696D-05, 2.221D-05, 2.728D-05, 3.216D-05,
     $ 3.686D-05, 4.135D-05, 4.568D-05, 4.981D-05, 5.375D-05, 5.753D-05,
     $ 6.112D-05, 6.454D-05, 6.775D-05, 7.081D-05, 7.367D-05, 7.635D-05,
     $ 7.884D-05, 8.114D-05/
      data (WNDNF( 29,J,2),J=1,20) /
     $ 1.97672680D+03, 1.95236170D+03, 1.92805800D+03, 1.90381740D+03,
     $ 1.87964150D+03, 1.85553180D+03, 1.83149000D+03, 1.80751740D+03,
     $ 1.78361570D+03, 1.75978620D+03, 1.73603020D+03, 1.71234900D+03,
     $ 1.68874360D+03, 1.66521500D+03, 1.64176410D+03, 1.61839150D+03,
     $ 1.59509750D+03, 1.57188250D+03, 1.54874650D+03, 1.52568900D+03/
      data ( FDNF( 29,J,2),J=1,20) /
     $ 5.051D-06, 9.959D-06, 1.472D-05, 1.934D-05, 2.381D-05, 2.815D-05,
     $ 3.234D-05, 3.639D-05, 4.031D-05, 4.408D-05, 4.771D-05, 5.120D-05,
     $ 5.456D-05, 5.778D-05, 6.086D-05, 6.380D-05, 6.659D-05, 6.924D-05,
     $ 7.173D-05, 7.407D-05/
      data (WNUPF( 30,J,1),J=1,20) /
     $ 2.24168530D+03, 2.21415610D+03, 2.18669280D+03, 2.15929730D+03,
     $ 2.13197120D+03, 2.10471630D+03, 2.07753450D+03, 2.05042730D+03,
     $ 2.02339640D+03, 1.99644330D+03, 1.96956950D+03, 1.94277630D+03,
     $ 1.91606490D+03, 1.88943630D+03, 1.86289130D+03, 1.83643060D+03,
     $ 1.81005450D+03, 1.78376310D+03, 1.75755620D+03, 1.73143330D+03/
      data ( FUPF( 30,J,1),J=1,20) /
     $ 6.125D-06, 1.204D-05, 1.775D-05, 2.325D-05, 2.854D-05, 3.363D-05,
     $ 3.851D-05, 4.319D-05, 4.766D-05, 5.195D-05, 5.603D-05, 5.993D-05,
     $ 6.363D-05, 6.714D-05, 7.044D-05, 7.356D-05, 7.647D-05, 7.919D-05,
     $ 8.171D-05, 8.398D-05/
      data (WNDNF( 30,J,1),J=1,20) /
     $ 2.01335240D+03, 1.98792340D+03, 1.96256030D+03, 1.93726480D+03,
     $ 1.91203860D+03, 1.88688350D+03, 1.86180120D+03, 1.83679340D+03,
     $ 1.81186160D+03, 1.78700740D+03, 1.76223220D+03, 1.73753730D+03,
     $ 1.71292390D+03, 1.68839290D+03, 1.66394530D+03, 1.63958150D+03,
     $ 1.61530210D+03, 1.59110710D+03, 1.56699640D+03, 1.54296960D+03/
      data ( FDNF( 30,J,1),J=1,20) /
     $ 5.267D-06, 1.038D-05, 1.534D-05, 2.015D-05, 2.480D-05, 2.931D-05,
     $ 3.366D-05, 3.787D-05, 4.192D-05, 4.584D-05, 4.959D-05, 5.320D-05,
     $ 5.667D-05, 5.998D-05, 6.315D-05, 6.618D-05, 6.903D-05, 7.174D-05,
     $ 7.430D-05, 7.666D-05/
      data (WNUPF( 30,J,2),J=1,20) /
     $ 2.19052890D+03, 2.16423360D+03, 2.13799990D+03, 2.11182940D+03,
     $ 2.08572370D+03, 2.05968430D+03, 2.03371300D+03, 2.00781110D+03,
     $ 1.98198030D+03, 1.95622190D+03, 1.93053740D+03, 1.90492790D+03,
     $ 1.87939450D+03, 1.85393830D+03, 1.82856000D+03, 1.80326030D+03,
     $ 1.77803950D+03, 1.75289800D+03, 1.72783560D+03, 1.70285190D+03/
      data ( FUPF( 30,J,2),J=1,20) /
     $ 5.851D-06, 1.151D-05, 1.698D-05, 2.224D-05, 2.731D-05, 3.219D-05,
     $ 3.688D-05, 4.139D-05, 4.571D-05, 4.983D-05, 5.380D-05, 5.756D-05,
     $ 6.115D-05, 6.456D-05, 6.778D-05, 7.081D-05, 7.368D-05, 7.636D-05,
     $ 7.883D-05, 8.112D-05/
      data (WNDNF( 30,J,2),J=1,20) /
     $ 1.97216040D+03, 1.94782800D+03, 1.92355720D+03, 1.89934930D+03,
     $ 1.87520620D+03, 1.85112930D+03, 1.82712020D+03, 1.80318050D+03,
     $ 1.77931160D+03, 1.75551490D+03, 1.73179180D+03, 1.70814340D+03,
     $ 1.68457080D+03, 1.66107510D+03, 1.63765710D+03, 1.61431730D+03,
     $ 1.59105620D+03, 1.56787400D+03, 1.54477070D+03, 1.52174600D+03/
      data ( FDNF( 30,J,2),J=1,20) /
     $ 5.043D-06, 9.944D-06, 1.469D-05, 1.931D-05, 2.379D-05, 2.811D-05,
     $ 3.230D-05, 3.634D-05, 4.026D-05, 4.402D-05, 4.766D-05, 5.115D-05,
     $ 5.449D-05, 5.772D-05, 6.079D-05, 6.372D-05, 6.652D-05, 6.916D-05,
     $ 7.166D-05, 7.400D-05/
      data (WNUPF( 31,J,1),J=1,20) /
     $ 2.24437700D+03, 2.21681280D+03, 2.18931460D+03, 2.16188410D+03,
     $ 2.13452310D+03, 2.10723340D+03, 2.08001660D+03, 2.05287450D+03,
     $ 2.02580870D+03, 1.99882070D+03, 1.97191210D+03, 1.94508410D+03,
     $ 1.91833780D+03, 1.89167440D+03, 1.86509460D+03, 1.83859910D+03,
     $ 1.81218810D+03, 1.78586180D+03, 1.75962010D+03, 1.73346220D+03/
      data ( FUPF( 31,J,1),J=1,20) /
     $ 6.133D-06, 1.206D-05, 1.777D-05, 2.328D-05, 2.857D-05, 3.366D-05,
     $ 3.854D-05, 4.321D-05, 4.770D-05, 5.198D-05, 5.607D-05, 5.997D-05,
     $ 6.366D-05, 6.716D-05, 7.046D-05, 7.357D-05, 7.648D-05, 7.918D-05,
     $ 8.170D-05, 8.397D-05/
      data (WNDNF( 31,J,1),J=1,20) /
     $ 2.00852540D+03, 1.98313150D+03, 1.95780340D+03, 1.93254290D+03,
     $ 1.90735180D+03, 1.88223180D+03, 1.85718460D+03, 1.83221190D+03,
     $ 1.80731530D+03, 1.78249620D+03, 1.75775620D+03, 1.73309640D+03,
     $ 1.70851820D+03, 1.68402240D+03, 1.65960980D+03, 1.63528120D+03,
     $ 1.61103690D+03, 1.58687700D+03, 1.56280140D+03, 1.53880960D+03/
      data ( FDNF( 31,J,1),J=1,20) /
     $ 5.259D-06, 1.037D-05, 1.532D-05, 2.013D-05, 2.478D-05, 2.927D-05,
     $ 3.362D-05, 3.781D-05, 4.186D-05, 4.576D-05, 4.952D-05, 5.313D-05,
     $ 5.660D-05, 5.992D-05, 6.308D-05, 6.610D-05, 6.897D-05, 7.165D-05,
     $ 7.421D-05, 7.657D-05/
      data (WNUPF( 31,J,2),J=1,20) /
     $ 2.19312830D+03, 2.16680040D+03, 2.14053400D+03, 2.11433080D+03,
     $ 2.08819250D+03, 2.06212050D+03, 2.03611650D+03, 2.01018200D+03,
     $ 1.98431860D+03, 1.95852770D+03, 1.93281050D+03, 1.90716840D+03,
     $ 1.88160250D+03, 1.85611370D+03, 1.83070290D+03, 1.80537070D+03,
     $ 1.78011740D+03, 1.75494330D+03, 1.72984820D+03, 1.70483200D+03/
      data ( FUPF( 31,J,2),J=1,20) /
     $ 5.859D-06, 1.152D-05, 1.700D-05, 2.226D-05, 2.733D-05, 3.221D-05,
     $ 3.692D-05, 4.141D-05, 4.574D-05, 4.987D-05, 5.382D-05, 5.759D-05,
     $ 6.116D-05, 6.457D-05, 6.779D-05, 7.084D-05, 7.369D-05, 7.634D-05,
     $ 7.884D-05, 8.111D-05/
      data (WNDNF( 31,J,2),J=1,20) /
     $ 1.96756530D+03, 1.94326570D+03, 1.91902760D+03, 1.89485250D+03,
     $ 1.87074220D+03, 1.84669810D+03, 1.82272180D+03, 1.79881490D+03,
     $ 1.77497880D+03, 1.75121490D+03, 1.72752460D+03, 1.70390910D+03,
     $ 1.68036940D+03, 1.65690660D+03, 1.63352140D+03, 1.61021440D+03,
     $ 1.58698620D+03, 1.56383680D+03, 1.54076630D+03, 1.51777440D+03/
      data ( FDNF( 31,J,2),J=1,20) /
     $ 5.035D-06, 9.929D-06, 1.467D-05, 1.929D-05, 2.375D-05, 2.808D-05,
     $ 3.225D-05, 3.630D-05, 4.021D-05, 4.397D-05, 4.759D-05, 5.108D-05,
     $ 5.443D-05, 5.765D-05, 6.073D-05, 6.367D-05, 6.644D-05, 6.910D-05,
     $ 7.159D-05, 7.394D-05/
      data (WNUPF( 32,J,1),J=1,20) /
     $ 2.24702920D+03, 2.21943010D+03, 2.19189690D+03, 2.16443150D+03,
     $ 2.13703550D+03, 2.10971080D+03, 2.08245910D+03, 2.05528210D+03,
     $ 2.02818150D+03, 2.00115860D+03, 1.97421510D+03, 1.94735230D+03,
     $ 1.92057120D+03, 1.89387300D+03, 1.86725840D+03, 1.84072800D+03,
     $ 1.81428220D+03, 1.78792100D+03, 1.76164440D+03, 1.73545160D+03/
      data ( FUPF( 32,J,1),J=1,20) /
     $ 6.141D-06, 1.207D-05, 1.779D-05, 2.330D-05, 2.859D-05, 3.368D-05,
     $ 3.857D-05, 4.325D-05, 4.773D-05, 5.202D-05, 5.610D-05, 5.998D-05,
     $ 6.368D-05, 6.717D-05, 7.048D-05, 7.359D-05, 7.649D-05, 7.917D-05,
     $ 8.168D-05, 8.395D-05/
      data (WNDNF( 32,J,1),J=1,20) /
     $ 2.00366790D+03, 1.97830900D+03, 1.95301600D+03, 1.92779060D+03,
     $ 1.90263460D+03, 1.87754970D+03, 1.85253760D+03, 1.82760000D+03,
     $ 1.80273850D+03, 1.77795460D+03, 1.75324970D+03, 1.72862510D+03,
     $ 1.70408200D+03, 1.67962130D+03, 1.65524400D+03, 1.63095050D+03,
     $ 1.60674140D+03, 1.58261660D+03, 1.55857600D+03, 1.53461930D+03/
      data ( FDNF( 32,J,1),J=1,20) /
     $ 5.249D-06, 1.035D-05, 1.529D-05, 2.009D-05, 2.474D-05, 2.923D-05,
     $ 3.357D-05, 3.775D-05, 4.180D-05, 4.571D-05, 4.946D-05, 5.306D-05,
     $ 5.652D-05, 5.985D-05, 6.300D-05, 6.603D-05, 6.889D-05, 7.158D-05,
     $ 7.414D-05, 7.649D-05/
      data (WNUPF( 32,J,2),J=1,20) /
     $ 2.19569090D+03, 2.16933030D+03, 2.14303130D+03, 2.11679540D+03,
     $ 2.09062440D+03, 2.06451980D+03, 2.03848310D+03, 2.01251610D+03,
     $ 1.98662000D+03, 1.96079650D+03, 1.93504680D+03, 1.90937210D+03,
     $ 1.88377370D+03, 1.85825240D+03, 1.83280900D+03, 1.80744420D+03,
     $ 1.78215830D+03, 1.75695160D+03, 1.73182400D+03, 1.70677510D+03/
      data ( FUPF( 32,J,2),J=1,20) /
     $ 5.865D-06, 1.153D-05, 1.702D-05, 2.229D-05, 2.737D-05, 3.225D-05,
     $ 3.694D-05, 4.144D-05, 4.576D-05, 4.989D-05, 5.384D-05, 5.760D-05,
     $ 6.119D-05, 6.460D-05, 6.781D-05, 7.084D-05, 7.370D-05, 7.635D-05,
     $ 7.883D-05, 8.110D-05/
      data (WNDNF( 32,J,2),J=1,20) /
     $ 1.96294160D+03, 1.93867480D+03, 1.91446940D+03, 1.89032710D+03,
     $ 1.86624950D+03, 1.84223820D+03, 1.81829480D+03, 1.79442070D+03,
     $ 1.77061740D+03, 1.74688640D+03, 1.72322900D+03, 1.69964630D+03,
     $ 1.67613950D+03, 1.65270950D+03, 1.62935710D+03, 1.60608300D+03,
     $ 1.58288760D+03, 1.55977110D+03, 1.53673340D+03, 1.51377420D+03/
      data ( FDNF( 32,J,2),J=1,20) /
     $ 5.028D-06, 9.914D-06, 1.465D-05, 1.926D-05, 2.372D-05, 2.803D-05,
     $ 3.222D-05, 3.625D-05, 4.014D-05, 4.391D-05, 4.752D-05, 5.102D-05,
     $ 5.437D-05, 5.758D-05, 6.065D-05, 6.358D-05, 6.638D-05, 6.902D-05,
     $ 7.152D-05, 7.386D-05/
      data (WNUPF( 33,J,1),J=1,20) /
     $ 2.24964170D+03, 2.22200760D+03, 2.19443950D+03, 2.16693910D+03,
     $ 2.13950820D+03, 2.11214860D+03, 2.08486200D+03, 2.05765010D+03,
     $ 2.03051450D+03, 2.00345690D+03, 1.97647850D+03, 1.94958080D+03,
     $ 1.92276490D+03, 1.89603190D+03, 1.86938240D+03, 1.84281720D+03,
     $ 1.81633660D+03, 1.78994050D+03, 1.76362890D+03, 1.73740120D+03/
      data ( FUPF( 33,J,1),J=1,20) /
     $ 6.148D-06, 1.208D-05, 1.780D-05, 2.332D-05, 2.862D-05, 3.371D-05,
     $ 3.860D-05, 4.328D-05, 4.777D-05, 5.205D-05, 5.612D-05, 6.002D-05,
     $ 6.371D-05, 6.720D-05, 7.049D-05, 7.360D-05, 7.649D-05, 7.918D-05,
     $ 8.168D-05, 8.394D-05/
      data (WNDNF( 33,J,1),J=1,20) /
     $ 1.99878010D+03, 1.97345630D+03, 1.94819830D+03, 1.92300800D+03,
     $ 1.89788700D+03, 1.87283720D+03, 1.84786020D+03, 1.82295770D+03,
     $ 1.79813130D+03, 1.77338260D+03, 1.74871280D+03, 1.72412340D+03,
     $ 1.69961550D+03, 1.67519000D+03, 1.65084790D+03, 1.62658960D+03,
     $ 1.60241550D+03, 1.57832590D+03, 1.55432040D+03, 1.53039870D+03/
      data ( FDNF( 33,J,1),J=1,20) /
     $ 5.240D-06, 1.033D-05, 1.527D-05, 2.006D-05, 2.469D-05, 2.918D-05,
     $ 3.351D-05, 3.770D-05, 4.175D-05, 4.564D-05, 4.939D-05, 5.300D-05,
     $ 5.645D-05, 5.976D-05, 6.293D-05, 6.594D-05, 6.881D-05, 7.149D-05,
     $ 7.406D-05, 7.642D-05/
      data (WNUPF( 33,J,2),J=1,20) /
     $ 2.19821650D+03, 2.17182320D+03, 2.14549150D+03, 2.11922300D+03,
     $ 2.09301930D+03, 2.06688200D+03, 2.04081280D+03, 2.01481310D+03,
     $ 1.98888450D+03, 1.96302830D+03, 1.93724610D+03, 1.91153890D+03,
     $ 1.88590780D+03, 1.86035400D+03, 1.83487810D+03, 1.80948070D+03,
     $ 1.78416230D+03, 1.75892300D+03, 1.73376280D+03, 1.70868120D+03/
      data ( FUPF( 33,J,2),J=1,20) /
     $ 5.872D-06, 1.155D-05, 1.703D-05, 2.231D-05, 2.738D-05, 3.228D-05,
     $ 3.697D-05, 4.148D-05, 4.580D-05, 4.992D-05, 5.388D-05, 5.763D-05,
     $ 6.122D-05, 6.462D-05, 6.783D-05, 7.086D-05, 7.371D-05, 7.635D-05,
     $ 7.882D-05, 8.109D-05/
      data (WNDNF( 33,J,2),J=1,20) /
     $ 1.95828950D+03, 1.93405550D+03, 1.90988280D+03, 1.88577330D+03,
     $ 1.86172850D+03, 1.83775000D+03, 1.81383930D+03, 1.78999810D+03,
     $ 1.76622760D+03, 1.74252950D+03, 1.71890490D+03, 1.69535500D+03,
     $ 1.67188110D+03, 1.64848400D+03, 1.62516450D+03, 1.60192330D+03,
     $ 1.57876070D+03, 1.55567700D+03, 1.53267210D+03, 1.50974570D+03/
      data ( FDNF( 33,J,2),J=1,20) /
     $ 5.019D-06, 9.897D-06, 1.463D-05, 1.922D-05, 2.369D-05, 2.799D-05,
     $ 3.216D-05, 3.619D-05, 4.009D-05, 4.385D-05, 4.746D-05, 5.096D-05,
     $ 5.430D-05, 5.751D-05, 6.058D-05, 6.351D-05, 6.630D-05, 6.894D-05,
     $ 7.145D-05, 7.379D-05/
      data (WNUPF( 34,J,1),J=1,20) /
     $ 2.25221440D+03, 2.22454540D+03, 2.19694230D+03, 2.16940690D+03,
     $ 2.14194110D+03, 2.11454650D+03, 2.08722500D+03, 2.05997820D+03,
     $ 2.03280780D+03, 2.00571520D+03, 1.97870200D+03, 1.95176950D+03,
     $ 1.92491880D+03, 1.89815090D+03, 1.87146660D+03, 1.84486660D+03,
     $ 1.81835110D+03, 1.79192020D+03, 1.76557360D+03, 1.73931100D+03/
      data ( FUPF( 34,J,1),J=1,20) /
     $ 6.155D-06, 1.210D-05, 1.782D-05, 2.334D-05, 2.864D-05, 3.375D-05,
     $ 3.863D-05, 4.331D-05, 4.779D-05, 5.207D-05, 5.616D-05, 6.004D-05,
     $ 6.373D-05, 6.722D-05, 7.051D-05, 7.361D-05, 7.651D-05, 7.918D-05,
     $ 8.167D-05, 8.393D-05/
      data (WNDNF( 34,J,1),J=1,20) /
     $ 1.99386220D+03, 1.96857340D+03, 1.94335040D+03, 1.91819510D+03,
     $ 1.89310920D+03, 1.86809450D+03, 1.84315260D+03, 1.81828530D+03,
     $ 1.79349400D+03, 1.76878040D+03, 1.74414590D+03, 1.71959160D+03,
     $ 1.69511890D+03, 1.67072860D+03, 1.64642160D+03, 1.62219840D+03,
     $ 1.59805960D+03, 1.57400500D+03, 1.55003460D+03, 1.52614800D+03/
      data ( FDNF( 34,J,1),J=1,20) /
     $ 5.232D-06, 1.031D-05, 1.525D-05, 2.003D-05, 2.465D-05, 2.913D-05,
     $ 3.346D-05, 3.764D-05, 4.168D-05, 4.558D-05, 4.932D-05, 5.291D-05,
     $ 5.638D-05, 5.968D-05, 6.284D-05, 6.587D-05, 6.872D-05, 7.141D-05,
     $ 7.397D-05, 7.633D-05/
      data (WNUPF( 34,J,2),J=1,20) /
     $ 2.20070500D+03, 2.17427910D+03, 2.14791470D+03, 2.12161350D+03,
     $ 2.09537710D+03, 2.06920720D+03, 2.04310530D+03, 2.01707300D+03,
     $ 1.99111180D+03, 1.96522310D+03, 1.93940820D+03, 1.91366840D+03,
     $ 1.88800490D+03, 1.86241840D+03, 1.83691000D+03, 1.81148010D+03,
     $ 1.78612910D+03, 1.76085720D+03, 1.73566440D+03, 1.71055020D+03/
      data ( FUPF( 34,J,2),J=1,20) /
     $ 5.879D-06, 1.156D-05, 1.706D-05, 2.233D-05, 2.742D-05, 3.230D-05,
     $ 3.700D-05, 4.151D-05, 4.582D-05, 4.996D-05, 5.391D-05, 5.767D-05,
     $ 6.124D-05, 6.464D-05, 6.785D-05, 7.088D-05, 7.372D-05, 7.636D-05,
     $ 7.882D-05, 8.107D-05/
      data (WNDNF( 34,J,2),J=1,20) /
     $ 1.95360910D+03, 1.92940780D+03, 1.90526790D+03, 1.88119120D+03,
     $ 1.85717910D+03, 1.83323340D+03, 1.80935560D+03, 1.78554710D+03,
     $ 1.76180950D+03, 1.73814420D+03, 1.71455250D+03, 1.69103550D+03,
     $ 1.66759450D+03, 1.64423020D+03, 1.62094360D+03, 1.59773520D+03,
     $ 1.57460550D+03, 1.55155460D+03, 1.52858250D+03, 1.50568890D+03/
      data ( FDNF( 34,J,2),J=1,20) /
     $ 5.010D-06, 9.881D-06, 1.459D-05, 1.920D-05, 2.364D-05, 2.794D-05,
     $ 3.212D-05, 3.614D-05, 4.003D-05, 4.378D-05, 4.741D-05, 5.088D-05,
     $ 5.423D-05, 5.743D-05, 6.051D-05, 6.343D-05, 6.622D-05, 6.887D-05,
     $ 7.136D-05, 7.371D-05/
      data (WNUPF( 35,J,1),J=1,20) /
     $ 2.25474720D+03, 2.22704310D+03, 2.19940510D+03, 2.17183470D+03,
     $ 2.14433400D+03, 2.11690450D+03, 2.08954800D+03, 2.06226630D+03,
     $ 2.03506100D+03, 2.00793360D+03, 1.98088560D+03, 1.95391820D+03,
     $ 1.92703260D+03, 1.90022990D+03, 1.87351080D+03, 1.84687590D+03,
     $ 1.82032560D+03, 1.79385980D+03, 1.76747830D+03, 1.74118070D+03/
      data ( FUPF( 35,J,1),J=1,20) /
     $ 6.164D-06, 1.211D-05, 1.784D-05, 2.336D-05, 2.868D-05, 3.377D-05,
     $ 3.867D-05, 4.335D-05, 4.783D-05, 5.212D-05, 5.619D-05, 6.007D-05,
     $ 6.375D-05, 6.725D-05, 7.052D-05, 7.362D-05, 7.651D-05, 7.917D-05,
     $ 8.167D-05, 8.390D-05/
      data (WNDNF( 35,J,1),J=1,20) /
     $ 1.98891420D+03, 1.96366040D+03, 1.93847250D+03, 1.91335230D+03,
     $ 1.88830150D+03, 1.86332180D+03, 1.83841500D+03, 1.81358280D+03,
     $ 1.78882670D+03, 1.76414820D+03, 1.73954880D+03, 1.71502980D+03,
     $ 1.69059220D+03, 1.66623710D+03, 1.64196530D+03, 1.61777730D+03,
     $ 1.59367360D+03, 1.56965420D+03, 1.54571890D+03, 1.52186730D+03/
      data ( FDNF( 35,J,1),J=1,20) /
     $ 5.223D-06, 1.030D-05, 1.521D-05, 1.999D-05, 2.461D-05, 2.908D-05,
     $ 3.341D-05, 3.759D-05, 4.162D-05, 4.551D-05, 4.924D-05, 5.285D-05,
     $ 5.630D-05, 5.961D-05, 6.276D-05, 6.577D-05, 6.863D-05, 7.132D-05,
     $ 7.389D-05, 7.624D-05/
      data (WNUPF( 35,J,2),J=1,20) /
     $ 2.20315620D+03, 2.17669760D+03, 2.15030050D+03, 2.12396670D+03,
     $ 2.09769770D+03, 2.07149510D+03, 2.04536060D+03, 2.01929560D+03,
     $ 1.99330180D+03, 1.96738050D+03, 1.94153310D+03, 1.91576070D+03,
     $ 1.89006460D+03, 1.86444560D+03, 1.83890460D+03, 1.81344220D+03,
     $ 1.78805860D+03, 1.76275420D+03, 1.73752870D+03, 1.71238180D+03/
      data ( FUPF( 35,J,2),J=1,20) /
     $ 5.887D-06, 1.157D-05, 1.707D-05, 2.235D-05, 2.743D-05, 3.233D-05,
     $ 3.703D-05, 4.154D-05, 4.586D-05, 4.999D-05, 5.393D-05, 5.770D-05,
     $ 6.128D-05, 6.467D-05, 6.787D-05, 7.088D-05, 7.372D-05, 7.636D-05,
     $ 7.881D-05, 8.107D-05/
      data (WNDNF( 35,J,2),J=1,20) /
     $ 1.94890060D+03, 1.92473200D+03, 1.90062490D+03, 1.87658090D+03,
     $ 1.85260160D+03, 1.82868870D+03, 1.80484360D+03, 1.78106800D+03,
     $ 1.75736330D+03, 1.73373080D+03, 1.71017190D+03, 1.68668780D+03,
     $ 1.66327960D+03, 1.63994830D+03, 1.61669460D+03, 1.59351900D+03,
     $ 1.57042220D+03, 1.54740410D+03, 1.52446480D+03, 1.50160400D+03/
      data ( FDNF( 35,J,2),J=1,20) /
     $ 5.003D-06, 9.865D-06, 1.458D-05, 1.917D-05, 2.361D-05, 2.790D-05,
     $ 3.206D-05, 3.608D-05, 3.997D-05, 4.372D-05, 4.734D-05, 5.082D-05,
     $ 5.415D-05, 5.737D-05, 6.042D-05, 6.335D-05, 6.614D-05, 6.879D-05,
     $ 7.128D-05, 7.362D-05/
      data (WNUPF( 36,J,1),J=1,20) /
     $ 2.25723980D+03, 2.22950080D+03, 2.20182770D+03, 2.17422250D+03,
     $ 2.14668670D+03, 2.11922230D+03, 2.09183090D+03, 2.06451440D+03,
     $ 2.03727410D+03, 2.01011190D+03, 1.98302900D+03, 1.95602670D+03,
     $ 1.92910630D+03, 1.90226880D+03, 1.87551490D+03, 1.84884510D+03,
     $ 1.82225990D+03, 1.79575920D+03, 1.76934280D+03, 1.74301020D+03/
      data ( FUPF( 36,J,1),J=1,20) /
     $ 6.172D-06, 1.213D-05, 1.786D-05, 2.339D-05, 2.870D-05, 3.380D-05,
     $ 3.869D-05, 4.338D-05, 4.786D-05, 5.214D-05, 5.623D-05, 6.010D-05,
     $ 6.379D-05, 6.727D-05, 7.054D-05, 7.363D-05, 7.652D-05, 7.917D-05,
     $ 8.166D-05, 8.389D-05/
      data (WNDNF( 36,J,1),J=1,20) /
     $ 1.98393630D+03, 1.95871750D+03, 1.93356470D+03, 1.90847950D+03,
     $ 1.88346380D+03, 1.85851920D+03, 1.83364760D+03, 1.80885040D+03,
     $ 1.78412950D+03, 1.75948620D+03, 1.73492190D+03, 1.71043810D+03,
     $ 1.68603570D+03, 1.66171580D+03, 1.63747910D+03, 1.61332630D+03,
     $ 1.58925780D+03, 1.56527350D+03, 1.54137330D+03, 1.51755670D+03/
      data ( FDNF( 36,J,1),J=1,20) /
     $ 5.214D-06, 1.028D-05, 1.519D-05, 1.996D-05, 2.458D-05, 2.904D-05,
     $ 3.336D-05, 3.752D-05, 4.155D-05, 4.544D-05, 4.918D-05, 5.277D-05,
     $ 5.622D-05, 5.952D-05, 6.267D-05, 6.570D-05, 6.855D-05, 7.123D-05,
     $ 7.379D-05, 7.615D-05/
      data (WNUPF( 36,J,2),J=1,20) /
     $ 2.20557010D+03, 2.17907880D+03, 2.15264900D+03, 2.12628250D+03,
     $ 2.09998080D+03, 2.07374560D+03, 2.04757840D+03, 2.02148090D+03,
     $ 1.99545440D+03, 1.96950050D+03, 1.94362050D+03, 1.91781560D+03,
     $ 1.89208690D+03, 1.86643540D+03, 1.84086190D+03, 1.81536680D+03,
     $ 1.78995070D+03, 1.76461370D+03, 1.73935560D+03, 1.71417600D+03/
      data ( FUPF( 36,J,2),J=1,20) /
     $ 5.893D-06, 1.159D-05, 1.708D-05, 2.237D-05, 2.746D-05, 3.237D-05,
     $ 3.706D-05, 4.156D-05, 4.589D-05, 5.001D-05, 5.396D-05, 5.772D-05,
     $ 6.130D-05, 6.469D-05, 6.789D-05, 7.090D-05, 7.373D-05, 7.637D-05,
     $ 7.882D-05, 8.106D-05/
      data (WNDNF( 36,J,2),J=1,20) /
     $ 1.94416400D+03, 1.92002810D+03, 1.89595380D+03, 1.87194250D+03,
     $ 1.84799600D+03, 1.82411590D+03, 1.80030370D+03, 1.77656090D+03,
     $ 1.75288890D+03, 1.72928930D+03, 1.70576330D+03, 1.68231210D+03,
     $ 1.65893680D+03, 1.63563830D+03, 1.61241750D+03, 1.58927490D+03,
     $ 1.56621080D+03, 1.54322560D+03, 1.52031910D+03, 1.49749110D+03/
      data ( FDNF( 36,J,2),J=1,20) /
     $ 4.993D-06, 9.848D-06, 1.455D-05, 1.914D-05, 2.356D-05, 2.786D-05,
     $ 3.201D-05, 3.603D-05, 3.990D-05, 4.366D-05, 4.726D-05, 5.074D-05,
     $ 5.408D-05, 5.729D-05, 6.034D-05, 6.327D-05, 6.607D-05, 6.870D-05,
     $ 7.121D-05, 7.353D-05/
      data (WNUPF( 37,J,1),J=1,20) /
     $ 2.25969210D+03, 2.23191820D+03, 2.20421010D+03, 2.17656990D+03,
     $ 2.14899920D+03, 2.12149980D+03, 2.09407360D+03, 2.06672210D+03,
     $ 2.03944700D+03, 2.01224980D+03, 1.98513210D+03, 1.95809500D+03,
     $ 1.93113980D+03, 1.90426740D+03, 1.87747860D+03, 1.85077400D+03,
     $ 1.82415390D+03, 1.79761830D+03, 1.77116700D+03, 1.74479940D+03/
      data ( FUPF( 37,J,1),J=1,20) /
     $ 6.179D-06, 1.214D-05, 1.789D-05, 2.341D-05, 2.873D-05, 3.384D-05,
     $ 3.873D-05, 4.341D-05, 4.789D-05, 5.218D-05, 5.625D-05, 6.014D-05,
     $ 6.381D-05, 6.729D-05, 7.056D-05, 7.364D-05, 7.652D-05, 7.918D-05,
     $ 8.166D-05, 8.388D-05/
      data (WNDNF( 37,J,1),J=1,20) /
     $ 1.97892860D+03, 1.95374490D+03, 1.92862710D+03, 1.90357700D+03,
     $ 1.87859630D+03, 1.85368690D+03, 1.82885030D+03, 1.80408830D+03,
     $ 1.77940250D+03, 1.75479440D+03, 1.73026530D+03, 1.70581660D+03,
     $ 1.68144940D+03, 1.65716470D+03, 1.63296330D+03, 1.60884570D+03,
     $ 1.58481220D+03, 1.56086310D+03, 1.53699800D+03, 1.51321650D+03/
      data ( FDNF( 37,J,1),J=1,20) /
     $ 5.204D-06, 1.026D-05, 1.516D-05, 1.992D-05, 2.453D-05, 2.899D-05,
     $ 3.329D-05, 3.747D-05, 4.149D-05, 4.536D-05, 4.909D-05, 5.269D-05,
     $ 5.613D-05, 5.944D-05, 6.259D-05, 6.560D-05, 6.845D-05, 7.115D-05,
     $ 7.371D-05, 7.605D-05/
      data (WNUPF( 37,J,2),J=1,20) /
     $ 2.20794640D+03, 2.18142240D+03, 2.15496000D+03, 2.12856080D+03,
     $ 2.10222640D+03, 2.07595850D+03, 2.04975870D+03, 2.02362860D+03,
     $ 1.99756950D+03, 1.97158300D+03, 1.94567040D+03, 1.91983300D+03,
     $ 1.89407170D+03, 1.86838770D+03, 1.84278150D+03, 1.81725390D+03,
     $ 1.79180530D+03, 1.76643560D+03, 1.74114490D+03, 1.71593270D+03/
      data ( FUPF( 37,J,2),J=1,20) /
     $ 5.901D-06, 1.160D-05, 1.711D-05, 2.240D-05, 2.749D-05, 3.238D-05,
     $ 3.710D-05, 4.160D-05, 4.593D-05, 5.005D-05, 5.400D-05, 5.775D-05,
     $ 6.133D-05, 6.471D-05, 6.790D-05, 7.092D-05, 7.374D-05, 7.637D-05,
     $ 7.881D-05, 8.105D-05/
      data (WNDNF( 37,J,2),J=1,20) /
     $ 1.93939940D+03, 1.91529630D+03, 1.89125470D+03, 1.86727630D+03,
     $ 1.84336260D+03, 1.81951520D+03, 1.79573580D+03, 1.77202580D+03,
     $ 1.74838670D+03, 1.72482000D+03, 1.70132680D+03, 1.67790850D+03,
     $ 1.65456610D+03, 1.63130050D+03, 1.60811250D+03, 1.58500280D+03,
     $ 1.56197160D+03, 1.53901930D+03, 1.51614560D+03, 1.49335030D+03/
      data ( FDNF( 37,J,2),J=1,20) /
     $ 4.985D-06, 9.831D-06, 1.453D-05, 1.911D-05, 2.353D-05, 2.781D-05,
     $ 3.196D-05, 3.597D-05, 3.985D-05, 4.359D-05, 4.719D-05, 5.067D-05,
     $ 5.400D-05, 5.720D-05, 6.027D-05, 6.319D-05, 6.597D-05, 6.861D-05,
     $ 7.111D-05, 7.345D-05/
      data (WNUPF( 38,J,1),J=1,20) /
     $ 2.26210410D+03, 2.23429510D+03, 2.20655210D+03, 2.17887690D+03,
     $ 2.15127130D+03, 2.12373700D+03, 2.09627580D+03, 2.06888940D+03,
     $ 2.04157940D+03, 2.01434730D+03, 1.98719470D+03, 1.96012280D+03,
     $ 1.93313270D+03, 1.90622550D+03, 1.87940190D+03, 1.85266240D+03,
     $ 1.82600750D+03, 1.79943700D+03, 1.77295070D+03, 1.74654800D+03/
      data ( FUPF( 38,J,1),J=1,20) /
     $ 6.187D-06, 1.216D-05, 1.791D-05, 2.344D-05, 2.876D-05, 3.387D-05,
     $ 3.876D-05, 4.345D-05, 4.793D-05, 5.221D-05, 5.628D-05, 6.016D-05,
     $ 6.384D-05, 6.731D-05, 7.057D-05, 7.367D-05, 7.653D-05, 7.917D-05,
     $ 8.165D-05, 8.385D-05/
      data (WNDNF( 38,J,1),J=1,20) /
     $ 1.97389140D+03, 1.94874270D+03, 1.92366000D+03, 1.89864490D+03,
     $ 1.87369930D+03, 1.84882490D+03, 1.82402350D+03, 1.79929660D+03,
     $ 1.77464590D+03, 1.75007300D+03, 1.72557910D+03, 1.70116560D+03,
     $ 1.67683360D+03, 1.65258410D+03, 1.62841780D+03, 1.60433540D+03,
     $ 1.58033710D+03, 1.55642310D+03, 1.53259310D+03, 1.50884660D+03/
      data ( FDNF( 38,J,1),J=1,20) /
     $ 5.195D-06, 1.024D-05, 1.514D-05, 1.988D-05, 2.448D-05, 2.894D-05,
     $ 3.325D-05, 3.740D-05, 4.142D-05, 4.530D-05, 4.903D-05, 5.261D-05,
     $ 5.605D-05, 5.935D-05, 6.249D-05, 6.552D-05, 6.836D-05, 7.105D-05,
     $ 7.361D-05, 7.596D-05/
      data (WNUPF( 38,J,2),J=1,20) /
     $ 2.21028510D+03, 2.18372840D+03, 2.15723330D+03, 2.13080140D+03,
     $ 2.10443440D+03, 2.07813380D+03, 2.05190140D+03, 2.02573860D+03,
     $ 1.99964690D+03, 1.97362790D+03, 1.94768270D+03, 1.92181270D+03,
     $ 1.89601880D+03, 1.87030220D+03, 1.84466350D+03, 1.81910340D+03,
     $ 1.79362210D+03, 1.76821980D+03, 1.74289650D+03, 1.71765160D+03/
      data ( FUPF( 38,J,2),J=1,20) /
     $ 5.908D-06, 1.161D-05, 1.713D-05, 2.241D-05, 2.752D-05, 3.241D-05,
     $ 3.712D-05, 4.164D-05, 4.596D-05, 5.008D-05, 5.403D-05, 5.779D-05,
     $ 6.135D-05, 6.473D-05, 6.792D-05, 7.093D-05, 7.375D-05, 7.637D-05,
     $ 7.881D-05, 8.104D-05/
      data (WNDNF( 38,J,2),J=1,20) /
     $ 1.93460710D+03, 1.91053680D+03, 1.88652790D+03, 1.86258220D+03,
     $ 1.83870130D+03, 1.81488670D+03, 1.79114010D+03, 1.76746300D+03,
     $ 1.74385670D+03, 1.72032280D+03, 1.69686260D+03, 1.67347710D+03,
     $ 1.65016760D+03, 1.62693490D+03, 1.60377980D+03, 1.58070300D+03,
     $ 1.55770470D+03, 1.53478510D+03, 1.51194430D+03, 1.48918180D+03/
      data ( FDNF( 38,J,2),J=1,20) /
     $ 4.977D-06, 9.814D-06, 1.451D-05, 1.906D-05, 2.349D-05, 2.777D-05,
     $ 3.191D-05, 3.591D-05, 3.979D-05, 4.352D-05, 4.712D-05, 5.060D-05,
     $ 5.392D-05, 5.713D-05, 6.018D-05, 6.310D-05, 6.590D-05, 6.853D-05,
     $ 7.103D-05, 7.336D-05/
      data (WNUPF( 39,J,1),J=1,20) /
     $ 2.26447550D+03, 2.23663150D+03, 2.20885360D+03, 2.18114340D+03,
     $ 2.15350280D+03, 2.12593350D+03, 2.09843740D+03, 2.07101610D+03,
     $ 2.04367120D+03, 2.01640430D+03, 1.98921680D+03, 1.96211000D+03,
     $ 1.93508510D+03, 1.90814300D+03, 1.88128460D+03, 1.85451030D+03,
     $ 1.82782040D+03, 1.80121500D+03, 1.77469380D+03, 1.74825610D+03/
      data ( FUPF( 39,J,1),J=1,20) /
     $ 6.195D-06, 1.217D-05, 1.792D-05, 2.347D-05, 2.879D-05, 3.390D-05,
     $ 3.879D-05, 4.348D-05, 4.796D-05, 5.225D-05, 5.631D-05, 6.019D-05,
     $ 6.386D-05, 6.734D-05, 7.060D-05, 7.368D-05, 7.653D-05, 7.917D-05,
     $ 8.164D-05, 8.383D-05/
      data (WNDNF( 39,J,1),J=1,20) /
     $ 1.96882470D+03, 1.94371100D+03, 1.91866330D+03, 1.89368330D+03,
     $ 1.86877280D+03, 1.84393350D+03, 1.81916720D+03, 1.79447540D+03,
     $ 1.76985990D+03, 1.74532210D+03, 1.72086340D+03, 1.69648510D+03,
     $ 1.67218830D+03, 1.64797400D+03, 1.62384290D+03, 1.59979570D+03,
     $ 1.57583260D+03, 1.55195370D+03, 1.52815880D+03, 1.50444740D+03/
      data ( FDNF( 39,J,1),J=1,20) /
     $ 5.185D-06, 1.022D-05, 1.511D-05, 1.985D-05, 2.444D-05, 2.889D-05,
     $ 3.319D-05, 3.734D-05, 4.135D-05, 4.522D-05, 4.895D-05, 5.253D-05,
     $ 5.597D-05, 5.927D-05, 6.241D-05, 6.542D-05, 6.828D-05, 7.095D-05,
     $ 7.352D-05, 7.586D-05/
      data (WNUPF( 39,J,2),J=1,20) /
     $ 2.21258600D+03, 2.18599660D+03, 2.15946880D+03, 2.13300420D+03,
     $ 2.10660450D+03, 2.08027130D+03, 2.05400620D+03, 2.02781080D+03,
     $ 2.00168650D+03, 1.97563490D+03, 1.94965710D+03, 1.92375450D+03,
     $ 1.89792810D+03, 1.87217890D+03, 1.84650770D+03, 1.82091490D+03,
     $ 1.79540110D+03, 1.76996620D+03, 1.74461020D+03, 1.71933260D+03/
      data ( FUPF( 39,J,2),J=1,20) /
     $ 5.916D-06, 1.163D-05, 1.714D-05, 2.244D-05, 2.755D-05, 3.245D-05,
     $ 3.716D-05, 4.166D-05, 4.599D-05, 5.012D-05, 5.405D-05, 5.782D-05,
     $ 6.138D-05, 6.475D-05, 6.795D-05, 7.095D-05, 7.375D-05, 7.638D-05,
     $ 7.881D-05, 8.103D-05/
      data (WNDNF( 39,J,2),J=1,20) /
     $ 1.92978720D+03, 1.90574960D+03, 1.88177350D+03, 1.85786050D+03,
     $ 1.83401240D+03, 1.81023060D+03, 1.78651680D+03, 1.76287250D+03,
     $ 1.73929910D+03, 1.71579800D+03, 1.69237070D+03, 1.66901810D+03,
     $ 1.64574150D+03, 1.62254170D+03, 1.59941950D+03, 1.57637550D+03,
     $ 1.55341010D+03, 1.53052340D+03, 1.50771540D+03, 1.48498570D+03/
      data ( FDNF( 39,J,2),J=1,20) /
     $ 4.967D-06, 9.796D-06, 1.448D-05, 1.904D-05, 2.344D-05, 2.772D-05,
     $ 3.186D-05, 3.586D-05, 3.972D-05, 4.346D-05, 4.705D-05, 5.052D-05,
     $ 5.385D-05, 5.704D-05, 6.010D-05, 6.303D-05, 6.580D-05, 6.844D-05,
     $ 7.094D-05, 7.328D-05/
      data (WNUPF( 40,J,1),J=1,20) /
     $ 2.26680620D+03, 2.23892720D+03, 2.21111430D+03, 2.18336910D+03,
     $ 2.15569360D+03, 2.12808940D+03, 2.10055830D+03, 2.07310210D+03,
     $ 2.04572230D+03, 2.01842050D+03, 1.99119810D+03, 1.96405650D+03,
     $ 1.93699670D+03, 1.91001980D+03, 1.88312650D+03, 1.85631730D+03,
     $ 1.82959260D+03, 1.80295220D+03, 1.77639600D+03, 1.74992330D+03/
      data ( FUPF( 40,J,1),J=1,20) /
     $ 6.203D-06, 1.218D-05, 1.795D-05, 2.349D-05, 2.882D-05, 3.392D-05,
     $ 3.882D-05, 4.352D-05, 4.800D-05, 5.228D-05, 5.634D-05, 6.022D-05,
     $ 6.389D-05, 6.735D-05, 7.061D-05, 7.368D-05, 7.654D-05, 7.916D-05,
     $ 8.163D-05, 8.381D-05/
      data (WNDNF( 40,J,1),J=1,20) /
     $ 1.96372870D+03, 1.93865010D+03, 1.91363740D+03, 1.88869240D+03,
     $ 1.86381690D+03, 1.83901270D+03, 1.81428150D+03, 1.78962490D+03,
     $ 1.76504460D+03, 1.74054190D+03, 1.71611840D+03, 1.69177530D+03,
     $ 1.66751370D+03, 1.64333460D+03, 1.61923870D+03, 1.59522670D+03,
     $ 1.57129880D+03, 1.54745500D+03, 1.52369520D+03, 1.50001890D+03/
      data ( FDNF( 40,J,1),J=1,20) /
     $ 5.175D-06, 1.020D-05, 1.509D-05, 1.981D-05, 2.440D-05, 2.884D-05,
     $ 3.312D-05, 3.727D-05, 4.128D-05, 4.515D-05, 4.886D-05, 5.244D-05,
     $ 5.588D-05, 5.917D-05, 6.231D-05, 6.532D-05, 6.817D-05, 7.085D-05,
     $ 7.342D-05, 7.575D-05/
      data (WNUPF( 40,J,2),J=1,20) /
     $ 2.21484890D+03, 2.18822690D+03, 2.16166640D+03, 2.13516910D+03,
     $ 2.10873670D+03, 2.08237090D+03, 2.05607310D+03, 2.02984510D+03,
     $ 2.00368820D+03, 1.97760390D+03, 1.95159360D+03, 1.92565840D+03,
     $ 1.89979950D+03, 1.87401770D+03, 1.84831390D+03, 1.82268860D+03,
     $ 1.79714210D+03, 1.77167460D+03, 1.74628590D+03, 1.72097560D+03/
      data ( FUPF( 40,J,2),J=1,20) /
     $ 5.923D-06, 1.164D-05, 1.716D-05, 2.247D-05, 2.757D-05, 3.248D-05,
     $ 3.719D-05, 4.170D-05, 4.603D-05, 5.015D-05, 5.409D-05, 5.784D-05,
     $ 6.141D-05, 6.478D-05, 6.796D-05, 7.096D-05, 7.377D-05, 7.638D-05,
     $ 7.880D-05, 8.101D-05/
      data (WNDNF( 40,J,2),J=1,20) /
     $ 1.92493970D+03, 1.90093480D+03, 1.87699150D+03, 1.85311130D+03,
     $ 1.82929590D+03, 1.80554690D+03, 1.78186590D+03, 1.75825450D+03,
     $ 1.73471390D+03, 1.71124570D+03, 1.68785120D+03, 1.66453160D+03,
     $ 1.64128780D+03, 1.61812090D+03, 1.59503170D+03, 1.57202060D+03,
     $ 1.54908800D+03, 1.52623420D+03, 1.50345900D+03, 1.48076200D+03/
      data ( FDNF( 40,J,2),J=1,20) /
     $ 4.958D-06, 9.779D-06, 1.446D-05, 1.900D-05, 2.341D-05, 2.768D-05,
     $ 3.180D-05, 3.579D-05, 3.965D-05, 4.338D-05, 4.698D-05, 5.043D-05,
     $ 5.377D-05, 5.696D-05, 6.001D-05, 6.294D-05, 6.572D-05, 6.835D-05,
     $ 7.084D-05, 7.319D-05/
      data (WNUPF( 41,J,1),J=1,20) /
     $ 2.26909600D+03, 2.24118210D+03, 2.21333420D+03, 2.18555400D+03,
     $ 2.15784350D+03, 2.13020430D+03, 2.10263830D+03, 2.07514720D+03,
     $ 2.04773250D+03, 2.02039580D+03, 1.99313860D+03, 1.96596210D+03,
     $ 1.93886750D+03, 1.91185570D+03, 1.88492750D+03, 1.85808350D+03,
     $ 1.83132380D+03, 1.80464850D+03, 1.77805730D+03, 1.75154960D+03/
      data ( FUPF( 41,J,1),J=1,20) /
     $ 6.211D-06, 1.220D-05, 1.796D-05, 2.352D-05, 2.885D-05, 3.396D-05,
     $ 3.886D-05, 4.354D-05, 4.804D-05, 5.231D-05, 5.638D-05, 6.025D-05,
     $ 6.391D-05, 6.738D-05, 7.063D-05, 7.370D-05, 7.654D-05, 7.916D-05,
     $ 8.162D-05, 8.379D-05/
      data (WNDNF( 41,J,1),J=1,20) /
     $ 1.95860350D+03, 1.93355990D+03, 1.90858220D+03, 1.88367230D+03,
     $ 1.85883190D+03, 1.83406280D+03, 1.80936670D+03, 1.78474520D+03,
     $ 1.76020000D+03, 1.73573260D+03, 1.71134420D+03, 1.68703630D+03,
     $ 1.66280990D+03, 1.63866600D+03, 1.61460540D+03, 1.59062850D+03,
     $ 1.56673580D+03, 1.54292720D+03, 1.51920250D+03, 1.49556120D+03/
      data ( FDNF( 41,J,1),J=1,20) /
     $ 5.166D-06, 1.018D-05, 1.506D-05, 1.978D-05, 2.436D-05, 2.878D-05,
     $ 3.307D-05, 3.722D-05, 4.122D-05, 4.507D-05, 4.878D-05, 5.236D-05,
     $ 5.580D-05, 5.908D-05, 6.222D-05, 6.523D-05, 6.808D-05, 7.075D-05,
     $ 7.331D-05, 7.565D-05/
      data (WNUPF( 41,J,2),J=1,20) /
     $ 2.21707390D+03, 2.19041910D+03, 2.16382590D+03, 2.13729600D+03,
     $ 2.11083090D+03, 2.08443240D+03, 2.05810200D+03, 2.03184130D+03,
     $ 2.00565180D+03, 1.97953490D+03, 1.95349200D+03, 1.92752420D+03,
     $ 1.90163270D+03, 1.87581840D+03, 1.85008200D+03, 1.82442410D+03,
     $ 1.79884500D+03, 1.77334490D+03, 1.74792350D+03, 1.72258050D+03/
      data ( FUPF( 41,J,2),J=1,20) /
     $ 5.931D-06, 1.166D-05, 1.719D-05, 2.249D-05, 2.760D-05, 3.251D-05,
     $ 3.722D-05, 4.173D-05, 4.606D-05, 5.019D-05, 5.412D-05, 5.788D-05,
     $ 6.143D-05, 6.480D-05, 6.799D-05, 7.098D-05, 7.378D-05, 7.638D-05,
     $ 7.879D-05, 8.100D-05/
      data (WNDNF( 41,J,2),J=1,20) /
     $ 1.92006490D+03, 1.89609270D+03, 1.87218210D+03, 1.84833470D+03,
     $ 1.82455210D+03, 1.80083590D+03, 1.77718770D+03, 1.75360900D+03,
     $ 1.73010140D+03, 1.70666610D+03, 1.68330440D+03, 1.66001770D+03,
     $ 1.63680680D+03, 1.61367280D+03, 1.59061650D+03, 1.56763830D+03,
     $ 1.54473860D+03, 1.52191760D+03, 1.49917520D+03, 1.47651110D+03/
      data ( FDNF( 41,J,2),J=1,20) /
     $ 4.949D-06, 9.761D-06, 1.442D-05, 1.896D-05, 2.336D-05, 2.763D-05,
     $ 3.175D-05, 3.573D-05, 3.959D-05, 4.331D-05, 4.690D-05, 5.036D-05,
     $ 5.369D-05, 5.687D-05, 5.993D-05, 6.284D-05, 6.563D-05, 6.825D-05,
     $ 7.075D-05, 7.308D-05/
      data (WNUPF( 42,J,1),J=1,20) /
     $ 2.27134490D+03, 2.24339600D+03, 2.21551310D+03, 2.18769790D+03,
     $ 2.15995240D+03, 2.13227830D+03, 2.10467740D+03, 2.07715130D+03,
     $ 2.04970170D+03, 2.02233010D+03, 1.99503800D+03, 1.96782670D+03,
     $ 1.94069720D+03, 1.91365050D+03, 1.88668750D+03, 1.85980860D+03,
     $ 1.83301400D+03, 1.80630380D+03, 1.77967750D+03, 1.75313470D+03/
      data ( FUPF( 42,J,1),J=1,20) /
     $ 6.219D-06, 1.222D-05, 1.799D-05, 2.354D-05, 2.888D-05, 3.399D-05,
     $ 3.889D-05, 4.358D-05, 4.807D-05, 5.234D-05, 5.641D-05, 6.028D-05,
     $ 6.394D-05, 6.740D-05, 7.064D-05, 7.371D-05, 7.655D-05, 7.916D-05,
     $ 8.161D-05, 8.377D-05/
      data (WNDNF( 42,J,1),J=1,20) /
     $ 1.95344930D+03, 1.92844070D+03, 1.90349810D+03, 1.87862320D+03,
     $ 1.85381790D+03, 1.82908380D+03, 1.80442280D+03, 1.77983650D+03,
     $ 1.75532640D+03, 1.73089420D+03, 1.70654100D+03, 1.68226830D+03,
     $ 1.65807710D+03, 1.63396850D+03, 1.60994300D+03, 1.58600140D+03,
     $ 1.56214380D+03, 1.53837030D+03, 1.51468080D+03, 1.49107450D+03/
      data ( FDNF( 42,J,1),J=1,20) /
     $ 5.156D-06, 1.016D-05, 1.502D-05, 1.974D-05, 2.431D-05, 2.873D-05,
     $ 3.301D-05, 3.715D-05, 4.114D-05, 4.500D-05, 4.871D-05, 5.227D-05,
     $ 5.571D-05, 5.899D-05, 6.213D-05, 6.513D-05, 6.798D-05, 7.065D-05,
     $ 7.321D-05, 7.555D-05/
      data (WNUPF( 42,J,2),J=1,20) /
     $ 2.21926060D+03, 2.19257310D+03, 2.16594720D+03, 2.13938460D+03,
     $ 2.11288690D+03, 2.08645570D+03, 2.06009260D+03, 2.03379930D+03,
     $ 2.00757720D+03, 1.98142770D+03, 1.95535210D+03, 1.92935180D+03,
     $ 1.90342770D+03, 1.87758080D+03, 1.85181180D+03, 1.82612130D+03,
     $ 1.80050970D+03, 1.77497690D+03, 1.74952280D+03, 1.72414710D+03/
      data ( FUPF( 42,J,2),J=1,20) /
     $ 5.939D-06, 1.167D-05, 1.720D-05, 2.252D-05, 2.763D-05, 3.254D-05,
     $ 3.725D-05, 4.177D-05, 4.608D-05, 5.022D-05, 5.416D-05, 5.790D-05,
     $ 6.146D-05, 6.482D-05, 6.800D-05, 7.099D-05, 7.378D-05, 7.639D-05,
     $ 7.880D-05, 8.099D-05/
      data (WNDNF( 42,J,2),J=1,20) /
     $ 1.91516280D+03, 1.89122330D+03, 1.86734550D+03, 1.84353080D+03,
     $ 1.81978100D+03, 1.79609760D+03, 1.77248220D+03, 1.74893640D+03,
     $ 1.72546160D+03, 1.70205910D+03, 1.67873040D+03, 1.65547650D+03,
     $ 1.63229860D+03, 1.60919750D+03, 1.58617400D+03, 1.56322870D+03,
     $ 1.54036190D+03, 1.51757380D+03, 1.49486430D+03, 1.47223290D+03/
      data ( FDNF( 42,J,2),J=1,20) /
     $ 4.940D-06, 9.744D-06, 1.440D-05, 1.893D-05, 2.333D-05, 2.758D-05,
     $ 3.169D-05, 3.567D-05, 3.953D-05, 4.325D-05, 4.682D-05, 5.028D-05,
     $ 5.360D-05, 5.679D-05, 5.984D-05, 6.275D-05, 6.553D-05, 6.816D-05,
     $ 7.065D-05, 7.299D-05/
      data (WNUPF( 43,J,1),J=1,20) /
     $ 2.27355270D+03, 2.24556880D+03, 2.21765080D+03, 2.18980070D+03,
     $ 2.16202020D+03, 2.13431110D+03, 2.10667520D+03, 2.07911420D+03,
     $ 2.05162970D+03, 2.02422320D+03, 1.99689630D+03, 1.96965000D+03,
     $ 1.94248570D+03, 1.91540420D+03, 1.88840630D+03, 1.86149240D+03,
     $ 1.83466290D+03, 1.80791770D+03, 1.78125650D+03, 1.75467860D+03/
      data ( FUPF( 43,J,1),J=1,20) /
     $ 6.227D-06, 1.224D-05, 1.801D-05, 2.356D-05, 2.891D-05, 3.402D-05,
     $ 3.893D-05, 4.361D-05, 4.811D-05, 5.238D-05, 5.644D-05, 6.031D-05,
     $ 6.396D-05, 6.742D-05, 7.066D-05, 7.372D-05, 7.655D-05, 7.915D-05,
     $ 8.160D-05, 8.375D-05/
      data (WNDNF( 43,J,1),J=1,20) /
     $ 1.94826620D+03, 1.92329260D+03, 1.89838500D+03, 1.87354520D+03,
     $ 1.84877490D+03, 1.82407600D+03, 1.79945010D+03, 1.77489890D+03,
     $ 1.75042400D+03, 1.72602690D+03, 1.70170890D+03, 1.67747140D+03,
     $ 1.65331550D+03, 1.62924200D+03, 1.60525180D+03, 1.58134530D+03,
     $ 1.55752290D+03, 1.53378460D+03, 1.51013010D+03, 1.48655890D+03/
      data ( FDNF( 43,J,1),J=1,20) /
     $ 5.146D-06, 1.015D-05, 1.500D-05, 1.970D-05, 2.426D-05, 2.868D-05,
     $ 3.295D-05, 3.708D-05, 4.107D-05, 4.492D-05, 4.862D-05, 5.220D-05,
     $ 5.562D-05, 5.890D-05, 6.202D-05, 6.503D-05, 6.787D-05, 7.055D-05,
     $ 7.310D-05, 7.544D-05/
      data (WNUPF( 43,J,2),J=1,20) /
     $ 2.22140900D+03, 2.19468890D+03, 2.16803030D+03, 2.14143490D+03,
     $ 2.11490450D+03, 2.08844060D+03, 2.06204490D+03, 2.03571890D+03,
     $ 2.00946420D+03, 1.98328210D+03, 1.95717390D+03, 1.93114100D+03,
     $ 1.90518430D+03, 1.87930480D+03, 1.85350330D+03, 1.82778020D+03,
     $ 1.80213590D+03, 1.77657050D+03, 1.75108380D+03, 1.72567520D+03/
      data ( FUPF( 43,J,2),J=1,20) /
     $ 5.946D-06, 1.168D-05, 1.722D-05, 2.254D-05, 2.766D-05, 3.256D-05,
     $ 3.728D-05, 4.180D-05, 4.612D-05, 5.025D-05, 5.418D-05, 5.793D-05,
     $ 6.148D-05, 6.485D-05, 6.802D-05, 7.100D-05, 7.379D-05, 7.639D-05,
     $ 7.879D-05, 8.098D-05/
      data (WNDNF( 43,J,2),J=1,20) /
     $ 1.91023350D+03, 1.88632690D+03, 1.86248170D+03, 1.83869980D+03,
     $ 1.81498280D+03, 1.79133220D+03, 1.76774960D+03, 1.74423660D+03,
     $ 1.72079460D+03, 1.69742500D+03, 1.67412920D+03, 1.65090820D+03,
     $ 1.62776320D+03, 1.60469500D+03, 1.58170450D+03, 1.55879210D+03,
     $ 1.53595820D+03, 1.51320290D+03, 1.49052620D+03, 1.46792760D+03/
      data ( FDNF( 43,J,2),J=1,20) /
     $ 4.931D-06, 9.725D-06, 1.437D-05, 1.890D-05, 2.329D-05, 2.753D-05,
     $ 3.164D-05, 3.561D-05, 3.946D-05, 4.317D-05, 4.675D-05, 5.020D-05,
     $ 5.352D-05, 5.670D-05, 5.975D-05, 6.266D-05, 6.544D-05, 6.807D-05,
     $ 7.055D-05, 7.289D-05/
      data (WNUPF( 44,J,1),J=1,20) /
     $ 2.27571920D+03, 2.24770020D+03, 2.21974730D+03, 2.19186220D+03,
     $ 2.16404670D+03, 2.13630260D+03, 2.10863180D+03, 2.08103580D+03,
     $ 2.05351640D+03, 2.02607500D+03, 1.99871320D+03, 1.97143210D+03,
     $ 1.94423280D+03, 1.91711650D+03, 1.89008370D+03, 1.86313490D+03,
     $ 1.83627050D+03, 1.80949030D+03, 1.78279410D+03, 1.75618100D+03/
      data ( FUPF( 44,J,1),J=1,20) /
     $ 6.236D-06, 1.224D-05, 1.803D-05, 2.360D-05, 2.893D-05, 3.406D-05,
     $ 3.895D-05, 4.366D-05, 4.814D-05, 5.241D-05, 5.647D-05, 6.033D-05,
     $ 6.399D-05, 6.744D-05, 7.068D-05, 7.372D-05, 7.656D-05, 7.915D-05,
     $ 8.159D-05, 8.372D-05/
      data (WNDNF( 44,J,1),J=1,20) /
     $ 1.94305430D+03, 1.91811580D+03, 1.89324320D+03, 1.86843840D+03,
     $ 1.84370320D+03, 1.81903930D+03, 1.79444860D+03, 1.76993250D+03,
     $ 1.74549280D+03, 1.72113080D+03, 1.69684810D+03, 1.67264580D+03,
     $ 1.64852500D+03, 1.62448680D+03, 1.60053180D+03, 1.57666050D+03,
     $ 1.55287330D+03, 1.52917020D+03, 1.50555080D+03, 1.48201470D+03/
      data ( FDNF( 44,J,1),J=1,20) /
     $ 5.136D-06, 1.013D-05, 1.497D-05, 1.967D-05, 2.422D-05, 2.863D-05,
     $ 3.290D-05, 3.701D-05, 4.100D-05, 4.484D-05, 4.854D-05, 5.210D-05,
     $ 5.553D-05, 5.881D-05, 6.193D-05, 6.493D-05, 6.778D-05, 7.044D-05,
     $ 7.300D-05, 7.533D-05/
      data (WNUPF( 44,J,2),J=1,20) /
     $ 2.22351900D+03, 2.19676610D+03, 2.17007480D+03, 2.14344680D+03,
     $ 2.11688370D+03, 2.09038710D+03, 2.06395870D+03, 2.03760010D+03,
     $ 2.01131270D+03, 1.98509800D+03, 1.95895730D+03, 1.93289170D+03,
     $ 1.90690250D+03, 1.88099040D+03, 1.85515620D+03, 1.82940050D+03,
     $ 1.80372360D+03, 1.77812550D+03, 1.75260610D+03, 1.72716480D+03/
      data ( FUPF( 44,J,2),J=1,20) /
     $ 5.954D-06, 1.170D-05, 1.724D-05, 2.256D-05, 2.768D-05, 3.260D-05,
     $ 3.731D-05, 4.183D-05, 4.616D-05, 5.028D-05, 5.422D-05, 5.795D-05,
     $ 6.151D-05, 6.487D-05, 6.803D-05, 7.101D-05, 7.379D-05, 7.639D-05,
     $ 7.878D-05, 8.097D-05/
      data (WNDNF( 44,J,2),J=1,20) /
     $ 1.90527730D+03, 1.88140340D+03, 1.85759100D+03, 1.83384180D+03,
     $ 1.81015750D+03, 1.78653970D+03, 1.76299000D+03, 1.73950980D+03,
     $ 1.71610070D+03, 1.69276400D+03, 1.66950100D+03, 1.64631290D+03,
     $ 1.62320080D+03, 1.60016560D+03, 1.57720790D+03, 1.55432840D+03,
     $ 1.53152740D+03, 1.50880500D+03, 1.48616110D+03, 1.46359530D+03/
      data ( FDNF( 44,J,2),J=1,20) /
     $ 4.921D-06, 9.707D-06, 1.435D-05, 1.887D-05, 2.324D-05, 2.748D-05,
     $ 3.158D-05, 3.555D-05, 3.939D-05, 4.310D-05, 4.667D-05, 5.012D-05,
     $ 5.343D-05, 5.661D-05, 5.965D-05, 6.256D-05, 6.534D-05, 6.797D-05,
     $ 7.045D-05, 7.279D-05/
      data (WNUPF( 45,J,1),J=1,20) /
     $ 2.27784420D+03, 2.24979030D+03, 2.22180240D+03, 2.19388220D+03,
     $ 2.16603170D+03, 2.13825270D+03, 2.11054690D+03, 2.08291600D+03,
     $ 2.05536160D+03, 2.02788540D+03, 2.00048860D+03, 1.97317260D+03,
     $ 1.94593850D+03, 1.91878720D+03, 1.89171950D+03, 1.86473590D+03,
     $ 1.83783650D+03, 1.81102130D+03, 1.78429000D+03, 1.75764190D+03/
      data ( FUPF( 45,J,1),J=1,20) /
     $ 6.244D-06, 1.226D-05, 1.804D-05, 2.362D-05, 2.897D-05, 3.409D-05,
     $ 3.899D-05, 4.369D-05, 4.817D-05, 5.244D-05, 5.651D-05, 6.036D-05,
     $ 6.401D-05, 6.746D-05, 7.069D-05, 7.374D-05, 7.656D-05, 7.915D-05,
     $ 8.157D-05, 8.370D-05/
      data (WNDNF( 45,J,1),J=1,20) /
     $ 1.93781390D+03, 1.91291030D+03, 1.88807280D+03, 1.86330300D+03,
     $ 1.83860290D+03, 1.81397410D+03, 1.78941840D+03, 1.76493750D+03,
     $ 1.74053290D+03, 1.71620620D+03, 1.69195860D+03, 1.66779150D+03,
     $ 1.64370600D+03, 1.61970300D+03, 1.59578320D+03, 1.57194720D+03,
     $ 1.54819510D+03, 1.52452710D+03, 1.50094290D+03, 1.47744180D+03/
      data ( FDNF( 45,J,1),J=1,20) /
     $ 5.126D-06, 1.011D-05, 1.495D-05, 1.963D-05, 2.418D-05, 2.857D-05,
     $ 3.284D-05, 3.695D-05, 4.092D-05, 4.476D-05, 4.846D-05, 5.201D-05,
     $ 5.543D-05, 5.871D-05, 6.184D-05, 6.484D-05, 6.767D-05, 7.033D-05,
     $ 7.289D-05, 7.522D-05/
      data (WNUPF( 45,J,2),J=1,20) /
     $ 2.22559050D+03, 2.19880490D+03, 2.17208080D+03, 2.14542010D+03,
     $ 2.11882420D+03, 2.09229500D+03, 2.06583390D+03, 2.03944270D+03,
     $ 2.01312260D+03, 1.98687530D+03, 1.96070190D+03, 1.93460380D+03,
     $ 1.90858200D+03, 1.88263730D+03, 1.85677050D+03, 1.83098220D+03,
     $ 1.80527270D+03, 1.77964190D+03, 1.75408980D+03, 1.72861570D+03/
      data ( FUPF( 45,J,2),J=1,20) /
     $ 5.961D-06, 1.171D-05, 1.727D-05, 2.258D-05, 2.771D-05, 3.263D-05,
     $ 3.735D-05, 4.187D-05, 4.619D-05, 5.031D-05, 5.425D-05, 5.799D-05,
     $ 6.153D-05, 6.489D-05, 6.806D-05, 7.102D-05, 7.381D-05, 7.638D-05,
     $ 7.876D-05, 8.094D-05/
      data (WNDNF( 45,J,2),J=1,20) /
     $ 1.90029430D+03, 1.87645300D+03, 1.85267340D+03, 1.82895690D+03,
     $ 1.80530540D+03, 1.78172040D+03, 1.75820350D+03, 1.73475610D+03,
     $ 1.71137980D+03, 1.68807600D+03, 1.66484590D+03, 1.64169080D+03,
     $ 1.61861160D+03, 1.59560920D+03, 1.57268450D+03, 1.54983790D+03,
     $ 1.52706980D+03, 1.50438030D+03, 1.48176920D+03, 1.45923620D+03/
      data ( FDNF( 45,J,2),J=1,20) /
     $ 4.912D-06, 9.689D-06, 1.432D-05, 1.884D-05, 2.320D-05, 2.743D-05,
     $ 3.153D-05, 3.549D-05, 3.933D-05, 4.302D-05, 4.659D-05, 5.003D-05,
     $ 5.334D-05, 5.652D-05, 5.956D-05, 6.247D-05, 6.524D-05, 6.787D-05,
     $ 7.035D-05, 7.268D-05/
      data (WNUPF( 46,J,1),J=1,20) /
     $ 2.27992780D+03, 2.25183880D+03, 2.22381580D+03, 2.19586070D+03,
     $ 2.16797520D+03, 2.14016120D+03, 2.11242040D+03, 2.08475460D+03,
     $ 2.05716530D+03, 2.02965410D+03, 2.00222240D+03, 1.97487150D+03,
     $ 1.94760250D+03, 1.92041640D+03, 1.89331380D+03, 1.86629520D+03,
     $ 1.83936080D+03, 1.81251070D+03, 1.78574430D+03, 1.75906100D+03/
      data ( FUPF( 46,J,1),J=1,20) /
     $ 6.252D-06, 1.227D-05, 1.807D-05, 2.364D-05, 2.899D-05, 3.412D-05,
     $ 3.902D-05, 4.371D-05, 4.820D-05, 5.247D-05, 5.653D-05, 6.038D-05,
     $ 6.403D-05, 6.748D-05, 7.070D-05, 7.375D-05, 7.656D-05, 7.913D-05,
     $ 8.156D-05, 8.367D-05/
      data (WNDNF( 46,J,1),J=1,20) /
     $ 1.93254500D+03, 1.90767640D+03, 1.88287390D+03, 1.85813920D+03,
     $ 1.83347410D+03, 1.80888040D+03, 1.78435980D+03, 1.75991400D+03,
     $ 1.73554460D+03, 1.71125300D+03, 1.68704070D+03, 1.66290880D+03,
     $ 1.63885850D+03, 1.61489070D+03, 1.59100620D+03, 1.56720530D+03,
     $ 1.54348850D+03, 1.51985570D+03, 1.49630650D+03, 1.47284050D+03/
      data ( FDNF( 46,J,1),J=1,20) /
     $ 5.116D-06, 1.009D-05, 1.491D-05, 1.959D-05, 2.413D-05, 2.853D-05,
     $ 3.277D-05, 3.688D-05, 4.085D-05, 4.469D-05, 4.838D-05, 5.192D-05,
     $ 5.534D-05, 5.861D-05, 6.173D-05, 6.473D-05, 6.757D-05, 7.023D-05,
     $ 7.278D-05, 7.511D-05/
      data (WNUPF( 46,J,2),J=1,20) /
     $ 2.22762320D+03, 2.20080480D+03, 2.17404810D+03, 2.14735460D+03,
     $ 2.12072610D+03, 2.09416410D+03, 2.06767040D+03, 2.04124650D+03,
     $ 2.01489380D+03, 1.98861380D+03, 1.96240790D+03, 1.93627710D+03,
     $ 1.91022270D+03, 1.88424540D+03, 1.85834600D+03, 1.83252510D+03,
     $ 1.80678290D+03, 1.78111950D+03, 1.75553460D+03, 1.73002770D+03/
      data ( FUPF( 46,J,2),J=1,20) /
     $ 5.969D-06, 1.173D-05, 1.729D-05, 2.260D-05, 2.774D-05, 3.266D-05,
     $ 3.737D-05, 4.190D-05, 4.622D-05, 5.034D-05, 5.427D-05, 5.801D-05,
     $ 6.156D-05, 6.491D-05, 6.807D-05, 7.103D-05, 7.381D-05, 7.638D-05,
     $ 7.876D-05, 8.092D-05/
      data (WNDNF( 46,J,2),J=1,20) /
     $ 1.89528450D+03, 1.87147590D+03, 1.84772900D+03, 1.82404530D+03,
     $ 1.80042660D+03, 1.77687430D+03, 1.75339020D+03, 1.72997570D+03,
     $ 1.70663230D+03, 1.68336130D+03, 1.66016410D+03, 1.63704190D+03,
     $ 1.61399560D+03, 1.59102620D+03, 1.56813440D+03, 1.54532070D+03,
     $ 1.52258550D+03, 1.49992880D+03, 1.47735060D+03, 1.45485030D+03/
      data ( FDNF( 46,J,2),J=1,20) /
     $ 4.903D-06, 9.670D-06, 1.429D-05, 1.880D-05, 2.315D-05, 2.738D-05,
     $ 3.147D-05, 3.543D-05, 3.926D-05, 4.295D-05, 4.652D-05, 4.996D-05,
     $ 5.326D-05, 5.643D-05, 5.947D-05, 6.238D-05, 6.514D-05, 6.776D-05,
     $ 7.025D-05, 7.258D-05/
      data (WNUPF( 47,J,1),J=1,20) /
     $ 2.28196960D+03, 2.25384560D+03, 2.22578760D+03, 2.19779740D+03,
     $ 2.16987690D+03, 2.14202790D+03, 2.11425220D+03, 2.08655140D+03,
     $ 2.05892710D+03, 2.03138100D+03, 2.00391440D+03, 1.97652860D+03,
     $ 1.94922470D+03, 1.92200370D+03, 1.89486620D+03, 1.86781260D+03,
     $ 1.84084330D+03, 1.81395820D+03, 1.78715670D+03, 1.76043820D+03/
      data ( FUPF( 47,J,1),J=1,20) /
     $ 6.259D-06, 1.229D-05, 1.809D-05, 2.367D-05, 2.902D-05, 3.415D-05,
     $ 3.905D-05, 4.375D-05, 4.824D-05, 5.251D-05, 5.656D-05, 6.042D-05,
     $ 6.406D-05, 6.749D-05, 7.071D-05, 7.375D-05, 7.656D-05, 7.913D-05,
     $ 8.154D-05, 8.365D-05/
      data (WNDNF( 47,J,1),J=1,20) /
     $ 1.92724770D+03, 1.90241420D+03, 1.87764670D+03, 1.85294700D+03,
     $ 1.82831690D+03, 1.80375830D+03, 1.77927290D+03, 1.75486220D+03,
     $ 1.73052790D+03, 1.70627150D+03, 1.68209440D+03, 1.65799780D+03,
     $ 1.63398270D+03, 1.61005010D+03, 1.58620080D+03, 1.56243520D+03,
     $ 1.53875350D+03, 1.51515580D+03, 1.49164180D+03, 1.46821080D+03/
      data ( FDNF( 47,J,1),J=1,20) /
     $ 5.106D-06, 1.007D-05, 1.488D-05, 1.956D-05, 2.408D-05, 2.847D-05,
     $ 3.272D-05, 3.681D-05, 4.078D-05, 4.460D-05, 4.828D-05, 5.184D-05,
     $ 5.524D-05, 5.852D-05, 6.163D-05, 6.463D-05, 6.746D-05, 7.012D-05,
     $ 7.267D-05, 7.499D-05/
      data (WNUPF( 47,J,2),J=1,20) /
     $ 2.22961710D+03, 2.20276600D+03, 2.17597650D+03, 2.14925030D+03,
     $ 2.12258910D+03, 2.09599440D+03, 2.06946800D+03, 2.04301140D+03,
     $ 2.01662610D+03, 1.99031350D+03, 1.96407490D+03, 1.93791150D+03,
     $ 1.91182450D+03, 1.88581460D+03, 1.85988260D+03, 1.83402900D+03,
     $ 1.80825420D+03, 1.78255800D+03, 1.75694040D+03, 1.73140070D+03/
      data ( FUPF( 47,J,2),J=1,20) /
     $ 5.976D-06, 1.174D-05, 1.730D-05, 2.263D-05, 2.776D-05, 3.269D-05,
     $ 3.741D-05, 4.192D-05, 4.625D-05, 5.038D-05, 5.430D-05, 5.804D-05,
     $ 6.158D-05, 6.494D-05, 6.809D-05, 7.104D-05, 7.381D-05, 7.638D-05,
     $ 7.875D-05, 8.091D-05/
      data (WNDNF( 47,J,2),J=1,20) /
     $ 1.89024810D+03, 1.86647220D+03, 1.84275800D+03, 1.81910710D+03,
     $ 1.79552110D+03, 1.77200170D+03, 1.74855030D+03, 1.72516870D+03,
     $ 1.70185810D+03, 1.67862000D+03, 1.65545570D+03, 1.63236640D+03,
     $ 1.60935300D+03, 1.58641650D+03, 1.56355760D+03, 1.54077690D+03,
     $ 1.51807460D+03, 1.49545080D+03, 1.47290540D+03, 1.45043790D+03/
      data ( FDNF( 47,J,2),J=1,20) /
     $ 4.894D-06, 9.652D-06, 1.426D-05, 1.876D-05, 2.312D-05, 2.733D-05,
     $ 3.141D-05, 3.537D-05, 3.919D-05, 4.287D-05, 4.643D-05, 4.987D-05,
     $ 5.317D-05, 5.634D-05, 5.938D-05, 6.227D-05, 6.504D-05, 6.766D-05,
     $ 7.015D-05, 7.247D-05/
      data (WNUPF( 48,J,1),J=1,20) /
     $ 2.28396950D+03, 2.25581050D+03, 2.22771750D+03, 2.19969230D+03,
     $ 2.17173680D+03, 2.14385280D+03, 2.11604200D+03, 2.08830620D+03,
     $ 2.06064710D+03, 2.03306600D+03, 2.00556450D+03, 1.97814380D+03,
     $ 1.95080500D+03, 1.92354900D+03, 1.89637660D+03, 1.86928810D+03,
     $ 1.84228380D+03, 1.81536360D+03, 1.78852710D+03, 1.76177340D+03/
      data ( FUPF( 48,J,1),J=1,20) /
     $ 6.267D-06, 1.231D-05, 1.812D-05, 2.369D-05, 2.904D-05, 3.418D-05,
     $ 3.908D-05, 4.378D-05, 4.826D-05, 5.254D-05, 5.659D-05, 6.044D-05,
     $ 6.408D-05, 6.752D-05, 7.073D-05, 7.376D-05, 7.656D-05, 7.912D-05,
     $ 8.153D-05, 8.362D-05/
      data (WNDNF( 48,J,1),J=1,20) /
     $ 1.92192240D+03, 1.89712380D+03, 1.87239130D+03, 1.84772660D+03,
     $ 1.82313160D+03, 1.79860810D+03, 1.77415770D+03, 1.74978220D+03,
     $ 1.72548310D+03, 1.70126190D+03, 1.67711990D+03, 1.65305850D+03,
     $ 1.62907870D+03, 1.60518140D+03, 1.58136730D+03, 1.55763680D+03,
     $ 1.53399040D+03, 1.51042790D+03, 1.48694890D+03, 1.46355300D+03/
      data ( FDNF( 48,J,1),J=1,20) /
     $ 5.096D-06, 1.005D-05, 1.486D-05, 1.952D-05, 2.404D-05, 2.841D-05,
     $ 3.265D-05, 3.674D-05, 4.070D-05, 4.453D-05, 4.821D-05, 5.174D-05,
     $ 5.515D-05, 5.841D-05, 6.153D-05, 6.453D-05, 6.735D-05, 7.000D-05,
     $ 7.256D-05, 7.488D-05/
      data (WNUPF( 48,J,2),J=1,20) /
     $ 2.23157200D+03, 2.20468820D+03, 2.17786590D+03, 2.15110700D+03,
     $ 2.12441300D+03, 2.09778570D+03, 2.07122660D+03, 2.04473730D+03,
     $ 2.01831930D+03, 1.99197410D+03, 1.96570290D+03, 1.93950690D+03,
     $ 1.91338720D+03, 1.88734470D+03, 1.86138010D+03, 1.83549390D+03,
     $ 1.80968640D+03, 1.78395750D+03, 1.75830710D+03, 1.73273460D+03/
      data ( FUPF( 48,J,2),J=1,20) /
     $ 5.984D-06, 1.176D-05, 1.733D-05, 2.265D-05, 2.779D-05, 3.272D-05,
     $ 3.744D-05, 4.196D-05, 4.628D-05, 5.040D-05, 5.433D-05, 5.806D-05,
     $ 6.160D-05, 6.495D-05, 6.809D-05, 7.105D-05, 7.381D-05, 7.638D-05,
     $ 7.874D-05, 8.088D-05/
      data (WNDNF( 48,J,2),J=1,20) /
     $ 1.88518520D+03, 1.86144210D+03, 1.83776060D+03, 1.81414240D+03,
     $ 1.79058920D+03, 1.76710250D+03, 1.74368400D+03, 1.72033510D+03,
     $ 1.69705740D+03, 1.67385220D+03, 1.65072080D+03, 1.62766440D+03,
     $ 1.60468400D+03, 1.58178040D+03, 1.55895440D+03, 1.53620660D+03,
     $ 1.51353720D+03, 1.49094620D+03, 1.46843370D+03, 1.44599900D+03/
      data ( FDNF( 48,J,2),J=1,20) /
     $ 4.884D-06, 9.633D-06, 1.424D-05, 1.872D-05, 2.307D-05, 2.728D-05,
     $ 3.135D-05, 3.530D-05, 3.911D-05, 4.280D-05, 4.636D-05, 4.978D-05,
     $ 5.308D-05, 5.625D-05, 5.928D-05, 6.218D-05, 6.494D-05, 6.756D-05,
     $ 7.004D-05, 7.237D-05/
      data (WNUPF( 49,J,1),J=1,20) /
     $ 2.28592750D+03, 2.25773340D+03, 2.22960540D+03, 2.20154510D+03,
     $ 2.17355460D+03, 2.14563560D+03, 2.11778980D+03, 2.09001910D+03,
     $ 2.06232500D+03, 2.03470900D+03, 2.00717250D+03, 1.97971690D+03,
     $ 1.95234320D+03, 1.92505230D+03, 1.89784490D+03, 1.87072150D+03,
     $ 1.84368220D+03, 1.81672690D+03, 1.78985520D+03, 1.76306640D+03/
      data ( FUPF( 49,J,1),J=1,20) /
     $ 6.275D-06, 1.232D-05, 1.813D-05, 2.372D-05, 2.907D-05, 3.421D-05,
     $ 3.912D-05, 4.381D-05, 4.830D-05, 5.257D-05, 5.662D-05, 6.046D-05,
     $ 6.410D-05, 6.754D-05, 7.073D-05, 7.376D-05, 7.656D-05, 7.910D-05,
     $ 8.151D-05, 8.359D-05/
      data (WNDNF( 49,J,1),J=1,20) /
     $ 1.91656890D+03, 1.89180540D+03, 1.86710780D+03, 1.84247820D+03,
     $ 1.81791820D+03, 1.79342980D+03, 1.76901450D+03, 1.74467410D+03,
     $ 1.72041020D+03, 1.69622420D+03, 1.67211740D+03, 1.64809120D+03,
     $ 1.62414660D+03, 1.60028450D+03, 1.57650570D+03, 1.55281050D+03,
     $ 1.52919920D+03, 1.50567180D+03, 1.48222800D+03, 1.45886710D+03/
      data ( FDNF( 49,J,1),J=1,20) /
     $ 5.086D-06, 1.003D-05, 1.483D-05, 1.948D-05, 2.399D-05, 2.836D-05,
     $ 3.259D-05, 3.668D-05, 4.063D-05, 4.444D-05, 4.812D-05, 5.166D-05,
     $ 5.506D-05, 5.831D-05, 6.142D-05, 6.441D-05, 6.724D-05, 6.989D-05,
     $ 7.244D-05, 7.476D-05/
      data (WNUPF( 49,J,2),J=1,20) /
     $ 2.23348780D+03, 2.20657120D+03, 2.17971630D+03, 2.15292460D+03,
     $ 2.12619790D+03, 2.09953780D+03, 2.07294600D+03, 2.04642410D+03,
     $ 2.01997340D+03, 1.99359550D+03, 1.96729170D+03, 1.94106310D+03,
     $ 1.91491080D+03, 1.88883560D+03, 1.86283840D+03, 1.83691950D+03,
     $ 1.81107930D+03, 1.78531770D+03, 1.75963460D+03, 1.73402920D+03/
      data ( FUPF( 49,J,2),J=1,20) /
     $ 5.992D-06, 1.176D-05, 1.734D-05, 2.268D-05, 2.781D-05, 3.275D-05,
     $ 3.747D-05, 4.199D-05, 4.631D-05, 5.043D-05, 5.436D-05, 5.809D-05,
     $ 6.163D-05, 6.497D-05, 6.811D-05, 7.106D-05, 7.381D-05, 7.637D-05,
     $ 7.872D-05, 8.087D-05/
      data (WNDNF( 49,J,2),J=1,20) /
     $ 1.88009600D+03, 1.85638560D+03, 1.83273680D+03, 1.80915130D+03,
     $ 1.78563090D+03, 1.76217700D+03, 1.73879130D+03, 1.71547520D+03,
     $ 1.69223040D+03, 1.66905810D+03, 1.64595960D+03, 1.62293610D+03,
     $ 1.59998850D+03, 1.57711790D+03, 1.55432490D+03, 1.53160990D+03,
     $ 1.50897340D+03, 1.48641540D+03, 1.46393560D+03, 1.44153370D+03/
      data ( FDNF( 49,J,2),J=1,20) /
     $ 4.875D-06, 9.614D-06, 1.421D-05, 1.869D-05, 2.303D-05, 2.723D-05,
     $ 3.129D-05, 3.523D-05, 3.905D-05, 4.273D-05, 4.627D-05, 4.970D-05,
     $ 5.299D-05, 5.615D-05, 5.918D-05, 6.208D-05, 6.484D-05, 6.745D-05,
     $ 6.993D-05, 7.226D-05/
      data (WNUPF( 50,J,1),J=1,20) /
     $ 2.28784340D+03, 2.25961420D+03, 2.23145110D+03, 2.20335580D+03,
     $ 2.17533020D+03, 2.14737620D+03, 2.11949550D+03, 2.09168970D+03,
     $ 2.06396060D+03, 2.03630970D+03, 2.00873830D+03, 1.98124780D+03,
     $ 1.95383910D+03, 1.92651330D+03, 1.89927090D+03, 1.87211250D+03,
     $ 1.84503820D+03, 1.81804790D+03, 1.79114110D+03, 1.76431700D+03/
      data ( FUPF( 50,J,1),J=1,20) /
     $ 6.284D-06, 1.233D-05, 1.815D-05, 2.374D-05, 2.910D-05, 3.424D-05,
     $ 3.915D-05, 4.385D-05, 4.832D-05, 5.260D-05, 5.665D-05, 6.048D-05,
     $ 6.412D-05, 6.755D-05, 7.075D-05, 7.377D-05, 7.656D-05, 7.909D-05,
     $ 8.148D-05, 8.355D-05/
      data (WNDNF( 50,J,1),J=1,20) /
     $ 1.91118760D+03, 1.88645900D+03, 1.86179650D+03, 1.83720190D+03,
     $ 1.81267700D+03, 1.78822360D+03, 1.76384340D+03, 1.73953820D+03,
     $ 1.71530940D+03, 1.69115850D+03, 1.66708700D+03, 1.64309600D+03,
     $ 1.61918670D+03, 1.59535980D+03, 1.57161620D+03, 1.54795620D+03,
     $ 1.52438010D+03, 1.50088790D+03, 1.47747920D+03, 1.45415330D+03/
      data ( FDNF( 50,J,1),J=1,20) /
     $ 5.075D-06, 1.001D-05, 1.479D-05, 1.945D-05, 2.394D-05, 2.831D-05,
     $ 3.252D-05, 3.660D-05, 4.055D-05, 4.437D-05, 4.803D-05, 5.156D-05,
     $ 5.496D-05, 5.822D-05, 6.132D-05, 6.431D-05, 6.713D-05, 6.977D-05,
     $ 7.234D-05, 7.464D-05/
      data (WNUPF( 50,J,2),J=1,20) /
     $ 2.23536440D+03, 2.20841510D+03, 2.18152730D+03, 2.15470290D+03,
     $ 2.12794350D+03, 2.10125070D+03, 2.07462620D+03, 2.04807150D+03,
     $ 2.02158820D+03, 1.99517770D+03, 1.96884120D+03, 1.94257990D+03,
     $ 1.91639500D+03, 1.89028720D+03, 1.86425730D+03, 1.83830580D+03,
     $ 1.81243290D+03, 1.78663860D+03, 1.76092260D+03, 1.73528440D+03/
      data ( FUPF( 50,J,2),J=1,20) /
     $ 5.999D-06, 1.178D-05, 1.736D-05, 2.271D-05, 2.785D-05, 3.278D-05,
     $ 3.751D-05, 4.202D-05, 4.634D-05, 5.046D-05, 5.438D-05, 5.811D-05,
     $ 6.165D-05, 6.499D-05, 6.812D-05, 7.107D-05, 7.382D-05, 7.636D-05,
     $ 7.871D-05, 8.084D-05/
      data (WNDNF( 50,J,2),J=1,20) /
     $ 1.87498060D+03, 1.85130280D+03, 1.82768680D+03, 1.80413410D+03,
     $ 1.78064630D+03, 1.75722520D+03, 1.73387230D+03, 1.71058910D+03,
     $ 1.68737710D+03, 1.66423770D+03, 1.64117210D+03, 1.61818150D+03,
     $ 1.59526690D+03, 1.57242920D+03, 1.54966910D+03, 1.52698710D+03,
     $ 1.50438340D+03, 1.48185830D+03, 1.45941140D+03, 1.43704230D+03/
      data ( FDNF( 50,J,2),J=1,20) /
     $ 4.865D-06, 9.596D-06, 1.419D-05, 1.865D-05, 2.298D-05, 2.718D-05,
     $ 3.124D-05, 3.517D-05, 3.898D-05, 4.265D-05, 4.620D-05, 4.961D-05,
     $ 5.290D-05, 5.606D-05, 5.908D-05, 6.198D-05, 6.473D-05, 6.735D-05,
     $ 6.982D-05, 7.215D-05/
      data (WNUPF( 51,J,1),J=1,20) /
     $ 2.28971690D+03, 2.26145270D+03, 2.23325450D+03, 2.20512420D+03,
     $ 2.17706360D+03, 2.14907450D+03, 2.12115880D+03, 2.09331800D+03,
     $ 2.06555400D+03, 2.03786810D+03, 2.01026170D+03, 1.98273620D+03,
     $ 1.95529270D+03, 1.92793190D+03, 1.90065460D+03, 1.87346120D+03,
     $ 1.84635180D+03, 1.81932640D+03, 1.79238440D+03, 1.76552510D+03/
      data ( FUPF( 51,J,1),J=1,20) /
     $ 6.291D-06, 1.235D-05, 1.817D-05, 2.376D-05, 2.913D-05, 3.427D-05,
     $ 3.918D-05, 4.388D-05, 4.836D-05, 5.262D-05, 5.667D-05, 6.051D-05,
     $ 6.414D-05, 6.756D-05, 7.075D-05, 7.376D-05, 7.654D-05, 7.907D-05,
     $ 8.146D-05, 8.351D-05/
      data (WNDNF( 51,J,1),J=1,20) /
     $ 1.90577850D+03, 1.88108490D+03, 1.85645740D+03, 1.83189780D+03,
     $ 1.80740790D+03, 1.78298960D+03, 1.75864450D+03, 1.73437440D+03,
     $ 1.71018080D+03, 1.68606510D+03, 1.66202880D+03, 1.63807300D+03,
     $ 1.61419890D+03, 1.59040730D+03, 1.56669890D+03, 1.54307410D+03,
     $ 1.51953320D+03, 1.49607620D+03, 1.47270260D+03, 1.44941170D+03/
      data ( FDNF( 51,J,1),J=1,20) /
     $ 5.065D-06, 9.990D-06, 1.477D-05, 1.941D-05, 2.389D-05, 2.825D-05,
     $ 3.247D-05, 3.653D-05, 4.048D-05, 4.428D-05, 4.794D-05, 5.148D-05,
     $ 5.486D-05, 5.812D-05, 6.121D-05, 6.419D-05, 6.702D-05, 6.966D-05,
     $ 7.221D-05, 7.452D-05/
      data (WNUPF( 51,J,2),J=1,20) /
     $ 2.23720160D+03, 2.21021950D+03, 2.18329900D+03, 2.15644180D+03,
     $ 2.12964970D+03, 2.10292420D+03, 2.07626690D+03, 2.04967960D+03,
     $ 2.02316360D+03, 1.99672040D+03, 1.97035120D+03, 1.94405730D+03,
     $ 1.91783970D+03, 1.89169930D+03, 1.86563680D+03, 1.83965260D+03,
     $ 1.81374690D+03, 1.78791990D+03, 1.76217110D+03, 1.73650000D+03/
      data ( FUPF( 51,J,2),J=1,20) /
     $ 6.007D-06, 1.179D-05, 1.738D-05, 2.272D-05, 2.787D-05, 3.280D-05,
     $ 3.753D-05, 4.205D-05, 4.638D-05, 5.050D-05, 5.442D-05, 5.814D-05,
     $ 6.166D-05, 6.500D-05, 6.814D-05, 7.108D-05, 7.381D-05, 7.636D-05,
     $ 7.869D-05, 8.081D-05/
      data (WNDNF( 51,J,2),J=1,20) /
     $ 1.86983910D+03, 1.84619400D+03, 1.82261070D+03, 1.79909070D+03,
     $ 1.77563570D+03, 1.75224740D+03, 1.72892720D+03, 1.70567690D+03,
     $ 1.68249780D+03, 1.65939120D+03, 1.63635850D+03, 1.61340080D+03,
     $ 1.59051910D+03, 1.56771440D+03, 1.54498720D+03, 1.52233810D+03,
     $ 1.49976740D+03, 1.47727510D+03, 1.45486100D+03, 1.43252470D+03/
      data ( FDNF( 51,J,2),J=1,20) /
     $ 4.855D-06, 9.577D-06, 1.416D-05, 1.862D-05, 2.294D-05, 2.713D-05,
     $ 3.118D-05, 3.511D-05, 3.890D-05, 4.257D-05, 4.612D-05, 4.952D-05,
     $ 5.281D-05, 5.596D-05, 5.898D-05, 6.187D-05, 6.463D-05, 6.724D-05,
     $ 6.971D-05, 7.204D-05/
      data (WNUPF( 52,J,1),J=1,20) /
     $ 2.29154810D+03, 2.26324880D+03, 2.23501550D+03, 2.20685010D+03,
     $ 2.17875440D+03, 2.15073030D+03, 2.12277960D+03, 2.09490380D+03,
     $ 2.06710480D+03, 2.03938390D+03, 2.01174260D+03, 1.98418220D+03,
     $ 1.95670360D+03, 1.92930790D+03, 1.90199560D+03, 1.87476720D+03,
     $ 1.84762280D+03, 1.82056220D+03, 1.79358510D+03, 1.76669050D+03/
      data ( FUPF( 52,J,1),J=1,20) /
     $ 6.299D-06, 1.236D-05, 1.819D-05, 2.379D-05, 2.916D-05, 3.430D-05,
     $ 3.921D-05, 4.391D-05, 4.839D-05, 5.265D-05, 5.670D-05, 6.053D-05,
     $ 6.417D-05, 6.757D-05, 7.076D-05, 7.377D-05, 7.654D-05, 7.906D-05,
     $ 8.143D-05, 8.348D-05/
      data (WNDNF( 52,J,1),J=1,20) /
     $ 1.90034190D+03, 1.87568320D+03, 1.85109060D+03, 1.82656600D+03,
     $ 1.80211120D+03, 1.77772800D+03, 1.75341800D+03, 1.72918300D+03,
     $ 1.70502450D+03, 1.68094410D+03, 1.65694290D+03, 1.63302240D+03,
     $ 1.60918350D+03, 1.58542710D+03, 1.56175400D+03, 1.53816440D+03,
     $ 1.51465870D+03, 1.49123680D+03, 1.46789830D+03, 1.44464250D+03/
      data ( FDNF( 52,J,1),J=1,20) /
     $ 5.055D-06, 9.962D-06, 1.473D-05, 1.936D-05, 2.385D-05, 2.819D-05,
     $ 3.240D-05, 3.647D-05, 4.040D-05, 4.420D-05, 4.786D-05, 5.138D-05,
     $ 5.476D-05, 5.801D-05, 6.110D-05, 6.409D-05, 6.690D-05, 6.954D-05,
     $ 7.210D-05, 7.440D-05/
      data (WNUPF( 52,J,2),J=1,20) /
     $ 2.23899930D+03, 2.21198450D+03, 2.18503120D+03, 2.15814130D+03,
     $ 2.13131630D+03, 2.10455810D+03, 2.07786810D+03, 2.05124810D+03,
     $ 2.02469940D+03, 1.99822350D+03, 1.97182170D+03, 1.94549510D+03,
     $ 1.91924490D+03, 1.89307180D+03, 1.86697660D+03, 1.84095970D+03,
     $ 1.81502130D+03, 1.78916150D+03, 1.76337990D+03, 1.73767590D+03/
      data ( FUPF( 52,J,2),J=1,20) /
     $ 6.014D-06, 1.181D-05, 1.740D-05, 2.275D-05, 2.789D-05, 3.283D-05,
     $ 3.756D-05, 4.208D-05, 4.641D-05, 5.052D-05, 5.444D-05, 5.817D-05,
     $ 6.169D-05, 6.502D-05, 6.815D-05, 7.108D-05, 7.382D-05, 7.634D-05,
     $ 7.867D-05, 8.079D-05/
      data (WNDNF( 52,J,2),J=1,20) /
     $ 1.86467160D+03, 1.84105930D+03, 1.81750860D+03, 1.79402130D+03,
     $ 1.77059910D+03, 1.74724350D+03, 1.72395620D+03, 1.70073870D+03,
     $ 1.67759240D+03, 1.65451870D+03, 1.63151890D+03, 1.60859410D+03,
     $ 1.58574540D+03, 1.56297360D+03, 1.54027930D+03, 1.51766320D+03,
     $ 1.49512530D+03, 1.47266590D+03, 1.45028470D+03, 1.42798110D+03/
      data ( FDNF( 52,J,2),J=1,20) /
     $ 4.846D-06, 9.562D-06, 1.412D-05, 1.858D-05, 2.290D-05, 2.708D-05,
     $ 3.112D-05, 3.504D-05, 3.884D-05, 4.250D-05, 4.603D-05, 4.944D-05,
     $ 5.271D-05, 5.587D-05, 5.889D-05, 6.177D-05, 6.452D-05, 6.713D-05,
     $ 6.960D-05, 7.192D-05/
      data (WNUPF( 53,J,1),J=1,20) /
     $ 2.29333670D+03, 2.26500230D+03, 2.23673390D+03, 2.20853340D+03,
     $ 2.18040270D+03, 2.15234360D+03, 2.12435770D+03, 2.09644700D+03,
     $ 2.06861290D+03, 2.04085710D+03, 2.01318080D+03, 1.98558540D+03,
     $ 1.95807190D+03, 1.93064120D+03, 1.90329390D+03, 1.87603050D+03,
     $ 1.84885100D+03, 1.82175530D+03, 1.79474300D+03, 1.76781300D+03/
      data ( FUPF( 53,J,1),J=1,20) /
     $ 6.308D-06, 1.238D-05, 1.821D-05, 2.381D-05, 2.918D-05, 3.432D-05,
     $ 3.925D-05, 4.394D-05, 4.842D-05, 5.268D-05, 5.672D-05, 6.055D-05,
     $ 6.418D-05, 6.759D-05, 7.076D-05, 7.376D-05, 7.653D-05, 7.904D-05,
     $ 8.140D-05, 8.344D-05/
      data (WNDNF( 53,J,1),J=1,20) /
     $ 1.89487770D+03, 1.87025400D+03, 1.84569640D+03, 1.82120680D+03,
     $ 1.79678700D+03, 1.77243880D+03, 1.74816400D+03, 1.72396410D+03,
     $ 1.69984080D+03, 1.67579550D+03, 1.65182960D+03, 1.62794430D+03,
     $ 1.60414060D+03, 1.58041950D+03, 1.55678160D+03, 1.53322720D+03,
     $ 1.50975680D+03, 1.48637000D+03, 1.46306660D+03, 1.43984580D+03/
      data ( FDNF( 53,J,1),J=1,20) /
     $ 5.045D-06, 9.944D-06, 1.471D-05, 1.933D-05, 2.380D-05, 2.814D-05,
     $ 3.234D-05, 3.640D-05, 4.033D-05, 4.411D-05, 4.777D-05, 5.128D-05,
     $ 5.466D-05, 5.791D-05, 6.100D-05, 6.398D-05, 6.679D-05, 6.943D-05,
     $ 7.198D-05, 7.427D-05/
      data (WNUPF( 53,J,2),J=1,20) /
     $ 2.24075740D+03, 2.21370980D+03, 2.18672370D+03, 2.15980100D+03,
     $ 2.13294330D+03, 2.10615230D+03, 2.07942970D+03, 2.05277690D+03,
     $ 2.02619550D+03, 1.99968690D+03, 1.97325240D+03, 1.94689320D+03,
     $ 1.92061030D+03, 1.89440450D+03, 1.86827660D+03, 1.84222700D+03,
     $ 1.81625590D+03, 1.79036330D+03, 1.76454890D+03, 1.73881190D+03/
      data ( FUPF( 53,J,2),J=1,20) /
     $ 6.022D-06, 1.182D-05, 1.742D-05, 2.277D-05, 2.792D-05, 3.286D-05,
     $ 3.759D-05, 4.211D-05, 4.644D-05, 5.055D-05, 5.447D-05, 5.818D-05,
     $ 6.170D-05, 6.503D-05, 6.815D-05, 7.109D-05, 7.381D-05, 7.633D-05,
     $ 7.865D-05, 8.076D-05/
      data (WNDNF( 53,J,2),J=1,20) /
     $ 1.85947830D+03, 1.83589860D+03, 1.81238070D+03, 1.78892610D+03,
     $ 1.76553660D+03, 1.74221380D+03, 1.71895930D+03, 1.69577460D+03,
     $ 1.67266120D+03, 1.64962040D+03, 1.62665350D+03, 1.60376160D+03,
     $ 1.58094580D+03, 1.55820690D+03, 1.53554560D+03, 1.51296240D+03,
     $ 1.49045750D+03, 1.46803090D+03, 1.44568250D+03, 1.42341170D+03/
      data ( FDNF( 53,J,2),J=1,20) /
     $ 4.836D-06, 9.542D-06, 1.410D-05, 1.854D-05, 2.285D-05, 2.702D-05,
     $ 3.107D-05, 3.497D-05, 3.877D-05, 4.242D-05, 4.594D-05, 4.936D-05,
     $ 5.263D-05, 5.578D-05, 5.879D-05, 6.167D-05, 6.441D-05, 6.703D-05,
     $ 6.949D-05, 7.180D-05/
      data (WNUPF( 54,J,1),J=1,20) /
     $ 2.29508260D+03, 2.26671310D+03, 2.23840960D+03, 2.21017400D+03,
     $ 2.18200820D+03, 2.15391400D+03, 2.12589310D+03, 2.09794740D+03,
     $ 2.07007830D+03, 2.04228750D+03, 2.01457620D+03, 1.98694580D+03,
     $ 1.95939730D+03, 1.93193160D+03, 1.90454930D+03, 1.87725080D+03,
     $ 1.85003630D+03, 1.82290550D+03, 1.79585780D+03, 1.76889260D+03/
      data ( FUPF( 54,J,1),J=1,20) /
     $ 6.315D-06, 1.239D-05, 1.823D-05, 2.384D-05, 2.921D-05, 3.436D-05,
     $ 3.927D-05, 4.397D-05, 4.845D-05, 5.270D-05, 5.675D-05, 6.058D-05,
     $ 6.420D-05, 6.760D-05, 7.077D-05, 7.377D-05, 7.652D-05, 7.902D-05,
     $ 8.137D-05, 8.339D-05/
      data (WNDNF( 54,J,1),J=1,20) /
     $ 1.88938620D+03, 1.86479750D+03, 1.84027490D+03, 1.81582020D+03,
     $ 1.79143550D+03, 1.76712240D+03, 1.74288260D+03, 1.71871780D+03,
     $ 1.69462970D+03, 1.67061960D+03, 1.64668890D+03, 1.62283880D+03,
     $ 1.59907040D+03, 1.57538450D+03, 1.55178180D+03, 1.52826270D+03,
     $ 1.50482740D+03, 1.48147580D+03, 1.45820750D+03, 1.43502180D+03/
      data ( FDNF( 54,J,1),J=1,20) /
     $ 5.034D-06, 9.927D-06, 1.468D-05, 1.928D-05, 2.375D-05, 2.808D-05,
     $ 3.228D-05, 3.633D-05, 4.025D-05, 4.403D-05, 4.768D-05, 5.119D-05,
     $ 5.457D-05, 5.781D-05, 6.089D-05, 6.386D-05, 6.668D-05, 6.931D-05,
     $ 7.185D-05, 7.415D-05/
      data (WNUPF( 54,J,2),J=1,20) /
     $ 2.24247580D+03, 2.21539530D+03, 2.18837650D+03, 2.16142100D+03,
     $ 2.13453050D+03, 2.10770680D+03, 2.08095140D+03, 2.05426590D+03,
     $ 2.02765170D+03, 2.00111050D+03, 1.97464330D+03, 1.94825140D+03,
     $ 1.92193580D+03, 1.89569740D+03, 1.86953680D+03, 1.84345450D+03,
     $ 1.81745060D+03, 1.79152520D+03, 1.76567790D+03, 1.73990800D+03/
      data ( FUPF( 54,J,2),J=1,20) /
     $ 6.029D-06, 1.184D-05, 1.744D-05, 2.279D-05, 2.794D-05, 3.289D-05,
     $ 3.762D-05, 4.214D-05, 4.646D-05, 5.058D-05, 5.449D-05, 5.821D-05,
     $ 6.172D-05, 6.505D-05, 6.816D-05, 7.108D-05, 7.380D-05, 7.632D-05,
     $ 7.863D-05, 8.073D-05/
      data (WNDNF( 54,J,2),J=1,20) /
     $ 1.85425930D+03, 1.83071230D+03, 1.80722710D+03, 1.78380520D+03,
     $ 1.76044840D+03, 1.73715840D+03, 1.71393670D+03, 1.69078480D+03,
     $ 1.66770430D+03, 1.64469630D+03, 1.62176230D+03, 1.59890340D+03,
     $ 1.57612050D+03, 1.55341460D+03, 1.53078620D+03, 1.50823590D+03,
     $ 1.48576390D+03, 1.46337020D+03, 1.44105460D+03, 1.41881660D+03/
      data ( FDNF( 54,J,2),J=1,20) /
     $ 4.827D-06, 9.523D-06, 1.407D-05, 1.850D-05, 2.281D-05, 2.697D-05,
     $ 3.100D-05, 3.491D-05, 3.869D-05, 4.234D-05, 4.586D-05, 4.927D-05,
     $ 5.253D-05, 5.568D-05, 5.869D-05, 6.156D-05, 6.431D-05, 6.691D-05,
     $ 6.938D-05, 7.169D-05/
      data (WNUPF( 55,J,1),J=1,20) /
     $ 2.29678560D+03, 2.26838100D+03, 2.24004240D+03, 2.21177170D+03,
     $ 2.18357080D+03, 2.15544150D+03, 2.12738560D+03, 2.09940480D+03,
     $ 2.07150070D+03, 2.04367490D+03, 2.01592860D+03, 1.98826320D+03,
     $ 1.96067980D+03, 1.93317900D+03, 1.90576170D+03, 1.87842820D+03,
     $ 1.85117850D+03, 1.82401250D+03, 1.79692960D+03, 1.76992900D+03/
      data ( FUPF( 55,J,1),J=1,20) /
     $ 6.323D-06, 1.240D-05, 1.825D-05, 2.386D-05, 2.924D-05, 3.439D-05,
     $ 3.930D-05, 4.400D-05, 4.848D-05, 5.273D-05, 5.677D-05, 6.060D-05,
     $ 6.421D-05, 6.761D-05, 7.077D-05, 7.376D-05, 7.650D-05, 7.899D-05,
     $ 8.134D-05, 8.335D-05/
      data (WNDNF( 55,J,1),J=1,20) /
     $ 1.88386760D+03, 1.85931370D+03, 1.83482610D+03, 1.81040650D+03,
     $ 1.78605670D+03, 1.76177870D+03, 1.73757400D+03, 1.71344430D+03,
     $ 1.68939130D+03, 1.66541640D+03, 1.64152090D+03, 1.61770610D+03,
     $ 1.59397290D+03, 1.57032220D+03, 1.54675480D+03, 1.52327090D+03,
     $ 1.49987080D+03, 1.47655440D+03, 1.45332120D+03, 1.43017050D+03/
      data ( FDNF( 55,J,1),J=1,20) /
     $ 5.023D-06, 9.910D-06, 1.465D-05, 1.924D-05, 2.370D-05, 2.803D-05,
     $ 3.221D-05, 3.625D-05, 4.017D-05, 4.395D-05, 4.759D-05, 5.109D-05,
     $ 5.447D-05, 5.770D-05, 6.078D-05, 6.376D-05, 6.657D-05, 6.919D-05,
     $ 7.173D-05, 7.403D-05/
      data (WNUPF( 55,J,2),J=1,20) /
     $ 2.24415420D+03, 2.21704100D+03, 2.18998940D+03, 2.16300110D+03,
     $ 2.13607780D+03, 2.10922130D+03, 2.08243310D+03, 2.05571490D+03,
     $ 2.02906800D+03, 2.00249400D+03, 1.97599420D+03, 1.94956960D+03,
     $ 1.92322130D+03, 1.89695020D+03, 1.87075690D+03, 1.84464180D+03,
     $ 1.81860520D+03, 1.79264690D+03, 1.76676670D+03, 1.74096390D+03/
      data ( FUPF( 55,J,2),J=1,20) /
     $ 6.037D-06, 1.185D-05, 1.746D-05, 2.282D-05, 2.797D-05, 3.292D-05,
     $ 3.765D-05, 4.217D-05, 4.649D-05, 5.061D-05, 5.451D-05, 5.823D-05,
     $ 6.174D-05, 6.506D-05, 6.817D-05, 7.108D-05, 7.380D-05, 7.630D-05,
     $ 7.861D-05, 8.070D-05/
      data (WNDNF( 55,J,2),J=1,20) /
     $ 1.84901480D+03, 1.82550040D+03, 1.80204780D+03, 1.77865870D+03,
     $ 1.75533470D+03, 1.73207740D+03, 1.70888850D+03, 1.68576950D+03,
     $ 1.66272170D+03, 1.63974670D+03, 1.61684560D+03, 1.59401960D+03,
     $ 1.57126960D+03, 1.54859660D+03, 1.52600120D+03, 1.50348380D+03,
     $ 1.48104470D+03, 1.45868380D+03, 1.43640110D+03, 1.41419580D+03/
      data ( FDNF( 55,J,2),J=1,20) /
     $ 4.816D-06, 9.505D-06, 1.405D-05, 1.847D-05, 2.276D-05, 2.692D-05,
     $ 3.095D-05, 3.484D-05, 3.861D-05, 4.226D-05, 4.577D-05, 4.917D-05,
     $ 5.244D-05, 5.558D-05, 5.859D-05, 6.146D-05, 6.420D-05, 6.680D-05,
     $ 6.926D-05, 7.158D-05/
      data (WNUPF( 56,J,1),J=1,20) /
     $ 2.29844560D+03, 2.27000590D+03, 2.24163220D+03, 2.21332640D+03,
     $ 2.18509040D+03, 2.15692600D+03, 2.12883500D+03, 2.10081920D+03,
     $ 2.07288000D+03, 2.04501920D+03, 2.01723790D+03, 1.98953750D+03,
     $ 1.96191900D+03, 1.93438330D+03, 1.90693090D+03, 1.87956230D+03,
     $ 1.85227750D+03, 1.82507630D+03, 1.79795810D+03, 1.77092210D+03/
      data ( FUPF( 56,J,1),J=1,20) /
     $ 6.331D-06, 1.242D-05, 1.827D-05, 2.388D-05, 2.926D-05, 3.441D-05,
     $ 3.933D-05, 4.403D-05, 4.850D-05, 5.276D-05, 5.679D-05, 6.061D-05,
     $ 6.423D-05, 6.761D-05, 7.077D-05, 7.375D-05, 7.650D-05, 7.897D-05,
     $ 8.131D-05, 8.331D-05/
      data (WNDNF( 56,J,1),J=1,20) /
     $ 1.87832180D+03, 1.85380300D+03, 1.82935030D+03, 1.80496560D+03,
     $ 1.78065090D+03, 1.75640790D+03, 1.73223830D+03, 1.70814380D+03,
     $ 1.68412590D+03, 1.66018620D+03, 1.63632590D+03, 1.61254630D+03,
     $ 1.58884830D+03, 1.56523290D+03, 1.54170070D+03, 1.51825200D+03,
     $ 1.49488710D+03, 1.47160580D+03, 1.44840770D+03, 1.42529200D+03/
      data ( FDNF( 56,J,1),J=1,20) /
     $ 5.013D-06, 9.885D-06, 1.462D-05, 1.920D-05, 2.365D-05, 2.797D-05,
     $ 3.215D-05, 3.619D-05, 4.009D-05, 4.386D-05, 4.750D-05, 5.100D-05,
     $ 5.436D-05, 5.759D-05, 6.067D-05, 6.364D-05, 6.644D-05, 6.907D-05,
     $ 7.161D-05, 7.389D-05/
      data (WNUPF( 56,J,2),J=1,20) /
     $ 2.24579260D+03, 2.21864660D+03, 2.19156220D+03, 2.16454110D+03,
     $ 2.13758500D+03, 2.11069570D+03, 2.08387480D+03, 2.05712380D+03,
     $ 2.03044420D+03, 2.00383750D+03, 1.97730490D+03, 1.95084760D+03,
     $ 1.92446670D+03, 1.89816280D+03, 1.87193680D+03, 1.84578900D+03,
     $ 1.81971960D+03, 1.79372850D+03, 1.76781530D+03, 1.74197950D+03/
      data ( FUPF( 56,J,2),J=1,20) /
     $ 6.044D-06, 1.186D-05, 1.748D-05, 2.284D-05, 2.800D-05, 3.295D-05,
     $ 3.768D-05, 4.220D-05, 4.651D-05, 5.063D-05, 5.454D-05, 5.825D-05,
     $ 6.176D-05, 6.507D-05, 6.817D-05, 7.108D-05, 7.378D-05, 7.629D-05,
     $ 7.858D-05, 8.066D-05/
      data (WNDNF( 56,J,2),J=1,20) /
     $ 1.84374480D+03, 1.82026310D+03, 1.79684320D+03, 1.77348670D+03,
     $ 1.75019550D+03, 1.72697090D+03, 1.70381480D+03, 1.68072860D+03,
     $ 1.65771370D+03, 1.63477160D+03, 1.61190340D+03, 1.58911030D+03,
     $ 1.56639320D+03, 1.54375320D+03, 1.52119060D+03, 1.49870620D+03,
     $ 1.47630000D+03, 1.45397200D+03, 1.43172210D+03, 1.40954960D+03/
      data ( FDNF( 56,J,2),J=1,20) /
     $ 4.807D-06, 9.478D-06, 1.402D-05, 1.843D-05, 2.272D-05, 2.687D-05,
     $ 3.088D-05, 3.478D-05, 3.854D-05, 4.218D-05, 4.569D-05, 4.908D-05,
     $ 5.235D-05, 5.548D-05, 5.848D-05, 6.135D-05, 6.409D-05, 6.669D-05,
     $ 6.915D-05, 7.146D-05/
      data (WNUPF( 57,J,1),J=1,20) /
     $ 2.30006250D+03, 2.27158770D+03, 2.24317880D+03, 2.21483790D+03,
     $ 2.18656680D+03, 2.15836730D+03, 2.13024120D+03, 2.10219030D+03,
     $ 2.07421610D+03, 2.04632020D+03, 2.01850390D+03, 1.99076850D+03,
     $ 1.96311500D+03, 1.93554420D+03, 1.90805670D+03, 1.88065300D+03,
     $ 1.85333300D+03, 1.82609660D+03, 1.79894320D+03, 1.77187170D+03/
      data ( FUPF( 57,J,1),J=1,20) /
     $ 6.339D-06, 1.243D-05, 1.829D-05, 2.391D-05, 2.929D-05, 3.444D-05,
     $ 3.936D-05, 4.405D-05, 4.853D-05, 5.278D-05, 5.681D-05, 6.063D-05,
     $ 6.423D-05, 6.762D-05, 7.077D-05, 7.374D-05, 7.648D-05, 7.894D-05,
     $ 8.127D-05, 8.326D-05/
      data (WNDNF( 57,J,1),J=1,20) /
     $ 1.87274920D+03, 1.84826520D+03, 1.82384750D+03, 1.79949780D+03,
     $ 1.77521810D+03, 1.75101010D+03, 1.72687560D+03, 1.70281620D+03,
     $ 1.67883350D+03, 1.65492900D+03, 1.63110390D+03, 1.60735950D+03,
     $ 1.58369680D+03, 1.56011660D+03, 1.53661960D+03, 1.51320620D+03,
     $ 1.48987650D+03, 1.46663030D+03, 1.44346730D+03, 1.42038670D+03/
      data ( FDNF( 57,J,1),J=1,20) /
     $ 5.003D-06, 9.861D-06, 1.458D-05, 1.917D-05, 2.361D-05, 2.791D-05,
     $ 3.208D-05, 3.611D-05, 4.001D-05, 4.377D-05, 4.741D-05, 5.090D-05,
     $ 5.426D-05, 5.749D-05, 6.056D-05, 6.353D-05, 6.633D-05, 6.895D-05,
     $ 7.149D-05, 7.377D-05/
      data (WNUPF( 57,J,2),J=1,20) /
     $ 2.24739090D+03, 2.22021210D+03, 2.19309480D+03, 2.16604090D+03,
     $ 2.13905200D+03, 2.11212990D+03, 2.08527620D+03, 2.05849250D+03,
     $ 2.03178020D+03, 2.00514070D+03, 1.97857540D+03, 1.95208540D+03,
     $ 1.92567170D+03, 1.89933520D+03, 1.87307640D+03, 1.84689580D+03,
     $ 1.82079360D+03, 1.79476960D+03, 1.76882350D+03, 1.74295470D+03/
      data ( FUPF( 57,J,2),J=1,20) /
     $ 6.051D-06, 1.188D-05, 1.750D-05, 2.286D-05, 2.803D-05, 3.297D-05,
     $ 3.770D-05, 4.222D-05, 4.654D-05, 5.065D-05, 5.456D-05, 5.827D-05,
     $ 6.177D-05, 6.508D-05, 6.818D-05, 7.108D-05, 7.378D-05, 7.627D-05,
     $ 7.856D-05, 8.062D-05/
      data (WNDNF( 57,J,2),J=1,20) /
     $ 1.83844950D+03, 1.81500040D+03, 1.79161320D+03, 1.76828940D+03,
     $ 1.74503090D+03, 1.72183910D+03, 1.69871580D+03, 1.67566240D+03,
     $ 1.65268040D+03, 1.62977110D+03, 1.60693580D+03, 1.58417560D+03,
     $ 1.56149150D+03, 1.53888440D+03, 1.51635480D+03, 1.49390320D+03,
     $ 1.47152990D+03, 1.44923490D+03, 1.42701780D+03, 1.40487810D+03/
      data ( FDNF( 57,J,2),J=1,20) /
     $ 4.797D-06, 9.461D-06, 1.399D-05, 1.840D-05, 2.267D-05, 2.681D-05,
     $ 3.083D-05, 3.470D-05, 3.847D-05, 4.210D-05, 4.561D-05, 4.899D-05,
     $ 5.225D-05, 5.537D-05, 5.837D-05, 6.124D-05, 6.397D-05, 6.657D-05,
     $ 6.903D-05, 7.134D-05/
      data (WNUPF( 58,J,1),J=1,20) /
     $ 2.30163610D+03, 2.27312610D+03, 2.24468210D+03, 2.21630610D+03,
     $ 2.18799980D+03, 2.15976520D+03, 2.13160400D+03, 2.10351800D+03,
     $ 2.07550880D+03, 2.04757780D+03, 2.01972650D+03, 1.99195600D+03,
     $ 1.96426740D+03, 1.93666160D+03, 1.90913910D+03, 1.88170020D+03,
     $ 1.85434510D+03, 1.82707340D+03, 1.79988460D+03, 1.77277770D+03/
      data ( FUPF( 58,J,1),J=1,20) /
     $ 6.346D-06, 1.245D-05, 1.830D-05, 2.393D-05, 2.931D-05, 3.446D-05,
     $ 3.938D-05, 4.408D-05, 4.856D-05, 5.280D-05, 5.683D-05, 6.064D-05,
     $ 6.424D-05, 6.763D-05, 7.077D-05, 7.373D-05, 7.646D-05, 7.891D-05,
     $ 8.123D-05, 8.321D-05/
      data (WNDNF( 58,J,1),J=1,20) /
     $ 1.86714980D+03, 1.84270070D+03, 1.81831790D+03, 1.79400320D+03,
     $ 1.76975850D+03, 1.74558560D+03, 1.72148620D+03, 1.69746190D+03,
     $ 1.67351430D+03, 1.64964490D+03, 1.62585510D+03, 1.60214590D+03,
     $ 1.57851840D+03, 1.55497350D+03, 1.53151180D+03, 1.50813360D+03,
     $ 1.48483900D+03, 1.46162800D+03, 1.43850010D+03, 1.41545440D+03/
      data ( FDNF( 58,J,1),J=1,20) /
     $ 4.992D-06, 9.846D-06, 1.456D-05, 1.913D-05, 2.356D-05, 2.785D-05,
     $ 3.202D-05, 3.604D-05, 3.993D-05, 4.369D-05, 4.732D-05, 5.080D-05,
     $ 5.416D-05, 5.738D-05, 6.044D-05, 6.341D-05, 6.621D-05, 6.882D-05,
     $ 7.136D-05, 7.363D-05/
      data (WNUPF( 58,J,2),J=1,20) /
     $ 2.24894890D+03, 2.22173720D+03, 2.19458710D+03, 2.16750040D+03,
     $ 2.14047870D+03, 2.11352380D+03, 2.08663730D+03, 2.05982080D+03,
     $ 2.03307570D+03, 2.00640350D+03, 1.97980550D+03, 1.95328280D+03,
     $ 1.92683630D+03, 1.90046700D+03, 1.87417550D+03, 1.84796210D+03,
     $ 1.82182710D+03, 1.79577020D+03, 1.76979120D+03, 1.74388930D+03/
      data ( FUPF( 58,J,2),J=1,20) /
     $ 6.058D-06, 1.189D-05, 1.751D-05, 2.289D-05, 2.805D-05, 3.300D-05,
     $ 3.773D-05, 4.225D-05, 4.657D-05, 5.068D-05, 5.458D-05, 5.829D-05,
     $ 6.178D-05, 6.509D-05, 6.818D-05, 7.108D-05, 7.377D-05, 7.625D-05,
     $ 7.852D-05, 8.058D-05/
      data (WNDNF( 58,J,2),J=1,20) /
     $ 1.83312900D+03, 1.80971260D+03, 1.78635800D+03, 1.76306690D+03,
     $ 1.73984110D+03, 1.71668210D+03, 1.69359150D+03, 1.67057090D+03,
     $ 1.64762180D+03, 1.62474540D+03, 1.60194300D+03, 1.57921570D+03,
     $ 1.55656450D+03, 1.53399030D+03, 1.51149370D+03, 1.48907510D+03,
     $ 1.46673470D+03, 1.44447250D+03, 1.42228820D+03, 1.40018120D+03/
      data ( FDNF( 58,J,2),J=1,20) /
     $ 4.787D-06, 9.444D-06, 1.396D-05, 1.836D-05, 2.262D-05, 2.676D-05,
     $ 3.076D-05, 3.464D-05, 3.839D-05, 4.202D-05, 4.552D-05, 4.891D-05,
     $ 5.215D-05, 5.528D-05, 5.827D-05, 6.114D-05, 6.386D-05, 6.646D-05,
     $ 6.891D-05, 7.121D-05/
      data (WNUPF( 59,J,1),J=1,20) /
     $ 2.30316630D+03, 2.27462120D+03, 2.24614200D+03, 2.21773070D+03,
     $ 2.18938930D+03, 2.16111960D+03, 2.13292330D+03, 2.10480220D+03,
     $ 2.07675790D+03, 2.04879180D+03, 2.02090550D+03, 1.99309990D+03,
     $ 1.96537630D+03, 1.93773540D+03, 1.91017780D+03, 1.88270380D+03,
     $ 1.85531340D+03, 1.82800650D+03, 1.80078230D+03, 1.77363990D+03/
      data ( FUPF( 59,J,1),J=1,20) /
     $ 6.354D-06, 1.246D-05, 1.832D-05, 2.395D-05, 2.934D-05, 3.450D-05,
     $ 3.941D-05, 4.410D-05, 4.858D-05, 5.283D-05, 5.685D-05, 6.066D-05,
     $ 6.426D-05, 6.763D-05, 7.076D-05, 7.373D-05, 7.644D-05, 7.888D-05,
     $ 8.120D-05, 8.315D-05/
      data (WNDNF( 59,J,1),J=1,20) /
     $ 1.86152380D+03, 1.83710960D+03, 1.81276170D+03, 1.78848200D+03,
     $ 1.76427230D+03, 1.74013440D+03, 1.71607000D+03, 1.69208080D+03,
     $ 1.66816840D+03, 1.64433420D+03, 1.62057960D+03, 1.59690560D+03,
     $ 1.57331340D+03, 1.54980370D+03, 1.52637720D+03, 1.50303420D+03,
     $ 1.47977490D+03, 1.45659900D+03, 1.43350620D+03, 1.41049550D+03/
      data ( FDNF( 59,J,1),J=1,20) /
     $ 4.982D-06, 9.824D-06, 1.452D-05, 1.909D-05, 2.351D-05, 2.780D-05,
     $ 3.195D-05, 3.597D-05, 3.986D-05, 4.361D-05, 4.722D-05, 5.071D-05,
     $ 5.406D-05, 5.728D-05, 6.034D-05, 6.329D-05, 6.609D-05, 6.870D-05,
     $ 7.124D-05, 7.350D-05/
      data (WNUPF( 59,J,2),J=1,20) /
     $ 2.25046650D+03, 2.22322200D+03, 2.19603900D+03, 2.16891940D+03,
     $ 2.14186490D+03, 2.11487720D+03, 2.08795790D+03, 2.06110860D+03,
     $ 2.03433080D+03, 2.00762580D+03, 1.98099500D+03, 1.95443960D+03,
     $ 1.92796040D+03, 1.90155830D+03, 1.87523400D+03, 1.84898780D+03,
     $ 1.82281990D+03, 1.79673020D+03, 1.77071810D+03, 1.74478310D+03/
      data ( FUPF( 59,J,2),J=1,20) /
     $ 6.066D-06, 1.191D-05, 1.753D-05, 2.291D-05, 2.808D-05, 3.303D-05,
     $ 3.776D-05, 4.228D-05, 4.660D-05, 5.070D-05, 5.460D-05, 5.830D-05,
     $ 6.179D-05, 6.509D-05, 6.818D-05, 7.107D-05, 7.375D-05, 7.623D-05,
     $ 7.850D-05, 8.054D-05/
      data (WNDNF( 59,J,2),J=1,20) /
     $ 1.82778340D+03, 1.80439970D+03, 1.78107770D+03, 1.75781940D+03,
     $ 1.73462620D+03, 1.71150000D+03, 1.68844220D+03, 1.66545440D+03,
     $ 1.64253810D+03, 1.61969450D+03, 1.59692500D+03, 1.57423070D+03,
     $ 1.55161250D+03, 1.52907120D+03, 1.50660750D+03, 1.48422180D+03,
     $ 1.46191430D+03, 1.43968500D+03, 1.41753350D+03, 1.39545930D+03/
      data ( FDNF( 59,J,2),J=1,20) /
     $ 4.777D-06, 9.420D-06, 1.393D-05, 1.833D-05, 2.258D-05, 2.671D-05,
     $ 3.071D-05, 3.457D-05, 3.832D-05, 4.194D-05, 4.544D-05, 4.881D-05,
     $ 5.206D-05, 5.518D-05, 5.817D-05, 6.103D-05, 6.376D-05, 6.634D-05,
     $ 6.879D-05, 7.109D-05/
      data (WNUPF( 60,J,1),J=1,20) /
     $ 2.30465300D+03, 2.27607260D+03, 2.24755820D+03, 2.21911180D+03,
     $ 2.19073530D+03, 2.16243040D+03, 2.13419900D+03, 2.10604270D+03,
     $ 2.07796330D+03, 2.04996220D+03, 2.02204070D+03, 1.99420010D+03,
     $ 1.96644140D+03, 1.93876540D+03, 1.91117260D+03, 1.88366350D+03,
     $ 1.85623790D+03, 1.82889560D+03, 1.80163600D+03, 1.77445810D+03/
      data ( FUPF( 60,J,1),J=1,20) /
     $ 6.361D-06, 1.248D-05, 1.834D-05, 2.397D-05, 2.936D-05, 3.452D-05,
     $ 3.944D-05, 4.413D-05, 4.861D-05, 5.285D-05, 5.687D-05, 6.067D-05,
     $ 6.426D-05, 6.763D-05, 7.076D-05, 7.371D-05, 7.642D-05, 7.885D-05,
     $ 8.115D-05, 8.310D-05/
      data (WNDNF( 60,J,1),J=1,20) /
     $ 1.85587120D+03, 1.83149200D+03, 1.80717900D+03, 1.78293420D+03,
     $ 1.75875950D+03, 1.73465660D+03, 1.71062730D+03, 1.68667330D+03,
     $ 1.66279600D+03, 1.63899700D+03, 1.61527750D+03, 1.59163880D+03,
     $ 1.56808180D+03, 1.54460740D+03, 1.52121610D+03, 1.49790830D+03,
     $ 1.47468420D+03, 1.45154340D+03, 1.42848570D+03, 1.40551000D+03/
      data ( FDNF( 60,J,1),J=1,20) /
     $ 4.971D-06, 9.802D-06, 1.450D-05, 1.905D-05, 2.346D-05, 2.774D-05,
     $ 3.188D-05, 3.589D-05, 3.978D-05, 4.352D-05, 4.713D-05, 5.061D-05,
     $ 5.396D-05, 5.717D-05, 6.022D-05, 6.318D-05, 6.597D-05, 6.857D-05,
     $ 7.111D-05, 7.337D-05/
      data (WNUPF( 60,J,2),J=1,20) /
     $ 2.25194360D+03, 2.22466620D+03, 2.19745040D+03, 2.17029790D+03,
     $ 2.14321060D+03, 2.11619000D+03, 2.08923790D+03, 2.06235580D+03,
     $ 2.03554510D+03, 2.00880740D+03, 1.98214390D+03, 1.95555560D+03,
     $ 1.92904370D+03, 1.90260890D+03, 1.87625180D+03, 1.84997280D+03,
     $ 1.82377200D+03, 1.79764930D+03, 1.77160430D+03, 1.74563610D+03/
      data ( FUPF( 60,J,2),J=1,20) /
     $ 6.072D-06, 1.192D-05, 1.755D-05, 2.292D-05, 2.810D-05, 3.305D-05,
     $ 3.778D-05, 4.230D-05, 4.662D-05, 5.072D-05, 5.462D-05, 5.832D-05,
     $ 6.181D-05, 6.510D-05, 6.818D-05, 7.107D-05, 7.374D-05, 7.620D-05,
     $ 7.846D-05, 8.050D-05/
      data (WNDNF( 60,J,2),J=1,20) /
     $ 1.82241290D+03, 1.79906180D+03, 1.77577250D+03, 1.75254680D+03,
     $ 1.72938640D+03, 1.70629290D+03, 1.68326790D+03, 1.66031290D+03,
     $ 1.63742940D+03, 1.61461870D+03, 1.59188210D+03, 1.56922070D+03,
     $ 1.54663540D+03, 1.52412710D+03, 1.50169630D+03, 1.47934360D+03,
     $ 1.45706900D+03, 1.43487250D+03, 1.41275380D+03, 1.39071240D+03/
      data ( FDNF( 60,J,2),J=1,20) /
     $ 4.768D-06, 9.405D-06, 1.390D-05, 1.829D-05, 2.254D-05, 2.665D-05,
     $ 3.064D-05, 3.450D-05, 3.825D-05, 4.186D-05, 4.535D-05, 4.872D-05,
     $ 5.196D-05, 5.507D-05, 5.806D-05, 6.092D-05, 6.364D-05, 6.622D-05,
     $ 6.867D-05, 7.097D-05/
      data (WNUPF( 61,J,1),J=1,20) /
     $ 2.30609590D+03, 2.27748030D+03, 2.24893080D+03, 2.22044910D+03,
     $ 2.19203740D+03, 2.16369730D+03, 2.13543080D+03, 2.10723940D+03,
     $ 2.07912490D+03, 2.05108870D+03, 2.02313210D+03, 1.99525640D+03,
     $ 1.96746260D+03, 1.93975150D+03, 1.91212360D+03, 1.88457920D+03,
     $ 1.85711830D+03, 1.82974080D+03, 1.80244570D+03, 1.77523220D+03/
      data ( FUPF( 61,J,1),J=1,20) /
     $ 6.369D-06, 1.249D-05, 1.836D-05, 2.400D-05, 2.939D-05, 3.455D-05,
     $ 3.946D-05, 4.416D-05, 4.863D-05, 5.287D-05, 5.688D-05, 6.069D-05,
     $ 6.427D-05, 6.763D-05, 7.075D-05, 7.369D-05, 7.639D-05, 7.882D-05,
     $ 8.111D-05, 8.306D-05/
      data (WNDNF( 61,J,1),J=1,20) /
     $ 1.85019230D+03, 1.82584790D+03, 1.80156990D+03, 1.77736010D+03,
     $ 1.75322030D+03, 1.72915250D+03, 1.70515820D+03, 1.68123930D+03,
     $ 1.65739720D+03, 1.63363330D+03, 1.60994900D+03, 1.58634550D+03,
     $ 1.56282380D+03, 1.53938460D+03, 1.51602850D+03, 1.49275600D+03,
     $ 1.46956700D+03, 1.44646140D+03, 1.42343870D+03, 1.40049810D+03/
      data ( FDNF( 61,J,1),J=1,20) /
     $ 4.961D-06, 9.780D-06, 1.446D-05, 1.901D-05, 2.341D-05, 2.768D-05,
     $ 3.182D-05, 3.582D-05, 3.969D-05, 4.343D-05, 4.703D-05, 5.051D-05,
     $ 5.385D-05, 5.706D-05, 6.011D-05, 6.306D-05, 6.585D-05, 6.845D-05,
     $ 7.098D-05, 7.324D-05/
      data (WNUPF( 61,J,2),J=1,20) /
     $ 2.25338000D+03, 2.22606970D+03, 2.19882100D+03, 2.17163570D+03,
     $ 2.14451540D+03, 2.11746200D+03, 2.09047710D+03, 2.06356220D+03,
     $ 2.03671870D+03, 2.00994820D+03, 1.98325190D+03, 1.95663090D+03,
     $ 1.93008620D+03, 1.90361860D+03, 1.87722860D+03, 1.85091680D+03,
     $ 1.82468310D+03, 1.79852750D+03, 1.77244940D+03, 1.74644810D+03/
      data ( FUPF( 61,J,2),J=1,20) /
     $ 6.079D-06, 1.193D-05, 1.756D-05, 2.295D-05, 2.812D-05, 3.307D-05,
     $ 3.781D-05, 4.233D-05, 4.664D-05, 5.074D-05, 5.464D-05, 5.833D-05,
     $ 6.182D-05, 6.511D-05, 6.818D-05, 7.106D-05, 7.372D-05, 7.618D-05,
     $ 7.842D-05, 8.045D-05/
      data (WNDNF( 61,J,2),J=1,20) /
     $ 1.81701760D+03, 1.79369910D+03, 1.77044250D+03, 1.74724940D+03,
     $ 1.72412170D+03, 1.70106090D+03, 1.67806870D+03, 1.65514650D+03,
     $ 1.63229590D+03, 1.60951810D+03, 1.58681440D+03, 1.56418590D+03,
     $ 1.54163350D+03, 1.51915810D+03, 1.49676030D+03, 1.47444040D+03,
     $ 1.45219870D+03, 1.43003510D+03, 1.40794930D+03, 1.38594060D+03/
      data ( FDNF( 61,J,2),J=1,20) /
     $ 4.758D-06, 9.382D-06, 1.388D-05, 1.825D-05, 2.249D-05, 2.659D-05,
     $ 3.058D-05, 3.444D-05, 3.817D-05, 4.178D-05, 4.527D-05, 4.863D-05,
     $ 5.186D-05, 5.498D-05, 5.795D-05, 6.080D-05, 6.353D-05, 6.611D-05,
     $ 6.855D-05, 7.085D-05/
      data (WNUPF( 62,J,1),J=1,20) /
     $ 2.30749490D+03, 2.27884420D+03, 2.25025940D+03, 2.22174260D+03,
     $ 2.19329560D+03, 2.16492040D+03, 2.13661860D+03, 2.10839210D+03,
     $ 2.08024250D+03, 2.05217110D+03, 2.02417950D+03, 1.99626870D+03,
     $ 1.96843970D+03, 1.94069340D+03, 1.91303030D+03, 1.88545070D+03,
     $ 1.85795460D+03, 1.83054170D+03, 1.80321120D+03, 1.77596210D+03/
      data ( FUPF( 62,J,1),J=1,20) /
     $ 6.376D-06, 1.250D-05, 1.838D-05, 2.402D-05, 2.941D-05, 3.457D-05,
     $ 3.949D-05, 4.418D-05, 4.865D-05, 5.289D-05, 5.690D-05, 6.070D-05,
     $ 6.428D-05, 6.763D-05, 7.074D-05, 7.368D-05, 7.637D-05, 7.878D-05,
     $ 8.106D-05, 8.301D-05/
      data (WNDNF( 62,J,1),J=1,20) /
     $ 1.84448720D+03, 1.82017770D+03, 1.79593450D+03, 1.77175970D+03,
     $ 1.74765490D+03, 1.72362210D+03, 1.69966290D+03, 1.67577900D+03,
     $ 1.65197200D+03, 1.62824340D+03, 1.60459430D+03, 1.58102600D+03,
     $ 1.55753950D+03, 1.53413550D+03, 1.51081470D+03, 1.48757740D+03,
     $ 1.46442360D+03, 1.44135310D+03, 1.41836550D+03, 1.39545980D+03/
      data ( FDNF( 62,J,1),J=1,20) /
     $ 4.950D-06, 9.760D-06, 1.443D-05, 1.897D-05, 2.337D-05, 2.763D-05,
     $ 3.176D-05, 3.575D-05, 3.962D-05, 4.334D-05, 4.694D-05, 5.042D-05,
     $ 5.375D-05, 5.695D-05, 5.999D-05, 6.294D-05, 6.572D-05, 6.832D-05,
     $ 7.084D-05, 7.310D-05/
      data (WNUPF( 62,J,2),J=1,20) /
     $ 2.25477560D+03, 2.22743240D+03, 2.20015080D+03, 2.17293260D+03,
     $ 2.14577950D+03, 2.11869320D+03, 2.09167540D+03, 2.06472760D+03,
     $ 2.03785140D+03, 2.01104810D+03, 1.98431900D+03, 1.95766520D+03,
     $ 1.93108770D+03, 1.90458730D+03, 1.87816450D+03, 1.85181980D+03,
     $ 1.82555320D+03, 1.79936450D+03, 1.77325340D+03, 1.74721900D+03/
      data ( FUPF( 62,J,2),J=1,20) /
     $ 6.087D-06, 1.194D-05, 1.758D-05, 2.297D-05, 2.815D-05, 3.310D-05,
     $ 3.784D-05, 4.236D-05, 4.667D-05, 5.076D-05, 5.466D-05, 5.835D-05,
     $ 6.183D-05, 6.511D-05, 6.818D-05, 7.104D-05, 7.370D-05, 7.615D-05,
     $ 7.839D-05, 8.041D-05/
      data (WNDNF( 62,J,2),J=1,20) /
     $ 1.81159760D+03, 1.78831170D+03, 1.76508770D+03, 1.74192740D+03,
     $ 1.71883230D+03, 1.69580430D+03, 1.67284480D+03, 1.64995550D+03,
     $ 1.62713760D+03, 1.60439270D+03, 1.58172190D+03, 1.55912630D+03,
     $ 1.53660690D+03, 1.51416440D+03, 1.49179950D+03, 1.46951260D+03,
     $ 1.44730380D+03, 1.42517300D+03, 1.40312000D+03, 1.38114400D+03/
      data ( FDNF( 62,J,2),J=1,20) /
     $ 4.748D-06, 9.368D-06, 1.385D-05, 1.822D-05, 2.244D-05, 2.654D-05,
     $ 3.052D-05, 3.437D-05, 3.810D-05, 4.170D-05, 4.518D-05, 4.854D-05,
     $ 5.177D-05, 5.487D-05, 5.785D-05, 6.070D-05, 6.341D-05, 6.599D-05,
     $ 6.843D-05, 7.072D-05/
      data (WNUPF( 63,J,1),J=1,20) /
     $ 2.30885000D+03, 2.28016400D+03, 2.25154400D+03, 2.22299190D+03,
     $ 2.19450970D+03, 2.16609930D+03, 2.13776240D+03, 2.10950070D+03,
     $ 2.08131590D+03, 2.05320940D+03, 2.02518260D+03, 1.99723670D+03,
     $ 1.96937260D+03, 1.94159110D+03, 1.91389290D+03, 1.88627800D+03,
     $ 1.85874660D+03, 1.83129820D+03, 1.80393220D+03, 1.77664750D+03/
      data ( FUPF( 63,J,1),J=1,20) /
     $ 6.383D-06, 1.251D-05, 1.840D-05, 2.404D-05, 2.943D-05, 3.459D-05,
     $ 3.951D-05, 4.421D-05, 4.867D-05, 5.290D-05, 5.692D-05, 6.071D-05,
     $ 6.428D-05, 6.763D-05, 7.073D-05, 7.366D-05, 7.634D-05, 7.874D-05,
     $ 8.104D-05, 8.288D-05/
      data (WNDNF( 63,J,1),J=1,20) /
     $ 1.83875600D+03, 1.81448130D+03, 1.79027310D+03, 1.76613310D+03,
     $ 1.74206330D+03, 1.71806550D+03, 1.69414140D+03, 1.67029260D+03,
     $ 1.64652080D+03, 1.62282730D+03, 1.59921340D+03, 1.57568030D+03,
     $ 1.55222900D+03, 1.52886030D+03, 1.50557470D+03, 1.48237260D+03,
     $ 1.45925400D+03, 1.43621870D+03, 1.41326610D+03, 1.39039540D+03/
      data ( FDNF( 63,J,1),J=1,20) /
     $ 4.939D-06, 9.740D-06, 1.440D-05, 1.893D-05, 2.331D-05, 2.757D-05,
     $ 3.169D-05, 3.568D-05, 3.954D-05, 4.326D-05, 4.685D-05, 5.031D-05,
     $ 5.365D-05, 5.684D-05, 5.988D-05, 6.282D-05, 6.560D-05, 6.819D-05,
     $ 7.071D-05, 7.297D-05/
      data (WNUPF( 63,J,2),J=1,20) /
     $ 2.25613020D+03, 2.22875410D+03, 2.20143960D+03, 2.17418850D+03,
     $ 2.14700250D+03, 2.11988340D+03, 2.09283270D+03, 2.06585210D+03,
     $ 2.03894300D+03, 2.01210690D+03, 1.98534500D+03, 1.95865840D+03,
     $ 1.93204800D+03, 1.90551480D+03, 1.87905920D+03, 1.85268150D+03,
     $ 1.82638200D+03, 1.80016030D+03, 1.77401610D+03, 1.74794850D+03/
      data ( FUPF( 63,J,2),J=1,20) /
     $ 6.094D-06, 1.195D-05, 1.759D-05, 2.299D-05, 2.817D-05, 3.312D-05,
     $ 3.786D-05, 4.238D-05, 4.669D-05, 5.078D-05, 5.467D-05, 5.836D-05,
     $ 6.183D-05, 6.511D-05, 6.818D-05, 7.103D-05, 7.368D-05, 7.612D-05,
     $ 7.834D-05, 8.032D-05/
      data (WNDNF( 63,J,2),J=1,20) /
     $ 1.80615310D+03, 1.78289980D+03, 1.75970840D+03, 1.73658070D+03,
     $ 1.71351830D+03, 1.69052300D+03, 1.66759630D+03, 1.64473980D+03,
     $ 1.62195480D+03, 1.59924270D+03, 1.57660480D+03, 1.55404210D+03,
     $ 1.53155560D+03, 1.50914610D+03, 1.48681410D+03, 1.46456010D+03,
     $ 1.44238420D+03, 1.42028630D+03, 1.39826610D+03, 1.37632280D+03/
      data ( FDNF( 63,J,2),J=1,20) /
     $ 4.738D-06, 9.346D-06, 1.382D-05, 1.817D-05, 2.239D-05, 2.649D-05,
     $ 3.046D-05, 3.430D-05, 3.802D-05, 4.161D-05, 4.509D-05, 4.844D-05,
     $ 5.167D-05, 5.477D-05, 5.774D-05, 6.058D-05, 6.330D-05, 6.587D-05,
     $ 6.831D-05, 7.059D-05/
      data (WNUPF( 64,J,1),J=1,20) /
     $ 2.31016090D+03, 2.28143960D+03, 2.25278440D+03, 2.22419710D+03,
     $ 2.19567970D+03, 2.16723400D+03, 2.13886190D+03, 2.11056500D+03,
     $ 2.08234510D+03, 2.05420340D+03, 2.02614140D+03, 1.99816030D+03,
     $ 1.97026110D+03, 1.94244450D+03, 1.91471090D+03, 1.88706080D+03,
     $ 1.85949400D+03, 1.83201030D+03, 1.80460870D+03, 1.77728830D+03/
      data ( FUPF( 64,J,1),J=1,20) /
     $ 6.391D-06, 1.253D-05, 1.842D-05, 2.406D-05, 2.946D-05, 3.461D-05,
     $ 3.954D-05, 4.423D-05, 4.869D-05, 5.292D-05, 5.693D-05, 6.072D-05,
     $ 6.428D-05, 6.762D-05, 7.072D-05, 7.364D-05, 7.631D-05, 7.870D-05,
     $ 8.094D-05, 8.283D-05/
      data (WNDNF( 64,J,1),J=1,20) /
     $ 1.83299880D+03, 1.80875900D+03, 1.78458570D+03, 1.76048060D+03,
     $ 1.73644580D+03, 1.71248300D+03, 1.68859390D+03, 1.66478020D+03,
     $ 1.64104350D+03, 1.61738510D+03, 1.59380650D+03, 1.57030860D+03,
     $ 1.54689260D+03, 1.52355910D+03, 1.50030870D+03, 1.47714180D+03,
     $ 1.45405840D+03, 1.43105820D+03, 1.40814060D+03, 1.38530490D+03/
      data ( FDNF( 64,J,1),J=1,20) /
     $ 4.929D-06, 9.721D-06, 1.437D-05, 1.889D-05, 2.327D-05, 2.751D-05,
     $ 3.163D-05, 3.560D-05, 3.945D-05, 4.317D-05, 4.676D-05, 5.021D-05,
     $ 5.353D-05, 5.673D-05, 5.977D-05, 6.271D-05, 6.547D-05, 6.806D-05,
     $ 7.058D-05, 7.283D-05/
      data (WNUPF( 64,J,2),J=1,20) /
     $ 2.25744380D+03, 2.23003480D+03, 2.20268730D+03, 2.17540330D+03,
     $ 2.14818440D+03, 2.12103240D+03, 2.09394880D+03, 2.06693540D+03,
     $ 2.03999340D+03, 2.01312450D+03, 1.98632970D+03, 1.95961030D+03,
     $ 1.93296710D+03, 1.90640100D+03, 1.87991250D+03, 1.85350200D+03,
     $ 1.82716950D+03, 1.80091480D+03, 1.77473740D+03, 1.74863650D+03/
      data ( FUPF( 64,J,2),J=1,20) /
     $ 6.101D-06, 1.197D-05, 1.761D-05, 2.301D-05, 2.819D-05, 3.314D-05,
     $ 3.788D-05, 4.240D-05, 4.671D-05, 5.080D-05, 5.469D-05, 5.837D-05,
     $ 6.184D-05, 6.511D-05, 6.817D-05, 7.102D-05, 7.366D-05, 7.609D-05,
     $ 7.831D-05, 8.031D-05/
      data (WNDNF( 64,J,2),J=1,20) /
     $ 1.80068410D+03, 1.77746340D+03, 1.75430460D+03, 1.73120960D+03,
     $ 1.70817990D+03, 1.68521730D+03, 1.66232340D+03, 1.63949960D+03,
     $ 1.61674740D+03, 1.59406820D+03, 1.57146320D+03, 1.54893340D+03,
     $ 1.52647990D+03, 1.50410330D+03, 1.48180420D+03, 1.45958310D+03,
     $ 1.43744010D+03, 1.41537510D+03, 1.39338770D+03, 1.37147710D+03/
      data ( FDNF( 64,J,2),J=1,20) /
     $ 4.728D-06, 9.326D-06, 1.379D-05, 1.814D-05, 2.235D-05, 2.643D-05,
     $ 3.040D-05, 3.423D-05, 3.795D-05, 4.153D-05, 4.500D-05, 4.835D-05,
     $ 5.157D-05, 5.467D-05, 5.764D-05, 6.047D-05, 6.318D-05, 6.575D-05,
     $ 6.818D-05, 7.047D-05/
      data (WNUPF( 65,J,1),J=1,20) /
     $ 2.31142760D+03, 2.28267100D+03, 2.25398050D+03, 2.22535790D+03,
     $ 2.19680520D+03, 2.16832430D+03, 2.13991700D+03, 2.11158490D+03,
     $ 2.08332970D+03, 2.05515290D+03, 2.02705580D+03, 1.99903950D+03,
     $ 1.97110510D+03, 1.94325320D+03, 1.91548440D+03, 1.88779900D+03,
     $ 1.86019690D+03, 1.83267760D+03, 1.80524050D+03, 1.77788440D+03/
      data ( FUPF( 65,J,1),J=1,20) /
     $ 6.398D-06, 1.254D-05, 1.843D-05, 2.408D-05, 2.948D-05, 3.464D-05,
     $ 3.956D-05, 4.425D-05, 4.871D-05, 5.294D-05, 5.695D-05, 6.072D-05,
     $ 6.429D-05, 6.762D-05, 7.071D-05, 7.362D-05, 7.628D-05, 7.868D-05,
     $ 8.093D-05, 8.279D-05/
      data (WNDNF( 65,J,1),J=1,20) /
     $ 1.82721580D+03, 1.80301090D+03, 1.77887240D+03, 1.75480230D+03,
     $ 1.73080240D+03, 1.70687460D+03, 1.68302050D+03, 1.65924200D+03,
     $ 1.63554030D+03, 1.61191720D+03, 1.58837370D+03, 1.56491100D+03,
     $ 1.54153020D+03, 1.51823200D+03, 1.49501680D+03, 1.47188510D+03,
     $ 1.44883680D+03, 1.42587180D+03, 1.40298930D+03, 1.38018850D+03/
      data ( FDNF( 65,J,1),J=1,20) /
     $ 4.918D-06, 9.695D-06, 1.434D-05, 1.885D-05, 2.322D-05, 2.746D-05,
     $ 3.156D-05, 3.553D-05, 3.937D-05, 4.308D-05, 4.666D-05, 5.011D-05,
     $ 5.344D-05, 5.662D-05, 5.965D-05, 6.258D-05, 6.535D-05, 6.793D-05,
     $ 7.044D-05, 7.269D-05/
      data (WNUPF( 65,J,2),J=1,20) /
     $ 2.25871620D+03, 2.23127420D+03, 2.20389380D+03, 2.17657680D+03,
     $ 2.14932500D+03, 2.12214010D+03, 2.09502360D+03, 2.06797730D+03,
     $ 2.04100250D+03, 2.01410070D+03, 1.98727310D+03, 1.96052080D+03,
     $ 1.93384480D+03, 1.90724580D+03, 1.88072440D+03, 1.85428090D+03,
     $ 1.82791540D+03, 1.80162770D+03, 1.77541710D+03, 1.74928300D+03/
      data ( FUPF( 65,J,2),J=1,20) /
     $ 6.108D-06, 1.198D-05, 1.763D-05, 2.303D-05, 2.821D-05, 3.317D-05,
     $ 3.791D-05, 4.243D-05, 4.673D-05, 5.082D-05, 5.471D-05, 5.838D-05,
     $ 6.184D-05, 6.511D-05, 6.816D-05, 7.100D-05, 7.364D-05, 7.605D-05,
     $ 7.829D-05, 8.023D-05/
      data (WNDNF( 65,J,2),J=1,20) /
     $ 1.79519080D+03, 1.77200270D+03, 1.74887650D+03, 1.72581410D+03,
     $ 1.70281710D+03, 1.67988720D+03, 1.65702600D+03, 1.63423510D+03,
     $ 1.61151570D+03, 1.58886940D+03, 1.56629730D+03, 1.54380040D+03,
     $ 1.52137980D+03, 1.49903610D+03, 1.47677000D+03, 1.45458180D+03,
     $ 1.43247170D+03, 1.41043950D+03, 1.38848480D+03, 1.36660710D+03/
      data ( FDNF( 65,J,2),J=1,20) /
     $ 4.718D-06, 9.305D-06, 1.376D-05, 1.810D-05, 2.231D-05, 2.638D-05,
     $ 3.034D-05, 3.416D-05, 3.787D-05, 4.145D-05, 4.492D-05, 4.825D-05,
     $ 5.147D-05, 5.456D-05, 5.753D-05, 6.036D-05, 6.306D-05, 6.563D-05,
     $ 6.805D-05, 7.034D-05/
      data (WNUPF( 66,J,1),J=1,20) /
     $ 2.31264980D+03, 2.28385790D+03, 2.25513210D+03, 2.22647420D+03,
     $ 2.19788630D+03, 2.16937010D+03, 2.14092750D+03, 2.11256030D+03,
     $ 2.08426990D+03, 2.05605780D+03, 2.02792550D+03, 1.99987400D+03,
     $ 1.97190430D+03, 1.94401720D+03, 1.91621320D+03, 1.88849240D+03,
     $ 1.86085490D+03, 1.83330010D+03, 1.80582740D+03, 1.77843550D+03/
      data ( FUPF( 66,J,1),J=1,20) /
     $ 6.405D-06, 1.256D-05, 1.845D-05, 2.410D-05, 2.950D-05, 3.466D-05,
     $ 3.959D-05, 4.427D-05, 4.873D-05, 5.295D-05, 5.695D-05, 6.073D-05,
     $ 6.428D-05, 6.761D-05, 7.069D-05, 7.360D-05, 7.624D-05, 7.863D-05,
     $ 8.084D-05, 8.275D-05/
      data (WNDNF( 66,J,1),J=1,20) /
     $ 1.82140720D+03, 1.79723710D+03, 1.77313340D+03, 1.74909820D+03,
     $ 1.72513330D+03, 1.70124040D+03, 1.67742150D+03, 1.65367790D+03,
     $ 1.63001140D+03, 1.60642340D+03, 1.58291510D+03, 1.55948770D+03,
     $ 1.53614210D+03, 1.51287910D+03, 1.48969920D+03, 1.46660260D+03,
     $ 1.44358950D+03, 1.42065960D+03, 1.39781210D+03, 1.37504630D+03/
      data ( FDNF( 66,J,1),J=1,20) /
     $ 4.908D-06, 9.677D-06, 1.431D-05, 1.880D-05, 2.317D-05, 2.740D-05,
     $ 3.149D-05, 3.545D-05, 3.929D-05, 4.299D-05, 4.656D-05, 5.002D-05,
     $ 5.332D-05, 5.650D-05, 5.953D-05, 6.246D-05, 6.523D-05, 6.780D-05,
     $ 7.031D-05, 7.256D-05/
      data (WNUPF( 66,J,2),J=1,20) /
     $ 2.25994720D+03, 2.23247230D+03, 2.20505890D+03, 2.17770900D+03,
     $ 2.15042430D+03, 2.12320640D+03, 2.09605700D+03, 2.06897780D+03,
     $ 2.04197010D+03, 2.01503540D+03, 1.98817500D+03, 1.96138980D+03,
     $ 1.93468090D+03, 1.90804900D+03, 1.88149470D+03, 1.85501830D+03,
     $ 1.82861970D+03, 1.80229890D+03, 1.77605520D+03, 1.74988770D+03/
      data ( FUPF( 66,J,2),J=1,20) /
     $ 6.115D-06, 1.199D-05, 1.764D-05, 2.305D-05, 2.823D-05, 3.319D-05,
     $ 3.792D-05, 4.244D-05, 4.675D-05, 5.084D-05, 5.472D-05, 5.839D-05,
     $ 6.185D-05, 6.511D-05, 6.815D-05, 7.098D-05, 7.361D-05, 7.602D-05,
     $ 7.824D-05, 8.015D-05/
      data (WNDNF( 66,J,2),J=1,20) /
     $ 1.78967340D+03, 1.76651780D+03, 1.74342420D+03, 1.72039440D+03,
     $ 1.69743010D+03, 1.67453290D+03, 1.65170450D+03, 1.62894630D+03,
     $ 1.60625980D+03, 1.58364630D+03, 1.56110710D+03, 1.53864310D+03,
     $ 1.51625540D+03, 1.49394470D+03, 1.47171150D+03, 1.44955620D+03,
     $ 1.42747900D+03, 1.40547960D+03, 1.38355780D+03, 1.36171270D+03/
      data ( FDNF( 66,J,2),J=1,20) /
     $ 4.708D-06, 9.286D-06, 1.374D-05, 1.806D-05, 2.226D-05, 2.632D-05,
     $ 3.027D-05, 3.409D-05, 3.780D-05, 4.137D-05, 4.483D-05, 4.816D-05,
     $ 5.137D-05, 5.446D-05, 5.741D-05, 6.025D-05, 6.295D-05, 6.550D-05,
     $ 6.793D-05, 7.021D-05/
      data (WNUPF( 67,J,1),J=1,20) /
     $ 2.31382740D+03, 2.28500030D+03, 2.25623910D+03, 2.22754590D+03,
     $ 2.19892270D+03, 2.17037120D+03, 2.14189340D+03, 2.11349080D+03,
     $ 2.08516520D+03, 2.05691790D+03, 2.02875040D+03, 2.00066370D+03,
     $ 1.97265880D+03, 1.94473640D+03, 1.91689700D+03, 1.88914090D+03,
     $ 1.86146790D+03, 1.83387760D+03, 1.80636920D+03, 1.77894150D+03/
      data ( FUPF( 67,J,1),J=1,20) /
     $ 6.412D-06, 1.256D-05, 1.847D-05, 2.412D-05, 2.953D-05, 3.468D-05,
     $ 3.961D-05, 4.429D-05, 4.874D-05, 5.297D-05, 5.696D-05, 6.074D-05,
     $ 6.428D-05, 6.760D-05, 7.067D-05, 7.356D-05, 7.624D-05, 7.857D-05,
     $ 8.075D-05, 8.263D-05/
      data (WNDNF( 67,J,1),J=1,20) /
     $ 1.81557300D+03, 1.79143770D+03, 1.76736890D+03, 1.74336860D+03,
     $ 1.71943860D+03, 1.69558070D+03, 1.67179680D+03, 1.64808830D+03,
     $ 1.62445690D+03, 1.60090410D+03, 1.57743090D+03, 1.55403870D+03,
     $ 1.53072840D+03, 1.50750060D+03, 1.48435590D+03, 1.46129460D+03,
     $ 1.43831660D+03, 1.41542170D+03, 1.39260930D+03, 1.36987840D+03/
      data ( FDNF( 67,J,1),J=1,20) /
     $ 4.897D-06, 9.659D-06, 1.428D-05, 1.877D-05, 2.312D-05, 2.734D-05,
     $ 3.142D-05, 3.538D-05, 3.921D-05, 4.290D-05, 4.647D-05, 4.991D-05,
     $ 5.322D-05, 5.639D-05, 5.941D-05, 6.234D-05, 6.510D-05, 6.767D-05,
     $ 7.018D-05, 7.241D-05/
      data (WNUPF( 67,J,2),J=1,20) /
     $ 2.26113680D+03, 2.23362890D+03, 2.20618260D+03, 2.17879970D+03,
     $ 2.15148200D+03, 2.12423110D+03, 2.09704890D+03, 2.06993670D+03,
     $ 2.04289610D+03, 2.01592850D+03, 1.98903520D+03, 1.96221710D+03,
     $ 1.93547530D+03, 1.90881050D+03, 1.88222330D+03, 1.85571380D+03,
     $ 1.82928220D+03, 1.80292830D+03, 1.77665130D+03, 1.75045050D+03/
      data ( FUPF( 67,J,2),J=1,20) /
     $ 6.121D-06, 1.201D-05, 1.766D-05, 2.307D-05, 2.826D-05, 3.321D-05,
     $ 3.795D-05, 4.247D-05, 4.677D-05, 5.086D-05, 5.473D-05, 5.840D-05,
     $ 6.185D-05, 6.511D-05, 6.814D-05, 7.096D-05, 7.358D-05, 7.602D-05,
     $ 7.820D-05, 8.015D-05/
      data (WNDNF( 67,J,2),J=1,20) /
     $ 1.78413180D+03, 1.76100880D+03, 1.73794780D+03, 1.71495070D+03,
     $ 1.69201900D+03, 1.66915450D+03, 1.64635880D+03, 1.62363340D+03,
     $ 1.60097970D+03, 1.57839910D+03, 1.55589270D+03, 1.53346170D+03,
     $ 1.51110690D+03, 1.48882910D+03, 1.46662880D+03, 1.44450650D+03,
     $ 1.42246210D+03, 1.40049560D+03, 1.37860650D+03, 1.35679410D+03/
      data ( FDNF( 67,J,2),J=1,20) /
     $ 4.699D-06, 9.267D-06, 1.370D-05, 1.802D-05, 2.221D-05, 2.627D-05,
     $ 3.021D-05, 3.402D-05, 3.772D-05, 4.129D-05, 4.473D-05, 4.807D-05,
     $ 5.127D-05, 5.435D-05, 5.730D-05, 6.013D-05, 6.282D-05, 6.539D-05,
     $ 6.781D-05, 7.007D-05/
      data (WNUPF( 68,J,1),J=1,20) /
     $ 2.31496030D+03, 2.28609780D+03, 2.25730130D+03, 2.22857280D+03,
     $ 2.19991430D+03, 2.17132750D+03, 2.14281440D+03, 2.11437660D+03,
     $ 2.08601570D+03, 2.05773320D+03, 2.02953030D+03, 2.00140840D+03,
     $ 1.97336820D+03, 1.94541050D+03, 1.91753580D+03, 1.88974430D+03,
     $ 1.86203580D+03, 1.83440990D+03, 1.80686580D+03, 1.77940230D+03/
      data ( FUPF( 68,J,1),J=1,20) /
     $ 6.419D-06, 1.258D-05, 1.848D-05, 2.414D-05, 2.954D-05, 3.470D-05,
     $ 3.963D-05, 4.431D-05, 4.876D-05, 5.299D-05, 5.697D-05, 6.074D-05,
     $ 6.427D-05, 6.759D-05, 7.065D-05, 7.353D-05, 7.615D-05, 7.852D-05,
     $ 8.074D-05, 8.259D-05/
      data (WNDNF( 68,J,1),J=1,20) /
     $ 1.80971330D+03, 1.78561290D+03, 1.76157890D+03, 1.73761350D+03,
     $ 1.71371840D+03, 1.68989550D+03, 1.66614660D+03, 1.64247320D+03,
     $ 1.61887700D+03, 1.59535920D+03, 1.57192130D+03, 1.54856430D+03,
     $ 1.52528910D+03, 1.50209650D+03, 1.47898710D+03, 1.45596090D+03,
     $ 1.43301820D+03, 1.41015840D+03, 1.38738100D+03, 1.36468500D+03/
      data ( FDNF( 68,J,1),J=1,20) /
     $ 4.886D-06, 9.635D-06, 1.425D-05, 1.873D-05, 2.307D-05, 2.728D-05,
     $ 3.136D-05, 3.531D-05, 3.912D-05, 4.282D-05, 4.638D-05, 4.981D-05,
     $ 5.311D-05, 5.628D-05, 5.930D-05, 6.221D-05, 6.497D-05, 6.754D-05,
     $ 7.004D-05, 7.227D-05/
      data (WNUPF( 68,J,2),J=1,20) /
     $ 2.26228480D+03, 2.23474390D+03, 2.20726460D+03, 2.17984870D+03,
     $ 2.15249800D+03, 2.12521420D+03, 2.09799900D+03, 2.07085390D+03,
     $ 2.04378040D+03, 2.01677990D+03, 1.98985360D+03, 1.96300260D+03,
     $ 1.93622790D+03, 1.90953020D+03, 1.88291000D+03, 1.85636750D+03,
     $ 1.82990280D+03, 1.80351570D+03, 1.77720550D+03, 1.75097130D+03/
      data ( FUPF( 68,J,2),J=1,20) /
     $ 6.127D-06, 1.201D-05, 1.767D-05, 2.309D-05, 2.827D-05, 3.324D-05,
     $ 3.797D-05, 4.249D-05, 4.679D-05, 5.087D-05, 5.474D-05, 5.841D-05,
     $ 6.185D-05, 6.510D-05, 6.813D-05, 7.094D-05, 7.355D-05, 7.593D-05,
     $ 7.815D-05, 8.007D-05/
      data (WNDNF( 68,J,2),J=1,20) /
     $ 1.77856640D+03, 1.75547590D+03, 1.73244750D+03, 1.70948290D+03,
     $ 1.68658390D+03, 1.66375220D+03, 1.64098920D+03, 1.61829660D+03,
     $ 1.59567570D+03, 1.57312790D+03, 1.55065440D+03, 1.52825630D+03,
     $ 1.50593440D+03, 1.48368950D+03, 1.46152220D+03, 1.43943270D+03,
     $ 1.41742120D+03, 1.39548750D+03, 1.37363120D+03, 1.35185160D+03/
      data ( FDNF( 68,J,2),J=1,20) /
     $ 4.688D-06, 9.248D-06, 1.368D-05, 1.799D-05, 2.217D-05, 2.622D-05,
     $ 3.015D-05, 3.396D-05, 3.764D-05, 4.120D-05, 4.465D-05, 4.797D-05,
     $ 5.117D-05, 5.425D-05, 5.720D-05, 6.001D-05, 6.271D-05, 6.526D-05,
     $ 6.768D-05, 6.995D-05/
      data (WNUPF( 69,J,1),J=1,20) /
     $ 2.31604840D+03, 2.28715050D+03, 2.25831870D+03, 2.22955480D+03,
     $ 2.20086090D+03, 2.17223880D+03, 2.14369040D+03, 2.11521730D+03,
     $ 2.08682110D+03, 2.05850330D+03, 2.03026520D+03, 2.00210800D+03,
     $ 1.97403250D+03, 1.94603950D+03, 1.91812940D+03, 1.89030240D+03,
     $ 1.86255840D+03, 1.83489690D+03, 1.80731710D+03, 1.77981770D+03/
      data ( FUPF( 69,J,1),J=1,20) /
     $ 6.426D-06, 1.259D-05, 1.850D-05, 2.416D-05, 2.956D-05, 3.472D-05,
     $ 3.965D-05, 4.433D-05, 4.877D-05, 5.299D-05, 5.698D-05, 6.074D-05,
     $ 6.427D-05, 6.758D-05, 7.063D-05, 7.350D-05, 7.613D-05, 7.847D-05,
     $ 8.066D-05, 8.248D-05/
      data (WNDNF( 69,J,1),J=1,20) /
     $ 1.80382850D+03, 1.77976280D+03, 1.75576370D+03, 1.73183310D+03,
     $ 1.70797290D+03, 1.68418500D+03, 1.66047110D+03, 1.63683280D+03,
     $ 1.61327160D+03, 1.58978900D+03, 1.56638630D+03, 1.54306450D+03,
     $ 1.51982450D+03, 1.49666720D+03, 1.47359290D+03, 1.45060200D+03,
     $ 1.42769430D+03, 1.40486960D+03, 1.38212730D+03, 1.35946620D+03/
      data ( FDNF( 69,J,1),J=1,20) /
     $ 4.876D-06, 9.612D-06, 1.422D-05, 1.868D-05, 2.302D-05, 2.722D-05,
     $ 3.129D-05, 3.523D-05, 3.904D-05, 4.273D-05, 4.628D-05, 4.971D-05,
     $ 5.301D-05, 5.617D-05, 5.918D-05, 6.209D-05, 6.484D-05, 6.740D-05,
     $ 6.990D-05, 7.216D-05/
      data (WNUPF( 69,J,2),J=1,20) /
     $ 2.26339110D+03, 2.23581720D+03, 2.20830480D+03, 2.18085590D+03,
     $ 2.15347220D+03, 2.12615540D+03, 2.09890720D+03, 2.07172920D+03,
     $ 2.04462270D+03, 2.01758930D+03, 1.99063010D+03, 1.96374620D+03,
     $ 1.93693850D+03, 1.91020780D+03, 1.88355460D+03, 1.85697910D+03,
     $ 1.83048130D+03, 1.80406100D+03, 1.77771750D+03, 1.75144990D+03/
      data ( FUPF( 69,J,2),J=1,20) /
     $ 6.134D-06, 1.203D-05, 1.769D-05, 2.310D-05, 2.829D-05, 3.326D-05,
     $ 3.799D-05, 4.250D-05, 4.680D-05, 5.088D-05, 5.475D-05, 5.841D-05,
     $ 6.185D-05, 6.509D-05, 6.811D-05, 7.092D-05, 7.350D-05, 7.591D-05,
     $ 7.803D-05, 8.000D-05/
      data (WNDNF( 69,J,2),J=1,20) /
     $ 1.77297710D+03, 1.74991920D+03, 1.72692330D+03, 1.70399140D+03,
     $ 1.68112500D+03, 1.65832590D+03, 1.63559570D+03, 1.61293580D+03,
     $ 1.59034780D+03, 1.56783280D+03, 1.54539220D+03, 1.52302690D+03,
     $ 1.50073800D+03, 1.47852600D+03, 1.45639160D+03, 1.43433510D+03,
     $ 1.41235640D+03, 1.39045560D+03, 1.36863210D+03, 1.34688510D+03/
      data ( FDNF( 69,J,2),J=1,20) /
     $ 4.678D-06, 9.230D-06, 1.365D-05, 1.795D-05, 2.212D-05, 2.617D-05,
     $ 3.009D-05, 3.388D-05, 3.756D-05, 4.112D-05, 4.455D-05, 4.788D-05,
     $ 5.106D-05, 5.414D-05, 5.709D-05, 5.990D-05, 6.258D-05, 6.514D-05,
     $ 6.755D-05, 6.981D-05/
      data (WNUPF( 70,J,1),J=1,20) /
     $ 2.31709150D+03, 2.28815820D+03, 2.25929100D+03, 2.23049170D+03,
     $ 2.20176240D+03, 2.17310500D+03, 2.14452120D+03, 2.11601280D+03,
     $ 2.08758130D+03, 2.05922820D+03, 2.03095480D+03, 2.00276230D+03,
     $ 1.97465140D+03, 1.94662310D+03, 1.91867760D+03, 1.89081520D+03,
     $ 1.86303560D+03, 1.83533850D+03, 1.80772280D+03, 1.78018740D+03/
      data ( FUPF( 70,J,1),J=1,20) /
     $ 6.432D-06, 1.260D-05, 1.852D-05, 2.418D-05, 2.958D-05, 3.475D-05,
     $ 3.967D-05, 4.435D-05, 4.879D-05, 5.301D-05, 5.699D-05, 6.074D-05,
     $ 6.427D-05, 6.756D-05, 7.060D-05, 7.345D-05, 7.604D-05, 7.842D-05,
     $ 8.058D-05, 8.237D-05/
      data (WNDNF( 70,J,1),J=1,20) /
     $ 1.79791840D+03, 1.77388750D+03, 1.74992320D+03, 1.72602750D+03,
     $ 1.70220230D+03, 1.67844930D+03, 1.65477040D+03, 1.63116710D+03,
     $ 1.60764110D+03, 1.58419360D+03, 1.56082600D+03, 1.53753940D+03,
     $ 1.51433470D+03, 1.49121260D+03, 1.46817350D+03, 1.44521770D+03,
     $ 1.42234520D+03, 1.39955560D+03, 1.37684830D+03, 1.35422210D+03/
      data ( FDNF( 70,J,1),J=1,20) /
     $ 4.865D-06, 9.596D-06, 1.418D-05, 1.865D-05, 2.297D-05, 2.716D-05,
     $ 3.123D-05, 3.516D-05, 3.896D-05, 4.264D-05, 4.618D-05, 4.960D-05,
     $ 5.289D-05, 5.606D-05, 5.906D-05, 6.196D-05, 6.471D-05, 6.727D-05,
     $ 6.976D-05, 7.199D-05/
      data (WNUPF( 70,J,2),J=1,20) /
     $ 2.26445560D+03, 2.23684860D+03, 2.20930320D+03, 2.18182130D+03,
     $ 2.15440450D+03, 2.12705470D+03, 2.09977350D+03, 2.07256250D+03,
     $ 2.04542310D+03, 2.01835670D+03, 1.99136450D+03, 1.96444770D+03,
     $ 1.93760700D+03, 1.91084340D+03, 1.88415710D+03, 1.85754850D+03,
     $ 1.83101760D+03, 1.80456400D+03, 1.77818720D+03, 1.75188610D+03/
      data ( FUPF( 70,J,2),J=1,20) /
     $ 6.140D-06, 1.204D-05, 1.771D-05, 2.312D-05, 2.832D-05, 3.327D-05,
     $ 3.801D-05, 4.253D-05, 4.682D-05, 5.090D-05, 5.476D-05, 5.841D-05,
     $ 6.185D-05, 6.508D-05, 6.809D-05, 7.090D-05, 7.345D-05, 7.583D-05,
     $ 7.799D-05, 7.993D-05/
      data (WNDNF( 70,J,2),J=1,20) /
     $ 1.76736420D+03, 1.74433870D+03, 1.72137550D+03, 1.69847610D+03,
     $ 1.67564240D+03, 1.65287590D+03, 1.63017840D+03, 1.60755130D+03,
     $ 1.58499610D+03, 1.56251400D+03, 1.54010620D+03, 1.51777390D+03,
     $ 1.49551780D+03, 1.47333880D+03, 1.45123730D+03, 1.42921360D+03,
     $ 1.40726790D+03, 1.38539980D+03, 1.36360910D+03, 1.34189480D+03/
      data ( FDNF( 70,J,2),J=1,20) /
     $ 4.668D-06, 9.213D-06, 1.362D-05, 1.791D-05, 2.207D-05, 2.611D-05,
     $ 3.002D-05, 3.382D-05, 3.749D-05, 4.104D-05, 4.447D-05, 4.778D-05,
     $ 5.096D-05, 5.404D-05, 5.697D-05, 5.979D-05, 6.247D-05, 6.501D-05,
     $ 6.742D-05, 6.968D-05/
      data (WNUPF( 71,J,1),J=1,20) /
     $ 2.31808940D+03, 2.28912070D+03, 2.26021810D+03, 2.23138340D+03,
     $ 2.20261870D+03, 2.17392590D+03, 2.14530680D+03, 2.11676300D+03,
     $ 2.08829620D+03, 2.05990770D+03, 2.03159900D+03, 2.00337110D+03,
     $ 1.97522490D+03, 1.94716120D+03, 1.91918030D+03, 1.89128230D+03,
     $ 1.86346720D+03, 1.83573430D+03, 1.80808290D+03, 1.78051150D+03/
      data ( FUPF( 71,J,1),J=1,20) /
     $ 6.439D-06, 1.262D-05, 1.853D-05, 2.419D-05, 2.960D-05, 3.477D-05,
     $ 3.968D-05, 4.436D-05, 4.881D-05, 5.301D-05, 5.699D-05, 6.074D-05,
     $ 6.426D-05, 6.755D-05, 7.058D-05, 7.340D-05, 7.603D-05, 7.837D-05,
     $ 8.050D-05, 8.234D-05/
      data (WNDNF( 71,J,1),J=1,20) /
     $ 1.79198340D+03, 1.76798720D+03, 1.74405770D+03, 1.72019690D+03,
     $ 1.69640650D+03, 1.67268850D+03, 1.64904460D+03, 1.62547640D+03,
     $ 1.60198540D+03, 1.57857310D+03, 1.55524070D+03, 1.53198930D+03,
     $ 1.50881980D+03, 1.48573280D+03, 1.46272900D+03, 1.43980840D+03,
     $ 1.41697100D+03, 1.39421650D+03, 1.37154410D+03, 1.34895290D+03/
      data ( FDNF( 71,J,1),J=1,20) /
     $ 4.855D-06, 9.573D-06, 1.415D-05, 1.860D-05, 2.292D-05, 2.710D-05,
     $ 3.116D-05, 3.508D-05, 3.888D-05, 4.255D-05, 4.609D-05, 4.950D-05,
     $ 5.279D-05, 5.594D-05, 5.894D-05, 6.184D-05, 6.458D-05, 6.713D-05,
     $ 6.962D-05, 7.182D-05/
      data (WNUPF( 71,J,2),J=1,20) /
     $ 2.26547800D+03, 2.23783800D+03, 2.21025950D+03, 2.18274450D+03,
     $ 2.15529480D+03, 2.12791190D+03, 2.10059770D+03, 2.07335370D+03,
     $ 2.04618130D+03, 2.01908190D+03, 1.99205680D+03, 1.96510690D+03,
     $ 1.93823330D+03, 1.91143660D+03, 1.88471720D+03, 1.85807550D+03,
     $ 1.83151140D+03, 1.80502460D+03, 1.77861440D+03, 1.75227990D+03/
      data ( FUPF( 71,J,2),J=1,20) /
     $ 6.147D-06, 1.205D-05, 1.772D-05, 2.314D-05, 2.833D-05, 3.330D-05,
     $ 3.803D-05, 4.254D-05, 4.684D-05, 5.091D-05, 5.477D-05, 5.841D-05,
     $ 6.184D-05, 6.507D-05, 6.807D-05, 7.087D-05, 7.348D-05, 7.582D-05,
     $ 7.794D-05, 7.986D-05/
      data (WNDNF( 71,J,2),J=1,20) /
     $ 1.76172760D+03, 1.73873470D+03, 1.71580400D+03, 1.69293720D+03,
     $ 1.67013610D+03, 1.64740230D+03, 1.62473750D+03, 1.60214320D+03,
     $ 1.57962070D+03, 1.55717150D+03, 1.53479660D+03, 1.51249710D+03,
     $ 1.49027400D+03, 1.46812790D+03, 1.44605930D+03, 1.42406850D+03,
     $ 1.40215560D+03, 1.38032040D+03, 1.35856240D+03, 1.33688080D+03/
      data ( FDNF( 71,J,2),J=1,20) /
     $ 4.659D-06, 9.189D-06, 1.359D-05, 1.787D-05, 2.202D-05, 2.606D-05,
     $ 2.996D-05, 3.374D-05, 3.741D-05, 4.095D-05, 4.438D-05, 4.769D-05,
     $ 5.087D-05, 5.392D-05, 5.686D-05, 5.966D-05, 6.234D-05, 6.489D-05,
     $ 6.729D-05, 6.955D-05/
      data (WNUPF( 72,J,1),J=1,20) /
     $ 2.31904210D+03, 2.29003790D+03, 2.26109980D+03, 2.23222970D+03,
     $ 2.20342960D+03, 2.17470140D+03, 2.14604690D+03, 2.11746770D+03,
     $ 2.08896550D+03, 2.06054170D+03, 2.03219770D+03, 2.00393440D+03,
     $ 1.97575280D+03, 1.94765360D+03, 1.91963730D+03, 1.89170380D+03,
     $ 1.86385300D+03, 1.83608440D+03, 1.80839700D+03, 1.78078960D+03/
      data ( FUPF( 72,J,1),J=1,20) /
     $ 6.445D-06, 1.263D-05, 1.855D-05, 2.421D-05, 2.962D-05, 3.478D-05,
     $ 3.970D-05, 4.438D-05, 4.882D-05, 5.302D-05, 5.699D-05, 6.073D-05,
     $ 6.424D-05, 6.752D-05, 7.056D-05, 7.343D-05, 7.601D-05, 7.825D-05,
     $ 8.042D-05, 8.224D-05/
      data (WNDNF( 72,J,1),J=1,20) /
     $ 1.78602350D+03, 1.76206210D+03, 1.73816740D+03, 1.71434130D+03,
     $ 1.69058590D+03, 1.66690280D+03, 1.64329390D+03, 1.61976070D+03,
     $ 1.59630480D+03, 1.57292760D+03, 1.54963040D+03, 1.52641420D+03,
     $ 1.50327980D+03, 1.48022810D+03, 1.45725950D+03, 1.43437400D+03,
     $ 1.41157180D+03, 1.38885240D+03, 1.36621500D+03, 1.34365860D+03/
      data ( FDNF( 72,J,1),J=1,20) /
     $ 4.843D-06, 9.552D-06, 1.412D-05, 1.857D-05, 2.287D-05, 2.704D-05,
     $ 3.109D-05, 3.501D-05, 3.880D-05, 4.246D-05, 4.599D-05, 4.940D-05,
     $ 5.268D-05, 5.583D-05, 5.882D-05, 6.172D-05, 6.445D-05, 6.700D-05,
     $ 6.945D-05, 7.172D-05/
      data (WNUPF( 72,J,2),J=1,20) /
     $ 2.26645830D+03, 2.23878520D+03, 2.21117370D+03, 2.18362560D+03,
     $ 2.15614280D+03, 2.12872690D+03, 2.10137960D+03, 2.07410260D+03,
     $ 2.04689720D+03, 2.01976480D+03, 1.99270660D+03, 1.96572380D+03,
     $ 1.93881710D+03, 1.91198740D+03, 1.88523500D+03, 1.85856010D+03,
     $ 1.83196280D+03, 1.80544270D+03, 1.77899910D+03, 1.75263100D+03/
      data ( FUPF( 72,J,2),J=1,20) /
     $ 6.153D-06, 1.206D-05, 1.773D-05, 2.316D-05, 2.835D-05, 3.331D-05,
     $ 3.805D-05, 4.256D-05, 4.685D-05, 5.092D-05, 5.478D-05, 5.841D-05,
     $ 6.184D-05, 6.506D-05, 6.806D-05, 7.084D-05, 7.343D-05, 7.573D-05,
     $ 7.790D-05, 7.979D-05/
      data (WNDNF( 72,J,2),J=1,20) /
     $ 1.75606770D+03, 1.73310720D+03, 1.71020900D+03, 1.68737480D+03,
     $ 1.66460630D+03, 1.64190520D+03, 1.61927320D+03, 1.59671160D+03,
     $ 1.57422190D+03, 1.55180550D+03, 1.52946350D+03, 1.50719690D+03,
     $ 1.48500660D+03, 1.46289340D+03, 1.44085770D+03, 1.41889990D+03,
     $ 1.39701980D+03, 1.37521750D+03, 1.35349220D+03, 1.33184320D+03/
      data ( FDNF( 72,J,2),J=1,20) /
     $ 4.648D-06, 9.172D-06, 1.356D-05, 1.783D-05, 2.198D-05, 2.600D-05,
     $ 2.990D-05, 3.368D-05, 3.733D-05, 4.087D-05, 4.429D-05, 4.759D-05,
     $ 5.077D-05, 5.382D-05, 5.674D-05, 5.955D-05, 6.222D-05, 6.476D-05,
     $ 6.716D-05, 6.938D-05/
      data (WNUPF( 73,J,1),J=1,20) /
     $ 2.31994930D+03, 2.29090970D+03, 2.26193610D+03, 2.23303050D+03,
     $ 2.20419500D+03, 2.17543130D+03, 2.14674140D+03, 2.11812680D+03,
     $ 2.08958920D+03, 2.06113010D+03, 2.03275060D+03, 2.00445190D+03,
     $ 1.97623490D+03, 1.94810030D+03, 1.92004840D+03, 1.89207930D+03,
     $ 1.86419290D+03, 1.83638850D+03, 1.80866520D+03, 1.78102160D+03/
      data ( FUPF( 73,J,1),J=1,20) /
     $ 6.452D-06, 1.264D-05, 1.857D-05, 2.423D-05, 2.964D-05, 3.480D-05,
     $ 3.972D-05, 4.439D-05, 4.883D-05, 5.303D-05, 5.699D-05, 6.073D-05,
     $ 6.423D-05, 6.750D-05, 7.055D-05, 7.338D-05, 7.593D-05, 7.821D-05,
     $ 8.034D-05, 8.214D-05/
      data (WNDNF( 73,J,1),J=1,20) /
     $ 1.78003880D+03, 1.75611210D+03, 1.73225220D+03, 1.70846100D+03,
     $ 1.68474040D+03, 1.66109230D+03, 1.63751830D+03, 1.61402020D+03,
     $ 1.59059940D+03, 1.56725740D+03, 1.54399530D+03, 1.52081420D+03,
     $ 1.49771510D+03, 1.47469860D+03, 1.45176510D+03, 1.42891480D+03,
     $ 1.40614770D+03, 1.38346330D+03, 1.36086090D+03, 1.33833940D+03/
      data ( FDNF( 73,J,1),J=1,20) /
     $ 4.833D-06, 9.531D-06, 1.410D-05, 1.852D-05, 2.282D-05, 2.699D-05,
     $ 3.102D-05, 3.493D-05, 3.871D-05, 4.237D-05, 4.590D-05, 4.930D-05,
     $ 5.257D-05, 5.571D-05, 5.870D-05, 6.159D-05, 6.432D-05, 6.686D-05,
     $ 6.932D-05, 7.156D-05/
      data (WNUPF( 73,J,2),J=1,20) /
     $ 2.26739640D+03, 2.23969020D+03, 2.21204560D+03, 2.18446440D+03,
     $ 2.15694850D+03, 2.12949950D+03, 2.10211920D+03, 2.07480910D+03,
     $ 2.04757060D+03, 2.02040520D+03, 1.99331400D+03, 1.96629810D+03,
     $ 1.93935840D+03, 1.91249560D+03, 1.88571010D+03, 1.85900200D+03,
     $ 1.83237150D+03, 1.80581800D+03, 1.77934090D+03, 1.75293920D+03/
      data ( FUPF( 73,J,2),J=1,20) /
     $ 6.159D-06, 1.208D-05, 1.775D-05, 2.317D-05, 2.837D-05, 3.333D-05,
     $ 3.806D-05, 4.257D-05, 4.686D-05, 5.093D-05, 5.478D-05, 5.841D-05,
     $ 6.183D-05, 6.504D-05, 6.803D-05, 7.083D-05, 7.338D-05, 7.572D-05,
     $ 7.779D-05, 7.972D-05/
      data (WNDNF( 73,J,2),J=1,20) /
     $ 1.75038440D+03, 1.72745640D+03, 1.70459070D+03, 1.68178910D+03,
     $ 1.65905320D+03, 1.63638480D+03, 1.61378540D+03, 1.59125650D+03,
     $ 1.56879970D+03, 1.54641610D+03, 1.52410690D+03, 1.50187320D+03,
     $ 1.47971590D+03, 1.45763560D+03, 1.43563280D+03, 1.41370780D+03,
     $ 1.39186060D+03, 1.37009100D+03, 1.34839850D+03, 1.32678220D+03/
      data ( FDNF( 73,J,2),J=1,20) /
     $ 4.638D-06, 9.150D-06, 1.353D-05, 1.780D-05, 2.193D-05, 2.595D-05,
     $ 2.984D-05, 3.361D-05, 3.726D-05, 4.078D-05, 4.420D-05, 4.749D-05,
     $ 5.066D-05, 5.371D-05, 5.663D-05, 5.944D-05, 6.210D-05, 6.463D-05,
     $ 6.703D-05, 6.925D-05/
      data (WNUPF( 74,J,1),J=1,20) /
     $ 2.32081090D+03, 2.29173580D+03, 2.26272670D+03, 2.23378570D+03,
     $ 2.20491470D+03, 2.17611550D+03, 2.14739010D+03, 2.11874010D+03,
     $ 2.09016710D+03, 2.06167250D+03, 2.03325760D+03, 2.00492350D+03,
     $ 1.97667110D+03, 1.94850100D+03, 1.92041350D+03, 1.89240880D+03,
     $ 1.86448660D+03, 1.83664640D+03, 1.80888710D+03, 1.78120740D+03/
      data ( FUPF( 74,J,1),J=1,20) /
     $ 6.459D-06, 1.265D-05, 1.858D-05, 2.424D-05, 2.966D-05, 3.482D-05,
     $ 3.973D-05, 4.440D-05, 4.884D-05, 5.303D-05, 5.699D-05, 6.072D-05,
     $ 6.422D-05, 6.748D-05, 7.048D-05, 7.333D-05, 7.585D-05, 7.816D-05,
     $ 8.027D-05, 8.204D-05/
      data (WNDNF( 74,J,1),J=1,20) /
     $ 1.77402950D+03, 1.75013760D+03, 1.72631240D+03, 1.70255600D+03,
     $ 1.67887030D+03, 1.65525710D+03, 1.63171810D+03, 1.60825500D+03,
     $ 1.58486930D+03, 1.56156230D+03, 1.53833540D+03, 1.51518950D+03,
     $ 1.49212560D+03, 1.46914430D+03, 1.44624600D+03, 1.42343090D+03,
     $ 1.40069890D+03, 1.37804950D+03, 1.35548210D+03, 1.33299540D+03/
      data ( FDNF( 74,J,1),J=1,20) /
     $ 4.822D-06, 9.510D-06, 1.406D-05, 1.848D-05, 2.277D-05, 2.693D-05,
     $ 3.095D-05, 3.485D-05, 3.863D-05, 4.228D-05, 4.580D-05, 4.919D-05,
     $ 5.246D-05, 5.559D-05, 5.858D-05, 6.146D-05, 6.419D-05, 6.672D-05,
     $ 6.919D-05, 7.141D-05/
      data (WNUPF( 74,J,2),J=1,20) /
     $ 2.26829220D+03, 2.24055280D+03, 2.21287500D+03, 2.18526070D+03,
     $ 2.15771170D+03, 2.13022960D+03, 2.10281620D+03, 2.07547300D+03,
     $ 2.04820150D+03, 2.02100300D+03, 1.99387880D+03, 1.96682980D+03,
     $ 1.93985710D+03, 1.91296110D+03, 1.88614240D+03, 1.85940120D+03,
     $ 1.83273730D+03, 1.80615050D+03, 1.77963990D+03, 1.75320460D+03/
      data ( FUPF( 74,J,2),J=1,20) /
     $ 6.165D-06, 1.208D-05, 1.776D-05, 2.319D-05, 2.839D-05, 3.335D-05,
     $ 3.808D-05, 4.259D-05, 4.688D-05, 5.094D-05, 5.478D-05, 5.841D-05,
     $ 6.182D-05, 6.503D-05, 6.801D-05, 7.075D-05, 7.333D-05, 7.565D-05,
     $ 7.776D-05, 7.959D-05/
      data (WNDNF( 74,J,2),J=1,20) /
     $ 1.74467790D+03, 1.72178240D+03, 1.69894920D+03, 1.67618010D+03,
     $ 1.65347680D+03, 1.63084100D+03, 1.60827430D+03, 1.58577820D+03,
     $ 1.56335420D+03, 1.54100340D+03, 1.51872710D+03, 1.49652630D+03,
     $ 1.47440180D+03, 1.45235440D+03, 1.43038450D+03, 1.40849240D+03,
     $ 1.38667810D+03, 1.36494130D+03, 1.34328150D+03, 1.32169780D+03/
      data ( FDNF( 74,J,2),J=1,20) /
     $ 4.628D-06, 9.128D-06, 1.350D-05, 1.776D-05, 2.189D-05, 2.589D-05,
     $ 2.977D-05, 3.353D-05, 3.717D-05, 4.070D-05, 4.411D-05, 4.739D-05,
     $ 5.056D-05, 5.360D-05, 5.652D-05, 5.932D-05, 6.197D-05, 6.450D-05,
     $ 6.689D-05, 6.913D-05/
      data (WNUPF( 75,J,1),J=1,20) /
     $ 2.32162680D+03, 2.29251620D+03, 2.26347160D+03, 2.23449500D+03,
     $ 2.20558850D+03, 2.17675390D+03, 2.14799300D+03, 2.11930750D+03,
     $ 2.09069910D+03, 2.06216900D+03, 2.03371870D+03, 2.00534910D+03,
     $ 1.97706120D+03, 1.94885550D+03, 1.92073250D+03, 1.89269210D+03,
     $ 1.86473410D+03, 1.83685800D+03, 1.80906270D+03, 1.78134680D+03/
      data ( FUPF( 75,J,1),J=1,20) /
     $ 6.464D-06, 1.266D-05, 1.859D-05, 2.426D-05, 2.968D-05, 3.484D-05,
     $ 3.975D-05, 4.442D-05, 4.885D-05, 5.304D-05, 5.699D-05, 6.071D-05,
     $ 6.420D-05, 6.745D-05, 7.047D-05, 7.329D-05, 7.584D-05, 7.805D-05,
     $ 8.020D-05, 8.195D-05/
      data (WNDNF( 75,J,1),J=1,20) /
     $ 1.76799580D+03, 1.74413850D+03, 1.72034810D+03, 1.69662650D+03,
     $ 1.67297570D+03, 1.64939740D+03, 1.62589340D+03, 1.60246530D+03,
     $ 1.57911460D+03, 1.55584280D+03, 1.53265100D+03, 1.50954030D+03,
     $ 1.48651150D+03, 1.46356540D+03, 1.44070230D+03, 1.41792230D+03,
     $ 1.39522540D+03, 1.37261110D+03, 1.35007860D+03, 1.32762680D+03/
      data ( FDNF( 75,J,1),J=1,20) /
     $ 4.811D-06, 9.490D-06, 1.403D-05, 1.844D-05, 2.272D-05, 2.687D-05,
     $ 3.089D-05, 3.478D-05, 3.855D-05, 4.219D-05, 4.570D-05, 4.909D-05,
     $ 5.235D-05, 5.548D-05, 5.846D-05, 6.134D-05, 6.405D-05, 6.662D-05,
     $ 6.907D-05, 7.126D-05/
      data (WNUPF( 75,J,2),J=1,20) /
     $ 2.26914540D+03, 2.24137280D+03, 2.21366190D+03, 2.18601440D+03,
     $ 2.15843230D+03, 2.13091710D+03, 2.10347060D+03, 2.07609430D+03,
     $ 2.04878970D+03, 2.02155810D+03, 1.99440080D+03, 1.96731870D+03,
     $ 1.94031290D+03, 1.91338380D+03, 1.88653190D+03, 1.85975740D+03,
     $ 1.83306020D+03, 1.80644000D+03, 1.77989590D+03, 1.75342680D+03/
      data ( FUPF( 75,J,2),J=1,20) /
     $ 6.171D-06, 1.209D-05, 1.778D-05, 2.321D-05, 2.840D-05, 3.337D-05,
     $ 3.810D-05, 4.260D-05, 4.689D-05, 5.095D-05, 5.479D-05, 5.841D-05,
     $ 6.182D-05, 6.501D-05, 6.799D-05, 7.074D-05, 7.329D-05, 7.557D-05,
     $ 7.765D-05, 7.953D-05/
      data (WNDNF( 75,J,2),J=1,20) /
     $ 1.73894830D+03, 1.71608530D+03, 1.69328460D+03, 1.67054800D+03,
     $ 1.64787730D+03, 1.62527420D+03, 1.60274020D+03, 1.58027680D+03,
     $ 1.55788550D+03, 1.53556750D+03, 1.51332410D+03, 1.49115610D+03,
     $ 1.46906460D+03, 1.44705010D+03, 1.42511310D+03, 1.40325380D+03,
     $ 1.38147240D+03, 1.35976830D+03, 1.33814130D+03, 1.31659020D+03/
      data ( FDNF( 75,J,2),J=1,20) /
     $ 4.619D-06, 9.113D-06, 1.348D-05, 1.772D-05, 2.183D-05, 2.583D-05,
     $ 2.971D-05, 3.346D-05, 3.710D-05, 4.062D-05, 4.401D-05, 4.730D-05,
     $ 5.046D-05, 5.350D-05, 5.640D-05, 5.919D-05, 6.185D-05, 6.437D-05,
     $ 6.675D-05, 6.901D-05/
      data (WNUPF( 76,J,1),J=1,20) /
     $ 2.32239690D+03, 2.29325070D+03, 2.26417050D+03, 2.23515840D+03,
     $ 2.20621630D+03, 2.17734620D+03, 2.14854980D+03, 2.11982880D+03,
     $ 2.09118490D+03, 2.06261940D+03, 2.03413350D+03, 2.00572850D+03,
     $ 1.97740500D+03, 1.94916380D+03, 1.92100510D+03, 1.89292900D+03,
     $ 1.86493520D+03, 1.83702320D+03, 1.80919180D+03, 1.78143960D+03/
      data ( FUPF( 76,J,1),J=1,20) /
     $ 6.471D-06, 1.267D-05, 1.860D-05, 2.428D-05, 2.969D-05, 3.485D-05,
     $ 3.976D-05, 4.443D-05, 4.885D-05, 5.304D-05, 5.699D-05, 6.070D-05,
     $ 6.419D-05, 6.742D-05, 7.040D-05, 7.325D-05, 7.576D-05, 7.801D-05,
     $ 8.013D-05, 8.185D-05/
      data (WNDNF( 76,J,1),J=1,20) /
     $ 1.76193770D+03, 1.73811510D+03, 1.71435940D+03, 1.69067260D+03,
     $ 1.66705660D+03, 1.64351320D+03, 1.62004420D+03, 1.59665110D+03,
     $ 1.57333550D+03, 1.55009870D+03, 1.52694210D+03, 1.50386650D+03,
     $ 1.48087300D+03, 1.45796200D+03, 1.43513410D+03, 1.41238930D+03,
     $ 1.38972750D+03, 1.36714820D+03, 1.34465070D+03, 1.32223370D+03/
      data ( FDNF( 76,J,1),J=1,20) /
     $ 4.801D-06, 9.464D-06, 1.400D-05, 1.840D-05, 2.267D-05, 2.681D-05,
     $ 3.082D-05, 3.471D-05, 3.846D-05, 4.210D-05, 4.560D-05, 4.899D-05,
     $ 5.224D-05, 5.536D-05, 5.833D-05, 6.121D-05, 6.392D-05, 6.647D-05,
     $ 6.889D-05, 7.111D-05/
      data (WNUPF( 76,J,2),J=1,20) /
     $ 2.26995590D+03, 2.24215020D+03, 2.21440610D+03, 2.18672550D+03,
     $ 2.15911010D+03, 2.13156180D+03, 2.10408210D+03, 2.07667270D+03,
     $ 2.04933500D+03, 2.02207030D+03, 1.99487990D+03, 1.96776470D+03,
     $ 1.94072570D+03, 1.91376340D+03, 1.88687830D+03, 1.86007060D+03,
     $ 1.83334000D+03, 1.80668630D+03, 1.78010860D+03, 1.75360580D+03/
      data ( FUPF( 76,J,2),J=1,20) /
     $ 6.177D-06, 1.211D-05, 1.779D-05, 2.323D-05, 2.842D-05, 3.338D-05,
     $ 3.811D-05, 4.262D-05, 4.689D-05, 5.095D-05, 5.479D-05, 5.840D-05,
     $ 6.181D-05, 6.499D-05, 6.795D-05, 7.073D-05, 7.325D-05, 7.556D-05,
     $ 7.762D-05, 7.947D-05/
      data (WNDNF( 76,J,2),J=1,20) /
     $ 1.73319570D+03, 1.71036520D+03, 1.68759700D+03, 1.66489290D+03,
     $ 1.64225480D+03, 1.61968430D+03, 1.59718300D+03, 1.57475230D+03,
     $ 1.55239380D+03, 1.53010860D+03, 1.50789800D+03, 1.48576290D+03,
     $ 1.46370430D+03, 1.44172270D+03, 1.41981860D+03, 1.39799220D+03,
     $ 1.37624350D+03, 1.35457230D+03, 1.33297790D+03, 1.31145950D+03/
      data ( FDNF( 76,J,2),J=1,20) /
     $ 4.608D-06, 9.092D-06, 1.344D-05, 1.768D-05, 2.179D-05, 2.578D-05,
     $ 2.964D-05, 3.339D-05, 3.702D-05, 4.053D-05, 4.392D-05, 4.720D-05,
     $ 5.035D-05, 5.339D-05, 5.629D-05, 5.907D-05, 6.173D-05, 6.424D-05,
     $ 6.660D-05, 6.882D-05/
      data (WNUPF( 77,J,1),J=1,20) /
     $ 2.32312090D+03, 2.29393910D+03, 2.26482340D+03, 2.23577570D+03,
     $ 2.20679810D+03, 2.17789240D+03, 2.14906040D+03, 2.12030390D+03,
     $ 2.09162450D+03, 2.06302340D+03, 2.03450210D+03, 2.00606140D+03,
     $ 1.97770240D+03, 1.94942560D+03, 1.92123120D+03, 1.89311940D+03,
     $ 1.86508980D+03, 1.83714170D+03, 1.80927410D+03, 1.78148560D+03/
      data ( FUPF( 77,J,1),J=1,20) /
     $ 6.476D-06, 1.268D-05, 1.862D-05, 2.429D-05, 2.971D-05, 3.487D-05,
     $ 3.978D-05, 4.444D-05, 4.886D-05, 5.305D-05, 5.698D-05, 6.069D-05,
     $ 6.416D-05, 6.739D-05, 7.039D-05, 7.320D-05, 7.569D-05, 7.791D-05,
     $ 8.000D-05, 8.170D-05/
      data (WNDNF( 77,J,1),J=1,20) /
     $ 1.75585540D+03, 1.73206750D+03, 1.70834650D+03, 1.68469450D+03,
     $ 1.66111330D+03, 1.63760480D+03, 1.61417070D+03, 1.59081260D+03,
     $ 1.56753200D+03, 1.54433040D+03, 1.52120890D+03, 1.49816850D+03,
     $ 1.47521010D+03, 1.45233430D+03, 1.42954150D+03, 1.40683190D+03,
     $ 1.38420520D+03, 1.36166090D+03, 1.33919830D+03, 1.31681610D+03/
      data ( FDNF( 77,J,1),J=1,20) /
     $ 4.790D-06, 9.445D-06, 1.397D-05, 1.836D-05, 2.262D-05, 2.675D-05,
     $ 3.075D-05, 3.463D-05, 3.838D-05, 4.201D-05, 4.550D-05, 4.888D-05,
     $ 5.213D-05, 5.525D-05, 5.821D-05, 6.108D-05, 6.379D-05, 6.632D-05,
     $ 6.877D-05, 7.097D-05/
      data (WNUPF( 77,J,2),J=1,20) /
     $ 2.27072370D+03, 2.24288480D+03, 2.21510750D+03, 2.18739360D+03,
     $ 2.15974510D+03, 2.13216360D+03, 2.10465070D+03, 2.07720820D+03,
     $ 2.04983730D+03, 2.02253950D+03, 1.99531590D+03, 1.96816760D+03,
     $ 1.94109540D+03, 1.91409990D+03, 1.88718160D+03, 1.86034050D+03,
     $ 1.83357650D+03, 1.80688930D+03, 1.78027800D+03, 1.75374140D+03/
      data ( FUPF( 77,J,2),J=1,20) /
     $ 6.183D-06, 1.212D-05, 1.780D-05, 2.324D-05, 2.844D-05, 3.340D-05,
     $ 3.813D-05, 4.263D-05, 4.690D-05, 5.095D-05, 5.478D-05, 5.840D-05,
     $ 6.179D-05, 6.497D-05, 6.791D-05, 7.065D-05, 7.320D-05, 7.549D-05,
     $ 7.752D-05, 7.935D-05/
      data (WNDNF( 77,J,2),J=1,20) /
     $ 1.72742030D+03, 1.70462220D+03, 1.68188650D+03, 1.65921500D+03,
     $ 1.63660940D+03, 1.61407150D+03, 1.59160280D+03, 1.56920490D+03,
     $ 1.54687910D+03, 1.52462680D+03, 1.50244900D+03, 1.48034680D+03,
     $ 1.45832100D+03, 1.43637230D+03, 1.41450110D+03, 1.39270760D+03,
     $ 1.37099170D+03, 1.34935330D+03, 1.32779160D+03, 1.30630580D+03/
      data ( FDNF( 77,J,2),J=1,20) /
     $ 4.598D-06, 9.071D-06, 1.342D-05, 1.765D-05, 2.174D-05, 2.572D-05,
     $ 2.958D-05, 3.332D-05, 3.694D-05, 4.045D-05, 4.383D-05, 4.710D-05,
     $ 5.025D-05, 5.328D-05, 5.617D-05, 5.895D-05, 6.160D-05, 6.411D-05,
     $ 6.652D-05, 6.871D-05/
      data (WNUPF( 78,J,1),J=1,20) /
     $ 2.32379880D+03, 2.29458140D+03, 2.26543000D+03, 2.23634670D+03,
     $ 2.20733350D+03, 2.17839220D+03, 2.14952470D+03, 2.12073260D+03,
     $ 2.09201760D+03, 2.06338100D+03, 2.03482410D+03, 2.00634790D+03,
     $ 1.97795330D+03, 1.94964070D+03, 1.92141070D+03, 1.89326300D+03,
     $ 1.86519750D+03, 1.83721340D+03, 1.80930970D+03, 1.78148470D+03/
      data ( FUPF( 78,J,1),J=1,20) /
     $ 6.484D-06, 1.269D-05, 1.863D-05, 2.431D-05, 2.972D-05, 3.488D-05,
     $ 3.979D-05, 4.445D-05, 4.886D-05, 5.305D-05, 5.697D-05, 6.068D-05,
     $ 6.414D-05, 6.735D-05, 7.032D-05, 7.310D-05, 7.561D-05, 7.787D-05,
     $ 7.994D-05, 8.161D-05/
      data (WNDNF( 78,J,1),J=1,20) /
     $ 1.74974900D+03, 1.72599570D+03, 1.70230950D+03, 1.67869220D+03,
     $ 1.65514580D+03, 1.63167220D+03, 1.60827300D+03, 1.58494990D+03,
     $ 1.56170440D+03, 1.53853780D+03, 1.51545140D+03, 1.49244620D+03,
     $ 1.46952300D+03, 1.44668240D+03, 1.42392480D+03, 1.40125020D+03,
     $ 1.37865860D+03, 1.35614930D+03, 1.33372160D+03, 1.31137420D+03/
      data ( FDNF( 78,J,1),J=1,20) /
     $ 4.779D-06, 9.427D-06, 1.394D-05, 1.832D-05, 2.257D-05, 2.669D-05,
     $ 3.068D-05, 3.455D-05, 3.830D-05, 4.192D-05, 4.541D-05, 4.878D-05,
     $ 5.201D-05, 5.513D-05, 5.809D-05, 6.095D-05, 6.365D-05, 6.618D-05,
     $ 6.860D-05, 7.083D-05/
      data (WNUPF( 78,J,2),J=1,20) /
     $ 2.27144860D+03, 2.24357650D+03, 2.21576590D+03, 2.18801880D+03,
     $ 2.16033700D+03, 2.13272230D+03, 2.10517630D+03, 2.07770050D+03,
     $ 2.05029650D+03, 2.02296550D+03, 1.99570870D+03, 1.96852720D+03,
     $ 1.94142180D+03, 1.91439310D+03, 1.88744150D+03, 1.86056700D+03,
     $ 1.83376970D+03, 1.80704890D+03, 1.78040390D+03, 1.75383350D+03/
      data ( FUPF( 78,J,2),J=1,20) /
     $ 6.189D-06, 1.212D-05, 1.781D-05, 2.325D-05, 2.845D-05, 3.341D-05,
     $ 3.814D-05, 4.264D-05, 4.691D-05, 5.095D-05, 5.478D-05, 5.839D-05,
     $ 6.177D-05, 6.497D-05, 6.787D-05, 7.065D-05, 7.310D-05, 7.542D-05,
     $ 7.748D-05, 7.929D-05/
      data (WNDNF( 78,J,2),J=1,20) /
     $ 1.72162220D+03, 1.69885650D+03, 1.67615320D+03, 1.65351420D+03,
     $ 1.63094120D+03, 1.60843590D+03, 1.58599990D+03, 1.56363470D+03,
     $ 1.54134170D+03, 1.51912210D+03, 1.49697720D+03, 1.47490780D+03,
     $ 1.45291490D+03, 1.43099910D+03, 1.40916070D+03, 1.38740010D+03,
     $ 1.36571710D+03, 1.34411140D+03, 1.32258240D+03, 1.30112920D+03/
      data ( FDNF( 78,J,2),J=1,20) /
     $ 4.589D-06, 9.051D-06, 1.339D-05, 1.761D-05, 2.169D-05, 2.567D-05,
     $ 2.952D-05, 3.325D-05, 3.687D-05, 4.036D-05, 4.374D-05, 4.700D-05,
     $ 5.014D-05, 5.317D-05, 5.606D-05, 5.883D-05, 6.148D-05, 6.401D-05,
     $ 6.637D-05, 6.860D-05/
      data (WNUPF( 79,J,1),J=1,20) /
     $ 2.32443040D+03, 2.29517730D+03, 2.26599030D+03, 2.23687140D+03,
     $ 2.20782250D+03, 2.17884560D+03, 2.14994240D+03, 2.12111480D+03,
     $ 2.09236420D+03, 2.06369200D+03, 2.03509950D+03, 2.00658770D+03,
     $ 1.97815740D+03, 1.94980920D+03, 1.92154330D+03, 1.89335980D+03,
     $ 1.86525840D+03, 1.83723820D+03, 1.80929810D+03, 1.78143680D+03/
      data ( FUPF( 79,J,1),J=1,20) /
     $ 6.490D-06, 1.270D-05, 1.864D-05, 2.432D-05, 2.974D-05, 3.489D-05,
     $ 3.980D-05, 4.446D-05, 4.887D-05, 5.304D-05, 5.697D-05, 6.066D-05,
     $ 6.414D-05, 6.732D-05, 7.032D-05, 7.306D-05, 7.554D-05, 7.777D-05,
     $ 7.981D-05, 8.153D-05/
      data (WNDNF( 79,J,1),J=1,20) /
     $ 1.74361860D+03, 1.71990000D+03, 1.69624840D+03, 1.67266590D+03,
     $ 1.64915430D+03, 1.62571550D+03, 1.60235130D+03, 1.57906320D+03,
     $ 1.55585270D+03, 1.53272120D+03, 1.50966990D+03, 1.48669990D+03,
     $ 1.46381180D+03, 1.44100640D+03, 1.41828390D+03, 1.39564450D+03,
     $ 1.37308790D+03, 1.35061370D+03, 1.32822080D+03, 1.30590820D+03/
      data ( FDNF( 79,J,1),J=1,20) /
     $ 4.769D-06, 9.403D-06, 1.391D-05, 1.828D-05, 2.252D-05, 2.663D-05,
     $ 3.062D-05, 3.448D-05, 3.821D-05, 4.182D-05, 4.531D-05, 4.867D-05,
     $ 5.191D-05, 5.501D-05, 5.796D-05, 6.082D-05, 6.352D-05, 6.604D-05,
     $ 6.849D-05, 7.063D-05/
      data (WNUPF( 79,J,2),J=1,20) /
     $ 2.27213050D+03, 2.24422500D+03, 2.21638120D+03, 2.18860090D+03,
     $ 2.16088580D+03, 2.13323790D+03, 2.10565860D+03, 2.07814960D+03,
     $ 2.05071240D+03, 2.02334820D+03, 1.99605830D+03, 1.96884350D+03,
     $ 1.94170490D+03, 1.91464290D+03, 1.88765790D+03, 1.86075010D+03,
     $ 1.83391920D+03, 1.80716480D+03, 1.78048610D+03, 1.75388180D+03/
      data ( FUPF( 79,J,2),J=1,20) /
     $ 6.194D-06, 1.213D-05, 1.783D-05, 2.327D-05, 2.846D-05, 3.343D-05,
     $ 3.815D-05, 4.265D-05, 4.692D-05, 5.096D-05, 5.478D-05, 5.838D-05,
     $ 6.176D-05, 6.490D-05, 6.783D-05, 7.057D-05, 7.306D-05, 7.535D-05,
     $ 7.739D-05, 7.917D-05/
      data (WNDNF( 79,J,2),J=1,20) /
     $ 1.71580150D+03, 1.69306820D+03, 1.67039740D+03, 1.64779080D+03,
     $ 1.62525040D+03, 1.60277770D+03, 1.58037430D+03, 1.55804180D+03,
     $ 1.53578150D+03, 1.51359480D+03, 1.49148270D+03, 1.46944620D+03,
     $ 1.44748610D+03, 1.42560320D+03, 1.40379770D+03, 1.38206990D+03,
     $ 1.36041970D+03, 1.33884670D+03, 1.31735040D+03, 1.29592980D+03/
      data ( FDNF( 79,J,2),J=1,20) /
     $ 4.578D-06, 9.031D-06, 1.336D-05, 1.757D-05, 2.165D-05, 2.561D-05,
     $ 2.945D-05, 3.318D-05, 3.679D-05, 4.027D-05, 4.365D-05, 4.691D-05,
     $ 5.004D-05, 5.306D-05, 5.594D-05, 5.871D-05, 6.135D-05, 6.384D-05,
     $ 6.623D-05, 6.843D-05/
      data (WNUPF( 80,J,1),J=1,20) /
     $ 2.32501550D+03, 2.29572680D+03, 2.26650410D+03, 2.23734940D+03,
     $ 2.20826490D+03, 2.17925230D+03, 2.15031360D+03, 2.12145030D+03,
     $ 2.09266400D+03, 2.06395620D+03, 2.03532810D+03, 2.00678060D+03,
     $ 1.97831460D+03, 1.94993070D+03, 1.92162900D+03, 1.89340960D+03,
     $ 1.86527210D+03, 1.83721580D+03, 1.80923940D+03, 1.78134150D+03/
      data ( FUPF( 80,J,1),J=1,20) /
     $ 6.497D-06, 1.271D-05, 1.865D-05, 2.433D-05, 2.975D-05, 3.491D-05,
     $ 3.981D-05, 4.447D-05, 4.887D-05, 5.304D-05, 5.696D-05, 6.065D-05,
     $ 6.409D-05, 6.730D-05, 7.025D-05, 7.302D-05, 7.547D-05, 7.767D-05,
     $ 7.975D-05, 8.138D-05/
      data (WNDNF( 80,J,1),J=1,20) /
     $ 1.73746440D+03, 1.71378040D+03, 1.69016350D+03, 1.66661570D+03,
     $ 1.64313890D+03, 1.61973500D+03, 1.59640570D+03, 1.57315250D+03,
     $ 1.54997710D+03, 1.52688070D+03, 1.50386450D+03, 1.48092960D+03,
     $ 1.45807660D+03, 1.43530640D+03, 1.41261900D+03, 1.39001470D+03,
     $ 1.36749320D+03, 1.34505390D+03, 1.32269600D+03, 1.30041820D+03/
      data ( FDNF( 80,J,1),J=1,20) /
     $ 4.758D-06, 9.379D-06, 1.388D-05, 1.824D-05, 2.247D-05, 2.657D-05,
     $ 3.055D-05, 3.440D-05, 3.813D-05, 4.173D-05, 4.521D-05, 4.857D-05,
     $ 5.179D-05, 5.489D-05, 5.784D-05, 6.069D-05, 6.335D-05, 6.590D-05,
     $ 6.832D-05, 7.050D-05/
      data (WNUPF( 80,J,2),J=1,20) /
     $ 2.27276920D+03, 2.24483040D+03, 2.21695330D+03, 2.18913970D+03,
     $ 2.16139140D+03, 2.13371010D+03, 2.10609760D+03, 2.07855540D+03,
     $ 2.05108490D+03, 2.02368750D+03, 1.99636430D+03, 1.96911630D+03,
     $ 1.94194440D+03, 1.91484910D+03, 1.88783070D+03, 1.86088940D+03,
     $ 1.83402500D+03, 1.80723700D+03, 1.78052450D+03, 1.75388620D+03/
      data ( FUPF( 80,J,2),J=1,20) /
     $ 6.200D-06, 1.214D-05, 1.784D-05, 2.328D-05, 2.848D-05, 3.344D-05,
     $ 3.816D-05, 4.266D-05, 4.692D-05, 5.096D-05, 5.477D-05, 5.837D-05,
     $ 6.174D-05, 6.491D-05, 6.780D-05, 7.050D-05, 7.302D-05, 7.528D-05,
     $ 7.730D-05, 7.906D-05/
      data (WNDNF( 80,J,2),J=1,20) /
     $ 1.70995830D+03, 1.68725740D+03, 1.66461900D+03, 1.64204490D+03,
     $ 1.61953700D+03, 1.59709690D+03, 1.57472620D+03, 1.55242640D+03,
     $ 1.53019880D+03, 1.50804480D+03, 1.48596550D+03, 1.46396190D+03,
     $ 1.44203470D+03, 1.42018460D+03, 1.39841200D+03, 1.37671700D+03,
     $ 1.35509960D+03, 1.33355940D+03, 1.31209580D+03, 1.29070770D+03/
      data ( FDNF( 80,J,2),J=1,20) /
     $ 4.568D-06, 9.012D-06, 1.333D-05, 1.753D-05, 2.160D-05, 2.555D-05,
     $ 2.939D-05, 3.311D-05, 3.671D-05, 4.019D-05, 4.355D-05, 4.680D-05,
     $ 4.993D-05, 5.294D-05, 5.583D-05, 5.859D-05, 6.122D-05, 6.373D-05,
     $ 6.609D-05, 6.826D-05/
      data (WNUPF( 81,J,1),J=1,20) /
     $ 2.32555410D+03, 2.29622960D+03, 2.26697120D+03, 2.23778080D+03,
     $ 2.20866060D+03, 2.17961230D+03, 2.15063790D+03, 2.12173890D+03,
     $ 2.09291700D+03, 2.06417350D+03, 2.03550970D+03, 2.00692650D+03,
     $ 1.97842480D+03, 1.95000510D+03, 1.92166760D+03, 1.89341220D+03,
     $ 1.86523870D+03, 1.83714610D+03, 1.80913330D+03, 1.78119880D+03/
      data ( FUPF( 81,J,1),J=1,20) /
     $ 6.497D-06, 1.272D-05, 1.867D-05, 2.435D-05, 2.976D-05, 3.492D-05,
     $ 3.982D-05, 4.447D-05, 4.888D-05, 5.304D-05, 5.695D-05, 6.063D-05,
     $ 6.404D-05, 6.727D-05, 7.019D-05, 7.292D-05, 7.540D-05, 7.758D-05,
     $ 7.963D-05, 8.130D-05/
      data (WNDNF( 81,J,1),J=1,20) /
     $ 1.73128650D+03, 1.70763710D+03, 1.68405480D+03, 1.66054170D+03,
     $ 1.63709970D+03, 1.61373070D+03, 1.59043620D+03, 1.56721810D+03,
     $ 1.54407760D+03, 1.52101630D+03, 1.49803520D+03, 1.47513540D+03,
     $ 1.45231760D+03, 1.42958250D+03, 1.40693030D+03, 1.38436110D+03,
     $ 1.36187460D+03, 1.33947030D+03, 1.31714730D+03, 1.29490420D+03/
      data ( FDNF( 81,J,1),J=1,20) /
     $ 4.747D-06, 9.362D-06, 1.384D-05, 1.820D-05, 2.242D-05, 2.651D-05,
     $ 3.048D-05, 3.432D-05, 3.804D-05, 4.164D-05, 4.511D-05, 4.846D-05,
     $ 5.168D-05, 5.477D-05, 5.771D-05, 6.056D-05, 6.325D-05, 6.577D-05,
     $ 6.816D-05, 7.037D-05/
      data (WNUPF( 81,J,2),J=1,20) /
     $ 2.27336460D+03, 2.24539250D+03, 2.21748200D+03, 2.18963510D+03,
     $ 2.16185350D+03, 2.13413890D+03, 2.10649310D+03, 2.07891760D+03,
     $ 2.05141390D+03, 2.02398320D+03, 1.99662670D+03, 1.96934540D+03,
     $ 1.94214020D+03, 1.91501150D+03, 1.88795970D+03, 1.86098500D+03,
     $ 1.83408700D+03, 1.80726530D+03, 1.78051890D+03, 1.75384670D+03/
      data ( FUPF( 81,J,2),J=1,20) /
     $ 6.205D-06, 1.216D-05, 1.785D-05, 2.329D-05, 2.850D-05, 3.345D-05,
     $ 3.818D-05, 4.266D-05, 4.693D-05, 5.096D-05, 5.477D-05, 5.836D-05,
     $ 6.172D-05, 6.484D-05, 6.776D-05, 7.050D-05, 7.292D-05, 7.522D-05,
     $ 7.720D-05, 7.901D-05/
      data (WNDNF( 81,J,2),J=1,20) /
     $ 1.70409280D+03, 1.68142420D+03, 1.65881820D+03, 1.63627660D+03,
     $ 1.61380120D+03, 1.59139370D+03, 1.56905560D+03, 1.54678850D+03,
     $ 1.52459370D+03, 1.50247240D+03, 1.48042600D+03, 1.45845520D+03,
     $ 1.43656080D+03, 1.41474360D+03, 1.39300380D+03, 1.37134170D+03,
     $ 1.34975710D+03, 1.32824960D+03, 1.30681860D+03, 1.28546310D+03/
      data ( FDNF( 81,J,2),J=1,20) /
     $ 4.558D-06, 8.994D-06, 1.330D-05, 1.749D-05, 2.155D-05, 2.550D-05,
     $ 2.933D-05, 3.303D-05, 3.663D-05, 4.010D-05, 4.346D-05, 4.671D-05,
     $ 4.983D-05, 5.283D-05, 5.571D-05, 5.847D-05, 6.109D-05, 6.356D-05,
     $ 6.595D-05, 6.816D-05/
      data (WNUPF( 82,J,1),J=1,20) /
     $ 2.32604590D+03, 2.29668570D+03, 2.26739150D+03, 2.23816540D+03,
     $ 2.20900940D+03, 2.17992540D+03, 2.15091520D+03, 2.12198050D+03,
     $ 2.09312290D+03, 2.06434370D+03, 2.03564420D+03, 2.00702530D+03,
     $ 1.97848780D+03, 1.95003220D+03, 1.92165880D+03, 1.89336740D+03,
     $ 1.86515780D+03, 1.83702890D+03, 1.80897970D+03, 1.78100850D+03/
      data ( FUPF( 82,J,1),J=1,20) /
     $ 6.503D-06, 1.273D-05, 1.868D-05, 2.436D-05, 2.977D-05, 3.493D-05,
     $ 3.983D-05, 4.447D-05, 4.887D-05, 5.303D-05, 5.694D-05, 6.061D-05,
     $ 6.405D-05, 6.724D-05, 7.018D-05, 7.288D-05, 7.534D-05, 7.748D-05,
     $ 7.951D-05, 8.117D-05/
      data (WNDNF( 82,J,1),J=1,20) /
     $ 1.72508500D+03, 1.70147020D+03, 1.67792260D+03, 1.65444420D+03,
     $ 1.63103690D+03, 1.60770270D+03, 1.58444310D+03, 1.56125990D+03,
     $ 1.53815450D+03, 1.51512820D+03, 1.49218220D+03, 1.46931760D+03,
     $ 1.44653490D+03, 1.42383490D+03, 1.40121790D+03, 1.37868370D+03,
     $ 1.35623230D+03, 1.33386300D+03, 1.31157480D+03, 1.28936640D+03/
      data ( FDNF( 82,J,1),J=1,20) /
     $ 4.736D-06, 9.339D-06, 1.381D-05, 1.815D-05, 2.236D-05, 2.645D-05,
     $ 3.041D-05, 3.424D-05, 3.796D-05, 4.155D-05, 4.501D-05, 4.835D-05,
     $ 5.156D-05, 5.465D-05, 5.759D-05, 6.042D-05, 6.309D-05, 6.558D-05,
     $ 6.800D-05, 7.018D-05/
      data (WNUPF( 82,J,2),J=1,20) /
     $ 2.27391660D+03, 2.24591110D+03, 2.21796730D+03, 2.19008700D+03,
     $ 2.16227200D+03, 2.13452410D+03, 2.10684500D+03, 2.07923620D+03,
     $ 2.05169910D+03, 2.02423510D+03, 1.99684530D+03, 1.96953080D+03,
     $ 1.94229210D+03, 1.91513010D+03, 1.88804490D+03, 1.86103660D+03,
     $ 1.83410500D+03, 1.80724950D+03, 1.78046930D+03, 1.75376290D+03/
      data ( FUPF( 82,J,2),J=1,20) /
     $ 6.209D-06, 1.217D-05, 1.787D-05, 2.331D-05, 2.851D-05, 3.347D-05,
     $ 3.819D-05, 4.267D-05, 4.693D-05, 5.096D-05, 5.476D-05, 5.834D-05,
     $ 6.172D-05, 6.485D-05, 6.773D-05, 7.043D-05, 7.288D-05, 7.509D-05,
     $ 7.712D-05, 7.890D-05/
      data (WNDNF( 82,J,2),J=1,20) /
     $ 1.69820500D+03, 1.67556870D+03, 1.65299510D+03, 1.63048600D+03,
     $ 1.60804310D+03, 1.58566810D+03, 1.56336270D+03, 1.54112820D+03,
     $ 1.51896610D+03, 1.49687770D+03, 1.47486400D+03, 1.45292600D+03,
     $ 1.43106460D+03, 1.40928020D+03, 1.38757330D+03, 1.36594400D+03,
     $ 1.34439210D+03, 1.32291740D+03, 1.30151910D+03, 1.28019610D+03/
      data ( FDNF( 82,J,2),J=1,20) /
     $ 4.548D-06, 8.970D-06, 1.327D-05, 1.745D-05, 2.150D-05, 2.544D-05,
     $ 2.926D-05, 3.296D-05, 3.655D-05, 4.002D-05, 4.337D-05, 4.661D-05,
     $ 4.972D-05, 5.272D-05, 5.559D-05, 5.835D-05, 6.097D-05, 6.345D-05,
     $ 6.582D-05, 6.800D-05/
      data (WNUPF( 83,J,1),J=1,20) /
     $ 2.32649090D+03, 2.29709490D+03, 2.26776480D+03, 2.23850290D+03,
     $ 2.20931110D+03, 2.18019140D+03, 2.15114540D+03, 2.12217500D+03,
     $ 2.09328170D+03, 2.06446670D+03, 2.03573140D+03, 2.00707670D+03,
     $ 1.97850340D+03, 1.95001190D+03, 1.92160260D+03, 1.89327520D+03,
     $ 1.86502930D+03, 1.83686410D+03, 1.80877840D+03, 1.78077050D+03/
      data ( FUPF( 83,J,1),J=1,20) /
     $ 6.509D-06, 1.274D-05, 1.869D-05, 2.438D-05, 2.979D-05, 3.494D-05,
     $ 3.984D-05, 4.448D-05, 4.887D-05, 5.302D-05, 5.692D-05, 6.059D-05,
     $ 6.400D-05, 6.721D-05, 7.012D-05, 7.279D-05, 7.527D-05, 7.739D-05,
     $ 7.939D-05, 8.103D-05/
      data (WNDNF( 83,J,1),J=1,20) /
     $ 1.71886010D+03, 1.69527980D+03, 1.67176680D+03, 1.64832310D+03,
     $ 1.62495060D+03, 1.60165120D+03, 1.57842650D+03, 1.55527820D+03,
     $ 1.53220780D+03, 1.50921660D+03, 1.48630570D+03, 1.46347610D+03,
     $ 1.44072860D+03, 1.41806370D+03, 1.39548180D+03, 1.37298270D+03,
     $ 1.35056630D+03, 1.32823190D+03, 1.30597860D+03, 1.28380490D+03/
      data ( FDNF( 83,J,1),J=1,20) /
     $ 4.725D-06, 9.317D-06, 1.378D-05, 1.811D-05, 2.231D-05, 2.639D-05,
     $ 3.034D-05, 3.417D-05, 3.787D-05, 4.146D-05, 4.491D-05, 4.825D-05,
     $ 5.145D-05, 5.453D-05, 5.746D-05, 6.030D-05, 6.293D-05, 6.545D-05,
     $ 6.784D-05, 7.006D-05/
      data (WNUPF( 83,J,2),J=1,20) /
     $ 2.27442500D+03, 2.24638610D+03, 2.21840890D+03, 2.19049520D+03,
     $ 2.16264680D+03, 2.13486560D+03, 2.10715310D+03, 2.07951100D+03,
     $ 2.05194060D+03, 2.02444320D+03, 1.99702010D+03, 1.96967210D+03,
     $ 1.94240010D+03, 1.91520460D+03, 1.88808590D+03, 1.86104410D+03,
     $ 1.83407880D+03, 1.80718950D+03, 1.78037530D+03, 1.75363490D+03/
      data ( FUPF( 83,J,2),J=1,20) /
     $ 6.218D-06, 1.217D-05, 1.787D-05, 2.332D-05, 2.852D-05, 3.348D-05,
     $ 3.819D-05, 4.268D-05, 4.693D-05, 5.096D-05, 5.475D-05, 5.833D-05,
     $ 6.170D-05, 6.479D-05, 6.770D-05, 7.036D-05, 7.285D-05, 7.503D-05,
     $ 7.703D-05, 7.879D-05/
      data (WNDNF( 83,J,2),J=1,20) /
     $ 1.69229500D+03, 1.66969110D+03, 1.64714990D+03, 1.62467320D+03,
     $ 1.60226280D+03, 1.57992040D+03, 1.55764750D+03, 1.53544570D+03,
     $ 1.51331640D+03, 1.49126070D+03, 1.46927980D+03, 1.44737470D+03,
     $ 1.42554610D+03, 1.40379450D+03, 1.38212040D+03, 1.36052390D+03,
     $ 1.33900490D+03, 1.31756290D+03, 1.29619720D+03, 1.27490670D+03/
      data ( FDNF( 83,J,2),J=1,20) /
     $ 4.538D-06, 8.952D-06, 1.325D-05, 1.741D-05, 2.146D-05, 2.539D-05,
     $ 2.920D-05, 3.289D-05, 3.647D-05, 3.993D-05, 4.328D-05, 4.650D-05,
     $ 4.962D-05, 5.261D-05, 5.548D-05, 5.822D-05, 6.084D-05, 6.329D-05,
     $ 6.563D-05, 6.784D-05/
      data (WNUPF( 84,J,1),J=1,20) /
     $ 2.32688880D+03, 2.29745700D+03, 2.26809110D+03, 2.23879330D+03,
     $ 2.20956570D+03, 2.18041010D+03, 2.15132840D+03, 2.12232220D+03,
     $ 2.09339310D+03, 2.06454230D+03, 2.03577120D+03, 2.00708070D+03,
     $ 1.97847150D+03, 1.94994410D+03, 1.92149870D+03, 1.89313520D+03,
     $ 1.86485310D+03, 1.83665150D+03, 1.80852920D+03, 1.78048450D+03/
      data ( FUPF( 84,J,1),J=1,20) /
     $ 6.515D-06, 1.275D-05, 1.870D-05, 2.438D-05, 2.980D-05, 3.495D-05,
     $ 3.984D-05, 4.448D-05, 4.887D-05, 5.301D-05, 5.690D-05, 6.054D-05,
     $ 6.395D-05, 6.713D-05, 7.006D-05, 7.275D-05, 7.521D-05, 7.731D-05,
     $ 7.928D-05, 8.090D-05/
      data (WNDNF( 84,J,1),J=1,20) /
     $ 1.71261180D+03, 1.68906610D+03, 1.66558770D+03, 1.64217870D+03,
     $ 1.61884090D+03, 1.59557630D+03, 1.57238650D+03, 1.54927310D+03,
     $ 1.52623770D+03, 1.50328150D+03, 1.48040570D+03, 1.45761120D+03,
     $ 1.43489880D+03, 1.41226910D+03, 1.38972220D+03, 1.36725820D+03,
     $ 1.34487680D+03, 1.32257740D+03, 1.30035890D+03, 1.27821990D+03/
      data ( FDNF( 84,J,1),J=1,20) /
     $ 4.715D-06, 9.296D-06, 1.375D-05, 1.807D-05, 2.227D-05, 2.633D-05,
     $ 3.027D-05, 3.409D-05, 3.779D-05, 4.136D-05, 4.481D-05, 4.814D-05,
     $ 5.134D-05, 5.441D-05, 5.734D-05, 6.018D-05, 6.284D-05, 6.533D-05,
     $ 6.769D-05, 6.988D-05/
      data (WNUPF( 84,J,2),J=1,20) /
     $ 2.27488970D+03, 2.24681740D+03, 2.21880680D+03, 2.19085960D+03,
     $ 2.16297790D+03, 2.13516320D+03, 2.10741730D+03, 2.07974180D+03,
     $ 2.05213800D+03, 2.02460730D+03, 1.99715080D+03, 1.96976940D+03,
     $ 1.94246400D+03, 1.91523500D+03, 1.88808270D+03, 1.86100730D+03,
     $ 1.83400830D+03, 1.80708510D+03, 1.78023690D+03, 1.75346230D+03/
      data ( FUPF( 84,J,2),J=1,20) /
     $ 6.222D-06, 1.218D-05, 1.788D-05, 2.333D-05, 2.853D-05, 3.349D-05,
     $ 3.820D-05, 4.268D-05, 4.693D-05, 5.095D-05, 5.474D-05, 5.831D-05,
     $ 6.168D-05, 6.479D-05, 6.766D-05, 7.030D-05, 7.275D-05, 7.497D-05,
     $ 7.695D-05, 7.862D-05/
      data (WNDNF( 84,J,2),J=1,20) /
     $ 1.68636310D+03, 1.66379150D+03, 1.64128260D+03, 1.61883830D+03,
     $ 1.59646040D+03, 1.57415050D+03, 1.55191030D+03, 1.52974120D+03,
     $ 1.50764450D+03, 1.48562160D+03, 1.46367350D+03, 1.44180120D+03,
     $ 1.42000540D+03, 1.39828670D+03, 1.37664540D+03, 1.35508180D+03,
     $ 1.33359550D+03, 1.31218610D+03, 1.29085300D+03, 1.26959510D+03/
      data ( FDNF( 84,J,2),J=1,20) /
     $ 4.528D-06, 8.929D-06, 1.321D-05, 1.737D-05, 2.141D-05, 2.533D-05,
     $ 2.913D-05, 3.282D-05, 3.639D-05, 3.984D-05, 4.318D-05, 4.641D-05,
     $ 4.951D-05, 5.250D-05, 5.536D-05, 5.809D-05, 6.071D-05, 6.320D-05,
     $ 6.550D-05, 6.769D-05/
      data (WNUPF( 85,J,1),J=1,20) /
     $ 2.32723960D+03, 2.29777180D+03, 2.26837010D+03, 2.23903650D+03,
     $ 2.20977300D+03, 2.18058150D+03, 2.15146400D+03, 2.12242190D+03,
     $ 2.09345690D+03, 2.06457040D+03, 2.03576340D+03, 2.00703700D+03,
     $ 1.97839190D+03, 1.94982850D+03, 1.92134700D+03, 1.89294730D+03,
     $ 1.86462890D+03, 1.83639090D+03, 1.80823190D+03, 1.78015030D+03/
      data ( FUPF( 85,J,1),J=1,20) /
     $ 6.521D-06, 1.276D-05, 1.871D-05, 2.440D-05, 2.981D-05, 3.496D-05,
     $ 3.985D-05, 4.448D-05, 4.886D-05, 5.300D-05, 5.689D-05, 6.053D-05,
     $ 6.396D-05, 6.710D-05, 7.000D-05, 7.266D-05, 7.509D-05, 7.722D-05,
     $ 7.917D-05, 8.077D-05/
      data (WNDNF( 85,J,1),J=1,20) /
     $ 1.70634040D+03, 1.68282920D+03, 1.65938530D+03, 1.63601100D+03,
     $ 1.61270790D+03, 1.58947810D+03, 1.56632310D+03, 1.54324470D+03,
     $ 1.52024430D+03, 1.49732310D+03, 1.47448230D+03, 1.45172300D+03,
     $ 1.42904570D+03, 1.40645100D+03, 1.38393930D+03, 1.36151040D+03,
     $ 1.33916400D+03, 1.31689940D+03, 1.29471570D+03, 1.27261140D+03/
      data ( FDNF( 85,J,1),J=1,20) /
     $ 4.704D-06, 9.275D-06, 1.371D-05, 1.803D-05, 2.221D-05, 2.627D-05,
     $ 3.020D-05, 3.401D-05, 3.770D-05, 4.127D-05, 4.471D-05, 4.803D-05,
     $ 5.122D-05, 5.429D-05, 5.721D-05, 6.000D-05, 6.269D-05, 6.515D-05,
     $ 6.754D-05, 6.971D-05/
      data (WNUPF( 85,J,2),J=1,20) /
     $ 2.27531060D+03, 2.24720480D+03, 2.21916070D+03, 2.19118010D+03,
     $ 2.16326490D+03, 2.13541680D+03, 2.10763750D+03, 2.07992850D+03,
     $ 2.05229140D+03, 2.02472720D+03, 1.99723730D+03, 1.96982250D+03,
     $ 1.94248360D+03, 1.91522100D+03, 1.88803520D+03, 1.86092610D+03,
     $ 1.83389330D+03, 1.80693620D+03, 1.78005400D+03, 1.75324510D+03/
      data ( FUPF( 85,J,2),J=1,20) /
     $ 6.225D-06, 1.219D-05, 1.789D-05, 2.334D-05, 2.854D-05, 3.350D-05,
     $ 3.821D-05, 4.269D-05, 4.693D-05, 5.095D-05, 5.473D-05, 5.829D-05,
     $ 6.160D-05, 6.473D-05, 6.763D-05, 7.024D-05, 7.266D-05, 7.485D-05,
     $ 7.680D-05, 7.852D-05/
      data (WNDNF( 85,J,2),J=1,20) /
     $ 1.68040920D+03, 1.65786990D+03, 1.63539340D+03, 1.61298150D+03,
     $ 1.59063610D+03, 1.56835870D+03, 1.54615110D+03, 1.52401460D+03,
     $ 1.50195060D+03, 1.47996050D+03, 1.45804510D+03, 1.43620560D+03,
     $ 1.41444270D+03, 1.39275680D+03, 1.37114840D+03, 1.34961750D+03,
     $ 1.32816400D+03, 1.30678730D+03, 1.28548680D+03, 1.26426140D+03/
      data ( FDNF( 85,J,2),J=1,20) /
     $ 4.518D-06, 8.912D-06, 1.319D-05, 1.733D-05, 2.136D-05, 2.527D-05,
     $ 2.907D-05, 3.274D-05, 3.631D-05, 3.975D-05, 4.309D-05, 4.630D-05,
     $ 4.940D-05, 5.239D-05, 5.524D-05, 5.797D-05, 6.058D-05, 6.304D-05,
     $ 6.538D-05, 6.754D-05/
      data (WNUPF( 86,J,1),J=1,20) /
     $ 2.32754310D+03, 2.29803940D+03, 2.26860170D+03, 2.23923210D+03,
     $ 2.20993270D+03, 2.18070540D+03, 2.15155200D+03, 2.12247400D+03,
     $ 2.09347320D+03, 2.06455070D+03, 2.03570780D+03, 2.00694550D+03,
     $ 1.97826440D+03, 1.94966500D+03, 1.92114740D+03, 1.89271150D+03,
     $ 1.86435670D+03, 1.83608210D+03, 1.80788640D+03, 1.77976780D+03/
      data ( FUPF( 86,J,1),J=1,20) /
     $ 6.526D-06, 1.277D-05, 1.872D-05, 2.440D-05, 2.982D-05, 3.496D-05,
     $ 3.985D-05, 4.448D-05, 4.886D-05, 5.299D-05, 5.687D-05, 6.053D-05,
     $ 6.392D-05, 6.702D-05, 6.994D-05, 7.263D-05, 7.503D-05, 7.713D-05,
     $ 7.906D-05, 8.064D-05/
      data (WNDNF( 86,J,1),J=1,20) /
     $ 1.70004580D+03, 1.67656910D+03, 1.65315990D+03, 1.62982010D+03,
     $ 1.60655180D+03, 1.58335670D+03, 1.56023660D+03, 1.53719310D+03,
     $ 1.51422760D+03, 1.49134150D+03, 1.46853580D+03, 1.44581150D+03,
     $ 1.42316930D+03, 1.40060980D+03, 1.37813310D+03, 1.35573920D+03,
     $ 1.33342780D+03, 1.31119820D+03, 1.28904920D+03, 1.26697960D+03/
      data ( FDNF( 86,J,1),J=1,20) /
     $ 4.693D-06, 9.254D-06, 1.368D-05, 1.799D-05, 2.216D-05, 2.621D-05,
     $ 3.014D-05, 3.394D-05, 3.762D-05, 4.118D-05, 4.461D-05, 4.792D-05,
     $ 5.111D-05, 5.417D-05, 5.709D-05, 5.988D-05, 6.254D-05, 6.503D-05,
     $ 6.740D-05, 6.954D-05/
      data (WNUPF( 86,J,2),J=1,20) /
     $ 2.27568750D+03, 2.24754820D+03, 2.21947060D+03, 2.19145650D+03,
     $ 2.16350780D+03, 2.13562630D+03, 2.10781350D+03, 2.08007110D+03,
     $ 2.05240040D+03, 2.02480290D+03, 1.99727940D+03, 1.96983120D+03,
     $ 1.94245870D+03, 1.91516260D+03, 1.88794320D+03, 1.86080030D+03,
     $ 1.83373370D+03, 1.80674270D+03, 1.77982630D+03, 1.75298310D+03/
      data ( FUPF( 86,J,2),J=1,20) /
     $ 6.228D-06, 1.220D-05, 1.790D-05, 2.336D-05, 2.856D-05, 3.351D-05,
     $ 3.822D-05, 4.269D-05, 4.694D-05, 5.094D-05, 5.472D-05, 5.827D-05,
     $ 6.158D-05, 6.468D-05, 6.754D-05, 7.018D-05, 7.263D-05, 7.480D-05,
     $ 7.673D-05, 7.842D-05/
      data (WNDNF( 86,J,2),J=1,20) /
     $ 1.67443350D+03, 1.65192650D+03, 1.62948240D+03, 1.60710290D+03,
     $ 1.58478990D+03, 1.56254510D+03, 1.54037000D+03, 1.51826610D+03,
     $ 1.49623490D+03, 1.47427740D+03, 1.45239490D+03, 1.43058820D+03,
     $ 1.40885800D+03, 1.38720500D+03, 1.36562940D+03, 1.34413130D+03,
     $ 1.32271050D+03, 1.30136650D+03, 1.28009860D+03, 1.25890570D+03/
      data ( FDNF( 86,J,2),J=1,20) /
     $ 4.508D-06, 8.890D-06, 1.316D-05, 1.729D-05, 2.132D-05, 2.522D-05,
     $ 2.901D-05, 3.267D-05, 3.623D-05, 3.967D-05, 4.299D-05, 4.621D-05,
     $ 4.929D-05, 5.227D-05, 5.512D-05, 5.786D-05, 6.046D-05, 6.289D-05,
     $ 6.520D-05, 6.740D-05/
      data (WNUPF( 87,J,1),J=1,20) /
     $ 2.32779910D+03, 2.29825940D+03, 2.26878570D+03, 2.23938020D+03,
     $ 2.21004490D+03, 2.18078160D+03, 2.15159220D+03, 2.12247840D+03,
     $ 2.09344160D+03, 2.06448320D+03, 2.03560440D+03, 2.00680610D+03,
     $ 1.97808890D+03, 1.94945340D+03, 1.92089960D+03, 1.89242740D+03,
     $ 1.86403620D+03, 1.83572500D+03, 1.80749250D+03, 1.77933690D+03/
      data ( FUPF( 87,J,1),J=1,20) /
     $ 6.532D-06, 1.277D-05, 1.873D-05, 2.442D-05, 2.983D-05, 3.497D-05,
     $ 3.986D-05, 4.448D-05, 4.886D-05, 5.298D-05, 5.684D-05, 6.046D-05,
     $ 6.387D-05, 6.699D-05, 6.988D-05, 7.254D-05, 7.491D-05, 7.699D-05,
     $ 7.890D-05, 8.046D-05/
      data (WNDNF( 87,J,1),J=1,20) /
     $ 1.69372840D+03, 1.67028610D+03, 1.64691140D+03, 1.62360630D+03,
     $ 1.60037260D+03, 1.57721230D+03, 1.55412710D+03, 1.53111840D+03,
     $ 1.50818790D+03, 1.48533680D+03, 1.46256610D+03, 1.43987690D+03,
     $ 1.41726980D+03, 1.39474540D+03, 1.37230380D+03, 1.34994490D+03,
     $ 1.32766850D+03, 1.30547370D+03, 1.28335960D+03, 1.26132450D+03/
      data ( FDNF( 87,J,1),J=1,20) /
     $ 4.682D-06, 9.234D-06, 1.365D-05, 1.794D-05, 2.211D-05, 2.615D-05,
     $ 3.007D-05, 3.386D-05, 3.753D-05, 4.109D-05, 4.451D-05, 4.782D-05,
     $ 5.099D-05, 5.405D-05, 5.696D-05, 5.977D-05, 6.240D-05, 6.486D-05,
     $ 6.726D-05, 6.943D-05/
      data (WNUPF( 87,J,2),J=1,20) /
     $ 2.27602030D+03, 2.24784750D+03, 2.21973640D+03, 2.19168870D+03,
     $ 2.16370650D+03, 2.13579140D+03, 2.10794520D+03, 2.08016920D+03,
     $ 2.05246510D+03, 2.02483400D+03, 1.99727710D+03, 1.96979530D+03,
     $ 1.94238930D+03, 1.91505960D+03, 1.88780640D+03, 1.86062980D+03,
     $ 1.83352930D+03, 1.80650430D+03, 1.77955370D+03, 1.75267610D+03/
      data ( FUPF( 87,J,2),J=1,20) /
     $ 6.237D-06, 1.220D-05, 1.791D-05, 2.336D-05, 2.857D-05, 3.351D-05,
     $ 3.823D-05, 4.269D-05, 4.693D-05, 5.093D-05, 5.470D-05, 5.827D-05,
     $ 6.156D-05, 6.462D-05, 6.751D-05, 7.012D-05, 7.254D-05, 7.468D-05,
     $ 7.659D-05, 7.832D-05/
      data (WNDNF( 87,J,2),J=1,20) /
     $ 1.66843620D+03, 1.64596150D+03, 1.62354960D+03, 1.60120250D+03,
     $ 1.57892200D+03, 1.55670960D+03, 1.53456710D+03, 1.51249590D+03,
     $ 1.49049730D+03, 1.46857260D+03, 1.44672280D+03, 1.42494890D+03,
     $ 1.40325160D+03, 1.38163140D+03, 1.36008860D+03, 1.33862320D+03,
     $ 1.31723520D+03, 1.29592390D+03, 1.27468850D+03, 1.25352800D+03/
      data ( FDNF( 87,J,2),J=1,20) /
     $ 4.498D-06, 8.874D-06, 1.313D-05, 1.726D-05, 2.127D-05, 2.516D-05,
     $ 2.894D-05, 3.260D-05, 3.615D-05, 3.958D-05, 4.290D-05, 4.610D-05,
     $ 4.919D-05, 5.216D-05, 5.500D-05, 5.771D-05, 6.029D-05, 6.274D-05,
     $ 6.509D-05, 6.726D-05/
      data (WNUPF( 88,J,1),J=1,20) /
     $ 2.32800750D+03, 2.29843180D+03, 2.26892210D+03, 2.23948060D+03,
     $ 2.21010920D+03, 2.18081000D+03, 2.15158460D+03, 2.12243480D+03,
     $ 2.09336200D+03, 2.06436760D+03, 2.03545280D+03, 2.00661850D+03,
     $ 1.97786530D+03, 1.94919360D+03, 1.92060360D+03, 1.89209500D+03,
     $ 1.86366730D+03, 1.83531940D+03, 1.80705010D+03, 1.77885730D+03/
      data ( FUPF( 88,J,1),J=1,20) /
     $ 6.531D-06, 1.278D-05, 1.874D-05, 2.442D-05, 2.983D-05, 3.498D-05,
     $ 3.986D-05, 4.447D-05, 4.885D-05, 5.296D-05, 5.682D-05, 6.046D-05,
     $ 6.383D-05, 6.691D-05, 6.983D-05, 7.246D-05, 7.480D-05, 7.691D-05,
     $ 7.880D-05, 8.034D-05/
      data (WNDNF( 88,J,1),J=1,20) /
     $ 1.68738810D+03, 1.66398030D+03, 1.64064010D+03, 1.61736960D+03,
     $ 1.59417060D+03, 1.57104500D+03, 1.54799460D+03, 1.52502080D+03,
     $ 1.50212520D+03, 1.47930910D+03, 1.45657350D+03, 1.43391930D+03,
     $ 1.41134730D+03, 1.38885800D+03, 1.36645140D+03, 1.34412760D+03,
     $ 1.32188610D+03, 1.29972620D+03, 1.27764680D+03, 1.25564640D+03/
      data ( FDNF( 88,J,1),J=1,20) /
     $ 4.671D-06, 9.209D-06, 1.362D-05, 1.790D-05, 2.206D-05, 2.609D-05,
     $ 3.000D-05, 3.378D-05, 3.745D-05, 4.099D-05, 4.441D-05, 4.771D-05,
     $ 5.088D-05, 5.393D-05, 5.684D-05, 5.960D-05, 6.226D-05, 6.475D-05,
     $ 6.712D-05, 6.927D-05/
      data (WNUPF( 88,J,2),J=1,20) /
     $ 2.27630890D+03, 2.24810260D+03, 2.21995780D+03, 2.19187660D+03,
     $ 2.16386080D+03, 2.13591220D+03, 2.10803240D+03, 2.08022290D+03,
     $ 2.05248520D+03, 2.02482060D+03, 1.99723020D+03, 1.96971480D+03,
     $ 1.94227520D+03, 1.91491180D+03, 1.88762490D+03, 1.86041440D+03,
     $ 1.83328000D+03, 1.80622090D+03, 1.77923600D+03, 1.75232400D+03/
      data ( FUPF( 88,J,2),J=1,20) /
     $ 6.240D-06, 1.221D-05, 1.792D-05, 2.338D-05, 2.857D-05, 3.353D-05,
     $ 3.823D-05, 4.269D-05, 4.693D-05, 5.092D-05, 5.469D-05, 5.823D-05,
     $ 6.154D-05, 6.463D-05, 6.743D-05, 7.006D-05, 7.246D-05, 7.457D-05,
     $ 7.651D-05, 7.817D-05/
      data (WNDNF( 88,J,2),J=1,20) /
     $ 1.66241740D+03, 1.63997480D+03, 1.61759530D+03, 1.59528050D+03,
     $ 1.57303240D+03, 1.55085260D+03, 1.52874260D+03, 1.50670400D+03,
     $ 1.48473810D+03, 1.46284610D+03, 1.44102910D+03, 1.41928800D+03,
     $ 1.39762340D+03, 1.37603600D+03, 1.35452600D+03, 1.33309350D+03,
     $ 1.31173810D+03, 1.29045950D+03, 1.26925670D+03, 1.24812860D+03/
      data ( FDNF( 88,J,2),J=1,20) /
     $ 4.488D-06, 8.853D-06, 1.310D-05, 1.721D-05, 2.122D-05, 2.511D-05,
     $ 2.888D-05, 3.253D-05, 3.607D-05, 3.950D-05, 4.281D-05, 4.601D-05,
     $ 4.908D-05, 5.205D-05, 5.488D-05, 5.757D-05, 6.017D-05, 6.266D-05,
     $ 6.492D-05, 6.712D-05/
      data (WNUPF( 89,J,1),J=1,20) /
     $ 2.32816810D+03, 2.29855630D+03, 2.26901060D+03, 2.23953300D+03,
     $ 2.21012560D+03, 2.18079030D+03, 2.15152890D+03, 2.12234310D+03,
     $ 2.09323430D+03, 2.06420390D+03, 2.03525300D+03, 2.00638260D+03,
     $ 1.97759330D+03, 1.94888540D+03, 1.92025910D+03, 1.89171410D+03,
     $ 1.86324980D+03, 1.83486520D+03, 1.80655880D+03, 1.77832880D+03/
      data ( FUPF( 89,J,1),J=1,20) /
     $ 6.537D-06, 1.279D-05, 1.875D-05, 2.444D-05, 2.984D-05, 3.498D-05,
     $ 3.986D-05, 4.447D-05, 4.884D-05, 5.294D-05, 5.678D-05, 6.040D-05,
     $ 6.379D-05, 6.689D-05, 6.972D-05, 7.237D-05, 7.475D-05, 7.678D-05,
     $ 7.864D-05, 8.017D-05/
      data (WNDNF( 89,J,1),J=1,20) /
     $ 1.68102510D+03, 1.65765170D+03, 1.63434600D+03, 1.61111010D+03,
     $ 1.58794580D+03, 1.56485490D+03, 1.54183930D+03, 1.51890040D+03,
     $ 1.49603980D+03, 1.47325860D+03, 1.45055800D+03, 1.42793890D+03,
     $ 1.40540200D+03, 1.38294770D+03, 1.36057620D+03, 1.33828740D+03,
     $ 1.31608080D+03, 1.29395580D+03, 1.27191110D+03, 1.24994530D+03/
      data ( FDNF( 89,J,1),J=1,20) /
     $ 4.660D-06, 9.190D-06, 1.359D-05, 1.786D-05, 2.201D-05, 2.603D-05,
     $ 2.993D-05, 3.370D-05, 3.736D-05, 4.090D-05, 4.431D-05, 4.760D-05,
     $ 5.077D-05, 5.380D-05, 5.670D-05, 5.950D-05, 6.212D-05, 6.458D-05,
     $ 6.693D-05, 6.911D-05/
      data (WNUPF( 89,J,2),J=1,20) /
     $ 2.27655320D+03, 2.24831320D+03, 2.22013480D+03, 2.19202000D+03,
     $ 2.16397060D+03, 2.13598840D+03, 2.10807500D+03, 2.08023190D+03,
     $ 2.05246070D+03, 2.02476250D+03, 1.99713840D+03, 1.96958940D+03,
     $ 1.94211610D+03, 1.91471910D+03, 1.88739840D+03, 1.86015400D+03,
     $ 1.83298560D+03, 1.80589230D+03, 1.77887320D+03, 1.75192660D+03/
      data ( FUPF( 89,J,2),J=1,20) /
     $ 6.243D-06, 1.222D-05, 1.793D-05, 2.338D-05, 2.858D-05, 3.353D-05,
     $ 3.823D-05, 4.269D-05, 4.692D-05, 5.091D-05, 5.467D-05, 5.819D-05,
     $ 6.147D-05, 6.458D-05, 6.740D-05, 7.000D-05, 7.237D-05, 7.452D-05,
     $ 7.638D-05, 7.802D-05/
      data (WNDNF( 89,J,2),J=1,20) /
     $ 1.65637700D+03, 1.63396670D+03, 1.61161950D+03, 1.58933710D+03,
     $ 1.56712140D+03, 1.54497400D+03, 1.52289660D+03, 1.50089060D+03,
     $ 1.47895730D+03, 1.45709800D+03, 1.43531380D+03, 1.41360540D+03,
     $ 1.39197370D+03, 1.37041910D+03, 1.34894190D+03, 1.32754200D+03,
     $ 1.30621940D+03, 1.28497340D+03, 1.26380320D+03, 1.24270750D+03/
      data ( FDNF( 89,J,2),J=1,20) /
     $ 4.477D-06, 8.832D-06, 1.307D-05, 1.718D-05, 2.117D-05, 2.505D-05,
     $ 2.881D-05, 3.246D-05, 3.599D-05, 3.941D-05, 4.271D-05, 4.591D-05,
     $ 4.897D-05, 5.193D-05, 5.476D-05, 5.749D-05, 6.006D-05, 6.251D-05,
     $ 6.480D-05, 6.693D-05/
      data (WNUPF( 90,J,1),J=1,20) /
     $ 2.32828090D+03, 2.29863300D+03, 2.26905110D+03, 2.23953740D+03,
     $ 2.21009390D+03, 2.18072260D+03, 2.15142510D+03, 2.12220320D+03,
     $ 2.09305830D+03, 2.06399180D+03, 2.03500490D+03, 2.00609830D+03,
     $ 1.97727270D+03, 1.94852860D+03, 1.91986590D+03, 1.89128440D+03,
     $ 1.86278350D+03, 1.83436210D+03, 1.80601870D+03, 1.77775140D+03/
      data ( FUPF( 90,J,1),J=1,20) /
     $ 6.542D-06, 1.279D-05, 1.875D-05, 2.444D-05, 2.985D-05, 3.498D-05,
     $ 3.985D-05, 4.446D-05, 4.882D-05, 5.293D-05, 5.676D-05, 6.039D-05,
     $ 6.374D-05, 6.682D-05, 6.966D-05, 7.229D-05, 7.464D-05, 7.670D-05,
     $ 7.855D-05, 8.006D-05/
      data (WNDNF( 90,J,1),J=1,20) /
     $ 1.67463950D+03, 1.65130060D+03, 1.62802940D+03, 1.60482800D+03,
     $ 1.58169830D+03, 1.55864210D+03, 1.53566130D+03, 1.51275730D+03,
     $ 1.48993150D+03, 1.46718540D+03, 1.44451980D+03, 1.42193570D+03,
     $ 1.39943390D+03, 1.37701460D+03, 1.35467820D+03, 1.33242440D+03,
     $ 1.31025270D+03, 1.28816250D+03, 1.26615260D+03, 1.24422130D+03/
      data ( FDNF( 90,J,1),J=1,20) /
     $ 4.650D-06, 9.166D-06, 1.356D-05, 1.782D-05, 2.196D-05, 2.597D-05,
     $ 2.986D-05, 3.363D-05, 3.728D-05, 4.080D-05, 4.420D-05, 4.749D-05,
     $ 5.065D-05, 5.368D-05, 5.657D-05, 5.934D-05, 6.199D-05, 6.442D-05,
     $ 6.680D-05, 6.890D-05/
      data (WNUPF( 90,J,2),J=1,20) /
     $ 2.27675290D+03, 2.24847930D+03, 2.22026720D+03, 2.19211880D+03,
     $ 2.16403570D+03, 2.13601980D+03, 2.10807280D+03, 2.08019620D+03,
     $ 2.05239130D+03, 2.02465950D+03, 1.99700180D+03, 1.96941910D+03,
     $ 1.94191210D+03, 1.91448130D+03, 1.88712670D+03, 1.85984840D+03,
     $ 1.83264590D+03, 1.80551850D+03, 1.77846490D+03, 1.75148380D+03/
      data ( FUPF( 90,J,2),J=1,20) /
     $ 6.246D-06, 1.223D-05, 1.794D-05, 2.339D-05, 2.859D-05, 3.354D-05,
     $ 3.823D-05, 4.269D-05, 4.692D-05, 5.089D-05, 5.465D-05, 5.816D-05,
     $ 6.145D-05, 6.453D-05, 6.732D-05, 6.994D-05, 7.229D-05, 7.441D-05,
     $ 7.626D-05, 7.793D-05/
      data (WNDNF( 90,J,2),J=1,20) /
     $ 1.65031540D+03, 1.62793730D+03, 1.60562230D+03, 1.58337220D+03,
     $ 1.56118890D+03, 1.53907400D+03, 1.51702910D+03, 1.49505570D+03,
     $ 1.47315510D+03, 1.45132850D+03, 1.42957700D+03, 1.40790140D+03,
     $ 1.38630250D+03, 1.36478060D+03, 1.34333620D+03, 1.32196910D+03,
     $ 1.30067920D+03, 1.27946580D+03, 1.25832810D+03, 1.23726490D+03/
      data ( FDNF( 90,J,2),J=1,20) /
     $ 4.467D-06, 8.812D-06, 1.304D-05, 1.714D-05, 2.112D-05, 2.499D-05,
     $ 2.875D-05, 3.238D-05, 3.591D-05, 3.932D-05, 4.262D-05, 4.580D-05,
     $ 4.887D-05, 5.182D-05, 5.464D-05, 5.735D-05, 5.989D-05, 6.238D-05,
     $ 6.464D-05, 6.680D-05/
      data (WNUPF( 91,J,1),J=1,20) /
     $ 2.32834560D+03, 2.29866150D+03, 2.26904350D+03, 2.23949370D+03,
     $ 2.21001400D+03, 2.18060650D+03, 2.15127290D+03, 2.12201490D+03,
     $ 2.09283390D+03, 2.06373130D+03, 2.03470810D+03, 2.00576530D+03,
     $ 1.97690350D+03, 1.94812300D+03, 1.91942390D+03, 1.89080590D+03,
     $ 1.86226820D+03, 1.83380990D+03, 1.80542940D+03, 1.77712470D+03/
      data ( FUPF( 91,J,1),J=1,20) /
     $ 6.547D-06, 1.280D-05, 1.876D-05, 2.445D-05, 2.985D-05, 3.499D-05,
     $ 3.986D-05, 4.446D-05, 4.881D-05, 5.291D-05, 5.674D-05, 6.033D-05,
     $ 6.370D-05, 6.674D-05, 6.961D-05, 7.221D-05, 7.453D-05, 7.657D-05,
     $ 7.840D-05, 7.989D-05/
      data (WNDNF( 91,J,1),J=1,20) /
     $ 1.66823150D+03, 1.64492690D+03, 1.62169020D+03, 1.59852330D+03,
     $ 1.57542820D+03, 1.55240680D+03, 1.52946070D+03, 1.50659160D+03,
     $ 1.48380070D+03, 1.46108950D+03, 1.43845900D+03, 1.41590990D+03,
     $ 1.39344310D+03, 1.37105890D+03, 1.34875750D+03, 1.32653870D+03,
     $ 1.30440190D+03, 1.28234660D+03, 1.26037130D+03, 1.23847450D+03/
      data ( FDNF( 91,J,1),J=1,20) /
     $ 4.639D-06, 9.148D-06, 1.352D-05, 1.778D-05, 2.191D-05, 2.591D-05,
     $ 2.979D-05, 3.355D-05, 3.719D-05, 4.071D-05, 4.410D-05, 4.738D-05,
     $ 5.054D-05, 5.356D-05, 5.645D-05, 5.923D-05, 6.180D-05, 6.426D-05,
     $ 6.661D-05, 6.874D-05/
      data (WNUPF( 91,J,2),J=1,20) /
     $ 2.27690800D+03, 2.24860070D+03, 2.22035490D+03, 2.19217280D+03,
     $ 2.16405600D+03, 2.13600650D+03, 2.10802580D+03, 2.08011550D+03,
     $ 2.05227690D+03, 2.02451150D+03, 1.99682010D+03, 1.96920370D+03,
     $ 1.94166290D+03, 1.91419820D+03, 1.88680980D+03, 1.85949750D+03,
     $ 1.83226090D+03, 1.80509910D+03, 1.77801110D+03, 1.75099530D+03/
      data ( FUPF( 91,J,2),J=1,20) /
     $ 6.254D-06, 1.223D-05, 1.794D-05, 2.340D-05, 2.860D-05, 3.354D-05,
     $ 3.824D-05, 4.269D-05, 4.691D-05, 5.088D-05, 5.462D-05, 5.812D-05,
     $ 6.144D-05, 6.448D-05, 6.729D-05, 6.983D-05, 7.221D-05, 7.431D-05,
     $ 7.613D-05, 7.779D-05/
      data (WNDNF( 91,J,2),J=1,20) /
     $ 1.64423250D+03, 1.62188660D+03, 1.59960380D+03, 1.57738610D+03,
     $ 1.55523520D+03, 1.53315270D+03, 1.51114030D+03, 1.48919950D+03,
     $ 1.46733150D+03, 1.44553760D+03, 1.42381880D+03, 1.40217600D+03,
     $ 1.38060990D+03, 1.35912080D+03, 1.33770910D+03, 1.31637480D+03,
     $ 1.29511750D+03, 1.27393680D+03, 1.25283160D+03, 1.23180070D+03/
      data ( FDNF( 91,J,2),J=1,20) /
     $ 4.457D-06, 8.792D-06, 1.301D-05, 1.710D-05, 2.108D-05, 2.493D-05,
     $ 2.868D-05, 3.231D-05, 3.583D-05, 3.923D-05, 4.252D-05, 4.570D-05,
     $ 4.876D-05, 5.170D-05, 5.452D-05, 5.721D-05, 5.978D-05, 6.219D-05,
     $ 6.448D-05, 6.667D-05/
      data (WNUPF( 92,J,1),J=1,20) /
     $ 2.32836210D+03, 2.29864180D+03, 2.26898760D+03, 2.23940150D+03,
     $ 2.20988570D+03, 2.18044200D+03, 2.15107220D+03, 2.12177800D+03,
     $ 2.09256080D+03, 2.06342200D+03, 2.03436270D+03, 2.00538360D+03,
     $ 1.97648550D+03, 1.94766860D+03, 1.91893300D+03, 1.89027830D+03,
     $ 1.86170390D+03, 1.83320860D+03, 1.80479080D+03, 1.77644870D+03/
      data ( FUPF( 92,J,1),J=1,20) /
     $ 6.552D-06, 1.280D-05, 1.877D-05, 2.445D-05, 2.986D-05, 3.499D-05,
     $ 3.985D-05, 4.445D-05, 4.880D-05, 5.288D-05, 5.672D-05, 6.027D-05,
     $ 6.361D-05, 6.672D-05, 6.951D-05, 7.208D-05, 7.443D-05, 7.645D-05,
     $ 7.825D-05, 7.973D-05/
      data (WNDNF( 92,J,1),J=1,20) /
     $ 1.66180110D+03, 1.63853090D+03, 1.61532860D+03, 1.59219630D+03,
     $ 1.56913580D+03, 1.54614910D+03, 1.52323770D+03, 1.50040340D+03,
     $ 1.47764750D+03, 1.45497120D+03, 1.43237560D+03, 1.40986160D+03,
     $ 1.38742990D+03, 1.36508070D+03, 1.34281430D+03, 1.32063040D+03,
     $ 1.29852860D+03, 1.27650800D+03, 1.25456740D+03, 1.23270520D+03/
      data ( FDNF( 92,J,1),J=1,20) /
     $ 4.628D-06, 9.124D-06, 1.349D-05, 1.774D-05, 2.185D-05, 2.585D-05,
     $ 2.972D-05, 3.347D-05, 3.710D-05, 4.062D-05, 4.401D-05, 4.727D-05,
     $ 5.042D-05, 5.343D-05, 5.632D-05, 5.908D-05, 6.168D-05, 6.416D-05,
     $ 6.649D-05, 6.859D-05/
      data (WNUPF( 92,J,2),J=1,20) /
     $ 2.27701840D+03, 2.24867730D+03, 2.22039780D+03, 2.19218190D+03,
     $ 2.16403140D+03, 2.13594810D+03, 2.10793370D+03, 2.07998970D+03,
     $ 2.05211750D+03, 2.02431830D+03, 1.99659310D+03, 1.96894300D+03,
     $ 1.94136840D+03, 1.91386990D+03, 1.88644750D+03, 1.85910110D+03,
     $ 1.83183030D+03, 1.80463420D+03, 1.77751170D+03, 1.75046110D+03/
      data ( FUPF( 92,J,2),J=1,20) /
     $ 6.257D-06, 1.224D-05, 1.795D-05, 2.341D-05, 2.860D-05, 3.355D-05,
     $ 3.823D-05, 4.268D-05, 4.690D-05, 5.086D-05, 5.460D-05, 5.809D-05,
     $ 6.137D-05, 6.443D-05, 6.721D-05, 6.978D-05, 7.213D-05, 7.421D-05,
     $ 7.601D-05, 7.765D-05/
      data (WNDNF( 92,J,2),J=1,20) /
     $ 1.63812860D+03, 1.61581480D+03, 1.59356430D+03, 1.57137880D+03,
     $ 1.54926020D+03, 1.52721020D+03, 1.50523040D+03, 1.48332210D+03,
     $ 1.46148680D+03, 1.43972550D+03, 1.41803950D+03, 1.39642940D+03,
     $ 1.37489600D+03, 1.35343970D+03, 1.33206080D+03, 1.31075920D+03,
     $ 1.28953460D+03, 1.26838640D+03, 1.24731370D+03, 1.22631520D+03/
      data ( FDNF( 92,J,2),J=1,20) /
     $ 4.447D-06, 8.773D-06, 1.298D-05, 1.706D-05, 2.103D-05, 2.488D-05,
     $ 2.862D-05, 3.224D-05, 3.575D-05, 3.915D-05, 4.243D-05, 4.560D-05,
     $ 4.865D-05, 5.158D-05, 5.438D-05, 5.708D-05, 5.962D-05, 6.205D-05,
     $ 6.438D-05, 6.649D-05/
      data (WNUPF( 93,J,1),J=1,20) /
     $ 2.32833020D+03, 2.29857370D+03, 2.26888320D+03, 2.23926090D+03,
     $ 2.20970880D+03, 2.18022880D+03, 2.15082280D+03, 2.12149240D+03,
     $ 2.09223900D+03, 2.06306390D+03, 2.03396830D+03, 2.00495290D+03,
     $ 1.97601840D+03, 1.94716510D+03, 1.91839290D+03, 1.88970150D+03,
     $ 1.86109020D+03, 1.83255780D+03, 1.80410280D+03, 1.77572310D+03/
      data ( FUPF( 93,J,1),J=1,20) /
     $ 6.557D-06, 1.281D-05, 1.878D-05, 2.446D-05, 2.986D-05, 3.499D-05,
     $ 3.985D-05, 4.444D-05, 4.878D-05, 5.286D-05, 5.670D-05, 6.027D-05,
     $ 6.357D-05, 6.665D-05, 6.946D-05, 7.200D-05, 7.427D-05, 7.632D-05,
     $ 7.811D-05, 7.957D-05/
      data (WNDNF( 93,J,1),J=1,20) /
     $ 1.65534850D+03, 1.63211270D+03, 1.60894480D+03, 1.58584690D+03,
     $ 1.56282110D+03, 1.53986900D+03, 1.51699240D+03, 1.49419290D+03,
     $ 1.47147180D+03, 1.44883050D+03, 1.42626990D+03, 1.40379090D+03,
     $ 1.38139420D+03, 1.35908000D+03, 1.33684860D+03, 1.31469970D+03,
     $ 1.29263270D+03, 1.27064690D+03, 1.24874100D+03, 1.22691330D+03/
      data ( FDNF( 93,J,1),J=1,20) /
     $ 4.617D-06, 9.102D-06, 1.346D-05, 1.770D-05, 2.180D-05, 2.579D-05,
     $ 2.965D-05, 3.340D-05, 3.702D-05, 4.052D-05, 4.390D-05, 4.717D-05,
     $ 5.030D-05, 5.331D-05, 5.620D-05, 5.893D-05, 6.155D-05, 6.401D-05,
     $ 6.631D-05, 6.845D-05/
      data (WNUPF( 93,J,2),J=1,20) /
     $ 2.27708390D+03, 2.24870900D+03, 2.22039570D+03, 2.19214600D+03,
     $ 2.16396170D+03, 2.13584470D+03, 2.10779650D+03, 2.07981870D+03,
     $ 2.05191270D+03, 2.02407970D+03, 1.99632080D+03, 1.96863680D+03,
     $ 1.94102840D+03, 1.91349590D+03, 1.88603950D+03, 1.85865910D+03,
     $ 1.83135400D+03, 1.80412350D+03, 1.77696640D+03, 1.74988100D+03/
      data ( FUPF( 93,J,2),J=1,20) /
     $ 6.259D-06, 1.225D-05, 1.796D-05, 2.342D-05, 2.861D-05, 3.355D-05,
     $ 3.824D-05, 4.268D-05, 4.689D-05, 5.085D-05, 5.459D-05, 5.805D-05,
     $ 6.135D-05, 6.438D-05, 6.714D-05, 6.968D-05, 7.200D-05, 7.411D-05,
     $ 7.589D-05, 7.751D-05/
      data (WNDNF( 93,J,2),J=1,20) /
     $ 1.63200360D+03, 1.60972200D+03, 1.58750360D+03, 1.56535050D+03,
     $ 1.54326420D+03, 1.52124670D+03, 1.49929930D+03, 1.47742360D+03,
     $ 1.45562090D+03, 1.43389230D+03, 1.41223890D+03, 1.39066160D+03,
     $ 1.36916090D+03, 1.34773740D+03, 1.32639120D+03, 1.30512230D+03,
     $ 1.28393040D+03, 1.26281480D+03, 1.24177460D+03, 1.22080850D+03/
      data ( FDNF( 93,J,2),J=1,20) /
     $ 4.437D-06, 8.754D-06, 1.295D-05, 1.702D-05, 2.098D-05, 2.482D-05,
     $ 2.855D-05, 3.217D-05, 3.567D-05, 3.905D-05, 4.233D-05, 4.550D-05,
     $ 4.854D-05, 5.147D-05, 5.428D-05, 5.695D-05, 5.952D-05, 6.193D-05,
     $ 6.422D-05, 6.636D-05/
      data (WNUPF( 94,J,1),J=1,20) /
     $ 2.32824990D+03, 2.29845700D+03, 2.26873020D+03, 2.23907160D+03,
     $ 2.20948320D+03, 2.17996700D+03, 2.15052460D+03, 2.12115790D+03,
     $ 2.09186820D+03, 2.06265690D+03, 2.03352490D+03, 2.00447310D+03,
     $ 1.97550220D+03, 1.94661230D+03, 1.91780350D+03, 1.88907530D+03,
     $ 1.86042710D+03, 1.83185760D+03, 1.80336520D+03, 1.77494780D+03/
      data ( FUPF( 94,J,1),J=1,20) /
     $ 6.556D-06, 1.282D-05, 1.879D-05, 2.447D-05, 2.987D-05, 3.499D-05,
     $ 3.984D-05, 4.443D-05, 4.876D-05, 5.283D-05, 5.663D-05, 6.021D-05,
     $ 6.353D-05, 6.658D-05, 6.936D-05, 7.193D-05, 7.417D-05, 7.620D-05,
     $ 7.797D-05, 7.941D-05/
      data (WNDNF( 94,J,1),J=1,20) /
     $ 1.64887380D+03, 1.62567230D+03, 1.60253880D+03, 1.57947540D+03,
     $ 1.55648410D+03, 1.53356670D+03, 1.51072490D+03, 1.48796010D+03,
     $ 1.46527400D+03, 1.44266750D+03, 1.42014190D+03, 1.39769790D+03,
     $ 1.37533620D+03, 1.35305710D+03, 1.33086060D+03, 1.30874660D+03,
     $ 1.28671460D+03, 1.26476350D+03, 1.24289220D+03, 1.22109890D+03/
      data ( FDNF( 94,J,1),J=1,20) /
     $ 4.606D-06, 9.085D-06, 1.343D-05, 1.766D-05, 2.175D-05, 2.572D-05,
     $ 2.958D-05, 3.332D-05, 3.693D-05, 4.043D-05, 4.380D-05, 4.705D-05,
     $ 5.019D-05, 5.317D-05, 5.603D-05, 5.878D-05, 6.138D-05, 6.381D-05,
     $ 6.614D-05, 6.825D-05/
      data (WNUPF( 94,J,2),J=1,20) /
     $ 2.27710430D+03, 2.24869560D+03, 2.22034840D+03, 2.19206490D+03,
     $ 2.16384680D+03, 2.13569590D+03, 2.10761390D+03, 2.07960240D+03,
     $ 2.05166260D+03, 2.02379580D+03, 1.99600300D+03, 1.96828520D+03,
     $ 1.94064280D+03, 1.91307630D+03, 1.88558590D+03, 1.85817120D+03,
     $ 1.83083180D+03, 1.80356680D+03, 1.77637500D+03, 1.74925470D+03/
      data ( FUPF( 94,J,2),J=1,20) /
     $ 6.262D-06, 1.225D-05, 1.796D-05, 2.342D-05, 2.861D-05, 3.355D-05,
     $ 3.824D-05, 4.267D-05, 4.687D-05, 5.083D-05, 5.455D-05, 5.802D-05,
     $ 6.128D-05, 6.428D-05, 6.706D-05, 6.963D-05, 7.193D-05, 7.396D-05,
     $ 7.578D-05, 7.733D-05/
      data (WNDNF( 94,J,2),J=1,20) /
     $ 1.62585780D+03, 1.60360830D+03, 1.58142210D+03, 1.55930120D+03,
     $ 1.53724730D+03, 1.51526210D+03, 1.49334720D+03, 1.47150410D+03,
     $ 1.44973390D+03, 1.42803800D+03, 1.40641740D+03, 1.38487280D+03,
     $ 1.36340490D+03, 1.34201410D+03, 1.32070060D+03, 1.29946440D+03,
     $ 1.27830510D+03, 1.25722210D+03, 1.23621430D+03, 1.21528050D+03/
      data ( FDNF( 94,J,2),J=1,20) /
     $ 4.427D-06, 8.730D-06, 1.292D-05, 1.698D-05, 2.093D-05, 2.477D-05,
     $ 2.849D-05, 3.209D-05, 3.559D-05, 3.897D-05, 4.224D-05, 4.539D-05,
     $ 4.843D-05, 5.135D-05, 5.418D-05, 5.683D-05, 5.937D-05, 6.180D-05,
     $ 6.407D-05, 6.619D-05/
      data (WNUPF( 95,J,1),J=1,20) /
     $ 2.32812090D+03, 2.29829170D+03, 2.26852850D+03, 2.23883350D+03,
     $ 2.20920870D+03, 2.17965610D+03, 2.15017750D+03, 2.12077440D+03,
     $ 2.09144840D+03, 2.06220060D+03, 2.03303230D+03, 2.00394410D+03,
     $ 1.97493660D+03, 1.94601010D+03, 1.91716460D+03, 1.88839960D+03,
     $ 1.85971430D+03, 1.83110750D+03, 1.80257760D+03, 1.77412250D+03/
      data ( FUPF( 95,J,1),J=1,20) /
     $ 6.561D-06, 1.282D-05, 1.879D-05, 2.447D-05, 2.987D-05, 3.499D-05,
     $ 3.984D-05, 4.442D-05, 4.874D-05, 5.280D-05, 5.661D-05, 6.016D-05,
     $ 6.344D-05, 6.651D-05, 6.926D-05, 7.180D-05, 7.407D-05, 7.603D-05,
     $ 7.778D-05, 7.921D-05/
      data (WNDNF( 95,J,1),J=1,20) /
     $ 1.64237720D+03, 1.61920990D+03, 1.59611080D+03, 1.57308190D+03,
     $ 1.55012510D+03, 1.52724230D+03, 1.50443520D+03, 1.48170530D+03,
     $ 1.45905400D+03, 1.43648250D+03, 1.41399180D+03, 1.39158280D+03,
     $ 1.36925610D+03, 1.34701190D+03, 1.32485040D+03, 1.30277140D+03,
     $ 1.28077410D+03, 1.25885780D+03, 1.23702110D+03, 1.21526230D+03/
      data ( FDNF( 95,J,1),J=1,20) /
     $ 4.595D-06, 9.063D-06, 1.340D-05, 1.761D-05, 2.170D-05, 2.566D-05,
     $ 2.951D-05, 3.324D-05, 3.684D-05, 4.034D-05, 4.370D-05, 4.694D-05,
     $ 5.007D-05, 5.304D-05, 5.592D-05, 5.864D-05, 6.126D-05, 6.366D-05,
     $ 6.597D-05, 6.812D-05/
      data (WNUPF( 95,J,2),J=1,20) /
     $ 2.27707960D+03, 2.24863690D+03, 2.22025590D+03, 2.19193850D+03,
     $ 2.16368650D+03, 2.13550180D+03, 2.10738590D+03, 2.07934050D+03,
     $ 2.05136680D+03, 2.02346620D+03, 1.99563950D+03, 1.96788770D+03,
     $ 1.94021140D+03, 1.91261090D+03, 1.88508630D+03, 1.85763740D+03,
     $ 1.83026360D+03, 1.80296410D+03, 1.77573750D+03, 1.74858220D+03/
      data ( FUPF( 95,J,2),J=1,20) /
     $ 6.270D-06, 1.226D-05, 1.797D-05, 2.343D-05, 2.862D-05, 3.355D-05,
     $ 3.823D-05, 4.267D-05, 4.686D-05, 5.080D-05, 5.450D-05, 5.799D-05,
     $ 6.122D-05, 6.423D-05, 6.698D-05, 6.952D-05, 7.180D-05, 7.386D-05,
     $ 7.566D-05, 7.720D-05/
      data (WNDNF( 95,J,2),J=1,20) /
     $ 1.61969110D+03, 1.59747370D+03, 1.57531970D+03, 1.55323110D+03,
     $ 1.53120950D+03, 1.50925670D+03, 1.48737430D+03, 1.46556360D+03,
     $ 1.44382610D+03, 1.42216290D+03, 1.40057490D+03, 1.37906300D+03,
     $ 1.35762780D+03, 1.33626980D+03, 1.31498900D+03, 1.29378550D+03,
     $ 1.27265890D+03, 1.25160840D+03, 1.23063310D+03, 1.20973160D+03/
      data ( FDNF( 95,J,2),J=1,20) /
     $ 4.417D-06, 8.712D-06, 1.290D-05, 1.694D-05, 2.088D-05, 2.471D-05,
     $ 2.842D-05, 3.202D-05, 3.551D-05, 3.888D-05, 4.214D-05, 4.529D-05,
     $ 4.832D-05, 5.124D-05, 5.403D-05, 5.670D-05, 5.921D-05, 6.162D-05,
     $ 6.393D-05, 6.602D-05/
      data (WNUPF( 96,J,1),J=1,20) /
     $ 2.32794320D+03, 2.29807750D+03, 2.26827790D+03, 2.23854640D+03,
     $ 2.20888530D+03, 2.17929620D+03, 2.14978120D+03, 2.12034170D+03,
     $ 2.09097930D+03, 2.06169510D+03, 2.03249030D+03, 2.00336550D+03,
     $ 1.97432150D+03, 1.94535830D+03, 1.91647600D+03, 1.88767410D+03,
     $ 1.85895170D+03, 1.83030760D+03, 1.80174010D+03, 1.77324710D+03/
      data ( FUPF( 96,J,1),J=1,20) /
     $ 6.565D-06, 1.283D-05, 1.880D-05, 2.448D-05, 2.987D-05, 3.498D-05,
     $ 3.983D-05, 4.441D-05, 4.872D-05, 5.277D-05, 5.654D-05, 6.010D-05,
     $ 6.340D-05, 6.644D-05, 6.916D-05, 7.168D-05, 7.393D-05, 7.592D-05,
     $ 7.764D-05, 7.906D-05/
      data (WNDNF( 96,J,1),J=1,20) /
     $ 1.63585860D+03, 1.61272570D+03, 1.58966090D+03, 1.56666640D+03,
     $ 1.54374420D+03, 1.52089600D+03, 1.49812360D+03, 1.47542840D+03,
     $ 1.45281200D+03, 1.43027530D+03, 1.40781960D+03, 1.38544560D+03,
     $ 1.36315390D+03, 1.34094470D+03, 1.31881820D+03, 1.29677400D+03,
     $ 1.27481160D+03, 1.25293000D+03, 1.23112790D+03, 1.20940350D+03/
      data ( FDNF( 96,J,1),J=1,20) /
     $ 4.584D-06, 9.041D-06, 1.337D-05, 1.757D-05, 2.165D-05, 2.561D-05,
     $ 2.944D-05, 3.316D-05, 3.676D-05, 4.024D-05, 4.360D-05, 4.683D-05,
     $ 4.995D-05, 5.295D-05, 5.580D-05, 5.850D-05, 6.109D-05, 6.352D-05,
     $ 6.580D-05, 6.793D-05/
      data (WNUPF( 96,J,2),J=1,20) /
     $ 2.27700950D+03, 2.24853300D+03, 2.22011800D+03, 2.19176660D+03,
     $ 2.16348070D+03, 2.13526210D+03, 2.10711230D+03, 2.07903300D+03,
     $ 2.05102540D+03, 2.02309080D+03, 1.99523020D+03, 1.96744450D+03,
     $ 1.93973410D+03, 1.91209950D+03, 1.88454070D+03, 1.85705740D+03,
     $ 1.82964920D+03, 1.80231500D+03, 1.77505360D+03, 1.74786330D+03/
      data ( FUPF( 96,J,2),J=1,20) /
     $ 6.272D-06, 1.226D-05, 1.797D-05, 2.343D-05, 2.862D-05, 3.355D-05,
     $ 3.823D-05, 4.265D-05, 4.684D-05, 5.079D-05, 5.450D-05, 5.796D-05,
     $ 6.120D-05, 6.419D-05, 6.691D-05, 6.942D-05, 7.173D-05, 7.372D-05,
     $ 7.550D-05, 7.702D-05/
      data (WNDNF( 96,J,2),J=1,20) /
     $ 1.61350390D+03, 1.59131850D+03, 1.56919670D+03, 1.54714020D+03,
     $ 1.52515100D+03, 1.50323050D+03, 1.48138060D+03, 1.45960240D+03,
     $ 1.43789750D+03, 1.41626690D+03, 1.39471160D+03, 1.37323240D+03,
     $ 1.35182990D+03, 1.33050460D+03, 1.30925660D+03, 1.28808570D+03,
     $ 1.26699170D+03, 1.24597370D+03, 1.22503080D+03, 1.20416160D+03/
      data ( FDNF( 96,J,2),J=1,20) /
     $ 4.407D-06, 8.694D-06, 1.287D-05, 1.691D-05, 2.083D-05, 2.465D-05,
     $ 2.836D-05, 3.194D-05, 3.542D-05, 3.879D-05, 4.205D-05, 4.519D-05,
     $ 4.821D-05, 5.112D-05, 5.389D-05, 5.658D-05, 5.912D-05, 6.150D-05,
     $ 6.378D-05, 6.585D-05/
      data (WNUPF( 97,J,1),J=1,20) /
     $ 2.32771650D+03, 2.29781430D+03, 2.26797820D+03, 2.23821030D+03,
     $ 2.20851260D+03, 2.17888710D+03, 2.14933560D+03, 2.11985970D+03,
     $ 2.09046070D+03, 2.06114010D+03, 2.03189870D+03, 2.00273740D+03,
     $ 1.97365670D+03, 1.94465680D+03, 1.91573760D+03, 1.88689860D+03,
     $ 1.85813900D+03, 1.82945760D+03, 1.80085240D+03, 1.77232140D+03/
      data ( FUPF( 97,J,1),J=1,20) /
     $ 6.570D-06, 1.283D-05, 1.880D-05, 2.448D-05, 2.987D-05, 3.498D-05,
     $ 3.982D-05, 4.439D-05, 4.870D-05, 5.275D-05, 5.653D-05, 6.005D-05,
     $ 6.332D-05, 6.632D-05, 6.907D-05, 7.161D-05, 7.383D-05, 7.575D-05,
     $ 7.746D-05, 7.886D-05/
      data (WNDNF( 97,J,1),J=1,20) /
     $ 1.62931840D+03, 1.60621970D+03, 1.58318920D+03, 1.56022920D+03,
     $ 1.53734140D+03, 1.51452790D+03, 1.49179010D+03, 1.46912970D+03,
     $ 1.44654800D+03, 1.42404630D+03, 1.40162550D+03, 1.37928650D+03,
     $ 1.35702970D+03, 1.33485550D+03, 1.31276390D+03, 1.29075460D+03,
     $ 1.26882700D+03, 1.24698010D+03, 1.22521260D+03, 1.20352260D+03/
      data ( FDNF( 97,J,1),J=1,20) /
     $ 4.574D-06, 9.021D-06, 1.333D-05, 1.753D-05, 2.160D-05, 2.554D-05,
     $ 2.937D-05, 3.308D-05, 3.667D-05, 4.014D-05, 4.349D-05, 4.672D-05,
     $ 4.983D-05, 5.282D-05, 5.564D-05, 5.836D-05, 6.097D-05, 6.338D-05,
     $ 6.564D-05, 6.774D-05/
      data (WNUPF( 97,J,2),J=1,20) /
     $ 2.27689410D+03, 2.24838350D+03, 2.21993450D+03, 2.19154920D+03,
     $ 2.16322930D+03, 2.13497670D+03, 2.10679300D+03, 2.07867970D+03,
     $ 2.05063810D+03, 2.02266960D+03, 1.99477500D+03, 1.96695520D+03,
     $ 1.93921070D+03, 1.91154190D+03, 1.88394880D+03, 1.85643120D+03,
     $ 1.82898840D+03, 1.80161960D+03, 1.77432330D+03, 1.74709770D+03/
      data ( FUPF( 97,J,2),J=1,20) /
     $ 6.275D-06, 1.227D-05, 1.798D-05, 2.344D-05, 2.862D-05, 3.355D-05,
     $ 3.822D-05, 4.265D-05, 4.683D-05, 5.076D-05, 5.446D-05, 5.793D-05,
     $ 6.114D-05, 6.409D-05, 6.684D-05, 6.933D-05, 7.161D-05, 7.363D-05,
     $ 7.539D-05, 7.689D-05/
      data (WNDNF( 97,J,2),J=1,20) /
     $ 1.60729600D+03, 1.58514270D+03, 1.56305300D+03, 1.54102880D+03,
     $ 1.51907180D+03, 1.49718370D+03, 1.47536620D+03, 1.45362060D+03,
     $ 1.43194820D+03, 1.41035020D+03, 1.38882750D+03, 1.36738100D+03,
     $ 1.34601130D+03, 1.32471870D+03, 1.30350340D+03, 1.28236520D+03,
     $ 1.26130370D+03, 1.24031830D+03, 1.21940780D+03, 1.19857090D+03/
      data ( FDNF( 97,J,2),J=1,20) /
     $ 4.396D-06, 8.672D-06, 1.284D-05, 1.687D-05, 2.079D-05, 2.459D-05,
     $ 2.829D-05, 3.187D-05, 3.534D-05, 3.870D-05, 4.195D-05, 4.509D-05,
     $ 4.810D-05, 5.101D-05, 5.379D-05, 5.646D-05, 5.897D-05, 6.133D-05,
     $ 6.359D-05, 6.569D-05/
      data (WNUPF( 98,J,1),J=1,20) /
     $ 2.32744070D+03, 2.29750200D+03, 2.26762930D+03, 2.23782480D+03,
     $ 2.20809060D+03, 2.17842860D+03, 2.14884060D+03, 2.11932810D+03,
     $ 2.08989260D+03, 2.06053540D+03, 2.03125740D+03, 2.00205950D+03,
     $ 1.97294200D+03, 1.94390530D+03, 1.91494920D+03, 1.88607310D+03,
     $ 1.85727620D+03, 1.82855720D+03, 1.79991430D+03, 1.77134530D+03/
      data ( FUPF( 98,J,1),J=1,20) /
     $ 6.569D-06, 1.284D-05, 1.881D-05, 2.448D-05, 2.987D-05, 3.498D-05,
     $ 3.981D-05, 4.437D-05, 4.868D-05, 5.272D-05, 5.646D-05, 6.000D-05,
     $ 6.328D-05, 6.626D-05, 6.897D-05, 7.149D-05, 7.369D-05, 7.564D-05,
     $ 7.728D-05, 7.867D-05/
      data (WNDNF( 98,J,1),J=1,20) /
     $ 1.62275650D+03, 1.59969200D+03, 1.57669590D+03, 1.55377020D+03,
     $ 1.53091700D+03, 1.50813790D+03, 1.48543490D+03, 1.46280920D+03,
     $ 1.44026240D+03, 1.41779550D+03, 1.39540960D+03, 1.37310550D+03,
     $ 1.35088370D+03, 1.32874450D+03, 1.30668780D+03, 1.28471340D+03,
     $ 1.26282060D+03, 1.24100840D+03, 1.21927530D+03, 1.19761970D+03/
      data ( FDNF( 98,J,1),J=1,20) /
     $ 4.563D-06, 8.995D-06, 1.330D-05, 1.749D-05, 2.155D-05, 2.548D-05,
     $ 2.930D-05, 3.300D-05, 3.658D-05, 4.005D-05, 4.339D-05, 4.661D-05,
     $ 4.971D-05, 5.269D-05, 5.553D-05, 5.822D-05, 6.081D-05, 6.320D-05,
     $ 6.548D-05, 6.756D-05/
      data (WNUPF( 98,J,2),J=1,20) /
     $ 2.27673300D+03, 2.24818840D+03, 2.21970540D+03, 2.19128600D+03,
     $ 2.16293210D+03, 2.13464550D+03, 2.10642770D+03, 2.07828040D+03,
     $ 2.05020490D+03, 2.02220230D+03, 1.99427360D+03, 1.96641970D+03,
     $ 1.93864110D+03, 1.91093800D+03, 1.88331060D+03, 1.85575850D+03,
     $ 1.82828120D+03, 1.80087750D+03, 1.77354620D+03, 1.74628540D+03/
      data ( FUPF( 98,J,2),J=1,20) /
     $ 6.277D-06, 1.227D-05, 1.798D-05, 2.344D-05, 2.863D-05, 3.355D-05,
     $ 3.822D-05, 4.264D-05, 4.681D-05, 5.073D-05, 5.441D-05, 5.785D-05,
     $ 6.108D-05, 6.405D-05, 6.677D-05, 6.923D-05, 7.149D-05, 7.349D-05,
     $ 7.523D-05, 7.672D-05/
      data (WNDNF( 98,J,2),J=1,20) /
     $ 1.60106780D+03, 1.57894650D+03, 1.55688890D+03, 1.53489680D+03,
     $ 1.51297210D+03, 1.49111640D+03, 1.46933120D+03, 1.44761810D+03,
     $ 1.42597830D+03, 1.40441290D+03, 1.38292290D+03, 1.36150910D+03,
     $ 1.34017210D+03, 1.31891220D+03, 1.29772950D+03, 1.27662400D+03,
     $ 1.25559510D+03, 1.23464210D+03, 1.21376400D+03, 1.19295930D+03/
      data ( FDNF( 98,J,2),J=1,20) /
     $ 4.386D-06, 8.650D-06, 1.281D-05, 1.683D-05, 2.074D-05, 2.454D-05,
     $ 2.822D-05, 3.180D-05, 3.526D-05, 3.861D-05, 4.185D-05, 4.498D-05,
     $ 4.799D-05, 5.091D-05, 5.365D-05, 5.629D-05, 5.883D-05, 6.122D-05,
     $ 6.345D-05, 6.553D-05/
      data (WNUPF( 99,J,1),J=1,20) /
     $ 2.32711570D+03, 2.29714040D+03, 2.26723100D+03, 2.23739000D+03,
     $ 2.20761910D+03, 2.17792050D+03, 2.14829590D+03, 2.11874680D+03,
     $ 2.08927470D+03, 2.05988090D+03, 2.03056630D+03, 2.00133160D+03,
     $ 1.97217730D+03, 1.94310370D+03, 1.91411060D+03, 1.88519730D+03,
     $ 1.85636300D+03, 1.82760640D+03, 1.79892570D+03, 1.77031840D+03/
      data ( FUPF( 99,J,1),J=1,20) /
     $ 6.574D-06, 1.284D-05, 1.881D-05, 2.448D-05, 2.987D-05, 3.497D-05,
     $ 3.980D-05, 4.436D-05, 4.865D-05, 5.269D-05, 5.645D-05, 5.995D-05,
     $ 6.320D-05, 6.619D-05, 6.888D-05, 7.137D-05, 7.355D-05, 7.548D-05,
     $ 7.711D-05, 7.848D-05/
      data (WNDNF( 99,J,1),J=1,20) /
     $ 1.61617310D+03, 1.59314280D+03, 1.57018090D+03, 1.54728960D+03,
     $ 1.52447090D+03, 1.50172640D+03, 1.47905800D+03, 1.45646700D+03,
     $ 1.43395500D+03, 1.41152300D+03, 1.38917200D+03, 1.36690280D+03,
     $ 1.34471600D+03, 1.32261170D+03, 1.30058990D+03, 1.27865030D+03,
     $ 1.25679230D+03, 1.23501480D+03, 1.21331620D+03, 1.19169490D+03/
      data ( FDNF( 99,J,1),J=1,20) /
     $ 4.552D-06, 8.975D-06, 1.327D-05, 1.745D-05, 2.149D-05, 2.542D-05,
     $ 2.923D-05, 3.292D-05, 3.650D-05, 3.995D-05, 4.329D-05, 4.650D-05,
     $ 4.959D-05, 5.256D-05, 5.538D-05, 5.809D-05, 6.065D-05, 6.307D-05,
     $ 6.533D-05, 6.744D-05/
      data (WNUPF( 99,J,2),J=1,20) /
     $ 2.27652630D+03, 2.24794750D+03, 2.21943040D+03, 2.19097700D+03,
     $ 2.16258900D+03, 2.13426830D+03, 2.10601650D+03, 2.07783510D+03,
     $ 2.04972540D+03, 2.02168870D+03, 1.99372600D+03, 1.96583790D+03,
     $ 1.93802500D+03, 1.91028770D+03, 1.88262590D+03, 1.85503930D+03,
     $ 1.82752720D+03, 1.80008870D+03, 1.77272230D+03, 1.74542620D+03/
      data ( FUPF( 99,J,2),J=1,20) /
     $ 6.279D-06, 1.228D-05, 1.799D-05, 2.345D-05, 2.862D-05, 3.355D-05,
     $ 3.821D-05, 4.262D-05, 4.679D-05, 5.071D-05, 5.437D-05, 5.782D-05,
     $ 6.102D-05, 6.396D-05, 6.670D-05, 6.914D-05, 7.137D-05, 7.335D-05,
     $ 7.508D-05, 7.655D-05/
      data (WNDNF( 99,J,2),J=1,20) /
     $ 1.59481910D+03, 1.57272990D+03, 1.55070430D+03, 1.52874440D+03,
     $ 1.50685200D+03, 1.48502860D+03, 1.46327590D+03, 1.44159520D+03,
     $ 1.41998790D+03, 1.39845510D+03, 1.37699780D+03, 1.35561660D+03,
     $ 1.33431230D+03, 1.31308510D+03, 1.29193510D+03, 1.27086220D+03,
     $ 1.24986580D+03, 1.22894540D+03, 1.20809960D+03, 1.18732710D+03/
      data ( FDNF( 99,J,2),J=1,20) /
     $ 4.376D-06, 8.633D-06, 1.277D-05, 1.679D-05, 2.069D-05, 2.448D-05,
     $ 2.816D-05, 3.172D-05, 3.518D-05, 3.852D-05, 4.176D-05, 4.488D-05,
     $ 4.788D-05, 5.075D-05, 5.352D-05, 5.618D-05, 5.869D-05, 6.106D-05,
     $ 6.332D-05, 6.538D-05/
      data (WNUPF(100,J,1),J=1,20) /
     $ 2.32674130D+03, 2.29672930D+03, 2.26678330D+03, 2.23690550D+03,
     $ 2.20709800D+03, 2.17736270D+03, 2.14770140D+03, 2.11811570D+03,
     $ 2.08860700D+03, 2.05917640D+03, 2.02982500D+03, 2.00055360D+03,
     $ 1.97136240D+03, 1.94225180D+03, 1.91322160D+03, 1.88427100D+03,
     $ 1.85539930D+03, 1.82660500D+03, 1.79788630D+03, 1.76924070D+03/
      data ( FUPF(100,J,1),J=1,20) /
     $ 6.578D-06, 1.284D-05, 1.881D-05, 2.448D-05, 2.986D-05, 3.496D-05,
     $ 3.979D-05, 4.434D-05, 4.862D-05, 5.266D-05, 5.638D-05, 5.990D-05,
     $ 6.312D-05, 6.608D-05, 6.879D-05, 7.126D-05, 7.342D-05, 7.533D-05,
     $ 7.693D-05, 7.829D-05/
      data (WNDNF(100,J,1),J=1,20) /
     $ 1.60956830D+03, 1.58657220D+03, 1.56364460D+03, 1.54078760D+03,
     $ 1.51800330D+03, 1.49529340D+03, 1.47265960D+03, 1.45010330D+03,
     $ 1.42762610D+03, 1.40522890D+03, 1.38291280D+03, 1.36067860D+03,
     $ 1.33852660D+03, 1.31645730D+03, 1.29447040D+03, 1.27256570D+03,
     $ 1.25074240D+03, 1.22899940D+03, 1.20733540D+03, 1.18574840D+03/
      data ( FDNF(100,J,1),J=1,20) /
     $ 4.541D-06, 8.955D-06, 1.324D-05, 1.740D-05, 2.144D-05, 2.536D-05,
     $ 2.916D-05, 3.285D-05, 3.641D-05, 3.986D-05, 4.318D-05, 4.639D-05,
     $ 4.948D-05, 5.244D-05, 5.527D-05, 5.796D-05, 6.050D-05, 6.289D-05,
     $ 6.517D-05, 6.726D-05/
      data (WNUPF(100,J,2),J=1,20) /
     $ 2.27627370D+03, 2.24766080D+03, 2.21910950D+03, 2.19062190D+03,
     $ 2.16219980D+03, 2.13384490D+03, 2.10555900D+03, 2.07734350D+03,
     $ 2.04919970D+03, 2.02112890D+03, 1.99313190D+03, 1.96520960D+03,
     $ 1.93736250D+03, 1.90959080D+03, 1.88189450D+03, 1.85427330D+03,
     $ 1.82672640D+03, 1.79925300D+03, 1.77185140D+03, 1.74451980D+03/
      data ( FUPF(100,J,2),J=1,20) /
     $ 6.281D-06, 1.228D-05, 1.799D-05, 2.345D-05, 2.863D-05, 3.354D-05,
     $ 3.820D-05, 4.261D-05, 4.677D-05, 5.065D-05, 5.437D-05, 5.779D-05,
     $ 6.095D-05, 6.392D-05, 6.658D-05, 6.905D-05, 7.126D-05, 7.322D-05,
     $ 7.492D-05, 7.638D-05/
      data (WNDNF(100,J,2),J=1,20) /
     $ 1.58855030D+03, 1.56649300D+03, 1.54449950D+03, 1.52257180D+03,
     $ 1.50071150D+03, 1.47892040D+03, 1.45720010D+03, 1.43555190D+03,
     $ 1.41397720D+03, 1.39247690D+03, 1.37105220D+03, 1.34970370D+03,
     $ 1.32843210D+03, 1.30723750D+03, 1.28612020D+03, 1.26507990D+03,
     $ 1.24411610D+03, 1.22322810D+03, 1.20241470D+03, 1.18167440D+03/
      data ( FDNF(100,J,2),J=1,20) /
     $ 4.366D-06, 8.612D-06, 1.275D-05, 1.675D-05, 2.064D-05, 2.442D-05,
     $ 2.809D-05, 3.165D-05, 3.510D-05, 3.844D-05, 4.166D-05, 4.478D-05,
     $ 4.777D-05, 5.065D-05, 5.343D-05, 5.607D-05, 5.856D-05, 6.090D-05,
     $ 6.313D-05, 6.522D-05/
      data (WNUPF(101,J,1),J=1,20) /
     $ 2.32631740D+03, 2.29626860D+03, 2.26628580D+03, 2.23637130D+03,
     $ 2.20652710D+03, 2.17675510D+03, 2.14705710D+03, 2.11743460D+03,
     $ 2.08788910D+03, 2.05842180D+03, 2.02903360D+03, 1.99972520D+03,
     $ 1.97049720D+03, 1.94134950D+03, 1.91228200D+03, 1.88329410D+03,
     $ 1.85438480D+03, 1.82555270D+03, 1.79679590D+03, 1.76811190D+03/
      data ( FUPF(101,J,1),J=1,20) /
     $ 6.577D-06, 1.285D-05, 1.881D-05, 2.448D-05, 2.986D-05, 3.496D-05,
     $ 3.978D-05, 4.432D-05, 4.859D-05, 5.259D-05, 5.637D-05, 5.985D-05,
     $ 6.303D-05, 6.602D-05, 6.871D-05, 7.114D-05, 7.328D-05, 7.517D-05,
     $ 7.677D-05, 7.811D-05/
      data (WNDNF(101,J,1),J=1,20) /
     $ 1.60294230D+03, 1.57998020D+03, 1.55708690D+03, 1.53426430D+03,
     $ 1.51151430D+03, 1.48883890D+03, 1.46623970D+03, 1.44371820D+03,
     $ 1.42127570D+03, 1.39891340D+03, 1.37663220D+03, 1.35443280D+03,
     $ 1.33231580D+03, 1.31028130D+03, 1.28832930D+03, 1.26645940D+03,
     $ 1.24467080D+03, 1.22296250D+03, 1.20133300D+03, 1.17978020D+03/
      data ( FDNF(101,J,1),J=1,20) /
     $ 4.530D-06, 8.931D-06, 1.321D-05, 1.736D-05, 2.139D-05, 2.530D-05,
     $ 2.909D-05, 3.276D-05, 3.633D-05, 3.976D-05, 4.308D-05, 4.628D-05,
     $ 4.936D-05, 5.232D-05, 5.512D-05, 5.783D-05, 6.034D-05, 6.276D-05,
     $ 6.498D-05, 6.704D-05/
      data (WNUPF(101,J,2),J=1,20) /
     $ 2.27597510D+03, 2.24732800D+03, 2.21874250D+03, 2.19022070D+03,
     $ 2.16176440D+03, 2.13337530D+03, 2.10505520D+03, 2.07680550D+03,
     $ 2.04862750D+03, 2.02052250D+03, 1.99249130D+03, 1.96453470D+03,
     $ 1.93665320D+03, 1.90884700D+03, 1.88111620D+03, 1.85346030D+03,
     $ 1.82587860D+03, 1.79837010D+03, 1.77093330D+03, 1.74356620D+03/
      data ( FUPF(101,J,2),J=1,20) /
     $ 6.284D-06, 1.228D-05, 1.800D-05, 2.345D-05, 2.863D-05, 3.354D-05,
     $ 3.819D-05, 4.259D-05, 4.675D-05, 5.065D-05, 5.433D-05, 5.771D-05,
     $ 6.090D-05, 6.383D-05, 6.652D-05, 6.896D-05, 7.114D-05, 7.308D-05,
     $ 7.478D-05, 7.622D-05/
      data (WNDNF(101,J,2),J=1,20) /
     $ 1.58226130D+03, 1.56023600D+03, 1.53827460D+03, 1.51637890D+03,
     $ 1.49455090D+03, 1.47279210D+03, 1.45110410D+03, 1.42948840D+03,
     $ 1.40794610D+03, 1.38647850D+03, 1.36508640D+03, 1.34377050D+03,
     $ 1.32253150D+03, 1.30136970D+03, 1.28028500D+03, 1.25927720D+03,
     $ 1.23834600D+03, 1.21749040D+03, 1.19670940D+03, 1.17600120D+03/
      data ( FDNF(101,J,2),J=1,20) /
     $ 4.356D-06, 8.591D-06, 1.271D-05, 1.671D-05, 2.060D-05, 2.437D-05,
     $ 2.803D-05, 3.158D-05, 3.502D-05, 3.834D-05, 4.156D-05, 4.467D-05,
     $ 4.766D-05, 5.054D-05, 5.330D-05, 5.591D-05, 5.842D-05, 6.079D-05,
     $ 6.300D-05, 6.507D-05/
      data (WNUPF(102,J,1),J=1,20) /
     $ 2.32584370D+03, 2.29575810D+03, 2.26573850D+03, 2.23578720D+03,
     $ 2.20590620D+03, 2.17609740D+03, 2.14636260D+03, 2.11670330D+03,
     $ 2.08712100D+03, 2.05761680D+03, 2.02819170D+03, 1.99884640D+03,
     $ 1.96958130D+03, 1.94039650D+03, 1.91129170D+03, 1.88226640D+03,
     $ 1.85331940D+03, 1.82444940D+03, 1.79565440D+03, 1.76693190D+03/
      data ( FUPF(102,J,1),J=1,20) /
     $ 6.581D-06, 1.285D-05, 1.881D-05, 2.448D-05, 2.986D-05, 3.495D-05,
     $ 3.976D-05, 4.430D-05, 4.856D-05, 5.256D-05, 5.631D-05, 5.975D-05,
     $ 6.296D-05, 6.591D-05, 6.857D-05, 7.099D-05, 7.315D-05, 7.502D-05,
     $ 7.660D-05, 7.788D-05/
      data (WNDNF(102,J,1),J=1,20) /
     $ 1.59629510D+03, 1.57336710D+03, 1.55050790D+03, 1.52771960D+03,
     $ 1.50500410D+03, 1.48236320D+03, 1.45979860D+03, 1.43731180D+03,
     $ 1.41490400D+03, 1.39257650D+03, 1.37033010D+03, 1.34816570D+03,
     $ 1.32608360D+03, 1.30408400D+03, 1.28216680D+03, 1.26033170D+03,
     $ 1.23857780D+03, 1.21690410D+03, 1.19530900D+03, 1.17379050D+03/
      data ( FDNF(102,J,1),J=1,20) /
     $ 4.520D-06, 8.912D-06, 1.318D-05, 1.732D-05, 2.134D-05, 2.524D-05,
     $ 2.902D-05, 3.269D-05, 3.623D-05, 3.967D-05, 4.298D-05, 4.617D-05,
     $ 4.922D-05, 5.220D-05, 5.498D-05, 5.766D-05, 6.020D-05, 6.259D-05,
     $ 6.483D-05, 6.688D-05/
      data (WNUPF(102,J,2),J=1,20) /
     $ 2.27563040D+03, 2.24694900D+03, 2.21832930D+03, 2.18977320D+03,
     $ 2.16128260D+03, 2.13285930D+03, 2.10450490D+03, 2.07622100D+03,
     $ 2.04800880D+03, 2.01986940D+03, 1.99180390D+03, 1.96381300D+03,
     $ 1.93589700D+03, 1.90805640D+03, 1.88029090D+03, 1.85260030D+03,
     $ 1.82498370D+03, 1.79744000D+03, 1.76996790D+03, 1.74256510D+03/
      data ( FUPF(102,J,2),J=1,20) /
     $ 6.286D-06, 1.229D-05, 1.800D-05, 2.345D-05, 2.863D-05, 3.353D-05,
     $ 3.818D-05, 4.258D-05, 4.672D-05, 5.059D-05, 5.429D-05, 5.768D-05,
     $ 6.084D-05, 6.374D-05, 6.640D-05, 6.887D-05, 7.103D-05, 7.296D-05,
     $ 7.463D-05, 7.601D-05/
      data (WNDNF(102,J,2),J=1,20) /
     $ 1.57595230D+03, 1.55395890D+03, 1.53202950D+03, 1.51016600D+03,
     $ 1.48837010D+03, 1.46664360D+03, 1.44498800D+03, 1.42340470D+03,
     $ 1.40189490D+03, 1.38045980D+03, 1.35910030D+03, 1.33781710D+03,
     $ 1.31661080D+03, 1.29548150D+03, 1.27442950D+03, 1.25345430D+03,
     $ 1.23255560D+03, 1.21173250D+03, 1.19098370D+03, 1.17030770D+03/
      data ( FDNF(102,J,2),J=1,20) /
     $ 4.345D-06, 8.571D-06, 1.269D-05, 1.667D-05, 2.055D-05, 2.431D-05,
     $ 2.796D-05, 3.150D-05, 3.494D-05, 3.826D-05, 4.147D-05, 4.457D-05,
     $ 4.755D-05, 5.044D-05, 5.317D-05, 5.580D-05, 5.829D-05, 6.063D-05,
     $ 6.283D-05, 6.488D-05/
      data (WNUPF(103,J,1),J=1,20) /
     $ 2.32532030D+03, 2.29519770D+03, 2.26514130D+03, 2.23515310D+03,
     $ 2.20523520D+03, 2.17538950D+03, 2.14561780D+03, 2.11592170D+03,
     $ 2.08630250D+03, 2.05676140D+03, 2.02729930D+03, 1.99791700D+03,
     $ 1.96861480D+03, 1.93939270D+03, 1.91025060D+03, 1.88118770D+03,
     $ 1.85220290D+03, 1.82329490D+03, 1.79446160D+03, 1.76570040D+03/
      data ( FUPF(103,J,1),J=1,20) /
     $ 6.580D-06, 1.285D-05, 1.881D-05, 2.448D-05, 2.985D-05, 3.494D-05,
     $ 3.974D-05, 4.427D-05, 4.853D-05, 5.254D-05, 5.624D-05, 5.971D-05,
     $ 6.288D-05, 6.580D-05, 6.849D-05, 7.088D-05, 7.298D-05, 7.483D-05,
     $ 7.639D-05, 7.766D-05/
      data (WNDNF(103,J,1),J=1,20) /
     $ 1.58962680D+03, 1.56673290D+03, 1.54390790D+03, 1.52115390D+03,
     $ 1.49847280D+03, 1.47586630D+03, 1.45333630D+03, 1.43088410D+03,
     $ 1.40851110D+03, 1.38621840D+03, 1.36400690D+03, 1.34187730D+03,
     $ 1.31983000D+03, 1.29786530D+03, 1.27598300D+03, 1.25418270D+03,
     $ 1.23246350D+03, 1.21082430D+03, 1.18926360D+03, 1.16777930D+03/
      data ( FDNF(103,J,1),J=1,20) /
     $ 4.509D-06, 8.889D-06, 1.314D-05, 1.728D-05, 2.129D-05, 2.518D-05,
     $ 2.895D-05, 3.261D-05, 3.615D-05, 3.957D-05, 4.287D-05, 4.606D-05,
     $ 4.913D-05, 5.203D-05, 5.488D-05, 5.754D-05, 6.005D-05, 6.242D-05,
     $ 6.464D-05, 6.671D-05/
      data (WNUPF(103,J,2),J=1,20) /
     $ 2.27523940D+03, 2.24652370D+03, 2.21786960D+03, 2.18927920D+03,
     $ 2.16075430D+03, 2.13229670D+03, 2.10390800D+03, 2.07558980D+03,
     $ 2.04734320D+03, 2.01916960D+03, 1.99106970D+03, 1.96304430D+03,
     $ 1.93509390D+03, 1.90721860D+03, 1.87941850D+03, 1.85169300D+03,
     $ 1.82404140D+03, 1.79646250D+03, 1.76895490D+03, 1.74151640D+03/
      data ( FUPF(103,J,2),J=1,20) /
     $ 6.293D-06, 1.229D-05, 1.800D-05, 2.345D-05, 2.862D-05, 3.353D-05,
     $ 3.817D-05, 4.256D-05, 4.670D-05, 5.059D-05, 5.424D-05, 5.761D-05,
     $ 6.078D-05, 6.366D-05, 6.634D-05, 6.873D-05, 7.088D-05, 7.283D-05,
     $ 7.444D-05, 7.585D-05/
      data (WNDNF(103,J,2),J=1,20) /
     $ 1.56962340D+03, 1.54766190D+03, 1.52576450D+03, 1.50393300D+03,
     $ 1.48216930D+03, 1.46047510D+03, 1.43885180D+03, 1.41730090D+03,
     $ 1.39582370D+03, 1.37442110D+03, 1.35309420D+03, 1.33184360D+03,
     $ 1.31066990D+03, 1.28957330D+03, 1.26855380D+03, 1.24761130D+03,
     $ 1.22674500D+03, 1.20595430D+03, 1.18523780D+03, 1.16459390D+03/
      data ( FDNF(103,J,2),J=1,20) /
     $ 4.335D-06, 8.551D-06, 1.266D-05, 1.663D-05, 2.050D-05, 2.425D-05,
     $ 2.790D-05, 3.143D-05, 3.486D-05, 3.817D-05, 4.137D-05, 4.446D-05,
     $ 4.744D-05, 5.029D-05, 5.304D-05, 5.565D-05, 5.812D-05, 6.048D-05,
     $ 6.271D-05, 6.473D-05/
      data (WNUPF(104,J,1),J=1,20) /
     $ 2.32474680D+03, 2.29458730D+03, 2.26449390D+03, 2.23446870D+03,
     $ 2.20451390D+03, 2.17463130D+03, 2.14482260D+03, 2.11508950D+03,
     $ 2.08543330D+03, 2.05585530D+03, 2.02635620D+03, 1.99693670D+03,
     $ 1.96759730D+03, 1.93833790D+03, 1.90915830D+03, 1.88005770D+03,
     $ 1.85103520D+03, 1.82208900D+03, 1.79321730D+03, 1.76441730D+03/
      data ( FUPF(104,J,1),J=1,20) /
     $ 6.585D-06, 1.286D-05, 1.882D-05, 2.448D-05, 2.985D-05, 3.493D-05,
     $ 3.972D-05, 4.425D-05, 4.850D-05, 5.246D-05, 5.618D-05, 5.961D-05,
     $ 6.280D-05, 6.570D-05, 6.836D-05, 7.072D-05, 7.285D-05, 7.469D-05,
     $ 7.618D-05, 7.749D-05/
      data (WNDNF(104,J,1),J=1,20) /
     $ 1.58293760D+03, 1.56007770D+03, 1.53728690D+03, 1.51456710D+03,
     $ 1.49192030D+03, 1.46934840D+03, 1.44685290D+03, 1.42443530D+03,
     $ 1.40209700D+03, 1.37983910D+03, 1.35766240D+03, 1.33556770D+03,
     $ 1.31355530D+03, 1.29162550D+03, 1.26977800D+03, 1.24801240D+03,
     $ 1.22632790D+03, 1.20472330D+03, 1.18319690D+03, 1.16174680D+03/
      data ( FDNF(104,J,1),J=1,20) /
     $ 4.498D-06, 8.866D-06, 1.311D-05, 1.723D-05, 2.123D-05, 2.512D-05,
     $ 2.888D-05, 3.253D-05, 3.606D-05, 3.947D-05, 4.277D-05, 4.594D-05,
     $ 4.900D-05, 5.191D-05, 5.474D-05, 5.737D-05, 5.990D-05, 6.230D-05,
     $ 6.450D-05, 6.656D-05/
      data (WNUPF(104,J,2),J=1,20) /
     $ 2.27480200D+03, 2.24605190D+03, 2.21736350D+03, 2.18873870D+03,
     $ 2.16017940D+03, 2.13168740D+03, 2.10326440D+03, 2.07491170D+03,
     $ 2.04663080D+03, 2.01842270D+03, 1.99028840D+03, 1.96222850D+03,
     $ 1.93424350D+03, 1.90633360D+03, 1.87849870D+03, 1.85073830D+03,
     $ 1.82305160D+03, 1.79543740D+03, 1.76789420D+03, 1.74042000D+03/
      data ( FUPF(104,J,2),J=1,20) /
     $ 6.295D-06, 1.229D-05, 1.800D-05, 2.345D-05, 2.862D-05, 3.352D-05,
     $ 3.816D-05, 4.254D-05, 4.667D-05, 5.053D-05, 5.415D-05, 5.758D-05,
     $ 6.068D-05, 6.357D-05, 6.623D-05, 6.865D-05, 7.077D-05, 7.266D-05,
     $ 7.430D-05, 7.565D-05/
      data (WNDNF(104,J,2),J=1,20) /
     $ 1.56327470D+03, 1.54134510D+03, 1.51947960D+03, 1.49768020D+03,
     $ 1.47594870D+03, 1.45428670D+03, 1.43269570D+03, 1.41117720D+03,
     $ 1.38973240D+03, 1.36836240D+03, 1.34706810D+03, 1.32585010D+03,
     $ 1.30470900D+03, 1.28364500D+03, 1.26265810D+03, 1.24174810D+03,
     $ 1.22091440D+03, 1.20015600D+03, 1.17947170D+03, 1.15886000D+03/
      data ( FDNF(104,J,2),J=1,20) /
     $ 4.325D-06, 8.531D-06, 1.263D-05, 1.659D-05, 2.045D-05, 2.420D-05,
     $ 2.783D-05, 3.135D-05, 3.478D-05, 3.808D-05, 4.127D-05, 4.436D-05,
     $ 4.733D-05, 5.019D-05, 5.292D-05, 5.550D-05, 5.799D-05, 6.033D-05,
     $ 6.254D-05, 6.459D-05/
      data (WNUPF(105,J,1),J=1,20) /
     $ 2.32412320D+03, 2.29392660D+03, 2.26379620D+03, 2.23373400D+03,
     $ 2.20374210D+03, 2.17382250D+03, 2.14397680D+03, 2.11420670D+03,
     $ 2.08451350D+03, 2.05489830D+03, 2.02536210D+03, 1.99590540D+03,
     $ 1.96652870D+03, 1.93723190D+03, 1.90801470D+03, 1.87887640D+03,
     $ 1.84981590D+03, 1.82083150D+03, 1.79192120D+03, 1.76308240D+03/
      data ( FUPF(105,J,1),J=1,20) /
     $ 6.589D-06, 1.286D-05, 1.882D-05, 2.448D-05, 2.984D-05, 3.491D-05,
     $ 3.971D-05, 4.422D-05, 4.847D-05, 5.244D-05, 5.612D-05, 5.957D-05,
     $ 6.273D-05, 6.560D-05, 6.823D-05, 7.062D-05, 7.268D-05, 7.450D-05,
     $ 7.598D-05, 7.722D-05/
      data (WNDNF(105,J,1),J=1,20) /
     $ 1.57622750D+03, 1.55340170D+03, 1.53064500D+03, 1.50795940D+03,
     $ 1.48534700D+03, 1.46280950D+03, 1.44034850D+03, 1.41796560D+03,
     $ 1.39566200D+03, 1.37343880D+03, 1.35129700D+03, 1.32923710D+03,
     $ 1.30725950D+03, 1.28536450D+03, 1.26355180D+03, 1.24182100D+03,
     $ 1.22017110D+03, 1.19860100D+03, 1.17710900D+03, 1.15569300D+03/
      data ( FDNF(105,J,1),J=1,20) /
     $ 4.487D-06, 8.844D-06, 1.308D-05, 1.719D-05, 2.118D-05, 2.506D-05,
     $ 2.881D-05, 3.245D-05, 3.597D-05, 3.938D-05, 4.266D-05, 4.583D-05,
     $ 4.886D-05, 5.180D-05, 5.460D-05, 5.725D-05, 5.976D-05, 6.213D-05,
     $ 6.431D-05, 6.635D-05/
      data (WNUPF(105,J,2),J=1,20) /
     $ 2.27431810D+03, 2.24553360D+03, 2.21681070D+03, 2.18815140D+03,
     $ 2.15955770D+03, 2.13103130D+03, 2.10257380D+03, 2.07418670D+03,
     $ 2.04587130D+03, 2.01762880D+03, 1.98945990D+03, 1.96136550D+03,
     $ 1.93334580D+03, 1.90540120D+03, 1.87753140D+03, 1.84973600D+03,
     $ 1.82201410D+03, 1.79436460D+03, 1.76678570D+03, 1.73927550D+03/
      data ( FUPF(105,J,2),J=1,20) /
     $ 6.297D-06, 1.230D-05, 1.800D-05, 2.345D-05, 2.861D-05, 3.351D-05,
     $ 3.814D-05, 4.252D-05, 4.664D-05, 5.053D-05, 5.411D-05, 5.751D-05,
     $ 6.062D-05, 6.349D-05, 6.612D-05, 6.852D-05, 7.062D-05, 7.249D-05,
     $ 7.411D-05, 7.545D-05/
      data (WNDNF(105,J,2),J=1,20) /
     $ 1.55690630D+03, 1.53500850D+03, 1.51317500D+03, 1.49140760D+03,
     $ 1.46970820D+03, 1.44807840D+03, 1.42651980D+03, 1.40503370D+03,
     $ 1.38362130D+03, 1.36228380D+03, 1.34102200D+03, 1.31983670D+03,
     $ 1.29872820D+03, 1.27769680D+03, 1.25674250D+03, 1.23586500D+03,
     $ 1.21506370D+03, 1.19433770D+03, 1.17368570D+03, 1.15310600D+03/
      data ( FDNF(105,J,2),J=1,20) /
     $ 4.315D-06, 8.512D-06, 1.260D-05, 1.655D-05, 2.040D-05, 2.414D-05,
     $ 2.776D-05, 3.128D-05, 3.469D-05, 3.799D-05, 4.118D-05, 4.425D-05,
     $ 4.721D-05, 5.005D-05, 5.280D-05, 5.540D-05, 5.787D-05, 6.019D-05,
     $ 6.237D-05, 6.441D-05/
      data (WNUPF(106,J,1),J=1,20) /
     $ 2.32344920D+03, 2.29321560D+03, 2.26304800D+03, 2.23294870D+03,
     $ 2.20291970D+03, 2.17296300D+03, 2.14308030D+03, 2.11327300D+03,
     $ 2.08354270D+03, 2.05389040D+03, 2.02431690D+03, 1.99482300D+03,
     $ 1.96540890D+03, 1.93607460D+03, 1.90681970D+03, 1.87764360D+03,
     $ 1.84854490D+03, 1.81952220D+03, 1.79057330D+03, 1.76169540D+03/
      data ( FUPF(106,J,1),J=1,20) /
     $ 6.588D-06, 1.286D-05, 1.882D-05, 2.447D-05, 2.983D-05, 3.490D-05,
     $ 3.969D-05, 4.419D-05, 4.844D-05, 5.237D-05, 5.607D-05, 5.948D-05,
     $ 6.265D-05, 6.550D-05, 6.815D-05, 7.047D-05, 7.251D-05, 7.431D-05,
     $ 7.578D-05, 7.701D-05/
      data (WNDNF(106,J,1),J=1,20) /
     $ 1.56949680D+03, 1.54670490D+03, 1.52398230D+03, 1.50133090D+03,
     $ 1.47875280D+03, 1.45624970D+03, 1.43382330D+03, 1.41147500D+03,
     $ 1.38920600D+03, 1.36701760D+03, 1.34491050D+03, 1.32288550D+03,
     $ 1.30094280D+03, 1.27908260D+03, 1.25730470D+03, 1.23560850D+03,
     $ 1.21399330D+03, 1.19245770D+03, 1.17100000D+03, 1.14961820D+03/
      data ( FDNF(106,J,1),J=1,20) /
     $ 4.476D-06, 8.826D-06, 1.305D-05, 1.715D-05, 2.113D-05, 2.500D-05,
     $ 2.874D-05, 3.237D-05, 3.588D-05, 3.928D-05, 4.256D-05, 4.572D-05,
     $ 4.873D-05, 5.164D-05, 5.446D-05, 5.709D-05, 5.958D-05, 6.197D-05,
     $ 6.413D-05, 6.620D-05/
      data (WNUPF(106,J,2),J=1,20) /
     $ 2.27378760D+03, 2.24496850D+03, 2.21621100D+03, 2.18751720D+03,
     $ 2.15888900D+03, 2.13032810D+03, 2.10183610D+03, 2.07341450D+03,
     $ 2.04506460D+03, 2.01678750D+03, 1.98858410D+03, 1.96045500D+03,
     $ 1.93240070D+03, 1.90442120D+03, 1.87651650D+03, 1.84868590D+03,
     $ 1.82092880D+03, 1.79324370D+03, 1.76562910D+03, 1.73808290D+03/
      data ( FUPF(106,J,2),J=1,20) /
     $ 6.299D-06, 1.230D-05, 1.800D-05, 2.345D-05, 2.861D-05, 3.350D-05,
     $ 3.813D-05, 4.249D-05, 4.661D-05, 5.047D-05, 5.408D-05, 5.744D-05,
     $ 6.057D-05, 6.341D-05, 6.602D-05, 6.839D-05, 7.052D-05, 7.237D-05,
     $ 7.393D-05, 7.526D-05/
      data (WNDNF(106,J,2),J=1,20) /
     $ 1.55051820D+03, 1.52865230D+03, 1.50685070D+03, 1.48511530D+03,
     $ 1.46344800D+03, 1.44185050D+03, 1.42032410D+03, 1.39887040D+03,
     $ 1.37749050D+03, 1.35618550D+03, 1.33495620D+03, 1.31380340D+03,
     $ 1.29272750D+03, 1.27172870D+03, 1.25080700D+03, 1.22996200D+03,
     $ 1.20919320D+03, 1.18849950D+03, 1.16787970D+03, 1.14733200D+03/
      data ( FDNF(106,J,2),J=1,20) /
     $ 4.305D-06, 8.488D-06, 1.257D-05, 1.651D-05, 2.035D-05, 2.408D-05,
     $ 2.770D-05, 3.121D-05, 3.461D-05, 3.790D-05, 4.108D-05, 4.415D-05,
     $ 4.709D-05, 4.995D-05, 5.268D-05, 5.526D-05, 5.770D-05, 6.005D-05,
     $ 6.221D-05, 6.423D-05/
      data (WNUPF(107,J,1),J=1,20) /
     $ 2.32272480D+03, 2.29245400D+03, 2.26224930D+03, 2.23211280D+03,
     $ 2.20204660D+03, 2.17205270D+03, 2.14213280D+03, 2.11228840D+03,
     $ 2.08252080D+03, 2.05283120D+03, 2.02322050D+03, 1.99368920D+03,
     $ 1.96423760D+03, 1.93486570D+03, 1.90557300D+03, 1.87635890D+03,
     $ 1.84722210D+03, 1.81816090D+03, 1.78917320D+03, 1.76025620D+03/
      data ( FUPF(107,J,1),J=1,20) /
     $ 6.587D-06, 1.286D-05, 1.881D-05, 2.447D-05, 2.982D-05, 3.489D-05,
     $ 3.966D-05, 4.416D-05, 4.840D-05, 5.235D-05, 5.601D-05, 5.939D-05,
     $ 6.254D-05, 6.540D-05, 6.803D-05, 7.033D-05, 7.235D-05, 7.413D-05,
     $ 7.559D-05, 7.681D-05/
      data (WNDNF(107,J,1),J=1,20) /
     $ 1.56274540D+03, 1.53998750D+03, 1.51729900D+03, 1.49468180D+03,
     $ 1.47213790D+03, 1.44966920D+03, 1.42727730D+03, 1.40496350D+03,
     $ 1.38272930D+03, 1.36057560D+03, 1.33850330D+03, 1.31651300D+03,
     $ 1.29460520D+03, 1.27277980D+03, 1.25103660D+03, 1.22937520D+03,
     $ 1.20779450D+03, 1.18629340D+03, 1.16487000D+03, 1.14352220D+03/
      data ( FDNF(107,J,1),J=1,20) /
     $ 4.465D-06, 8.805D-06, 1.301D-05, 1.711D-05, 2.108D-05, 2.493D-05,
     $ 2.867D-05, 3.229D-05, 3.580D-05, 3.919D-05, 4.245D-05, 4.560D-05,
     $ 4.865D-05, 5.153D-05, 5.433D-05, 5.693D-05, 5.944D-05, 6.181D-05,
     $ 6.395D-05, 6.600D-05/
      data (WNUPF(107,J,2),J=1,20) /
     $ 2.27321020D+03, 2.24435650D+03, 2.21556440D+03, 2.18683610D+03,
     $ 2.15817330D+03, 2.12957780D+03, 2.10105120D+03, 2.07259510D+03,
     $ 2.04421060D+03, 2.01589890D+03, 1.98766080D+03, 1.95949690D+03,
     $ 1.93140780D+03, 1.90339340D+03, 1.87545370D+03, 1.84758800D+03,
     $ 1.81979540D+03, 1.79207480D+03, 1.76442440D+03, 1.73684190D+03/
      data ( FUPF(107,J,2),J=1,20) /
     $ 6.296D-06, 1.230D-05, 1.800D-05, 2.345D-05, 2.861D-05, 3.349D-05,
     $ 3.811D-05, 4.247D-05, 4.658D-05, 5.042D-05, 5.404D-05, 5.737D-05,
     $ 6.047D-05, 6.333D-05, 6.592D-05, 6.826D-05, 7.038D-05, 7.221D-05,
     $ 7.376D-05, 7.507D-05/
      data (WNDNF(107,J,2),J=1,20) /
     $ 1.54411070D+03, 1.52227660D+03, 1.50050680D+03, 1.47880350D+03,
     $ 1.45716830D+03, 1.43560290D+03, 1.41410880D+03, 1.39268740D+03,
     $ 1.37133990D+03, 1.35006740D+03, 1.32887070D+03, 1.30775050D+03,
     $ 1.28670710D+03, 1.26574090D+03, 1.24485170D+03, 1.22403920D+03,
     $ 1.20330280D+03, 1.18264150D+03, 1.16205380D+03, 1.14153820D+03/
      data ( FDNF(107,J,2),J=1,20) /
     $ 4.294D-06, 8.470D-06, 1.254D-05, 1.647D-05, 2.030D-05, 2.402D-05,
     $ 2.763D-05, 3.113D-05, 3.453D-05, 3.781D-05, 4.098D-05, 4.404D-05,
     $ 4.698D-05, 4.981D-05, 5.251D-05, 5.512D-05, 5.758D-05, 5.986D-05,
     $ 6.205D-05, 6.409D-05/
      data (WNUPF(108,J,1),J=1,20) /
     $ 2.32194980D+03, 2.29164170D+03, 2.26139970D+03, 2.23122590D+03,
     $ 2.20112250D+03, 2.17109140D+03, 2.14113420D+03, 2.11125250D+03,
     $ 2.08144760D+03, 2.05172070D+03, 2.02207260D+03, 1.99250380D+03,
     $ 1.96301460D+03, 1.93360500D+03, 1.90427450D+03, 1.87502240D+03,
     $ 1.84584730D+03, 1.81674750D+03, 1.78772090D+03, 1.75876460D+03/
      data ( FUPF(108,J,1),J=1,20) /
     $ 6.591D-06, 1.286D-05, 1.881D-05, 2.447D-05, 2.981D-05, 3.487D-05,
     $ 3.964D-05, 4.413D-05, 4.833D-05, 5.228D-05, 5.595D-05, 5.935D-05,
     $ 6.247D-05, 6.530D-05, 6.791D-05, 7.019D-05, 7.219D-05, 7.395D-05,
     $ 7.540D-05, 7.656D-05/
      data (WNDNF(108,J,1),J=1,20) /
     $ 1.55597350D+03, 1.53324960D+03, 1.51059500D+03, 1.48801200D+03,
     $ 1.46550240D+03, 1.44306810D+03, 1.42071060D+03, 1.39843150D+03,
     $ 1.37623190D+03, 1.35411290D+03, 1.33207530D+03, 1.31011990D+03,
     $ 1.28824680D+03, 1.26645620D+03, 1.24474780D+03, 1.22312100D+03,
     $ 1.20157490D+03, 1.18010820D+03, 1.15871910D+03, 1.13740540D+03/
      data ( FDNF(108,J,1),J=1,20) /
     $ 4.454D-06, 8.779D-06, 1.298D-05, 1.706D-05, 2.103D-05, 2.487D-05,
     $ 2.860D-05, 3.221D-05, 3.571D-05, 3.909D-05, 4.235D-05, 4.549D-05,
     $ 4.853D-05, 5.143D-05, 5.419D-05, 5.682D-05, 5.926D-05, 6.161D-05,
     $ 6.378D-05, 6.581D-05/
      data (WNUPF(108,J,2),J=1,20) /
     $ 2.27258580D+03, 2.24369750D+03, 2.21487080D+03, 2.18610770D+03,
     $ 2.15741030D+03, 2.12878020D+03, 2.10021900D+03, 2.07172820D+03,
     $ 2.04330900D+03, 2.01496260D+03, 1.98668980D+03, 1.95849110D+03,
     $ 1.93036710D+03, 1.90231780D+03, 1.87434290D+03, 1.84644190D+03,
     $ 1.81861390D+03, 1.79085760D+03, 1.76317120D+03, 1.73555250D+03/
      data ( FUPF(108,J,2),J=1,20) /
     $ 6.298D-06, 1.230D-05, 1.800D-05, 2.345D-05, 2.860D-05, 3.348D-05,
     $ 3.809D-05, 4.245D-05, 4.656D-05, 5.037D-05, 5.395D-05, 5.730D-05,
     $ 6.042D-05, 6.326D-05, 6.581D-05, 6.814D-05, 7.023D-05, 7.205D-05,
     $ 7.358D-05, 7.488D-05/
      data (WNDNF(108,J,2),J=1,20) /
     $ 1.53768380D+03, 1.51588140D+03, 1.49414350D+03, 1.47247220D+03,
     $ 1.45086900D+03, 1.42933580D+03, 1.40787390D+03, 1.38648490D+03,
     $ 1.36516980D+03, 1.34392980D+03, 1.32276560D+03, 1.30167790D+03,
     $ 1.28066710D+03, 1.25973350D+03, 1.23887680D+03, 1.21809680D+03,
     $ 1.19739280D+03, 1.17676370D+03, 1.15620820D+03, 1.13572460D+03/
      data ( FDNF(108,J,2),J=1,20) /
     $ 4.284D-06, 8.452D-06, 1.251D-05, 1.643D-05, 2.025D-05, 2.397D-05,
     $ 2.757D-05, 3.106D-05, 3.444D-05, 3.772D-05, 4.088D-05, 4.394D-05,
     $ 4.687D-05, 4.968D-05, 5.240D-05, 5.498D-05, 5.742D-05, 5.972D-05,
     $ 6.189D-05, 6.392D-05/
      data (WNUPF(109,J,1),J=1,20) /
     $ 2.32112410D+03, 2.29077860D+03, 2.26049920D+03, 2.23028810D+03,
     $ 2.20014740D+03, 2.17007880D+03, 2.14008430D+03, 2.11016530D+03,
     $ 2.08032300D+03, 2.05055870D+03, 2.02087310D+03, 1.99126670D+03,
     $ 1.96173990D+03, 1.93229250D+03, 1.90292400D+03, 1.87363370D+03,
     $ 1.84442020D+03, 1.81528170D+03, 1.78621600D+03, 1.75722030D+03/
      data ( FUPF(109,J,1),J=1,20) /
     $ 6.590D-06, 1.286D-05, 1.881D-05, 2.446D-05, 2.980D-05, 3.485D-05,
     $ 3.961D-05, 4.409D-05, 4.829D-05, 5.221D-05, 5.585D-05, 5.926D-05,
     $ 6.235D-05, 6.521D-05, 6.774D-05, 7.005D-05, 7.203D-05, 7.378D-05,
     $ 7.516D-05, 7.631D-05/
      data (WNDNF(109,J,1),J=1,20) /
     $ 1.54918130D+03, 1.52649120D+03, 1.50387070D+03, 1.48132180D+03,
     $ 1.45884640D+03, 1.43644650D+03, 1.41412340D+03, 1.39187880D+03,
     $ 1.36971380D+03, 1.34762950D+03, 1.32562680D+03, 1.30370610D+03,
     $ 1.28186780D+03, 1.26011190D+03, 1.23843820D+03, 1.21684610D+03,
     $ 1.19533460D+03, 1.17390230D+03, 1.15254740D+03, 1.13126770D+03/
      data ( FDNF(109,J,1),J=1,20) /
     $ 4.443D-06, 8.758D-06, 1.295D-05, 1.702D-05, 2.098D-05, 2.481D-05,
     $ 2.853D-05, 3.213D-05, 3.562D-05, 3.899D-05, 4.224D-05, 4.538D-05,
     $ 4.840D-05, 5.128D-05, 5.402D-05, 5.667D-05, 5.913D-05, 6.146D-05,
     $ 6.361D-05, 6.566D-05/
      data (WNUPF(109,J,2),J=1,20) /
     $ 2.27191430D+03, 2.24299130D+03, 2.21412980D+03, 2.18533210D+03,
     $ 2.15659990D+03, 2.12793510D+03, 2.09933920D+03, 2.07081370D+03,
     $ 2.04235980D+03, 2.01397860D+03, 1.98567090D+03, 1.95743740D+03,
     $ 1.92927840D+03, 1.90119400D+03, 1.87318400D+03, 1.84524760D+03,
     $ 1.81738400D+03, 1.78959190D+03, 1.76186940D+03, 1.73421440D+03/
      data ( FUPF(109,J,2),J=1,20) /
     $ 6.300D-06, 1.230D-05, 1.800D-05, 2.344D-05, 2.859D-05, 3.347D-05,
     $ 3.807D-05, 4.242D-05, 4.650D-05, 5.032D-05, 5.392D-05, 5.724D-05,
     $ 6.032D-05, 6.313D-05, 6.571D-05, 6.802D-05, 7.009D-05, 7.189D-05,
     $ 7.341D-05, 7.465D-05/
      data (WNDNF(109,J,2),J=1,20) /
     $ 1.53123750D+03, 1.50946690D+03, 1.48776090D+03, 1.46612140D+03,
     $ 1.44455030D+03, 1.42304920D+03, 1.40161960D+03, 1.38026290D+03,
     $ 1.35898020D+03, 1.33777260D+03, 1.31664100D+03, 1.29558580D+03,
     $ 1.27460760D+03, 1.25370640D+03, 1.23288230D+03, 1.21213480D+03,
     $ 1.19146310D+03, 1.17086630D+03, 1.15034300D+03, 1.12989130D+03/
      data ( FDNF(109,J,2),J=1,20) /
     $ 4.274D-06, 8.429D-06, 1.248D-05, 1.639D-05, 2.021D-05, 2.391D-05,
     $ 2.750D-05, 3.098D-05, 3.436D-05, 3.763D-05, 4.079D-05, 4.383D-05,
     $ 4.676D-05, 4.959D-05, 5.228D-05, 5.484D-05, 5.726D-05, 5.959D-05,
     $ 6.174D-05, 6.374D-05/
      data (WNUPF(110,J,1),J=1,20) /
     $ 2.32024740D+03, 2.28986450D+03, 2.25954760D+03, 2.22929910D+03,
     $ 2.19912090D+03, 2.16901500D+03, 2.13898300D+03, 2.10902650D+03,
     $ 2.07914680D+03, 2.04934500D+03, 2.01962180D+03, 1.98997780D+03,
     $ 1.96041320D+03, 1.93092780D+03, 1.90152130D+03, 1.87219270D+03,
     $ 1.84294060D+03, 1.81376330D+03, 1.78465850D+03, 1.75562320D+03/
      data ( FUPF(110,J,1),J=1,20) /
     $ 6.594D-06, 1.286D-05, 1.881D-05, 2.445D-05, 2.979D-05, 3.483D-05,
     $ 3.959D-05, 4.406D-05, 4.826D-05, 5.215D-05, 5.580D-05, 5.918D-05,
     $ 6.224D-05, 6.507D-05, 6.763D-05, 6.986D-05, 7.187D-05, 7.356D-05,
     $ 7.493D-05, 7.607D-05/
      data (WNDNF(110,J,1),J=1,20) /
     $ 1.54236870D+03, 1.51971250D+03, 1.49712600D+03, 1.47461120D+03,
     $ 1.45217000D+03, 1.42980440D+03, 1.40751580D+03, 1.38530570D+03,
     $ 1.36317530D+03, 1.34112570D+03, 1.31915760D+03, 1.29727170D+03,
     $ 1.27546820D+03, 1.25374710D+03, 1.23210810D+03, 1.21055060D+03,
     $ 1.18907360D+03, 1.16767570D+03, 1.14635500D+03, 1.12510930D+03/
      data ( FDNF(110,J,1),J=1,20) /
     $ 4.432D-06, 8.738D-06, 1.292D-05, 1.698D-05, 2.092D-05, 2.475D-05,
     $ 2.846D-05, 3.205D-05, 3.553D-05, 3.890D-05, 4.214D-05, 4.525D-05,
     $ 4.828D-05, 5.113D-05, 5.389D-05, 5.652D-05, 5.896D-05, 6.131D-05,
     $ 6.344D-05, 6.548D-05/
      data (WNUPF(110,J,2),J=1,20) /
     $ 2.27119560D+03, 2.24223780D+03, 2.21334150D+03, 2.18450900D+03,
     $ 2.15574200D+03, 2.12704240D+03, 2.09841170D+03, 2.06985140D+03,
     $ 2.04136270D+03, 2.01294660D+03, 1.98460410D+03, 1.95633570D+03,
     $ 1.92814160D+03, 1.90002210D+03, 1.87197670D+03, 1.84400490D+03,
     $ 1.81610560D+03, 1.78827760D+03, 1.76051890D+03, 1.73282740D+03/
      data ( FUPF(110,J,2),J=1,20) /
     $ 6.301D-06, 1.231D-05, 1.800D-05, 2.344D-05, 2.858D-05, 3.345D-05,
     $ 3.805D-05, 4.239D-05, 4.648D-05, 5.027D-05, 5.384D-05, 5.717D-05,
     $ 6.023D-05, 6.306D-05, 6.562D-05, 6.790D-05, 6.991D-05, 7.169D-05,
     $ 7.320D-05, 7.443D-05/
      data (WNDNF(110,J,2),J=1,20) /
     $ 1.52477210D+03, 1.50303320D+03, 1.48135900D+03, 1.45975140D+03,
     $ 1.43821240D+03, 1.41674340D+03, 1.39534600D+03, 1.37402160D+03,
     $ 1.35277130D+03, 1.33159610D+03, 1.31049690D+03, 1.28947430D+03,
     $ 1.26852860D+03, 1.24766000D+03, 1.22686840D+03, 1.20615320D+03,
     $ 1.18551400D+03, 1.16494940D+03, 1.14445820D+03, 1.12403840D+03/
      data ( FDNF(110,J,2),J=1,20) /
     $ 4.264D-06, 8.407D-06, 1.245D-05, 1.635D-05, 2.016D-05, 2.385D-05,
     $ 2.743D-05, 3.091D-05, 3.428D-05, 3.753D-05, 4.068D-05, 4.372D-05,
     $ 4.665D-05, 4.946D-05, 5.213D-05, 5.471D-05, 5.715D-05, 5.941D-05,
     $ 6.158D-05, 6.357D-05/
      data (WNUPF(111,J,1),J=1,20) /
     $ 2.31931960D+03, 2.28889910D+03, 2.25854480D+03, 2.22825870D+03,
     $ 2.19804300D+03, 2.16789960D+03, 2.13783010D+03, 2.10783610D+03,
     $ 2.07791880D+03, 2.04807940D+03, 2.01831850D+03, 1.98863670D+03,
     $ 1.95903420D+03, 1.92951090D+03, 1.90006620D+03, 1.87069910D+03,
     $ 1.84140840D+03, 1.81219220D+03, 1.78304800D+03, 1.75397310D+03/
      data ( FUPF(111,J,1),J=1,20) /
     $ 6.593D-06, 1.286D-05, 1.881D-05, 2.444D-05, 2.978D-05, 3.481D-05,
     $ 3.956D-05, 4.402D-05, 4.819D-05, 5.213D-05, 5.575D-05, 5.910D-05,
     $ 6.217D-05, 6.493D-05, 6.751D-05, 6.973D-05, 7.167D-05, 7.339D-05,
     $ 7.471D-05, 7.584D-05/
      data (WNDNF(111,J,1),J=1,20) /
     $ 1.53553600D+03, 1.51291360D+03, 1.49036100D+03, 1.46788030D+03,
     $ 1.44547330D+03, 1.42314200D+03, 1.40088780D+03, 1.37871220D+03,
     $ 1.35661640D+03, 1.33460150D+03, 1.31266810D+03, 1.29081690D+03,
     $ 1.26904810D+03, 1.24736180D+03, 1.22575750D+03, 1.20423460D+03,
     $ 1.18279210D+03, 1.16142850D+03, 1.14014200D+03, 1.11893020D+03/
      data ( FDNF(111,J,1),J=1,20) /
     $ 4.421D-06, 8.717D-06, 1.289D-05, 1.694D-05, 2.087D-05, 2.469D-05,
     $ 2.839D-05, 3.197D-05, 3.544D-05, 3.880D-05, 4.203D-05, 4.516D-05,
     $ 4.816D-05, 5.103D-05, 5.377D-05, 5.637D-05, 5.879D-05, 6.112D-05,
     $ 6.327D-05, 6.529D-05/
      data (WNUPF(111,J,2),J=1,20) /
     $ 2.27042950D+03, 2.24143680D+03, 2.21250570D+03, 2.18363830D+03,
     $ 2.15483650D+03, 2.12610200D+03, 2.09743640D+03, 2.06884120D+03,
     $ 2.04031760D+03, 2.01186660D+03, 1.98348910D+03, 1.95518560D+03,
     $ 1.92695650D+03, 1.89880170D+03, 1.87072090D+03, 1.84271350D+03,
     $ 1.81477850D+03, 1.78691450D+03, 1.75911950D+03, 1.73139130D+03/
      data ( FUPF(111,J,2),J=1,20) /
     $ 6.303D-06, 1.230D-05, 1.800D-05, 2.343D-05, 2.857D-05, 3.343D-05,
     $ 3.803D-05, 4.236D-05, 4.643D-05, 5.023D-05, 5.380D-05, 5.710D-05,
     $ 6.014D-05, 6.294D-05, 6.548D-05, 6.774D-05, 6.977D-05, 7.154D-05,
     $ 7.303D-05, 7.421D-05/
      data (WNDNF(111,J,2),J=1,20) /
     $ 1.51828750D+03, 1.49658030D+03, 1.47493790D+03, 1.45336230D+03,
     $ 1.43185520D+03, 1.41041830D+03, 1.38905310D+03, 1.36776100D+03,
     $ 1.34654310D+03, 1.32540030D+03, 1.30433360D+03, 1.28334340D+03,
     $ 1.26243030D+03, 1.24159420D+03, 1.22083500D+03, 1.20015230D+03,
     $ 1.17954540D+03, 1.15901300D+03, 1.13855390D+03, 1.11816600D+03/
      data ( FDNF(111,J,2),J=1,20) /
     $ 4.253D-06, 8.390D-06, 1.242D-05, 1.631D-05, 2.011D-05, 2.379D-05,
     $ 2.737D-05, 3.083D-05, 3.420D-05, 3.744D-05, 4.059D-05, 4.362D-05,
     $ 4.655D-05, 4.933D-05, 5.202D-05, 5.457D-05, 5.700D-05, 5.928D-05,
     $ 6.139D-05, 6.341D-05/
C
      call HI ('COFUND')
C     !BEG
C     !END
      call BYE ('COFUND')
C
      end
