      subroutine COOVER
C
C     Rudolf Loeser, 1994 Aug 16
C---- Does nothing - just contains data statements
C
C     Initializes CO first overtone band arrays
C                                        with Goorvitch 1994 data.
C     !DASH
      save
C     !DASH
      integer J
C     !COM
C---- LOOM        as of 1994 Dec 16
      integer     JCOLMF,KCOLMF,JCOLMO,KCOLMO,JCOLMS,KCOLMS,
     $            JCOLMR,KCOLMR,JCOMAX,KCOMAX
      parameter   (JCOLMF=111, KCOLMF=20)
      parameter   (JCOLMO=111, KCOLMO=13)
      parameter   (JCOLMS=111, KCOLMS=12)
      parameter   (JCOLMR=53,  KCOLMR=21)
      parameter   (JCOMAX=max(JCOLMF,JCOLMO,JCOLMS,JCOLMR))
      parameter   (KCOMAX=max(KCOLMF,KCOLMO,KCOLMS,KCOLMR))
C     (Be sure to recompile all users of LOOM when changing any
C     of the above parameter values!)
      real*8      WNUPF,WNDNF,WNUPO,WNDNO,WNUPS,WNDNS,WNROT,
     $            FUPF ,FDNF ,FUPO ,FDNO ,FUPS ,FDNS ,FROT ,
     $            EXEN,WVCOLO,WVCOHI,RC1213
      integer     JCOFUN,KCOFUN,JCOOVR,KCOOVR,JCOSEC,KCOSEC,
     $            JCOROT,KCOROT,ISOSLCT,METHCOW,METHCOF
      logical     FUNDCO,OVERCO,SECNCO,ROTACO
C
      dimension   WNUPF(JCOLMF,KCOLMF,2), WNDNF(JCOLMF,KCOLMF,2),
     $            WNUPO(JCOLMO,KCOLMO,2), WNDNO(JCOLMO,KCOLMO,2),
     $            WNUPS(JCOLMS,KCOLMS,2), WNDNS(JCOLMS,KCOLMS,2),
     $            WNROT(JCOLMR,KCOLMR,2),
     $            FUPF(JCOLMF,KCOLMF,2),  FDNF(JCOLMF,KCOLMF,2),
     $            FUPO(JCOLMO,KCOLMO,2),  FDNO(JCOLMO,KCOLMO,2),
     $            FUPS(JCOLMS,KCOLMS,2),  FDNS(JCOLMS,KCOLMS,2),
     $            FROT(JCOLMR,KCOLMR,2),
     $            EXEN(JCOMAX+1,KCOMAX,2)
      dimension   FUNDCO(2),OVERCO(2),SECNCO(2),ROTACO(2),
     $            JCOFUN(2),KCOFUN(2),JCOOVR(2),KCOOVR(2),
     $            JCOSEC(2),KCOSEC(2),JCOROT(2),KCOROT(2)
C
C     Carbon Monoxide lines:  wavenumbers and oscillator strengths.
C
C     WNROT, etc., are for rotational lines     : j'-j=+1, v'-v=0;
C     WNUPF, etc., are for fundamental lines    : j'-j=+1, v'-v=1;
C     WNDNF, etc., are for fundamental lines    : j'-j=-1, v'-v=1;
C     WNUPO, etc., are for first overtone lines : j'-j=+1, v'-v=2;
C     WNDNO, etc., are for first overtone lines : j'-j=-1, v'-v=2;
C     WNUPS, etc., are for second overtone lines: j'-j=+1, v'-v=3;
C     WNDNS, etc., are for second overtone lines: j'-j=-1, v'-v=3.
C
C     This is how the array indices relate to the quantum numbers:
C
C     1. index J corresponds to quantum number j -
C                in WNROT, etc., j = J-1, j' = J
C                in WNUPF, etc., j = J-1, j' = J
C                in WNDNF, etc., j = J  , j' = J-1
C                in WNUPO, etc., j = J-1, j' = J
C                in WNDNO, etc., j = J  , j' = J-1
C                in WNUPS, etc., j = J-1, j' = J
C                in WNDNS, etc., j = J  , j' = J-1
C
C     2. index K corresponds to quantum number v (=nu) -
C                in WNROT, etc.,                 v = K-1, v' = K-1
C                in WNUPF, etc. and WNDNF, etc., v = K-1, v' = K
C                in WNUPO, etc. and WNDNO, etc., v = K-1, v' = K+1
C                in WNUPS, etc. and WNDNS, etc., v = K-1, v' = K+2
C
C     3. index L identifies the Carbon isotope -
C                L=1 for Carbon-12, L=2 for Carbon-13.
C
C     Wavenumbers and energies from:
C        Farrenq, R., Guelachvili, G., Sauval, A.J., Grevesse, N.,
C        and Farmer, C.B. 1991,
C        J.Molec.Spectrosc., 149, 375
C       or
C        Coxon, J.A., and Hajigeorgiou, P.G. 1992,
C        Can.J.Phys., 70, 40-54
C       or
C        Goorvitch, 1994, Ap.J.Suppl.
C     f-values from:
C        Chackerian, C., Jr, and Tipping, R. H. 1983
C        J.Molec.Spectros., 99, 431
C       or
C        "improved" Chackerian
C       or
C        Goorvitch, 1994, Ap.J.Suppl.
C
      common      /LOOM1 / EXEN
      common      /LOOM2 / WNROT,FROT
      common      /LOOM3 / WNUPF,FUPF,WNDNF,FDNF
      common      /LOOM4 / WNUPO,FUPO,WNDNO,FDNO
      common      /LOOM5 / WNUPS,FUPS,WNDNS,FDNS
      common      /LOOM6 / JCOFUN,KCOFUN,JCOOVR,KCOOVR,JCOSEC,KCOSEC,
     $                     JCOROT,KCOROT
      common      /LOOM7 / WVCOLO,WVCOHI
      common      /LOOM8 / FUNDCO,OVERCO,SECNCO,ROTACO
C
C     (These parameters are computed by subroutines WEAVE and FOCA.)
C
      common      /LOOM9 / RC1213
      common      /LOOM10/ ISOSLCT,METHCOW,METHCOF
C
C     RC1213  is the C(12)/C(13) isotopic abundance ratio.
C     ISOSLCT controls which isotopes are included in this calculation:
C     ISOSLCT = 1 means: C(12) only;
C     ISOSLCT = 2 means: C(13) only; and
C     ISOSLCT = 3 means: both C(12) and C(13).
C
C     METHCOF = 1 means: use f-values from Chackerian & Tipping (1983);
C     METHCOF = 2 means: use f-values from "new" Chackerian data;
C     METHCOF = 3 means: use f-values from Goorvitch (1994).
C
C     METHCOW = 1 means: use energies from Farrenq et al.;
C     METHCOW = 2 means: use energies from Coxon & Hajigeorgiou;
C     METHCOW = 3 means: use wave numbers & energies from
C                                                    Goorvitch (1994).
C     .
C     !DASH
      data (WNUPO(  1,J,1),J=1,13) /
     $ 4.26383720D+03, 4.21090800D+03, 4.15811210D+03, 4.10545310D+03,
     $ 4.05293430D+03, 4.00055920D+03, 3.94833110D+03, 3.89625320D+03,
     $ 3.84432880D+03, 3.79256080D+03, 3.74095210D+03, 3.68950520D+03,
     $ 3.63822240D+03/
      data ( FUPO(  1,J,1),J=1,13) /
     $ 8.957D-08, 2.718D-07, 5.486D-07, 9.206D-07, 1.388D-06, 1.949D-06,
     $ 2.602D-06, 3.345D-06, 4.175D-06, 5.091D-06, 6.087D-06, 7.163D-06,
     $ 8.332D-06/
      data (WNDNO(  1,J,1),J=1,13) /
     $ 4.25621710D+03, 4.20335790D+03, 4.15063210D+03, 4.09804310D+03,
     $ 4.04559430D+03, 3.99328910D+03, 3.94113090D+03, 3.88912300D+03,
     $ 3.83726860D+03, 3.78557050D+03, 3.73403170D+03, 3.68265470D+03,
     $ 3.63144180D+03/
      data ( FDNO(  1,J,1),J=1,13) /
     $ 2.950D-08, 8.957D-08, 1.808D-07, 3.035D-07, 4.577D-07, 6.427D-07,
     $ 8.580D-07, 1.103D-06, 1.377D-06, 1.680D-06, 2.009D-06, 2.364D-06,
     $ 2.750D-06/
      data (WNUPO(  1,J,2),J=1,13) /
     $ 4.17042960D+03, 4.11982900D+03, 4.06935290D+03, 4.01900440D+03,
     $ 3.96878670D+03, 3.91870290D+03, 3.86875590D+03, 3.81894900D+03,
     $ 3.76928490D+03, 3.71976640D+03, 3.67039620D+03, 3.62117660D+03,
     $ 3.57210990D+03/
      data ( FUPO(  1,J,2),J=1,13) /
     $ 8.364D-08, 2.538D-07, 5.123D-07, 8.599D-07, 1.296D-06, 1.821D-06,
     $ 2.432D-06, 3.127D-06, 3.905D-06, 4.763D-06, 5.698D-06, 6.707D-06,
     $ 7.788D-06/
      data (WNDNO(  1,J,2),J=1,13) /
     $ 4.16314320D+03, 4.11260800D+03, 4.06219730D+03, 4.01191430D+03,
     $ 3.96176200D+03, 3.91174350D+03, 3.86186200D+03, 3.81212040D+03,
     $ 3.76252170D+03, 3.71306860D+03, 3.66376380D+03, 3.61460960D+03,
     $ 3.56560820D+03/
      data ( FDNO(  1,J,2),J=1,13) /
     $ 2.756D-08, 8.363D-08, 1.689D-07, 2.835D-07, 4.273D-07, 6.003D-07,
     $ 8.020D-07, 1.032D-06, 1.289D-06, 1.572D-06, 1.880D-06, 2.214D-06,
     $ 2.571D-06/
      data (WNUPO(  2,J,1),J=1,13) /
     $ 4.26754210D+03, 4.21457790D+03, 4.16174700D+03, 4.10905300D+03,
     $ 4.05649930D+03, 4.00408910D+03, 3.95182600D+03, 3.89971320D+03,
     $ 3.84775380D+03, 3.79595090D+03, 3.74430720D+03, 3.69282540D+03,
     $ 3.64150760D+03/
      data ( FUPO(  2,J,1),J=1,13) /
     $ 6.007D-08, 1.823D-07, 3.680D-07, 6.173D-07, 9.303D-07, 1.306D-06,
     $ 1.744D-06, 2.242D-06, 2.798D-06, 3.410D-06, 4.080D-06, 4.800D-06,
     $ 5.583D-06/
      data (WNDNO(  2,J,1),J=1,13) /
     $ 4.25230220D+03, 4.19947800D+03, 4.14678720D+03, 4.09423320D+03,
     $ 4.04181940D+03, 3.98954920D+03, 3.93742610D+03, 3.88545320D+03,
     $ 3.83363370D+03, 3.78197060D+03, 3.73046680D+03, 3.67912480D+03,
     $ 3.62794690D+03/
      data ( FDNO(  2,J,1),J=1,13) /
     $ 3.520D-08, 1.068D-07, 2.158D-07, 3.622D-07, 5.460D-07, 7.668D-07,
     $ 1.024D-06, 1.317D-06, 1.644D-06, 2.006D-06, 2.398D-06, 2.822D-06,
     $ 3.284D-06/
      data (WNUPO(  2,J,2),J=1,13) /
     $ 4.17397450D+03, 4.12334120D+03, 4.07283240D+03, 4.02245120D+03,
     $ 3.97220080D+03, 3.92208430D+03, 3.87210470D+03, 3.82226500D+03,
     $ 3.77256830D+03, 3.72301710D+03, 3.67361430D+03, 3.62436200D+03,
     $ 3.57526270D+03/
      data ( FUPO(  2,J,2),J=1,13) /
     $ 5.610D-08, 1.702D-07, 3.433D-07, 5.763D-07, 8.690D-07, 1.220D-06,
     $ 1.630D-06, 2.096D-06, 2.617D-06, 3.191D-06, 3.817D-06, 4.493D-06,
     $ 5.217D-06/
      data (WNDNO(  2,J,2),J=1,13) /
     $ 4.15940190D+03, 4.10889950D+03, 4.05852160D+03, 4.00827120D+03,
     $ 3.95815160D+03, 3.90816590D+03, 3.85831710D+03, 3.80860820D+03,
     $ 3.75904220D+03, 3.70962180D+03, 3.66034970D+03, 3.61122810D+03,
     $ 3.56225940D+03/
      data ( FDNO(  2,J,2),J=1,13) /
     $ 3.288D-08, 9.980D-08, 2.016D-07, 3.384D-07, 5.102D-07, 7.168D-07,
     $ 9.574D-07, 1.232D-06, 1.538D-06, 1.877D-06, 2.246D-06, 2.644D-06,
     $ 3.070D-06/
      data (WNUPO(  3,J,1),J=1,13) /
     $ 4.27117660D+03, 4.21817740D+03, 4.16531160D+03, 4.11258260D+03,
     $ 4.05999390D+03, 4.00754880D+03, 3.95525070D+03, 3.90310290D+03,
     $ 3.85110860D+03, 3.79927070D+03, 3.74759210D+03, 3.69607540D+03,
     $ 3.64472270D+03/
      data ( FUPO(  3,J,1),J=1,13) /
     $ 5.440D-08, 1.650D-07, 3.330D-07, 5.586D-07, 8.420D-07, 1.182D-06,
     $ 1.578D-06, 2.028D-06, 2.532D-06, 3.086D-06, 3.690D-06, 4.342D-06,
     $ 5.050D-06/
      data (WNDNO(  3,J,1),J=1,13) /
     $ 4.24831760D+03, 4.19552850D+03, 4.14287260D+03, 4.09035360D+03,
     $ 4.03797490D+03, 3.98573970D+03, 3.93365150D+03, 3.88171360D+03,
     $ 3.82992920D+03, 3.77830110D+03, 3.72683230D+03, 3.67552530D+03,
     $ 3.62438230D+03/
      data ( FDNO(  3,J,1),J=1,13) /
     $ 3.749D-08, 1.138D-07, 2.299D-07, 3.859D-07, 5.817D-07, 8.171D-07,
     $ 1.091D-06, 1.404D-06, 1.753D-06, 2.137D-06, 2.557D-06, 3.010D-06,
     $ 3.500D-06/
      data (WNUPO(  3,J,2),J=1,13) /
     $ 4.17745370D+03, 4.12678770D+03, 4.07624620D+03, 4.02583240D+03,
     $ 3.97554930D+03, 3.92540000D+03, 3.87538780D+03, 3.82551540D+03,
     $ 3.77578600D+03, 3.72620220D+03, 3.67676670D+03, 3.62748180D+03,
     $ 3.57834980D+03/
      data ( FUPO(  3,J,2),J=1,13) /
     $ 5.078D-08, 1.541D-07, 3.108D-07, 5.216D-07, 7.864D-07, 1.104D-06,
     $ 1.475D-06, 1.896D-06, 2.368D-06, 2.886D-06, 3.452D-06, 4.064D-06,
     $ 4.718D-06/
      data (WNDNO(  3,J,2),J=1,13) /
     $ 4.15559560D+03, 4.10512590D+03, 4.05478060D+03, 4.00456300D+03,
     $ 3.95447620D+03, 3.90452310D+03, 3.85470700D+03, 3.80503090D+03,
     $ 3.75549760D+03, 3.70610990D+03, 3.65687050D+03, 3.60778170D+03,
     $ 3.55884560D+03/
      data ( FDNO(  3,J,2),J=1,13) /
     $ 3.503D-08, 1.063D-07, 2.147D-07, 3.606D-07, 5.437D-07, 7.639D-07,
     $ 1.021D-06, 1.313D-06, 1.640D-06, 2.000D-06, 2.394D-06, 2.819D-06,
     $ 3.274D-06/
      data (WNUPO(  4,J,1),J=1,13) /
     $ 4.27474070D+03, 4.22170660D+03, 4.16880580D+03, 4.11604180D+03,
     $ 4.06341810D+03, 4.01093800D+03, 3.95860500D+03, 3.90642230D+03,
     $ 3.85439300D+03, 3.80252020D+03, 3.75080670D+03, 3.69925500D+03,
     $ 3.64786750D+03/
      data ( FUPO(  4,J,1),J=1,13) /
     $ 5.211D-08, 1.581D-07, 3.190D-07, 5.351D-07, 8.064D-07, 1.132D-06,
     $ 1.511D-06, 1.943D-06, 2.424D-06, 2.954D-06, 3.531D-06, 4.156D-06,
     $ 4.833D-06/
      data (WNDNO(  4,J,1),J=1,13) /
     $ 4.24426350D+03, 4.19150930D+03, 4.13888850D+03, 4.08640450D+03,
     $ 4.03406080D+03, 3.98186060D+03, 3.92980750D+03, 3.87790460D+03,
     $ 3.82615510D+03, 3.77456210D+03, 3.72312830D+03, 3.67185630D+03,
     $ 3.62074830D+03/
      data ( FDNO(  4,J,1),J=1,13) /
     $ 3.864D-08, 1.173D-07, 2.370D-07, 3.979D-07, 6.000D-07, 8.429D-07,
     $ 1.126D-06, 1.448D-06, 1.808D-06, 2.206D-06, 2.639D-06, 3.106D-06,
     $ 3.612D-06/
      data (WNUPO(  4,J,2),J=1,13) /
     $ 4.18086710D+03, 4.13016840D+03, 4.07959420D+03, 4.02914770D+03,
     $ 3.97883190D+03, 3.92865000D+03, 3.87860500D+03, 3.82870010D+03,
     $ 3.77893800D+03, 3.72932150D+03, 3.67985340D+03, 3.63053590D+03,
     $ 3.58137130D+03/
      data ( FUPO(  4,J,2),J=1,13) /
     $ 4.864D-08, 1.476D-07, 2.977D-07, 4.996D-07, 7.530D-07, 1.057D-06,
     $ 1.412D-06, 1.816D-06, 2.266D-06, 2.763D-06, 3.304D-06, 3.890D-06,
     $ 4.516D-06/
      data (WNDNO(  4,J,2),J=1,13) /
     $ 4.15172420D+03, 4.10128720D+03, 4.05097470D+03, 4.00078980D+03,
     $ 3.95073570D+03, 3.90081540D+03, 3.85103200D+03, 3.80138860D+03,
     $ 3.75188800D+03, 3.70253310D+03, 3.65332630D+03, 3.60427020D+03,
     $ 3.55536690D+03/
      data ( FDNO(  4,J,2),J=1,13) /
     $ 3.611D-08, 1.096D-07, 2.214D-07, 3.719D-07, 5.608D-07, 7.880D-07,
     $ 1.053D-06, 1.354D-06, 1.692D-06, 2.064D-06, 2.470D-06, 2.909D-06,
     $ 3.379D-06/
      data (WNUPO(  5,J,1),J=1,13) /
     $ 4.27823430D+03, 4.22516510D+03, 4.17222930D+03, 4.11943040D+03,
     $ 4.06677170D+03, 4.01425670D+03, 3.96188870D+03, 3.90967110D+03,
     $ 3.85760690D+03, 3.80569920D+03, 3.75395070D+03, 3.70236420D+03,
     $ 3.65094170D+03/
      data ( FUPO(  5,J,1),J=1,13) /
     $ 5.098D-08, 1.547D-07, 3.119D-07, 5.232D-07, 7.886D-07, 1.107D-06,
     $ 1.477D-06, 1.899D-06, 2.369D-06, 2.888D-06, 3.451D-06, 4.060D-06,
     $ 4.722D-06/
      data (WNDNO(  5,J,1),J=1,13) /
     $ 4.24013990D+03, 4.18742070D+03, 4.13483500D+03, 4.08238600D+03,
     $ 4.03007730D+03, 3.97791220D+03, 3.92589400D+03, 3.87402620D+03,
     $ 3.82231170D+03, 3.77075370D+03, 3.71935490D+03, 3.66811790D+03,
     $ 3.61704500D+03/
      data ( FDNO(  5,J,1),J=1,13) /
     $ 3.930D-08, 1.194D-07, 2.411D-07, 4.047D-07, 6.104D-07, 8.575D-07,
     $ 1.145D-06, 1.474D-06, 1.840D-06, 2.245D-06, 2.685D-06, 3.161D-06,
     $ 3.676D-06/
      data (WNUPO(  5,J,2),J=1,13) /
     $ 4.18421450D+03, 4.13348320D+03, 4.08287630D+03, 4.03239700D+03,
     $ 3.98204860D+03, 3.93183400D+03, 3.88175640D+03, 3.83181880D+03,
     $ 3.78202400D+03, 3.73237490D+03, 3.68287420D+03, 3.63352410D+03,
     $ 3.58432680D+03/
      data ( FUPO(  5,J,2),J=1,13) /
     $ 4.758D-08, 1.443D-07, 2.911D-07, 4.884D-07, 7.362D-07, 1.034D-06,
     $ 1.380D-06, 1.774D-06, 2.214D-06, 2.700D-06, 3.229D-06, 3.800D-06,
     $ 4.411D-06/
      data (WNDNO(  5,J,2),J=1,13) /
     $ 4.14778780D+03, 4.09738360D+03, 4.04710390D+03, 3.99695170D+03,
     $ 3.94693030D+03, 3.89704270D+03, 3.84729210D+03, 3.79768140D+03,
     $ 3.74821360D+03, 3.69889140D+03, 3.64971740D+03, 3.60069400D+03,
     $ 3.55182340D+03/
      data ( FDNO(  5,J,2),J=1,13) /
     $ 3.673D-08, 1.115D-07, 2.253D-07, 3.783D-07, 5.705D-07, 8.017D-07,
     $ 1.071D-06, 1.378D-06, 1.722D-06, 2.101D-06, 2.515D-06, 2.961D-06,
     $ 3.440D-06/
      data (WNUPO(  6,J,1),J=1,13) /
     $ 4.28165700D+03, 4.22855290D+03, 4.17558220D+03, 4.12274830D+03,
     $ 4.07005460D+03, 4.01750470D+03, 3.96510180D+03, 3.91284920D+03,
     $ 3.86075010D+03, 3.80880750D+03, 3.75702410D+03, 3.70540270D+03,
     $ 3.65394540D+03/
      data ( FUPO(  6,J,1),J=1,13) /
     $ 5.035D-08, 1.527D-07, 3.080D-07, 5.166D-07, 7.785D-07, 1.093D-06,
     $ 1.458D-06, 1.874D-06, 2.338D-06, 2.850D-06, 3.406D-06, 4.006D-06,
     $ 4.660D-06/
      data (WNDNO(  6,J,1),J=1,13) /
     $ 4.23594700D+03, 4.18326290D+03, 4.13071210D+03, 4.07829820D+03,
     $ 4.02602450D+03, 3.97389440D+03, 3.92191140D+03, 3.87007850D+03,
     $ 3.81839910D+03, 3.76687620D+03, 3.71551240D+03, 3.66431040D+03,
     $ 3.61327250D+03/
      data ( FDNO(  6,J,1),J=1,13) /
     $ 3.967D-08, 1.205D-07, 2.435D-07, 4.088D-07, 6.164D-07, 8.662D-07,
     $ 1.157D-06, 1.488D-06, 1.858D-06, 2.268D-06, 2.713D-06, 3.194D-06,
     $ 3.714D-06/
      data (WNUPO(  6,J,2),J=1,13) /
     $ 4.18749590D+03, 4.13673180D+03, 4.08609220D+03, 4.03558030D+03,
     $ 3.98519920D+03, 3.93495190D+03, 3.88484170D+03, 3.83487140D+03,
     $ 3.78504400D+03, 3.73536230D+03, 3.68582890D+03, 3.63644620D+03,
     $ 3.58721640D+03/
      data ( FUPO(  6,J,2),J=1,13) /
     $ 4.699D-08, 1.425D-07, 2.875D-07, 4.823D-07, 7.268D-07, 1.020D-06,
     $ 1.362D-06, 1.751D-06, 2.185D-06, 2.665D-06, 3.186D-06, 3.749D-06,
     $ 4.353D-06/
      data (WNDNO(  6,J,2),J=1,13) /
     $ 4.14378680D+03, 4.09341530D+03, 4.04316830D+03, 3.99304890D+03,
     $ 3.94306020D+03, 3.89320540D+03, 3.84348750D+03, 3.79390960D+03,
     $ 3.74447450D+03, 3.69518500D+03, 3.64604370D+03, 3.59705310D+03,
     $ 3.54821530D+03/
      data ( FDNO(  6,J,2),J=1,13) /
     $ 3.708D-08, 1.126D-07, 2.275D-07, 3.821D-07, 5.762D-07, 8.100D-07,
     $ 1.082D-06, 1.392D-06, 1.739D-06, 2.122D-06, 2.541D-06, 2.992D-06,
     $ 3.476D-06/
      data (WNUPO(  7,J,1),J=1,13) /
     $ 4.28500890D+03, 4.23186980D+03, 4.17886410D+03, 4.12599530D+03,
     $ 4.07326670D+03, 4.02068180D+03, 3.96824400D+03, 3.91595650D+03,
     $ 3.86382240D+03, 3.81184490D+03, 3.76002670D+03, 3.70837040D+03,
     $ 3.65687820D+03/
      data ( FUPO(  7,J,1),J=1,13) /
     $ 5.002D-08, 1.517D-07, 3.058D-07, 5.129D-07, 7.731D-07, 1.085D-06,
     $ 1.448D-06, 1.860D-06, 2.321D-06, 2.828D-06, 3.380D-06, 3.975D-06,
     $ 4.623D-06/
      data (WNDNO(  7,J,1),J=1,13) /
     $ 4.23168500D+03, 4.17903590D+03, 4.12652020D+03, 4.07414130D+03,
     $ 4.02190270D+03, 3.96980760D+03, 3.91785960D+03, 3.86606180D+03,
     $ 3.81441750D+03, 3.76292950D+03, 3.71160080D+03, 3.66043390D+03,
     $ 3.60943110D+03/
      data ( FDNO(  7,J,1),J=1,13) /
     $ 3.988D-08, 1.211D-07, 2.448D-07, 4.110D-07, 6.199D-07, 8.707D-07,
     $ 1.163D-06, 1.497D-06, 1.870D-06, 2.281D-06, 2.729D-06, 3.213D-06,
     $ 3.737D-06/
      data (WNUPO(  7,J,2),J=1,13) /
     $ 4.19071090D+03, 4.13991420D+03, 4.08924200D+03, 4.03869740D+03,
     $ 3.98828360D+03, 3.93800370D+03, 3.88786080D+03, 3.83785780D+03,
     $ 3.78799780D+03, 3.73828350D+03, 3.68871750D+03, 3.63930220D+03,
     $ 3.59003980D+03/
      data ( FUPO(  7,J,2),J=1,13) /
     $ 4.667D-08, 1.415D-07, 2.854D-07, 4.788D-07, 7.215D-07, 1.013D-06,
     $ 1.352D-06, 1.738D-06, 2.169D-06, 2.644D-06, 3.162D-06, 3.720D-06,
     $ 4.318D-06/
      data (WNDNO(  7,J,2),J=1,13) /
     $ 4.13972110D+03, 4.08938230D+03, 4.03916810D+03, 3.98908140D+03,
     $ 3.93912550D+03, 3.88930340D+03, 3.83961830D+03, 3.79007310D+03,
     $ 3.74067080D+03, 3.69141400D+03, 3.64230550D+03, 3.59334770D+03,
     $ 3.54454260D+03/
      data ( FDNO(  7,J,2),J=1,13) /
     $ 3.728D-08, 1.132D-07, 2.288D-07, 3.843D-07, 5.795D-07, 8.147D-07,
     $ 1.089D-06, 1.401D-06, 1.750D-06, 2.135D-06, 2.556D-06, 3.011D-06,
     $ 3.498D-06/
      data (WNUPO(  8,J,1),J=1,13) /
     $ 4.28828980D+03, 4.23511570D+03, 4.18207510D+03, 4.12917120D+03,
     $ 4.07640770D+03, 4.02378790D+03, 3.97131520D+03, 3.91899270D+03,
     $ 3.86682380D+03, 3.81481140D+03, 3.76295840D+03, 3.71126720D+03,
     $ 3.65974020D+03/
      data ( FUPO(  8,J,1),J=1,13) /
     $ 4.985D-08, 1.511D-07, 3.047D-07, 5.110D-07, 7.700D-07, 1.081D-06,
     $ 1.441D-06, 1.852D-06, 2.311D-06, 2.815D-06, 3.365D-06, 3.957D-06,
     $ 4.603D-06/
      data (WNDNO(  8,J,1),J=1,13) /
     $ 4.22735400D+03, 4.17474000D+03, 4.12225930D+03, 4.06991550D+03,
     $ 4.01771190D+03, 3.96565190D+03, 3.91373890D+03, 3.86197620D+03,
     $ 3.81036690D+03, 3.75891400D+03, 3.70762040D+03, 3.65648850D+03,
     $ 3.60552070D+03/
      data ( FDNO(  8,J,1),J=1,13) /
     $ 3.999D-08, 1.215D-07, 2.455D-07, 4.122D-07, 6.218D-07, 8.735D-07,
     $ 1.167D-06, 1.502D-06, 1.876D-06, 2.289D-06, 2.739D-06, 3.225D-06,
     $ 3.750D-06/
      data (WNUPO(  8,J,2),J=1,13) /
     $ 4.19385970D+03, 4.14303020D+03, 4.09232530D+03, 4.04174810D+03,
     $ 3.99130160D+03, 3.94098910D+03, 3.89081350D+03, 3.84077800D+03,
     $ 3.79088530D+03, 3.74113840D+03, 3.69153980D+03, 3.64209190D+03,
     $ 3.59279690D+03/
      data ( FUPO(  8,J,2),J=1,13) /
     $ 4.651D-08, 1.410D-07, 2.843D-07, 4.769D-07, 7.187D-07, 1.009D-06,
     $ 1.347D-06, 1.731D-06, 2.159D-06, 2.633D-06, 3.147D-06, 3.703D-06,
     $ 4.297D-06/
      data (WNDNO(  8,J,2),J=1,13) /
     $ 4.13559090D+03, 4.08528490D+03, 4.03510340D+03, 3.98504950D+03,
     $ 3.93512630D+03, 3.88533700D+03, 3.83568460D+03, 3.78617220D+03,
     $ 3.73680260D+03, 3.68757870D+03, 3.63850290D+03, 3.58957780D+03,
     $ 3.54080550D+03/
      data ( FDNO(  8,J,2),J=1,13) /
     $ 3.738D-08, 1.135D-07, 2.295D-07, 3.854D-07, 5.813D-07, 8.171D-07,
     $ 1.092D-06, 1.405D-06, 1.756D-06, 2.143D-06, 2.565D-06, 3.022D-06,
     $ 3.511D-06/
      data (WNUPO(  9,J,1),J=1,13) /
     $ 4.29149940D+03, 4.23829040D+03, 4.18521480D+03, 4.13227610D+03,
     $ 4.07947760D+03, 4.02682290D+03, 3.97431520D+03, 3.92195790D+03,
     $ 3.86975410D+03, 3.81770680D+03, 3.76581890D+03, 3.71409290D+03,
     $ 3.66253100D+03/
      data ( FUPO(  9,J,1),J=1,13) /
     $ 4.979D-08, 1.509D-07, 3.042D-07, 5.102D-07, 7.688D-07, 1.079D-06,
     $ 1.439D-06, 1.849D-06, 2.306D-06, 2.809D-06, 3.358D-06, 3.948D-06,
     $ 4.592D-06/
      data (WNDNO(  9,J,1),J=1,13) /
     $ 4.22295420D+03, 4.17037520D+03, 4.11792960D+03, 4.06562080D+03,
     $ 4.01345220D+03, 3.96142730D+03, 3.90954940D+03, 3.85782180D+03,
     $ 3.80624750D+03, 3.75482970D+03, 3.70357120D+03, 3.65247440D+03,
     $ 3.60154170D+03/
      data ( FDNO(  9,J,1),J=1,13) /
     $ 4.002D-08, 1.216D-07, 2.457D-07, 4.127D-07, 6.226D-07, 8.747D-07,
     $ 1.169D-06, 1.504D-06, 1.879D-06, 2.292D-06, 2.743D-06, 3.231D-06,
     $ 3.756D-06/
      data (WNUPO(  9,J,2),J=1,13) /
     $ 4.19694190D+03, 4.14607980D+03, 4.09534220D+03, 4.04473230D+03,
     $ 3.99425320D+03, 3.94390800D+03, 3.89369980D+03, 3.84363160D+03,
     $ 3.79370640D+03, 3.74392690D+03, 3.69429570D+03, 3.64481520D+03,
     $ 3.59548770D+03/
      data ( FUPO(  9,J,2),J=1,13) /
     $ 4.644D-08, 1.408D-07, 2.838D-07, 4.761D-07, 7.176D-07, 1.007D-06,
     $ 1.344D-06, 1.727D-06, 2.155D-06, 2.626D-06, 3.140D-06, 3.694D-06,
     $ 4.287D-06/
      data (WNDNO(  9,J,2),J=1,13) /
     $ 4.13139640D+03, 4.08112310D+03, 4.03097440D+03, 3.98095320D+03,
     $ 3.93106280D+03, 3.88130630D+03, 3.83168670D+03, 3.78220700D+03,
     $ 3.73287020D+03, 3.68367900D+03, 3.63463610D+03, 3.58574370D+03,
     $ 3.53700420D+03/
      data ( FDNO(  9,J,2),J=1,13) /
     $ 3.742D-08, 1.137D-07, 2.298D-07, 3.859D-07, 5.821D-07, 8.184D-07,
     $ 1.094D-06, 1.407D-06, 1.759D-06, 2.147D-06, 2.570D-06, 3.027D-06,
     $ 3.518D-06/
      data (WNUPO( 10,J,1),J=1,13) /
     $ 4.29463780D+03, 4.24139380D+03, 4.18828320D+03, 4.13530960D+03,
     $ 4.08247620D+03, 4.02978650D+03, 3.97724390D+03, 3.92485170D+03,
     $ 3.87261310D+03, 3.82053090D+03, 3.76860820D+03, 3.71684730D+03,
     $ 3.66525060D+03/
      data ( FUPO( 10,J,1),J=1,13) /
     $ 4.981D-08, 1.510D-07, 3.043D-07, 5.102D-07, 7.684D-07, 1.078D-06,
     $ 1.438D-06, 1.848D-06, 2.305D-06, 2.808D-06, 3.355D-06, 3.945D-06,
     $ 4.588D-06/
      data (WNDNO( 10,J,1),J=1,13) /
     $ 4.21848570D+03, 4.16594170D+03, 4.11353120D+03, 4.06125750D+03,
     $ 4.00912400D+03, 3.95713410D+03, 3.90529130D+03, 3.85359870D+03,
     $ 3.80205960D+03, 3.75067680D+03, 3.69945340D+03, 3.64839160D+03,
     $ 3.59749400D+03/
      data ( FDNO( 10,J,1),J=1,13) /
     $ 4.000D-08, 1.215D-07, 2.457D-07, 4.127D-07, 6.224D-07, 8.748D-07,
     $ 1.169D-06, 1.504D-06, 1.879D-06, 2.293D-06, 2.744D-06, 3.232D-06,
     $ 3.758D-06/
      data (WNUPO( 10,J,2),J=1,13) /
     $ 4.19995740D+03, 4.14906270D+03, 4.09829240D+03, 4.04764990D+03,
     $ 3.99713810D+03, 3.94676030D+03, 3.89651950D+03, 3.84641870D+03,
     $ 3.79646090D+03, 3.74664880D+03, 3.69698500D+03, 3.64747200D+03,
     $ 3.59811190D+03/
      data ( FUPO( 10,J,2),J=1,13) /
     $ 4.645D-08, 1.408D-07, 2.838D-07, 4.759D-07, 7.174D-07, 1.006D-06,
     $ 1.343D-06, 1.726D-06, 2.154D-06, 2.625D-06, 3.137D-06, 3.691D-06,
     $ 4.283D-06/
      data (WNDNO( 10,J,2),J=1,13) /
     $ 4.12713760D+03, 4.07689710D+03, 4.02678110D+03, 3.97679270D+03,
     $ 3.92693510D+03, 3.87721130D+03, 3.82762450D+03, 3.77817760D+03,
     $ 3.72887360D+03, 3.67971520D+03, 3.63070500D+03, 3.58184550D+03,
     $ 3.53313870D+03/
      data ( FDNO( 10,J,2),J=1,13) /
     $ 3.741D-08, 1.136D-07, 2.298D-07, 3.859D-07, 5.819D-07, 8.181D-07,
     $ 1.094D-06, 1.408D-06, 1.760D-06, 2.148D-06, 2.571D-06, 3.029D-06,
     $ 3.520D-06/
      data (WNUPO( 11,J,1),J=1,13) /
     $ 4.29770460D+03, 4.24442570D+03, 4.19128020D+03, 4.13827160D+03,
     $ 4.08540330D+03, 4.03267870D+03, 3.98010130D+03, 3.92767420D+03,
     $ 3.87540060D+03, 3.82328370D+03, 3.77132610D+03, 3.71953040D+03,
     $ 3.66789890D+03/
      data ( FUPO( 11,J,1),J=1,13) /
     $ 4.986D-08, 1.512D-07, 3.046D-07, 5.105D-07, 7.695D-07, 1.079D-06,
     $ 1.440D-06, 1.849D-06, 2.306D-06, 2.810D-06, 3.357D-06, 3.946D-06,
     $ 4.590D-06/
      data (WNDNO( 11,J,1),J=1,13) /
     $ 4.21394860D+03, 4.16143980D+03, 4.10906430D+03, 4.05682560D+03,
     $ 4.00472720D+03, 3.95277240D+03, 3.90096460D+03, 3.84930710D+03,
     $ 3.79780310D+03, 3.74645550D+03, 3.69526710D+03, 3.64424050D+03,
     $ 3.59337790D+03/
      data ( FDNO( 11,J,1),J=1,13) /
     $ 3.995D-08, 1.214D-07, 2.454D-07, 4.123D-07, 6.217D-07, 8.739D-07,
     $ 1.168D-06, 1.503D-06, 1.878D-06, 2.292D-06, 2.743D-06, 3.230D-06,
     $ 3.756D-06/
      data (WNUPO( 11,J,2),J=1,13) /
     $ 4.20290620D+03, 4.15197880D+03, 4.10117590D+03, 4.05050070D+03,
     $ 3.99995630D+03, 3.94954580D+03, 3.89927240D+03, 3.84913900D+03,
     $ 3.79914860D+03, 3.74930390D+03, 3.69960760D+03, 3.65006210D+03,
     $ 3.60066940D+03/
      data ( FUPO( 11,J,2),J=1,13) /
     $ 4.651D-08, 1.410D-07, 2.841D-07, 4.762D-07, 7.176D-07, 1.007D-06,
     $ 1.344D-06, 1.727D-06, 2.155D-06, 2.626D-06, 3.139D-06, 3.691D-06,
     $ 4.283D-06/
      data (WNDNO( 11,J,2),J=1,13) /
     $ 4.12281480D+03, 4.07260700D+03, 4.02252380D+03, 3.97256820D+03,
     $ 3.92274330D+03, 3.87305230D+03, 3.82349830D+03, 3.77408420D+03,
     $ 3.72481300D+03, 3.67568740D+03, 3.62671000D+03, 3.57788330D+03,
     $ 3.52920930D+03/
      data ( FDNO( 11,J,2),J=1,13) /
     $ 3.737D-08, 1.135D-07, 2.295D-07, 3.856D-07, 5.817D-07, 8.178D-07,
     $ 1.093D-06, 1.407D-06, 1.758D-06, 2.146D-06, 2.570D-06, 3.027D-06,
     $ 3.519D-06/
      data (WNUPO( 12,J,1),J=1,13) /
     $ 4.30069990D+03, 4.24738600D+03, 4.19420560D+03, 4.14116200D+03,
     $ 4.08825880D+03, 4.03549930D+03, 3.98288700D+03, 3.93042500D+03,
     $ 3.87811660D+03, 3.82596480D+03, 3.77397240D+03, 3.72214190D+03,
     $ 3.67047560D+03/
      data ( FUPO( 12,J,1),J=1,13) /
     $ 5.000D-08, 1.515D-07, 3.052D-07, 5.117D-07, 7.709D-07, 1.081D-06,
     $ 1.442D-06, 1.852D-06, 2.310D-06, 2.813D-06, 3.360D-06, 3.951D-06,
     $ 4.596D-06/
      data (WNDNO( 12,J,1),J=1,13) /
     $ 4.20934320D+03, 4.15686940D+03, 4.10452900D+03, 4.05232540D+03,
     $ 4.00026200D+03, 3.94834230D+03, 3.89656960D+03, 3.84494720D+03,
     $ 3.79347830D+03, 3.74216580D+03, 3.69101250D+03, 3.64002100D+03,
     $ 3.58919360D+03/
      data ( FDNO( 12,J,1),J=1,13) /
     $ 3.988D-08, 1.212D-07, 2.450D-07, 4.116D-07, 6.208D-07, 8.728D-07,
     $ 1.166D-06, 1.501D-06, 1.875D-06, 2.289D-06, 2.739D-06, 3.226D-06,
     $ 3.751D-06/
      data (WNUPO( 12,J,2),J=1,13) /
     $ 4.20578810D+03, 4.15482800D+03, 4.10399250D+03, 4.05328460D+03,
     $ 4.00270760D+03, 3.95226450D+03, 3.90195850D+03, 3.85179250D+03,
     $ 3.80176950D+03, 3.75189230D+03, 3.70216340D+03, 3.65258530D+03,
     $ 3.60316010D+03/
      data ( FUPO( 12,J,2),J=1,13) /
     $ 4.661D-08, 1.413D-07, 2.847D-07, 4.774D-07, 7.191D-07, 1.009D-06,
     $ 1.346D-06, 1.730D-06, 2.157D-06, 2.629D-06, 3.142D-06, 3.696D-06,
     $ 4.288D-06/
      data (WNDNO( 12,J,2),J=1,13) /
     $ 4.11842790D+03, 4.06825300D+03, 4.01820250D+03, 3.96827970D+03,
     $ 3.91848760D+03, 3.86882940D+03, 3.81930810D+03, 3.76992690D+03,
     $ 3.72068840D+03, 3.67159560D+03, 3.62265110D+03, 3.57385720D+03,
     $ 3.52521600D+03/
      data ( FDNO( 12,J,2),J=1,13) /
     $ 3.730D-08, 1.133D-07, 2.292D-07, 3.850D-07, 5.808D-07, 8.164D-07,
     $ 1.092D-06, 1.405D-06, 1.756D-06, 2.144D-06, 2.567D-06, 3.024D-06,
     $ 3.515D-06/
      data (WNUPO( 13,J,1),J=1,13) /
     $ 4.30362330D+03, 4.25027450D+03, 4.19705920D+03, 4.14398070D+03,
     $ 4.09104260D+03, 4.03824820D+03, 3.98560100D+03, 3.93310410D+03,
     $ 3.88076090D+03, 3.82857430D+03, 3.77654700D+03, 3.72468170D+03,
     $ 3.67298070D+03/
      data ( FUPO( 13,J,1),J=1,13) /
     $ 5.016D-08, 1.519D-07, 3.060D-07, 5.128D-07, 7.728D-07, 1.084D-06,
     $ 1.445D-06, 1.856D-06, 2.314D-06, 2.818D-06, 3.367D-06, 3.958D-06,
     $ 4.604D-06/
      data (WNDNO( 13,J,1),J=1,13) /
     $ 4.20466950D+03, 4.15223080D+03, 4.09992540D+03, 4.04775690D+03,
     $ 3.99572860D+03, 3.94384400D+03, 3.89210640D+03, 3.84051910D+03,
     $ 3.78908530D+03, 3.73780790D+03, 3.68668980D+03, 3.63573340D+03,
     $ 3.58494110D+03/
      data ( FDNO( 13,J,1),J=1,13) /
     $ 3.978D-08, 1.209D-07, 2.445D-07, 4.107D-07, 6.193D-07, 8.707D-07,
     $ 1.164D-06, 1.498D-06, 1.872D-06, 2.284D-06, 2.734D-06, 3.221D-06,
     $ 3.744D-06/
      data (WNUPO( 13,J,2),J=1,13) /
     $ 4.20860300D+03, 4.15761020D+03, 4.10674200D+03, 4.05600150D+03,
     $ 4.00539190D+03, 3.95491620D+03, 3.90457750D+03, 3.85437900D+03,
     $ 3.80432340D+03, 3.75441360D+03, 3.70465220D+03, 3.65504160D+03,
     $ 3.60558380D+03/
      data ( FUPO( 13,J,2),J=1,13) /
     $ 4.676D-08, 1.416D-07, 2.854D-07, 4.784D-07, 7.208D-07, 1.011D-06,
     $ 1.349D-06, 1.733D-06, 2.162D-06, 2.634D-06, 3.148D-06, 3.702D-06,
     $ 4.296D-06/
      data (WNDNO( 13,J,2),J=1,13) /
     $ 4.11397730D+03, 4.06383510D+03, 4.01381750D+03, 3.96392740D+03,
     $ 3.91416810D+03, 3.86454270D+03, 3.81505420D+03, 3.76570570D+03,
     $ 3.71650010D+03, 3.66744020D+03, 3.61852840D+03, 3.56976730D+03,
     $ 3.52115900D+03/
      data ( FDNO( 13,J,2),J=1,13) /
     $ 3.722D-08, 1.131D-07, 2.287D-07, 3.841D-07, 5.796D-07, 8.148D-07,
     $ 1.089D-06, 1.402D-06, 1.753D-06, 2.140D-06, 2.563D-06, 3.019D-06,
     $ 3.510D-06/
      data (WNUPO( 14,J,1),J=1,13) /
     $ 4.30647490D+03, 4.25309110D+03, 4.19984080D+03, 4.14672750D+03,
     $ 4.09375440D+03, 4.04092520D+03, 3.98824310D+03, 3.93571140D+03,
     $ 3.88333330D+03, 3.83111190D+03, 3.77904980D+03, 3.72714970D+03,
     $ 3.67541390D+03/
      data ( FUPO( 14,J,1),J=1,13) /
     $ 5.033D-08, 1.524D-07, 3.070D-07, 5.144D-07, 7.748D-07, 1.087D-06,
     $ 1.449D-06, 1.861D-06, 2.320D-06, 2.826D-06, 3.375D-06, 3.967D-06,
     $ 4.615D-06/
      data (WNDNO( 14,J,1),J=1,13) /
     $ 4.19992770D+03, 4.14752410D+03, 4.09525380D+03, 4.04312030D+03,
     $ 3.99112710D+03, 3.93927760D+03, 3.88757510D+03, 3.83602300D+03,
     $ 3.78462430D+03, 3.73338200D+03, 3.68229900D+03, 3.63137780D+03,
     $ 3.58062060D+03/
      data ( FDNO( 14,J,1),J=1,13) /
     $ 3.966D-08, 1.206D-07, 2.438D-07, 4.097D-07, 6.179D-07, 8.686D-07,
     $ 1.161D-06, 1.494D-06, 1.867D-06, 2.279D-06, 2.729D-06, 3.214D-06,
     $ 3.738D-06/
      data (WNUPO( 14,J,2),J=1,13) /
     $ 4.21135070D+03, 4.16032530D+03, 4.10942440D+03, 4.05865130D+03,
     $ 4.00800900D+03, 3.95750070D+03, 3.90712940D+03, 3.85689830D+03,
     $ 3.80681020D+03, 3.75686780D+03, 3.70707390D+03, 3.65743070D+03,
     $ 3.60794050D+03/
      data ( FUPO( 14,J,2),J=1,13) /
     $ 4.689D-08, 1.421D-07, 2.862D-07, 4.796D-07, 7.226D-07, 1.014D-06,
     $ 1.353D-06, 1.737D-06, 2.167D-06, 2.640D-06, 3.155D-06, 3.711D-06,
     $ 4.304D-06/
      data (WNDNO( 14,J,2),J=1,13) /
     $ 4.10946300D+03, 4.05935360D+03, 4.00936870D+03, 3.95951140D+03,
     $ 3.90978490D+03, 3.86019230D+03, 3.81073660D+03, 3.76142100D+03,
     $ 3.71224820D+03, 3.66322100D+03, 3.61434210D+03, 3.56561390D+03,
     $ 3.51703840D+03/
      data ( FDNO( 14,J,2),J=1,13) /
     $ 3.710D-08, 1.128D-07, 2.281D-07, 3.831D-07, 5.779D-07, 8.128D-07,
     $ 1.087D-06, 1.399D-06, 1.749D-06, 2.135D-06, 2.557D-06, 3.013D-06,
     $ 3.503D-06/
      data (WNUPO( 15,J,1),J=1,13) /
     $ 4.30925440D+03, 4.25583570D+03, 4.20255050D+03, 4.14940220D+03,
     $ 4.09639430D+03, 4.04353010D+03, 3.99081310D+03, 3.93824660D+03,
     $ 3.88583370D+03, 3.83357750D+03, 3.78148060D+03, 3.72954580D+03,
     $ 3.67777520D+03/
      data ( FUPO( 15,J,1),J=1,13) /
     $ 5.052D-08, 1.530D-07, 3.081D-07, 5.162D-07, 7.776D-07, 1.090D-06,
     $ 1.453D-06, 1.867D-06, 2.327D-06, 2.833D-06, 3.384D-06, 3.979D-06,
     $ 4.624D-06/
      data (WNDNO( 15,J,1),J=1,13) /
     $ 4.19511800D+03, 4.14274940D+03, 4.09051420D+03, 4.03841580D+03,
     $ 3.98645770D+03, 3.93464330D+03, 3.88297590D+03, 3.83145890D+03,
     $ 3.78009530D+03, 3.72888820D+03, 3.67784040D+03, 3.62695430D+03,
     $ 3.57623230D+03/
      data ( FDNO( 15,J,1),J=1,13) /
     $ 3.955D-08, 1.202D-07, 2.431D-07, 4.084D-07, 6.161D-07, 8.661D-07,
     $ 1.158D-06, 1.490D-06, 1.863D-06, 2.274D-06, 2.722D-06, 3.206D-06,
     $ 3.726D-06/
      data (WNUPO( 15,J,2),J=1,13) /
     $ 4.21403100D+03, 4.16297300D+03, 4.11203950D+03, 4.06123370D+03,
     $ 4.01055880D+03, 3.96001790D+03, 3.90961410D+03, 3.85935040D+03,
     $ 3.80922970D+03, 3.75925480D+03, 3.70942830D+03, 3.65975260D+03,
     $ 3.61022990D+03/
      data ( FUPO( 15,J,2),J=1,13) /
     $ 4.707D-08, 1.426D-07, 2.872D-07, 4.814D-07, 7.252D-07, 1.017D-06,
     $ 1.357D-06, 1.743D-06, 2.173D-06, 2.647D-06, 3.163D-06, 3.721D-06,
     $ 4.314D-06/
      data (WNDNO( 15,J,2),J=1,13) /
     $ 4.10488510D+03, 4.05480850D+03, 4.00485640D+03, 3.95503190D+03,
     $ 3.90533820D+03, 3.85577840D+03, 3.80635550D+03, 3.75707270D+03,
     $ 3.70793270D+03, 3.65893840D+03, 3.61009240D+03, 3.56139700D+03,
     $ 3.51285430D+03/
      data ( FDNO( 15,J,2),J=1,13) /
     $ 3.700D-08, 1.124D-07, 2.274D-07, 3.823D-07, 5.765D-07, 8.106D-07,
     $ 1.084D-06, 1.395D-06, 1.745D-06, 2.130D-06, 2.551D-06, 3.006D-06,
     $ 3.494D-06/
      data (WNUPO( 16,J,1),J=1,13) /
     $ 4.31196170D+03, 4.25850800D+03, 4.20518790D+03, 4.15200470D+03,
     $ 4.09896190D+03, 4.04606290D+03, 3.99331100D+03, 3.94070970D+03,
     $ 3.88826200D+03, 3.83597090D+03, 3.78383930D+03, 3.73186970D+03,
     $ 3.68006430D+03/
      data ( FUPO( 16,J,1),J=1,13) /
     $ 5.071D-08, 1.536D-07, 3.093D-07, 5.184D-07, 7.803D-07, 1.094D-06,
     $ 1.459D-06, 1.873D-06, 2.335D-06, 2.843D-06, 3.394D-06, 3.990D-06,
     $ 4.639D-06/
      data (WNDNO( 16,J,1),J=1,13) /
     $ 4.19024040D+03, 4.13790690D+03, 4.08570680D+03, 4.03364350D+03,
     $ 3.98172050D+03, 3.92994120D+03, 3.87830900D+03, 3.82682710D+03,
     $ 3.77549860D+03, 3.72432670D+03, 3.67331400D+03, 3.62246310D+03,
     $ 3.57177620D+03/
      data ( FDNO( 16,J,1),J=1,13) /
     $ 3.939D-08, 1.198D-07, 2.423D-07, 4.070D-07, 6.139D-07, 8.633D-07,
     $ 1.154D-06, 1.486D-06, 1.857D-06, 2.267D-06, 2.714D-06, 3.197D-06,
     $ 3.715D-06/
      data (WNUPO( 16,J,2),J=1,13) /
     $ 4.21664400D+03, 4.16555330D+03, 4.11458710D+03, 4.06374870D+03,
     $ 4.01304120D+03, 3.96246770D+03, 3.91203130D+03, 3.86173500D+03,
     $ 3.81158180D+03, 3.76157440D+03, 3.71171540D+03, 3.66200720D+03,
     $ 3.61245200D+03/
      data ( FUPO( 16,J,2),J=1,13) /
     $ 4.726D-08, 1.432D-07, 2.883D-07, 4.832D-07, 7.277D-07, 1.021D-06,
     $ 1.361D-06, 1.748D-06, 2.180D-06, 2.655D-06, 3.173D-06, 3.729D-06,
     $ 4.326D-06/
      data (WNDNO( 16,J,2),J=1,13) /
     $ 4.10024390D+03, 4.05020000D+03, 4.00028070D+03, 3.95048900D+03,
     $ 3.90082810D+03, 3.85130100D+03, 3.80191100D+03, 3.75266100D+03,
     $ 3.70355390D+03, 3.65459250D+03, 3.60577930D+03, 3.55711670D+03,
     $ 3.50860690D+03/
      data ( FDNO( 16,J,2),J=1,13) /
     $ 3.688D-08, 1.121D-07, 2.267D-07, 3.809D-07, 5.745D-07, 8.082D-07,
     $ 1.081D-06, 1.391D-06, 1.740D-06, 2.124D-06, 2.544D-06, 2.998D-06,
     $ 3.485D-06/
      data (WNUPO( 17,J,1),J=1,13) /
     $ 4.31459660D+03, 4.26110810D+03, 4.20775300D+03, 4.15453490D+03,
     $ 4.10145720D+03, 4.04852330D+03, 3.99573660D+03, 3.94310040D+03,
     $ 3.89061790D+03, 3.83829200D+03, 3.78612560D+03, 3.73412130D+03,
     $ 3.68228120D+03/
      data ( FUPO( 17,J,1),J=1,13) /
     $ 5.094D-08, 1.543D-07, 3.106D-07, 5.203D-07, 7.836D-07, 1.098D-06,
     $ 1.464D-06, 1.880D-06, 2.343D-06, 2.852D-06, 3.406D-06, 4.003D-06,
     $ 4.655D-06/
      data (WNDNO( 17,J,1),J=1,13) /
     $ 4.18529520D+03, 4.13299680D+03, 4.08083180D+03, 4.02880360D+03,
     $ 3.97691570D+03, 3.92517150D+03, 3.87357440D+03, 3.82212760D+03,
     $ 3.77083430D+03, 3.71969760D+03, 3.66872000D+03, 3.61790430D+03,
     $ 3.56725260D+03/
      data ( FDNO( 17,J,1),J=1,13) /
     $ 3.926D-08, 1.193D-07, 2.415D-07, 4.057D-07, 6.120D-07, 8.606D-07,
     $ 1.151D-06, 1.481D-06, 1.851D-06, 2.260D-06, 2.706D-06, 3.189D-06,
     $ 3.706D-06/
      data (WNUPO( 17,J,2),J=1,13) /
     $ 4.21918930D+03, 4.16806600D+03, 4.11706720D+03, 4.06619620D+03,
     $ 4.01545600D+03, 3.96484990D+03, 3.91438100D+03, 3.86405210D+03,
     $ 3.81386640D+03, 3.76382640D+03, 3.71393490D+03, 3.66419430D+03,
     $ 3.61460660D+03/
      data ( FUPO( 17,J,2),J=1,13) /
     $ 4.748D-08, 1.438D-07, 2.895D-07, 4.852D-07, 7.306D-07, 1.024D-06,
     $ 1.366D-06, 1.755D-06, 2.188D-06, 2.664D-06, 3.182D-06, 3.742D-06,
     $ 4.339D-06/
      data (WNDNO( 17,J,2),J=1,13) /
     $ 4.09553930D+03, 4.04552820D+03, 3.99564170D+03, 3.94588280D+03,
     $ 3.89625470D+03, 3.84676050D+03, 3.79740330D+03, 3.74818610D+03,
     $ 3.69911190D+03, 3.65018330D+03, 3.60140290D+03, 3.55277330D+03,
     $ 3.50429640D+03/
      data ( FDNO( 17,J,2),J=1,13) /
     $ 3.674D-08, 1.117D-07, 2.259D-07, 3.797D-07, 5.729D-07, 8.054D-07,
     $ 1.077D-06, 1.387D-06, 1.734D-06, 2.118D-06, 2.537D-06, 2.989D-06,
     $ 3.477D-06/
      data (WNUPO( 18,J,1),J=1,13) /
     $ 4.31715900D+03, 4.26363560D+03, 4.21024560D+03, 4.15699260D+03,
     $ 4.10388000D+03, 4.05091120D+03, 3.99808970D+03, 3.94541870D+03,
     $ 3.89290140D+03, 3.84054070D+03, 3.78833960D+03, 3.73630040D+03,
     $ 3.68442560D+03/
      data ( FUPO( 18,J,1),J=1,13) /
     $ 5.120D-08, 1.550D-07, 3.120D-07, 5.226D-07, 7.869D-07, 1.103D-06,
     $ 1.470D-06, 1.887D-06, 2.352D-06, 2.863D-06, 3.417D-06, 4.017D-06,
     $ 4.669D-06/
      data (WNDNO( 18,J,1),J=1,13) /
     $ 4.18028250D+03, 4.12801920D+03, 4.07588920D+03, 4.02389610D+03,
     $ 3.97204340D+03, 3.92033430D+03, 3.86877230D+03, 3.81736070D+03,
     $ 3.76610260D+03, 3.71500100D+03, 3.66405860D+03, 3.61327810D+03,
     $ 3.56266160D+03/
      data ( FDNO( 18,J,1),J=1,13) /
     $ 3.911D-08, 1.189D-07, 2.406D-07, 4.043D-07, 6.097D-07, 8.576D-07,
     $ 1.146D-06, 1.476D-06, 1.845D-06, 2.253D-06, 2.697D-06, 3.178D-06,
     $ 3.695D-06/
      data (WNUPO( 18,J,2),J=1,13) /
     $ 4.22166700D+03, 4.17051100D+03, 4.11947960D+03, 4.06857590D+03,
     $ 4.01780320D+03, 3.96716450D+03, 3.91666290D+03, 3.86630160D+03,
     $ 3.81608330D+03, 3.76601080D+03, 3.71608680D+03, 3.66631370D+03,
     $ 3.61669350D+03/
      data ( FUPO( 18,J,2),J=1,13) /
     $ 4.769D-08, 1.444D-07, 2.906D-07, 4.871D-07, 7.334D-07, 1.029D-06,
     $ 1.371D-06, 1.761D-06, 2.195D-06, 2.674D-06, 3.194D-06, 3.754D-06,
     $ 4.354D-06/
      data (WNDNO( 18,J,2),J=1,13) /
     $ 4.09077160D+03, 4.04079330D+03, 3.99093960D+03, 3.94121340D+03,
     $ 3.89161810D+03, 3.84215680D+03, 3.79283240D+03, 3.74364810D+03,
     $ 3.69460670D+03, 3.64571100D+03, 3.59696350D+03, 3.54836670D+03,
     $ 3.49992270D+03/
      data ( FDNO( 18,J,2),J=1,13) /
     $ 3.659D-08, 1.112D-07, 2.252D-07, 3.784D-07, 5.708D-07, 8.027D-07,
     $ 1.074D-06, 1.382D-06, 1.729D-06, 2.111D-06, 2.529D-06, 2.981D-06,
     $ 3.465D-06/
      data (WNUPO( 19,J,1),J=1,13) /
     $ 4.31964880D+03, 4.26609040D+03, 4.21266550D+03, 4.15937760D+03,
     $ 4.10623020D+03, 4.05322650D+03, 4.00037020D+03, 3.94766440D+03,
     $ 3.89511220D+03, 3.84271680D+03, 3.79048090D+03, 3.73840700D+03,
     $ 3.68649750D+03/
      data ( FUPO( 19,J,1),J=1,13) /
     $ 5.143D-08, 1.558D-07, 3.135D-07, 5.249D-07, 7.903D-07, 1.108D-06,
     $ 1.476D-06, 1.895D-06, 2.361D-06, 2.873D-06, 3.432D-06, 4.032D-06,
     $ 4.686D-06/
      data (WNDNO( 19,J,1),J=1,13) /
     $ 4.17520240D+03, 4.12297420D+03, 4.07087930D+03, 4.01892130D+03,
     $ 3.96710370D+03, 3.91542970D+03, 3.86390290D+03, 3.81252640D+03,
     $ 3.76130350D+03, 3.71023710D+03, 3.65932990D+03, 3.60858460D+03,
     $ 3.55800330D+03/
      data ( FDNO( 19,J,1),J=1,13) /
     $ 3.895D-08, 1.184D-07, 2.397D-07, 4.028D-07, 6.077D-07, 8.544D-07,
     $ 1.143D-06, 1.471D-06, 1.839D-06, 2.245D-06, 2.687D-06, 3.169D-06,
     $ 3.682D-06/
      data (WNUPO( 19,J,2),J=1,13) /
     $ 4.22407680D+03, 4.17288820D+03, 4.12182410D+03, 4.07088790D+03,
     $ 4.02008250D+03, 3.96941120D+03, 3.91887710D+03, 3.86848320D+03,
     $ 3.81823230D+03, 3.76812740D+03, 3.71817090D+03, 3.66836530D+03,
     $ 3.61871270D+03/
      data ( FUPO( 19,J,2),J=1,13) /
     $ 4.792D-08, 1.451D-07, 2.919D-07, 4.892D-07, 7.365D-07, 1.033D-06,
     $ 1.377D-06, 1.768D-06, 2.204D-06, 2.684D-06, 3.205D-06, 3.768D-06,
     $ 4.370D-06/
      data (WNDNO( 19,J,2),J=1,13) /
     $ 4.08594080D+03, 4.03599540D+03, 3.98617440D+03, 3.93648110D+03,
     $ 3.88691860D+03, 3.83749010D+03, 3.78819860D+03, 3.73904710D+03,
     $ 3.69003860D+03, 3.64117570D+03, 3.59246120D+03, 3.54389730D+03,
     $ 3.49548610D+03/
      data ( FDNO( 19,J,2),J=1,13) /
     $ 3.646D-08, 1.108D-07, 2.243D-07, 3.769D-07, 5.687D-07, 8.000D-07,
     $ 1.070D-06, 1.378D-06, 1.723D-06, 2.104D-06, 2.521D-06, 2.972D-06,
     $ 3.454D-06/
      data (WNUPO( 20,J,1),J=1,13) /
     $ 4.32206580D+03, 4.26847250D+03, 4.21501270D+03, 4.16168990D+03,
     $ 4.10850760D+03, 4.05546910D+03, 4.00257790D+03, 3.94983730D+03,
     $ 3.89725030D+03, 3.84482020D+03, 3.79254950D+03, 3.74044090D+03,
     $ 3.68849660D+03/
      data ( FUPO( 20,J,1),J=1,13) /
     $ 5.172D-08, 1.565D-07, 3.149D-07, 5.274D-07, 7.938D-07, 1.113D-06,
     $ 1.483D-06, 1.903D-06, 2.371D-06, 2.885D-06, 3.444D-06, 4.046D-06,
     $ 4.705D-06/
      data (WNDNO( 20,J,1),J=1,13) /
     $ 4.17005510D+03, 4.11786200D+03, 4.06580220D+03, 4.01387930D+03,
     $ 3.96209680D+03, 3.91045800D+03, 3.85896630D+03, 3.80762500D+03,
     $ 3.75643730D+03, 3.70540600D+03, 3.65453410D+03, 3.60382390D+03,
     $ 3.55327790D+03/
      data ( FDNO( 20,J,1),J=1,13) /
     $ 3.880D-08, 1.180D-07, 2.388D-07, 4.012D-07, 6.054D-07, 8.512D-07,
     $ 1.138D-06, 1.466D-06, 1.832D-06, 2.237D-06, 2.678D-06, 3.159D-06,
     $ 3.668D-06/
      data (WNUPO( 20,J,2),J=1,13) /
     $ 4.22641860D+03, 4.17519740D+03, 4.12410070D+03, 4.07313180D+03,
     $ 4.02229390D+03, 3.97159000D+03, 3.92102330D+03, 3.87059690D+03,
     $ 3.82031350D+03, 3.77017600D+03, 3.72018710D+03, 3.67034900D+03,
     $ 3.62066390D+03/
      data ( FUPO( 20,J,2),J=1,13) /
     $ 4.815D-08, 1.458D-07, 2.933D-07, 4.913D-07, 7.397D-07, 1.037D-06,
     $ 1.383D-06, 1.775D-06, 2.213D-06, 2.695D-06, 3.218D-06, 3.782D-06,
     $ 4.385D-06/
      data (WNDNO( 20,J,2),J=1,13) /
     $ 4.08104720D+03, 4.03113460D+03, 3.98134640D+03, 3.93168590D+03,
     $ 3.88215620D+03, 3.83276050D+03, 3.78350190D+03, 3.73438320D+03,
     $ 3.68540760D+03, 3.63657760D+03, 3.58789600D+03, 3.53936500D+03,
     $ 3.49098680D+03/
      data ( FDNO( 20,J,2),J=1,13) /
     $ 3.632D-08, 1.104D-07, 2.235D-07, 3.756D-07, 5.666D-07, 7.971D-07,
     $ 1.066D-06, 1.373D-06, 1.717D-06, 2.097D-06, 2.512D-06, 2.961D-06,
     $ 3.444D-06/
      data (WNUPO( 21,J,1),J=1,13) /
     $ 4.32440980D+03, 4.27078160D+03, 4.21728690D+03, 4.16392920D+03,
     $ 4.11071200D+03, 4.05763870D+03, 4.00471270D+03, 3.95193720D+03,
     $ 3.89931550D+03, 3.84685060D+03, 3.79454520D+03, 3.74240190D+03,
     $ 3.69042290D+03/
      data ( FUPO( 21,J,1),J=1,13) /
     $ 5.198D-08, 1.573D-07, 3.163D-07, 5.300D-07, 7.976D-07, 1.118D-06,
     $ 1.489D-06, 1.911D-06, 2.381D-06, 2.898D-06, 3.459D-06, 4.063D-06,
     $ 4.722D-06/
      data (WNDNO( 21,J,1),J=1,13) /
     $ 4.16484080D+03, 4.11268270D+03, 4.06065800D+03, 4.00877030D+03,
     $ 3.95702280D+03, 3.90541920D+03, 3.85396260D+03, 3.80265650D+03,
     $ 3.75150400D+03, 3.70050790D+03, 3.64967120D+03, 3.59899630D+03,
     $ 3.54848550D+03/
      data ( FDNO( 21,J,1),J=1,13) /
     $ 3.863D-08, 1.175D-07, 2.379D-07, 3.995D-07, 6.030D-07, 8.479D-07,
     $ 1.134D-06, 1.460D-06, 1.825D-06, 2.229D-06, 2.670D-06, 3.147D-06,
     $ 3.656D-06/
      data (WNUPO( 21,J,2),J=1,13) /
     $ 4.22869230D+03, 4.17743840D+03, 4.12630920D+03, 4.07530770D+03,
     $ 4.02443710D+03, 3.97370070D+03, 3.92310150D+03, 3.87264240D+03,
     $ 3.82232660D+03, 3.77215660D+03, 3.72213520D+03, 3.67226470D+03,
     $ 3.62254710D+03/
      data ( FUPO( 21,J,2),J=1,13) /
     $ 4.839D-08, 1.465D-07, 2.946D-07, 4.937D-07, 7.432D-07, 1.042D-06,
     $ 1.389D-06, 1.783D-06, 2.222D-06, 2.705D-06, 3.232D-06, 3.798D-06,
     $ 4.402D-06/
      data (WNDNO( 21,J,2),J=1,13) /
     $ 4.07609090D+03, 4.02621100D+03, 3.97645560D+03, 3.92682790D+03,
     $ 3.87733110D+03, 3.82796820D+03, 3.77874240D+03, 3.72965670D+03,
     $ 3.68071390D+03, 3.63191680D+03, 3.58326810D+03, 3.53477000D+03,
     $ 3.48642470D+03/
      data ( FDNO( 21,J,2),J=1,13) /
     $ 3.616D-08, 1.100D-07, 2.226D-07, 3.742D-07, 5.644D-07, 7.942D-07,
     $ 1.062D-06, 1.368D-06, 1.711D-06, 2.090D-06, 2.502D-06, 2.951D-06,
     $ 3.433D-06/
      data (WNUPO( 22,J,1),J=1,13) /
     $ 4.32668080D+03, 4.27301770D+03, 4.21948810D+03, 4.16609550D+03,
     $ 4.11284340D+03, 4.05973520D+03, 4.00677440D+03, 3.95396420D+03,
     $ 3.90130770D+03, 3.84880800D+03, 3.79646790D+03, 3.74428980D+03,
     $ 3.69227610D+03/
      data ( FUPO( 22,J,1),J=1,13) /
     $ 5.226D-08, 1.582D-07, 3.181D-07, 5.326D-07, 8.014D-07, 1.123D-06,
     $ 1.496D-06, 1.920D-06, 2.391D-06, 2.909D-06, 3.474D-06, 4.079D-06,
     $ 4.742D-06/
      data (WNDNO( 22,J,1),J=1,13) /
     $ 4.15955950D+03, 4.10743650D+03, 4.05544690D+03, 4.00359430D+03,
     $ 3.95188200D+03, 3.90031350D+03, 3.84889210D+03, 3.79762120D+03,
     $ 3.74650380D+03, 3.69554300D+03, 3.64474150D+03, 3.59410180D+03,
     $ 3.54362620D+03/
      data ( FDNO( 22,J,1),J=1,13) /
     $ 3.847D-08, 1.170D-07, 2.369D-07, 3.980D-07, 6.004D-07, 8.447D-07,
     $ 1.130D-06, 1.455D-06, 1.819D-06, 2.221D-06, 2.660D-06, 3.136D-06,
     $ 3.642D-06/
      data (WNUPO( 22,J,2),J=1,13) /
     $ 4.23089780D+03, 4.17961130D+03, 4.12844940D+03, 4.07741530D+03,
     $ 4.02651220D+03, 3.97574320D+03, 3.92511140D+03, 3.87461980D+03,
     $ 3.82427140D+03, 3.77406900D+03, 3.72401510D+03, 3.67411210D+03,
     $ 3.62436220D+03/
      data ( FUPO( 22,J,2),J=1,13) /
     $ 4.865D-08, 1.473D-07, 2.963D-07, 4.960D-07, 7.467D-07, 1.047D-06,
     $ 1.395D-06, 1.791D-06, 2.232D-06, 2.716D-06, 3.244D-06, 3.812D-06,
     $ 4.421D-06/
      data (WNDNO( 22,J,2),J=1,13) /
     $ 4.07107190D+03, 4.02122480D+03, 3.97150220D+03, 3.92190740D+03,
     $ 3.87244340D+03, 3.82311330D+03, 3.77392040D+03, 3.72486750D+03,
     $ 3.67595760D+03, 3.62719350D+03, 3.57857760D+03, 3.53011250D+03,
     $ 3.48180010D+03/
      data ( FDNO( 22,J,2),J=1,13) /
     $ 3.602D-08, 1.095D-07, 2.218D-07, 3.727D-07, 5.622D-07, 7.911D-07,
     $ 1.058D-06, 1.363D-06, 1.704D-06, 2.082D-06, 2.493D-06, 2.940D-06,
     $ 3.420D-06/
      data (WNUPO( 23,J,1),J=1,13) /
     $ 4.32887850D+03, 4.27518050D+03, 4.22161600D+03, 4.16818850D+03,
     $ 4.11490160D+03, 4.06175860D+03, 4.00876290D+03, 3.95591790D+03,
     $ 3.90322660D+03, 3.85069220D+03, 3.79831730D+03, 3.74610460D+03,
     $ 3.69405620D+03/
      data ( FUPO( 23,J,1),J=1,13) /
     $ 5.256D-08, 1.590D-07, 3.198D-07, 5.351D-07, 8.053D-07, 1.128D-06,
     $ 1.503D-06, 1.928D-06, 2.402D-06, 2.922D-06, 3.489D-06, 4.098D-06,
     $ 4.762D-06/
      data (WNDNO( 23,J,1),J=1,13) /
     $ 4.15421140D+03, 4.10212350D+03, 4.05016900D+03, 3.99835150D+03,
     $ 3.94667430D+03, 3.89514100D+03, 3.84375480D+03, 3.79251900D+03,
     $ 3.74143690D+03, 3.69051130D+03, 3.63974500D+03, 3.58914060D+03,
     $ 3.53870030D+03/
      data ( FDNO( 23,J,1),J=1,13) /
     $ 3.832D-08, 1.165D-07, 2.360D-07, 3.964D-07, 5.981D-07, 8.413D-07,
     $ 1.125D-06, 1.449D-06, 1.812D-06, 2.213D-06, 2.651D-06, 3.123D-06,
     $ 3.628D-06/
      data (WNUPO( 23,J,2),J=1,13) /
     $ 4.23303490D+03, 4.18171580D+03, 4.13052130D+03, 4.07945460D+03,
     $ 4.02851880D+03, 3.97771720D+03, 3.92705290D+03, 3.87652880D+03,
     $ 3.82614800D+03, 3.77591300D+03, 3.72582670D+03, 3.67589120D+03,
     $ 3.62610890D+03/
      data ( FUPO( 23,J,2),J=1,13) /
     $ 4.891D-08, 1.480D-07, 2.978D-07, 4.984D-07, 7.504D-07, 1.052D-06,
     $ 1.401D-06, 1.799D-06, 2.242D-06, 2.729D-06, 3.258D-06, 3.829D-06,
     $ 4.438D-06/
      data (WNDNO( 23,J,2),J=1,13) /
     $ 4.06599040D+03, 4.01617610D+03, 3.96648640D+03, 3.91692430D+03,
     $ 3.86749310D+03, 3.81819600D+03, 3.76903590D+03, 3.72001590D+03,
     $ 3.67113890D+03, 3.62240770D+03, 3.57382480D+03, 3.52539260D+03,
     $ 3.47711310D+03/
      data ( FDNO( 23,J,2),J=1,13) /
     $ 3.587D-08, 1.091D-07, 2.209D-07, 3.713D-07, 5.600D-07, 7.879D-07,
     $ 1.054D-06, 1.357D-06, 1.698D-06, 2.074D-06, 2.485D-06, 2.930D-06,
     $ 3.409D-06/
      data (WNUPO( 24,J,1),J=1,13) /
     $ 4.33100290D+03, 4.27726990D+03, 4.22367060D+03, 4.17020820D+03,
     $ 4.11688640D+03, 4.06370850D+03, 4.01067800D+03, 3.95779820D+03,
     $ 3.90507220D+03, 3.85250310D+03, 3.80009350D+03, 3.74784600D+03,
     $ 3.69576300D+03/
      data ( FUPO( 24,J,1),J=1,13) /
     $ 5.285D-08, 1.599D-07, 3.213D-07, 5.379D-07, 8.096D-07, 1.134D-06,
     $ 1.510D-06, 1.937D-06, 2.413D-06, 2.936D-06, 3.504D-06, 4.115D-06,
     $ 4.781D-06/
      data (WNDNO( 24,J,1),J=1,13) /
     $ 4.14879670D+03, 4.09674390D+03, 4.04482450D+03, 3.99304210D+03,
     $ 3.94140010D+03, 3.88990190D+03, 3.83855080D+03, 3.78735030D+03,
     $ 3.73630340D+03, 3.68541300D+03, 3.63468200D+03, 3.58411280D+03,
     $ 3.53370780D+03/
      data ( FDNO( 24,J,1),J=1,13) /
     $ 3.814D-08, 1.160D-07, 2.349D-07, 3.949D-07, 5.957D-07, 8.380D-07,
     $ 1.121D-06, 1.443D-06, 1.805D-06, 2.204D-06, 2.641D-06, 3.112D-06,
     $ 3.614D-06/
      data (WNUPO( 24,J,2),J=1,13) /
     $ 4.23510350D+03, 4.18375180D+03, 4.13252460D+03, 4.08142530D+03,
     $ 4.03045700D+03, 3.97962280D+03, 3.92892600D+03, 3.87836940D+03,
     $ 3.82795600D+03, 3.77768860D+03, 3.72756980D+03, 3.67760190D+03,
     $ 3.62778710D+03/
      data ( FUPO( 24,J,2),J=1,13) /
     $ 4.919D-08, 1.488D-07, 2.991D-07, 5.011D-07, 7.540D-07, 1.057D-06,
     $ 1.408D-06, 1.807D-06, 2.251D-06, 2.740D-06, 3.272D-06, 3.845D-06,
     $ 4.455D-06/
      data (WNDNO( 24,J,2),J=1,13) /
     $ 4.06084660D+03, 4.01106510D+03, 3.96140820D+03, 3.91187900D+03,
     $ 3.86248060D+03, 3.81321630D+03, 3.76408910D+03, 3.71510200D+03,
     $ 3.66625790D+03, 3.61755960D+03, 3.56900960D+03, 3.52061030D+03,
     $ 3.47236390D+03/
      data ( FDNO( 24,J,2),J=1,13) /
     $ 3.571D-08, 1.086D-07, 2.200D-07, 3.698D-07, 5.578D-07, 7.849D-07,
     $ 1.050D-06, 1.352D-06, 1.692D-06, 2.067D-06, 2.476D-06, 2.920D-06,
     $ 3.396D-06/
      data (WNUPO( 25,J,1),J=1,13) /
     $ 4.33305370D+03, 4.27928590D+03, 4.22565160D+03, 4.17215440D+03,
     $ 4.11879770D+03, 4.06558500D+03, 4.01251970D+03, 3.95960510D+03,
     $ 3.90684430D+03, 3.85424040D+03, 3.80179610D+03, 3.74951400D+03,
     $ 3.69739620D+03/
      data ( FUPO( 25,J,1),J=1,13) /
     $ 5.314D-08, 1.608D-07, 3.231D-07, 5.408D-07, 8.137D-07, 1.140D-06,
     $ 1.518D-06, 1.947D-06, 2.424D-06, 2.949D-06, 3.520D-06, 4.133D-06,
     $ 4.802D-06/
      data (WNDNO( 25,J,1),J=1,13) /
     $ 4.14331550D+03, 4.09129780D+03, 4.03941350D+03, 3.98766620D+03,
     $ 3.93605930D+03, 3.88459630D+03, 3.83328040D+03, 3.78211510D+03,
     $ 3.73110340D+03, 3.68024830D+03, 3.62955250D+03, 3.57901860D+03,
     $ 3.52864880D+03/
      data ( FDNO( 25,J,1),J=1,13) /
     $ 3.798D-08, 1.155D-07, 2.339D-07, 3.931D-07, 5.931D-07, 8.345D-07,
     $ 1.116D-06, 1.437D-06, 1.797D-06, 2.196D-06, 2.629D-06, 3.100D-06,
     $ 3.600D-06/
      data (WNUPO( 25,J,2),J=1,13) /
     $ 4.23710350D+03, 4.18571910D+03, 4.13445930D+03, 4.08332740D+03,
     $ 4.03232650D+03, 3.98145980D+03, 3.93073040D+03, 3.88014130D+03,
     $ 3.82969540D+03, 3.77939550D+03, 3.72924430D+03, 3.67924400D+03,
     $ 3.62939670D+03/
      data ( FUPO( 25,J,2),J=1,13) /
     $ 4.945D-08, 1.496D-07, 3.008D-07, 5.035D-07, 7.578D-07, 1.062D-06,
     $ 1.415D-06, 1.816D-06, 2.261D-06, 2.753D-06, 3.286D-06, 3.861D-06,
     $ 4.476D-06/
      data (WNDNO( 25,J,2),J=1,13) /
     $ 4.05564060D+03, 4.00589190D+03, 3.95626780D+03, 3.90677140D+03,
     $ 3.85740580D+03, 3.80817440D+03, 3.75908000D+03, 3.71012580D+03,
     $ 3.66131470D+03, 3.61264930D+03, 3.56413230D+03, 3.51576590D+03,
     $ 3.46755240D+03/
      data ( FDNO( 25,J,2),J=1,13) /
     $ 3.557D-08, 1.082D-07, 2.190D-07, 3.682D-07, 5.557D-07, 7.818D-07,
     $ 1.046D-06, 1.347D-06, 1.685D-06, 2.059D-06, 2.467D-06, 2.910D-06,
     $ 3.384D-06/
      data (WNUPO( 26,J,1),J=1,13) /
     $ 4.33503090D+03, 4.28122810D+03, 4.22755900D+03, 4.17402680D+03,
     $ 4.12063530D+03, 4.06738780D+03, 4.01428770D+03, 3.96133830D+03,
     $ 3.90854280D+03, 3.85590410D+03, 3.80342510D+03, 3.75110830D+03,
     $ 3.69895590D+03/
      data ( FUPO( 26,J,1),J=1,13) /
     $ 5.345D-08, 1.617D-07, 3.249D-07, 5.437D-07, 8.178D-07, 1.145D-06,
     $ 1.525D-06, 1.956D-06, 2.435D-06, 2.963D-06, 3.535D-06, 4.151D-06,
     $ 4.824D-06/
      data (WNDNO( 26,J,1),J=1,13) /
     $ 4.13776790D+03, 4.08578530D+03, 4.03393620D+03, 3.98222400D+03,
     $ 3.93065220D+03, 3.87922440D+03, 3.82794370D+03, 3.77681360D+03,
     $ 3.72583710D+03, 3.67501720D+03, 3.62435680D+03, 3.57385810D+03,
     $ 3.52352360D+03/
      data ( FDNO( 26,J,1),J=1,13) /
     $ 3.781D-08, 1.150D-07, 2.330D-07, 3.915D-07, 5.908D-07, 8.311D-07,
     $ 1.112D-06, 1.432D-06, 1.790D-06, 2.187D-06, 2.621D-06, 3.089D-06,
     $ 3.587D-06/
      data (WNUPO( 26,J,2),J=1,13) /
     $ 4.23903460D+03, 4.18761760D+03, 4.13632530D+03, 4.08516080D+03,
     $ 4.03412730D+03, 3.98322800D+03, 3.93246600D+03, 3.88184440D+03,
     $ 3.83136610D+03, 3.78103370D+03, 3.73085000D+03, 3.68081730D+03,
     $ 3.63093760D+03/
      data ( FUPO( 26,J,2),J=1,13) /
     $ 4.975D-08, 1.504D-07, 3.024D-07, 5.061D-07, 7.616D-07, 1.067D-06,
     $ 1.422D-06, 1.824D-06, 2.273D-06, 2.765D-06, 3.302D-06, 3.878D-06,
     $ 4.494D-06/
      data (WNDNO( 26,J,2),J=1,13) /
     $ 4.05037250D+03, 4.00065660D+03, 3.95106530D+03, 3.90160170D+03,
     $ 3.85226900D+03, 3.80307040D+03, 3.75400900D+03, 3.70508770D+03,
     $ 3.65630940D+03, 3.60767700D+03, 3.55919290D+03, 3.51085950D+03,
     $ 3.46267900D+03/
      data ( FDNO( 26,J,2),J=1,13) /
     $ 3.542D-08, 1.077D-07, 2.181D-07, 3.668D-07, 5.534D-07, 7.785D-07,
     $ 1.042D-06, 1.342D-06, 1.678D-06, 2.051D-06, 2.457D-06, 2.898D-06,
     $ 3.372D-06/
      data (WNUPO( 27,J,1),J=1,13) /
     $ 4.33693420D+03, 4.28309660D+03, 4.22939250D+03, 4.17582550D+03,
     $ 4.12239910D+03, 4.06911670D+03, 4.01598180D+03, 3.96299770D+03,
     $ 3.91016740D+03, 3.85749400D+03, 3.80498030D+03, 3.75262880D+03,
     $ 3.70044170D+03/
      data ( FUPO( 27,J,1),J=1,13) /
     $ 5.377D-08, 1.626D-07, 3.266D-07, 5.466D-07, 8.223D-07, 1.151D-06,
     $ 1.533D-06, 1.966D-06, 2.447D-06, 2.977D-06, 3.551D-06, 4.170D-06,
     $ 4.845D-06/
      data (WNDNO( 27,J,1),J=1,13) /
     $ 4.13215420D+03, 4.08020670D+03, 4.02839260D+03, 3.97671560D+03,
     $ 3.92517900D+03, 3.87378620D+03, 3.82254080D+03, 3.77144590D+03,
     $ 3.72050460D+03, 3.66972000D+03, 3.61909480D+03, 3.56863150D+03,
     $ 3.51833230D+03/
      data ( FDNO( 27,J,1),J=1,13) /
     $ 3.765D-08, 1.145D-07, 2.320D-07, 3.898D-07, 5.882D-07, 8.276D-07,
     $ 1.107D-06, 1.426D-06, 1.783D-06, 2.178D-06, 2.609D-06, 3.076D-06,
     $ 3.573D-06/
      data (WNUPO( 27,J,2),J=1,13) /
     $ 4.24089690D+03, 4.18944730D+03, 4.13812230D+03, 4.08692520D+03,
     $ 4.03585910D+03, 3.98492730D+03, 3.93413280D+03, 3.88347870D+03,
     $ 3.83296780D+03, 3.78260300D+03, 3.73238690D+03, 3.68232170D+03,
     $ 3.63240970D+03/
      data ( FUPO( 27,J,2),J=1,13) /
     $ 5.002D-08, 1.513D-07, 3.040D-07, 5.089D-07, 7.657D-07, 1.072D-06,
     $ 1.428D-06, 1.833D-06, 2.283D-06, 2.777D-06, 3.315D-06, 3.894D-06,
     $ 4.513D-06/
      data (WNDNO( 27,J,2),J=1,13) /
     $ 4.04504240D+03, 3.99535940D+03, 3.94580090D+03, 3.89637010D+03,
     $ 3.84707030D+03, 3.79790450D+03, 3.74887590D+03, 3.69998750D+03,
     $ 3.65124220D+03, 3.60264270D+03, 3.55419160D+03, 3.50589120D+03,
     $ 3.45774370D+03/
      data ( FDNO( 27,J,2),J=1,13) /
     $ 3.527D-08, 1.073D-07, 2.173D-07, 3.653D-07, 5.511D-07, 7.755D-07,
     $ 1.037D-06, 1.336D-06, 1.672D-06, 2.044D-06, 2.447D-06, 2.887D-06,
     $ 3.358D-06/
      data (WNUPO( 28,J,1),J=1,13) /
     $ 4.33876360D+03, 4.28489110D+03, 4.23115210D+03, 4.17755020D+03,
     $ 4.12408900D+03, 4.07077180D+03, 4.01760200D+03, 3.96458310D+03,
     $ 3.91171810D+03, 3.85901000D+03, 3.80646160D+03, 3.75407540D+03,
     $ 3.70185370D+03/
      data ( FUPO( 28,J,1),J=1,13) /
     $ 5.409D-08, 1.635D-07, 3.285D-07, 5.496D-07, 8.265D-07, 1.157D-06,
     $ 1.541D-06, 1.976D-06, 2.460D-06, 2.991D-06, 3.569D-06, 4.189D-06,
     $ 4.867D-06/
      data (WNDNO( 28,J,1),J=1,13) /
     $ 4.12647440D+03, 4.07456200D+03, 4.02278300D+03, 3.97114110D+03,
     $ 3.91963960D+03, 3.86828210D+03, 3.81707180D+03, 3.76601210D+03,
     $ 3.71510620D+03, 3.66435680D+03, 3.61376690D+03, 3.56333890D+03,
     $ 3.51307500D+03/
      data ( FDNO( 28,J,1),J=1,13) /
     $ 3.749D-08, 1.140D-07, 2.311D-07, 3.882D-07, 5.858D-07, 8.242D-07,
     $ 1.102D-06, 1.420D-06, 1.775D-06, 2.170D-06, 2.600D-06, 3.065D-06,
     $ 3.558D-06/
      data (WNUPO( 28,J,2),J=1,13) /
     $ 4.24269020D+03, 4.19120790D+03, 4.13985030D+03, 4.08862060D+03,
     $ 4.03752190D+03, 3.98655750D+03, 3.93573050D+03, 3.88504390D+03,
     $ 3.83450050D+03, 3.78410330D+03, 3.73385470D+03, 3.68375710D+03,
     $ 3.63381270D+03/
      data ( FUPO( 28,J,2),J=1,13) /
     $ 5.031D-08, 1.521D-07, 3.056D-07, 5.115D-07, 7.696D-07, 1.078D-06,
     $ 1.436D-06, 1.842D-06, 2.295D-06, 2.791D-06, 3.331D-06, 3.913D-06,
     $ 4.533D-06/
      data (WNDNO( 28,J,2),J=1,13) /
     $ 4.03965060D+03, 3.99000030D+03, 3.94047460D+03, 3.89107670D+03,
     $ 3.84180970D+03, 3.79267680D+03, 3.74368110D+03, 3.69482560D+03,
     $ 3.64611320D+03, 3.59754670D+03, 3.54912860D+03, 3.50086120D+03,
     $ 3.45274660D+03/
      data ( FDNO( 28,J,2),J=1,13) /
     $ 3.512D-08, 1.068D-07, 2.163D-07, 3.637D-07, 5.488D-07, 7.723D-07,
     $ 1.033D-06, 1.331D-06, 1.665D-06, 2.035D-06, 2.439D-06, 2.875D-06,
     $ 3.346D-06/
      data (WNUPO( 29,J,1),J=1,13) /
     $ 4.34051890D+03, 4.28661150D+03, 4.23283760D+03, 4.17920080D+03,
     $ 4.12570470D+03, 4.07235270D+03, 4.01914810D+03, 3.96609440D+03,
     $ 3.91319470D+03, 3.86045190D+03, 3.80786880D+03, 3.75544790D+03,
     $ 3.70319150D+03/
      data ( FUPO( 29,J,1),J=1,13) /
     $ 5.442D-08, 1.645D-07, 3.304D-07, 5.526D-07, 8.311D-07, 1.163D-06,
     $ 1.549D-06, 1.986D-06, 2.472D-06, 3.005D-06, 3.586D-06, 4.209D-06,
     $ 4.889D-06/
      data (WNDNO( 29,J,1),J=1,13) /
     $ 4.12072870D+03, 4.06885140D+03, 4.01710750D+03, 3.96550070D+03,
     $ 3.91403440D+03, 3.86271200D+03, 3.81153700D+03, 3.76051250D+03,
     $ 3.70964180D+03, 3.65892770D+03, 3.60837310D+03, 3.55798040D+03,
     $ 3.50775180D+03/
      data ( FDNO( 29,J,1),J=1,13) /
     $ 3.732D-08, 1.135D-07, 2.300D-07, 3.866D-07, 5.834D-07, 8.207D-07,
     $ 1.098D-06, 1.414D-06, 1.769D-06, 2.161D-06, 2.590D-06, 3.053D-06,
     $ 3.544D-06/
      data (WNUPO( 29,J,2),J=1,13) /
     $ 4.24441420D+03, 4.19289930D+03, 4.14150910D+03, 4.09024680D+03,
     $ 4.03911560D+03, 3.98811860D+03, 3.93725900D+03, 3.88653990D+03,
     $ 3.83596410D+03, 3.78553440D+03, 3.73525340D+03, 3.68512340D+03,
     $ 3.63514650D+03/
      data ( FUPO( 29,J,2),J=1,13) /
     $ 5.061D-08, 1.530D-07, 3.074D-07, 5.142D-07, 7.737D-07, 1.084D-06,
     $ 1.443D-06, 1.851D-06, 2.305D-06, 2.804D-06, 3.347D-06, 3.930D-06,
     $ 4.554D-06/
      data (WNDNO( 29,J,2),J=1,13) /
     $ 4.03419700D+03, 3.98457960D+03, 3.93508670D+03, 3.88572160D+03,
     $ 3.83648740D+03, 3.78738740D+03, 3.73842460D+03, 3.68960200D+03,
     $ 3.64092260D+03, 3.59238900D+03, 3.54400380D+03, 3.49576940D+03,
     $ 3.44768790D+03/
      data ( FDNO( 29,J,2),J=1,13) /
     $ 3.497D-08, 1.064D-07, 2.154D-07, 3.622D-07, 5.464D-07, 7.692D-07,
     $ 1.029D-06, 1.325D-06, 1.659D-06, 2.027D-06, 2.429D-06, 2.864D-06,
     $ 3.334D-06/
      data (WNUPO( 30,J,1),J=1,13) /
     $ 4.34220000D+03, 4.28825760D+03, 4.23444880D+03, 4.18077720D+03,
     $ 4.12724620D+03, 4.07385930D+03, 4.02062000D+03, 3.96753150D+03,
     $ 3.91459700D+03, 3.86181950D+03, 3.80920170D+03, 3.75674620D+03,
     $ 3.70445510D+03/
      data ( FUPO( 30,J,1),J=1,13) /
     $ 5.475D-08, 1.655D-07, 3.322D-07, 5.556D-07, 8.356D-07, 1.170D-06,
     $ 1.557D-06, 1.995D-06, 2.485D-06, 3.020D-06, 3.603D-06, 4.229D-06,
     $ 4.912D-06/
      data (WNDNO( 30,J,1),J=1,13) /
     $ 4.11491720D+03, 4.06307500D+03, 4.01136630D+03, 3.95979460D+03,
     $ 3.90836340D+03, 3.85707620D+03, 3.80593640D+03, 3.75494710D+03,
     $ 3.70411170D+03, 3.65343290D+03, 3.60291360D+03, 3.55255620D+03,
     $ 3.50236290D+03/
      data ( FDNO( 30,J,1),J=1,13) /
     $ 3.716D-08, 1.130D-07, 2.290D-07, 3.849D-07, 5.808D-07, 8.172D-07,
     $ 1.093D-06, 1.409D-06, 1.762D-06, 2.152D-06, 2.579D-06, 3.041D-06,
     $ 3.530D-06/
      data (WNUPO( 30,J,2),J=1,13) /
     $ 4.24606900D+03, 4.19452150D+03, 4.14309860D+03, 4.09180370D+03,
     $ 4.04063990D+03, 3.98961040D+03, 3.93871830D+03, 3.88796660D+03,
     $ 3.83735830D+03, 3.78689620D+03, 3.73658270D+03, 3.68642040D+03,
     $ 3.63641110D+03/
      data ( FUPO( 30,J,2),J=1,13) /
     $ 5.090D-08, 1.539D-07, 3.090D-07, 5.171D-07, 7.778D-07, 1.089D-06,
     $ 1.450D-06, 1.861D-06, 2.317D-06, 2.817D-06, 3.363D-06, 3.949D-06,
     $ 4.575D-06/
      data (WNDNO( 30,J,2),J=1,13) /
     $ 4.02868190D+03, 3.97909730D+03, 3.92963720D+03, 3.88030490D+03,
     $ 3.83110360D+03, 3.78203650D+03, 3.73310660D+03, 3.68431690D+03,
     $ 3.63567040D+03, 3.58716980D+03, 3.53881760D+03, 3.49061620D+03,
     $ 3.44256760D+03/
      data ( FDNO( 30,J,2),J=1,13) /
     $ 3.482D-08, 1.059D-07, 2.146D-07, 3.607D-07, 5.443D-07, 7.659D-07,
     $ 1.025D-06, 1.320D-06, 1.652D-06, 2.018D-06, 2.420D-06, 2.854D-06,
     $ 3.321D-06/
      data (WNUPO( 31,J,1),J=1,13) /
     $ 4.34380660D+03, 4.28982930D+03, 4.23598560D+03, 4.18227910D+03,
     $ 4.12871330D+03, 4.07529160D+03, 4.02201750D+03, 3.96889420D+03,
     $ 3.91592500D+03, 3.86311270D+03, 3.81046030D+03, 3.75797010D+03,
     $ 3.70564430D+03/
      data ( FUPO( 31,J,1),J=1,13) /
     $ 5.508D-08, 1.664D-07, 3.341D-07, 5.589D-07, 8.402D-07, 1.176D-06,
     $ 1.565D-06, 2.007D-06, 2.497D-06, 3.036D-06, 3.620D-06, 4.249D-06,
     $ 4.934D-06/
      data (WNDNO( 31,J,1),J=1,13) /
     $ 4.10904010D+03, 4.05723300D+03, 4.00555940D+03, 3.95402280D+03,
     $ 3.90262680D+03, 3.85137480D+03, 3.80027020D+03, 3.74931620D+03,
     $ 3.69851590D+03, 3.64787250D+03, 3.59738840D+03, 3.54706640D+03,
     $ 3.49690840D+03/
      data ( FDNO( 31,J,1),J=1,13) /
     $ 3.700D-08, 1.125D-07, 2.281D-07, 3.833D-07, 5.784D-07, 8.138D-07,
     $ 1.089D-06, 1.403D-06, 1.754D-06, 2.143D-06, 2.568D-06, 3.029D-06,
     $ 3.516D-06/
      data (WNUPO( 31,J,2),J=1,13) /
     $ 4.24765430D+03, 4.19607420D+03, 4.14461870D+03, 4.09329120D+03,
     $ 4.04209480D+03, 3.99103270D+03, 3.94010810D+03, 3.88932390D+03,
     $ 3.83868320D+03, 3.78818860D+03, 3.73784270D+03, 3.68764790D+03,
     $ 3.63760620D+03/
      data ( FUPO( 31,J,2),J=1,13) /
     $ 5.121D-08, 1.548D-07, 3.108D-07, 5.200D-07, 7.820D-07, 1.095D-06,
     $ 1.458D-06, 1.870D-06, 2.328D-06, 2.831D-06, 3.379D-06, 3.967D-06,
     $ 4.595D-06/
      data (WNDNO( 31,J,2),J=1,13) /
     $ 4.02310540D+03, 3.97355360D+03, 3.92412630D+03, 3.87482680D+03,
     $ 3.82565840D+03, 3.77662410D+03, 3.72772710D+03, 3.67897040D+03,
     $ 3.63035680D+03, 3.58188920D+03, 3.53357000D+03, 3.48540160D+03,
     $ 3.43738600D+03/
      data ( FDNO( 31,J,2),J=1,13) /
     $ 3.467D-08, 1.054D-07, 2.137D-07, 3.592D-07, 5.419D-07, 7.627D-07,
     $ 1.021D-06, 1.315D-06, 1.646D-06, 2.011D-06, 2.410D-06, 2.843D-06,
     $ 3.308D-06/
      data (WNUPO( 32,J,1),J=1,13) /
     $ 4.34533870D+03, 4.29132650D+03, 4.23744790D+03, 4.18370650D+03,
     $ 4.13010580D+03, 4.07664930D+03, 4.02334040D+03, 3.97018230D+03,
     $ 3.91717840D+03, 3.86433140D+03, 3.81164430D+03, 3.75911940D+03,
     $ 3.70675900D+03/
      data ( FUPO( 32,J,1),J=1,13) /
     $ 5.543D-08, 1.675D-07, 3.360D-07, 5.619D-07, 8.449D-07, 1.182D-06,
     $ 1.573D-06, 2.016D-06, 2.510D-06, 3.051D-06, 3.638D-06, 4.270D-06,
     $ 4.957D-06/
      data (WNDNO( 32,J,1),J=1,13) /
     $ 4.10309750D+03, 4.05132550D+03, 3.99968700D+03, 3.94818560D+03,
     $ 3.89682470D+03, 3.84560790D+03, 3.79453850D+03, 3.74361970D+03,
     $ 3.69285480D+03, 3.64224660D+03, 3.59179790D+03, 3.54151110D+03,
     $ 3.49138850D+03/
      data ( FDNO( 32,J,1),J=1,13) /
     $ 3.683D-08, 1.120D-07, 2.271D-07, 3.817D-07, 5.758D-07, 8.103D-07,
     $ 1.084D-06, 1.397D-06, 1.748D-06, 2.135D-06, 2.558D-06, 3.017D-06,
     $ 3.502D-06/
      data (WNUPO( 32,J,2),J=1,13) /
     $ 4.24917000D+03, 4.19755730D+03, 4.14606920D+03, 4.09470900D+03,
     $ 4.04348010D+03, 3.99238540D+03, 3.94142830D+03, 3.89061160D+03,
     $ 3.83993840D+03, 3.78941140D+03, 3.73903310D+03, 3.68880590D+03,
     $ 3.63873180D+03/
      data ( FUPO( 32,J,2),J=1,13) /
     $ 5.152D-08, 1.557D-07, 3.125D-07, 5.229D-07, 7.862D-07, 1.101D-06,
     $ 1.465D-06, 1.879D-06, 2.340D-06, 2.844D-06, 3.395D-06, 3.986D-06,
     $ 4.616D-06/
      data (WNDNO( 32,J,2),J=1,13) /
     $ 4.01746760D+03, 3.96794860D+03, 3.91855410D+03, 3.86928750D+03,
     $ 3.82015190D+03, 3.77115050D+03, 3.72228640D+03, 3.67356260D+03,
     $ 3.62498200D+03, 3.57654730D+03, 3.52826110D+03, 3.48012570D+03,
     $ 3.43214320D+03/
      data ( FDNO( 32,J,2),J=1,13) /
     $ 3.452D-08, 1.050D-07, 2.128D-07, 3.577D-07, 5.397D-07, 7.595D-07,
     $ 1.016D-06, 1.309D-06, 1.638D-06, 2.003D-06, 2.400D-06, 2.832D-06,
     $ 3.295D-06/
      data (WNUPO( 33,J,1),J=1,13) /
     $ 4.34679620D+03, 4.29274900D+03, 4.23883550D+03, 4.18505920D+03,
     $ 4.13142370D+03, 4.07793230D+03, 4.02458860D+03, 3.97139580D+03,
     $ 3.91835710D+03, 3.86547540D+03, 3.81275360D+03, 3.76019410D+03,
     $ 3.70779900D+03/
      data ( FUPO( 33,J,1),J=1,13) /
     $ 5.577D-08, 1.685D-07, 3.380D-07, 5.652D-07, 8.497D-07, 1.189D-06,
     $ 1.582D-06, 2.028D-06, 2.522D-06, 3.066D-06, 3.655D-06, 4.289D-06,
     $ 4.980D-06/
      data (WNDNO( 33,J,1),J=1,13) /
     $ 4.09708970D+03, 4.04535270D+03, 3.99374930D+03, 3.94228300D+03,
     $ 3.89095730D+03, 3.83977570D+03, 3.78874140D+03, 3.73785790D+03,
     $ 3.68712830D+03, 3.63655540D+03, 3.58614200D+03, 3.53589060D+03,
     $ 3.48580330D+03/
      data ( FDNO( 33,J,1),J=1,13) /
     $ 3.667D-08, 1.116D-07, 2.261D-07, 3.801D-07, 5.734D-07, 8.070D-07,
     $ 1.080D-06, 1.391D-06, 1.740D-06, 2.127D-06, 2.548D-06, 3.006D-06,
     $ 3.487D-06/
      data (WNUPO( 33,J,2),J=1,13) /
     $ 4.25061610D+03, 4.19897070D+03, 4.14745000D+03, 4.09605720D+03,
     $ 4.04479570D+03, 3.99366850D+03, 3.94267880D+03, 3.89182960D+03,
     $ 3.84112390D+03, 3.79056440D+03, 3.74015370D+03, 3.68989410D+03,
     $ 3.63978770D+03/
      data ( FUPO( 33,J,2),J=1,13) /
     $ 5.183D-08, 1.566D-07, 3.143D-07, 5.257D-07, 7.906D-07, 1.107D-06,
     $ 1.473D-06, 1.889D-06, 2.351D-06, 2.858D-06, 3.411D-06, 4.005D-06,
     $ 4.638D-06/
      data (WNDNO( 33,J,2),J=1,13) /
     $ 4.01176870D+03, 3.96228240D+03, 3.91292070D+03, 3.86368690D+03,
     $ 3.81458420D+03, 3.76561570D+03, 3.71678450D+03, 3.66809360D+03,
     $ 3.61954600D+03, 3.57114430D+03, 3.52289110D+03, 3.47478870D+03,
     $ 3.42683920D+03/
      data ( FDNO( 33,J,2),J=1,13) /
     $ 3.437D-08, 1.046D-07, 2.119D-07, 3.563D-07, 5.375D-07, 7.564D-07,
     $ 1.012D-06, 1.304D-06, 1.633D-06, 1.994D-06, 2.391D-06, 2.821D-06,
     $ 3.284D-06/
      data (WNUPO( 34,J,1),J=1,13) /
     $ 4.34817870D+03, 4.29409670D+03, 4.24014830D+03, 4.18633710D+03,
     $ 4.13266670D+03, 4.07914050D+03, 4.02576190D+03, 3.97253440D+03,
     $ 3.91946090D+03, 3.86654460D+03, 3.81378800D+03, 3.76119390D+03,
     $ 3.70876410D+03/
      data ( FUPO( 34,J,1),J=1,13) /
     $ 5.612D-08, 1.696D-07, 3.400D-07, 5.685D-07, 8.545D-07, 1.195D-06,
     $ 1.590D-06, 2.037D-06, 2.536D-06, 3.082D-06, 3.673D-06, 4.310D-06,
     $ 5.004D-06/
      data (WNDNO( 34,J,1),J=1,13) /
     $ 4.09101660D+03, 4.03931470D+03, 3.98774640D+03, 3.93631530D+03,
     $ 3.88502470D+03, 3.83387820D+03, 3.78287920D+03, 3.73203100D+03,
     $ 3.68133660D+03, 3.63079900D+03, 3.58042090D+03, 3.53020490D+03,
     $ 3.48015290D+03/
      data ( FDNO( 34,J,1),J=1,13) /
     $ 3.651D-08, 1.111D-07, 2.251D-07, 3.786D-07, 5.710D-07, 8.035D-07,
     $ 1.075D-06, 1.385D-06, 1.733D-06, 2.117D-06, 2.538D-06, 2.993D-06,
     $ 3.472D-06/
      data (WNUPO( 34,J,2),J=1,13) /
     $ 4.25199230D+03, 4.20031420D+03, 4.14876090D+03, 4.09733550D+03,
     $ 4.04604140D+03, 3.99488160D+03, 3.94385940D+03, 3.89297780D+03,
     $ 3.84223960D+03, 3.79164770D+03, 3.74120450D+03, 3.69091250D+03,
     $ 3.64077370D+03/
      data ( FUPO( 34,J,2),J=1,13) /
     $ 5.215D-08, 1.575D-07, 3.161D-07, 5.287D-07, 7.949D-07, 1.113D-06,
     $ 1.481D-06, 1.899D-06, 2.363D-06, 2.873D-06, 3.427D-06, 4.024D-06,
     $ 4.660D-06/
      data (WNDNO( 34,J,2),J=1,13) /
     $ 4.00600870D+03, 3.95655520D+03, 3.90722640D+03, 3.85802540D+03,
     $ 3.80895550D+03, 3.76001980D+03, 3.71122160D+03, 3.66256360D+03,
     $ 3.61404900D+03, 3.56568030D+03, 3.51746010D+03, 3.46939080D+03,
     $ 3.42147430D+03/
      data ( FDNO( 34,J,2),J=1,13) /
     $ 3.423D-08, 1.041D-07, 2.110D-07, 3.548D-07, 5.352D-07, 7.533D-07,
     $ 1.008D-06, 1.299D-06, 1.626D-06, 1.987D-06, 2.381D-06, 2.810D-06,
     $ 3.271D-06/
      data (WNUPO( 35,J,1),J=1,13) /
     $ 4.34948640D+03, 4.29536940D+03, 4.24138610D+03, 4.18754000D+03,
     $ 4.13383470D+03, 4.08027360D+03, 4.02686030D+03, 3.97359790D+03,
     $ 3.92048980D+03, 3.86753870D+03, 3.81474750D+03, 3.76211860D+03,
     $ 3.70965430D+03/
      data ( FUPO( 35,J,1),J=1,13) /
     $ 5.646D-08, 1.706D-07, 3.420D-07, 5.717D-07, 8.593D-07, 1.202D-06,
     $ 1.599D-06, 2.048D-06, 2.548D-06, 3.097D-06, 3.693D-06, 4.332D-06,
     $ 5.028D-06/
      data (WNDNO( 35,J,1),J=1,13) /
     $ 4.08487850D+03, 4.03321170D+03, 3.98167850D+03, 3.93028250D+03,
     $ 3.87902700D+03, 3.82791570D+03, 3.77695200D+03, 3.72613900D+03,
     $ 3.67547980D+03, 3.62497760D+03, 3.57463490D+03, 3.52445410D+03,
     $ 3.47443760D+03/
      data ( FDNO( 35,J,1),J=1,13) /
     $ 3.635D-08, 1.106D-07, 2.242D-07, 3.769D-07, 5.686D-07, 8.001D-07,
     $ 1.071D-06, 1.380D-06, 1.725D-06, 2.108D-06, 2.528D-06, 2.982D-06,
     $ 3.458D-06/
      data (WNUPO( 35,J,2),J=1,13) /
     $ 4.25329850D+03, 4.20158780D+03, 4.15000190D+03, 4.09854390D+03,
     $ 4.04721720D+03, 3.99602480D+03, 3.94497010D+03, 3.89405590D+03,
     $ 3.84328530D+03, 3.79266090D+03, 3.74218530D+03, 3.69186090D+03,
     $ 3.64168970D+03/
      data ( FUPO( 35,J,2),J=1,13) /
     $ 5.246D-08, 1.584D-07, 3.180D-07, 5.317D-07, 7.993D-07, 1.119D-06,
     $ 1.488D-06, 1.909D-06, 2.375D-06, 2.887D-06, 3.443D-06, 4.042D-06,
     $ 4.681D-06/
      data (WNDNO( 35,J,2),J=1,13) /
     $ 4.00018790D+03, 3.95076720D+03, 3.90147110D+03, 3.85230290D+03,
     $ 3.80326590D+03, 3.75436310D+03, 3.70559780D+03, 3.65697280D+03,
     $ 3.60849110D+03, 3.56015540D+03, 3.51196820D+03, 3.46393190D+03,
     $ 3.41604850D+03/
      data ( FDNO( 35,J,2),J=1,13) /
     $ 3.408D-08, 1.037D-07, 2.101D-07, 3.532D-07, 5.330D-07, 7.501D-07,
     $ 1.004D-06, 1.293D-06, 1.620D-06, 1.979D-06, 2.372D-06, 2.799D-06,
     $ 3.258D-06/
      data (WNUPO( 36,J,1),J=1,13) /
     $ 4.35071890D+03, 4.29656690D+03, 4.24254870D+03, 4.18866770D+03,
     $ 4.13492750D+03, 4.08133170D+03, 4.02788350D+03, 3.97458640D+03,
     $ 3.92144350D+03, 3.86845770D+03, 3.81563180D+03, 3.76296830D+03,
     $ 3.71046930D+03/
      data ( FUPO( 36,J,1),J=1,13) /
     $ 5.683D-08, 1.715D-07, 3.441D-07, 5.751D-07, 8.642D-07, 1.209D-06,
     $ 1.607D-06, 2.059D-06, 2.562D-06, 3.113D-06, 3.711D-06, 4.354D-06,
     $ 5.052D-06/
      data (WNDNO( 36,J,1),J=1,13) /
     $ 4.07867550D+03, 4.02704380D+03, 3.97554570D+03, 3.92418470D+03,
     $ 3.87296450D+03, 3.82188840D+03, 3.77095980D+03, 3.72018200D+03,
     $ 3.66955820D+03, 3.61909130D+03, 3.56878390D+03, 3.51863850D+03,
     $ 3.46865730D+03/
      data ( FDNO( 36,J,1),J=1,13) /
     $ 3.619D-08, 1.101D-07, 2.233D-07, 3.753D-07, 5.662D-07, 7.968D-07,
     $ 1.066D-06, 1.374D-06, 1.719D-06, 2.100D-06, 2.518D-06, 2.970D-06,
     $ 3.444D-06/
      data (WNUPO( 36,J,2),J=1,13) /
     $ 4.25453460D+03, 4.20279130D+03, 4.15117270D+03, 4.09968210D+03,
     $ 4.04832280D+03, 3.99709790D+03, 3.94601060D+03, 3.89506400D+03,
     $ 3.84426080D+03, 3.79360400D+03, 3.74309600D+03, 3.69273920D+03,
     $ 3.64253560D+03/
      data ( FUPO( 36,J,2),J=1,13) /
     $ 5.279D-08, 1.594D-07, 3.199D-07, 5.346D-07, 8.038D-07, 1.125D-06,
     $ 1.497D-06, 1.918D-06, 2.387D-06, 2.901D-06, 3.461D-06, 4.062D-06,
     $ 4.704D-06/
      data (WNDNO( 36,J,2),J=1,13) /
     $ 3.99430620D+03, 3.94491830D+03, 3.89565510D+03, 3.84651970D+03,
     $ 3.79751550D+03, 3.74864570D+03, 3.69991320D+03, 3.65132110D+03,
     $ 3.60287240D+03, 3.55456970D+03, 3.50641560D+03, 3.45841230D+03,
     $ 3.41056190D+03/
      data ( FDNO( 36,J,2),J=1,13) /
     $ 3.393D-08, 1.032D-07, 2.092D-07, 3.518D-07, 5.308D-07, 7.471D-07,
     $ 9.999D-07, 1.288D-06, 1.612D-06, 1.971D-06, 2.363D-06, 2.788D-06,
     $ 3.245D-06/
      data (WNUPO( 37,J,1),J=1,13) /
     $ 4.35187610D+03, 4.29768920D+03, 4.24363610D+03, 4.18972020D+03,
     $ 4.13594510D+03, 4.08231440D+03, 4.02883140D+03, 3.97549950D+03,
     $ 3.92232190D+03, 3.86930140D+03, 3.81644080D+03, 3.76374260D+03,
     $ 3.71120890D+03/
      data ( FUPO( 37,J,1),J=1,13) /
     $ 5.719D-08, 1.726D-07, 3.462D-07, 5.785D-07, 8.692D-07, 1.215D-06,
     $ 1.616D-06, 2.070D-06, 2.575D-06, 3.129D-06, 3.729D-06, 4.374D-06,
     $ 5.077D-06/
      data (WNDNO( 37,J,1),J=1,13) /
     $ 4.07240770D+03, 4.02081110D+03, 3.96934810D+03, 3.91802230D+03,
     $ 3.86683710D+03, 3.81579620D+03, 3.76490290D+03, 3.71416040D+03,
     $ 3.66357180D+03, 3.61314020D+03, 3.56286820D+03, 3.51275820D+03,
     $ 3.46281230D+03/
      data ( FDNO( 37,J,1),J=1,13) /
     $ 3.604D-08, 1.097D-07, 2.223D-07, 3.737D-07, 5.637D-07, 7.935D-07,
     $ 1.062D-06, 1.368D-06, 1.712D-06, 2.092D-06, 2.507D-06, 2.957D-06,
     $ 3.431D-06/
      data (WNUPO( 37,J,2),J=1,13) /
     $ 4.25570050D+03, 4.20392460D+03, 4.15227330D+03, 4.10075010D+03,
     $ 4.04935820D+03, 3.99810070D+03, 3.94698090D+03, 3.89600170D+03,
     $ 3.84516610D+03, 3.79447680D+03, 3.74393640D+03, 3.69354720D+03,
     $ 3.64331120D+03/
      data ( FUPO( 37,J,2),J=1,13) /
     $ 5.312D-08, 1.604D-07, 3.218D-07, 5.378D-07, 8.084D-07, 1.131D-06,
     $ 1.504D-06, 1.929D-06, 2.400D-06, 2.916D-06, 3.478D-06, 4.082D-06,
     $ 4.726D-06/
      data (WNDNO( 37,J,2),J=1,13) /
     $ 3.98836400D+03, 3.93900890D+03, 3.88977840D+03, 3.84067590D+03,
     $ 3.79170450D+03, 3.74286750D+03, 3.69416800D+03, 3.64560890D+03,
     $ 3.59719310D+03, 3.54892340D+03, 3.50080230D+03, 3.45283210D+03,
     $ 3.40501470D+03/
      data ( FDNO( 37,J,2),J=1,13) /
     $ 3.379D-08, 1.028D-07, 2.084D-07, 3.504D-07, 5.285D-07, 7.440D-07,
     $ 9.957D-07, 1.283D-06, 1.607D-06, 1.963D-06, 2.353D-06, 2.777D-06,
     $ 3.232D-06/
      data (WNUPO( 38,J,1),J=1,13) /
     $ 4.35295790D+03, 4.29873610D+03, 4.24464800D+03, 4.19069720D+03,
     $ 4.13688720D+03, 4.08322170D+03, 4.02970390D+03, 3.97633720D+03,
     $ 3.92312480D+03, 3.87006960D+03, 3.81717430D+03, 3.76444150D+03,
     $ 3.71187310D+03/
      data ( FUPO( 38,J,1),J=1,13) /
     $ 5.756D-08, 1.737D-07, 3.483D-07, 5.819D-07, 8.743D-07, 1.222D-06,
     $ 1.625D-06, 2.081D-06, 2.589D-06, 3.145D-06, 3.748D-06, 4.396D-06,
     $ 5.101D-06/
      data (WNDNO( 38,J,1),J=1,13) /
     $ 4.06607540D+03, 4.01451380D+03, 3.96308590D+03, 3.91179520D+03,
     $ 3.86064520D+03, 3.80963940D+03, 3.75878130D+03, 3.70807410D+03,
     $ 3.65752080D+03, 3.60712450D+03, 3.55688780D+03, 3.50681320D+03,
     $ 3.45690280D+03/
      data ( FDNO( 38,J,1),J=1,13) /
     $ 3.588D-08, 1.092D-07, 2.213D-07, 3.721D-07, 5.614D-07, 7.901D-07,
     $ 1.057D-06, 1.362D-06, 1.705D-06, 2.083D-06, 2.497D-06, 2.945D-06,
     $ 3.416D-06/
      data (WNUPO( 38,J,2),J=1,13) /
     $ 4.25679610D+03, 4.20498740D+03, 4.15330350D+03, 4.10174770D+03,
     $ 4.05032320D+03, 3.99903310D+03, 3.94788080D+03, 3.89686910D+03,
     $ 3.84600100D+03, 3.79527930D+03, 3.74470650D+03, 3.69428480D+03,
     $ 3.64401650D+03/
      data ( FUPO( 38,J,2),J=1,13) /
     $ 5.345D-08, 1.613D-07, 3.236D-07, 5.409D-07, 8.129D-07, 1.137D-06,
     $ 1.513D-06, 1.939D-06, 2.412D-06, 2.932D-06, 3.496D-06, 4.101D-06,
     $ 4.748D-06/
      data (WNDNO( 38,J,2),J=1,13) /
     $ 3.98236130D+03, 3.93303890D+03, 3.88384130D+03, 3.83477160D+03,
     $ 3.78583300D+03, 3.73702890D+03, 3.68836230D+03, 3.63983610D+03,
     $ 3.59145330D+03, 3.54321660D+03, 3.49512860D+03, 3.44719140D+03,
     $ 3.39940710D+03/
      data ( FDNO( 38,J,2),J=1,13) /
     $ 3.365D-08, 1.024D-07, 2.075D-07, 3.490D-07, 5.264D-07, 7.409D-07,
     $ 9.917D-07, 1.278D-06, 1.600D-06, 1.955D-06, 2.344D-06, 2.766D-06,
     $ 3.221D-06/
      data (WNUPO( 39,J,1),J=1,13) /
     $ 4.35396420D+03, 4.29970740D+03, 4.24558440D+03, 4.19159860D+03,
     $ 4.13775380D+03, 4.08405340D+03, 4.03050080D+03, 3.97709930D+03,
     $ 3.92385210D+03, 3.87076220D+03, 3.81783230D+03, 3.76506470D+03,
     $ 3.71246170D+03/
      data ( FUPO( 39,J,1),J=1,13) /
     $ 5.794D-08, 1.748D-07, 3.504D-07, 5.853D-07, 8.794D-07, 1.229D-06,
     $ 1.634D-06, 2.094D-06, 2.603D-06, 3.161D-06, 3.768D-06, 4.418D-06,
     $ 5.126D-06/
      data (WNDNO( 39,J,1),J=1,13) /
     $ 4.05967850D+03, 4.00815200D+03, 3.95675920D+03, 3.90550360D+03,
     $ 3.85438880D+03, 3.80341820D+03, 3.75259530D+03, 3.70192330D+03,
     $ 3.65140530D+03, 3.60104440D+03, 3.55084300D+03, 3.50080380D+03,
     $ 3.45092870D+03/
      data ( FDNO( 39,J,1),J=1,13) /
     $ 3.573D-08, 1.087D-07, 2.204D-07, 3.705D-07, 5.590D-07, 7.868D-07,
     $ 1.053D-06, 1.357D-06, 1.697D-06, 2.075D-06, 2.487D-06, 2.934D-06,
     $ 3.403D-06/
      data (WNUPO( 39,J,2),J=1,13) /
     $ 4.25782110D+03, 4.20597980D+03, 4.15426330D+03, 4.10267480D+03,
     $ 4.05121760D+03, 3.99989500D+03, 3.94871010D+03, 3.89766590D+03,
     $ 3.84676540D+03, 3.79601120D+03, 3.74540590D+03, 3.69495190D+03,
     $ 3.64465110D+03/
      data ( FUPO( 39,J,2),J=1,13) /
     $ 5.379D-08, 1.623D-07, 3.256D-07, 5.440D-07, 8.175D-07, 1.143D-06,
     $ 1.521D-06, 1.949D-06, 2.425D-06, 2.947D-06, 3.513D-06, 4.122D-06,
     $ 4.771D-06/
      data (WNDNO( 39,J,2),J=1,13) /
     $ 3.97629820D+03, 3.92700860D+03, 3.87784370D+03, 3.82880680D+03,
     $ 3.77990120D+03, 3.73112990D+03, 3.68249620D+03, 3.63400300D+03,
     $ 3.58565320D+03, 3.53744950D+03, 3.48939440D+03, 3.44149030D+03,
     $ 3.39373910D+03/
      data ( FDNO( 39,J,2),J=1,13) /
     $ 3.351D-08, 1.019D-07, 2.067D-07, 3.475D-07, 5.242D-07, 7.378D-07,
     $ 9.876D-07, 1.272D-06, 1.594D-06, 1.947D-06, 2.335D-06, 2.756D-06,
     $ 3.208D-06/
      data (WNUPO( 40,J,1),J=1,13) /
     $ 4.35489470D+03, 4.30060300D+03, 4.24644500D+03, 4.19242440D+03,
     $ 4.13854460D+03, 4.08480930D+03, 4.03122190D+03, 3.97778570D+03,
     $ 3.92450370D+03, 3.87137910D+03, 3.81841440D+03, 3.76561220D+03,
     $ 3.71297450D+03/
      data ( FUPO( 40,J,1),J=1,13) /
     $ 5.830D-08, 1.759D-07, 3.525D-07, 5.889D-07, 8.844D-07, 1.236D-06,
     $ 1.643D-06, 2.104D-06, 2.616D-06, 3.178D-06, 3.787D-06, 4.441D-06,
     $ 5.151D-06/
      data (WNDNO( 40,J,1),J=1,13) /
     $ 4.05321740D+03, 4.00172590D+03, 3.95036820D+03, 3.89914770D+03,
     $ 3.84806800D+03, 3.79713260D+03, 3.74634490D+03, 3.69570820D+03,
     $ 3.64522550D+03, 3.59489990D+03, 3.54473390D+03, 3.49473000D+03,
     $ 3.44489030D+03/
      data ( FDNO( 40,J,1),J=1,13) /
     $ 3.558D-08, 1.083D-07, 2.195D-07, 3.690D-07, 5.567D-07, 7.835D-07,
     $ 1.049D-06, 1.351D-06, 1.690D-06, 2.067D-06, 2.478D-06, 2.922D-06,
     $ 3.388D-06/
      data (WNUPO( 40,J,2),J=1,13) /
     $ 4.25877550D+03, 4.20690150D+03, 4.15515230D+03, 4.10353120D+03,
     $ 4.05204150D+03, 4.00068630D+03, 3.94946880D+03, 3.89839210D+03,
     $ 3.84745900D+03, 3.79667240D+03, 3.74603470D+03, 3.69554830D+03,
     $ 3.64521510D+03/
      data ( FUPO( 40,J,2),J=1,13) /
     $ 5.414D-08, 1.634D-07, 3.275D-07, 5.472D-07, 8.222D-07, 1.150D-06,
     $ 1.529D-06, 1.959D-06, 2.437D-06, 2.962D-06, 3.530D-06, 4.142D-06,
     $ 4.795D-06/
      data (WNDNO( 40,J,2),J=1,13) /
     $ 3.97017480D+03, 3.92091800D+03, 3.87178590D+03, 3.82278190D+03,
     $ 3.77390900D+03, 3.72517070D+03, 3.67656980D+03, 3.62810960D+03,
     $ 3.57979270D+03, 3.53162210D+03, 3.48360010D+03, 3.43572900D+03,
     $ 3.38801080D+03/
      data ( FDNO( 40,J,2),J=1,13) /
     $ 3.337D-08, 1.015D-07, 2.058D-07, 3.460D-07, 5.221D-07, 7.348D-07,
     $ 9.836D-07, 1.267D-06, 1.586D-06, 1.940D-06, 2.326D-06, 2.744D-06,
     $ 3.195D-06/
      data (WNUPO( 41,J,1),J=1,13) /
     $ 4.35574950D+03, 4.30142280D+03, 4.24722980D+03, 4.19317420D+03,
     $ 4.13925960D+03, 4.08548940D+03, 4.03186720D+03, 3.97839610D+03,
     $ 3.92507940D+03, 3.87192000D+03, 3.81892070D+03, 3.76608380D+03,
     $ 3.71341140D+03/
      data ( FUPO( 41,J,1),J=1,13) /
     $ 5.869D-08, 1.770D-07, 3.547D-07, 5.923D-07, 8.896D-07, 1.243D-06,
     $ 1.653D-06, 2.116D-06, 2.631D-06, 3.195D-06, 3.806D-06, 4.463D-06,
     $ 5.177D-06/
      data (WNDNO( 41,J,1),J=1,13) /
     $ 4.04669210D+03, 3.99523570D+03, 3.94391300D+03, 3.89272750D+03,
     $ 3.84168300D+03, 3.79078280D+03, 3.74003030D+03, 3.68942880D+03,
     $ 3.63898150D+03, 3.58869110D+03, 3.53856050D+03, 3.48859200D+03,
     $ 3.43878770D+03/
      data ( FDNO( 41,J,1),J=1,13) /
     $ 3.543D-08, 1.078D-07, 2.186D-07, 3.675D-07, 5.543D-07, 7.802D-07,
     $ 1.044D-06, 1.346D-06, 1.683D-06, 2.058D-06, 2.467D-06, 2.911D-06,
     $ 3.373D-06/
      data (WNUPO( 41,J,2),J=1,13) /
     $ 4.25965910D+03, 4.20775250D+03, 4.15597060D+03, 4.10431680D+03,
     $ 4.05279450D+03, 4.00140670D+03, 3.95015670D+03, 3.89904740D+03,
     $ 3.84808190D+03, 3.79726280D+03, 3.74659270D+03, 3.69607380D+03,
     $ 3.64570820D+03/
      data ( FUPO( 41,J,2),J=1,13) /
     $ 5.448D-08, 1.643D-07, 3.295D-07, 5.504D-07, 8.269D-07, 1.156D-06,
     $ 1.537D-06, 1.970D-06, 2.449D-06, 2.977D-06, 3.548D-06, 4.163D-06,
     $ 4.817D-06/
      data (WNDNO( 41,J,2),J=1,13) /
     $ 3.96399140D+03, 3.91476740D+03, 3.86566810D+03, 3.81669680D+03,
     $ 3.76785680D+03, 3.71915130D+03, 3.67058340D+03, 3.62215610D+03,
     $ 3.57387220D+03, 3.52573450D+03, 3.47774560D+03, 3.42990750D+03,
     $ 3.38222250D+03/
      data ( FDNO( 41,J,2),J=1,13) /
     $ 3.323D-08, 1.011D-07, 2.049D-07, 3.446D-07, 5.199D-07, 7.318D-07,
     $ 9.795D-07, 1.263D-06, 1.581D-06, 1.931D-06, 2.317D-06, 2.734D-06,
     $ 3.183D-06/
      data (WNUPO( 42,J,1),J=1,13) /
     $ 4.35652820D+03, 4.30216650D+03, 4.24793860D+03, 4.19384810D+03,
     $ 4.13989850D+03, 4.08609350D+03, 4.03243630D+03, 3.97893050D+03,
     $ 3.92557900D+03, 3.87238490D+03, 3.81935090D+03, 3.76647930D+03,
     $ 3.71377220D+03/
      data ( FUPO( 42,J,1),J=1,13) /
     $ 5.907D-08, 1.782D-07, 3.569D-07, 5.959D-07, 8.948D-07, 1.251D-06,
     $ 1.661D-06, 2.128D-06, 2.645D-06, 3.212D-06, 3.825D-06, 4.486D-06,
     $ 5.201D-06/
      data (WNDNO( 42,J,1),J=1,13) /
     $ 4.04010270D+03, 3.98868130D+03, 3.93739370D+03, 3.88624340D+03,
     $ 3.83523390D+03, 3.78436890D+03, 3.73365160D+03, 3.68308540D+03,
     $ 3.63267340D+03, 3.58241840D+03, 3.53232310D+03, 3.48239000D+03,
     $ 3.43262110D+03/
      data ( FDNO( 42,J,1),J=1,13) /
     $ 3.528D-08, 1.074D-07, 2.176D-07, 3.660D-07, 5.521D-07, 7.771D-07,
     $ 1.040D-06, 1.340D-06, 1.676D-06, 2.049D-06, 2.458D-06, 2.900D-06,
     $ 3.360D-06/
      data (WNUPO( 42,J,2),J=1,13) /
     $ 4.26047180D+03, 4.20853250D+03, 4.15671800D+03, 4.10503160D+03,
     $ 4.05347660D+03, 4.00205620D+03, 3.95077360D+03, 3.89963180D+03,
     $ 3.84863380D+03, 3.79778230D+03, 3.74707970D+03, 3.69652840D+03,
     $ 3.64613040D+03/
      data ( FUPO( 42,J,2),J=1,13) /
     $ 5.483D-08, 1.654D-07, 3.314D-07, 5.536D-07, 8.317D-07, 1.163D-06,
     $ 1.546D-06, 1.981D-06, 2.463D-06, 2.992D-06, 3.566D-06, 4.183D-06,
     $ 4.841D-06/
      data (WNDNO( 42,J,2),J=1,13) /
     $ 3.95774800D+03, 3.90855670D+03, 3.85949020D+03, 3.81055170D+03,
     $ 3.76174460D+03, 3.71307190D+03, 3.66453690D+03, 3.61614250D+03,
     $ 3.56789170D+03, 3.51978700D+03, 3.47183110D+03, 3.42402610D+03,
     $ 3.37637410D+03/
      data ( FDNO( 42,J,2),J=1,13) /
     $ 3.309D-08, 1.007D-07, 2.041D-07, 3.432D-07, 5.178D-07, 7.288D-07,
     $ 9.756D-07, 1.256D-06, 1.574D-06, 1.924D-06, 2.307D-06, 2.724D-06,
     $ 3.171D-06/
      data (WNUPO( 43,J,1),J=1,13) /
     $ 4.35723080D+03, 4.30283410D+03, 4.24857120D+03, 4.19444570D+03,
     $ 4.14046120D+03, 4.08662130D+03, 4.03292940D+03, 3.97938870D+03,
     $ 3.92600250D+03, 3.87277360D+03, 3.81970480D+03, 3.76679850D+03,
     $ 3.71405680D+03/
      data ( FUPO( 43,J,1),J=1,13) /
     $ 5.946D-08, 1.793D-07, 3.591D-07, 5.995D-07, 9.001D-07, 1.258D-06,
     $ 1.672D-06, 2.139D-06, 2.659D-06, 3.228D-06, 3.846D-06, 4.508D-06,
     $ 5.227D-06/
      data (WNDNO( 43,J,1),J=1,13) /
     $ 4.03344940D+03, 3.98206310D+03, 3.93081050D+03, 3.87969530D+03,
     $ 3.82872100D+03, 3.77789110D+03, 3.72720910D+03, 3.67667810D+03,
     $ 3.62630130D+03, 3.57608170D+03, 3.52602180D+03, 3.47612400D+03,
     $ 3.42639050D+03/
      data ( FDNO( 43,J,1),J=1,13) /
     $ 3.514D-08, 1.069D-07, 2.168D-07, 3.645D-07, 5.498D-07, 7.738D-07,
     $ 1.036D-06, 1.334D-06, 1.670D-06, 2.041D-06, 2.447D-06, 2.889D-06,
     $ 3.346D-06/
      data (WNUPO( 43,J,2),J=1,13) /
     $ 4.26121350D+03, 4.20924150D+03, 4.15739430D+03, 4.10567520D+03,
     $ 4.05408760D+03, 4.00263460D+03, 3.95131950D+03, 3.90014520D+03,
     $ 3.84911460D+03, 3.79823060D+03, 3.74749560D+03, 3.69691190D+03,
     $ 3.64648150D+03/
      data ( FUPO( 43,J,2),J=1,13) /
     $ 5.518D-08, 1.665D-07, 3.334D-07, 5.569D-07, 8.365D-07, 1.169D-06,
     $ 1.554D-06, 1.992D-06, 2.475D-06, 3.007D-06, 3.585D-06, 4.204D-06,
     $ 4.865D-06/
      data (WNDNO( 43,J,2),J=1,13) /
     $ 3.95144480D+03, 3.90228620D+03, 3.85325250D+03, 3.80434680D+03,
     $ 3.75557240D+03, 3.70693270D+03, 3.65843060D+03, 3.61006910D+03,
     $ 3.56185130D+03, 3.51377960D+03, 3.46585670D+03, 3.41808480D+03,
     $ 3.37046590D+03/
      data ( FDNO( 43,J,2),J=1,13) /
     $ 3.295D-08, 1.003D-07, 2.033D-07, 3.418D-07, 5.156D-07, 7.259D-07,
     $ 9.716D-07, 1.252D-06, 1.568D-06, 1.916D-06, 2.299D-06, 2.713D-06,
     $ 3.159D-06/
      data (WNUPO( 44,J,1),J=1,13) /
     $ 4.35785710D+03, 4.30342540D+03, 4.24912750D+03, 4.19496710D+03,
     $ 4.14094770D+03, 4.08707280D+03, 4.03334600D+03, 3.97977050D+03,
     $ 3.92634950D+03, 3.87308590D+03, 3.81998240D+03, 3.76704140D+03,
     $ 3.71426500D+03/
      data ( FUPO( 44,J,1),J=1,13) /
     $ 5.985D-08, 1.805D-07, 3.614D-07, 6.031D-07, 9.054D-07, 1.264D-06,
     $ 1.680D-06, 2.151D-06, 2.674D-06, 3.246D-06, 3.866D-06, 4.531D-06,
     $ 5.253D-06/
      data (WNDNO( 44,J,1),J=1,13) /
     $ 4.02673240D+03, 3.97538110D+03, 3.92416360D+03, 3.87308340D+03,
     $ 3.82214420D+03, 3.77134950D+03, 3.72070270D+03, 3.67020700D+03,
     $ 3.61986550D+03, 3.56968120D+03, 3.51965670D+03, 3.46979430D+03,
     $ 3.42009620D+03/
      data ( FDNO( 44,J,1),J=1,13) /
     $ 3.499D-08, 1.065D-07, 2.160D-07, 3.629D-07, 5.475D-07, 7.706D-07,
     $ 1.031D-06, 1.329D-06, 1.663D-06, 2.033D-06, 2.438D-06, 2.876D-06,
     $ 3.333D-06/
      data (WNUPO( 44,J,2),J=1,13) /
     $ 4.26188410D+03, 4.20987930D+03, 4.15799940D+03, 4.10624770D+03,
     $ 4.05462740D+03, 4.00314180D+03, 3.95179410D+03, 3.90058730D+03,
     $ 3.84952420D+03, 3.79860770D+03, 3.74784030D+03, 3.69722410D+03,
     $ 3.64676130D+03/
      data ( FUPO( 44,J,2),J=1,13) /
     $ 5.553D-08, 1.675D-07, 3.355D-07, 5.602D-07, 8.413D-07, 1.176D-06,
     $ 1.563D-06, 2.002D-06, 2.489D-06, 3.023D-06, 3.602D-06, 4.225D-06,
     $ 4.889D-06/
      data (WNDNO( 44,J,2),J=1,13) /
     $ 3.94508180D+03, 3.89595600D+03, 3.84695500D+03, 3.79808210D+03,
     $ 3.74934060D+03, 3.70073370D+03, 3.65226450D+03, 3.60393600D+03,
     $ 3.55575110D+03, 3.50771250D+03, 3.45982260D+03, 3.41208380D+03,
     $ 3.36449800D+03/
      data ( FDNO( 44,J,2),J=1,13) /
     $ 3.282D-08, 9.985D-08, 2.025D-07, 3.404D-07, 5.136D-07, 7.229D-07,
     $ 9.678D-07, 1.247D-06, 1.562D-06, 1.909D-06, 2.289D-06, 2.702D-06,
     $ 3.146D-06/
      data (WNUPO( 45,J,1),J=1,13) /
     $ 4.35840700D+03, 4.30394030D+03, 4.24960740D+03, 4.19541190D+03,
     $ 4.14135760D+03, 4.08744790D+03, 4.03368620D+03, 3.98007590D+03,
     $ 3.92662010D+03, 3.87332170D+03, 3.82018350D+03, 3.76720780D+03,
     $ 3.71439660D+03/
      data ( FUPO( 45,J,1),J=1,13) /
     $ 6.025D-08, 1.816D-07, 3.636D-07, 6.067D-07, 9.108D-07, 1.272D-06,
     $ 1.690D-06, 2.163D-06, 2.688D-06, 3.263D-06, 3.885D-06, 4.554D-06,
     $ 5.279D-06/
      data (WNDNO( 45,J,1),J=1,13) /
     $ 4.01995180D+03, 3.96863550D+03, 3.91745300D+03, 3.86640790D+03,
     $ 3.81550380D+03, 3.76474430D+03, 3.71413260D+03, 3.66367220D+03,
     $ 3.61336600D+03, 3.56321700D+03, 3.51322790D+03, 3.46340090D+03,
     $ 3.41373820D+03/
      data ( FDNO( 45,J,1),J=1,13) /
     $ 3.485D-08, 1.060D-07, 2.151D-07, 3.614D-07, 5.453D-07, 7.675D-07,
     $ 1.027D-06, 1.324D-06, 1.656D-06, 2.025D-06, 2.429D-06, 2.866D-06,
     $ 3.320D-06/
      data (WNUPO( 45,J,2),J=1,13) /
     $ 4.26248330D+03, 4.21044590D+03, 4.15853320D+03, 4.10674880D+03,
     $ 4.05509590D+03, 4.00357770D+03, 3.95219740D+03, 3.90095800D+03,
     $ 3.84986240D+03, 3.79891350D+03, 3.74811350D+03, 3.69746500D+03,
     $ 3.64696970D+03/
      data ( FUPO( 45,J,2),J=1,13) /
     $ 5.589D-08, 1.685D-07, 3.375D-07, 5.635D-07, 8.462D-07, 1.182D-06,
     $ 1.572D-06, 2.013D-06, 2.502D-06, 3.039D-06, 3.621D-06, 4.246D-06,
     $ 4.912D-06/
      data (WNDNO( 45,J,2),J=1,13) /
     $ 3.93865930D+03, 3.88956620D+03, 3.84059790D+03, 3.79175780D+03,
     $ 3.74304920D+03, 3.69447510D+03, 3.64603880D+03, 3.59774330D+03,
     $ 3.54959130D+03, 3.50158570D+03, 3.45372890D+03, 3.40602320D+03,
     $ 3.35847040D+03/
      data ( FDNO( 45,J,2),J=1,13) /
     $ 3.269D-08, 9.945D-08, 2.016D-07, 3.391D-07, 5.115D-07, 7.200D-07,
     $ 9.638D-07, 1.242D-06, 1.555D-06, 1.901D-06, 2.280D-06, 2.691D-06,
     $ 3.134D-06/
      data (WNUPO( 46,J,1),J=1,13) /
     $ 4.35888030D+03, 4.30437850D+03, 4.25001060D+03, 4.19578020D+03,
     $ 4.14169090D+03, 4.08774630D+03, 4.03394970D+03, 3.98030460D+03,
     $ 3.92681390D+03, 3.87348080D+03, 3.82030780D+03, 3.76729740D+03,
     $ 3.71445150D+03/
      data ( FUPO( 46,J,1),J=1,13) /
     $ 6.065D-08, 1.827D-07, 3.658D-07, 6.105D-07, 9.163D-07, 1.280D-06,
     $ 1.700D-06, 2.175D-06, 2.702D-06, 3.280D-06, 3.905D-06, 4.578D-06,
     $ 5.305D-06/
      data (WNDNO( 46,J,1),J=1,13) /
     $ 4.01310770D+03, 3.96182640D+03, 3.91067890D+03, 3.85966890D+03,
     $ 3.80879990D+03, 3.75807550D+03, 3.70749910D+03, 3.65707390D+03,
     $ 3.60680300D+03, 3.55668940D+03, 3.50673560D+03, 3.45694400D+03,
     $ 3.40731660D+03/
      data ( FDNO( 46,J,1),J=1,13) /
     $ 3.471D-08, 1.056D-07, 2.142D-07, 3.600D-07, 5.430D-07, 7.643D-07,
     $ 1.023D-06, 1.318D-06, 1.649D-06, 2.017D-06, 2.418D-06, 2.854D-06,
     $ 3.305D-06/
      data (WNUPO( 46,J,2),J=1,13) /
     $ 4.26301110D+03, 4.21094090D+03, 4.15899560D+03, 4.10717850D+03,
     $ 4.05549290D+03, 4.00394210D+03, 3.95252920D+03, 3.90125720D+03,
     $ 3.85012920D+03, 3.79914770D+03, 3.74831530D+03, 3.69763430D+03,
     $ 3.64710650D+03/
      data ( FUPO( 46,J,2),J=1,13) /
     $ 5.625D-08, 1.696D-07, 3.396D-07, 5.669D-07, 8.511D-07, 1.189D-06,
     $ 1.580D-06, 2.024D-06, 2.515D-06, 3.055D-06, 3.640D-06, 4.268D-06,
     $ 4.937D-06/
      data (WNDNO( 46,J,2),J=1,13) /
     $ 3.93217730D+03, 3.88311690D+03, 3.83418140D+03, 3.78537410D+03,
     $ 3.73669820D+03, 3.68815700D+03, 3.63975360D+03, 3.59149100D+03,
     $ 3.54337210D+03, 3.49539950D+03, 3.44757570D+03, 3.39990300D+03,
     $ 3.35238330D+03/
      data ( FDNO( 46,J,2),J=1,13) /
     $ 3.256D-08, 9.905D-08, 2.009D-07, 3.377D-07, 5.095D-07, 7.171D-07,
     $ 9.600D-07, 1.237D-06, 1.549D-06, 1.894D-06, 2.271D-06, 2.681D-06,
     $ 3.123D-06/
      data (WNUPO( 47,J,1),J=1,13) /
     $ 4.35927680D+03, 4.30474010D+03, 4.25033720D+03, 4.19607170D+03,
     $ 4.14194750D+03, 4.08796790D+03, 4.03413640D+03, 3.98045640D+03,
     $ 3.92693100D+03, 3.87356310D+03, 3.82035540D+03, 3.76731020D+03,
     $ 3.71442960D+03/
      data ( FUPO( 47,J,1),J=1,13) /
     $ 6.105D-08, 1.840D-07, 3.682D-07, 6.142D-07, 9.217D-07, 1.287D-06,
     $ 1.710D-06, 2.187D-06, 2.717D-06, 3.298D-06, 3.927D-06, 4.601D-06,
     $ 5.332D-06/
      data (WNDNO( 47,J,1),J=1,13) /
     $ 4.00620030D+03, 3.95495390D+03, 3.90384150D+03, 3.85286650D+03,
     $ 3.80203270D+03, 3.75134340D+03, 3.70080220D+03, 3.65041220D+03,
     $ 3.60017660D+03, 3.55009830D+03, 3.50017990D+03, 3.45042360D+03,
     $ 3.40083170D+03/
      data ( FDNO( 47,J,1),J=1,13) /
     $ 3.457D-08, 1.052D-07, 2.133D-07, 3.585D-07, 5.408D-07, 7.612D-07,
     $ 1.019D-06, 1.313D-06, 1.643D-06, 2.008D-06, 2.408D-06, 2.843D-06,
     $ 3.293D-06/
      data (WNUPO( 47,J,2),J=1,13) /
     $ 4.26346740D+03, 4.21136440D+03, 4.15938640D+03, 4.10753660D+03,
     $ 4.05581830D+03, 4.00423480D+03, 3.95278930D+03, 3.90148480D+03,
     $ 3.85032420D+03, 3.79931020D+03, 3.74844540D+03, 3.69773190D+03,
     $ 3.64717170D+03/
      data ( FUPO( 47,J,2),J=1,13) /
     $ 5.662D-08, 1.706D-07, 3.417D-07, 5.703D-07, 8.561D-07, 1.196D-06,
     $ 1.589D-06, 2.035D-06, 2.529D-06, 3.071D-06, 3.658D-06, 4.289D-06,
     $ 4.961D-06/
      data (WNDNO( 47,J,2),J=1,13) /
     $ 3.92563600D+03, 3.87660830D+03, 3.82770560D+03, 3.77893100D+03,
     $ 3.73028790D+03, 3.68177960D+03, 3.63340910D+03, 3.58517940D+03,
     $ 3.53709340D+03, 3.48915390D+03, 3.44136320D+03, 3.39372350D+03,
     $ 3.34623690D+03/
      data ( FDNO( 47,J,2),J=1,13) /
     $ 3.243D-08, 9.866D-08, 2.001D-07, 3.364D-07, 5.074D-07, 7.143D-07,
     $ 9.561D-07, 1.232D-06, 1.543D-06, 1.886D-06, 2.262D-06, 2.671D-06,
     $ 3.111D-06/
      data (WNUPO( 48,J,1),J=1,13) /
     $ 4.35959660D+03, 4.30502470D+03, 4.25058680D+03, 4.19628630D+03,
     $ 4.14212710D+03, 4.08811260D+03, 4.03424620D+03, 3.98053130D+03,
     $ 3.92697110D+03, 3.87356840D+03, 3.82032590D+03, 3.76724600D+03,
     $ 3.71433060D+03/
      data ( FUPO( 48,J,1),J=1,13) /
     $ 6.146D-08, 1.852D-07, 3.704D-07, 6.180D-07, 9.273D-07, 1.295D-06,
     $ 1.719D-06, 2.199D-06, 2.732D-06, 3.316D-06, 3.947D-06, 4.625D-06,
     $ 5.358D-06/
      data (WNDNO( 48,J,1),J=1,13) /
     $ 3.99922960D+03, 3.94801830D+03, 3.89694080D+03, 3.84600090D+03,
     $ 3.79520220D+03, 3.74454800D+03, 3.69404200D+03, 3.64368730D+03,
     $ 3.59348700D+03, 3.54344400D+03, 3.49356090D+03, 3.44384010D+03,
     $ 3.39428350D+03/
      data ( FDNO( 48,J,1),J=1,13) /
     $ 3.443D-08, 1.047D-07, 2.125D-07, 3.571D-07, 5.387D-07, 7.581D-07,
     $ 1.015D-06, 1.308D-06, 1.636D-06, 2.001D-06, 2.399D-06, 2.832D-06,
     $ 3.279D-06/
      data (WNUPO( 48,J,2),J=1,13) /
     $ 4.26385190D+03, 4.21171620D+03, 4.15970550D+03, 4.10782290D+03,
     $ 4.05607200D+03, 4.00445590D+03, 3.95297770D+03, 3.90164060D+03,
     $ 3.85044750D+03, 3.79940100D+03, 3.74850370D+03, 3.69775770D+03,
     $ 3.64716510D+03/
      data ( FUPO( 48,J,2),J=1,13) /
     $ 5.699D-08, 1.718D-07, 3.438D-07, 5.737D-07, 8.612D-07, 1.203D-06,
     $ 1.598D-06, 2.046D-06, 2.542D-06, 3.086D-06, 3.677D-06, 4.311D-06,
     $ 4.986D-06/
      data (WNDNO( 48,J,2),J=1,13) /
     $ 3.91903550D+03, 3.87004050D+03, 3.82117050D+03, 3.77242870D+03,
     $ 3.72381840D+03, 3.67534290D+03, 3.62700530D+03, 3.57880860D+03,
     $ 3.53075560D+03, 3.48284900D+03, 3.43509130D+03, 3.38748480D+03,
     $ 3.34003120D+03/
      data ( FDNO( 48,J,2),J=1,13) /
     $ 3.230D-08, 9.827D-08, 1.993D-07, 3.351D-07, 5.054D-07, 7.114D-07,
     $ 9.524D-07, 1.227D-06, 1.537D-06, 1.879D-06, 2.254D-06, 2.661D-06,
     $ 3.099D-06/
      data (WNUPO( 49,J,1),J=1,13) /
     $ 4.35983930D+03, 4.30523240D+03, 4.25075940D+03, 4.19642390D+03,
     $ 4.14222960D+03, 4.08818020D+03, 4.03427890D+03, 3.98052910D+03,
     $ 3.92693410D+03, 3.87349660D+03, 3.82021930D+03, 3.76710460D+03,
     $ 3.71415450D+03/
      data ( FUPO( 49,J,1),J=1,13) /
     $ 6.188D-08, 1.864D-07, 3.728D-07, 6.219D-07, 9.329D-07, 1.302D-06,
     $ 1.729D-06, 2.211D-06, 2.746D-06, 3.333D-06, 3.968D-06, 4.648D-06,
     $ 5.386D-06/
      data (WNDNO( 49,J,1),J=1,13) /
     $ 3.99219600D+03, 3.94101960D+03, 3.88997710D+03, 3.83907220D+03,
     $ 3.78830860D+03, 3.73768960D+03, 3.68721870D+03, 3.63689920D+03,
     $ 3.58673420D+03, 3.53672650D+03, 3.48687880D+03, 3.43719340D+03,
     $ 3.38767220D+03/
      data ( FDNO( 49,J,1),J=1,13) /
     $ 3.429D-08, 1.043D-07, 2.116D-07, 3.557D-07, 5.365D-07, 7.551D-07,
     $ 1.010D-06, 1.302D-06, 1.630D-06, 1.993D-06, 2.390D-06, 2.821D-06,
     $ 3.266D-06/
      data (WNUPO( 49,J,2),J=1,13) /
     $ 4.26416460D+03, 4.21199620D+03, 4.15995270D+03, 4.10803740D+03,
     $ 4.05625380D+03, 4.00460500D+03, 3.95309420D+03, 3.90172460D+03,
     $ 3.85049890D+03, 3.79941980D+03, 3.74849000D+03, 3.69771160D+03,
     $ 3.64708640D+03/
      data ( FUPO( 49,J,2),J=1,13) /
     $ 5.736D-08, 1.728D-07, 3.459D-07, 5.771D-07, 8.662D-07, 1.210D-06,
     $ 1.607D-06, 2.058D-06, 2.556D-06, 3.103D-06, 3.696D-06, 4.333D-06,
     $ 5.010D-06/
      data (WNDNO( 49,J,2),J=1,13) /
     $ 3.91237590D+03, 3.86341370D+03, 3.81457630D+03, 3.76586730D+03,
     $ 3.71728980D+03, 3.66884710D+03, 3.62054240D+03, 3.57237860D+03,
     $ 3.52435860D+03, 3.47648500D+03, 3.42876040D+03, 3.38118690D+03,
     $ 3.33376640D+03/
      data ( FDNO( 49,J,2),J=1,13) /
     $ 3.218D-08, 9.788D-08, 1.985D-07, 3.337D-07, 5.033D-07, 7.086D-07,
     $ 9.486D-07, 1.222D-06, 1.530D-06, 1.872D-06, 2.245D-06, 2.651D-06,
     $ 3.087D-06/
      data (WNUPO( 50,J,1),J=1,13) /
     $ 4.36000480D+03, 4.30536290D+03, 4.25085480D+03, 4.19648420D+03,
     $ 4.14225500D+03, 4.08817050D+03, 4.03423430D+03, 3.98044970D+03,
     $ 3.92681980D+03, 3.87334740D+03, 3.82003540D+03, 3.76688590D+03,
     $ 3.71390100D+03/
      data ( FUPO( 50,J,1),J=1,13) /
     $ 6.229D-08, 1.876D-07, 3.752D-07, 6.257D-07, 9.385D-07, 1.310D-06,
     $ 1.739D-06, 2.224D-06, 2.762D-06, 3.352D-06, 3.989D-06, 4.673D-06,
     $ 5.412D-06/
      data (WNDNO( 50,J,1),J=1,13) /
     $ 3.98509940D+03, 3.93395800D+03, 3.88295050D+03, 3.83208060D+03,
     $ 3.78135200D+03, 3.73076820D+03, 3.68033250D+03, 3.63004820D+03,
     $ 3.57991850D+03, 3.52994610D+03, 3.48013370D+03, 3.43048370D+03,
     $ 3.38099790D+03/
      data ( FDNO( 50,J,1),J=1,13) /
     $ 3.416D-08, 1.040D-07, 2.108D-07, 3.543D-07, 5.344D-07, 7.521D-07,
     $ 1.007D-06, 1.297D-06, 1.624D-06, 1.985D-06, 2.380D-06, 2.810D-06,
     $ 3.252D-06/
      data (WNUPO( 50,J,2),J=1,13) /
     $ 4.26440540D+03, 4.21220420D+03, 4.16012790D+03, 4.10817990D+03,
     $ 4.05636350D+03, 4.00468210D+03, 3.95313870D+03, 3.90173640D+03,
     $ 3.85047810D+03, 3.79936660D+03, 3.74840420D+03, 3.69759330D+03,
     $ 3.64693570D+03/
      data ( FUPO( 50,J,2),J=1,13) /
     $ 5.774D-08, 1.739D-07, 3.481D-07, 5.806D-07, 8.713D-07, 1.217D-06,
     $ 1.616D-06, 2.069D-06, 2.570D-06, 3.119D-06, 3.715D-06, 4.355D-06,
     $ 5.035D-06/
      data (WNDNO( 50,J,2),J=1,13) /
     $ 3.90565740D+03, 3.85672780D+03, 3.80792320D+03, 3.75924690D+03,
     $ 3.71070220D+03, 3.66229240D+03, 3.61402050D+03, 3.56588960D+03,
     $ 3.51790260D+03, 3.47006200D+03, 3.42237040D+03, 3.37483000D+03,
     $ 3.32744260D+03/
      data ( FDNO( 50,J,2),J=1,13) /
     $ 3.205D-08, 9.750D-08, 1.977D-07, 3.324D-07, 5.014D-07, 7.058D-07,
     $ 9.449D-07, 1.218D-06, 1.525D-06, 1.864D-06, 2.237D-06, 2.640D-06,
     $ 3.075D-06/
      data (WNUPO( 51,J,1),J=1,13) /
     $ 4.36009310D+03, 4.30541600D+03, 4.25087280D+03, 4.19646720D+03,
     $ 4.14220290D+03, 4.08808350D+03, 4.03411230D+03, 3.98029280D+03,
     $ 3.92662800D+03, 3.87312090D+03, 3.81977400D+03, 3.76658970D+03,
     $ 3.71357000D+03/
      data ( FUPO( 51,J,1),J=1,13) /
     $ 6.271D-08, 1.888D-07, 3.775D-07, 6.295D-07, 9.442D-07, 1.318D-06,
     $ 1.750D-06, 2.237D-06, 2.777D-06, 3.369D-06, 4.010D-06, 4.697D-06,
     $ 5.440D-06/
      data (WNDNO( 51,J,1),J=1,13) /
     $ 3.97794000D+03, 3.92683350D+03, 3.87586100D+03, 3.82502620D+03,
     $ 3.77433260D+03, 3.72378390D+03, 3.67338340D+03, 3.62313440D+03,
     $ 3.57303990D+03, 3.52310280D+03, 3.47332580D+03, 3.42371110D+03,
     $ 3.37426070D+03/
      data ( FDNO( 51,J,1),J=1,13) /
     $ 3.403D-08, 1.035D-07, 2.099D-07, 3.529D-07, 5.322D-07, 7.490D-07,
     $ 1.003D-06, 1.292D-06, 1.617D-06, 1.977D-06, 2.371D-06, 2.799D-06,
     $ 3.240D-06/
      data (WNUPO( 51,J,2),J=1,13) /
     $ 4.26457410D+03, 4.21234010D+03, 4.16023100D+03, 4.10825020D+03,
     $ 4.05640110D+03, 4.00468700D+03, 3.95311100D+03, 3.90167610D+03,
     $ 3.85038520D+03, 3.79924110D+03, 3.74824630D+03, 3.69740280D+03,
     $ 3.64671270D+03/
      data ( FUPO( 51,J,2),J=1,13) /
     $ 5.812D-08, 1.750D-07, 3.502D-07, 5.842D-07, 8.764D-07, 1.224D-06,
     $ 1.626D-06, 2.080D-06, 2.583D-06, 3.136D-06, 3.735D-06, 4.376D-06,
     $ 5.060D-06/
      data (WNDNO( 51,J,2),J=1,13) /
     $ 3.89888010D+03, 3.84998320D+03, 3.80121120D+03, 3.75256760D+03,
     $ 3.70405570D+03, 3.65567870D+03, 3.60743970D+03, 3.55934180D+03,
     $ 3.51138770D+03, 3.46358010D+03, 3.41592160D+03, 3.36841420D+03,
     $ 3.32105990D+03/
      data ( FDNO( 51,J,2),J=1,13) /
     $ 3.193D-08, 9.709D-08, 1.970D-07, 3.312D-07, 4.994D-07, 7.030D-07,
     $ 9.411D-07, 1.213D-06, 1.518D-06, 1.857D-06, 2.227D-06, 2.630D-06,
     $ 3.063D-06/
      data (WNUPO( 52,J,1),J=1,13) /
     $ 4.36010390D+03, 4.30539170D+03, 4.25081340D+03, 4.19637270D+03,
     $ 4.14207340D+03, 4.08791890D+03, 4.03391280D+03, 3.98005840D+03,
     $ 3.92635870D+03, 3.87281670D+03, 3.81943500D+03, 3.76621590D+03,
     $ 3.71316130D+03/
      data ( FUPO( 52,J,1),J=1,13) /
     $ 6.314D-08, 1.901D-07, 3.800D-07, 6.334D-07, 9.499D-07, 1.325D-06,
     $ 1.759D-06, 2.250D-06, 2.792D-06, 3.387D-06, 4.031D-06, 4.721D-06,
     $ 5.467D-06/
      data (WNDNO( 52,J,1),J=1,13) /
     $ 3.97071800D+03, 3.91964650D+03, 3.86870890D+03, 3.81790910D+03,
     $ 3.76725060D+03, 3.71673690D+03, 3.66637160D+03, 3.61615780D+03,
     $ 3.56609860D+03, 3.51619680D+03, 3.46645520D+03, 3.41687590D+03,
     $ 3.36746080D+03/
      data ( FDNO( 52,J,1),J=1,13) /
     $ 3.390D-08, 1.031D-07, 2.091D-07, 3.515D-07, 5.301D-07, 7.461D-07,
     $ 9.981D-07, 1.287D-06, 1.610D-06, 1.970D-06, 2.362D-06, 2.789D-06,
     $ 3.227D-06/
      data (WNUPO( 52,J,2),J=1,13) /
     $ 4.26467050D+03, 4.21240370D+03, 4.16026180D+03, 4.10824830D+03,
     $ 4.05636650D+03, 4.00461960D+03, 3.95301090D+03, 3.90154340D+03,
     $ 3.85022000D+03, 3.79904330D+03, 3.74801590D+03, 3.69713990D+03,
     $ 3.64641730D+03/
      data ( FUPO( 52,J,2),J=1,13) /
     $ 5.850D-08, 1.762D-07, 3.524D-07, 5.877D-07, 8.817D-07, 1.231D-06,
     $ 1.635D-06, 2.091D-06, 2.597D-06, 3.152D-06, 3.753D-06, 4.399D-06,
     $ 5.086D-06/
      data (WNDNO( 52,J,2),J=1,13) /
     $ 3.89204410D+03, 3.84317980D+03, 3.79444060D+03, 3.74582970D+03,
     $ 3.69735050D+03, 3.64900630D+03, 3.60080020D+03, 3.55273520D+03,
     $ 3.50481400D+03, 3.45703950D+03, 3.40941400D+03, 3.36193960D+03,
     $ 3.31461840D+03/
      data ( FDNO( 52,J,2),J=1,13) /
     $ 3.181D-08, 9.676D-08, 1.962D-07, 3.298D-07, 4.975D-07, 7.003D-07,
     $ 9.374D-07, 1.208D-06, 1.512D-06, 1.850D-06, 2.219D-06, 2.620D-06,
     $ 3.051D-06/
      data (WNUPO( 53,J,1),J=1,13) /
     $ 4.36003710D+03, 4.30528980D+03, 4.25067630D+03, 4.19620060D+03,
     $ 4.14186620D+03, 4.08767670D+03, 4.03363560D+03, 3.97974620D+03,
     $ 3.92601160D+03, 3.87243470D+03, 3.81901820D+03, 3.76576430D+03,
     $ 3.71267490D+03/
      data ( FUPO( 53,J,1),J=1,13) /
     $ 6.356D-08, 1.913D-07, 3.824D-07, 6.373D-07, 9.552D-07, 1.333D-06,
     $ 1.770D-06, 2.262D-06, 2.808D-06, 3.406D-06, 4.052D-06, 4.746D-06,
     $ 5.494D-06/
      data (WNDNO( 53,J,1),J=1,13) /
     $ 3.96343360D+03, 3.91239690D+03, 3.86149430D+03, 3.81072940D+03,
     $ 3.76010600D+03, 3.70962740D+03, 3.65929720D+03, 3.60911860D+03,
     $ 3.55909470D+03, 3.50922830D+03, 3.45952190D+03, 3.40997800D+03,
     $ 3.36059830D+03/
      data ( FDNO( 53,J,1),J=1,13) /
     $ 3.377D-08, 1.027D-07, 2.083D-07, 3.501D-07, 5.280D-07, 7.432D-07,
     $ 9.944D-07, 1.282D-06, 1.605D-06, 1.962D-06, 2.353D-06, 2.778D-06,
     $ 3.214D-06/
      data (WNUPO( 53,J,2),J=1,13) /
     $ 4.26469460D+03, 4.21239500D+03, 4.16022030D+03, 4.10817390D+03,
     $ 4.05625940D+03, 4.00447980D+03, 3.95283840D+03, 3.90133820D+03,
     $ 3.84998220D+03, 3.79877300D+03, 3.74771300D+03, 3.69680450D+03,
     $ 3.64604940D+03/
      data ( FUPO( 53,J,2),J=1,13) /
     $ 5.889D-08, 1.773D-07, 3.546D-07, 5.912D-07, 8.869D-07, 1.238D-06,
     $ 1.644D-06, 2.103D-06, 2.611D-06, 3.170D-06, 3.773D-06, 4.421D-06,
     $ 5.111D-06/
      data (WNDNO( 53,J,2),J=1,13) /
     $ 3.88514950D+03, 3.83631790D+03, 3.78761130D+03, 3.73903310D+03,
     $ 3.69058680D+03, 3.64227540D+03, 3.59410210D+03, 3.54606990D+03,
     $ 3.49818180D+03, 3.45044020D+03, 3.40284770D+03, 3.35540640D+03,
     $ 3.30811830D+03/
      data ( FDNO( 53,J,2),J=1,13) /
     $ 3.169D-08, 9.636D-08, 1.955D-07, 3.286D-07, 4.955D-07, 6.976D-07,
     $ 9.338D-07, 1.203D-06, 1.507D-06, 1.843D-06, 2.210D-06, 2.610D-06,
     $ 3.040D-06/
      data (WNUPO( 54,J,1),J=1,13) /
     $ 4.35989260D+03, 4.30511010D+03, 4.25046150D+03, 4.19595060D+03,
     $ 4.14158110D+03, 4.08735660D+03, 4.03328050D+03, 3.97935620D+03,
     $ 3.92558670D+03, 3.87197490D+03, 3.81852350D+03, 3.76523470D+03,
     $ 3.71211050D+03/
      data ( FUPO( 54,J,1),J=1,13) /
     $ 6.399D-08, 1.925D-07, 3.849D-07, 6.413D-07, 9.617D-07, 1.341D-06,
     $ 1.779D-06, 2.275D-06, 2.823D-06, 3.424D-06, 4.074D-06, 4.771D-06,
     $ 5.521D-06/
      data (WNDNO( 54,J,1),J=1,13) /
     $ 3.95608670D+03, 3.90508490D+03, 3.85421730D+03, 3.80348740D+03,
     $ 3.75289890D+03, 3.70245550D+03, 3.65216040D+03, 3.60201700D+03,
     $ 3.55202830D+03, 3.50219720D+03, 3.45252620D+03, 3.40301760D+03,
     $ 3.35367330D+03/
      data ( FDNO( 54,J,1),J=1,13) /
     $ 3.363D-08, 1.023D-07, 2.075D-07, 3.488D-07, 5.260D-07, 7.402D-07,
     $ 9.908D-07, 1.277D-06, 1.598D-06, 1.954D-06, 2.344D-06, 2.767D-06,
     $ 3.201D-06/
      data (WNUPO( 54,J,2),J=1,13) /
     $ 4.26464620D+03, 4.21231370D+03, 4.16010620D+03, 4.10802710D+03,
     $ 4.05607970D+03, 4.00426740D+03, 3.95259330D+03, 3.90106050D+03,
     $ 3.84967180D+03, 3.79843000D+03, 3.74733750D+03, 3.69639640D+03,
     $ 3.64560870D+03/
      data ( FUPO( 54,J,2),J=1,13) /
     $ 5.928D-08, 1.784D-07, 3.568D-07, 5.949D-07, 8.921D-07, 1.245D-06,
     $ 1.653D-06, 2.115D-06, 2.626D-06, 3.186D-06, 3.793D-06, 4.444D-06,
     $ 5.137D-06/
      data (WNDNO( 54,J,2),J=1,13) /
     $ 3.87819650D+03, 3.82939750D+03, 3.78072360D+03, 3.73217810D+03,
     $ 3.68376450D+03, 3.63548590D+03, 3.58734550D+03, 3.53934620D+03,
     $ 3.49149100D+03, 3.44378240D+03, 3.39622300D+03, 3.34881470D+03,
     $ 3.30155960D+03/
      data ( FDNO( 54,J,2),J=1,13) /
     $ 3.157D-08, 9.606D-08, 1.948D-07, 3.273D-07, 4.937D-07, 6.949D-07,
     $ 9.303D-07, 1.198D-06, 1.501D-06, 1.836D-06, 2.202D-06, 2.600D-06,
     $ 3.029D-06/
      data (WNUPO( 55,J,1),J=1,13) /
     $ 4.35967020D+03, 4.30485250D+03, 4.25016870D+03, 4.19562270D+03,
     $ 4.14121810D+03, 4.08695850D+03, 4.03284740D+03, 3.97888810D+03,
     $ 3.92508360D+03, 3.87143700D+03, 3.81795070D+03, 3.76462700D+03,
     $ 3.71146790D+03/
      data ( FUPO( 55,J,1),J=1,13) /
     $ 6.443D-08, 1.939D-07, 3.873D-07, 6.453D-07, 9.670D-07, 1.350D-06,
     $ 1.790D-06, 2.287D-06, 2.839D-06, 3.443D-06, 4.095D-06, 4.795D-06,
     $ 5.550D-06/
      data (WNDNO( 55,J,1),J=1,13) /
     $ 3.94867760D+03, 3.89771070D+03, 3.84687800D+03, 3.79618310D+03,
     $ 3.74562960D+03, 3.69522130D+03, 3.64496130D+03, 3.59485310D+03,
     $ 3.54489970D+03, 3.49510380D+03, 3.44546820D+03, 3.39599490D+03,
     $ 3.34668600D+03/
      data ( FDNO( 55,J,1),J=1,13) /
     $ 3.351D-08, 1.019D-07, 2.068D-07, 3.475D-07, 5.239D-07, 7.374D-07,
     $ 9.865D-07, 1.272D-06, 1.592D-06, 1.947D-06, 2.335D-06, 2.757D-06,
     $ 3.188D-06/
      data (WNUPO( 55,J,2),J=1,13) /
     $ 4.26452520D+03, 4.21215980D+03, 4.15991940D+03, 4.10780750D+03,
     $ 4.05582730D+03, 4.00398230D+03, 3.95227550D+03, 3.90071000D+03,
     $ 3.84928870D+03, 3.79801430D+03, 3.74688910D+03, 3.69591550D+03,
     $ 3.64509520D+03/
      data ( FUPO( 55,J,2),J=1,13) /
     $ 5.967D-08, 1.796D-07, 3.591D-07, 5.985D-07, 8.974D-07, 1.252D-06,
     $ 1.662D-06, 2.127D-06, 2.640D-06, 3.203D-06, 3.813D-06, 4.467D-06,
     $ 5.163D-06/
      data (WNDNO( 55,J,2),J=1,13) /
     $ 3.87118520D+03, 3.82241880D+03, 3.77377750D+03, 3.72526480D+03,
     $ 3.67688390D+03, 3.62863800D+03, 3.58053050D+03, 3.53256410D+03,
     $ 3.48474180D+03, 3.43706620D+03, 3.38953980D+03, 3.34216460D+03,
     $ 3.29494250D+03/
      data ( FDNO( 55,J,2),J=1,13) /
     $ 3.145D-08, 9.568D-08, 1.940D-07, 3.261D-07, 4.918D-07, 6.923D-07,
     $ 9.270D-07, 1.194D-06, 1.495D-06, 1.829D-06, 2.194D-06, 2.590D-06,
     $ 3.018D-06/
      data (WNUPO( 56,J,1),J=1,13) /
     $ 4.35936980D+03, 4.30451690D+03, 4.24979790D+03, 4.19521670D+03,
     $ 4.14077700D+03, 4.08648230D+03, 4.03233620D+03, 3.97834180D+03,
     $ 3.92450240D+03, 3.87082080D+03, 3.81729960D+03, 3.76394110D+03,
     $ 3.71074700D+03/
      data ( FUPO( 56,J,1),J=1,13) /
     $ 6.486D-08, 1.951D-07, 3.898D-07, 6.494D-07, 9.730D-07, 1.357D-06,
     $ 1.800D-06, 2.300D-06, 2.855D-06, 3.461D-06, 4.117D-06, 4.821D-06,
     $ 5.577D-06/
      data (WNDNO( 56,J,1),J=1,13) /
     $ 3.94120650D+03, 3.89027450D+03, 3.83947660D+03, 3.78881660D+03,
     $ 3.73829820D+03, 3.68792490D+03, 3.63770010D+03, 3.58762700D+03,
     $ 3.53770880D+03, 3.48794830D+03, 3.43834790D+03, 3.38891000D+03,
     $ 3.33963650D+03/
      data ( FDNO( 56,J,1),J=1,13) /
     $ 3.339D-08, 1.015D-07, 2.059D-07, 3.461D-07, 5.219D-07, 7.345D-07,
     $ 9.832D-07, 1.267D-06, 1.586D-06, 1.939D-06, 2.326D-06, 2.746D-06,
     $ 3.176D-06/
      data (WNUPO( 56,J,2),J=1,13) /
     $ 4.26433140D+03, 4.21193310D+03, 4.15965990D+03, 4.10751510D+03,
     $ 4.05550210D+03, 4.00362430D+03, 3.95188480D+03, 3.90028660D+03,
     $ 3.84883260D+03, 3.79752560D+03, 3.74636790D+03, 3.69536160D+03,
     $ 3.64450880D+03/
      data ( FUPO( 56,J,2),J=1,13) /
     $ 6.007D-08, 1.807D-07, 3.613D-07, 6.022D-07, 9.027D-07, 1.259D-06,
     $ 1.672D-06, 2.139D-06, 2.654D-06, 3.220D-06, 3.832D-06, 4.489D-06,
     $ 5.189D-06/
      data (WNDNO( 56,J,2),J=1,13) /
     $ 3.86411570D+03, 3.81538190D+03, 3.76677330D+03, 3.71829320D+03,
     $ 3.66994500D+03, 3.62173190D+03, 3.57365720D+03, 3.52572370D+03,
     $ 3.47793440D+03, 3.43029180D+03, 3.38279830D+03, 3.33545620D+03,
     $ 3.28826710D+03/
      data ( FDNO( 56,J,2),J=1,13) /
     $ 3.134D-08, 9.531D-08, 1.933D-07, 3.249D-07, 4.899D-07, 6.896D-07,
     $ 9.230D-07, 1.189D-06, 1.489D-06, 1.821D-06, 2.186D-06, 2.581D-06,
     $ 3.006D-06/
      data (WNUPO( 57,J,1),J=1,13) /
     $ 4.35899120D+03, 4.30410300D+03, 4.24934880D+03, 4.19473250D+03,
     $ 4.14025760D+03, 4.08592780D+03, 4.03174660D+03, 3.97771720D+03,
     $ 3.92384280D+03, 3.87012630D+03, 3.81657020D+03, 3.76317670D+03,
     $ 3.70994770D+03/
      data ( FUPO( 57,J,1),J=1,13) /
     $ 6.531D-08, 1.964D-07, 3.923D-07, 6.535D-07, 9.788D-07, 1.365D-06,
     $ 1.811D-06, 2.313D-06, 2.871D-06, 3.481D-06, 4.139D-06, 4.846D-06,
     $ 5.605D-06/
      data (WNDNO( 57,J,1),J=1,13) /
     $ 3.93367340D+03, 3.88277620D+03, 3.83201320D+03, 3.78138810D+03,
     $ 3.73090470D+03, 3.68056640D+03, 3.63037680D+03, 3.58033890D+03,
     $ 3.53045590D+03, 3.48073060D+03, 3.43116560D+03, 3.38176300D+03,
     $ 3.33252480D+03/
      data ( FDNO( 57,J,1),J=1,13) /
     $ 3.326D-08, 1.011D-07, 2.052D-07, 3.448D-07, 5.199D-07, 7.317D-07,
     $ 9.791D-07, 1.262D-06, 1.580D-06, 1.931D-06, 2.317D-06, 2.736D-06,
     $ 3.163D-06/
      data (WNUPO( 57,J,2),J=1,13) /
     $ 4.26406470D+03, 4.21163350D+03, 4.15932740D+03, 4.10714980D+03,
     $ 4.05510400D+03, 4.00319330D+03, 3.95142110D+03, 3.89979020D+03,
     $ 3.84830350D+03, 3.79696380D+03, 3.74577350D+03, 3.69473470D+03,
     $ 3.64384920D+03/
      data ( FUPO( 57,J,2),J=1,13) /
     $ 6.047D-08, 1.819D-07, 3.635D-07, 6.058D-07, 9.080D-07, 1.267D-06,
     $ 1.681D-06, 2.150D-06, 2.669D-06, 3.237D-06, 3.852D-06, 4.512D-06,
     $ 5.215D-06/
      data (WNDNO( 57,J,2),J=1,13) /
     $ 3.85698820D+03, 3.80828700D+03, 3.75971090D+03, 3.71126350D+03,
     $ 3.66294800D+03, 3.61476770D+03, 3.56672580D+03, 3.51882520D+03,
     $ 3.47106880D+03, 3.42345910D+03, 3.37599870D+03, 3.32868960D+03,
     $ 3.28153360D+03/
      data ( FDNO( 57,J,2),J=1,13) /
     $ 3.123D-08, 9.496D-08, 1.926D-07, 3.237D-07, 4.881D-07, 6.870D-07,
     $ 9.191D-07, 1.185D-06, 1.484D-06, 1.815D-06, 2.177D-06, 2.570D-06,
     $ 2.996D-06/
      data (WNUPO( 58,J,1),J=1,13) /
     $ 4.35853430D+03, 4.30361080D+03, 4.24882140D+03, 4.19416980D+03,
     $ 4.13965980D+03, 4.08529480D+03, 4.03107850D+03, 3.97701410D+03,
     $ 3.92310470D+03, 3.86935320D+03, 3.81576210D+03, 3.76233370D+03,
     $ 3.70906980D+03/
      data ( FUPO( 58,J,1),J=1,13) /
     $ 6.576D-08, 1.977D-07, 3.948D-07, 6.576D-07, 9.852D-07, 1.373D-06,
     $ 1.821D-06, 2.327D-06, 2.887D-06, 3.499D-06, 4.162D-06, 4.871D-06,
     $ 5.634D-06/
      data (WNDNO( 58,J,1),J=1,13) /
     $ 3.92607850D+03, 3.87521610D+03, 3.82448800D+03, 3.77389780D+03,
     $ 3.72344940D+03, 3.67314610D+03, 3.62299150D+03, 3.57298880D+03,
     $ 3.52314110D+03, 3.47345110D+03, 3.42392130D+03, 3.37455410D+03,
     $ 3.32535120D+03/
      data ( FDNO( 58,J,1),J=1,13) /
     $ 3.315D-08, 1.008D-07, 2.044D-07, 3.435D-07, 5.179D-07, 7.289D-07,
     $ 9.752D-07, 1.257D-06, 1.574D-06, 1.924D-06, 2.309D-06, 2.726D-06,
     $ 3.151D-06/
      data (WNUPO( 58,J,2),J=1,13) /
     $ 4.26372500D+03, 4.21126090D+03, 4.15892190D+03, 4.10671130D+03,
     $ 4.05463270D+03, 4.00268920D+03, 3.95088420D+03, 3.89922060D+03,
     $ 3.84770120D+03, 3.79632890D+03, 3.74510590D+03, 3.69403440D+03,
     $ 3.64311630D+03/
      data ( FUPO( 58,J,2),J=1,13) /
     $ 6.088D-08, 1.831D-07, 3.658D-07, 6.096D-07, 9.139D-07, 1.275D-06,
     $ 1.691D-06, 2.163D-06, 2.683D-06, 3.255D-06, 3.873D-06, 4.536D-06,
     $ 5.242D-06/
      data (WNDNO( 58,J,2),J=1,13) /
     $ 3.84980270D+03, 3.80113410D+03, 3.75259060D+03, 3.70417580D+03,
     $ 3.65589300D+03, 3.60774550D+03, 3.55973640D+03, 3.51186860D+03,
     $ 3.46414510D+03, 3.41656850D+03, 3.36914100D+03, 3.32186490D+03,
     $ 3.27474200D+03/
      data ( FDNO( 58,J,2),J=1,13) /
     $ 3.111D-08, 9.462D-08, 1.919D-07, 3.225D-07, 4.862D-07, 6.844D-07,
     $ 9.162D-07, 1.180D-06, 1.479D-06, 1.808D-06, 2.169D-06, 2.562D-06,
     $ 2.984D-06/
      data (WNUPO( 59,J,1),J=1,13) /
     $ 4.35799890D+03, 4.30304020D+03, 4.24821550D+03, 4.19352860D+03,
     $ 4.13898340D+03, 4.08458330D+03, 4.03033190D+03, 3.97623240D+03,
     $ 3.92228800D+03, 3.86850150D+03, 3.81487540D+03, 3.76141200D+03,
     $ 3.70811310D+03/
      data ( FUPO( 59,J,1),J=1,13) /
     $ 6.621D-08, 1.991D-07, 3.974D-07, 6.616D-07, 9.915D-07, 1.381D-06,
     $ 1.832D-06, 2.340D-06, 2.903D-06, 3.518D-06, 4.184D-06, 4.897D-06,
     $ 5.662D-06/
      data (WNDNO( 59,J,1),J=1,13) /
     $ 3.91842190D+03, 3.86759430D+03, 3.81690100D+03, 3.76634580D+03,
     $ 3.71593220D+03, 3.66566400D+03, 3.61554450D+03, 3.56557700D+03,
     $ 3.51576440D+03, 3.46610970D+03, 3.41661520D+03, 3.36728330D+03,
     $ 3.31811570D+03/
      data ( FDNO( 59,J,1),J=1,13) /
     $ 3.303D-08, 1.004D-07, 2.037D-07, 3.423D-07, 5.160D-07, 7.261D-07,
     $ 9.714D-07, 1.252D-06, 1.567D-06, 1.917D-06, 2.299D-06, 2.715D-06,
     $ 3.139D-06/
      data (WNUPO( 59,J,2),J=1,13) /
     $ 4.26331210D+03, 4.21081510D+03, 4.15844310D+03, 4.10619970D+03,
     $ 4.05408810D+03, 4.00211190D+03, 3.95027400D+03, 3.89857760D+03,
     $ 3.84702560D+03, 3.79562050D+03, 3.74436490D+03, 3.69326080D+03,
     $ 3.64231000D+03/
      data ( FUPO( 59,J,2),J=1,13) /
     $ 6.128D-08, 1.843D-07, 3.682D-07, 6.133D-07, 9.188D-07, 1.282D-06,
     $ 1.701D-06, 2.174D-06, 2.698D-06, 3.272D-06, 3.893D-06, 4.559D-06,
     $ 5.268D-06/
      data (WNDNO( 59,J,2),J=1,13) /
     $ 3.84255950D+03, 3.79392330D+03, 3.74541250D+03, 3.69703030D+03,
     $ 3.64878020D+03, 3.60066540D+03, 3.55268910D+03, 3.50485420D+03,
     $ 3.45716360D+03, 3.40961990D+03, 3.36222540D+03, 3.31498230D+03,
     $ 3.26789240D+03/
      data ( FDNO( 59,J,2),J=1,13) /
     $ 3.100D-08, 9.429D-08, 1.912D-07, 3.213D-07, 4.844D-07, 6.818D-07,
     $ 9.126D-07, 1.176D-06, 1.473D-06, 1.801D-06, 2.161D-06, 2.552D-06,
     $ 2.973D-06/
      data (WNUPO( 60,J,1),J=1,13) /
     $ 4.35738490D+03, 4.30239080D+03, 4.24753080D+03, 4.19280870D+03,
     $ 4.13822820D+03, 4.08379300D+03, 4.02950640D+03, 3.97537190D+03,
     $ 3.92139240D+03, 3.86757080D+03, 3.81390970D+03, 3.76041130D+03,
     $ 3.70707740D+03/
      data ( FUPO( 60,J,1),J=1,13) /
     $ 6.666D-08, 2.003D-07, 3.999D-07, 6.658D-07, 9.975D-07, 1.390D-06,
     $ 1.843D-06, 2.353D-06, 2.918D-06, 3.538D-06, 4.206D-06, 4.923D-06,
     $ 5.691D-06/
      data (WNDNO( 60,J,1),J=1,13) /
     $ 3.91070380D+03, 3.85991100D+03, 3.80925250D+03, 3.75873210D+03,
     $ 3.70835350D+03, 3.65812030D+03, 3.60803590D+03, 3.55810350D+03,
     $ 3.50832610D+03, 3.45870660D+03, 3.40924740D+03, 3.35995080D+03,
     $ 3.31081860D+03/
      data ( FDNO( 60,J,1),J=1,13) /
     $ 3.291D-08, 1.001D-07, 2.029D-07, 3.410D-07, 5.140D-07, 7.234D-07,
     $ 9.678D-07, 1.248D-06, 1.562D-06, 1.910D-06, 2.291D-06, 2.705D-06,
     $ 3.127D-06/
      data (WNUPO( 60,J,2),J=1,13) /
     $ 4.26282600D+03, 4.21029590D+03, 4.15789100D+03, 4.10561460D+03,
     $ 4.05347020D+03, 4.00146110D+03, 3.94959040D+03, 3.89786130D+03,
     $ 3.84627650D+03, 3.79483870D+03, 3.74355040D+03, 3.69241360D+03,
     $ 3.64143010D+03/
      data ( FUPO( 60,J,2),J=1,13) /
     $ 6.170D-08, 1.855D-07, 3.705D-07, 6.171D-07, 9.244D-07, 1.289D-06,
     $ 1.710D-06, 2.187D-06, 2.713D-06, 3.289D-06, 3.913D-06, 4.582D-06,
     $ 5.294D-06/
      data (WNDNO( 60,J,2),J=1,13) /
     $ 3.83525850D+03, 3.78665490D+03, 3.73817660D+03, 3.68982700D+03,
     $ 3.64160960D+03, 3.59352750D+03, 3.54558400D+03, 3.49778200D+03,
     $ 3.45012420D+03, 3.40261350D+03, 3.35525200D+03, 3.30804190D+03,
     $ 3.26098500D+03/
      data ( FDNO( 60,J,2),J=1,13) /
     $ 3.089D-08, 9.397D-08, 1.905D-07, 3.201D-07, 4.826D-07, 6.793D-07,
     $ 9.091D-07, 1.171D-06, 1.467D-06, 1.794D-06, 2.153D-06, 2.542D-06,
     $ 2.962D-06/
      data (WNUPO( 61,J,1),J=1,13) /
     $ 4.35669220D+03, 4.30166270D+03, 4.24676740D+03, 4.19201000D+03,
     $ 4.13739420D+03, 4.08292380D+03, 4.02860200D+03, 3.97443230D+03,
     $ 3.92041780D+03, 3.86656120D+03, 3.81286510D+03, 3.75933160D+03,
     $ 3.70596270D+03/
      data ( FUPO( 61,J,1),J=1,13) /
     $ 6.712D-08, 2.017D-07, 4.026D-07, 6.700D-07, 1.003D-06, 1.398D-06,
     $ 1.853D-06, 2.367D-06, 2.935D-06, 3.557D-06, 4.228D-06, 4.948D-06,
     $ 5.720D-06/
      data (WNDNO( 61,J,1),J=1,13) /
     $ 3.90292430D+03, 3.85216620D+03, 3.80154250D+03, 3.75105700D+03,
     $ 3.70071330D+03, 3.65051510D+03, 3.60046570D+03, 3.55056840D+03,
     $ 3.50082620D+03, 3.45124190D+03, 3.40181800D+03, 3.35255670D+03,
     $ 3.30345980D+03/
      data ( FDNO( 61,J,1),J=1,13) /
     $ 3.279D-08, 9.967D-08, 2.022D-07, 3.398D-07, 5.121D-07, 7.207D-07,
     $ 9.642D-07, 1.243D-06, 1.556D-06, 1.902D-06, 2.282D-06, 2.695D-06,
     $ 3.115D-06/
      data (WNUPO( 61,J,2),J=1,13) /
     $ 4.26226640D+03, 4.20970340D+03, 4.15726540D+03, 4.10495610D+03,
     $ 4.05277880D+03, 4.00073670D+03, 3.94883320D+03, 3.89707130D+03,
     $ 3.84545370D+03, 3.79398320D+03, 3.74266220D+03, 3.69149270D+03,
     $ 3.64047650D+03/
      data ( FUPO( 61,J,2),J=1,13) /
     $ 6.211D-08, 1.867D-07, 3.729D-07, 6.209D-07, 9.306D-07, 1.297D-06,
     $ 1.721D-06, 2.199D-06, 2.727D-06, 3.307D-06, 3.934D-06, 4.606D-06,
     $ 5.321D-06/
      data (WNDNO( 61,J,2),J=1,13) /
     $ 3.82790000D+03, 3.77932890D+03, 3.73088310D+03, 3.68256620D+03,
     $ 3.63438140D+03, 3.58633200D+03, 3.53842130D+03, 3.49065200D+03,
     $ 3.44302720D+03, 3.39554940D+03, 3.34822090D+03, 3.30104380D+03,
     $ 3.25401990D+03/
      data ( FDNO( 61,J,2),J=1,13) /
     $ 3.078D-08, 9.358D-08, 1.898D-07, 3.189D-07, 4.808D-07, 6.767D-07,
     $ 9.057D-07, 1.167D-06, 1.462D-06, 1.788D-06, 2.145D-06, 2.533D-06,
     $ 2.951D-06/
      data (WNUPO( 62,J,1),J=1,13) /
     $ 4.35592050D+03, 4.30085570D+03, 4.24592500D+03, 4.19113220D+03,
     $ 4.13648120D+03, 4.08197550D+03, 4.02761860D+03, 3.97341370D+03,
     $ 3.91936400D+03, 3.86547240D+03, 3.81174120D+03, 3.75817270D+03,
     $ 3.70476860D+03/
      data ( FUPO( 62,J,1),J=1,13) /
     $ 6.758D-08, 2.030D-07, 4.051D-07, 6.742D-07, 1.010D-06, 1.407D-06,
     $ 1.864D-06, 2.380D-06, 2.951D-06, 3.576D-06, 4.251D-06, 4.974D-06,
     $ 5.749D-06/
      data (WNDNO( 62,J,1),J=1,13) /
     $ 3.89508350D+03, 3.84436010D+03, 3.79377120D+03, 3.74332050D+03,
     $ 3.69301170D+03, 3.64284850D+03, 3.59283410D+03, 3.54297200D+03,
     $ 3.49326490D+03, 3.44371590D+03, 3.39432720D+03, 3.34510120D+03,
     $ 3.29603950D+03/
      data ( FDNO( 62,J,1),J=1,13) /
     $ 3.268D-08, 9.936D-08, 2.014D-07, 3.385D-07, 5.102D-07, 7.180D-07,
     $ 9.608D-07, 1.238D-06, 1.550D-06, 1.895D-06, 2.274D-06, 2.685D-06,
     $ 3.103D-06/
      data (WNUPO( 62,J,2),J=1,13) /
     $ 4.26163320D+03, 4.20903720D+03, 4.15656620D+03, 4.10422390D+03,
     $ 4.05201360D+03, 3.99993870D+03, 3.94800240D+03, 3.89620760D+03,
     $ 3.84455720D+03, 3.79305400D+03, 3.74170020D+03, 3.69049800D+03,
     $ 3.63944900D+03/
      data ( FUPO( 62,J,2),J=1,13) /
     $ 6.253D-08, 1.880D-07, 3.752D-07, 6.247D-07, 9.358D-07, 1.305D-06,
     $ 1.730D-06, 2.211D-06, 2.742D-06, 3.324D-06, 3.954D-06, 4.630D-06,
     $ 5.348D-06/
      data (WNDNO( 62,J,2),J=1,13) /
     $ 3.82048400D+03, 3.77194540D+03, 3.72353220D+03, 3.67524780D+03,
     $ 3.62709560D+03, 3.57907900D+03, 3.53120100D+03, 3.48346460D+03,
     $ 3.43587260D+03, 3.38842770D+03, 3.34113220D+03, 3.29398810D+03,
     $ 3.24699720D+03/
      data ( FDNO( 62,J,2),J=1,13) /
     $ 3.068D-08, 9.328D-08, 1.891D-07, 3.178D-07, 4.791D-07, 6.743D-07,
     $ 9.024D-07, 1.162D-06, 1.457D-06, 1.781D-06, 2.137D-06, 2.524D-06,
     $ 2.941D-06/
      data (WNUPO( 63,J,1),J=1,13) /
     $ 4.35506980D+03, 4.29996950D+03, 4.24500340D+03, 4.19017530D+03,
     $ 4.13548900D+03, 4.08094800D+03, 4.02655580D+03, 3.97231580D+03,
     $ 3.91823100D+03, 3.86430420D+03, 3.81053790D+03, 3.75693430D+03,
     $ 3.70349510D+03/
      data ( FUPO( 63,J,1),J=1,13) /
     $ 6.805D-08, 2.044D-07, 4.078D-07, 6.785D-07, 1.016D-06, 1.415D-06,
     $ 1.875D-06, 2.394D-06, 2.968D-06, 3.596D-06, 4.274D-06, 5.000D-06,
     $ 5.778D-06/
      data (WNDNO( 63,J,1),J=1,13) /
     $ 3.88718150D+03, 3.83649280D+03, 3.78593870D+03, 3.73552280D+03,
     $ 3.68524890D+03, 3.63512060D+03, 3.58514130D+03, 3.53531420D+03,
     $ 3.48564230D+03, 3.43612850D+03, 3.38677510D+03, 3.33758430D+03,
     $ 3.28855790D+03/
      data ( FDNO( 63,J,1),J=1,13) /
     $ 3.257D-08, 9.898D-08, 2.008D-07, 3.372D-07, 5.083D-07, 7.154D-07,
     $ 9.575D-07, 1.234D-06, 1.544D-06, 1.888D-06, 2.265D-06, 2.675D-06,
     $ 3.091D-06/
      data (WNUPO( 63,J,2),J=1,13) /
     $ 4.26092640D+03, 4.20829730D+03, 4.15579330D+03, 4.10341800D+03,
     $ 4.05117470D+03, 3.99906690D+03, 3.94709760D+03, 3.89527000D+03,
     $ 3.84358680D+03, 3.79205080D+03, 3.74066420D+03, 3.68942920D+03,
     $ 3.63834750D+03/
      data ( FUPO( 63,J,2),J=1,13) /
     $ 6.294D-08, 1.892D-07, 3.776D-07, 6.286D-07, 9.416D-07, 1.312D-06,
     $ 1.740D-06, 2.223D-06, 2.758D-06, 3.342D-06, 3.975D-06, 4.654D-06,
     $ 5.375D-06/
      data (WNDNO( 63,J,2),J=1,13) /
     $ 3.81301080D+03, 3.76450460D+03, 3.71612390D+03, 3.66787200D+03,
     $ 3.61975250D+03, 3.57176850D+03, 3.52392330D+03, 3.47621970D+03,
     $ 3.42866060D+03, 3.38124860D+03, 3.33398600D+03, 3.28687490D+03,
     $ 3.23991700D+03/
      data ( FDNO( 63,J,2),J=1,13) /
     $ 3.057D-08, 9.291D-08, 1.884D-07, 3.167D-07, 4.774D-07, 6.718D-07,
     $ 8.992D-07, 1.158D-06, 1.451D-06, 1.775D-06, 2.129D-06, 2.514D-06,
     $ 2.930D-06/
      data (WNUPO( 64,J,1),J=1,13) /
     $ 4.35413980D+03, 4.29900410D+03, 4.24400260D+03, 4.18913910D+03,
     $ 4.13441740D+03, 4.07984110D+03, 4.02541370D+03, 3.97113850D+03,
     $ 3.91701850D+03, 3.86305650D+03, 3.80925510D+03, 3.75561640D+03,
     $ 3.70214210D+03/
      data ( FUPO( 64,J,1),J=1,13) /
     $ 6.852D-08, 2.057D-07, 4.104D-07, 6.828D-07, 1.022D-06, 1.424D-06,
     $ 1.886D-06, 2.407D-06, 2.984D-06, 3.616D-06, 4.297D-06, 5.027D-06,
     $ 5.807D-06/
      data (WNDNO( 64,J,1),J=1,13) /
     $ 3.87921860D+03, 3.82856460D+03, 3.77804510D+03, 3.72766400D+03,
     $ 3.67742500D+03, 3.62733170D+03, 3.57738740D+03, 3.52759530D+03,
     $ 3.47795860D+03, 3.42847990D+03, 3.37916180D+03, 3.33000620D+03,
     $ 3.28101510D+03/
      data ( FDNO( 64,J,1),J=1,13) /
     $ 3.246D-08, 9.868D-08, 2.001D-07, 3.360D-07, 5.065D-07, 7.127D-07,
     $ 9.535D-07, 1.229D-06, 1.539D-06, 1.881D-06, 2.257D-06, 2.665D-06,
     $ 3.080D-06/
      data (WNUPO( 64,J,2),J=1,13) /
     $ 4.26014570D+03, 4.20748350D+03, 4.15494650D+03, 4.10253810D+03,
     $ 4.05026180D+03, 3.99812100D+03, 3.94611890D+03, 3.89425840D+03,
     $ 3.84254240D+03, 3.79097350D+03, 3.73955420D+03, 3.68828640D+03,
     $ 3.63717190D+03/
      data ( FUPO( 64,J,2),J=1,13) /
     $ 6.337D-08, 1.904D-07, 3.800D-07, 6.325D-07, 9.472D-07, 1.320D-06,
     $ 1.750D-06, 2.236D-06, 2.772D-06, 3.361D-06, 3.996D-06, 4.678D-06,
     $ 5.402D-06/
      data (WNDNO( 64,J,2),J=1,13) /
     $ 3.80548030D+03, 3.75700660D+03, 3.70865830D+03, 3.66043900D+03,
     $ 3.61235210D+03, 3.56440080D+03, 3.51658830D+03, 3.46891750D+03,
     $ 3.42139120D+03, 3.37401210D+03, 3.32678250D+03, 3.27970430D+03,
     $ 3.23277940D+03/
      data ( FDNO( 64,J,2),J=1,13) /
     $ 3.047D-08, 9.264D-08, 1.878D-07, 3.156D-07, 4.757D-07, 6.694D-07,
     $ 8.961D-07, 1.154D-06, 1.446D-06, 1.768D-06, 2.122D-06, 2.505D-06,
     $ 2.919D-06/
      data (WNUPO( 65,J,1),J=1,13) /
     $ 4.35313050D+03, 4.29795940D+03, 4.24292240D+03, 4.18802350D+03,
     $ 4.13326640D+03, 4.07865480D+03, 4.02419210D+03, 3.96988160D+03,
     $ 3.91572640D+03, 3.86172920D+03, 3.80789260D+03, 3.75421870D+03,
     $ 3.70070920D+03/
      data ( FUPO( 65,J,1),J=1,13) /
     $ 6.899D-08, 2.071D-07, 4.131D-07, 6.871D-07, 1.028D-06, 1.432D-06,
     $ 1.897D-06, 2.421D-06, 3.002D-06, 3.635D-06, 4.319D-06, 5.053D-06,
     $ 5.836D-06/
      data (WNDNO( 65,J,1),J=1,13) /
     $ 3.87119470D+03, 3.82057540D+03, 3.77009060D+03, 3.71974430D+03,
     $ 3.66954020D+03, 3.61948170D+03, 3.56957240D+03, 3.51981540D+03,
     $ 3.47021380D+03, 3.42077030D+03, 3.37148730D+03, 3.32236710D+03,
     $ 3.27341120D+03/
      data ( FDNO( 65,J,1),J=1,13) /
     $ 3.234D-08, 9.832D-08, 1.993D-07, 3.349D-07, 5.047D-07, 7.102D-07,
     $ 9.504D-07, 1.224D-06, 1.533D-06, 1.874D-06, 2.249D-06, 2.656D-06,
     $ 3.068D-06/
      data (WNUPO( 65,J,2),J=1,13) /
     $ 4.25929110D+03, 4.20659580D+03, 4.15402560D+03, 4.10158420D+03,
     $ 4.04927490D+03, 3.99710110D+03, 3.94506600D+03, 3.89317260D+03,
     $ 3.84142370D+03, 3.78982200D+03, 3.73836980D+03, 3.68706920D+03,
     $ 3.63592190D+03/
      data ( FUPO( 65,J,2),J=1,13) /
     $ 6.380D-08, 1.916D-07, 3.824D-07, 6.364D-07, 9.527D-07, 1.328D-06,
     $ 1.760D-06, 2.249D-06, 2.788D-06, 3.378D-06, 4.017D-06, 4.702D-06,
     $ 5.429D-06/
      data (WNDNO( 65,J,2),J=1,13) /
     $ 3.79789280D+03, 3.74945150D+03, 3.70113570D+03, 3.65294890D+03,
     $ 3.60489460D+03, 3.55697590D+03, 3.50919610D+03, 3.46155810D+03,
     $ 3.41406470D+03, 3.36671840D+03, 3.31952170D+03, 3.27247650D+03,
     $ 3.22558450D+03/
      data ( FDNO( 65,J,2),J=1,13) /
     $ 3.037D-08, 9.229D-08, 1.872D-07, 3.144D-07, 4.740D-07, 6.670D-07,
     $ 8.924D-07, 1.150D-06, 1.440D-06, 1.762D-06, 2.114D-06, 2.496D-06,
     $ 2.909D-06/
      data (WNUPO( 66,J,1),J=1,13) /
     $ 4.35204180D+03, 4.29683510D+03, 4.24176260D+03, 4.18682820D+03,
     $ 4.13203570D+03, 4.07738870D+03, 4.02289070D+03, 3.96854490D+03,
     $ 3.91435450D+03, 3.86032210D+03, 3.80645030D+03, 3.75274120D+03,
     $ 3.69919650D+03/
      data ( FUPO( 66,J,1),J=1,13) /
     $ 6.947D-08, 2.085D-07, 4.158D-07, 6.915D-07, 1.034D-06, 1.440D-06,
     $ 1.908D-06, 2.435D-06, 3.018D-06, 3.655D-06, 4.343D-06, 5.079D-06,
     $ 5.866D-06/
      data (WNDNO( 66,J,1),J=1,13) /
     $ 3.86311010D+03, 3.81252540D+03, 3.76207540D+03, 3.71176380D+03,
     $ 3.66159440D+03, 3.61157090D+03, 3.56169650D+03, 3.51197460D+03,
     $ 3.46240810D+03, 3.41299970D+03, 3.36375200D+03, 3.31466690D+03,
     $ 3.26574630D+03/
      data ( FDNO( 66,J,1),J=1,13) /
     $ 3.224D-08, 9.797D-08, 1.986D-07, 3.337D-07, 5.029D-07, 7.076D-07,
     $ 9.466D-07, 1.220D-06, 1.527D-06, 1.868D-06, 2.241D-06, 2.646D-06,
     $ 3.056D-06/
      data (WNUPO( 66,J,2),J=1,13) /
     $ 4.25836240D+03, 4.20563390D+03, 4.15303060D+03, 4.10055610D+03,
     $ 4.04821370D+03, 3.99600690D+03, 3.94393880D+03, 3.89201250D+03,
     $ 3.84023070D+03, 3.78859610D+03, 3.73711110D+03, 3.68577770D+03,
     $ 3.63459750D+03/
      data ( FUPO( 66,J,2),J=1,13) /
     $ 6.423D-08, 1.929D-07, 3.849D-07, 6.404D-07, 9.588D-07, 1.336D-06,
     $ 1.770D-06, 2.261D-06, 2.803D-06, 3.397D-06, 4.038D-06, 4.726D-06,
     $ 5.457D-06/
      data (WNDNO( 66,J,2),J=1,13) /
     $ 3.79024830D+03, 3.74183940D+03, 3.69355600D+03, 3.64540180D+03,
     $ 3.59738000D+03, 3.54949390D+03, 3.50174680D+03, 3.45414160D+03,
     $ 3.40668100D+03, 3.35936760D+03, 3.31220380D+03, 3.26519150D+03,
     $ 3.21833250D+03/
      data ( FDNO( 66,J,2),J=1,13) /
     $ 3.026D-08, 9.203D-08, 1.865D-07, 3.134D-07, 4.723D-07, 6.646D-07,
     $ 8.895D-07, 1.146D-06, 1.435D-06, 1.755D-06, 2.106D-06, 2.487D-06,
     $ 2.898D-06/
      data (WNUPO( 67,J,1),J=1,13) /
     $ 4.35087330D+03, 4.29563110D+03, 4.24052310D+03, 4.18555320D+03,
     $ 4.13072520D+03, 4.07604280D+03, 4.02150940D+03, 3.96712830D+03,
     $ 3.91290260D+03, 3.85883500D+03, 3.80492800D+03, 3.75118360D+03,
     $ 3.69760360D+03/
      data ( FUPO( 67,J,1),J=1,13) /
     $ 6.995D-08, 2.099D-07, 4.185D-07, 6.959D-07, 1.041D-06, 1.449D-06,
     $ 1.920D-06, 2.449D-06, 3.035D-06, 3.675D-06, 4.366D-06, 5.106D-06,
     $ 5.895D-06/
      data (WNDNO( 67,J,1),J=1,13) /
     $ 3.85496500D+03, 3.80441480D+03, 3.75399940D+03, 3.70372250D+03,
     $ 3.65358800D+03, 3.60359930D+03, 3.55375990D+03, 3.50407300D+03,
     $ 3.45454160D+03, 3.40516830D+03, 3.35595580D+03, 3.30690590D+03,
     $ 3.25802050D+03/
      data ( FDNO( 67,J,1),J=1,13) /
     $ 3.213D-08, 9.763D-08, 1.980D-07, 3.325D-07, 5.011D-07, 7.050D-07,
     $ 9.430D-07, 1.216D-06, 1.521D-06, 1.861D-06, 2.232D-06, 2.636D-06,
     $ 3.045D-06/
      data (WNUPO( 67,J,2),J=1,13) /
     $ 4.25735940D+03, 4.20459770D+03, 4.15196130D+03, 4.09945360D+03,
     $ 4.04707820D+03, 3.99483830D+03, 3.94273720D+03, 3.89077790D+03,
     $ 3.83896320D+03, 3.78729570D+03, 3.73577780D+03, 3.68441150D+03,
     $ 3.63319840D+03/
      data ( FUPO( 67,J,2),J=1,13) /
     $ 6.466D-08, 1.942D-07, 3.873D-07, 6.444D-07, 9.647D-07, 1.344D-06,
     $ 1.780D-06, 2.274D-06, 2.819D-06, 3.415D-06, 4.059D-06, 4.750D-06,
     $ 5.485D-06/
      data (WNDNO( 67,J,2),J=1,13) /
     $ 3.78254700D+03, 3.73417040D+03, 3.68591950D+03, 3.63779770D+03,
     $ 3.58980850D+03, 3.54195510D+03, 3.49424060D+03, 3.44666810D+03,
     $ 3.39924030D+03, 3.35195980D+03, 3.30482890D+03, 3.25784950D+03,
     $ 3.21102340D+03/
      data ( FDNO( 67,J,2),J=1,13) /
     $ 3.017D-08, 9.170D-08, 1.859D-07, 3.123D-07, 4.707D-07, 6.623D-07,
     $ 8.859D-07, 1.141D-06, 1.430D-06, 1.749D-06, 2.099D-06, 2.479D-06,
     $ 2.888D-06/
      data (WNUPO( 68,J,1),J=1,13) /
     $ 4.34962510D+03, 4.29434730D+03, 4.23920370D+03, 4.18419820D+03,
     $ 4.12933480D+03, 4.07461690D+03, 4.02004810D+03, 3.96563170D+03,
     $ 3.91137060D+03, 3.85726770D+03, 3.80332540D+03, 3.74954580D+03,
     $ 3.69593050D+03/
      data ( FUPO( 68,J,1),J=1,13) /
     $ 7.043D-08, 2.113D-07, 4.213D-07, 7.003D-07, 1.047D-06, 1.458D-06,
     $ 1.930D-06, 2.463D-06, 3.052D-06, 3.695D-06, 4.390D-06, 5.133D-06,
     $ 5.926D-06/
      data (WNDNO( 68,J,1),J=1,13) /
     $ 3.84675930D+03, 3.79624370D+03, 3.74586290D+03, 3.69562070D+03,
     $ 3.64552090D+03, 3.59556710D+03, 3.54576260D+03, 3.49611070D+03,
     $ 3.44661440D+03, 3.39727630D+03, 3.34809890D+03, 3.29908420D+03,
     $ 3.25023390D+03/
      data ( FDNO( 68,J,1),J=1,13) /
     $ 3.203D-08, 9.737D-08, 1.973D-07, 3.314D-07, 4.993D-07, 7.025D-07,
     $ 9.401D-07, 1.212D-06, 1.516D-06, 1.854D-06, 2.224D-06, 2.627D-06,
     $ 3.034D-06/
      data (WNUPO( 68,J,2),J=1,13) /
     $ 4.25628210D+03, 4.20348720D+03, 4.15081750D+03, 4.09827670D+03,
     $ 4.04586810D+03, 3.99359520D+03, 3.94146100D+03, 3.88946870D+03,
     $ 3.83762110D+03, 3.78592070D+03, 3.73436980D+03, 3.68297060D+03,
     $ 3.63172460D+03/
      data ( FUPO( 68,J,2),J=1,13) /
     $ 6.510D-08, 1.955D-07, 3.898D-07, 6.484D-07, 9.704D-07, 1.351D-06,
     $ 1.790D-06, 2.287D-06, 2.834D-06, 3.433D-06, 4.081D-06, 4.775D-06,
     $ 5.513D-06/
      data (WNDNO( 68,J,2),J=1,13) /
     $ 3.77478900D+03, 3.72644480D+03, 3.67822620D+03, 3.63013690D+03,
     $ 3.58218020D+03, 3.53435930D+03, 3.48667750D+03, 3.43913780D+03,
     $ 3.39174280D+03, 3.34449510D+03, 3.29739710D+03, 3.25045060D+03,
     $ 3.20365740D+03/
      data ( FDNO( 68,J,2),J=1,13) /
     $ 3.007D-08, 9.139D-08, 1.853D-07, 3.112D-07, 4.690D-07, 6.599D-07,
     $ 8.832D-07, 1.138D-06, 1.425D-06, 1.742D-06, 2.091D-06, 2.469D-06,
     $ 2.878D-06/
      data (WNUPO( 69,J,1),J=1,13) /
     $ 4.34829700D+03, 4.29298350D+03, 4.23780420D+03, 4.18276320D+03,
     $ 4.12786420D+03, 4.07311090D+03, 4.01850670D+03, 3.96405480D+03,
     $ 3.90975840D+03, 3.85562020D+03, 3.80164250D+03, 3.74782760D+03,
     $ 3.69417690D+03/
      data ( FUPO( 69,J,1),J=1,13) /
     $ 7.092D-08, 2.128D-07, 4.240D-07, 7.047D-07, 1.054D-06, 1.466D-06,
     $ 1.942D-06, 2.477D-06, 3.069D-06, 3.715D-06, 4.413D-06, 5.160D-06,
     $ 5.955D-06/
      data (WNDNO( 69,J,1),J=1,13) /
     $ 3.83849320D+03, 3.78801220D+03, 3.73766600D+03, 3.68745850D+03,
     $ 3.63739340D+03, 3.58747440D+03, 3.53770480D+03, 3.48808790D+03,
     $ 3.43862660D+03, 3.38932360D+03, 3.34018140D+03, 3.29120190D+03,
     $ 3.24238680D+03/
      data ( FDNO( 69,J,1),J=1,13) /
     $ 3.193D-08, 9.705D-08, 1.966D-07, 3.302D-07, 4.976D-07, 7.000D-07,
     $ 9.367D-07, 1.207D-06, 1.511D-06, 1.847D-06, 2.216D-06, 2.617D-06,
     $ 3.022D-06/
      data (WNUPO( 69,J,2),J=1,13) /
     $ 4.25513020D+03, 4.20230210D+03, 4.14959920D+03, 4.09702520D+03,
     $ 4.04458350D+03, 3.99227740D+03, 3.94011020D+03, 3.88808480D+03,
     $ 3.83620420D+03, 3.78447080D+03, 3.73288700D+03, 3.68145480D+03,
     $ 3.63017580D+03/
      data ( FUPO( 69,J,2),J=1,13) /
     $ 6.554D-08, 1.967D-07, 3.923D-07, 6.524D-07, 9.759D-07, 1.359D-06,
     $ 1.801D-06, 2.299D-06, 2.850D-06, 3.452D-06, 4.103D-06, 4.799D-06,
     $ 5.541D-06/
      data (WNDNO( 69,J,2),J=1,13) /
     $ 3.76697440D+03, 3.71866240D+03, 3.67047630D+03, 3.62241940D+03,
     $ 3.57449520D+03, 3.52670690D+03, 3.47905770D+03, 3.43155070D+03,
     $ 3.38418850D+03, 3.33697360D+03, 3.28990840D+03, 3.24299490D+03,
     $ 3.19623460D+03/
      data ( FDNO( 69,J,2),J=1,13) /
     $ 2.998D-08, 9.108D-08, 1.846D-07, 3.101D-07, 4.674D-07, 6.576D-07,
     $ 8.799D-07, 1.134D-06, 1.420D-06, 1.737D-06, 2.083D-06, 2.460D-06,
     $ 2.868D-06/
      data (WNUPO( 70,J,1),J=1,13) /
     $ 4.34688870D+03, 4.29153950D+03, 4.23632460D+03, 4.18124800D+03,
     $ 4.12631340D+03, 4.07152460D+03, 4.01688490D+03, 3.96239760D+03,
     $ 3.90806580D+03, 3.85389220D+03, 3.79987910D+03, 3.74602880D+03,
     $ 3.69234270D+03/
      data ( FUPO( 70,J,1),J=1,13) /
     $ 7.141D-08, 2.142D-07, 4.268D-07, 7.092D-07, 1.060D-06, 1.476D-06,
     $ 1.953D-06, 2.491D-06, 3.086D-06, 3.736D-06, 4.437D-06, 5.187D-06,
     $ 5.986D-06/
      data (WNDNO( 70,J,1),J=1,13) /
     $ 3.83016700D+03, 3.77972040D+03, 3.72940880D+03, 3.67923590D+03,
     $ 3.62920560D+03, 3.57932140D+03, 3.52958670D+03, 3.48000470D+03,
     $ 3.43057840D+03, 3.38131050D+03, 3.33220340D+03, 3.28325900D+03,
     $ 3.23447910D+03/
      data ( FDNO( 70,J,1),J=1,13) /
     $ 3.182D-08, 9.674D-08, 1.960D-07, 3.291D-07, 4.959D-07, 6.976D-07,
     $ 9.333D-07, 1.203D-06, 1.505D-06, 1.840D-06, 2.208D-06, 2.608D-06,
     $ 3.011D-06/
      data (WNUPO( 70,J,2),J=1,13) /
     $ 4.25390370D+03, 4.20104230D+03, 4.14830620D+03, 4.09569890D+03,
     $ 4.04322400D+03, 3.99088480D+03, 3.93868440D+03, 3.88662600D+03,
     $ 3.83471230D+03, 3.78294600D+03, 3.73132920D+03, 3.67986400D+03,
     $ 3.62855190D+03/
      data ( FUPO( 70,J,2),J=1,13) /
     $ 6.599D-08, 1.981D-07, 3.948D-07, 6.565D-07, 9.820D-07, 1.368D-06,
     $ 1.812D-06, 2.312D-06, 2.865D-06, 3.471D-06, 4.124D-06, 4.824D-06,
     $ 5.568D-06/
      data (WNDNO( 70,J,2),J=1,13) /
     $ 3.75910330D+03, 3.71082360D+03, 3.66266980D+03, 3.61464530D+03,
     $ 3.56675360D+03, 3.51899790D+03, 3.47138130D+03, 3.42390700D+03,
     $ 3.37657750D+03, 3.32939550D+03, 3.28236310D+03, 3.23548250D+03,
     $ 3.18875510D+03/
      data ( FDNO( 70,J,2),J=1,13) /
     $ 2.988D-08, 9.078D-08, 1.840D-07, 3.091D-07, 4.658D-07, 6.554D-07,
     $ 8.766D-07, 1.130D-06, 1.415D-06, 1.730D-06, 2.076D-06, 2.452D-06,
     $ 2.858D-06/
      data (WNUPO( 71,J,1),J=1,13) /
     $ 4.34540020D+03, 4.29001530D+03, 4.23476470D+03, 4.17965240D+03,
     $ 4.12468220D+03, 4.06985780D+03, 4.01518250D+03, 3.96065980D+03,
     $ 3.90629250D+03, 3.85208350D+03, 3.79803510D+03, 3.74414930D+03,
     $ 3.69042770D+03/
      data ( FUPO( 71,J,1),J=1,13) /
     $ 7.191D-08, 2.157D-07, 4.296D-07, 7.135D-07, 1.067D-06, 1.484D-06,
     $ 1.965D-06, 2.506D-06, 3.104D-06, 3.756D-06, 4.460D-06, 5.214D-06,
     $ 6.016D-06/
      data (WNDNO( 71,J,1),J=1,13) /
     $ 3.82178060D+03, 3.77136850D+03, 3.72109140D+03, 3.67095320D+03,
     $ 3.62095750D+03, 3.57110810D+03, 3.52140820D+03, 3.47186120D+03,
     $ 3.42246990D+03, 3.37323710D+03, 3.32416500D+03, 3.27525580D+03,
     $ 3.22651100D+03/
      data ( FDNO( 71,J,1),J=1,13) /
     $ 3.173D-08, 9.636D-08, 1.953D-07, 3.280D-07, 4.942D-07, 6.952D-07,
     $ 9.301D-07, 1.199D-06, 1.500D-06, 1.834D-06, 2.200D-06, 2.599D-06,
     $ 3.001D-06/
      data (WNUPO( 71,J,2),J=1,13) /
     $ 4.25260250D+03, 4.19970770D+03, 4.14693830D+03, 4.09429770D+03,
     $ 4.04178960D+03, 3.98941720D+03, 3.93718370D+03, 3.88509220D+03,
     $ 3.83314540D+03, 3.78134600D+03, 3.72969620D+03, 3.67819790D+03,
     $ 3.62685290D+03/
      data ( FUPO( 71,J,2),J=1,13) /
     $ 6.643D-08, 1.994D-07, 3.973D-07, 6.606D-07, 9.879D-07, 1.375D-06,
     $ 1.822D-06, 2.326D-06, 2.881D-06, 3.489D-06, 4.146D-06, 4.850D-06,
     $ 5.597D-06/
      data (WNDNO( 71,J,2),J=1,13) /
     $ 3.75117580D+03, 3.70292850D+03, 3.65480690D+03, 3.60681480D+03,
     $ 3.55895550D+03, 3.51123240D+03, 3.46364840D+03, 3.41620670D+03,
     $ 3.36891000D+03, 3.32176070D+03, 3.27476120D+03, 3.22791340D+03,
     $ 3.18121890D+03/
      data ( FDNO( 71,J,2),J=1,13) /
     $ 2.979D-08, 9.049D-08, 1.834D-07, 3.080D-07, 4.642D-07, 6.531D-07,
     $ 8.741D-07, 1.126D-06, 1.410D-06, 1.724D-06, 2.069D-06, 2.443D-06,
     $ 2.848D-06/
      data (WNUPO( 72,J,1),J=1,13) /
     $ 4.34383130D+03, 4.28841060D+03, 4.23312430D+03, 4.17797630D+03,
     $ 4.12297040D+03, 4.06811030D+03, 4.01339950D+03, 3.95884130D+03,
     $ 3.90443850D+03, 3.85019400D+03, 3.79611010D+03, 3.74218890D+03,
     $ 3.68843180D+03/
      data ( FUPO( 72,J,1),J=1,13) /
     $ 7.238D-08, 2.171D-07, 4.324D-07, 7.182D-07, 1.073D-06, 1.493D-06,
     $ 1.976D-06, 2.520D-06, 3.121D-06, 3.777D-06, 4.485D-06, 5.242D-06,
     $ 6.047D-06/
      data (WNDNO( 72,J,1),J=1,13) /
     $ 3.81333420D+03, 3.76295660D+03, 3.71271400D+03, 3.66261030D+03,
     $ 3.61264930D+03, 3.56283460D+03, 3.51316960D+03, 3.46365750D+03,
     $ 3.41430120D+03, 3.36510340D+03, 3.31606650D+03, 3.26719230D+03,
     $ 3.21848260D+03/
      data ( FDNO( 72,J,1),J=1,13) /
     $ 3.163D-08, 9.607D-08, 1.947D-07, 3.269D-07, 4.926D-07, 6.931D-07,
     $ 9.269D-07, 1.194D-06, 1.494D-06, 1.828D-06, 2.192D-06, 2.590D-06,
     $ 2.990D-06/
      data (WNUPO( 72,J,2),J=1,13) /
     $ 4.25122630D+03, 4.19829820D+03, 4.14549540D+03, 4.09282150D+03,
     $ 4.04028010D+03, 3.98787450D+03, 3.93560780D+03, 3.88348310D+03,
     $ 3.83150330D+03, 3.77967080D+03, 3.72798790D+03, 3.67645660D+03,
     $ 3.62507840D+03/
      data ( FUPO( 72,J,2),J=1,13) /
     $ 6.689D-08, 2.006D-07, 3.999D-07, 6.647D-07, 9.937D-07, 1.384D-06,
     $ 1.832D-06, 2.338D-06, 2.897D-06, 3.508D-06, 4.168D-06, 4.874D-06,
     $ 5.625D-06/
      data (WNDNO( 72,J,2),J=1,13) /
     $ 3.74319210D+03, 3.69497700D+03, 3.64688780D+03, 3.59892800D+03,
     $ 3.55110110D+03, 3.50341050D+03, 3.45585910D+03, 3.40845010D+03,
     $ 3.36118600D+03, 3.31406960D+03, 3.26710290D+03, 3.22028790D+03,
     $ 3.17362620D+03/
      data ( FDNO( 72,J,2),J=1,13) /
     $ 2.970D-08, 9.021D-08, 1.828D-07, 3.070D-07, 4.627D-07, 6.509D-07,
     $ 8.710D-07, 1.122D-06, 1.405D-06, 1.718D-06, 2.061D-06, 2.434D-06,
     $ 2.838D-06/
      data (WNUPO( 73,J,1),J=1,13) /
     $ 4.34218190D+03, 4.28672530D+03, 4.23140320D+03, 4.17621940D+03,
     $ 4.12117790D+03, 4.06628210D+03, 4.01153570D+03, 3.95694190D+03,
     $ 3.90250360D+03, 3.84822360D+03, 3.79410420D+03, 3.74014740D+03,
     $ 3.68635480D+03/
      data ( FUPO( 73,J,1),J=1,13) /
     $ 7.290D-08, 2.186D-07, 4.352D-07, 7.228D-07, 1.080D-06, 1.502D-06,
     $ 1.988D-06, 2.534D-06, 3.138D-06, 3.797D-06, 4.508D-06, 5.269D-06,
     $ 6.077D-06/
      data (WNDNO( 73,J,1),J=1,13) /
     $ 3.80482810D+03, 3.75448480D+03, 3.70427670D+03, 3.65420750D+03,
     $ 3.60428120D+03, 3.55450120D+03, 3.50487100D+03, 3.45539380D+03,
     $ 3.40607240D+03, 3.35690960D+03, 3.30790770D+03, 3.25906870D+03,
     $ 3.21039410D+03/
      data ( FDNO( 73,J,1),J=1,13) /
     $ 3.153D-08, 9.578D-08, 1.941D-07, 3.259D-07, 4.909D-07, 6.905D-07,
     $ 9.238D-07, 1.190D-06, 1.489D-06, 1.821D-06, 2.185D-06, 2.580D-06,
     $ 2.979D-06/
      data (WNUPO( 73,J,2),J=1,13) /
     $ 4.24977510D+03, 4.19681350D+03, 4.14397730D+03, 4.09127010D+03,
     $ 4.03869540D+03, 3.98625650D+03, 3.93395660D+03, 3.88179880D+03,
     $ 3.82978580D+03, 3.77792010D+03, 3.72620410D+03, 3.67463970D+03,
     $ 3.62322840D+03/
      data ( FUPO( 73,J,2),J=1,13) /
     $ 6.734D-08, 2.020D-07, 4.025D-07, 6.688D-07, 1.000D-06, 1.392D-06,
     $ 1.843D-06, 2.352D-06, 2.913D-06, 3.527D-06, 4.190D-06, 4.899D-06,
     $ 5.654D-06/
      data (WNDNO( 73,J,2),J=1,13) /
     $ 3.73515230D+03, 3.68696940D+03, 3.63891240D+03, 3.59098500D+03,
     $ 3.54319050D+03, 3.49553230D+03, 3.44801350D+03, 3.40063710D+03,
     $ 3.35340580D+03, 3.30632210D+03, 3.25938820D+03, 3.21260600D+03,
     $ 3.16597710D+03/
      data ( FDNO( 73,J,2),J=1,13) /
     $ 2.961D-08, 8.993D-08, 1.822D-07, 3.061D-07, 4.611D-07, 6.487D-07,
     $ 8.680D-07, 1.118D-06, 1.400D-06, 1.712D-06, 2.054D-06, 2.427D-06,
     $ 2.828D-06/
      data (WNUPO( 74,J,1),J=1,13) /
     $ 4.34045170D+03, 4.28495930D+03, 4.22960130D+03, 4.17438180D+03,
     $ 4.11930440D+03, 4.06437300D+03, 4.00959090D+03, 3.95496150D+03,
     $ 3.90048760D+03, 3.84617200D+03, 3.79201710D+03, 3.73802470D+03,
     $ 3.68419650D+03/
      data ( FUPO( 74,J,1),J=1,13) /
     $ 7.340D-08, 2.201D-07, 4.380D-07, 7.272D-07, 1.087D-06, 1.512D-06,
     $ 1.999D-06, 2.549D-06, 3.156D-06, 3.818D-06, 4.533D-06, 5.297D-06,
     $ 6.108D-06/
      data (WNDNO( 74,J,1),J=1,13) /
     $ 3.79626210D+03, 3.74595320D+03, 3.69577950D+03, 3.64574490D+03,
     $ 3.59585320D+03, 3.54610790D+03, 3.49651250D+03, 3.44707010D+03,
     $ 3.39778370D+03, 3.34865590D+03, 3.29968900D+03, 3.25088500D+03,
     $ 3.20224550D+03/
      data ( FDNO( 74,J,1),J=1,13) /
     $ 3.144D-08, 9.550D-08, 1.935D-07, 3.248D-07, 4.893D-07, 6.879D-07,
     $ 9.201D-07, 1.186D-06, 1.484D-06, 1.815D-06, 2.177D-06, 2.571D-06,
     $ 2.968D-06/
      data (WNUPO( 74,J,2),J=1,13) /
     $ 4.24824870D+03, 4.19525370D+03, 4.14238400D+03, 4.08964340D+03,
     $ 4.03703540D+03, 3.98456310D+03, 3.93223000D+03, 3.88003890D+03,
     $ 3.82799270D+03, 3.77609390D+03, 3.72434480D+03, 3.67274720D+03,
     $ 3.62130270D+03/
      data ( FUPO( 74,J,2),J=1,13) /
     $ 6.780D-08, 2.033D-07, 4.050D-07, 6.730D-07, 1.006D-06, 1.400D-06,
     $ 1.853D-06, 2.365D-06, 2.929D-06, 3.546D-06, 4.212D-06, 4.924D-06,
     $ 5.682D-06/
      data (WNDNO( 74,J,2),J=1,13) /
     $ 3.72705650D+03, 3.67890570D+03, 3.63088100D+03, 3.58298590D+03,
     $ 3.53522380D+03, 3.48759800D+03, 3.44011180D+03, 3.39276800D+03,
     $ 3.34556930D+03, 3.29851830D+03, 3.25161720D+03, 3.20486780D+03,
     $ 3.15827170D+03/
      data ( FDNO( 74,J,2),J=1,13) /
     $ 2.952D-08, 8.966D-08, 1.817D-07, 3.050D-07, 4.596D-07, 6.465D-07,
     $ 8.651D-07, 1.114D-06, 1.395D-06, 1.706D-06, 2.047D-06, 2.418D-06,
     $ 2.818D-06/
      data (WNUPO( 75,J,1),J=1,13) /
     $ 4.33864070D+03, 4.28311240D+03, 4.22771850D+03, 4.17246310D+03,
     $ 4.11735000D+03, 4.06238280D+03, 4.00756500D+03, 3.95289990D+03,
     $ 3.89839040D+03, 3.84403920D+03, 3.78984860D+03, 3.73582060D+03,
     $ 3.68195670D+03/
      data ( FUPO( 75,J,1),J=1,13) /
     $ 7.396D-08, 2.215D-07, 4.409D-07, 7.322D-07, 1.093D-06, 1.521D-06,
     $ 2.011D-06, 2.563D-06, 3.173D-06, 3.839D-06, 4.557D-06, 5.325D-06,
     $ 6.139D-06/
      data (WNDNO( 75,J,1),J=1,13) /
     $ 3.78763660D+03, 3.73736200D+03, 3.68722270D+03, 3.63722260D+03,
     $ 3.58736540D+03, 3.53765480D+03, 3.48809420D+03, 3.43868660D+03,
     $ 3.38943510D+03, 3.34034230D+03, 3.29141040D+03, 3.24264140D+03,
     $ 3.19403690D+03/
      data ( FDNO( 75,J,1),J=1,13) /
     $ 3.134D-08, 9.523D-08, 1.928D-07, 3.237D-07, 4.876D-07, 6.854D-07,
     $ 9.172D-07, 1.181D-06, 1.479D-06, 1.809D-06, 2.170D-06, 2.562D-06,
     $ 2.958D-06/
      data (WNUPO( 75,J,2),J=1,13) /
     $ 4.24664690D+03, 4.19361840D+03, 4.14071530D+03, 4.08794130D+03,
     $ 4.03529980D+03, 3.98279420D+03, 3.93042780D+03, 3.87820350D+03,
     $ 3.82612400D+03, 3.77419200D+03, 3.72240970D+03, 3.67077880D+03,
     $ 3.61930110D+03/
      data ( FUPO( 75,J,2),J=1,13) /
     $ 6.826D-08, 2.046D-07, 4.077D-07, 6.772D-07, 1.012D-06, 1.408D-06,
     $ 1.864D-06, 2.378D-06, 2.945D-06, 3.564D-06, 4.234D-06, 4.950D-06,
     $ 5.711D-06/
      data (WNDNO( 75,J,2),J=1,13) /
     $ 3.71890480D+03, 3.67078620D+03, 3.62279360D+03, 3.57493080D+03,
     $ 3.52720100D+03, 3.47960770D+03, 3.43215400D+03, 3.38484270D+03,
     $ 3.33767670D+03, 3.29065840D+03, 3.24379010D+03, 3.19707350D+03,
     $ 3.15051020D+03/
      data ( FDNO( 75,J,2),J=1,13) /
     $ 2.943D-08, 8.940D-08, 1.811D-07, 3.041D-07, 4.581D-07, 6.444D-07,
     $ 8.623D-07, 1.110D-06, 1.390D-06, 1.700D-06, 2.040D-06, 2.409D-06,
     $ 2.809D-06/
      data (WNUPO( 76,J,1),J=1,13) /
     $ 4.33674880D+03, 4.28118440D+03, 4.22575460D+03, 4.17046330D+03,
     $ 4.11531430D+03, 4.06031130D+03, 4.00545770D+03, 3.95075690D+03,
     $ 3.89621170D+03, 3.84182480D+03, 3.78759860D+03, 3.73353490D+03,
     $ 3.67963530D+03/
      data ( FUPO( 76,J,1),J=1,13) /
     $ 7.444D-08, 2.230D-07, 4.438D-07, 7.364D-07, 1.100D-06, 1.530D-06,
     $ 2.023D-06, 2.578D-06, 3.191D-06, 3.860D-06, 4.581D-06, 5.352D-06,
     $ 6.170D-06/
      data (WNDNO( 76,J,1),J=1,13) /
     $ 3.77895160D+03, 3.72871130D+03, 3.67860640D+03, 3.62864070D+03,
     $ 3.57881810D+03, 3.52914210D+03, 3.47961620D+03, 3.43024340D+03,
     $ 3.38102680D+03, 3.33196890D+03, 3.28307200D+03, 3.23433800D+03,
     $ 3.18576850D+03/
      data ( FDNO( 76,J,1),J=1,13) /
     $ 3.125D-08, 9.490D-08, 1.923D-07, 3.227D-07, 4.860D-07, 6.837D-07,
     $ 9.144D-07, 1.178D-06, 1.474D-06, 1.802D-06, 2.162D-06, 2.554D-06,
     $ 2.948D-06/
      data (WNUPO( 76,J,2),J=1,13) /
     $ 4.24496970D+03, 4.19190770D+03, 4.13897110D+03, 4.08616350D+03,
     $ 4.03348860D+03, 3.98094970D+03, 3.92854990D+03, 3.87629220D+03,
     $ 3.82417950D+03, 3.77221420D+03, 3.72039860D+03, 3.66873460D+03,
     $ 3.61722350D+03/
      data ( FUPO( 76,J,2),J=1,13) /
     $ 6.874D-08, 2.060D-07, 4.103D-07, 6.815D-07, 1.019D-06, 1.417D-06,
     $ 1.875D-06, 2.391D-06, 2.961D-06, 3.583D-06, 4.256D-06, 4.975D-06,
     $ 5.740D-06/
      data (WNDNO( 76,J,2),J=1,13) /
     $ 3.71069730D+03, 3.66261080D+03, 3.61465040D+03, 3.56681980D+03,
     $ 3.51912240D+03, 3.47156150D+03, 3.42414020D+03, 3.37686150D+03,
     $ 3.32972810D+03, 3.28274250D+03, 3.23590690D+03, 3.18922300D+03,
     $ 3.14269250D+03/
      data ( FDNO( 76,J,2),J=1,13) /
     $ 2.935D-08, 8.915D-08, 1.805D-07, 3.031D-07, 4.566D-07, 6.422D-07,
     $ 8.588D-07, 1.107D-06, 1.386D-06, 1.694D-06, 2.033D-06, 2.401D-06,
     $ 2.799D-06/
      data (WNUPO( 77,J,1),J=1,13) /
     $ 4.33477560D+03, 4.27917530D+03, 4.22370940D+03, 4.16838220D+03,
     $ 4.11319720D+03, 4.05815840D+03, 4.00326900D+03, 3.94853240D+03,
     $ 3.89395150D+03, 3.83952890D+03, 3.78526690D+03, 3.73116750D+03,
     $ 3.67723200D+03/
      data ( FUPO( 77,J,1),J=1,13) /
     $ 7.497D-08, 2.245D-07, 4.467D-07, 7.412D-07, 1.107D-06, 1.539D-06,
     $ 2.035D-06, 2.593D-06, 3.209D-06, 3.881D-06, 4.606D-06, 5.380D-06,
     $ 6.201D-06/
      data (WNDNO( 77,J,1),J=1,13) /
     $ 3.77020730D+03, 3.72000120D+03, 3.66993060D+03, 3.61999940D+03,
     $ 3.57021120D+03, 3.52056980D+03, 3.47107860D+03, 3.42174060D+03,
     $ 3.37255880D+03, 3.32353590D+03, 3.27467390D+03, 3.22597490D+03,
     $ 3.17744040D+03/
      data ( FDNO( 77,J,1),J=1,13) /
     $ 3.117D-08, 9.465D-08, 1.917D-07, 3.217D-07, 4.845D-07, 6.813D-07,
     $ 9.110D-07, 1.174D-06, 1.468D-06, 1.796D-06, 2.155D-06, 2.545D-06,
     $ 2.937D-06/
      data (WNUPO( 77,J,2),J=1,13) /
     $ 4.24321690D+03, 4.19012130D+03, 4.13715110D+03, 4.08431000D+03,
     $ 4.03160160D+03, 3.97902920D+03, 3.92659600D+03, 3.87430500D+03,
     $ 3.82215900D+03, 3.77016040D+03, 3.71831150D+03, 3.66661410D+03,
     $ 3.61506970D+03/
      data ( FUPO( 77,J,2),J=1,13) /
     $ 6.922D-08, 2.074D-07, 4.129D-07, 6.856D-07, 1.024D-06, 1.425D-06,
     $ 1.886D-06, 2.405D-06, 2.977D-06, 3.603D-06, 4.278D-06, 5.001D-06,
     $ 5.769D-06/
      data (WNDNO( 77,J,2),J=1,13) /
     $ 3.70243420D+03, 3.65437970D+03, 3.60645140D+03, 3.55865300D+03,
     $ 3.51098790D+03, 3.46345940D+03, 3.41607060D+03, 3.36882440D+03,
     $ 3.32172370D+03, 3.27477070D+03, 3.22796780D+03, 3.18131670D+03,
     $ 3.13481880D+03/
      data ( FDNO( 77,J,2),J=1,13) /
     $ 2.926D-08, 8.884D-08, 1.800D-07, 3.022D-07, 4.552D-07, 6.401D-07,
     $ 8.561D-07, 1.103D-06, 1.381D-06, 1.688D-06, 2.026D-06, 2.393D-06,
     $ 2.790D-06/
      data (WNUPO( 78,J,1),J=1,13) /
     $ 4.33272120D+03, 4.27708470D+03, 4.22158290D+03, 4.16621950D+03,
     $ 4.11099870D+03, 4.05592390D+03, 4.00099860D+03, 3.94622620D+03,
     $ 3.89160950D+03, 3.83715110D+03, 3.78285330D+03, 3.72871810D+03,
     $ 3.67474680D+03/
      data ( FUPO( 78,J,1),J=1,13) /
     $ 7.548D-08, 2.261D-07, 4.497D-07, 7.465D-07, 1.114D-06, 1.548D-06,
     $ 2.047D-06, 2.608D-06, 3.227D-06, 3.903D-06, 4.630D-06, 5.409D-06,
     $ 6.232D-06/
      data (WNDNO( 78,J,1),J=1,13) /
     $ 3.76140370D+03, 3.71123190D+03, 3.66119550D+03, 3.61129860D+03,
     $ 3.56154500D+03, 3.51193820D+03, 3.46248160D+03, 3.41317840D+03,
     $ 3.36403140D+03, 3.31504330D+03, 3.26621630D+03, 3.21755220D+03,
     $ 3.16905260D+03/
      data ( FDNO( 78,J,1),J=1,13) /
     $ 3.108D-08, 9.433D-08, 1.911D-07, 3.206D-07, 4.829D-07, 6.790D-07,
     $ 9.083D-07, 1.170D-06, 1.464D-06, 1.790D-06, 2.147D-06, 2.536D-06,
     $ 2.927D-06/
      data (WNUPO( 78,J,2),J=1,13) /
     $ 4.24138840D+03, 4.18825910D+03, 4.13525530D+03, 4.08238070D+03,
     $ 4.02963870D+03, 3.97703280D+03, 3.92456620D+03, 3.87224180D+03,
     $ 3.82006240D+03, 3.76803050D+03, 3.71614820D+03, 3.66441750D+03,
     $ 3.61283970D+03/
      data ( FUPO( 78,J,2),J=1,13) /
     $ 6.968D-08, 2.087D-07, 4.155D-07, 6.897D-07, 1.031D-06, 1.434D-06,
     $ 1.897D-06, 2.419D-06, 2.994D-06, 3.623D-06, 4.301D-06, 5.027D-06,
     $ 5.798D-06/
      data (WNDNO( 78,J,2),J=1,13) /
     $ 3.69411540D+03, 3.64609300D+03, 3.59819690D+03, 3.55043060D+03,
     $ 3.50279780D+03, 3.45530160D+03, 3.40794520D+03, 3.36073160D+03,
     $ 3.31366340D+03, 3.26674310D+03, 3.21997280D+03, 3.17335440D+03,
     $ 3.12688930D+03/
      data ( FDNO( 78,J,2),J=1,13) /
     $ 2.918D-08, 8.860D-08, 1.794D-07, 3.012D-07, 4.537D-07, 6.382D-07,
     $ 8.535D-07, 1.099D-06, 1.376D-06, 1.683D-06, 2.019D-06, 2.385D-06,
     $ 2.780D-06/
      data (WNUPO( 79,J,1),J=1,13) /
     $ 4.33058530D+03, 4.27491270D+03, 4.21937470D+03, 4.16397530D+03,
     $ 4.10871840D+03, 4.05360760D+03, 3.99864650D+03, 3.94383810D+03,
     $ 3.88918550D+03, 3.83469130D+03, 3.78035770D+03, 3.72618660D+03,
     $ 3.67217940D+03/
      data ( FUPO( 79,J,1),J=1,13) /
     $ 7.599D-08, 2.276D-07, 4.526D-07, 7.510D-07, 1.121D-06, 1.557D-06,
     $ 2.059D-06, 2.622D-06, 3.245D-06, 3.924D-06, 4.655D-06, 5.437D-06,
     $ 6.264D-06/
      data (WNDNO( 79,J,1),J=1,13) /
     $ 3.75254100D+03, 3.70240330D+03, 3.65240120D+03, 3.60253870D+03,
     $ 3.55281950D+03, 3.50324720D+03, 3.45382520D+03, 3.40455670D+03,
     $ 3.35544460D+03, 3.30649130D+03, 3.25769920D+03, 3.20907010D+03,
     $ 3.16060530D+03/
      data ( FDNO( 79,J,1),J=1,13) /
     $ 3.099D-08, 9.409D-08, 1.905D-07, 3.197D-07, 4.814D-07, 6.767D-07,
     $ 9.050D-07, 1.166D-06, 1.458D-06, 1.784D-06, 2.140D-06, 2.528D-06,
     $ 2.917D-06/
      data (WNUPO( 79,J,2),J=1,13) /
     $ 4.23948400D+03, 4.18632100D+03, 4.13328350D+03, 4.08037530D+03,
     $ 4.02759970D+03, 3.97496030D+03, 3.92246020D+03, 3.87010230D+03,
     $ 3.81788950D+03, 3.76582420D+03, 3.71390850D+03, 3.66214430D+03,
     $ 3.61053310D+03/
      data ( FUPO( 79,J,2),J=1,13) /
     $ 7.013D-08, 2.101D-07, 4.182D-07, 6.943D-07, 1.037D-06, 1.442D-06,
     $ 1.908D-06, 2.432D-06, 3.010D-06, 3.642D-06, 4.324D-06, 5.053D-06,
     $ 5.827D-06/
      data (WNDNO( 79,J,2),J=1,13) /
     $ 3.68574130D+03, 3.63775080D+03, 3.58988680D+03, 3.54215270D+03,
     $ 3.49455210D+03, 3.44708820D+03, 3.39976420D+03, 3.35258310D+03,
     $ 3.30554750D+03, 3.25865970D+03, 3.21192210D+03, 3.16533640D+03,
     $ 3.11890400D+03/
      data ( FDNO( 79,J,2),J=1,13) /
     $ 2.910D-08, 8.836D-08, 1.789D-07, 3.003D-07, 4.523D-07, 6.358D-07,
     $ 8.509D-07, 1.096D-06, 1.372D-06, 1.677D-06, 2.013D-06, 2.377D-06,
     $ 2.771D-06/
      data (WNUPO( 80,J,1),J=1,13) /
     $ 4.32836780D+03, 4.27265900D+03, 4.21708480D+03, 4.16164930D+03,
     $ 4.10635630D+03, 4.05120950D+03, 3.99621230D+03, 3.94136800D+03,
     $ 3.88667950D+03, 3.83214940D+03, 3.77777990D+03, 3.72357290D+03,
     $ 3.66952960D+03/
      data ( FUPO( 80,J,1),J=1,13) /
     $ 7.654D-08, 2.291D-07, 4.556D-07, 7.560D-07, 1.128D-06, 1.567D-06,
     $ 2.071D-06, 2.638D-06, 3.263D-06, 3.945D-06, 4.680D-06, 5.465D-06,
     $ 6.296D-06/
      data (WNDNO( 80,J,1),J=1,13) /
     $ 3.74361930D+03, 3.69351580D+03, 3.64354790D+03, 3.59371960D+03,
     $ 3.54403480D+03, 3.49449700D+03, 3.44510970D+03, 3.39587590D+03,
     $ 3.34679840D+03, 3.29788000D+03, 3.24912280D+03, 3.20052850D+03,
     $ 3.15209860D+03/
      data ( FDNO( 80,J,1),J=1,13) /
     $ 3.091D-08, 9.379D-08, 1.899D-07, 3.187D-07, 4.798D-07, 6.745D-07,
     $ 9.019D-07, 1.162D-06, 1.454D-06, 1.778D-06, 2.132D-06, 2.519D-06,
     $ 2.907D-06/
      data (WNUPO( 80,J,2),J=1,13) /
     $ 4.23750350D+03, 4.18430680D+03, 4.13123560D+03, 4.07829370D+03,
     $ 4.02548450D+03, 3.97281150D+03, 3.92027780D+03, 3.86788650D+03,
     $ 3.81564020D+03, 3.76354140D+03, 3.71159230D+03, 3.65979460D+03,
     $ 3.60814990D+03/
      data ( FUPO( 80,J,2),J=1,13) /
     $ 7.063D-08, 2.115D-07, 4.209D-07, 6.987D-07, 1.043D-06, 1.450D-06,
     $ 1.918D-06, 2.446D-06, 3.026D-06, 3.661D-06, 4.347D-06, 5.079D-06,
     $ 5.857D-06/
      data (WNDNO( 80,J,2),J=1,13) /
     $ 3.67731180D+03, 3.62935330D+03, 3.58152130D+03, 3.53381930D+03,
     $ 3.48625090D+03, 3.43881930D+03, 3.39152770D+03, 3.34437900D+03,
     $ 3.29737590D+03, 3.25052080D+03, 3.20381580D+03, 3.15726270D+03,
     $ 3.11086290D+03/
      data ( FDNO( 80,J,2),J=1,13) /
     $ 2.902D-08, 8.807D-08, 1.784D-07, 2.994D-07, 4.509D-07, 6.342D-07,
     $ 8.478D-07, 1.092D-06, 1.367D-06, 1.671D-06, 2.006D-06, 2.369D-06,
     $ 2.761D-06/
      data (WNUPO( 81,J,1),J=1,13) /
     $ 4.32606860D+03, 4.27032350D+03, 4.21471300D+03, 4.15924130D+03,
     $ 4.10391220D+03, 4.04872930D+03, 3.99369610D+03, 3.93881580D+03,
     $ 3.88409130D+03, 3.82952520D+03, 3.77511970D+03, 3.72087670D+03,
     $ 3.66679730D+03/
      data ( FUPO( 81,J,1),J=1,13) /
     $ 7.708D-08, 2.306D-07, 4.586D-07, 7.602D-07, 1.135D-06, 1.576D-06,
     $ 2.083D-06, 2.653D-06, 3.281D-06, 3.966D-06, 4.705D-06, 5.494D-06,
     $ 6.329D-06/
      data (WNDNO( 81,J,1),J=1,13) /
     $ 3.73463880D+03, 3.68456930D+03, 3.63463560D+03, 3.58484160D+03,
     $ 3.53519110D+03, 3.48568780D+03, 3.43633500D+03, 3.38713580D+03,
     $ 3.33809320D+03, 3.28920950D+03, 3.24048710D+03, 3.19192770D+03,
     $ 3.14353270D+03/
      data ( FDNO( 81,J,1),J=1,13) /
     $ 3.083D-08, 9.356D-08, 1.894D-07, 3.177D-07, 4.783D-07, 6.724D-07,
     $ 8.988D-07, 1.158D-06, 1.449D-06, 1.772D-06, 2.125D-06, 2.510D-06,
     $ 2.897D-06/
      data (WNUPO( 81,J,2),J=1,13) /
     $ 4.23544690D+03, 4.18221640D+03, 4.12911140D+03, 4.07613580D+03,
     $ 4.02329290D+03, 3.97058630D+03, 3.91801900D+03, 3.86559410D+03,
     $ 3.81331420D+03, 3.76118190D+03, 3.70919930D+03, 3.65736820D+03,
     $ 3.60568980D+03/
      data ( FUPO( 81,J,2),J=1,13) /
     $ 7.112D-08, 2.129D-07, 4.236D-07, 7.031D-07, 1.050D-06, 1.459D-06,
     $ 1.929D-06, 2.460D-06, 3.043D-06, 3.681D-06, 4.369D-06, 5.105D-06,
     $ 5.886D-06/
      data (WNDNO( 81,J,2),J=1,13) /
     $ 3.66882710D+03, 3.62090050D+03, 3.57310050D+03, 3.52543060D+03,
     $ 3.47789430D+03, 3.43049500D+03, 3.38323580D+03, 3.33611950D+03,
     $ 3.28914890D+03, 3.24232630D+03, 3.19565390D+03, 3.14913350D+03,
     $ 3.10276630D+03/
      data ( FDNO( 81,J,2),J=1,13) /
     $ 2.894D-08, 8.785D-08, 1.779D-07, 2.985D-07, 4.494D-07, 6.319D-07,
     $ 8.454D-07, 1.088D-06, 1.363D-06, 1.666D-06, 1.999D-06, 2.361D-06,
     $ 2.752D-06/
      data (WNUPO( 82,J,1),J=1,13) /
     $ 4.32368740D+03, 4.26790590D+03, 4.21225920D+03, 4.15675120D+03,
     $ 4.10138590D+03, 4.04616680D+03, 3.99109750D+03, 3.93618110D+03,
     $ 3.88142060D+03, 3.82681850D+03, 3.77237700D+03, 3.71809780D+03,
     $ 3.66398240D+03/
      data ( FUPO( 82,J,1),J=1,13) /
     $ 7.761D-08, 2.322D-07, 4.616D-07, 7.650D-07, 1.142D-06, 1.586D-06,
     $ 2.095D-06, 2.667D-06, 3.299D-06, 3.988D-06, 4.730D-06, 5.523D-06,
     $ 6.356D-06/
      data (WNDNO( 82,J,1),J=1,13) /
     $ 3.72559950D+03, 3.67556400D+03, 3.62566440D+03, 3.57590460D+03,
     $ 3.52628850D+03, 3.47681960D+03, 3.42750130D+03, 3.37833680D+03,
     $ 3.32932880D+03, 3.28047990D+03, 3.23179230D+03, 3.18326770D+03,
     $ 3.13490750D+03/
      data ( FDNO( 82,J,1),J=1,13) /
     $ 3.075D-08, 9.327D-08, 1.888D-07, 3.168D-07, 4.768D-07, 6.703D-07,
     $ 8.964D-07, 1.155D-06, 1.444D-06, 1.765D-06, 2.118D-06, 2.502D-06,
     $ 2.887D-06/
      data (WNUPO( 82,J,2),J=1,13) /
     $ 4.23331410D+03, 4.18004960D+03, 4.12691090D+03, 4.07390140D+03,
     $ 4.02102480D+03, 3.96828440D+03, 3.91568350D+03, 3.86322500D+03,
     $ 3.81091160D+03, 3.75874570D+03, 3.70672950D+03, 3.65486480D+03,
     $ 3.60315280D+03/
      data ( FUPO( 82,J,2),J=1,13) /
     $ 7.160D-08, 2.143D-07, 4.264D-07, 7.074D-07, 1.056D-06, 1.467D-06,
     $ 1.940D-06, 2.473D-06, 3.060D-06, 3.701D-06, 4.392D-06, 5.131D-06,
     $ 5.916D-06/
      data (WNDNO( 82,J,2),J=1,13) /
     $ 3.66028730D+03, 3.61239260D+03, 3.56462450D+03, 3.51698670D+03,
     $ 3.46948250D+03, 3.42211550D+03, 3.37488850D+03, 3.32780470D+03,
     $ 3.28086650D+03, 3.23407650D+03, 3.18743660D+03, 3.14094880D+03,
     $ 3.09461420D+03/
      data ( FDNO( 82,J,2),J=1,13) /
     $ 2.887D-08, 8.764D-08, 1.773D-07, 2.976D-07, 4.481D-07, 6.297D-07,
     $ 8.424D-07, 1.085D-06, 1.358D-06, 1.661D-06, 1.992D-06, 2.353D-06,
     $ 2.743D-06/
      data (WNUPO( 83,J,1),J=1,13) /
     $ 4.32122410D+03, 4.26540630D+03, 4.20972320D+03, 4.15417880D+03,
     $ 4.09877720D+03, 4.04352190D+03, 3.98841640D+03, 3.93346390D+03,
     $ 3.87866730D+03, 3.82402910D+03, 3.76955150D+03, 3.71523620D+03,
     $ 3.66108450D+03/
      data ( FUPO( 83,J,1),J=1,13) /
     $ 7.812D-08, 2.338D-07, 4.646D-07, 7.703D-07, 1.149D-06, 1.595D-06,
     $ 2.107D-06, 2.683D-06, 3.318D-06, 4.010D-06, 4.755D-06, 5.552D-06,
     $ 6.388D-06/
      data (WNDNO( 83,J,1),J=1,13) /
     $ 3.71650150D+03, 3.66650000D+03, 3.61663450D+03, 3.56690890D+03,
     $ 3.51732710D+03, 3.46789260D+03, 3.41860880D+03, 3.36947880D+03,
     $ 3.32050550D+03, 3.27169130D+03, 3.22303850D+03, 3.17454870D+03,
     $ 3.12622320D+03/
      data ( FDNO( 83,J,1),J=1,13) /
     $ 3.066D-08, 9.305D-08, 1.883D-07, 3.158D-07, 4.754D-07, 6.683D-07,
     $ 8.934D-07, 1.150D-06, 1.440D-06, 1.760D-06, 2.111D-06, 2.494D-06,
     $ 2.877D-06/
      data (WNUPO( 83,J,2),J=1,13) /
     $ 4.23110470D+03, 4.17780640D+03, 4.12463370D+03, 4.07159040D+03,
     $ 4.01868000D+03, 3.96590590D+03, 3.91327130D+03, 3.86077910D+03,
     $ 3.80843200D+03, 3.75623250D+03, 3.70418270D+03, 3.65228430D+03,
     $ 3.60053860D+03/
      data ( FUPO( 83,J,2),J=1,13) /
     $ 7.206D-08, 2.157D-07, 4.291D-07, 7.115D-07, 1.062D-06, 1.476D-06,
     $ 1.952D-06, 2.487D-06, 3.076D-06, 3.721D-06, 4.415D-06, 5.158D-06,
     $ 5.945D-06/
      data (WNDNO( 83,J,2),J=1,13) /
     $ 3.65169250D+03, 3.60382960D+03, 3.55609350D+03, 3.50848760D+03,
     $ 3.46101560D+03, 3.41368070D+03, 3.36648610D+03, 3.31943450D+03,
     $ 3.27252880D+03, 3.22577130D+03, 3.17916400D+03, 3.13270870D+03,
     $ 3.08640670D+03/
      data ( FDNO( 83,J,2),J=1,13) /
     $ 2.879D-08, 8.737D-08, 1.768D-07, 2.967D-07, 4.467D-07, 6.281D-07,
     $ 8.395D-07, 1.081D-06, 1.354D-06, 1.655D-06, 1.986D-06, 2.346D-06,
     $ 2.734D-06/
      data (WNUPO( 84,J,1),J=1,13) /
     $ 4.31867870D+03, 4.26282430D+03, 4.20710480D+03, 4.15152400D+03,
     $ 4.09608610D+03, 4.04079450D+03, 3.98565280D+03, 3.93066400D+03,
     $ 3.87583120D+03, 3.82115680D+03, 3.76664300D+03, 3.71229150D+03,
     $ 3.65810350D+03/
      data ( FUPO( 84,J,1),J=1,13) /
     $ 7.868D-08, 2.353D-07, 4.677D-07, 7.749D-07, 1.156D-06, 1.605D-06,
     $ 2.120D-06, 2.698D-06, 3.337D-06, 4.032D-06, 4.780D-06, 5.580D-06,
     $ 6.425D-06/
      data (WNDNO( 84,J,1),J=1,13) /
     $ 3.70734510D+03, 3.65737750D+03, 3.60754600D+03, 3.55785460D+03,
     $ 3.50830700D+03, 3.45890680D+03, 3.40965750D+03, 3.36056200D+03,
     $ 3.31162330D+03, 3.26284390D+03, 3.21422570D+03, 3.16577070D+03,
     $ 3.11747990D+03/
      data ( FDNO( 84,J,1),J=1,13) /
     $ 3.059D-08, 9.278D-08, 1.878D-07, 3.149D-07, 4.740D-07, 6.663D-07,
     $ 8.905D-07, 1.147D-06, 1.435D-06, 1.754D-06, 2.104D-06, 2.486D-06,
     $ 2.868D-06/
      data (WNUPO( 84,J,2),J=1,13) /
     $ 4.22881880D+03, 4.17548650D+03, 4.12227990D+03, 4.06920270D+03,
     $ 4.01625840D+03, 3.96345050D+03, 3.91078210D+03, 3.85825620D+03,
     $ 3.80587540D+03, 3.75364230D+03, 3.70155880D+03, 3.64962660D+03,
     $ 3.59784720D+03/
      data ( FUPO( 84,J,2),J=1,13) /
     $ 7.257D-08, 2.171D-07, 4.319D-07, 7.162D-07, 1.069D-06, 1.485D-06,
     $ 1.963D-06, 2.501D-06, 3.093D-06, 3.740D-06, 4.438D-06, 5.184D-06,
     $ 5.975D-06/
      data (WNDNO( 84,J,2),J=1,13) /
     $ 3.64304280D+03, 3.59521170D+03, 3.54750740D+03, 3.49993360D+03,
     $ 3.45249360D+03, 3.40519090D+03, 3.35802850D+03, 3.31100930D+03,
     $ 3.26413600D+03, 3.21741090D+03, 3.17083610D+03, 3.12441330D+03,
     $ 3.07814390D+03/
      data ( FDNO( 84,J,2),J=1,13) /
     $ 2.872D-08, 8.716D-08, 1.763D-07, 2.958D-07, 4.454D-07, 6.260D-07,
     $ 8.373D-07, 1.078D-06, 1.349D-06, 1.650D-06, 1.979D-06, 2.338D-06,
     $ 2.725D-06/
      data (WNUPO( 85,J,1),J=1,13) /
     $ 4.31605080D+03, 4.26015990D+03, 4.20440380D+03, 4.14878660D+03,
     $ 4.09331230D+03, 4.03798430D+03, 3.98280630D+03, 3.92778130D+03,
     $ 3.87291220D+03, 3.81820160D+03, 3.76365150D+03, 3.70926370D+03,
     $ 3.65503930D+03/
      data ( FUPO( 85,J,1),J=1,13) /
     $ 7.923D-08, 2.369D-07, 4.708D-07, 7.799D-07, 1.163D-06, 1.614D-06,
     $ 2.132D-06, 2.714D-06, 3.355D-06, 4.053D-06, 4.806D-06, 5.609D-06,
     $ 6.456D-06/
      data (WNDNO( 85,J,1),J=1,13) /
     $ 3.69813020D+03, 3.64819650D+03, 3.59839900D+03, 3.54874170D+03,
     $ 3.49922830D+03, 3.44986240D+03, 3.40064750D+03, 3.35158660D+03,
     $ 3.30268240D+03, 3.25393760D+03, 3.20535420D+03, 3.15693380D+03,
     $ 3.10867780D+03/
      data ( FDNO( 85,J,1),J=1,13) /
     $ 3.051D-08, 9.257D-08, 1.872D-07, 3.140D-07, 4.726D-07, 6.643D-07,
     $ 8.877D-07, 1.143D-06, 1.430D-06, 1.748D-06, 2.097D-06, 2.477D-06,
     $ 2.858D-06/
      data (WNUPO( 85,J,2),J=1,13) /
     $ 4.22645620D+03, 4.17308980D+03, 4.11984920D+03, 4.06673800D+03,
     $ 4.01375990D+03, 3.96091810D+03, 3.90821580D+03, 3.85565610D+03,
     $ 3.80324160D+03, 3.75097470D+03, 3.69885740D+03, 3.64689150D+03,
     $ 3.59507820D+03/
      data ( FUPO( 85,J,2),J=1,13) /
     $ 7.308D-08, 2.186D-07, 4.347D-07, 7.207D-07, 1.075D-06, 1.493D-06,
     $ 1.974D-06, 2.515D-06, 3.110D-06, 3.760D-06, 4.461D-06, 5.211D-06,
     $ 6.006D-06/
      data (WNDNO( 85,J,2),J=1,13) /
     $ 3.63433830D+03, 3.58653900D+03, 3.53886650D+03, 3.49132460D+03,
     $ 3.44391660D+03, 3.39664600D+03, 3.34951580D+03, 3.30252900D+03,
     $ 3.25568800D+03, 3.20899540D+03, 3.16245310D+03, 3.11606280D+03,
     $ 3.06982590D+03/
      data ( FDNO( 85,J,2),J=1,13) /
     $ 2.864D-08, 8.690D-08, 1.758D-07, 2.950D-07, 4.440D-07, 6.240D-07,
     $ 8.345D-07, 1.074D-06, 1.345D-06, 1.644D-06, 1.973D-06, 2.330D-06,
     $ 2.716D-06/
      data (WNUPO( 86,J,1),J=1,13) /
     $ 4.31334040D+03, 4.25741290D+03, 4.20162020D+03, 4.14596650D+03,
     $ 4.09045560D+03, 4.03509120D+03, 3.97987680D+03, 3.92481550D+03,
     $ 3.86991010D+03, 3.81516310D+03, 3.76057670D+03, 3.70615250D+03,
     $ 3.65189170D+03/
      data ( FUPO( 86,J,1),J=1,13) /
     $ 7.977D-08, 2.385D-07, 4.738D-07, 7.848D-07, 1.170D-06, 1.624D-06,
     $ 2.144D-06, 2.729D-06, 3.374D-06, 4.075D-06, 4.831D-06, 5.639D-06,
     $ 6.485D-06/
      data (WNDNO( 86,J,1),J=1,13) /
     $ 3.68885700D+03, 3.63895720D+03, 3.58919360D+03, 3.53957030D+03,
     $ 3.49009110D+03, 3.44075950D+03, 3.39157890D+03, 3.34255250D+03,
     $ 3.29368290D+03, 3.24497270D+03, 3.19642390D+03, 3.14803820D+03,
     $ 3.09981680D+03/
      data ( FDNO( 86,J,1),J=1,13) /
     $ 3.043D-08, 9.231D-08, 1.867D-07, 3.131D-07, 4.712D-07, 6.618D-07,
     $ 8.850D-07, 1.139D-06, 1.425D-06, 1.743D-06, 2.090D-06, 2.469D-06,
     $ 2.849D-06/
      data (WNUPO( 86,J,2),J=1,13) /
     $ 4.22401670D+03, 4.17061620D+03, 4.11734150D+03, 4.06419630D+03,
     $ 4.01118420D+03, 3.95830850D+03, 3.90557230D+03, 3.85297880D+03,
     $ 3.80053040D+03, 3.74822970D+03, 3.69607860D+03, 3.64407890D+03,
     $ 3.59223170D+03/
      data ( FUPO( 86,J,2),J=1,13) /
     $ 7.357D-08, 2.200D-07, 4.374D-07, 7.251D-07, 1.082D-06, 1.502D-06,
     $ 1.985D-06, 2.529D-06, 3.127D-06, 3.780D-06, 4.485D-06, 5.237D-06,
     $ 6.035D-06/
      data (WNDNO( 86,J,2),J=1,13) /
     $ 3.62557910D+03, 3.57781150D+03, 3.53017090D+03, 3.48266080D+03,
     $ 3.43528490D+03, 3.38804630D+03, 3.34094830D+03, 3.29399370D+03,
     $ 3.24718510D+03, 3.20052490D+03, 3.15401500D+03, 3.10765720D+03,
     $ 3.06145270D+03/
      data ( FDNO( 86,J,2),J=1,13) /
     $ 2.857D-08, 8.665D-08, 1.753D-07, 2.941D-07, 4.427D-07, 6.225D-07,
     $ 8.318D-07, 1.071D-06, 1.340D-06, 1.639D-06, 1.966D-06, 2.323D-06,
     $ 2.708D-06/
      data (WNUPO( 87,J,1),J=1,13) /
     $ 4.31054730D+03, 4.25458310D+03, 4.19875370D+03, 4.14306340D+03,
     $ 4.08751600D+03, 4.03211510D+03, 3.97686420D+03, 3.92176640D+03,
     $ 3.86682460D+03, 3.81204130D+03, 3.75741850D+03, 3.70295780D+03,
     $ 3.64866040D+03/
      data ( FUPO( 87,J,1),J=1,13) /
     $ 8.035D-08, 2.401D-07, 4.769D-07, 7.902D-07, 1.177D-06, 1.634D-06,
     $ 2.157D-06, 2.745D-06, 3.392D-06, 4.098D-06, 4.857D-06, 5.668D-06,
     $ 6.520D-06/
      data (WNDNO( 87,J,1),J=1,13) /
     $ 3.67952570D+03, 3.62965960D+03, 3.57992990D+03, 3.53034060D+03,
     $ 3.48089550D+03, 3.43159810D+03, 3.38245190D+03, 3.33345990D+03,
     $ 3.28462480D+03, 3.23594920D+03, 3.18743500D+03, 3.13908390D+03,
     $ 3.09089710D+03/
      data ( FDNO( 87,J,1),J=1,13) /
     $ 3.036D-08, 9.206D-08, 1.862D-07, 3.122D-07, 4.698D-07, 6.600D-07,
     $ 8.823D-07, 1.136D-06, 1.421D-06, 1.737D-06, 2.083D-06, 2.461D-06,
     $ 2.840D-06/
      data (WNUPO( 87,J,2),J=1,13) /
     $ 4.22150020D+03, 4.16806550D+03, 4.11475670D+03, 4.06157740D+03,
     $ 4.00853120D+03, 3.95562150D+03, 3.90285140D+03, 3.85022400D+03,
     $ 3.79774170D+03, 3.74540710D+03, 3.69322220D+03, 3.64118850D+03,
     $ 3.58930730D+03/
      data ( FUPO( 87,J,2),J=1,13) /
     $ 7.405D-08, 2.215D-07, 4.402D-07, 7.295D-07, 1.088D-06, 1.512D-06,
     $ 1.997D-06, 2.543D-06, 3.145D-06, 3.801D-06, 4.508D-06, 5.264D-06,
     $ 6.064D-06/
      data (WNDNO( 87,J,2),J=1,13) /
     $ 3.61676540D+03, 3.56902940D+03, 3.52142050D+03, 3.47394230D+03,
     $ 3.42659830D+03, 3.37939180D+03, 3.33232600D+03, 3.28540360D+03,
     $ 3.23862730D+03, 3.19199950D+03, 3.14552200D+03, 3.09919660D+03,
     $ 3.05302460D+03/
      data ( FDNO( 87,J,2),J=1,13) /
     $ 2.850D-08, 8.646D-08, 1.749D-07, 2.933D-07, 4.414D-07, 6.206D-07,
     $ 8.291D-07, 1.067D-06, 1.337D-06, 1.634D-06, 1.960D-06, 2.315D-06,
     $ 2.699D-06/
      data (WNUPO( 88,J,1),J=1,13) /
     $ 4.30767130D+03, 4.25167030D+03, 4.19580420D+03, 4.14007720D+03,
     $ 4.08449310D+03, 4.02905570D+03, 3.97376820D+03, 3.91863400D+03,
     $ 3.86365570D+03, 3.80883590D+03, 3.75417660D+03, 3.69967930D+03,
     $ 3.64534530D+03/
      data ( FUPO( 88,J,1),J=1,13) /
     $ 8.091D-08, 2.417D-07, 4.801D-07, 7.949D-07, 1.185D-06, 1.643D-06,
     $ 2.170D-06, 2.760D-06, 3.411D-06, 4.119D-06, 4.882D-06, 5.697D-06,
     $ 6.554D-06/
      data (WNDNO( 88,J,1),J=1,13) /
     $ 3.67013630D+03, 3.62030400D+03, 3.57060810D+03, 3.52105270D+03,
     $ 3.47164170D+03, 3.42237850D+03, 3.37326650D+03, 3.32430890D+03,
     $ 3.27550830D+03, 3.22686720D+03, 3.17838760D+03, 3.13007110D+03,
     $ 3.08191880D+03/
      data ( FDNO( 88,J,1),J=1,13) /
     $ 3.029D-08, 9.181D-08, 1.857D-07, 3.113D-07, 4.684D-07, 6.582D-07,
     $ 8.797D-07, 1.132D-06, 1.416D-06, 1.731D-06, 2.077D-06, 2.453D-06,
     $ 2.831D-06/
      data (WNUPO( 88,J,2),J=1,13) /
     $ 4.21890650D+03, 4.16543760D+03, 4.11209460D+03, 4.05888120D+03,
     $ 4.00580080D+03, 3.95285710D+03, 3.90005300D+03, 3.84739150D+03,
     $ 3.79487540D+03, 3.74250680D+03, 3.69028790D+03, 3.63822020D+03,
     $ 3.58630500D+03/
      data ( FUPO( 88,J,2),J=1,13) /
     $ 7.457D-08, 2.229D-07, 4.431D-07, 7.343D-07, 1.095D-06, 1.520D-06,
     $ 2.008D-06, 2.557D-06, 3.162D-06, 3.821D-06, 4.531D-06, 5.291D-06,
     $ 6.097D-06/
      data (WNDNO( 88,J,2),J=1,13) /
     $ 3.60789720D+03, 3.56019280D+03, 3.51261560D+03, 3.46516920D+03,
     $ 3.41785710D+03, 3.37068270D+03, 3.32364890D+03, 3.27675870D+03,
     $ 3.23001470D+03, 3.18341920D+03, 3.13697410D+03, 3.09068110D+03,
     $ 3.04454140D+03/
      data ( FDNO( 88,J,2),J=1,13) /
     $ 2.844D-08, 8.621D-08, 1.744D-07, 2.924D-07, 4.402D-07, 6.186D-07,
     $ 8.271D-07, 1.064D-06, 1.332D-06, 1.628D-06, 1.954D-06, 2.307D-06,
     $ 2.690D-06/
      data (WNUPO( 89,J,1),J=1,13) /
     $ 4.30471230D+03, 4.24867450D+03, 4.19277160D+03, 4.13700780D+03,
     $ 4.08138700D+03, 4.02591280D+03, 3.97058880D+03, 3.91541800D+03,
     $ 3.86040310D+03, 3.80554670D+03, 3.75085080D+03, 3.69631700D+03,
     $ 3.64194620D+03/
      data ( FUPO( 89,J,1),J=1,13) /
     $ 8.147D-08, 2.434D-07, 4.832D-07, 8.000D-07, 1.192D-06, 1.653D-06,
     $ 2.182D-06, 2.776D-06, 3.430D-06, 4.142D-06, 4.908D-06, 5.729D-06,
     $ 6.582D-06/
      data (WNDNO( 89,J,1),J=1,13) /
     $ 3.66068890D+03, 3.61089030D+03, 3.56122820D+03, 3.51170670D+03,
     $ 3.46232970D+03, 3.41310060D+03, 3.36402290D+03, 3.31509960D+03,
     $ 3.26633340D+03, 3.21772680D+03, 3.16928170D+03, 3.12099980D+03,
     $ 3.07288210D+03/
      data ( FDNO( 89,J,1),J=1,13) /
     $ 3.022D-08, 9.162D-08, 1.852D-07, 3.104D-07, 4.670D-07, 6.559D-07,
     $ 8.765D-07, 1.129D-06, 1.412D-06, 1.726D-06, 2.070D-06, 2.445D-06,
     $ 2.822D-06/
      data (WNUPO( 89,J,2),J=1,13) /
     $ 4.21623550D+03, 4.16273240D+03, 4.10935510D+03, 4.05610740D+03,
     $ 4.00299290D+03, 3.95001500D+03, 3.89717680D+03, 3.84448130D+03,
     $ 3.79193110D+03, 3.73952850D+03, 3.68727560D+03, 3.63517380D+03,
     $ 3.58322450D+03/
      data ( FUPO( 89,J,2),J=1,13) /
     $ 7.508D-08, 2.244D-07, 4.459D-07, 7.390D-07, 1.102D-06, 1.529D-06,
     $ 2.020D-06, 2.572D-06, 3.179D-06, 3.841D-06, 4.555D-06, 5.318D-06,
     $ 6.124D-06/
      data (WNDNO( 89,J,2),J=1,13) /
     $ 3.59897460D+03, 3.55130180D+03, 3.50375630D+03, 3.45634160D+03,
     $ 3.40906140D+03, 3.36191890D+03, 3.31491720D+03, 3.26805920D+03,
     $ 3.22134740D+03, 3.17478420D+03, 3.12837150D+03, 3.08211080D+03,
     $ 3.03600350D+03/
      data ( FDNO( 89,J,2),J=1,13) /
     $ 2.837D-08, 8.603D-08, 1.739D-07, 2.916D-07, 4.389D-07, 6.168D-07,
     $ 8.246D-07, 1.061D-06, 1.328D-06, 1.623D-06, 1.947D-06, 2.300D-06,
     $ 2.682D-06/
      data (WNUPO( 90,J,1),J=1,13) /
     $ 4.30167020D+03, 4.24559540D+03, 4.18965560D+03, 4.13385490D+03,
     $ 4.07819730D+03, 4.02268640D+03, 3.96732570D+03, 3.91211820D+03,
     $ 3.85706670D+03, 3.80217370D+03, 3.74744110D+03, 3.69287050D+03,
     $ 3.63846300D+03/
      data ( FUPO( 90,J,1),J=1,13) /
     $ 8.201D-08, 2.450D-07, 4.864D-07, 8.050D-07, 1.199D-06, 1.663D-06,
     $ 2.195D-06, 2.791D-06, 3.449D-06, 4.164D-06, 4.934D-06, 5.754D-06,
     $ 6.620D-06/
      data (WNDNO( 90,J,1),J=1,13) /
     $ 3.65118370D+03, 3.60141870D+03, 3.55179030D+03, 3.50230270D+03,
     $ 3.45295960D+03, 3.40376470D+03, 3.35472120D+03, 3.30583210D+03,
     $ 3.25710040D+03, 3.20852820D+03, 3.16011760D+03, 3.11187010D+03,
     $ 3.06378690D+03/
      data ( FDNO( 90,J,1),J=1,13) /
     $ 3.014D-08, 9.138D-08, 1.847D-07, 3.096D-07, 4.657D-07, 6.541D-07,
     $ 8.740D-07, 1.125D-06, 1.407D-06, 1.720D-06, 2.064D-06, 2.438D-06,
     $ 2.813D-06/
      data (WNUPO( 90,J,2),J=1,13) /
     $ 4.21348710D+03, 4.15994960D+03, 4.10653790D+03, 4.05325600D+03,
     $ 4.00010720D+03, 3.94709510D+03, 3.89422280D+03, 3.84149320D+03,
     $ 3.78890890D+03, 3.73647220D+03, 3.68418520D+03, 3.63204930D+03,
     $ 3.58006570D+03/
      data ( FUPO( 90,J,2),J=1,13) /
     $ 7.559D-08, 2.259D-07, 4.488D-07, 7.436D-07, 1.108D-06, 1.538D-06,
     $ 2.031D-06, 2.586D-06, 3.196D-06, 3.861D-06, 4.579D-06, 5.345D-06,
     $ 6.156D-06/
      data (WNDNO( 90,J,2),J=1,13) /
     $ 3.58999770D+03, 3.54235650D+03, 3.49484250D+03, 3.44745960D+03,
     $ 3.40021120D+03, 3.35310070D+03, 3.30613100D+03, 3.25930510D+03,
     $ 3.21262550D+03, 3.16609460D+03, 3.11971410D+03, 3.07348580D+03,
     $ 3.02741080D+03/
      data ( FDNO( 90,J,2),J=1,13) /
     $ 2.830D-08, 8.580D-08, 1.735D-07, 2.908D-07, 4.377D-07, 6.149D-07,
     $ 8.221D-07, 1.058D-06, 1.324D-06, 1.618D-06, 1.941D-06, 2.293D-06,
     $ 2.673D-06/
      data (WNUPO( 91,J,1),J=1,13) /
     $ 4.29854470D+03, 4.24243280D+03, 4.18645600D+03, 4.13061840D+03,
     $ 4.07492400D+03, 4.01937630D+03, 3.96397870D+03, 3.90873450D+03,
     $ 3.85364630D+03, 3.79871650D+03, 3.74394720D+03, 3.68933980D+03,
     $ 3.63489530D+03/
      data ( FUPO( 91,J,1),J=1,13) /
     $ 8.260D-08, 2.466D-07, 4.896D-07, 8.105D-07, 1.207D-06, 1.673D-06,
     $ 2.208D-06, 2.807D-06, 3.468D-06, 4.187D-06, 4.960D-06, 5.785D-06,
     $ 6.652D-06/
      data (WNDNO( 91,J,1),J=1,13) /
     $ 3.64162080D+03, 3.59188930D+03, 3.54229460D+03, 3.49284080D+03,
     $ 3.44353160D+03, 3.39437070D+03, 3.34536130D+03, 3.29650660D+03,
     $ 3.24780910D+03, 3.19927130D+03, 3.15089520D+03, 3.10268220D+03,
     $ 3.05463340D+03/
      data ( FDNO( 91,J,1),J=1,13) /
     $ 3.008D-08, 9.115D-08, 1.842D-07, 3.087D-07, 4.644D-07, 6.525D-07,
     $ 8.716D-07, 1.122D-06, 1.403D-06, 1.715D-06, 2.057D-06, 2.430D-06,
     $ 2.804D-06/
      data (WNUPO( 91,J,2),J=1,13) /
     $ 4.21066110D+03, 4.15708910D+03, 4.10364310D+03, 4.05032670D+03,
     $ 3.99714370D+03, 3.94409730D+03, 3.89119080D+03, 3.83842690D+03,
     $ 3.78580850D+03, 3.73333760D+03, 3.68101640D+03, 3.62884630D+03,
     $ 3.57682840D+03/
      data ( FUPO( 91,J,2),J=1,13) /
     $ 7.608D-08, 2.274D-07, 4.517D-07, 7.481D-07, 1.115D-06, 1.547D-06,
     $ 2.043D-06, 2.600D-06, 3.213D-06, 3.882D-06, 4.602D-06, 5.372D-06,
     $ 6.188D-06/
      data (WNDNO( 91,J,2),J=1,13) /
     $ 3.58096670D+03, 3.53335690D+03, 3.48587460D+03, 3.43852330D+03,
     $ 3.39130670D+03, 3.34422800D+03, 3.29729030D+03, 3.25049650D+03,
     $ 3.20384910D+03, 3.15735040D+03, 3.11100220D+03, 3.06480620D+03,
     $ 3.01876340D+03/
      data ( FDNO( 91,J,2),J=1,13) /
     $ 2.823D-08, 8.557D-08, 1.730D-07, 2.901D-07, 4.364D-07, 6.131D-07,
     $ 8.197D-07, 1.055D-06, 1.320D-06, 1.613D-06, 1.935D-06, 2.285D-06,
     $ 2.664D-06/
      data (WNUPO( 92,J,1),J=1,13) /
     $ 4.29533570D+03, 4.23918670D+03, 4.18317280D+03, 4.12729820D+03,
     $ 4.07156680D+03, 4.01598210D+03, 3.96054770D+03, 3.90526670D+03,
     $ 3.85014160D+03, 3.79517510D+03, 3.74036890D+03, 3.68572450D+03,
     $ 3.63124300D+03/
      data ( FUPO( 92,J,1),J=1,13) /
     $ 8.317D-08, 2.483D-07, 4.927D-07, 8.153D-07, 1.214D-06, 1.683D-06,
     $ 2.220D-06, 2.823D-06, 3.487D-06, 4.209D-06, 4.986D-06, 5.814D-06,
     $ 6.683D-06/
      data (WNDNO( 92,J,1),J=1,13) /
     $ 3.63200020D+03, 3.58230220D+03, 3.53274110D+03, 3.48332100D+03,
     $ 3.43404570D+03, 3.38491880D+03, 3.33594360D+03, 3.28712300D+03,
     $ 3.23845990D+03, 3.18995640D+03, 3.14161470D+03, 3.09343610D+03,
     $ 3.04542160D+03/
      data ( FDNO( 92,J,1),J=1,13) /
     $ 3.001D-08, 9.092D-08, 1.837D-07, 3.079D-07, 4.631D-07, 6.503D-07,
     $ 8.686D-07, 1.118D-06, 1.399D-06, 1.710D-06, 2.050D-06, 2.422D-06,
     $ 2.795D-06/
      data (WNUPO( 92,J,2),J=1,13) /
     $ 4.20775740D+03, 4.15415090D+03, 4.10067030D+03, 4.04731950D+03,
     $ 3.99410210D+03, 3.94102140D+03, 3.88808050D+03, 3.83528250D+03,
     $ 3.78262970D+03, 3.73012470D+03, 3.67776920D+03, 3.62556470D+03,
     $ 3.57351250D+03/
      data ( FUPO( 92,J,2),J=1,13) /
     $ 7.661D-08, 2.289D-07, 4.546D-07, 7.530D-07, 1.121D-06, 1.556D-06,
     $ 2.055D-06, 2.615D-06, 3.231D-06, 3.903D-06, 4.626D-06, 5.399D-06,
     $ 6.219D-06/
      data (WNDNO( 92,J,2),J=1,13) /
     $ 3.57188170D+03, 3.52430330D+03, 3.47685240D+03, 3.42953280D+03,
     $ 3.38234790D+03, 3.33530110D+03, 3.28839530D+03, 3.24163360D+03,
     $ 3.19501830D+03, 3.14855170D+03, 3.10223580D+03, 3.05607200D+03,
     $ 3.01006150D+03/
      data ( FDNO( 92,J,2),J=1,13) /
     $ 2.817D-08, 8.541D-08, 1.725D-07, 2.892D-07, 4.352D-07, 6.114D-07,
     $ 8.168D-07, 1.051D-06, 1.316D-06, 1.608D-06, 1.929D-06, 2.278D-06,
     $ 2.656D-06/
      data (WNUPO( 93,J,1),J=1,13) /
     $ 4.29204300D+03, 4.23585680D+03, 4.17980580D+03, 4.12389400D+03,
     $ 4.06812550D+03, 4.01250390D+03, 3.95703260D+03, 3.90171450D+03,
     $ 3.84655260D+03, 3.79154910D+03, 3.73670600D+03, 3.68202460D+03,
     $ 3.62750600D+03/
      data ( FUPO( 93,J,1),J=1,13) /
     $ 8.373D-08, 2.499D-07, 4.960D-07, 8.205D-07, 1.222D-06, 1.693D-06,
     $ 2.234D-06, 2.839D-06, 3.506D-06, 4.232D-06, 5.012D-06, 5.843D-06,
     $ 6.719D-06/
      data (WNDNO( 93,J,1),J=1,13) /
     $ 3.62232210D+03, 3.57265750D+03, 3.52313000D+03, 3.47374360D+03,
     $ 3.42450210D+03, 3.37540910D+03, 3.32646800D+03, 3.27768160D+03,
     $ 3.22905270D+03, 3.18058350D+03, 3.13227610D+03, 3.08413180D+03,
     $ 3.03615170D+03/
      data ( FDNO( 93,J,1),J=1,13) /
     $ 2.995D-08, 9.075D-08, 1.833D-07, 3.071D-07, 4.619D-07, 6.487D-07,
     $ 8.663D-07, 1.115D-06, 1.394D-06, 1.704D-06, 2.044D-06, 2.414D-06,
     $ 2.787D-06/
      data (WNUPO( 93,J,2),J=1,13) /
     $ 4.20477580D+03, 4.15113470D+03, 4.09761960D+03, 4.04423420D+03,
     $ 3.99098230D+03, 3.93786720D+03, 3.88489200D+03, 3.83205950D+03,
     $ 3.77937250D+03, 3.72683310D+03, 3.67444320D+03, 3.62220440D+03,
     $ 3.57011770D+03/
      data ( FUPO( 93,J,2),J=1,13) /
     $ 7.714D-08, 2.304D-07, 4.575D-07, 7.573D-07, 1.128D-06, 1.565D-06,
     $ 2.066D-06, 2.629D-06, 3.248D-06, 3.923D-06, 4.650D-06, 5.427D-06,
     $ 6.249D-06/
      data (WNDNO( 93,J,2),J=1,13) /
     $ 3.56274260D+03, 3.51519560D+03, 3.46777620D+03, 3.42048810D+03,
     $ 3.37333490D+03, 3.32631990D+03, 3.27944610D+03, 3.23271630D+03,
     $ 3.18613310D+03, 3.13969870D+03, 3.09341490D+03, 3.04728340D+03,
     $ 3.00130500D+03/
      data ( FDNO( 93,J,2),J=1,13) /
     $ 2.811D-08, 8.519D-08, 1.721D-07, 2.885D-07, 4.341D-07, 6.096D-07,
     $ 8.144D-07, 1.048D-06, 1.312D-06, 1.603D-06, 1.923D-06, 2.271D-06,
     $ 2.648D-06/
      data (WNUPO( 94,J,1),J=1,13) /
     $ 4.28866650D+03, 4.23244300D+03, 4.17635470D+03, 4.12040580D+03,
     $ 4.06460010D+03, 4.00894140D+03, 3.95343300D+03, 3.89807800D+03,
     $ 3.84287900D+03, 3.78783850D+03, 3.73295830D+03, 3.67823990D+03,
     $ 3.62368400D+03/
      data ( FUPO( 94,J,1),J=1,13) /
     $ 8.433D-08, 2.517D-07, 4.992D-07, 8.257D-07, 1.229D-06, 1.703D-06,
     $ 2.246D-06, 2.855D-06, 3.525D-06, 4.255D-06, 5.039D-06, 5.877D-06,
     $ 6.749D-06/
      data (WNDNO( 94,J,1),J=1,13) /
     $ 3.61258660D+03, 3.56295540D+03, 3.51346140D+03, 3.46410860D+03,
     $ 3.41490090D+03, 3.36584180D+03, 3.31693460D+03, 3.26818230D+03,
     $ 3.21958760D+03, 3.17115270D+03, 3.12287960D+03, 3.07476960D+03,
     $ 3.02682380D+03/
      data ( FDNO( 94,J,1),J=1,13) /
     $ 2.988D-08, 9.053D-08, 1.828D-07, 3.062D-07, 4.606D-07, 6.466D-07,
     $ 8.640D-07, 1.112D-06, 1.390D-06, 1.699D-06, 2.038D-06, 2.407D-06,
     $ 2.778D-06/
      data (WNUPO( 94,J,2),J=1,13) /
     $ 4.20171620D+03, 4.14804040D+03, 4.09449060D+03, 4.04107070D+03,
     $ 3.98778420D+03, 3.93463460D+03, 3.88162490D+03, 3.82875800D+03,
     $ 3.77603660D+03, 3.72346280D+03, 3.67103850D+03, 3.61876520D+03,
     $ 3.56664390D+03/
      data ( FUPO( 94,J,2),J=1,13) /
     $ 7.765D-08, 2.319D-07, 4.604D-07, 7.620D-07, 1.135D-06, 1.574D-06,
     $ 2.078D-06, 2.644D-06, 3.266D-06, 3.944D-06, 4.674D-06, 5.455D-06,
     $ 6.278D-06/
      data (WNDNO( 94,J,2),J=1,13) /
     $ 3.55354970D+03, 3.50603400D+03, 3.45864600D+03, 3.41138950D+03,
     $ 3.36426790D+03, 3.31728460D+03, 3.27044270D+03, 3.22374490D+03,
     $ 3.17719370D+03, 3.13079140D+03, 3.08453980D+03, 3.03844030D+03,
     $ 2.99249410D+03/
      data ( FDNO( 94,J,2),J=1,13) /
     $ 2.805D-08, 8.497D-08, 1.717D-07, 2.877D-07, 4.329D-07, 6.079D-07,
     $ 8.122D-07, 1.045D-06, 1.307D-06, 1.598D-06, 1.917D-06, 2.264D-06,
     $ 2.640D-06/
      data (WNUPO( 95,J,1),J=1,13) /
     $ 4.28520600D+03, 4.22894510D+03, 4.17281940D+03, 4.11683320D+03,
     $ 4.06099030D+03, 4.00529440D+03, 3.94974890D+03, 3.89435670D+03,
     $ 3.83912070D+03, 3.78404310D+03, 3.72912570D+03, 3.67437000D+03,
     $ 3.61977680D+03/
      data ( FUPO( 95,J,1),J=1,13) /
     $ 8.492D-08, 2.533D-07, 5.025D-07, 8.307D-07, 1.237D-06, 1.713D-06,
     $ 2.259D-06, 2.871D-06, 3.544D-06, 4.277D-06, 5.065D-06, 5.905D-06,
     $ 6.783D-06/
      data (WNDNO( 95,J,1),J=1,13) /
     $ 3.60279370D+03, 3.55319590D+03, 3.50373530D+03, 3.45441610D+03,
     $ 3.40524210D+03, 3.35621680D+03, 3.30734360D+03, 3.25862530D+03,
     $ 3.21006480D+03, 3.16166410D+03, 3.11342520D+03, 3.06534950D+03,
     $ 3.01743790D+03/
      data ( FDNO( 95,J,1),J=1,13) /
     $ 2.982D-08, 9.031D-08, 1.824D-07, 3.054D-07, 4.594D-07, 6.450D-07,
     $ 8.613D-07, 1.108D-06, 1.386D-06, 1.694D-06, 2.031D-06, 2.399D-06,
     $ 2.770D-06/
      data (WNUPO( 95,J,2),J=1,13) /
     $ 4.19857840D+03, 4.14486780D+03, 4.09128330D+03, 4.03782870D+03,
     $ 3.98450760D+03, 3.93132340D+03, 3.87827910D+03, 3.82537780D+03,
     $ 3.77262180D+03, 3.72001360D+03, 3.66755480D+03, 3.61524690D+03,
     $ 3.56309100D+03/
      data ( FUPO( 95,J,2),J=1,13) /
     $ 7.820D-08, 2.334D-07, 4.634D-07, 7.667D-07, 1.142D-06, 1.584D-06,
     $ 2.090D-06, 2.658D-06, 3.284D-06, 3.965D-06, 4.698D-06, 5.481D-06,
     $ 6.312D-06/
      data (WNDNO( 95,J,2),J=1,13) /
     $ 3.54430300D+03, 3.49681850D+03, 3.44946190D+03, 3.40223690D+03,
     $ 3.35514690D+03, 3.30819540D+03, 3.26138520D+03, 3.21471930D+03,
     $ 3.16820010D+03, 3.12182990D+03, 3.07561040D+03, 3.02954300D+03,
     $ 2.98362890D+03/
      data ( FDNO( 95,J,2),J=1,13) /
     $ 2.799D-08, 8.482D-08, 1.713D-07, 2.870D-07, 4.317D-07, 6.063D-07,
     $ 8.099D-07, 1.042D-06, 1.304D-06, 1.593D-06, 1.911D-06, 2.257D-06,
     $ 2.631D-06/
      data (WNUPO( 96,J,1),J=1,13) /
     $ 4.28166130D+03, 4.22536290D+03, 4.16919980D+03, 4.11317620D+03,
     $ 4.05729600D+03, 4.00156280D+03, 3.94598000D+03, 3.89055060D+03,
     $ 3.83527740D+03, 3.78016260D+03, 3.72520800D+03, 3.67041490D+03,
     $ 3.61578430D+03/
      data ( FUPO( 96,J,1),J=1,13) /
     $ 8.550D-08, 2.550D-07, 5.058D-07, 8.361D-07, 1.244D-06, 1.724D-06,
     $ 2.272D-06, 2.887D-06, 3.564D-06, 4.300D-06, 5.092D-06, 5.937D-06,
     $ 6.817D-06/
      data (WNDNO( 96,J,1),J=1,13) /
     $ 3.59294370D+03, 3.54337910D+03, 3.49395190D+03, 3.44466620D+03,
     $ 3.39552580D+03, 3.34653430D+03, 3.29769500D+03, 3.24901070D+03,
     $ 3.20048430D+03, 3.15211780D+03, 3.10391310D+03, 3.05587160D+03,
     $ 3.00799410D+03/
      data ( FDNO( 96,J,1),J=1,13) /
     $ 2.976D-08, 9.010D-08, 1.819D-07, 3.047D-07, 4.581D-07, 6.430D-07,
     $ 8.585D-07, 1.105D-06, 1.382D-06, 1.689D-06, 2.025D-06, 2.392D-06,
     $ 2.761D-06/
      data (WNUPO( 96,J,2),J=1,13) /
     $ 4.19536220D+03, 4.14161680D+03, 4.08799750D+03, 4.03450810D+03,
     $ 3.98115230D+03, 3.92793340D+03, 3.87485460D+03, 3.82191860D+03,
     $ 3.76912810D+03, 3.71648520D+03, 3.66399180D+03, 3.61164930D+03,
     $ 3.55945860D+03/
      data ( FUPO( 96,J,2),J=1,13) /
     $ 7.869D-08, 2.350D-07, 4.663D-07, 7.717D-07, 1.149D-06, 1.593D-06,
     $ 2.102D-06, 2.673D-06, 3.301D-06, 3.985D-06, 4.723D-06, 5.508D-06,
     $ 6.340D-06/
      data (WNDNO( 96,J,2),J=1,13) /
     $ 3.53500270D+03, 3.48754940D+03, 3.44022410D+03, 3.39303040D+03,
     $ 3.34597200D+03, 3.29905210D+03, 3.25227380D+03, 3.20563970D+03,
     $ 3.15915250D+03, 3.11281430D+03, 3.06662680D+03, 3.02059150D+03,
     $ 2.97470950D+03/
      data ( FDNO( 96,J,2),J=1,13) /
     $ 2.793D-08, 8.461D-08, 1.708D-07, 2.863D-07, 4.306D-07, 6.047D-07,
     $ 8.078D-07, 1.039D-06, 1.300D-06, 1.589D-06, 1.905D-06, 2.250D-06,
     $ 2.623D-06/
      data (WNUPO( 97,J,1),J=1,13) /
     $ 4.27803230D+03, 4.22169630D+03, 4.16549570D+03, 4.10943460D+03,
     $ 4.05351690D+03, 3.99774630D+03, 3.94212620D+03, 3.88665950D+03,
     $ 3.83134900D+03, 3.77619680D+03, 3.72120490D+03, 3.66637440D+03,
     $ 3.61170620D+03/
      data ( FUPO( 97,J,1),J=1,13) /
     $ 8.606D-08, 2.567D-07, 5.091D-07, 8.415D-07, 1.251D-06, 1.734D-06,
     $ 2.285D-06, 2.903D-06, 3.583D-06, 4.323D-06, 5.118D-06, 5.964D-06,
     $ 6.850D-06/
      data (WNDNO( 97,J,1),J=1,13) /
     $ 3.58303650D+03, 3.53350510D+03, 3.48411120D+03, 3.43485890D+03,
     $ 3.38575210D+03, 3.33679440D+03, 3.28798890D+03, 3.23933860D+03,
     $ 3.19084620D+03, 3.14251380D+03, 3.09434320D+03, 3.04633590D+03,
     $ 2.99849250D+03/
      data ( FDNO( 97,J,1),J=1,13) /
     $ 2.970D-08, 8.990D-08, 1.815D-07, 3.039D-07, 4.569D-07, 6.415D-07,
     $ 8.564D-07, 1.102D-06, 1.377D-06, 1.683D-06, 2.019D-06, 2.385D-06,
     $ 2.753D-06/
      data (WNUPO( 97,J,2),J=1,13) /
     $ 4.19206760D+03, 4.13828720D+03, 4.08463300D+03, 4.03110880D+03,
     $ 3.97771820D+03, 3.92446450D+03, 3.87135100D+03, 3.81838040D+03,
     $ 3.76555520D+03, 3.71287770D+03, 3.66034960D+03, 3.60797230D+03,
     $ 3.55574680D+03/
      data ( FUPO( 97,J,2),J=1,13) /
     $ 7.922D-08, 2.365D-07, 4.693D-07, 7.767D-07, 1.155D-06, 1.602D-06,
     $ 2.113D-06, 2.688D-06, 3.319D-06, 4.007D-06, 4.747D-06, 5.539D-06,
     $ 6.373D-06/
      data (WNDNO( 97,J,2),J=1,13) /
     $ 3.52564870D+03, 3.47822660D+03, 3.43093250D+03, 3.38377030D+03,
     $ 3.33674330D+03, 3.28985510D+03, 3.24310840D+03, 3.19650620D+03,
     $ 3.15005090D+03, 3.10374460D+03, 3.05758920D+03, 3.01158590D+03,
     $ 2.96573590D+03/
      data ( FDNO( 97,J,2),J=1,13) /
     $ 2.788D-08, 8.441D-08, 1.704D-07, 2.855D-07, 4.294D-07, 6.031D-07,
     $ 8.051D-07, 1.036D-06, 1.296D-06, 1.584D-06, 1.899D-06, 2.243D-06,
     $ 2.615D-06/
      data (WNUPO( 98,J,1),J=1,13) /
     $ 4.27431890D+03, 4.21794510D+03, 4.16170680D+03, 4.10560810D+03,
     $ 4.04965290D+03, 3.99384480D+03, 3.93818730D+03, 3.88268320D+03,
     $ 3.82733520D+03, 3.77214570D+03, 3.71711620D+03, 3.66224820D+03,
     $ 3.60754230D+03/
      data ( FUPO( 98,J,1),J=1,13) /
     $ 8.667D-08, 2.585D-07, 5.124D-07, 8.467D-07, 1.259D-06, 1.744D-06,
     $ 2.298D-06, 2.919D-06, 3.603D-06, 4.346D-06, 5.144D-06, 5.995D-06,
     $ 6.882D-06/
      data (WNDNO( 98,J,1),J=1,13) /
     $ 3.57307240D+03, 3.52357400D+03, 3.47421340D+03, 3.42499450D+03,
     $ 3.37592120D+03, 3.32699710D+03, 3.27822540D+03, 3.22960910D+03,
     $ 3.18115060D+03, 3.13285230D+03, 3.08471580D+03, 3.03674250D+03,
     $ 2.98893320D+03/
      data ( FDNO( 98,J,1),J=1,13) /
     $ 2.964D-08, 8.970D-08, 1.810D-07, 3.031D-07, 4.557D-07, 6.396D-07,
     $ 8.538D-07, 1.099D-06, 1.374D-06, 1.678D-06, 2.013D-06, 2.377D-06,
     $ 2.745D-06/
      data (WNUPO( 98,J,2),J=1,13) /
     $ 4.18869440D+03, 4.13487890D+03, 4.08118970D+03, 4.02763060D+03,
     $ 3.97420510D+03, 3.92091660D+03, 3.86776830D+03, 3.81476290D+03,
     $ 3.76190300D+03, 3.70919070D+03, 3.65662780D+03, 3.60421570D+03,
     $ 3.55195520D+03/
      data ( FUPO( 98,J,2),J=1,13) /
     $ 7.979D-08, 2.381D-07, 4.724D-07, 7.810D-07, 1.163D-06, 1.611D-06,
     $ 2.126D-06, 2.703D-06, 3.337D-06, 4.028D-06, 4.771D-06, 5.564D-06,
     $ 6.405D-06/
      data (WNDNO( 98,J,2),J=1,13) /
     $ 3.51624130D+03, 3.46885020D+03, 3.42158740D+03, 3.37445640D+03,
     $ 3.32746100D+03, 3.28060420D+03, 3.23388930D+03, 3.18731880D+03,
     $ 3.14089540D+03, 3.09462100D+03, 3.04849750D+03, 3.00252620D+03,
     $ 2.95670810D+03/
      data ( FDNO( 98,J,2),J=1,13) /
     $ 2.782D-08, 8.421D-08, 1.701D-07, 2.848D-07, 4.283D-07, 6.015D-07,
     $ 8.030D-07, 1.033D-06, 1.292D-06, 1.579D-06, 1.893D-06, 2.236D-06,
     $ 2.607D-06/
      data (WNUPO( 99,J,1),J=1,13) /
     $ 4.27052070D+03, 4.21410920D+03, 4.15783310D+03, 4.10169670D+03,
     $ 4.04570380D+03, 3.98985820D+03, 3.93416300D+03, 3.87862150D+03,
     $ 3.82323600D+03, 3.76800890D+03, 3.71294190D+03, 3.65803620D+03,
     $ 3.60329250D+03/
      data ( FUPO( 99,J,1),J=1,13) /
     $ 8.726D-08, 2.602D-07, 5.157D-07, 8.523D-07, 1.266D-06, 1.754D-06,
     $ 2.312D-06, 2.936D-06, 3.622D-06, 4.369D-06, 5.173D-06, 6.025D-06,
     $ 6.919D-06/
      data (WNDNO( 99,J,1),J=1,13) /
     $ 3.56305130D+03, 3.51358590D+03, 3.46425850D+03, 3.41507290D+03,
     $ 3.36603310D+03, 3.31714260D+03, 3.26840470D+03, 3.21982210D+03,
     $ 3.17139760D+03, 3.12313330D+03, 3.07503080D+03, 3.02709160D+03,
     $ 2.97931630D+03/
      data ( FDNO( 99,J,1),J=1,13) /
     $ 2.958D-08, 8.955D-08, 1.806D-07, 3.024D-07, 4.546D-07, 6.377D-07,
     $ 8.518D-07, 1.095D-06, 1.369D-06, 1.673D-06, 2.007D-06, 2.370D-06,
     $ 2.737D-06/
      data (WNUPO( 99,J,2),J=1,13) /
     $ 4.18524230D+03, 4.13139180D+03, 4.07766750D+03, 4.02407330D+03,
     $ 3.97061280D+03, 3.91728940D+03, 3.86410620D+03, 3.81106600D+03,
     $ 3.75817120D+03, 3.70542410D+03, 3.65282630D+03, 3.60037920D+03,
     $ 3.54808370D+03/
      data ( FUPO( 99,J,2),J=1,13) /
     $ 8.030D-08, 2.396D-07, 4.754D-07, 7.863D-07, 1.170D-06, 1.621D-06,
     $ 2.138D-06, 2.717D-06, 3.355D-06, 4.049D-06, 4.795D-06, 5.594D-06,
     $ 6.437D-06/
      data (WNDNO( 99,J,2),J=1,13) /
     $ 3.50678050D+03, 3.45942040D+03, 3.41218870D+03, 3.36508900D+03,
     $ 3.31812490D+03, 3.27129970D+03, 3.22461640D+03, 3.17807770D+03,
     $ 3.13168600D+03, 3.08544350D+03, 3.03935190D+03, 2.99341260D+03,
     $ 2.94762640D+03/
      data ( FDNO( 99,J,2),J=1,13) /
     $ 2.776D-08, 8.407D-08, 1.696D-07, 2.841D-07, 4.272D-07, 5.995D-07,
     $ 8.010D-07, 1.030D-06, 1.288D-06, 1.574D-06, 1.888D-06, 2.229D-06,
     $ 2.599D-06/
      data (WNUPO(100,J,1),J=1,13) /
     $ 4.26663770D+03, 4.21018830D+03, 4.15387430D+03, 4.09770010D+03,
     $ 4.04166950D+03, 3.98578610D+03, 3.93005330D+03, 3.87447410D+03,
     $ 3.81905100D+03, 3.76378630D+03, 3.70868160D+03, 3.65373810D+03,
     $ 3.59895640D+03/
      data ( FUPO(100,J,1),J=1,13) /
     $ 8.789D-08, 2.619D-07, 5.191D-07, 8.573D-07, 1.274D-06, 1.764D-06,
     $ 2.325D-06, 2.952D-06, 3.642D-06, 4.392D-06, 5.196D-06, 6.055D-06,
     $ 6.950D-06/
      data (WNDNO(100,J,1),J=1,13) /
     $ 3.55297330D+03, 3.50354100D+03, 3.45424660D+03, 3.40509440D+03,
     $ 3.35608800D+03, 3.30723100D+03, 3.25852670D+03, 3.20997800D+03,
     $ 3.16158730D+03, 3.11335690D+03, 3.06528850D+03, 3.01738320D+03,
     $ 2.96964180D+03/
      data ( FDNO(100,J,1),J=1,13) /
     $ 2.953D-08, 8.935D-08, 1.802D-07, 3.016D-07, 4.534D-07, 6.363D-07,
     $ 8.493D-07, 1.093D-06, 1.366D-06, 1.668D-06, 2.000D-06, 2.363D-06,
     $ 2.729D-06/
      data (WNUPO(100,J,2),J=1,13) /
     $ 4.18171140D+03, 4.12782560D+03, 4.07406610D+03, 4.02043680D+03,
     $ 3.96694130D+03, 3.91358290D+03, 3.86036470D+03, 3.80728950D+03,
     $ 3.75435980D+03, 3.70157770D+03, 3.64894490D+03, 3.59646280D+03,
     $ 3.54413210D+03/
      data ( FUPO(100,J,2),J=1,13) /
     $ 8.085D-08, 2.412D-07, 4.784D-07, 7.910D-07, 1.176D-06, 1.630D-06,
     $ 2.150D-06, 2.732D-06, 3.373D-06, 4.070D-06, 4.820D-06, 5.618D-06,
     $ 6.467D-06/
      data (WNDNO(100,J,2),J=1,13) /
     $ 3.49726640D+03, 3.44993730D+03, 3.40273660D+03, 3.35566810D+03,
     $ 3.30873540D+03, 3.26194160D+03, 3.21528990D+03, 3.16878280D+03,
     $ 3.12242290D+03, 3.07621230D+03, 3.03015260D+03, 2.98424510D+03,
     $ 2.93849070D+03/
      data ( FDNO(100,J,2),J=1,13) /
     $ 2.771D-08, 8.388D-08, 1.693D-07, 2.834D-07, 4.262D-07, 5.980D-07,
     $ 7.985D-07, 1.027D-06, 1.285D-06, 1.570D-06, 1.882D-06, 2.223D-06,
     $ 2.591D-06/
      data (WNUPO(101,J,1),J=1,13) /
     $ 4.26266970D+03, 4.20618220D+03, 4.14983030D+03, 4.09361820D+03,
     $ 4.03754970D+03, 3.98162850D+03, 3.92585800D+03, 3.87024100D+03,
     $ 3.81478020D+03, 3.75947770D+03, 3.70433510D+03, 3.64935370D+03,
     $ 3.59453400D+03/
      data ( FUPO(101,J,1),J=1,13) /
     $ 8.846D-08, 2.636D-07, 5.224D-07, 8.627D-07, 1.282D-06, 1.775D-06,
     $ 2.338D-06, 2.969D-06, 3.662D-06, 4.415D-06, 5.224D-06, 6.090D-06,
     $ 6.985D-06/
      data (WNDNO(101,J,1),J=1,13) /
     $ 3.54283870D+03, 3.49343930D+03, 3.44417790D+03, 3.39505880D+03,
     $ 3.34608580D+03, 3.29726230D+03, 3.24859160D+03, 3.20007660D+03,
     $ 3.15171980D+03, 3.10352330D+03, 3.05548870D+03, 3.00761730D+03,
     $ 2.95990980D+03/
      data ( FDNO(101,J,1),J=1,13) /
     $ 2.947D-08, 8.916D-08, 1.798D-07, 3.009D-07, 4.523D-07, 6.345D-07,
     $ 8.468D-07, 1.089D-06, 1.362D-06, 1.663D-06, 1.995D-06, 2.356D-06,
     $ 2.721D-06/
      data (WNUPO(101,J,2),J=1,13) /
     $ 4.17810130D+03, 4.12418020D+03, 4.07038550D+03, 4.01672100D+03,
     $ 3.96319030D+03, 3.90979670D+03, 3.85654340D+03, 3.80343320D+03,
     $ 3.75046850D+03, 3.69765130D+03, 3.64498350D+03, 3.59246620D+03,
     $ 3.54010020D+03/
      data ( FUPO(101,J,2),J=1,13) /
     $ 8.139D-08, 2.427D-07, 4.814D-07, 7.960D-07, 1.184D-06, 1.640D-06,
     $ 2.162D-06, 2.747D-06, 3.391D-06, 4.091D-06, 4.845D-06, 5.647D-06,
     $ 6.498D-06/
      data (WNDNO(101,J,2),J=1,13) /
     $ 3.48769900D+03, 3.44040080D+03, 3.39323120D+03, 3.34619380D+03,
     $ 3.29929240D+03, 3.25253000D+03, 3.20590980D+03, 3.15943440D+03,
     $ 3.11310620D+03, 3.06692730D+03, 3.02089940D+03, 2.97502370D+03,
     $ 2.92930120D+03/
      data ( FDNO(101,J,2),J=1,13) /
     $ 2.766D-08, 8.369D-08, 1.689D-07, 2.827D-07, 4.251D-07, 5.966D-07,
     $ 7.966D-07, 1.024D-06, 1.281D-06, 1.565D-06, 1.876D-06, 2.216D-06,
     $ 2.583D-06/
      data (WNUPO(102,J,1),J=1,13) /
     $ 4.25861660D+03, 4.20209090D+03, 4.14570090D+03, 4.08945070D+03,
     $ 4.03334420D+03, 3.97738510D+03, 3.92157670D+03, 3.86592190D+03,
     $ 3.81042320D+03, 3.75508280D+03, 3.69990230D+03, 3.64488290D+03,
     $ 3.59002500D+03/
      data ( FUPO(102,J,1),J=1,13) /
     $ 8.906D-08, 2.654D-07, 5.256D-07, 8.685D-07, 1.290D-06, 1.785D-06,
     $ 2.351D-06, 2.985D-06, 3.682D-06, 4.438D-06, 5.251D-06, 6.118D-06,
     $ 7.020D-06/
      data (WNDNO(102,J,1),J=1,13) /
     $ 3.53264740D+03, 3.48328080D+03, 3.43405240D+03, 3.38496650D+03,
     $ 3.33602670D+03, 3.28723670D+03, 3.23859950D+03, 3.19011820D+03,
     $ 3.14179510D+03, 3.09363240D+03, 3.04563170D+03, 2.99779410D+03,
     $ 2.95012040D+03/
      data ( FDNO(102,J,1),J=1,13) /
     $ 2.942D-08, 8.898D-08, 1.794D-07, 3.002D-07, 4.511D-07, 6.327D-07,
     $ 8.444D-07, 1.086D-06, 1.358D-06, 1.659D-06, 1.988D-06, 2.348D-06,
     $ 2.713D-06/
      data (WNUPO(102,J,2),J=1,13) /
     $ 4.17441210D+03, 4.12045550D+03, 4.06662540D+03, 4.01292560D+03,
     $ 3.95935960D+03, 3.90593080D+03, 3.85264240D+03, 3.79949700D+03,
     $ 3.74649710D+03, 3.69364480D+03, 3.64094180D+03, 3.58838920D+03,
     $ 3.53598790D+03/
      data ( FUPO(102,J,2),J=1,13) /
     $ 8.197D-08, 2.443D-07, 4.845D-07, 8.005D-07, 1.191D-06, 1.649D-06,
     $ 2.174D-06, 2.762D-06, 3.409D-06, 4.112D-06, 4.869D-06, 5.675D-06,
     $ 6.532D-06/
      data (WNDNO(102,J,2),J=1,13) /
     $ 3.47807860D+03, 3.43081120D+03, 3.38367250D+03, 3.33666630D+03,
     $ 3.28979600D+03, 3.24306500D+03, 3.19647620D+03, 3.15003240D+03,
     $ 3.10373590D+03, 3.05758870D+03, 3.01159250D+03, 2.96574870D+03,
     $ 2.92005780D+03/
      data ( FDNO(102,J,2),J=1,13) /
     $ 2.760D-08, 8.351D-08, 1.684D-07, 2.820D-07, 4.240D-07, 5.951D-07,
     $ 7.941D-07, 1.021D-06, 1.277D-06, 1.560D-06, 1.871D-06, 2.209D-06,
     $ 2.576D-06/
      data (WNUPO(103,J,1),J=1,13) /
     $ 4.25447810D+03, 4.19791410D+03, 4.14148590D+03, 4.08519750D+03,
     $ 4.02905300D+03, 3.97305580D+03, 3.91720940D+03, 3.86151660D+03,
     $ 3.80598000D+03, 3.75060150D+03, 3.69538300D+03, 3.64032530D+03,
     $ 3.58542910D+03/
      data ( FUPO(103,J,1),J=1,13) /
     $ 8.971D-08, 2.671D-07, 5.293D-07, 8.737D-07, 1.298D-06, 1.796D-06,
     $ 2.365D-06, 3.001D-06, 3.701D-06, 4.462D-06, 5.278D-06, 6.151D-06,
     $ 7.054D-06/
      data (WNDNO(103,J,1),J=1,13) /
     $ 3.52239960D+03, 3.47306570D+03, 3.42387030D+03, 3.37481740D+03,
     $ 3.32591080D+03, 3.27715410D+03, 3.22855040D+03, 3.18010270D+03,
     $ 3.13181330D+03, 3.08368440D+03, 3.03571740D+03, 2.98791370D+03,
     $ 2.94027370D+03/
      data ( FDNO(103,J,1),J=1,13) /
     $ 2.937D-08, 8.879D-08, 1.790D-07, 2.995D-07, 4.500D-07, 6.314D-07,
     $ 8.425D-07, 1.083D-06, 1.354D-06, 1.654D-06, 1.983D-06, 2.342D-06,
     $ 2.705D-06/
      data (WNUPO(103,J,2),J=1,13) /
     $ 4.17064340D+03, 4.11665130D+03, 4.06278570D+03, 4.00905050D+03,
     $ 3.95544910D+03, 3.90198500D+03, 3.84866130D+03, 3.79548070D+03,
     $ 3.74244560D+03, 3.68955800D+03, 3.63681970D+03, 3.58423180D+03,
     $ 3.53179490D+03/
      data ( FUPO(103,J,2),J=1,13) /
     $ 8.249D-08, 2.459D-07, 4.876D-07, 8.059D-07, 1.198D-06, 1.659D-06,
     $ 2.186D-06, 2.778D-06, 3.427D-06, 4.134D-06, 4.893D-06, 5.702D-06,
     $ 6.561D-06/
      data (WNDNO(103,J,2),J=1,13) /
     $ 3.46840510D+03, 3.42116840D+03, 3.37406060D+03, 3.32708540D+03,
     $ 3.28024630D+03, 3.23354660D+03, 3.18698930D+03, 3.14057690D+03,
     $ 3.09431200D+03, 3.04819650D+03, 3.00223210D+03, 2.95641990D+03,
     $ 2.91076080D+03/
      data ( FDNO(103,J,2),J=1,13) /
     $ 2.756D-08, 8.338D-08, 1.681D-07, 2.814D-07, 4.230D-07, 5.932D-07,
     $ 7.923D-07, 1.019D-06, 1.273D-06, 1.556D-06, 1.865D-06, 2.203D-06,
     $ 2.568D-06/
      data (WNUPO(104,J,1),J=1,13) /
     $ 4.25025400D+03, 4.19365170D+03, 4.13718510D+03, 4.08085850D+03,
     $ 4.02467570D+03, 3.96864040D+03, 3.91275590D+03, 3.85702500D+03,
     $ 3.80145020D+03, 3.74603370D+03, 3.69077690D+03, 3.63568090D+03,
     $ 3.58074620D+03/
      data ( FUPO(104,J,1),J=1,13) /
     $ 9.029D-08, 2.689D-07, 5.324D-07, 8.792D-07, 1.305D-06, 1.806D-06,
     $ 2.378D-06, 3.018D-06, 3.722D-06, 4.486D-06, 5.304D-06, 6.179D-06,
     $ 7.087D-06/
      data (WNDNO(104,J,1),J=1,13) /
     $ 3.51209540D+03, 3.46279410D+03, 3.41363150D+03, 3.36461160D+03,
     $ 3.31573810D+03, 3.26701470D+03, 3.21844450D+03, 3.17003030D+03,
     $ 3.12177450D+03, 3.07367930D+03, 3.02574610D+03, 2.97797600D+03,
     $ 2.93036970D+03/
      data ( FDNO(104,J,1),J=1,13) /
     $ 2.932D-08, 8.861D-08, 1.786D-07, 2.988D-07, 4.489D-07, 6.297D-07,
     $ 8.402D-07, 1.080D-06, 1.350D-06, 1.649D-06, 1.977D-06, 2.334D-06,
     $ 2.698D-06/
      data (WNUPO(104,J,2),J=1,13) /
     $ 4.16679510D+03, 4.11276740D+03, 4.05886630D+03, 4.00509550D+03,
     $ 3.95145870D+03, 3.89795920D+03, 3.84460010D+03, 3.79138410D+03,
     $ 3.73831360D+03, 3.68539070D+03, 3.63261700D+03, 3.57999360D+03,
     $ 3.52752110D+03/
      data ( FUPO(104,J,2),J=1,13) /
     $ 8.304D-08, 2.475D-07, 4.908D-07, 8.106D-07, 1.205D-06, 1.668D-06,
     $ 2.199D-06, 2.792D-06, 3.445D-06, 4.155D-06, 4.918D-06, 5.734D-06,
     $ 6.594D-06/
      data (WNDNO(104,J,2),J=1,13) /
     $ 3.45867860D+03, 3.41147270D+03, 3.36439570D+03, 3.31745150D+03,
     $ 3.27064350D+03, 3.22397500D+03, 3.17744900D+03, 3.13106810D+03,
     $ 3.08483480D+03, 3.03875090D+03, 2.99281810D+03, 2.94703760D+03,
     $ 2.90141000D+03/
      data ( FDNO(104,J,2),J=1,13) /
     $ 2.751D-08, 8.321D-08, 1.677D-07, 2.807D-07, 4.220D-07, 5.919D-07,
     $ 7.900D-07, 1.016D-06, 1.270D-06, 1.551D-06, 1.860D-06, 2.196D-06,
     $ 2.560D-06/
      data (WNUPO(105,J,1),J=1,13) /
     $ 4.24594430D+03, 4.18930340D+03, 4.13279840D+03, 4.07643330D+03,
     $ 4.02021220D+03, 3.96413870D+03, 3.90821590D+03, 3.85244670D+03,
     $ 3.79683370D+03, 3.74137890D+03, 3.68608380D+03, 3.63094940D+03,
     $ 3.57597610D+03/
      data ( FUPO(105,J,1),J=1,13) /
     $ 9.091D-08, 2.707D-07, 5.359D-07, 8.847D-07, 1.313D-06, 1.817D-06,
     $ 2.392D-06, 3.035D-06, 3.742D-06, 4.509D-06, 5.335D-06, 6.211D-06,
     $ 7.124D-06/
      data (WNDNO(105,J,1),J=1,13) /
     $ 3.50173480D+03, 3.45246610D+03, 3.40333620D+03, 3.35434920D+03,
     $ 3.30550880D+03, 3.25681860D+03, 3.20828180D+03, 3.15990100D+03,
     $ 3.11167880D+03, 3.06361720D+03, 3.01571770D+03, 2.96798130D+03,
     $ 2.92040850D+03/
      data ( FDNO(105,J,1),J=1,13) /
     $ 2.927D-08, 8.848D-08, 1.782D-07, 2.981D-07, 4.479D-07, 6.280D-07,
     $ 8.379D-07, 1.077D-06, 1.346D-06, 1.644D-06, 1.971D-06, 2.327D-06,
     $ 2.691D-06/
      data (WNUPO(105,J,2),J=1,13) /
     $ 4.16286710D+03, 4.10880370D+03, 4.05486690D+03, 4.00106050D+03,
     $ 3.94738810D+03, 3.89385310D+03, 3.84045850D+03, 3.78720700D+03,
     $ 3.73410110D+03, 3.68114270D+03, 3.62833350D+03, 3.57567440D+03,
     $ 3.52316620D+03/
      data ( FUPO(105,J,2),J=1,13) /
     $ 8.359D-08, 2.491D-07, 4.938D-07, 8.158D-07, 1.212D-06, 1.678D-06,
     $ 2.211D-06, 2.808D-06, 3.464D-06, 4.177D-06, 4.943D-06, 5.761D-06,
     $ 6.627D-06/
      data (WNDNO(105,J,2),J=1,13) /
     $ 3.44889930D+03, 3.40172400D+03, 3.35467780D+03, 3.30776440D+03,
     $ 3.26098750D+03, 3.21435020D+03, 3.16785550D+03, 3.12150600D+03,
     $ 3.07530410D+03, 3.02925180D+03, 2.98335060D+03, 2.93760170D+03,
     $ 2.89200570D+03/
      data ( FDNO(105,J,2),J=1,13) /
     $ 2.746D-08, 8.303D-08, 1.673D-07, 2.800D-07, 4.209D-07, 5.905D-07,
     $ 7.882D-07, 1.013D-06, 1.266D-06, 1.547D-06, 1.855D-06, 2.190D-06,
     $ 2.553D-06/
      data (WNUPO(106,J,1),J=1,13) /
     $ 4.24154860D+03, 4.18486910D+03, 4.12832550D+03, 4.07192190D+03,
     $ 4.01566240D+03, 3.95955040D+03, 3.90358920D+03, 3.84778170D+03,
     $ 3.79213040D+03, 3.73663720D+03, 3.68130360D+03, 3.62613060D+03,
     $ 3.57111860D+03/
      data ( FUPO(106,J,1),J=1,13) /
     $ 9.156D-08, 2.725D-07, 5.393D-07, 8.900D-07, 1.321D-06, 1.827D-06,
     $ 2.405D-06, 3.052D-06, 3.762D-06, 4.533D-06, 5.360D-06, 6.242D-06,
     $ 7.156D-06/
      data (WNDNO(106,J,1),J=1,13) /
     $ 3.49131790D+03, 3.44208170D+03, 3.39298450D+03, 3.34403030D+03,
     $ 3.29522290D+03, 3.24656590D+03, 3.19806230D+03, 3.14971500D+03,
     $ 3.10152630D+03, 3.05349820D+03, 3.00563230D+03, 2.95792950D+03,
     $ 2.91039020D+03/
      data ( FDNO(106,J,1),J=1,13) /
     $ 2.922D-08, 8.831D-08, 1.778D-07, 2.974D-07, 4.468D-07, 6.263D-07,
     $ 8.357D-07, 1.074D-06, 1.342D-06, 1.639D-06, 1.965D-06, 2.321D-06,
     $ 2.683D-06/
      data (WNUPO(106,J,2),J=1,13) /
     $ 4.15885930D+03, 4.10476000D+03, 4.05078740D+03, 3.99694520D+03,
     $ 3.94323720D+03, 3.88966650D+03, 3.83623630D+03, 3.78294930D+03,
     $ 3.72980780D+03, 3.67681390D+03, 3.62396900D+03, 3.57127420D+03,
     $ 3.51873020D+03/
      data ( FUPO(106,J,2),J=1,13) /
     $ 8.417D-08, 2.508D-07, 4.972D-07, 8.204D-07, 1.219D-06, 1.688D-06,
     $ 2.223D-06, 2.823D-06, 3.482D-06, 4.198D-06, 4.967D-06, 5.791D-06,
     $ 6.659D-06/
      data (WNDNO(106,J,2),J=1,13) /
     $ 3.43906720D+03, 3.39192240D+03, 3.34490690D+03, 3.29802440D+03,
     $ 3.25127840D+03, 3.20467230D+03, 3.15820880D+03, 3.11189070D+03,
     $ 3.06572020D+03, 3.01969940D+03, 2.97382980D+03, 2.92811240D+03,
     $ 2.88254790D+03/
      data ( FDNO(106,J,2),J=1,13) /
     $ 2.741D-08, 8.286D-08, 1.670D-07, 2.794D-07, 4.200D-07, 5.887D-07,
     $ 7.859D-07, 1.010D-06, 1.263D-06, 1.542D-06, 1.849D-06, 2.183D-06,
     $ 2.545D-06/
      data (WNUPO(107,J,1),J=1,13) /
     $ 4.23706700D+03, 4.18034870D+03, 4.12376630D+03, 4.06732410D+03,
     $ 4.01102590D+03, 3.95487540D+03, 3.89887570D+03, 3.84302980D+03,
     $ 3.78733990D+03, 3.73180820D+03, 3.67643600D+03, 3.62122420D+03,
     $ 3.56617330D+03/
      data ( FUPO(107,J,1),J=1,13) /
     $ 9.216D-08, 2.743D-07, 5.432D-07, 8.958D-07, 1.329D-06, 1.838D-06,
     $ 2.419D-06, 3.068D-06, 3.782D-06, 4.556D-06, 5.390D-06, 6.272D-06,
     $ 7.192D-06/
      data (WNDNO(107,J,1),J=1,13) /
     $ 3.48084480D+03, 3.43164110D+03, 3.38257640D+03, 3.33365500D+03,
     $ 3.28488060D+03, 3.23625660D+03, 3.18778620D+03, 3.13947220D+03,
     $ 3.09131700D+03, 3.04332240D+03, 2.99549000D+03, 2.94782070D+03,
     $ 2.90031490D+03/
      data ( FDNO(107,J,1),J=1,13) /
     $ 2.917D-08, 8.814D-08, 1.774D-07, 2.967D-07, 4.457D-07, 6.247D-07,
     $ 8.335D-07, 1.072D-06, 1.339D-06, 1.634D-06, 1.960D-06, 2.314D-06,
     $ 2.676D-06/
      data (WNUPO(107,J,2),J=1,13) /
     $ 4.15477140D+03, 4.10063620D+03, 4.04662760D+03, 3.99274960D+03,
     $ 3.93900580D+03, 3.88539940D+03, 3.83193350D+03, 3.77861080D+03,
     $ 3.72543360D+03, 3.67240400D+03, 3.61952330D+03, 3.56679270D+03,
     $ 3.51421260D+03/
      data ( FUPO(107,J,2),J=1,13) /
     $ 8.474D-08, 2.523D-07, 5.000D-07, 8.258D-07, 1.226D-06, 1.697D-06,
     $ 2.235D-06, 2.838D-06, 3.500D-06, 4.220D-06, 4.995D-06, 5.817D-06,
     $ 6.690D-06/
      data (WNDNO(107,J,2),J=1,13) /
     $ 3.42918250D+03, 3.38206810D+03, 3.33508320D+03, 3.28823150D+03,
     $ 3.24151640D+03, 3.19494130D+03, 3.14850900D+03, 3.10222220D+03,
     $ 3.05608310D+03, 3.01009380D+03, 2.96425560D+03, 2.91856970D+03,
     $ 2.87303660D+03/
      data ( FDNO(107,J,2),J=1,13) /
     $ 2.737D-08, 8.274D-08, 1.667D-07, 2.788D-07, 4.190D-07, 5.874D-07,
     $ 7.837D-07, 1.008D-06, 1.260D-06, 1.538D-06, 1.844D-06, 2.177D-06,
     $ 2.538D-06/
      data (WNUPO(108,J,1),J=1,13) /
     $ 4.23249900D+03, 4.17574180D+03, 4.11912060D+03, 4.06263960D+03,
     $ 4.00630270D+03, 3.95011350D+03, 3.89407520D+03, 3.83819060D+03,
     $ 3.78246210D+03, 3.72689170D+03, 3.67148080D+03, 3.61623010D+03,
     $ 3.56114010D+03/
      data ( FUPO(108,J,1),J=1,13) /
     $ 9.279D-08, 2.761D-07, 5.465D-07, 9.014D-07, 1.337D-06, 1.848D-06,
     $ 2.433D-06, 3.085D-06, 3.802D-06, 4.580D-06, 5.414D-06, 6.302D-06,
     $ 7.228D-06/
      data (WNDNO(108,J,1),J=1,13) /
     $ 3.47031560D+03, 3.42114420D+03, 3.37211210D+03, 3.32322330D+03,
     $ 3.27448180D+03, 3.22589080D+03, 3.17745360D+03, 3.12917290D+03,
     $ 3.08105100D+03, 3.03308980D+03, 2.98529080D+03, 2.93765500D+03,
     $ 2.89018250D+03/
      data ( FDNO(108,J,1),J=1,13) /
     $ 2.912D-08, 8.797D-08, 1.771D-07, 2.961D-07, 4.447D-07, 6.235D-07,
     $ 8.313D-07, 1.069D-06, 1.335D-06, 1.630D-06, 1.954D-06, 2.307D-06,
     $ 2.669D-06/
      data (WNUPO(108,J,2),J=1,13) /
     $ 4.15060340D+03, 4.09643200D+03, 4.04238750D+03, 3.98847350D+03,
     $ 3.93469370D+03, 3.88105150D+03, 3.82754980D+03, 3.77419130D+03,
     $ 3.72097830D+03, 3.66791280D+03, 3.61499630D+03, 3.56222970D+03,
     $ 3.50961350D+03/
      data ( FUPO(108,J,2),J=1,13) /
     $ 8.530D-08, 2.540D-07, 5.033D-07, 8.307D-07, 1.233D-06, 1.707D-06,
     $ 2.248D-06, 2.853D-06, 3.519D-06, 4.241D-06, 5.019D-06, 5.847D-06,
     $ 6.721D-06/
      data (WNDNO(108,J,2),J=1,13) /
     $ 3.41924500D+03, 3.37216110D+03, 3.32520670D+03, 3.27838570D+03,
     $ 3.23170150D+03, 3.18515740D+03, 3.13875620D+03, 3.09250060D+03,
     $ 3.04639290D+03, 3.00043490D+03, 2.95462810D+03, 2.90897360D+03,
     $ 2.86347200D+03/
      data ( FDNO(108,J,2),J=1,13) /
     $ 2.732D-08, 8.258D-08, 1.663D-07, 2.782D-07, 4.180D-07, 5.862D-07,
     $ 7.820D-07, 1.005D-06, 1.256D-06, 1.534D-06, 1.839D-06, 2.171D-06,
     $ 2.530D-06/
      data (WNUPO(109,J,1),J=1,13) /
     $ 4.22784470D+03, 4.17104840D+03, 4.11438820D+03, 4.05786830D+03,
     $ 4.00149250D+03, 3.94526450D+03, 3.88918740D+03, 3.83326410D+03,
     $ 3.77749680D+03, 3.72188760D+03, 3.66643770D+03, 3.61114810D+03,
     $ 3.55601880D+03/
      data ( FUPO(109,J,1),J=1,13) /
     $ 9.341D-08, 2.779D-07, 5.498D-07, 9.069D-07, 1.345D-06, 1.859D-06,
     $ 2.446D-06, 3.102D-06, 3.822D-06, 4.604D-06, 5.442D-06, 6.336D-06,
     $ 7.263D-06/
      data (WNDNO(109,J,1),J=1,13) /
     $ 3.45973050D+03, 3.41059130D+03, 3.36159160D+03, 3.31273540D+03,
     $ 3.26402660D+03, 3.21546860D+03, 3.16706440D+03, 3.11881690D+03,
     $ 3.07072830D+03, 3.02280050D+03, 2.97503490D+03, 2.92743240D+03,
     $ 2.87999320D+03/
      data ( FDNO(109,J,1),J=1,13) /
     $ 2.908D-08, 8.781D-08, 1.767D-07, 2.954D-07, 4.437D-07, 6.219D-07,
     $ 8.292D-07, 1.066D-06, 1.331D-06, 1.625D-06, 1.948D-06, 2.300D-06,
     $ 2.662D-06/
      data (WNUPO(109,J,2),J=1,13) /
     $ 4.14635490D+03, 4.09214740D+03, 4.03806670D+03, 3.98411660D+03,
     $ 3.93030080D+03, 3.87662260D+03, 3.82308500D+03, 3.76969060D+03,
     $ 3.71644170D+03, 3.66334020D+03, 3.61038770D+03, 3.55758490D+03,
     $ 3.50493250D+03/
      data ( FUPO(109,J,2),J=1,13) /
     $ 8.585D-08, 2.556D-07, 5.065D-07, 8.359D-07, 1.241D-06, 1.717D-06,
     $ 2.260D-06, 2.869D-06, 3.537D-06, 4.263D-06, 5.041D-06, 5.876D-06,
     $ 6.756D-06/
      data (WNDNO(109,J,2),J=1,13) /
     $ 3.40925510D+03, 3.36220150D+03, 3.31527760D+03, 3.26848720D+03,
     $ 3.22183380D+03, 3.17532060D+03, 3.12895040D+03, 3.08272600D+03,
     $ 3.03664950D+03, 2.99072290D+03, 2.94494740D+03, 2.89932430D+03,
     $ 2.85385400D+03/
      data ( FDNO(109,J,2),J=1,13) /
     $ 2.728D-08, 8.242D-08, 1.659D-07, 2.775D-07, 4.170D-07, 5.845D-07,
     $ 7.799D-07, 1.002D-06, 1.253D-06, 1.529D-06, 1.833D-06, 2.164D-06,
     $ 2.523D-06/
      data (WNUPO(110,J,1),J=1,13) /
     $ 4.22310370D+03, 4.16626820D+03, 4.10956890D+03, 4.05300990D+03,
     $ 3.99659510D+03, 3.94032820D+03, 3.88421220D+03, 3.82824990D+03,
     $ 3.77244380D+03, 3.71679550D+03, 3.66130660D+03, 3.60597780D+03,
     $ 3.55080920D+03/
      data ( FUPO(110,J,1),J=1,13) /
     $ 9.406D-08, 2.797D-07, 5.534D-07, 9.123D-07, 1.353D-06, 1.870D-06,
     $ 2.460D-06, 3.119D-06, 3.842D-06, 4.626D-06, 5.470D-06, 6.365D-06,
     $ 7.297D-06/
      data (WNDNO(110,J,1),J=1,13) /
     $ 3.44908930D+03, 3.39998230D+03, 3.35101490D+03, 3.30219130D+03,
     $ 3.25351520D+03, 3.20499000D+03, 3.15661890D+03, 3.10840450D+03,
     $ 3.06034910D+03, 3.01245460D+03, 2.96472230D+03, 2.91715300D+03,
     $ 2.86974710D+03/
      data ( FDNO(110,J,1),J=1,13) /
     $ 2.904D-08, 8.769D-08, 1.764D-07, 2.948D-07, 4.427D-07, 6.204D-07,
     $ 8.271D-07, 1.063D-06, 1.328D-06, 1.621D-06, 1.943D-06, 2.294D-06,
     $ 2.654D-06/
      data (WNUPO(110,J,2),J=1,13) /
     $ 4.14202600D+03, 4.08778210D+03, 4.03366510D+03, 3.97967890D+03,
     $ 3.92582690D+03, 3.87211260D+03, 3.81853890D+03, 3.76510850D+03,
     $ 3.71182350D+03, 3.65868600D+03, 3.60569730D+03, 3.55285840D+03,
     $ 3.50016960D+03/
      data ( FUPO(110,J,2),J=1,13) /
     $ 8.644D-08, 2.573D-07, 5.096D-07, 8.406D-07, 1.248D-06, 1.726D-06,
     $ 2.273D-06, 2.884D-06, 3.556D-06, 4.285D-06, 5.068D-06, 5.904D-06,
     $ 6.785D-06/
      data (WNDNO(110,J,2),J=1,13) /
     $ 3.39921270D+03, 3.35218930D+03, 3.30529580D+03, 3.25853600D+03,
     $ 3.21191330D+03, 3.16543090D+03, 3.11909180D+03, 3.07289850D+03,
     $ 3.02685320D+03, 2.98095780D+03, 2.93521370D+03, 2.88962180D+03,
     $ 2.84418270D+03/
      data ( FDNO(110,J,2),J=1,13) /
     $ 2.724D-08, 8.231D-08, 1.656D-07, 2.770D-07, 4.161D-07, 5.833D-07,
     $ 7.778D-07, 1.000D-06, 1.249D-06, 1.525D-06, 1.828D-06, 2.158D-06,
     $ 2.515D-06/
      data (WNUPO(111,J,1),J=1,13) /
     $ 4.21827600D+03, 4.16140110D+03, 4.10466250D+03, 4.04806430D+03,
     $ 3.99161040D+03, 3.93530430D+03, 3.87914930D+03, 3.82314800D+03,
     $ 3.76730270D+03, 3.71161540D+03, 3.65608730D+03, 3.60071910D+03,
     $ 3.54551090D+03/
      data ( FUPO(111,J,1),J=1,13) /
     $ 9.471D-08, 2.815D-07, 5.570D-07, 9.181D-07, 1.361D-06, 1.881D-06,
     $ 2.474D-06, 3.136D-06, 3.863D-06, 4.652D-06, 5.498D-06, 6.398D-06,
     $ 7.330D-06/
      data (WNDNO(111,J,1),J=1,13) /
     $ 3.43839240D+03, 3.38931740D+03, 3.34038230D+03, 3.29159110D+03,
     $ 3.24294760D+03, 3.19445520D+03, 3.14611700D+03, 3.09793560D+03,
     $ 3.04991340D+03, 3.00205210D+03, 2.95435300D+03, 2.90681690D+03,
     $ 2.85944410D+03/
      data ( FDNO(111,J,1),J=1,13) /
     $ 2.899D-08, 8.753D-08, 1.760D-07, 2.941D-07, 4.417D-07, 6.188D-07,
     $ 8.251D-07, 1.060D-06, 1.324D-06, 1.616D-06, 1.937D-06, 2.287D-06,
     $ 2.648D-06/
      data (WNUPO(111,J,2),J=1,13) /
     $ 4.13761630D+03, 4.08333600D+03, 4.02918270D+03, 3.97516010D+03,
     $ 3.92127190D+03, 3.86752130D+03, 3.81391140D+03, 3.76044480D+03,
     $ 3.70712370D+03, 3.65395000D+03, 3.60092500D+03, 3.54804970D+03,
     $ 3.49532440D+03/
      data ( FUPO(111,J,2),J=1,13) /
     $ 8.701D-08, 2.590D-07, 5.127D-07, 8.462D-07, 1.255D-06, 1.736D-06,
     $ 2.286D-06, 2.900D-06, 3.574D-06, 4.307D-06, 5.095D-06, 5.932D-06,
     $ 6.819D-06/
      data (WNDNO(111,J,2),J=1,13) /
     $ 3.38911790D+03, 3.34212470D+03, 3.29526150D+03, 3.24853220D+03,
     $ 3.20194010D+03, 3.15548850D+03, 3.10918030D+03, 3.06301810D+03,
     $ 3.01700390D+03, 2.97113970D+03, 2.92542680D+03, 2.87986610D+03,
     $ 2.83445820D+03/
      data ( FDNO(111,J,2),J=1,13) /
     $ 2.720D-08, 8.215D-08, 1.653D-07, 2.764D-07, 4.152D-07, 5.821D-07,
     $ 7.758D-07, 9.973D-07, 1.246D-06, 1.521D-06, 1.823D-06, 2.152D-06,
     $ 2.508D-06/
C
      call HI ('COOVER')
C     !BEG
C     !END
      call BYE ('COOVER')
C
      end
