      subroutine COSECN
C
C     Rudolf Loeser, 1994 Aug 16
C---- Does nothing - just contains data statements
C
C     Initializes CO second overtone band arrays
C                                         with Goorvitch 1994 data.
C     !DASH
      save
C     !DASH
      integer J
C     !COM
C---- LOOM        as of 1994 Dec 16
      integer     JCOLMF,KCOLMF,JCOLMO,KCOLMO,JCOLMS,KCOLMS,
     $            JCOLMR,KCOLMR,JCOMAX,KCOMAX
      parameter   (JCOLMF=111, KCOLMF=20)
      parameter   (JCOLMO=111, KCOLMO=13)
      parameter   (JCOLMS=111, KCOLMS=12)
      parameter   (JCOLMR=53,  KCOLMR=21)
      parameter   (JCOMAX=max(JCOLMF,JCOLMO,JCOLMS,JCOLMR))
      parameter   (KCOMAX=max(KCOLMF,KCOLMO,KCOLMS,KCOLMR))
C     (Be sure to recompile all users of LOOM when changing any
C     of the above parameter values!)
      real*8      WNUPF,WNDNF,WNUPO,WNDNO,WNUPS,WNDNS,WNROT,
     $            FUPF ,FDNF ,FUPO ,FDNO ,FUPS ,FDNS ,FROT ,
     $            EXEN,WVCOLO,WVCOHI,RC1213
      integer     JCOFUN,KCOFUN,JCOOVR,KCOOVR,JCOSEC,KCOSEC,
     $            JCOROT,KCOROT,ISOSLCT,METHCOW,METHCOF
      logical     FUNDCO,OVERCO,SECNCO,ROTACO
C
      dimension   WNUPF(JCOLMF,KCOLMF,2), WNDNF(JCOLMF,KCOLMF,2),
     $            WNUPO(JCOLMO,KCOLMO,2), WNDNO(JCOLMO,KCOLMO,2),
     $            WNUPS(JCOLMS,KCOLMS,2), WNDNS(JCOLMS,KCOLMS,2),
     $            WNROT(JCOLMR,KCOLMR,2),
     $            FUPF(JCOLMF,KCOLMF,2),  FDNF(JCOLMF,KCOLMF,2),
     $            FUPO(JCOLMO,KCOLMO,2),  FDNO(JCOLMO,KCOLMO,2),
     $            FUPS(JCOLMS,KCOLMS,2),  FDNS(JCOLMS,KCOLMS,2),
     $            FROT(JCOLMR,KCOLMR,2),
     $            EXEN(JCOMAX+1,KCOMAX,2)
      dimension   FUNDCO(2),OVERCO(2),SECNCO(2),ROTACO(2),
     $            JCOFUN(2),KCOFUN(2),JCOOVR(2),KCOOVR(2),
     $            JCOSEC(2),KCOSEC(2),JCOROT(2),KCOROT(2)
C
C     Carbon Monoxide lines:  wavenumbers and oscillator strengths.
C
C     WNROT, etc., are for rotational lines     : j'-j=+1, v'-v=0;
C     WNUPF, etc., are for fundamental lines    : j'-j=+1, v'-v=1;
C     WNDNF, etc., are for fundamental lines    : j'-j=-1, v'-v=1;
C     WNUPO, etc., are for first overtone lines : j'-j=+1, v'-v=2;
C     WNDNO, etc., are for first overtone lines : j'-j=-1, v'-v=2;
C     WNUPS, etc., are for second overtone lines: j'-j=+1, v'-v=3;
C     WNDNS, etc., are for second overtone lines: j'-j=-1, v'-v=3.
C
C     This is how the array indices relate to the quantum numbers:
C
C     1. index J corresponds to quantum number j -
C                in WNROT, etc., j = J-1, j' = J
C                in WNUPF, etc., j = J-1, j' = J
C                in WNDNF, etc., j = J  , j' = J-1
C                in WNUPO, etc., j = J-1, j' = J
C                in WNDNO, etc., j = J  , j' = J-1
C                in WNUPS, etc., j = J-1, j' = J
C                in WNDNS, etc., j = J  , j' = J-1
C
C     2. index K corresponds to quantum number v (=nu) -
C                in WNROT, etc.,                 v = K-1, v' = K-1
C                in WNUPF, etc. and WNDNF, etc., v = K-1, v' = K
C                in WNUPO, etc. and WNDNO, etc., v = K-1, v' = K+1
C                in WNUPS, etc. and WNDNS, etc., v = K-1, v' = K+2
C
C     3. index L identifies the Carbon isotope -
C                L=1 for Carbon-12, L=2 for Carbon-13.
C
C     Wavenumbers and energies from:
C        Farrenq, R., Guelachvili, G., Sauval, A.J., Grevesse, N.,
C        and Farmer, C.B. 1991,
C        J.Molec.Spectrosc., 149, 375
C       or
C        Coxon, J.A., and Hajigeorgiou, P.G. 1992,
C        Can.J.Phys., 70, 40-54
C       or
C        Goorvitch, 1994, Ap.J.Suppl.
C     f-values from:
C        Chackerian, C., Jr, and Tipping, R. H. 1983
C        J.Molec.Spectros., 99, 431
C       or
C        "improved" Chackerian
C       or
C        Goorvitch, 1994, Ap.J.Suppl.
C
      common      /LOOM1 / EXEN
      common      /LOOM2 / WNROT,FROT
      common      /LOOM3 / WNUPF,FUPF,WNDNF,FDNF
      common      /LOOM4 / WNUPO,FUPO,WNDNO,FDNO
      common      /LOOM5 / WNUPS,FUPS,WNDNS,FDNS
      common      /LOOM6 / JCOFUN,KCOFUN,JCOOVR,KCOOVR,JCOSEC,KCOSEC,
     $                     JCOROT,KCOROT
      common      /LOOM7 / WVCOLO,WVCOHI
      common      /LOOM8 / FUNDCO,OVERCO,SECNCO,ROTACO
C
C     (These parameters are computed by subroutines WEAVE and FOCA.)
C
      common      /LOOM9 / RC1213
      common      /LOOM10/ ISOSLCT,METHCOW,METHCOF
C
C     RC1213  is the C(12)/C(13) isotopic abundance ratio.
C     ISOSLCT controls which isotopes are included in this calculation:
C     ISOSLCT = 1 means: C(12) only;
C     ISOSLCT = 2 means: C(13) only; and
C     ISOSLCT = 3 means: both C(12) and C(13).
C
C     METHCOF = 1 means: use f-values from Chackerian & Tipping (1983);
C     METHCOF = 2 means: use f-values from "new" Chackerian data;
C     METHCOF = 3 means: use f-values from Goorvitch (1994).
C
C     METHCOW = 1 means: use energies from Farrenq et al.;
C     METHCOW = 2 means: use energies from Coxon & Hajigeorgiou;
C     METHCOW = 3 means: use wave numbers & energies from
C                                                    Goorvitch (1994).
C     .
C     !DASH
      data (WNUPS(  1,J,1),J=1,12) /
     $ 6.35417910D+03, 6.27490320D+03, 6.19583000D+03, 6.11696460D+03,
     $ 6.03831210D+03, 5.95987750D+03, 5.88166590D+03, 5.80368200D+03,
     $ 5.72593060D+03, 5.64841590D+03, 5.57114190D+03, 5.49411240D+03/
      data ( FUPS(  1,J,1),J=1,12) /
     $ 5.481D-10, 2.394D-09, 6.489D-09, 1.399D-08, 2.623D-08, 4.467D-08,
     $ 7.090D-08, 1.066D-07, 1.534D-07, 2.131D-07, 2.873D-07, 3.773D-07/
      data (WNDNS(  1,J,1),J=1,12) /
     $ 6.34659400D+03, 6.26738820D+03, 6.18838500D+03, 6.10958950D+03,
     $ 6.03100700D+03, 5.95264240D+03, 5.87450070D+03, 5.79658690D+03,
     $ 5.71890540D+03, 5.64146060D+03, 5.56425660D+03, 5.48729690D+03/
      data ( FDNS(  1,J,1),J=1,12) /
     $ 1.783D-10, 7.797D-10, 2.116D-09, 4.563D-09, 8.563D-09, 1.460D-08,
     $ 2.318D-08, 3.487D-08, 5.023D-08, 6.980D-08, 9.413D-08, 1.237D-07/
      data (WNUPS(  1,J,2),J=1,12) /
     $ 6.21589590D+03, 6.14010510D+03, 6.06450340D+03, 5.98909550D+03,
     $ 5.91388610D+03, 5.83887970D+03, 5.76408110D+03, 5.68949450D+03,
     $ 5.61512420D+03, 5.54097440D+03, 5.46704870D+03, 5.39335060D+03/
      data ( FUPS(  1,J,2),J=1,12) /
     $ 4.979D-10, 2.172D-09, 5.886D-09, 1.268D-08, 2.375D-08, 4.044D-08,
     $ 6.419D-08, 9.650D-08, 1.389D-07, 1.930D-07, 2.602D-07, 3.421D-07/
      data (WNDNS(  1,J,2),J=1,12) /
     $ 6.20864220D+03, 6.13291680D+03, 6.05738060D+03, 5.98203810D+03,
     $ 5.90689410D+03, 5.83195310D+03, 5.75721980D+03, 5.68269860D+03,
     $ 5.60839370D+03, 5.53430930D+03, 5.46044890D+03, 5.38681610D+03/
      data ( FDNS(  1,J,2),J=1,12) /
     $ 1.621D-10, 7.080D-10, 1.920D-09, 4.140D-09, 7.760D-09, 1.322D-08,
     $ 2.100D-08, 3.158D-08, 4.550D-08, 6.323D-08, 8.530D-08, 1.122D-07/
      data (WNUPS(  2,J,1),J=1,12) /
     $ 6.35781390D+03, 6.27850310D+03, 6.19939490D+03, 6.12049450D+03,
     $ 6.04180700D+03, 5.96333750D+03, 5.88509090D+03, 5.80707210D+03,
     $ 5.72928570D+03, 5.65173610D+03, 5.57442720D+03, 5.49736270D+03/
      data ( FUPS(  2,J,1),J=1,12) /
     $ 3.700D-10, 1.614D-09, 4.373D-09, 9.427D-09, 1.767D-08, 3.008D-08,
     $ 4.773D-08, 7.173D-08, 1.032D-07, 1.433D-07, 1.932D-07, 2.537D-07/
      data (WNDNS(  2,J,1),J=1,12) /
     $ 6.34264410D+03, 6.26347330D+03, 6.18450510D+03, 6.10574470D+03,
     $ 6.02719710D+03, 5.94886750D+03, 5.87076090D+03, 5.79288200D+03,
     $ 5.71523550D+03, 5.63782570D+03, 5.56065670D+03, 5.48373210D+03/
      data ( FDNS(  2,J,1),J=1,12) /
     $ 2.114D-10, 9.248D-10, 2.510D-09, 5.420D-09, 1.017D-08, 1.735D-08,
     $ 2.756D-08, 4.146D-08, 5.974D-08, 8.302D-08, 1.120D-07, 1.472D-07/
      data (WNUPS(  2,J,2),J=1,12) /
     $ 6.21937540D+03, 6.14355190D+03, 6.06791750D+03, 5.99247690D+03,
     $ 5.91723480D+03, 5.84219580D+03, 5.76736440D+03, 5.69274520D+03,
     $ 5.61834230D+03, 5.54415970D+03, 5.47020140D+03, 5.39647060D+03/
      data ( FUPS(  2,J,2),J=1,12) /
     $ 3.360D-10, 1.465D-09, 3.967D-09, 8.543D-09, 1.600D-08, 2.723D-08,
     $ 4.320D-08, 6.493D-08, 9.347D-08, 1.298D-07, 1.750D-07, 2.300D-07/
      data (WNDNS(  2,J,2),J=1,12) /
     $ 6.20486820D+03, 6.12917560D+03, 6.05367210D+03, 5.97836230D+03,
     $ 5.90325100D+03, 5.82834280D+03, 5.75364220D+03, 5.67915370D+03,
     $ 5.60488160D+03, 5.53082980D+03, 5.45700210D+03, 5.38340200D+03/
      data ( FDNS(  2,J,2),J=1,12) /
     $ 1.922D-10, 8.398D-10, 2.278D-09, 4.914D-09, 9.218D-09, 1.571D-08,
     $ 2.496D-08, 3.756D-08, 5.412D-08, 7.522D-08, 1.015D-07, 1.335D-07/
      data (WNUPS(  3,J,1),J=1,12) /
     $ 6.36134350D+03, 6.28199770D+03, 6.20285450D+03, 6.12391910D+03,
     $ 6.04519670D+03, 5.96669220D+03, 5.88841070D+03, 5.81035690D+03,
     $ 5.73253560D+03, 5.65495100D+03, 5.57760730D+03, 5.50050790D+03/
      data ( FUPS(  3,J,1),J=1,12) /
     $ 3.370D-10, 1.470D-09, 3.982D-09, 8.576D-09, 1.607D-08, 2.734D-08,
     $ 4.338D-08, 6.516D-08, 9.376D-08, 1.302D-07, 1.754D-07, 2.302D-07/
      data (WNDNS(  3,J,1),J=1,12) /
     $ 6.33858950D+03, 6.25945370D+03, 6.18052050D+03, 6.10179510D+03,
     $ 6.02328260D+03, 5.94498800D+03, 5.86691640D+03, 5.78907260D+03,
     $ 5.71146110D+03, 5.63408630D+03, 5.55695230D+03, 5.48006260D+03/
      data ( FDNS(  3,J,1),J=1,12) /
     $ 2.239D-10, 9.796D-10, 2.661D-09, 5.746D-09, 1.079D-08, 1.840D-08,
     $ 2.924D-08, 4.401D-08, 6.344D-08, 8.819D-08, 1.190D-07, 1.564D-07/
      data (WNUPS(  3,J,2),J=1,12) /
     $ 6.22275650D+03, 6.14690030D+03, 6.07123320D+03, 5.99576000D+03,
     $ 5.92048520D+03, 5.84541350D+03, 5.77054940D+03, 5.69589750D+03,
     $ 5.62146200D+03, 5.54724680D+03, 5.47325580D+03, 5.39949240D+03/
      data ( FUPS(  3,J,2),J=1,12) /
     $ 3.060D-10, 1.334D-09, 3.610D-09, 7.770D-09, 1.455D-08, 2.474D-08,
     $ 3.926D-08, 5.898D-08, 8.488D-08, 1.179D-07, 1.588D-07, 2.088D-07/
      data (WNDNS(  3,J,2),J=1,12) /
     $ 6.20099640D+03, 6.12533660D+03, 6.04986580D+03, 5.97458870D+03,
     $ 5.89951010D+03, 5.82463460D+03, 5.74996680D+03, 5.67551100D+03,
     $ 5.60127160D+03, 5.52725250D+03, 5.45345760D+03, 5.37989020D+03/
      data ( FDNS(  3,J,2),J=1,12) /
     $ 2.036D-10, 8.899D-10, 2.416D-09, 5.211D-09, 9.779D-09, 1.667D-08,
     $ 2.650D-08, 3.989D-08, 5.747D-08, 7.991D-08, 1.079D-07, 1.419D-07/
      data (WNUPS(  4,J,1),J=1,12) /
     $ 6.36476760D+03, 6.28538680D+03, 6.20620870D+03, 6.12723830D+03,
     $ 6.04848090D+03, 5.96994150D+03, 5.89162510D+03, 5.81353640D+03,
     $ 5.73568020D+03, 5.65806070D+03, 5.58068200D+03, 5.50354780D+03/
      data ( FUPS(  4,J,1),J=1,12) /
     $ 3.249D-10, 1.417D-09, 3.836D-09, 8.257D-09, 1.546D-08, 2.631D-08,
     $ 4.171D-08, 6.266D-08, 9.013D-08, 1.251D-07, 1.684D-07, 2.211D-07/
      data (WNDNS(  4,J,1),J=1,12) /
     $ 6.33443030D+03, 6.25532950D+03, 6.17643140D+03, 6.09774100D+03,
     $ 6.01926350D+03, 5.94100400D+03, 5.86296740D+03, 5.78515860D+03,
     $ 5.70758210D+03, 5.63024240D+03, 5.55314340D+03, 5.47628880D+03/
      data ( FDNS(  4,J,1),J=1,12) /
     $ 2.293D-10, 1.004D-09, 2.729D-09, 5.897D-09, 1.108D-08, 1.890D-08,
     $ 3.004D-08, 4.523D-08, 6.521D-08, 9.068D-08, 1.223D-07, 1.609D-07/
      data (WNUPS(  4,J,2),J=1,12) /
     $ 6.22603900D+03, 6.15015020D+03, 6.07445040D+03, 5.99894450D+03,
     $ 5.92363700D+03, 5.84853260D+03, 5.77363590D+03, 5.69895140D+03,
     $ 5.62448320D+03, 5.55023540D+03, 5.47621180D+03, 5.40241580D+03/
      data ( FUPS(  4,J,2),J=1,12) /
     $ 2.950D-10, 1.285D-09, 3.477D-09, 7.480D-09, 1.400D-08, 2.380D-08,
     $ 3.774D-08, 5.670D-08, 8.157D-08, 1.132D-07, 1.526D-07, 2.004D-07/
      data (WNDNS(  4,J,2),J=1,12) /
     $ 6.19702690D+03, 6.12139980D+03, 6.04596170D+03, 5.97071740D+03,
     $ 5.89567160D+03, 5.82082880D+03, 5.74619370D+03, 5.67177070D+03,
     $ 5.59756400D+03, 5.52357770D+03, 5.44981550D+03, 5.37628080D+03/
      data ( FDNS(  4,J,2),J=1,12) /
     $ 2.086D-10, 9.124D-10, 2.478D-09, 5.350D-09, 1.004D-08, 1.712D-08,
     $ 2.722D-08, 4.099D-08, 5.908D-08, 8.218D-08, 1.109D-07, 1.460D-07/
      data (WNUPS(  5,J,1),J=1,12) /
     $ 6.36808610D+03, 6.28867040D+03, 6.20945730D+03, 6.13045200D+03,
     $ 6.05165960D+03, 5.97308530D+03, 5.89473390D+03, 5.81661040D+03,
     $ 5.73871920D+03, 5.66106490D+03, 5.58365130D+03, 5.50648220D+03/
      data ( FUPS(  5,J,1),J=1,12) /
     $ 3.198D-10, 1.393D-09, 3.771D-09, 8.117D-09, 1.519D-08, 2.584D-08,
     $ 4.096D-08, 6.150D-08, 8.844D-08, 1.227D-07, 1.652D-07, 2.169D-07/
      data (WNDNS(  5,J,1),J=1,12) /
     $ 6.33016670D+03, 6.25110100D+03, 6.17223790D+03, 6.09358250D+03,
     $ 6.01514010D+03, 5.93691560D+03, 5.85891410D+03, 5.78114030D+03,
     $ 5.70359890D+03, 5.62629420D+03, 5.54923030D+03, 5.47241070D+03/
      data ( FDNS(  5,J,1),J=1,12) /
     $ 2.318D-10, 1.015D-09, 2.761D-09, 5.968D-09, 1.122D-08, 1.915D-08,
     $ 3.045D-08, 4.585D-08, 6.611D-08, 9.191D-08, 1.241D-07, 1.632D-07/
      data (WNUPS(  5,J,2),J=1,12) /
     $ 6.22922290D+03, 6.15330130D+03, 6.07756890D+03, 6.00203030D+03,
     $ 5.92669020D+03, 5.85155320D+03, 5.77662390D+03, 5.70190670D+03,
     $ 5.62740590D+03, 5.55312550D+03, 5.47906930D+03, 5.40524070D+03/
      data ( FUPS(  5,J,2),J=1,12) /
     $ 2.902D-10, 1.263D-09, 3.418D-09, 7.350D-09, 1.374D-08, 2.338D-08,
     $ 3.706D-08, 5.564D-08, 8.003D-08, 1.111D-07, 1.497D-07, 1.966D-07/
      data (WNDNS(  5,J,2),J=1,12) /
     $ 6.19295970D+03, 6.11736530D+03, 6.04196000D+03, 5.96674850D+03,
     $ 5.89173540D+03, 5.81692540D+03, 5.74232300D+03, 5.66793280D+03,
     $ 5.59375880D+03, 5.51980530D+03, 5.44607580D+03, 5.37257400D+03/
      data ( FDNS(  5,J,2),J=1,12) /
     $ 2.108D-10, 9.227D-10, 2.507D-09, 5.415D-09, 1.017D-08, 1.735D-08,
     $ 2.759D-08, 4.155D-08, 5.990D-08, 8.335D-08, 1.125D-07, 1.481D-07/
      data (WNUPS(  6,J,1),J=1,12) /
     $ 6.37129890D+03, 6.29184820D+03, 6.21260010D+03, 6.13355990D+03,
     $ 6.05473260D+03, 5.97612340D+03, 5.89773710D+03, 5.81957860D+03,
     $ 5.74165260D+03, 5.66396340D+03, 5.58651500D+03, 5.50931110D+03/
      data ( FUPS(  6,J,1),J=1,12) /
     $ 3.179D-10, 1.385D-09, 3.745D-09, 8.056D-09, 1.507D-08, 2.564D-08,
     $ 4.062D-08, 6.096D-08, 8.765D-08, 1.215D-07, 1.637D-07, 2.148D-07/
      data (WNDNS(  6,J,1),J=1,12) /
     $ 6.32579890D+03, 6.24676820D+03, 6.16794010D+03, 6.08931980D+03,
     $ 6.01091240D+03, 5.93272300D+03, 5.85475650D+03, 5.77701780D+03,
     $ 5.69951150D+03, 5.62224190D+03, 5.54521300D+03, 5.46842850D+03/
      data ( FDNS(  6,J,1),J=1,12) /
     $ 2.326D-10, 1.019D-09, 2.774D-09, 5.998D-09, 1.128D-08, 1.925D-08,
     $ 3.063D-08, 4.614D-08, 6.654D-08, 9.254D-08, 1.250D-07, 1.644D-07/
      data (WNUPS(  6,J,2),J=1,12) /
     $ 6.23230790D+03, 6.15635370D+03, 6.08058860D+03, 6.00501740D+03,
     $ 5.92964460D+03, 5.85447490D+03, 5.77951300D+03, 5.70476320D+03,
     $ 5.63022980D+03, 5.55591680D+03, 5.48182810D+03, 5.40796690D+03/
      data ( FUPS(  6,J,2),J=1,12) /
     $ 2.885D-10, 1.255D-09, 3.394D-09, 7.295D-09, 1.364D-08, 2.318D-08,
     $ 3.674D-08, 5.515D-08, 7.930D-08, 1.100D-07, 1.482D-07, 1.946D-07/
      data (WNDNS(  6,J,2),J=1,12) /
     $ 6.18879510D+03, 6.11323350D+03, 6.03786090D+03, 5.96268210D+03,
     $ 5.88770180D+03, 5.81292460D+03, 5.73835500D+03, 5.66399750D+03,
     $ 5.58985630D+03, 5.51593550D+03, 5.44223890D+03, 5.36876980D+03/
      data ( FDNS(  6,J,2),J=1,12) /
     $ 2.116D-10, 9.269D-10, 2.519D-09, 5.443D-09, 1.022D-08, 1.745D-08,
     $ 2.775D-08, 4.182D-08, 6.031D-08, 8.392D-08, 1.133D-07, 1.492D-07/
      data (WNUPS(  7,J,1),J=1,12) /
     $ 6.37440580D+03, 6.29492010D+03, 6.21563710D+03, 6.13656200D+03,
     $ 6.05769980D+03, 5.97905560D+03, 5.90063440D+03, 5.82244110D+03,
     $ 5.74448020D+03, 5.66675620D+03, 5.58927300D+03, 5.51203420D+03/
      data ( FUPS(  7,J,1),J=1,12) /
     $ 3.178D-10, 1.383D-09, 3.740D-09, 8.038D-09, 1.504D-08, 2.557D-08,
     $ 4.049D-08, 6.077D-08, 8.731D-08, 1.212D-07, 1.631D-07, 2.139D-07/
      data (WNDNS(  7,J,1),J=1,12) /
     $ 6.32132680D+03, 6.24233120D+03, 6.16353820D+03, 6.08495300D+03,
     $ 6.00658070D+03, 5.92842630D+03, 5.85049490D+03, 5.77279130D+03,
     $ 5.69532000D+03, 5.61808550D+03, 5.54109170D+03, 5.46434230D+03/
      data ( FDNS(  7,J,1),J=1,12) /
     $ 2.324D-10, 1.019D-09, 2.775D-09, 6.003D-09, 1.129D-08, 1.929D-08,
     $ 3.069D-08, 4.623D-08, 6.667D-08, 9.280D-08, 1.253D-07, 1.649D-07/
      data (WNUPS(  7,J,2),J=1,12) /
     $ 6.23529400D+03, 6.15930720D+03, 6.08350940D+03, 6.00790550D+03,
     $ 5.93250010D+03, 5.85729780D+03, 5.78230330D+03, 5.70752080D+03,
     $ 5.63295490D+03, 5.55860930D+03, 5.48448800D+03, 5.41059430D+03/
      data ( FUPS(  7,J,2),J=1,12) /
     $ 2.882D-10, 1.254D-09, 3.388D-09, 7.280D-09, 1.361D-08, 2.312D-08,
     $ 3.662D-08, 5.497D-08, 7.900D-08, 1.096D-07, 1.476D-07, 1.938D-07/
      data (WNDNS(  7,J,2),J=1,12) /
     $ 6.18453310D+03, 6.10900430D+03, 6.03366450D+03, 5.95851850D+03,
     $ 5.88357090D+03, 5.80882640D+03, 5.73428960D+03, 5.65996490D+03,
     $ 5.58585650D+03, 5.51196850D+03, 5.43830470D+03, 5.36486840D+03/
      data ( FDNS(  7,J,2),J=1,12) /
     $ 2.115D-10, 9.267D-10, 2.521D-09, 5.448D-09, 1.024D-08, 1.748D-08,
     $ 2.781D-08, 4.191D-08, 6.046D-08, 8.413D-08, 1.137D-07, 1.496D-07/
      data (WNUPS(  8,J,1),J=1,12) /
     $ 6.37740660D+03, 6.29788600D+03, 6.21856810D+03, 6.13945800D+03,
     $ 6.06056090D+03, 5.98188190D+03, 5.90342580D+03, 5.82519760D+03,
     $ 5.74720190D+03, 5.66944300D+03, 5.59192500D+03, 5.51465140D+03/
      data ( FUPS(  8,J,1),J=1,12) /
     $ 3.187D-10, 1.387D-09, 3.747D-09, 8.053D-09, 1.506D-08, 2.559D-08,
     $ 4.051D-08, 6.078D-08, 8.733D-08, 1.211D-07, 1.629D-07, 2.137D-07/
      data (WNDNS(  8,J,1),J=1,12) /
     $ 6.31675090D+03, 6.23779030D+03, 6.15903230D+03, 6.08048220D+03,
     $ 6.00214500D+03, 5.92402570D+03, 5.84612940D+03, 5.76846080D+03,
     $ 5.69102470D+03, 5.61382530D+03, 5.53686660D+03, 5.46015230D+03/
      data ( FDNS(  8,J,1),J=1,12) /
     $ 2.316D-10, 1.016D-09, 2.768D-09, 5.994D-09, 1.127D-08, 1.926D-08,
     $ 3.066D-08, 4.621D-08, 6.671D-08, 9.282D-08, 1.254D-07, 1.649D-07/
      data (WNUPS(  8,J,2),J=1,12) /
     $ 6.23818100D+03, 6.16216150D+03, 6.08633110D+03, 6.01069460D+03,
     $ 5.93525650D+03, 5.86002160D+03, 5.78499450D+03, 5.71017950D+03,
     $ 5.63558090D+03, 5.56120280D+03, 5.48704900D+03, 5.41312270D+03/
      data ( FUPS(  8,J,2),J=1,12) /
     $ 2.890D-10, 1.257D-09, 3.394D-09, 7.287D-09, 1.362D-08, 2.313D-08,
     $ 3.663D-08, 5.497D-08, 7.900D-08, 1.095D-07, 1.475D-07, 1.936D-07/
      data (WNDNS(  8,J,2),J=1,12) /
     $ 6.18017400D+03, 6.10467790D+03, 6.02937090D+03, 5.95425760D+03,
     $ 5.87934280D+03, 5.80463120D+03, 5.73012710D+03, 5.65583520D+03,
     $ 5.58175970D+03, 5.50790450D+03, 5.43427340D+03, 5.36086990D+03/
      data ( FDNS(  8,J,2),J=1,12) /
     $ 2.108D-10, 9.241D-10, 2.515D-09, 5.439D-09, 1.022D-08, 1.746D-08,
     $ 2.779D-08, 4.189D-08, 6.047D-08, 8.418D-08, 1.137D-07, 1.497D-07/
      data (WNUPS(  9,J,1),J=1,12) /
     $ 6.38030130D+03, 6.30074580D+03, 6.22139290D+03, 6.14224790D+03,
     $ 6.06331590D+03, 5.98460200D+03, 5.90611110D+03, 5.82784800D+03,
     $ 5.74981750D+03, 5.67202380D+03, 5.59447090D+03, 5.51716260D+03/
      data ( FUPS(  9,J,1),J=1,12) /
     $ 3.203D-10, 1.393D-09, 3.763D-09, 8.082D-09, 1.511D-08, 2.566D-08,
     $ 4.062D-08, 6.094D-08, 8.753D-08, 1.213D-07, 1.632D-07, 2.141D-07/
      data (WNDNS(  9,J,1),J=1,12) /
     $ 6.31207100D+03, 6.23314550D+03, 6.15442270D+03, 6.07590760D+03,
     $ 5.99760540D+03, 5.91952130D+03, 5.84166010D+03, 5.76402670D+03,
     $ 5.68662560D+03, 5.60946130D+03, 5.53253780D+03, 5.45585860D+03/
      data ( FDNS(  9,J,1),J=1,12) /
     $ 2.304D-10, 1.012D-09, 2.757D-09, 5.968D-09, 1.124D-08, 1.921D-08,
     $ 3.058D-08, 4.611D-08, 6.653D-08, 9.263D-08, 1.252D-07, 1.647D-07/
      data (WNUPS(  9,J,2),J=1,12) /
     $ 6.24096880D+03, 6.16491670D+03, 6.08905360D+03, 6.01338450D+03,
     $ 5.93791380D+03, 5.86264630D+03, 5.78758650D+03, 5.71273900D+03,
     $ 5.63810790D+03, 5.56369720D+03, 5.48951080D+03, 5.41555210D+03/
      data ( FUPS(  9,J,2),J=1,12) /
     $ 2.904D-10, 1.262D-09, 3.408D-09, 7.318D-09, 1.366D-08, 2.320D-08,
     $ 3.673D-08, 5.509D-08, 7.912D-08, 1.098D-07, 1.477D-07, 1.938D-07/
      data (WNDNS(  9,J,2),J=1,12) /
     $ 6.17571770D+03, 6.10025440D+03, 6.02498020D+03, 5.94989970D+03,
     $ 5.87501770D+03, 5.80033890D+03, 5.72586760D+03, 5.65160850D+03,
     $ 5.57756580D+03, 5.50374340D+03, 5.43014520D+03, 5.35677450D+03/
      data ( FDNS(  9,J,2),J=1,12) /
     $ 2.098D-10, 9.205D-10, 2.506D-09, 5.421D-09, 1.019D-08, 1.742D-08,
     $ 2.773D-08, 4.181D-08, 6.032D-08, 8.400D-08, 1.135D-07, 1.495D-07/
      data (WNUPS( 10,J,1),J=1,12) /
     $ 6.38308960D+03, 6.30349920D+03, 6.22411140D+03, 6.14493150D+03,
     $ 6.06596460D+03, 5.98721580D+03, 5.90869010D+03, 5.83039220D+03,
     $ 5.75232680D+03, 5.67449830D+03, 5.59691070D+03, 5.51956760D+03/
      data ( FUPS( 10,J,1),J=1,12) /
     $ 3.225D-10, 1.402D-09, 3.785D-09, 8.126D-09, 1.518D-08, 2.578D-08,
     $ 4.079D-08, 6.116D-08, 8.784D-08, 1.217D-07, 1.637D-07, 2.147D-07/
      data (WNDNS( 10,J,1),J=1,12) /
     $ 6.30728750D+03, 6.22839710D+03, 6.14970930D+03, 6.07122930D+03,
     $ 5.99296230D+03, 5.91491320D+03, 5.83708720D+03, 5.75948890D+03,
     $ 5.68212300D+03, 5.60499380D+03, 5.52810540D+03, 5.45146140D+03/
      data ( FDNS( 10,J,1),J=1,12) /
     $ 2.290D-10, 1.006D-09, 2.743D-09, 5.943D-09, 1.119D-08, 1.913D-08,
     $ 3.047D-08, 4.595D-08, 6.633D-08, 9.238D-08, 1.248D-07, 1.643D-07/
      data (WNUPS( 10,J,2),J=1,12) /
     $ 6.24365730D+03, 6.16757250D+03, 6.09167680D+03, 6.01597500D+03,
     $ 5.94047170D+03, 5.86517160D+03, 5.79007930D+03, 5.71519920D+03,
     $ 5.64053550D+03, 5.56609240D+03, 5.49187350D+03, 5.41788220D+03/
      data ( FUPS( 10,J,2),J=1,12) /
     $ 2.923D-10, 1.269D-09, 3.426D-09, 7.353D-09, 1.373D-08, 2.330D-08,
     $ 3.688D-08, 5.532D-08, 7.942D-08, 1.101D-07, 1.482D-07, 1.944D-07/
      data (WNDNS( 10,J,2),J=1,12) /
     $ 6.17116460D+03, 6.09573400D+03, 6.02049260D+03, 5.94544490D+03,
     $ 5.87059570D+03, 5.79594970D+03, 5.72151130D+03, 5.64728500D+03,
     $ 5.57327510D+03, 5.49948560D+03, 5.42592020D+03, 5.35258230D+03/
      data ( FDNS( 10,J,2),J=1,12) /
     $ 2.085D-10, 9.152D-10, 2.493D-09, 5.395D-09, 1.015D-08, 1.735D-08,
     $ 2.763D-08, 4.167D-08, 6.014D-08, 8.376D-08, 1.132D-07, 1.491D-07/
      data (WNUPS( 11,J,1),J=1,12) /
     $ 6.38577150D+03, 6.30614610D+03, 6.22672340D+03, 6.14750870D+03,
     $ 6.06850690D+03, 5.98972320D+03, 5.91116260D+03, 5.83282990D+03,
     $ 5.75472980D+03, 5.67686650D+03, 5.59924410D+03, 5.52186630D+03/
      data ( FUPS( 11,J,1),J=1,12) /
     $ 3.250D-10, 1.412D-09, 3.811D-09, 8.181D-09, 1.528D-08, 2.593D-08,
     $ 4.102D-08, 6.148D-08, 8.829D-08, 1.223D-07, 1.644D-07, 2.156D-07/
      data (WNDNS( 11,J,1),J=1,12) /
     $ 6.30240050D+03, 6.22354510D+03, 6.14489250D+03, 6.06644760D+03,
     $ 5.98821560D+03, 5.91020170D+03, 5.83241070D+03, 5.75484760D+03,
     $ 5.67751680D+03, 5.60042290D+03, 5.52356960D+03, 5.44696080D+03/
      data ( FDNS( 11,J,1),J=1,12) /
     $ 2.273D-10, 9.996D-10, 2.726D-09, 5.909D-09, 1.113D-08, 1.904D-08,
     $ 3.033D-08, 4.574D-08, 6.609D-08, 9.200D-08, 1.243D-07, 1.637D-07/
      data (WNUPS( 11,J,2),J=1,12) /
     $ 6.24624620D+03, 6.17012880D+03, 6.09420050D+03, 6.01846610D+03,
     $ 5.94293020D+03, 5.86759760D+03, 5.79247270D+03, 5.71756000D+03,
     $ 5.64286380D+03, 5.56838810D+03, 5.49413670D+03, 5.42011300D+03/
      data ( FUPS( 11,J,2),J=1,12) /
     $ 2.945D-10, 1.279D-09, 3.449D-09, 7.400D-09, 1.381D-08, 2.343D-08,
     $ 3.707D-08, 5.557D-08, 7.981D-08, 1.106D-07, 1.488D-07, 1.951D-07/
      data (WNDNS( 11,J,2),J=1,12) /
     $ 6.16651460D+03, 6.09111690D+03, 6.01590820D+03, 5.94089330D+03,
     $ 5.86607700D+03, 5.79146370D+03, 5.71705810D+03, 5.64286470D+03,
     $ 5.56888760D+03, 5.49513100D+03, 5.42159850D+03, 5.34829350D+03/
      data ( FDNS( 11,J,2),J=1,12) /
     $ 2.070D-10, 9.091D-10, 2.478D-09, 5.365D-09, 1.010D-08, 1.727D-08,
     $ 2.750D-08, 4.149D-08, 5.991D-08, 8.348D-08, 1.128D-07, 1.487D-07/
      data (WNUPS( 12,J,1),J=1,12) /
     $ 6.38834670D+03, 6.30868640D+03, 6.22922890D+03, 6.14997920D+03,
     $ 6.07094260D+03, 5.99212400D+03, 5.91352860D+03, 5.83516110D+03,
     $ 5.75702620D+03, 5.67912820D+03, 5.60147100D+03, 5.52405850D+03/
      data ( FUPS( 12,J,1),J=1,12) /
     $ 3.278D-10, 1.424D-09, 3.840D-09, 8.239D-09, 1.538D-08, 2.610D-08,
     $ 4.128D-08, 6.187D-08, 8.878D-08, 1.230D-07, 1.653D-07, 2.166D-07/
      data (WNDNS( 12,J,1),J=1,12) /
     $ 6.29741000D+03, 6.21858980D+03, 6.13997220D+03, 6.06156240D+03,
     $ 5.98336560D+03, 5.90538680D+03, 5.82763100D+03, 5.75010300D+03,
     $ 5.67280740D+03, 5.59574860D+03, 5.51893060D+03, 5.44235690D+03/
      data ( FDNS( 12,J,1),J=1,12) /
     $ 2.256D-10, 9.920D-10, 2.708D-09, 5.872D-09, 1.106D-08, 1.893D-08,
     $ 3.017D-08, 4.552D-08, 6.576D-08, 9.160D-08, 1.238D-07, 1.630D-07/
      data (WNUPS( 12,J,2),J=1,12) /
     $ 6.24873560D+03, 6.17258550D+03, 6.09662460D+03, 6.02085760D+03,
     $ 5.94528910D+03, 5.86992390D+03, 5.79476640D+03, 5.71982120D+03,
     $ 5.64509250D+03, 5.57058440D+03, 5.49630050D+03, 5.42224430D+03/
      data ( FUPS( 12,J,2),J=1,12) /
     $ 2.970D-10, 1.289D-09, 3.475D-09, 7.452D-09, 1.390D-08, 2.358D-08,
     $ 3.730D-08, 5.591D-08, 8.022D-08, 1.112D-07, 1.495D-07, 1.961D-07/
      data (WNDNS( 12,J,2),J=1,12) /
     $ 6.16176800D+03, 6.08640300D+03, 6.01122720D+03, 5.93624510D+03,
     $ 5.86146150D+03, 5.78688110D+03, 5.71250840D+03, 5.63834780D+03,
     $ 5.56440360D+03, 5.49067980D+03, 5.41718020D+03, 5.34390810D+03/
      data ( FDNS( 12,J,2),J=1,12) /
     $ 2.054D-10, 9.028D-10, 2.462D-09, 5.332D-09, 1.004D-08, 1.717D-08,
     $ 2.736D-08, 4.128D-08, 5.964D-08, 8.312D-08, 1.124D-07, 1.480D-07/
      data (WNUPS( 13,J,1),J=1,12) /
     $ 6.39081520D+03, 6.31112000D+03, 6.23162750D+03, 6.15234300D+03,
     $ 6.07327150D+03, 5.99441810D+03, 5.91578790D+03, 5.83738560D+03,
     $ 5.75921590D+03, 5.68128310D+03, 5.60359130D+03, 5.52614400D+03/
      data ( FUPS( 13,J,1),J=1,12) /
     $ 3.309D-10, 1.436D-09, 3.873D-09, 8.308D-09, 1.550D-08, 2.629D-08,
     $ 4.156D-08, 6.228D-08, 8.932D-08, 1.237D-07, 1.663D-07, 2.178D-07/
      data (WNDNS( 13,J,1),J=1,12) /
     $ 6.29231630D+03, 6.21353120D+03, 6.13494870D+03, 6.05657410D+03,
     $ 5.97841240D+03, 5.90046870D+03, 5.82274810D+03, 5.74525520D+03,
     $ 5.66799490D+03, 5.59097120D+03, 5.51418840D+03, 5.43765000D+03/
      data ( FDNS( 13,J,1),J=1,12) /
     $ 2.237D-10, 9.844D-10, 2.688D-09, 5.830D-09, 1.099D-08, 1.882D-08,
     $ 3.000D-08, 4.530D-08, 6.541D-08, 9.115D-08, 1.232D-07, 1.623D-07/
      data (WNUPS( 13,J,2),J=1,12) /
     $ 6.25112520D+03, 6.17494250D+03, 6.09894900D+03, 6.02314940D+03,
     $ 5.94754830D+03, 5.87215050D+03, 5.79696050D+03, 5.72198280D+03,
     $ 5.64722160D+03, 5.57268090D+03, 5.49836460D+03, 5.42427590D+03/
      data ( FUPS( 13,J,2),J=1,12) /
     $ 2.997D-10, 1.300D-09, 3.504D-09, 7.512D-09, 1.401D-08, 2.375D-08,
     $ 3.755D-08, 5.624D-08, 8.072D-08, 1.118D-07, 1.504D-07, 1.972D-07/
      data (WNDNS( 13,J,2),J=1,12) /
     $ 6.15692480D+03, 6.08159270D+03, 6.00644960D+03, 5.93150040D+03,
     $ 5.85674960D+03, 5.78220210D+03, 5.70786220D+03, 5.63373450D+03,
     $ 5.55982320D+03, 5.48613220D+03, 5.41266550D+03, 5.33942630D+03/
      data ( FDNS( 13,J,2),J=1,12) /
     $ 2.038D-10, 8.959D-10, 2.444D-09, 5.296D-09, 9.978D-09, 1.707D-08,
     $ 2.721D-08, 4.107D-08, 5.933D-08, 8.270D-08, 1.118D-07, 1.474D-07/
      data (WNUPS( 14,J,1),J=1,12) /
     $ 6.39317670D+03, 6.31344660D+03, 6.23391930D+03, 6.15459990D+03,
     $ 6.07549350D+03, 5.99660540D+03, 5.91794030D+03, 5.83950330D+03,
     $ 5.76129880D+03, 5.68333130D+03, 5.60560480D+03, 5.52812280D+03/
      data ( FUPS( 14,J,1),J=1,12) /
     $ 3.342D-10, 1.450D-09, 3.907D-09, 8.378D-09, 1.563D-08, 2.650D-08,
     $ 4.189D-08, 6.270D-08, 8.996D-08, 1.245D-07, 1.673D-07, 2.192D-07/
      data (WNDNS( 14,J,1),J=1,12) /
     $ 6.28711960D+03, 6.20836950D+03, 6.12982220D+03, 6.05148260D+03,
     $ 5.97335610D+03, 5.89544760D+03, 5.81776210D+03, 5.74030450D+03,
     $ 5.66307930D+03, 5.58609090D+03, 5.50934330D+03, 5.43284000D+03/
      data ( FDNS( 14,J,1),J=1,12) /
     $ 2.217D-10, 9.766D-10, 2.668D-09, 5.790D-09, 1.092D-08, 1.870D-08,
     $ 2.982D-08, 4.503D-08, 6.507D-08, 9.066D-08, 1.226D-07, 1.615D-07/
      data (WNUPS( 14,J,2),J=1,12) /
     $ 6.25341490D+03, 6.17719960D+03, 6.10117350D+03, 6.02534130D+03,
     $ 5.94970760D+03, 5.87427730D+03, 5.79905480D+03, 5.72404450D+03,
     $ 5.64925080D+03, 5.57467770D+03, 5.50032890D+03, 5.42620780D+03/
      data ( FUPS( 14,J,2),J=1,12) /
     $ 3.026D-10, 1.312D-09, 3.534D-09, 7.574D-09, 1.412D-08, 2.393D-08,
     $ 3.781D-08, 5.667D-08, 8.126D-08, 1.126D-07, 1.513D-07, 1.984D-07/
      data (WNDNS( 14,J,2),J=1,12) /
     $ 6.15198520D+03, 6.07668590D+03, 6.00157570D+03, 5.92665920D+03,
     $ 5.85194140D+03, 5.77742660D+03, 5.70311960D+03, 5.62902480D+03,
     $ 5.55514640D+03, 5.48148840D+03, 5.40805450D+03, 5.33484830D+03/
      data ( FDNS( 14,J,2),J=1,12) /
     $ 2.020D-10, 8.890D-10, 2.426D-09, 5.259D-09, 9.910D-09, 1.697D-08,
     $ 2.705D-08, 4.083D-08, 5.900D-08, 8.228D-08, 1.112D-07, 1.467D-07/
      data (WNUPS( 15,J,1),J=1,12) /
     $ 6.39543120D+03, 6.31566620D+03, 6.23610400D+03, 6.15674970D+03,
     $ 6.07760860D+03, 5.99868560D+03, 5.91998580D+03, 5.84151390D+03,
     $ 5.76327470D+03, 5.68527250D+03, 5.60751130D+03, 5.52999460D+03/
      data ( FUPS( 15,J,1),J=1,12) /
     $ 3.376D-10, 1.464D-09, 3.945D-09, 8.455D-09, 1.576D-08, 2.672D-08,
     $ 4.221D-08, 6.317D-08, 9.062D-08, 1.254D-07, 1.685D-07, 2.207D-07/
      data (WNDNS( 15,J,1),J=1,12) /
     $ 6.28181980D+03, 6.20310490D+03, 6.12459260D+03, 6.04628820D+03,
     $ 5.96819680D+03, 5.89032350D+03, 5.81267320D+03, 5.73525080D+03,
     $ 5.65806080D+03, 5.58110770D+03, 5.50439530D+03, 5.42792730D+03/
      data ( FDNS( 15,J,1),J=1,12) /
     $ 2.197D-10, 9.684D-10, 2.646D-09, 5.745D-09, 1.084D-08, 1.857D-08,
     $ 2.963D-08, 4.474D-08, 6.468D-08, 9.016D-08, 1.219D-07, 1.606D-07/
      data (WNUPS( 15,J,2),J=1,12) /
     $ 6.25560460D+03, 6.17935670D+03, 6.10329800D+03, 6.02743310D+03,
     $ 5.95176700D+03, 5.87630410D+03, 5.80104900D+03, 5.72600630D+03,
     $ 5.65118010D+03, 5.57657450D+03, 5.50219330D+03, 5.42803980D+03/
      data ( FUPS( 15,J,2),J=1,12) /
     $ 3.056D-10, 1.324D-09, 3.566D-09, 7.638D-09, 1.424D-08, 2.412D-08,
     $ 3.810D-08, 5.707D-08, 8.186D-08, 1.133D-07, 1.523D-07, 1.997D-07/
      data (WNDNS( 15,J,2),J=1,12) /
     $ 6.14694940D+03, 6.07168290D+03, 5.99660550D+03, 5.92172190D+03,
     $ 5.84703680D+03, 5.77255500D+03, 5.69828080D+03, 5.62421890D+03,
     $ 5.55037340D+03, 5.47674830D+03, 5.40334740D+03, 5.33017410D+03/
      data ( FDNS( 15,J,2),J=1,12) /
     $ 2.003D-10, 8.816D-10, 2.407D-09, 5.223D-09, 9.845D-09, 1.685D-08,
     $ 2.688D-08, 4.058D-08, 5.868D-08, 8.181D-08, 1.107D-07, 1.459D-07/
      data (WNUPS( 16,J,1),J=1,12) /
     $ 6.39757850D+03, 6.31777860D+03, 6.23818150D+03, 6.15879240D+03,
     $ 6.07961640D+03, 6.00065860D+03, 5.92192400D+03, 5.84341740D+03,
     $ 5.76514350D+03, 5.68710660D+03, 5.60931070D+03, 5.53175930D+03/
      data ( FUPS( 16,J,1),J=1,12) /
     $ 3.413D-10, 1.479D-09, 3.984D-09, 8.532D-09, 1.591D-08, 2.695D-08,
     $ 4.255D-08, 6.371D-08, 9.132D-08, 1.263D-07, 1.697D-07, 2.222D-07/
      data (WNDNS( 16,J,1),J=1,12) /
     $ 6.27641730D+03, 6.19773750D+03, 6.11926030D+03, 6.04099110D+03,
     $ 5.96293480D+03, 5.88509670D+03, 5.80748160D+03, 5.73009440D+03,
     $ 5.65293960D+03, 5.57602170D+03, 5.49934460D+03, 5.42291190D+03/
      data ( FDNS( 16,J,1),J=1,12) /
     $ 2.177D-10, 9.600D-10, 2.625D-09, 5.703D-09, 1.076D-08, 1.845D-08,
     $ 2.944D-08, 4.445D-08, 6.427D-08, 8.964D-08, 1.212D-07, 1.598D-07/
      data (WNUPS( 16,J,2),J=1,12) /
     $ 6.25769410D+03, 6.18141360D+03, 6.10532230D+03, 6.02942490D+03,
     $ 5.95372620D+03, 5.87823070D+03, 5.80294320D+03, 5.72786790D+03,
     $ 5.65300930D+03, 5.57837130D+03, 5.50395760D+03, 5.42977180D+03/
      data ( FUPS( 16,J,2),J=1,12) /
     $ 3.088D-10, 1.338D-09, 3.600D-09, 7.710D-09, 1.436D-08, 2.433D-08,
     $ 3.842D-08, 5.752D-08, 8.248D-08, 1.142D-07, 1.534D-07, 2.010D-07/
      data (WNDNS( 16,J,2),J=1,12) /
     $ 6.14181740D+03, 6.06658370D+03, 5.99153920D+03, 5.91668840D+03,
     $ 5.84203620D+03, 5.76758720D+03, 5.69334600D+03, 5.61931700D+03,
     $ 5.54550440D+03, 5.47191220D+03, 5.39854430D+03, 5.32540390D+03/
      data ( FDNS( 16,J,2),J=1,12) /
     $ 1.984D-10, 8.739D-10, 2.388D-09, 5.182D-09, 9.773D-09, 1.674D-08,
     $ 2.671D-08, 4.033D-08, 5.833D-08, 8.133D-08, 1.101D-07, 1.451D-07/
      data (WNUPS( 17,J,1),J=1,12) /
     $ 6.39961840D+03, 6.31978360D+03, 6.24015170D+03, 6.16072770D+03,
     $ 6.08151690D+03, 6.00252430D+03, 5.92375490D+03, 5.84521360D+03,
     $ 5.76690500D+03, 5.68883340D+03, 5.61100280D+03, 5.53341680D+03/
      data ( FUPS( 17,J,1),J=1,12) /
     $ 3.448D-10, 1.495D-09, 4.024D-09, 8.615D-09, 1.605D-08, 2.719D-08,
     $ 4.294D-08, 6.421D-08, 9.203D-08, 1.273D-07, 1.710D-07, 2.238D-07/
      data (WNDNS( 17,J,1),J=1,12) /
     $ 6.27091200D+03, 6.19226740D+03, 6.11382540D+03, 6.03559130D+03,
     $ 5.95757020D+03, 5.87976720D+03, 5.80218740D+03, 5.72483540D+03,
     $ 5.64771590D+03, 5.57083320D+03, 5.49419140D+03, 5.41779400D+03/
      data ( FDNS( 17,J,1),J=1,12) /
     $ 2.157D-10, 9.514D-10, 2.603D-09, 5.657D-09, 1.069D-08, 1.832D-08,
     $ 2.923D-08, 4.417D-08, 6.389D-08, 8.909D-08, 1.205D-07, 1.588D-07/
      data (WNUPS( 17,J,2),J=1,12) /
     $ 6.25968340D+03, 6.18337030D+03, 6.10724640D+03, 6.03131640D+03,
     $ 5.95558510D+03, 5.88005710D+03, 5.80473710D+03, 5.72962940D+03,
     $ 5.65473830D+03, 5.58006790D+03, 5.50562180D+03, 5.43140350D+03/
      data ( FUPS( 17,J,2),J=1,12) /
     $ 3.121D-10, 1.352D-09, 3.636D-09, 7.782D-09, 1.449D-08, 2.454D-08,
     $ 3.876D-08, 5.800D-08, 8.312D-08, 1.150D-07, 1.545D-07, 2.024D-07/
      data (WNDNS( 17,J,2),J=1,12) /
     $ 6.13658950D+03, 6.06138860D+03, 5.98637690D+03, 5.91155900D+03,
     $ 5.83693960D+03, 5.76252350D+03, 5.68831520D+03, 5.61431910D+03,
     $ 5.54053940D+03, 5.46698020D+03, 5.39364520D+03, 5.32053780D+03/
      data ( FDNS( 17,J,2),J=1,12) /
     $ 1.966D-10, 8.666D-10, 2.369D-09, 5.143D-09, 9.703D-09, 1.662D-08,
     $ 2.653D-08, 4.009D-08, 5.797D-08, 8.086D-08, 1.094D-07, 1.443D-07/
      data (WNUPS( 18,J,1),J=1,12) /
     $ 6.40155080D+03, 6.32168120D+03, 6.24201440D+03, 6.16255560D+03,
     $ 6.08330990D+03, 6.00428260D+03, 5.92547840D+03, 5.84690240D+03,
     $ 5.76855910D+03, 5.69045280D+03, 5.61258750D+03, 5.53496690D+03/
      data ( FUPS( 18,J,1),J=1,12) /
     $ 3.489D-10, 1.511D-09, 4.066D-09, 8.703D-09, 1.621D-08, 2.744D-08,
     $ 4.331D-08, 6.477D-08, 9.280D-08, 1.283D-07, 1.723D-07, 2.255D-07/
      data (WNDNS( 18,J,1),J=1,12) /
     $ 6.26530430D+03, 6.18669480D+03, 6.10828790D+03, 6.03008900D+03,
     $ 5.95210310D+03, 5.87433530D+03, 5.79679070D+03, 5.71947390D+03,
     $ 5.64238970D+03, 5.56554230D+03, 5.48893580D+03, 5.41257370D+03/
      data ( FDNS( 18,J,1),J=1,12) /
     $ 2.136D-10, 9.430D-10, 2.582D-09, 5.614D-09, 1.061D-08, 1.819D-08,
     $ 2.903D-08, 4.389D-08, 6.349D-08, 8.854D-08, 1.198D-07, 1.579D-07/
      data (WNUPS( 18,J,2),J=1,12) /
     $ 6.26157220D+03, 6.18522650D+03, 6.10907000D+03, 6.03310750D+03,
     $ 5.95734360D+03, 5.88178320D+03, 5.80643060D+03, 5.73129050D+03,
     $ 5.65636690D+03, 5.58166410D+03, 5.50718560D+03, 5.43293500D+03/
      data ( FUPS( 18,J,2),J=1,12) /
     $ 3.154D-10, 1.366D-09, 3.674D-09, 7.857D-09, 1.463D-08, 2.476D-08,
     $ 3.909D-08, 5.849D-08, 8.380D-08, 1.159D-07, 1.557D-07, 2.039D-07/
      data (WNDNS( 18,J,2),J=1,12) /
     $ 6.13126570D+03, 6.05609760D+03, 5.98111870D+03, 5.90633370D+03,
     $ 5.83174720D+03, 5.75736400D+03, 5.68318860D+03, 5.60922540D+03,
     $ 5.53547860D+03, 5.46195240D+03, 5.38865040D+03, 5.31557600D+03/
      data ( FDNS( 18,J,2),J=1,12) /
     $ 1.948D-10, 8.589D-10, 2.349D-09, 5.103D-09, 9.632D-09, 1.651D-08,
     $ 2.635D-08, 3.984D-08, 5.759D-08, 8.038D-08, 1.088D-07, 1.435D-07/
      data (WNUPS( 19,J,1),J=1,12) /
     $ 6.40337560D+03, 6.32347110D+03, 6.24376940D+03, 6.16427580D+03,
     $ 6.08499530D+03, 6.00593320D+03, 5.92709430D+03, 5.84848360D+03,
     $ 5.77010550D+03, 5.69196460D+03, 5.61406470D+03, 5.53640950D+03/
      data ( FUPS( 19,J,1),J=1,12) /
     $ 3.530D-10, 1.528D-09, 4.108D-09, 8.789D-09, 1.636D-08, 2.770D-08,
     $ 4.370D-08, 6.535D-08, 9.359D-08, 1.294D-07, 1.737D-07, 2.272D-07/
      data (WNDNS( 19,J,1),J=1,12) /
     $ 6.25959420D+03, 6.18101980D+03, 6.10264810D+03, 6.02448430D+03,
     $ 5.94653360D+03, 5.86880110D+03, 5.79129160D+03, 5.71401010D+03,
     $ 5.63696120D+03, 5.56014910D+03, 5.48357790D+03, 5.40725110D+03/
      data ( FDNS( 19,J,1),J=1,12) /
     $ 2.115D-10, 9.346D-10, 2.560D-09, 5.569D-09, 1.053D-08, 1.806D-08,
     $ 2.885D-08, 4.359D-08, 6.308D-08, 8.797D-08, 1.191D-07, 1.570D-07/
      data (WNUPS( 19,J,2),J=1,12) /
     $ 6.26336050D+03, 6.18698220D+03, 6.11079310D+03, 6.03479800D+03,
     $ 5.95900170D+03, 5.88340870D+03, 5.80802360D+03, 5.73285100D+03,
     $ 5.65789510D+03, 5.58315980D+03, 5.50864900D+03, 5.43436590D+03/
      data ( FUPS( 19,J,2),J=1,12) /
     $ 3.192D-10, 1.381D-09, 3.711D-09, 7.935D-09, 1.477D-08, 2.499D-08,
     $ 3.943D-08, 5.897D-08, 8.449D-08, 1.169D-07, 1.569D-07, 2.055D-07/
      data (WNDNS( 19,J,2),J=1,12) /
     $ 6.12584610D+03, 6.05071090D+03, 5.97576480D+03, 5.90101260D+03,
     $ 5.82645910D+03, 5.75210870D+03, 5.67796620D+03, 5.60403600D+03,
     $ 5.53032220D+03, 5.45682900D+03, 5.38356000D+03, 5.31051850D+03/
      data ( FDNS( 19,J,2),J=1,12) /
     $ 1.929D-10, 8.513D-10, 2.330D-09, 5.064D-09, 9.559D-09, 1.639D-08,
     $ 2.618D-08, 3.956D-08, 5.723D-08, 7.987D-08, 1.081D-07, 1.426D-07/
      data (WNUPS( 20,J,1),J=1,12) /
     $ 6.40509250D+03, 6.32515320D+03, 6.24541670D+03, 6.16588820D+03,
     $ 6.08657300D+03, 6.00747600D+03, 5.92860240D+03, 5.84995700D+03,
     $ 5.77154430D+03, 5.69336870D+03, 5.61543420D+03, 5.53774440D+03/
      data ( FUPS( 20,J,1),J=1,12) /
     $ 3.569D-10, 1.545D-09, 4.154D-09, 8.882D-09, 1.653D-08, 2.797D-08,
     $ 4.410D-08, 6.592D-08, 9.441D-08, 1.305D-07, 1.751D-07, 2.290D-07/
      data (WNDNS( 20,J,1),J=1,12) /
     $ 6.25378190D+03, 6.17524260D+03, 6.09690610D+03, 6.01877750D+03,
     $ 5.94086200D+03, 5.86316460D+03, 5.78569040D+03, 5.70844420D+03,
     $ 5.63143060D+03, 5.55465380D+03, 5.47811790D+03, 5.40182640D+03/
      data ( FDNS( 20,J,1),J=1,12) /
     $ 2.095D-10, 9.261D-10, 2.539D-09, 5.524D-09, 1.044D-08, 1.792D-08,
     $ 2.863D-08, 4.329D-08, 6.266D-08, 8.744D-08, 1.183D-07, 1.560D-07/
      data (WNUPS( 20,J,2),J=1,12) /
     $ 6.26504810D+03, 6.18863720D+03, 6.11241560D+03, 6.03638790D+03,
     $ 5.96055900D+03, 5.88493350D+03, 5.80951600D+03, 5.73431090D+03,
     $ 5.65932260D+03, 5.58455490D+03, 5.51001170D+03, 5.43569630D+03/
      data ( FUPS( 20,J,2),J=1,12) /
     $ 3.228D-10, 1.396D-09, 3.751D-09, 8.018D-09, 1.491D-08, 2.523D-08,
     $ 3.979D-08, 5.949D-08, 8.521D-08, 1.178D-07, 1.582D-07, 2.071D-07/
      data (WNDNS( 20,J,2),J=1,12) /
     $ 6.12033100D+03, 6.04522860D+03, 5.97031540D+03, 5.89559610D+03,
     $ 5.82107540D+03, 5.74675790D+03, 5.67264840D+03, 5.59875110D+03,
     $ 5.52507030D+03, 5.45161000D+03, 5.37837400D+03, 5.30536560D+03/
      data ( FDNS( 20,J,2),J=1,12) /
     $ 1.911D-10, 8.437D-10, 2.310D-09, 5.022D-09, 9.488D-09, 1.627D-08,
     $ 2.600D-08, 3.929D-08, 5.688D-08, 7.937D-08, 1.075D-07, 1.418D-07/
      data (WNUPS( 21,J,1),J=1,12) /
     $ 6.40670160D+03, 6.32672740D+03, 6.24695600D+03, 6.16739270D+03,
     $ 6.08804270D+03, 6.00891100D+03, 5.93000270D+03, 5.85132250D+03,
     $ 5.77287510D+03, 5.69466490D+03, 5.61669580D+03, 5.53897140D+03/
      data ( FUPS( 21,J,1),J=1,12) /
     $ 3.612D-10, 1.562D-09, 4.198D-09, 8.976D-09, 1.670D-08, 2.824D-08,
     $ 4.454D-08, 6.654D-08, 9.524D-08, 1.316D-07, 1.765D-07, 2.309D-07/
      data (WNDNS( 21,J,1),J=1,12) /
     $ 6.24786750D+03, 6.16936340D+03, 6.09106200D+03, 6.01296860D+03,
     $ 5.93508820D+03, 5.85742610D+03, 5.77998720D+03, 5.70277630D+03,
     $ 5.62579790D+03, 5.54905650D+03, 5.47255590D+03, 5.39629980D+03/
      data ( FDNS( 21,J,1),J=1,12) /
     $ 2.074D-10, 9.177D-10, 2.516D-09, 5.479D-09, 1.037D-08, 1.779D-08,
     $ 2.844D-08, 4.300D-08, 6.226D-08, 8.688D-08, 1.176D-07, 1.551D-07/
      data (WNUPS( 21,J,2),J=1,12) /
     $ 6.26663490D+03, 6.19019140D+03, 6.11393720D+03, 6.03787700D+03,
     $ 5.96201550D+03, 5.88635750D+03, 5.81090760D+03, 5.73567010D+03,
     $ 5.66064930D+03, 5.58584930D+03, 5.51127370D+03, 5.43692600D+03/
      data ( FUPS( 21,J,2),J=1,12) /
     $ 3.263D-10, 1.411D-09, 3.790D-09, 8.100D-09, 1.506D-08, 2.546D-08,
     $ 4.017D-08, 6.002D-08, 8.595D-08, 1.188D-07, 1.595D-07, 2.087D-07/
      data (WNDNS( 21,J,2),J=1,12) /
     $ 6.11472040D+03, 6.03965080D+03, 5.96477050D+03, 5.89008400D+03,
     $ 5.81559620D+03, 5.74131170D+03, 5.66723510D+03, 5.59337070D+03,
     $ 5.51972300D+03, 5.44629570D+03, 5.37309270D+03, 5.30011730D+03/
      data ( FDNS( 21,J,2),J=1,12) /
     $ 1.893D-10, 8.363D-10, 2.291D-09, 4.984D-09, 9.416D-09, 1.615D-08,
     $ 2.581D-08, 3.905D-08, 5.651D-08, 7.888D-08, 1.068D-07, 1.410D-07/
      data (WNUPS( 22,J,1),J=1,12) /
     $ 6.40820250D+03, 6.32819350D+03, 6.24838730D+03, 6.16878920D+03,
     $ 6.08940430D+03, 6.01023790D+03, 5.93129480D+03, 5.85258000D+03,
     $ 5.77409800D+03, 5.69585310D+03, 5.61784940D+03, 5.54009050D+03/
      data ( FUPS( 22,J,1),J=1,12) /
     $ 3.656D-10, 1.580D-09, 4.244D-09, 9.072D-09, 1.687D-08, 2.853D-08,
     $ 4.495D-08, 6.716D-08, 9.612D-08, 1.328D-07, 1.780D-07, 2.328D-07/
      data (WNDNS( 22,J,1),J=1,12) /
     $ 6.24185120D+03, 6.16338220D+03, 6.08511600D+03, 6.00705770D+03,
     $ 5.92921260D+03, 5.85158570D+03, 5.77418210D+03, 5.69700640D+03,
     $ 5.62006340D+03, 5.54335730D+03, 5.46689210D+03, 5.39067140D+03/
      data ( FDNS( 22,J,1),J=1,12) /
     $ 2.054D-10, 9.093D-10, 2.496D-09, 5.436D-09, 1.028D-08, 1.766D-08,
     $ 2.822D-08, 4.271D-08, 6.184D-08, 8.631D-08, 1.169D-07, 1.542D-07/
      data (WNUPS( 22,J,2),J=1,12) /
     $ 6.26812070D+03, 6.19164460D+03, 6.11535780D+03, 6.03926510D+03,
     $ 5.96337110D+03, 5.88768070D+03, 5.81219820D+03, 5.73692830D+03,
     $ 5.66187510D+03, 5.58704270D+03, 5.51243480D+03, 5.43805480D+03/
      data ( FUPS( 22,J,2),J=1,12) /
     $ 3.302D-10, 1.427D-09, 3.833D-09, 8.184D-09, 1.521D-08, 2.572D-08,
     $ 4.053D-08, 6.058D-08, 8.672D-08, 1.198D-07, 1.608D-07, 2.104D-07/
      data (WNDNS( 22,J,2),J=1,12) /
     $ 6.10901440D+03, 6.03397770D+03, 5.95913020D+03, 5.88447670D+03,
     $ 5.81002180D+03, 5.73577020D+03, 5.66172650D+03, 5.58789510D+03,
     $ 5.51428030D+03, 5.44088610D+03, 5.36771620D+03, 5.29477380D+03/
      data ( FDNS( 22,J,2),J=1,12) /
     $ 1.874D-10, 8.287D-10, 2.271D-09, 4.942D-09, 9.344D-09, 1.604D-08,
     $ 2.562D-08, 3.878D-08, 5.613D-08, 7.838D-08, 1.062D-07, 1.401D-07/
      data (WNUPS( 23,J,1),J=1,12) /
     $ 6.40959520D+03, 6.32955130D+03, 6.24971030D+03, 6.17007740D+03,
     $ 6.09065770D+03, 6.01145660D+03, 5.93247880D+03, 5.85372930D+03,
     $ 5.77521260D+03, 5.69693320D+03, 5.61889490D+03, 5.54110130D+03/
      data ( FUPS( 23,J,1),J=1,12) /
     $ 3.700D-10, 1.599D-09, 4.293D-09, 9.171D-09, 1.705D-08, 2.882D-08,
     $ 4.540D-08, 6.780D-08, 9.700D-08, 1.339D-07, 1.796D-07, 2.347D-07/
      data (WNDNS( 23,J,1),J=1,12) /
     $ 6.23573310D+03, 6.15729930D+03, 6.07906820D+03, 6.00104510D+03,
     $ 5.92323520D+03, 5.84564360D+03, 5.76827520D+03, 5.69113490D+03,
     $ 5.61422720D+03, 5.53755640D+03, 5.46112660D+03, 5.38494120D+03/
      data ( FDNS( 23,J,1),J=1,12) /
     $ 2.034D-10, 9.011D-10, 2.474D-09, 5.391D-09, 1.020D-08, 1.753D-08,
     $ 2.802D-08, 4.243D-08, 6.143D-08, 8.577D-08, 1.161D-07, 1.532D-07/
      data (WNUPS( 23,J,2),J=1,12) /
     $ 6.26950540D+03, 6.19299680D+03, 6.11667740D+03, 6.04055210D+03,
     $ 5.96462570D+03, 5.88890270D+03, 5.81338780D+03, 5.73808550D+03,
     $ 5.66299990D+03, 5.58813520D+03, 5.51349490D+03, 5.43908260D+03/
      data ( FUPS( 23,J,2),J=1,12) /
     $ 3.342D-10, 1.443D-09, 3.873D-09, 8.271D-09, 1.537D-08, 2.598D-08,
     $ 4.093D-08, 6.113D-08, 8.749D-08, 1.209D-07, 1.622D-07, 2.121D-07/
      data (WNDNS( 23,J,2),J=1,12) /
     $ 6.10321330D+03, 6.02820950D+03, 5.95339480D+03, 5.87877410D+03,
     $ 5.80435210D+03, 5.73013350D+03, 5.65612270D+03, 5.58232440D+03,
     $ 5.50874260D+03, 5.43538140D+03, 5.36224450D+03, 5.28933520D+03/
      data ( FDNS( 23,J,2),J=1,12) /
     $ 1.856D-10, 8.213D-10, 2.251D-09, 4.902D-09, 9.272D-09, 1.592D-08,
     $ 2.545D-08, 3.851D-08, 5.577D-08, 7.787D-08, 1.055D-07, 1.393D-07/
      data (WNUPS( 24,J,1),J=1,12) /
     $ 6.41087960D+03, 6.33080080D+03, 6.25092490D+03, 6.17125720D+03,
     $ 6.09180280D+03, 6.01256690D+03, 5.93355440D+03, 5.85477020D+03,
     $ 5.77621890D+03, 5.69790490D+03, 5.61983200D+03, 5.54200390D+03/
      data ( FUPS( 24,J,1),J=1,12) /
     $ 3.745D-10, 1.618D-09, 4.343D-09, 9.270D-09, 1.723D-08, 2.911D-08,
     $ 4.585D-08, 6.845D-08, 9.789D-08, 1.351D-07, 1.812D-07, 2.368D-07/
      data (WNDNS( 24,J,1),J=1,12) /
     $ 6.22951340D+03, 6.15111470D+03, 6.07291880D+03, 5.99493090D+03,
     $ 5.91715620D+03, 5.83959980D+03, 5.76226670D+03, 5.68516170D+03,
     $ 5.60828930D+03, 5.53165400D+03, 5.45525950D+03, 5.37910960D+03/
      data ( FDNS( 24,J,1),J=1,12) /
     $ 2.014D-10, 8.927D-10, 2.453D-09, 5.347D-09, 1.013D-08, 1.740D-08,
     $ 2.784D-08, 4.212D-08, 6.102D-08, 8.520D-08, 1.154D-07, 1.523D-07/
      data (WNUPS( 24,J,2),J=1,12) /
     $ 6.27078890D+03, 6.19424770D+03, 6.11789580D+03, 6.04173800D+03,
     $ 5.96577900D+03, 5.89002350D+03, 5.81447620D+03, 5.73914150D+03,
     $ 5.66402350D+03, 5.58912640D+03, 5.51445390D+03, 5.44000920D+03/
      data ( FUPS( 24,J,2),J=1,12) /
     $ 3.381D-10, 1.460D-09, 3.917D-09, 8.360D-09, 1.553D-08, 2.623D-08,
     $ 4.134D-08, 6.172D-08, 8.830D-08, 1.220D-07, 1.636D-07, 2.138D-07/
      data (WNDNS( 24,J,2),J=1,12) /
     $ 6.09731710D+03, 6.02234610D+03, 5.94756430D+03, 5.87297650D+03,
     $ 5.79858740D+03, 5.72440170D+03, 5.65042400D+03, 5.57665860D+03,
     $ 5.50310980D+03, 5.42978170D+03, 5.35667780D+03, 5.28380170D+03/
      data ( FDNS( 24,J,2),J=1,12) /
     $ 1.838D-10, 8.137D-10, 2.233D-09, 4.863D-09, 9.202D-09, 1.580D-08,
     $ 2.527D-08, 3.824D-08, 5.541D-08, 7.739D-08, 1.048D-07, 1.384D-07/
      data (WNUPS( 25,J,1),J=1,12) /
     $ 6.41205540D+03, 6.33194180D+03, 6.25203110D+03, 6.17232850D+03,
     $ 6.09283940D+03, 6.01356870D+03, 5.93452150D+03, 5.85570260D+03,
     $ 5.77711670D+03, 5.69876810D+03, 5.62066070D+03, 5.54279810D+03/
      data ( FUPS( 25,J,1),J=1,12) /
     $ 3.792D-10, 1.637D-09, 4.392D-09, 9.373D-09, 1.741D-08, 2.941D-08,
     $ 4.631D-08, 6.912D-08, 9.882D-08, 1.364D-07, 1.828D-07, 2.388D-07/
      data (WNDNS( 25,J,1),J=1,12) /
     $ 6.22319220D+03, 6.14482860D+03, 6.06666790D+03, 5.98871520D+03,
     $ 5.91097570D+03, 5.83345460D+03, 5.75615680D+03, 5.67908710D+03,
     $ 5.60225010D+03, 5.52565010D+03, 5.44929110D+03, 5.37317650D+03/
      data ( FDNS( 25,J,1),J=1,12) /
     $ 1.994D-10, 8.845D-10, 2.431D-09, 5.304D-09, 1.005D-08, 1.727D-08,
     $ 2.763D-08, 4.184D-08, 6.061D-08, 8.467D-08, 1.147D-07, 1.513D-07/
      data (WNUPS( 25,J,2),J=1,12) /
     $ 6.27197110D+03, 6.19539730D+03, 6.11901280D+03, 6.04282250D+03,
     $ 5.96683100D+03, 5.89104300D+03, 5.81546330D+03, 5.74009610D+03,
     $ 5.66494580D+03, 5.59001630D+03, 5.51531150D+03, 5.44083450D+03/
      data ( FUPS( 25,J,2),J=1,12) /
     $ 3.422D-10, 1.477D-09, 3.961D-09, 8.451D-09, 1.569D-08, 2.649D-08,
     $ 4.173D-08, 6.231D-08, 8.910D-08, 1.230D-07, 1.650D-07, 2.157D-07/
      data (WNDNS( 25,J,2),J=1,12) /
     $ 6.09132600D+03, 6.01638790D+03, 5.94163900D+03, 5.86708400D+03,
     $ 5.79272790D+03, 5.71857510D+03, 5.64463030D+03, 5.57089790D+03,
     $ 5.49738220D+03, 5.42408710D+03, 5.35101630D+03, 5.27817320D+03/
      data ( FDNS( 25,J,2),J=1,12) /
     $ 1.821D-10, 8.065D-10, 2.214D-09, 4.825D-09, 9.131D-09, 1.569D-08,
     $ 2.510D-08, 3.800D-08, 5.504D-08, 7.688D-08, 1.042D-07, 1.376D-07/
      data (WNUPS( 26,J,1),J=1,12) /
     $ 6.41312250D+03, 6.33297410D+03, 6.25302850D+03, 6.17329120D+03,
     $ 6.09376720D+03, 6.01446180D+03, 5.93537990D+03, 5.85652640D+03,
     $ 5.77790590D+03, 5.69952270D+03, 5.62138070D+03, 5.54348360D+03/
      data ( FUPS( 26,J,1),J=1,12) /
     $ 3.839D-10, 1.657D-09, 4.443D-09, 9.480D-09, 1.760D-08, 2.973D-08,
     $ 4.678D-08, 6.980D-08, 9.976D-08, 1.376D-07, 1.844D-07, 2.410D-07/
      data (WNDNS( 26,J,1),J=1,12) /
     $ 6.21676960D+03, 6.13844120D+03, 6.06031570D+03, 5.98239820D+03,
     $ 5.90469390D+03, 5.82720800D+03, 5.74994550D+03, 5.67291120D+03,
     $ 5.59610950D+03, 5.51954490D+03, 5.44322130D+03, 5.36714220D+03/
      data ( FDNS( 26,J,1),J=1,12) /
     $ 1.975D-10, 8.766D-10, 2.409D-09, 5.260D-09, 9.972D-09, 1.715D-08,
     $ 2.743D-08, 4.157D-08, 6.021D-08, 8.411D-08, 1.140D-07, 1.504D-07/
      data (WNUPS( 26,J,2),J=1,12) /
     $ 6.27305170D+03, 6.19644540D+03, 6.12002830D+03, 6.04380550D+03,
     $ 5.96778150D+03, 5.89196110D+03, 5.81634890D+03, 5.74094930D+03,
     $ 5.66576660D+03, 5.59080480D+03, 5.51606770D+03, 5.44155850D+03/
      data ( FUPS( 26,J,2),J=1,12) /
     $ 3.465D-10, 1.494D-09, 4.006D-09, 8.543D-09, 1.586D-08, 2.676D-08,
     $ 4.216D-08, 6.290D-08, 8.994D-08, 1.242D-07, 1.664D-07, 2.176D-07/
      data (WNDNS( 26,J,2),J=1,12) /
     $ 6.08524010D+03, 6.01033480D+03, 5.93561880D+03, 5.86109670D+03,
     $ 5.78677350D+03, 5.71265370D+03, 5.63874190D+03, 5.56504250D+03,
     $ 5.49155980D+03, 5.41829780D+03, 5.34526010D+03, 5.27245010D+03/
      data ( FDNS( 26,J,2),J=1,12) /
     $ 1.803D-10, 7.992D-10, 2.196D-09, 4.787D-09, 9.062D-09, 1.557D-08,
     $ 2.492D-08, 3.774D-08, 5.468D-08, 7.640D-08, 1.035D-07, 1.367D-07/
      data (WNUPS( 27,J,1),J=1,12) /
     $ 6.41408090D+03, 6.33389750D+03, 6.25391720D+03, 6.17414500D+03,
     $ 6.09458630D+03, 6.01524620D+03, 5.93612960D+03, 5.85724150D+03,
     $ 5.77858630D+03, 5.70016850D+03, 5.62199200D+03, 5.54406030D+03/
      data ( FUPS( 27,J,1),J=1,12) /
     $ 3.887D-10, 1.677D-09, 4.494D-09, 9.587D-09, 1.780D-08, 3.004D-08,
     $ 4.726D-08, 7.049D-08, 1.007D-07, 1.389D-07, 1.861D-07, 2.430D-07/
      data (WNDNS( 27,J,1),J=1,12) /
     $ 6.21024580D+03, 6.13195260D+03, 6.05386220D+03, 5.97597990D+03,
     $ 5.89831090D+03, 5.82086030D+03, 5.74363310D+03, 5.66663410D+03,
     $ 5.58986780D+03, 5.51333860D+03, 5.43705040D+03, 5.36100680D+03/
      data ( FDNS( 27,J,1),J=1,12) /
     $ 1.956D-10, 8.685D-10, 2.389D-09, 5.218D-09, 9.895D-09, 1.702D-08,
     $ 2.725D-08, 4.127D-08, 5.982D-08, 8.358D-08, 1.133D-07, 1.495D-07/
      data (WNUPS( 27,J,2),J=1,12) /
     $ 6.27403080D+03, 6.19739180D+03, 6.12094230D+03, 6.04468680D+03,
     $ 5.96863030D+03, 5.89277750D+03, 5.81713280D+03, 5.74170090D+03,
     $ 5.66648590D+03, 5.59149180D+03, 5.51672230D+03, 5.44218080D+03/
      data ( FUPS( 27,J,2),J=1,12) /
     $ 3.506D-10, 1.512D-09, 4.051D-09, 8.638D-09, 1.603D-08, 2.706D-08,
     $ 4.257D-08, 6.351D-08, 9.079D-08, 1.253D-07, 1.679D-07, 2.194D-07/
      data (WNDNS( 27,J,2),J=1,12) /
     $ 6.07905950D+03, 6.00418710D+03, 5.92950390D+03, 5.85501480D+03,
     $ 5.78072440D+03, 5.70663760D+03, 5.63275880D+03, 5.55909240D+03,
     $ 5.48564280D+03, 5.41241380D+03, 5.33940930D+03, 5.26663240D+03/
      data ( FDNS( 27,J,2),J=1,12) /
     $ 1.786D-10, 7.920D-10, 2.176D-09, 4.747D-09, 8.993D-09, 1.546D-08,
     $ 2.475D-08, 3.749D-08, 5.433D-08, 7.591D-08, 1.029D-07, 1.359D-07/
      data (WNUPS( 28,J,1),J=1,12) /
     $ 6.41493020D+03, 6.33471200D+03, 6.25469690D+03, 6.17488990D+03,
     $ 6.09529640D+03, 6.01592150D+03, 5.93677030D+03, 5.85784750D+03,
     $ 5.77915780D+03, 5.70070540D+03, 5.62249440D+03, 5.54452820D+03/
      data ( FUPS( 28,J,1),J=1,12) /
     $ 3.936D-10, 1.697D-09, 4.547D-09, 9.696D-09, 1.799D-08, 3.036D-08,
     $ 4.775D-08, 7.120D-08, 1.017D-07, 1.403D-07, 1.878D-07, 2.453D-07/
      data (WNDNS( 28,J,1),J=1,12) /
     $ 6.20362100D+03, 6.12536290D+03, 6.04730770D+03, 5.96946060D+03,
     $ 5.89182680D+03, 5.81441150D+03, 5.73721960D+03, 5.66025590D+03,
     $ 5.58352510D+03, 5.50703130D+03, 5.43077860D+03, 5.35477040D+03/
      data ( FDNS( 28,J,1),J=1,12) /
     $ 1.937D-10, 8.607D-10, 2.370D-09, 5.177D-09, 9.819D-09, 1.690D-08,
     $ 2.705D-08, 4.100D-08, 5.942D-08, 8.304D-08, 1.125D-07, 1.486D-07/
      data (WNUPS( 28,J,2),J=1,12) /
     $ 6.27490800D+03, 6.19823650D+03, 6.12175440D+03, 6.04546650D+03,
     $ 5.96937750D+03, 5.89349210D+03, 5.81781510D+03, 5.74235070D+03,
     $ 5.66710340D+03, 5.59207690D+03, 5.51727520D+03, 5.44270140D+03/
      data ( FUPS( 28,J,2),J=1,12) /
     $ 3.549D-10, 1.530D-09, 4.098D-09, 8.735D-09, 1.620D-08, 2.733D-08,
     $ 4.300D-08, 6.415D-08, 9.165D-08, 1.265D-07, 1.694D-07, 2.215D-07/
      data (WNDNS( 28,J,2),J=1,12) /
     $ 6.07278440D+03, 5.99794480D+03, 5.92329450D+03, 5.84883830D+03,
     $ 5.77458090D+03, 5.70052700D+03, 5.62668120D+03, 5.55304790D+03,
     $ 5.47963130D+03, 5.40643540D+03, 5.33346400D+03, 5.26072020D+03/
      data ( FDNS( 28,J,2),J=1,12) /
     $ 1.768D-10, 7.849D-10, 2.158D-09, 4.711D-09, 8.925D-09, 1.535D-08,
     $ 2.458D-08, 3.723D-08, 5.396D-08, 7.544D-08, 1.023D-07, 1.351D-07/
      data (WNUPS( 29,J,1),J=1,12) /
     $ 6.41567050D+03, 6.33541750D+03, 6.25536740D+03, 6.17552570D+03,
     $ 6.09589740D+03, 6.01648780D+03, 5.93730190D+03, 5.85834450D+03,
     $ 5.77962010D+03, 5.70113320D+03, 5.62288760D+03, 5.54488690D+03/
      data ( FUPS( 29,J,1),J=1,12) /
     $ 3.986D-10, 1.718D-09, 4.602D-09, 9.809D-09, 1.819D-08, 3.068D-08,
     $ 4.825D-08, 7.191D-08, 1.027D-07, 1.416D-07, 1.895D-07, 2.474D-07/
      data (WNDNS( 29,J,1),J=1,12) /
     $ 6.19689530D+03, 6.11867230D+03, 6.04065230D+03, 5.96284040D+03,
     $ 5.88524190D+03, 5.80786180D+03, 5.73070520D+03, 5.65377690D+03,
     $ 5.57708150D+03, 5.50062310D+03, 5.42440580D+03, 5.34843310D+03/
      data ( FDNS( 29,J,1),J=1,12) /
     $ 1.919D-10, 8.529D-10, 2.349D-09, 5.136D-09, 9.744D-09, 1.677D-08,
     $ 2.686D-08, 4.073D-08, 5.903D-08, 8.251D-08, 1.118D-07, 1.476D-07/
      data (WNUPS( 29,J,2),J=1,12) /
     $ 6.27568340D+03, 6.19897940D+03, 6.12246470D+03, 6.04614420D+03,
     $ 5.97002270D+03, 5.89410490D+03, 5.81839540D+03, 5.74289870D+03,
     $ 5.66761900D+03, 5.59256030D+03, 5.51772620D+03, 5.44312020D+03/
      data ( FUPS( 29,J,2),J=1,12) /
     $ 3.595D-10, 1.548D-09, 4.146D-09, 8.833D-09, 1.638D-08, 2.761D-08,
     $ 4.344D-08, 6.477D-08, 9.254D-08, 1.276D-07, 1.710D-07, 2.233D-07/
      data (WNDNS( 29,J,2),J=1,12) /
     $ 6.06641490D+03, 5.99160820D+03, 5.91699080D+03, 5.84256740D+03,
     $ 5.76834300D+03, 5.69432200D+03, 5.62050920D+03, 5.54690890D+03,
     $ 5.47352540D+03, 5.40036270D+03, 5.32742430D+03, 5.25471370D+03/
      data ( FDNS( 29,J,2),J=1,12) /
     $ 1.751D-10, 7.780D-10, 2.141D-09, 4.673D-09, 8.858D-09, 1.524D-08,
     $ 2.441D-08, 3.698D-08, 5.363D-08, 7.497D-08, 1.016D-07, 1.343D-07/
      data (WNUPS( 30,J,1),J=1,12) /
     $ 6.41630150D+03, 6.33601360D+03, 6.25592870D+03, 6.17605220D+03,
     $ 6.09638920D+03, 6.01694480D+03, 5.93772420D+03, 5.85873220D+03,
     $ 5.77997330D+03, 5.70145180D+03, 5.62317170D+03, 5.54513650D+03/
      data ( FUPS( 30,J,1),J=1,12) /
     $ 4.037D-10, 1.739D-09, 4.658D-09, 9.922D-09, 1.839D-08, 3.102D-08,
     $ 4.876D-08, 7.264D-08, 1.037D-07, 1.429D-07, 1.914D-07, 2.497D-07/
      data (WNDNS( 30,J,1),J=1,12) /
     $ 6.19006880D+03, 6.11188100D+03, 6.03389610D+03, 5.95611940D+03,
     $ 5.87855610D+03, 5.80121140D+03, 5.72409010D+03, 5.64719720D+03,
     $ 5.57053710D+03, 5.49411420D+03, 5.41793240D+03, 5.34199510D+03/
      data ( FDNS( 30,J,1),J=1,12) /
     $ 1.900D-10, 8.452D-10, 2.330D-09, 5.095D-09, 9.670D-09, 1.666D-08,
     $ 2.669D-08, 4.044D-08, 5.866D-08, 8.200D-08, 1.111D-07, 1.468D-07/
      data (WNUPS( 30,J,2),J=1,12) /
     $ 6.27635680D+03, 6.19962020D+03, 6.12307290D+03, 6.04671990D+03,
     $ 5.97056590D+03, 5.89461570D+03, 5.81887380D+03, 5.74334470D+03,
     $ 5.66803260D+03, 5.59294160D+03, 5.51807520D+03, 5.44343700D+03/
      data ( FUPS( 30,J,2),J=1,12) /
     $ 3.639D-10, 1.567D-09, 4.195D-09, 8.934D-09, 1.656D-08, 2.792D-08,
     $ 4.390D-08, 6.542D-08, 9.344D-08, 1.288D-07, 1.725D-07, 2.253D-07/
      data (WNDNS( 30,J,2),J=1,12) /
     $ 6.05995120D+03, 5.98517730D+03, 5.91059270D+03, 5.83620230D+03,
     $ 5.76201080D+03, 5.68802280D+03, 5.61424300D+03, 5.54067570D+03,
     $ 5.46732530D+03, 5.39419570D+03, 5.32129050D+03, 5.24861300D+03/
      data ( FDNS( 30,J,2),J=1,12) /
     $ 1.734D-10, 7.710D-10, 2.123D-09, 4.636D-09, 8.792D-09, 1.513D-08,
     $ 2.423D-08, 3.674D-08, 5.328D-08, 7.449D-08, 1.010D-07, 1.334D-07/
      data (WNUPS( 31,J,1),J=1,12) /
     $ 6.41682310D+03, 6.33650030D+03, 6.25638060D+03, 6.17646930D+03,
     $ 6.09677150D+03, 6.01729250D+03, 5.93803720D+03, 5.85901050D+03,
     $ 5.78021700D+03, 5.70166100D+03, 5.62334630D+03, 5.54527660D+03/
      data ( FUPS( 31,J,1),J=1,12) /
     $ 4.089D-10, 1.761D-09, 4.713D-09, 1.004D-08, 1.861D-08, 3.136D-08,
     $ 4.928D-08, 7.339D-08, 1.048D-07, 1.443D-07, 1.931D-07, 2.520D-07/
      data (WNDNS( 31,J,1),J=1,12) /
     $ 6.18314160D+03, 6.10498900D+03, 6.02703930D+03, 5.94929780D+03,
     $ 5.87176980D+03, 5.79446030D+03, 5.71737440D+03, 5.64051680D+03,
     $ 5.56389220D+03, 5.48750470D+03, 5.41135840D+03, 5.33545660D+03/
      data ( FDNS( 31,J,1),J=1,12) /
     $ 1.881D-10, 8.378D-10, 2.311D-09, 5.054D-09, 9.598D-09, 1.654D-08,
     $ 2.649D-08, 4.017D-08, 5.827D-08, 8.148D-08, 1.105D-07, 1.459D-07/
      data (WNUPS( 31,J,2),J=1,12) /
     $ 6.27692800D+03, 6.20015880D+03, 6.12357900D+03, 6.04719350D+03,
     $ 5.97100700D+03, 5.89502430D+03, 5.81925000D+03, 5.74368850D+03,
     $ 5.66834410D+03, 5.59322070D+03, 5.51832210D+03, 5.44365160D+03/
      data ( FUPS( 31,J,2),J=1,12) /
     $ 3.685D-10, 1.586D-09, 4.244D-09, 9.034D-09, 1.674D-08, 2.821D-08,
     $ 4.434D-08, 6.608D-08, 9.434D-08, 1.301D-07, 1.741D-07, 2.274D-07/
      data (WNDNS( 31,J,2),J=1,12) /
     $ 6.05339330D+03, 5.97865230D+03, 5.90410060D+03, 5.82974300D+03,
     $ 5.75558440D+03, 5.68162940D+03, 5.60788260D+03, 5.53434840D+03,
     $ 5.46103110D+03, 5.38793460D+03, 5.31506250D+03, 5.24241820D+03/
      data ( FDNS( 31,J,2),J=1,12) /
     $ 1.719D-10, 7.641D-10, 2.105D-09, 4.600D-09, 8.727D-09, 1.502D-08,
     $ 2.406D-08, 3.649D-08, 5.294D-08, 7.403D-08, 1.004D-07, 1.327D-07/
      data (WNUPS( 32,J,1),J=1,12) /
     $ 6.41723520D+03, 6.33687750D+03, 6.25672300D+03, 6.17677680D+03,
     $ 6.09704430D+03, 6.01753050D+03, 5.93824060D+03, 5.85917920D+03,
     $ 5.78035120D+03, 5.70176060D+03, 5.62341140D+03, 5.54530720D+03/
      data ( FUPS( 32,J,1),J=1,12) /
     $ 4.143D-10, 1.784D-09, 4.771D-09, 1.016D-08, 1.881D-08, 3.170D-08,
     $ 4.981D-08, 7.416D-08, 1.058D-07, 1.457D-07, 1.949D-07, 2.543D-07/
      data (WNDNS( 32,J,1),J=1,12) /
     $ 6.17611400D+03, 6.09799650D+03, 6.02008200D+03, 5.94237580D+03,
     $ 5.86488300D+03, 5.78760880D+03, 5.71055820D+03, 5.63373600D+03,
     $ 5.55714680D+03, 5.48079480D+03, 5.40468390D+03, 5.32881760D+03/
      data ( FDNS( 32,J,1),J=1,12) /
     $ 1.863D-10, 8.303D-10, 2.291D-09, 5.015D-09, 9.528D-09, 1.642D-08,
     $ 2.632D-08, 3.991D-08, 5.791D-08, 8.097D-08, 1.098D-07, 1.450D-07/
      data (WNUPS( 32,J,2),J=1,12) /
     $ 6.27739700D+03, 6.20059520D+03, 6.12398280D+03, 6.04756470D+03,
     $ 5.97134580D+03, 5.89533060D+03, 5.81952380D+03, 5.74393000D+03,
     $ 5.66855320D+03, 5.59339760D+03, 5.51846680D+03, 5.44376400D+03/
      data ( FUPS( 32,J,2),J=1,12) /
     $ 3.732D-10, 1.606D-09, 4.295D-09, 9.140D-09, 1.692D-08, 2.852D-08,
     $ 4.481D-08, 6.676D-08, 9.529D-08, 1.313D-07, 1.757D-07, 2.294D-07/
      data (WNDNS( 32,J,2),J=1,12) /
     $ 6.04674140D+03, 5.97203320D+03, 5.89751440D+03, 5.82318980D+03,
     $ 5.74906410D+03, 5.67514210D+03, 5.60142830D+03, 5.52792710D+03,
     $ 5.45464290D+03, 5.38157950D+03, 5.30874060D+03, 5.23612950D+03/
      data ( FDNS( 32,J,2),J=1,12) /
     $ 1.702D-10, 7.575D-10, 2.088D-09, 4.565D-09, 8.662D-09, 1.492D-08,
     $ 2.391D-08, 3.626D-08, 5.260D-08, 7.357D-08, 9.978D-08, 1.319D-07/
      data (WNUPS( 33,J,1),J=1,12) /
     $ 6.41753750D+03, 6.33714510D+03, 6.25695570D+03, 6.17697470D+03,
     $ 6.09720740D+03, 6.01765890D+03, 5.93833420D+03, 5.85923830D+03,
     $ 5.78037560D+03, 5.70175050D+03, 5.62336690D+03, 5.54522820D+03/
      data ( FUPS( 33,J,1),J=1,12) /
     $ 4.197D-10, 1.806D-09, 4.829D-09, 1.028D-08, 1.903D-08, 3.205D-08,
     $ 5.034D-08, 7.494D-08, 1.069D-07, 1.472D-07, 1.968D-07, 2.566D-07/
      data (WNDNS( 33,J,1),J=1,12) /
     $ 6.16898610D+03, 6.09090380D+03, 6.01302440D+03, 5.93535330D+03,
     $ 5.85789580D+03, 5.78065690D+03, 5.70364160D+03, 5.62685480D+03,
     $ 5.55030100D+03, 5.47398450D+03, 5.39790910D+03, 5.32207840D+03/
      data ( FDNS( 33,J,1),J=1,12) /
     $ 1.846D-10, 8.230D-10, 2.273D-09, 4.976D-09, 9.458D-09, 1.630D-08,
     $ 2.613D-08, 3.966D-08, 5.754D-08, 8.046D-08, 1.091D-07, 1.441D-07/
      data (WNUPS( 33,J,2),J=1,12) /
     $ 6.27776350D+03, 6.20092910D+03, 6.12428420D+03, 6.04783360D+03,
     $ 5.97158210D+03, 5.89553450D+03, 5.81969530D+03, 5.74406910D+03,
     $ 5.66866000D+03, 5.59347210D+03, 5.51850900D+03, 5.44377390D+03/
      data ( FUPS( 33,J,2),J=1,12) /
     $ 3.778D-10, 1.626D-09, 4.346D-09, 9.245D-09, 1.712D-08, 2.883D-08,
     $ 4.529D-08, 6.743D-08, 9.623D-08, 1.326D-07, 1.774D-07, 2.315D-07/
      data (WNDNS( 33,J,2),J=1,12) /
     $ 6.03999560D+03, 5.96532030D+03, 5.89083440D+03, 5.81654260D+03,
     $ 5.74244990D+03, 5.66856080D+03, 5.59488000D+03, 5.52141200D+03,
     $ 5.44816080D+03, 5.37513060D+03, 5.30232480D+03, 5.22974690D+03/
      data ( FDNS( 33,J,2),J=1,12) /
     $ 1.687D-10, 7.509D-10, 2.070D-09, 4.528D-09, 8.599D-09, 1.481D-08,
     $ 2.375D-08, 3.601D-08, 5.227D-08, 7.310D-08, 9.918D-08, 1.311D-07/
      data (WNUPS( 34,J,1),J=1,12) /
     $ 6.41773010D+03, 6.33730270D+03, 6.25707850D+03, 6.17706270D+03,
     $ 6.09726060D+03, 6.01767740D+03, 5.93831810D+03, 5.85918750D+03,
     $ 5.78029020D+03, 5.70163060D+03, 5.62321240D+03, 5.54503920D+03/
      data ( FUPS( 34,J,1),J=1,12) /
     $ 4.251D-10, 1.828D-09, 4.888D-09, 1.040D-08, 1.925D-08, 3.242D-08,
     $ 5.088D-08, 7.572D-08, 1.080D-07, 1.486D-07, 1.987D-07, 2.590D-07/
      data (WNDNS( 34,J,1),J=1,12) /
     $ 6.16175800D+03, 6.08371080D+03, 6.00586660D+03, 5.92823070D+03,
     $ 5.85080840D+03, 5.77360480D+03, 5.69662490D+03, 5.61987350D+03,
     $ 5.54335510D+03, 5.46707410D+03, 5.39103420D+03, 5.31523900D+03/
      data ( FDNS( 34,J,1),J=1,12) /
     $ 1.828D-10, 8.159D-10, 2.254D-09, 4.938D-09, 9.388D-09, 1.619D-08,
     $ 2.597D-08, 3.939D-08, 5.717D-08, 7.997D-08, 1.085D-07, 1.433D-07/
      data (WNUPS( 34,J,2),J=1,12) /
     $ 6.27802750D+03, 6.20116050D+03, 6.12448300D+03, 6.04799980D+03,
     $ 5.97171580D+03, 5.89563580D+03, 5.81976420D+03, 5.74410560D+03,
     $ 5.66866420D+03, 5.59344400D+03, 5.51844860D+03, 5.44368130D+03/
      data ( FUPS( 34,J,2),J=1,12) /
     $ 3.827D-10, 1.646D-09, 4.399D-09, 9.352D-09, 1.731D-08, 2.913D-08,
     $ 4.576D-08, 6.813D-08, 9.718D-08, 1.339D-07, 1.791D-07, 2.336D-07/
      data (WNDNS( 34,J,2),J=1,12) /
     $ 6.03315610D+03, 5.95851370D+03, 5.88406060D+03, 5.80980170D+03,
     $ 5.73574190D+03, 5.66188580D+03, 5.58823810D+03, 5.51480310D+03,
     $ 5.44158510D+03, 5.36858790D+03, 5.29581540D+03, 5.22327060D+03/
      data ( FDNS( 34,J,2),J=1,12) /
     $ 1.671D-10, 7.443D-10, 2.054D-09, 4.494D-09, 8.536D-09, 1.471D-08,
     $ 2.359D-08, 3.578D-08, 5.194D-08, 7.267D-08, 9.858D-08, 1.303D-07/
      data (WNUPS( 35,J,1),J=1,12) /
     $ 6.41781260D+03, 6.33735040D+03, 6.25709130D+03, 6.17704070D+03,
     $ 6.09720380D+03, 6.01758590D+03, 5.93819190D+03, 5.85902670D+03,
     $ 5.78009480D+03, 5.70140060D+03, 5.62294800D+03, 5.54474030D+03/
      data ( FUPS( 35,J,1),J=1,12) /
     $ 4.307D-10, 1.852D-09, 4.949D-09, 1.052D-08, 1.948D-08, 3.278D-08,
     $ 5.143D-08, 7.652D-08, 1.091D-07, 1.501D-07, 2.006D-07, 2.614D-07/
      data (WNDNS( 35,J,1),J=1,12) /
     $ 6.15442980D+03, 6.07641770D+03, 5.99860870D+03, 5.92100800D+03,
     $ 5.84362100D+03, 5.76645270D+03, 5.68950810D+03, 5.61279210D+03,
     $ 5.53630920D+03, 5.46006360D+03, 5.38405920D+03, 5.30829950D+03/
      data ( FDNS( 35,J,1),J=1,12) /
     $ 1.811D-10, 8.089D-10, 2.235D-09, 4.900D-09, 9.321D-09, 1.607D-08,
     $ 2.579D-08, 3.914D-08, 5.682D-08, 7.948D-08, 1.078D-07, 1.424D-07/
      data (WNUPS( 35,J,2),J=1,12) /
     $ 6.27818870D+03, 6.20128920D+03, 6.12457910D+03, 6.04806340D+03,
     $ 5.97174690D+03, 5.89563440D+03, 5.81973040D+03, 5.74403940D+03,
     $ 5.66856570D+03, 5.59331320D+03, 5.51828550D+03, 5.44348600D+03/
      data ( FUPS( 35,J,2),J=1,12) /
     $ 3.877D-10, 1.667D-09, 4.451D-09, 9.462D-09, 1.751D-08, 2.946D-08,
     $ 4.625D-08, 6.884D-08, 9.816D-08, 1.352D-07, 1.807D-07, 2.358D-07/
      data (WNDNS( 35,J,2),J=1,12) /
     $ 6.02622300D+03, 5.95161340D+03, 5.87719320D+03, 5.80296720D+03,
     $ 5.72894030D+03, 5.65511730D+03, 5.58150250D+03, 5.50810060D+03,
     $ 5.43491570D+03, 5.36195170D+03, 5.28921230D+03, 5.21670070D+03/
      data ( FDNS( 35,J,2),J=1,12) /
     $ 1.655D-10, 7.380D-10, 2.038D-09, 4.461D-09, 8.475D-09, 1.461D-08,
     $ 2.344D-08, 3.556D-08, 5.161D-08, 7.223D-08, 9.800D-08, 1.295D-07/
      data (WNUPS( 36,J,1),J=1,12) /
     $ 6.41778500D+03, 6.33728790D+03, 6.25699400D+03, 6.17690850D+03,
     $ 6.09703690D+03, 6.01738420D+03, 5.93795550D+03, 5.85875570D+03,
     $ 5.77978930D+03, 5.70106050D+03, 5.62257340D+03, 5.54433120D+03/
      data ( FUPS( 36,J,1),J=1,12) /
     $ 4.363D-10, 1.876D-09, 5.011D-09, 1.065D-08, 1.970D-08, 3.314D-08,
     $ 5.200D-08, 7.734D-08, 1.102D-07, 1.517D-07, 2.025D-07, 2.639D-07/
      data (WNDNS( 36,J,1),J=1,12) /
     $ 6.14700170D+03, 6.06902480D+03, 5.99125090D+03, 5.91368540D+03,
     $ 5.83633360D+03, 5.75920060D+03, 5.68229140D+03, 5.60561080D+03,
     $ 5.52916330D+03, 5.45295320D+03, 5.37698440D+03, 5.30126020D+03/
      data ( FDNS( 36,J,1),J=1,12) /
     $ 1.795D-10, 8.019D-10, 2.218D-09, 4.863D-09, 9.253D-09, 1.597D-08,
     $ 2.562D-08, 3.889D-08, 5.647D-08, 7.900D-08, 1.072D-07, 1.416D-07/
      data (WNUPS( 36,J,2),J=1,12) /
     $ 6.27824720D+03, 6.20131500D+03, 6.12457240D+03, 6.04802410D+03,
     $ 5.97167510D+03, 5.89553010D+03, 5.81959370D+03, 5.74387040D+03,
     $ 5.66836430D+03, 5.59307950D+03, 5.51801960D+03, 5.44318790D+03/
      data ( FUPS( 36,J,2),J=1,12) /
     $ 3.927D-10, 1.687D-09, 4.506D-09, 9.573D-09, 1.770D-08, 2.979D-08,
     $ 4.675D-08, 6.955D-08, 9.915D-08, 1.365D-07, 1.825D-07, 2.380D-07/
      data (WNDNS( 36,J,2),J=1,12) /
     $ 6.01919650D+03, 5.94461970D+03, 5.87023230D+03, 5.79603920D+03,
     $ 5.72204530D+03, 5.64825520D+03, 5.57467350D+03, 5.50130460D+03,
     $ 5.42815280D+03, 5.35522200D+03, 5.28251580D+03, 5.21003740D+03/
      data ( FDNS( 36,J,2),J=1,12) /
     $ 1.640D-10, 7.316D-10, 2.021D-09, 4.427D-09, 8.414D-09, 1.451D-08,
     $ 2.327D-08, 3.533D-08, 5.129D-08, 7.178D-08, 9.742D-08, 1.288D-07/
      data (WNUPS( 37,J,1),J=1,12) /
     $ 6.41764720D+03, 6.33711520D+03, 6.25678630D+03, 6.17666610D+03,
     $ 6.09675960D+03, 6.01707220D+03, 5.93760890D+03, 5.85837440D+03,
     $ 5.77937340D+03, 5.70061010D+03, 5.62208840D+03, 5.54381180D+03/
      data ( FUPS( 37,J,1),J=1,12) /
     $ 4.422D-10, 1.900D-09, 5.073D-09, 1.078D-08, 1.993D-08, 3.352D-08,
     $ 5.258D-08, 7.816D-08, 1.113D-07, 1.532D-07, 2.045D-07, 2.664D-07/
      data (WNDNS( 37,J,1),J=1,12) /
     $ 6.13947390D+03, 6.06153210D+03, 5.98379330D+03, 5.90626310D+03,
     $ 5.82894650D+03, 5.75184880D+03, 5.67497490D+03, 5.59832970D+03,
     $ 5.52191770D+03, 5.44574310D+03, 5.36980970D+03, 5.29412110D+03/
      data ( FDNS( 37,J,1),J=1,12) /
     $ 1.777D-10, 7.951D-10, 2.200D-09, 4.827D-09, 9.188D-09, 1.585D-08,
     $ 2.545D-08, 3.865D-08, 5.612D-08, 7.852D-08, 1.065D-07, 1.408D-07/
      data (WNUPS( 37,J,2),J=1,12) /
     $ 6.27820270D+03, 6.20123790D+03, 6.12446270D+03, 6.04788190D+03,
     $ 5.97150040D+03, 5.89532290D+03, 5.81935410D+03, 5.74359830D+03,
     $ 5.66805990D+03, 5.59274280D+03, 5.51765070D+03, 5.44278670D+03/
      data ( FUPS( 37,J,2),J=1,12) /
     $ 3.977D-10, 1.708D-09, 4.560D-09, 9.686D-09, 1.790D-08, 3.012D-08,
     $ 4.725D-08, 7.027D-08, 1.002D-07, 1.378D-07, 1.842D-07, 2.401D-07/
      data (WNDNS( 37,J,2),J=1,12) /
     $ 6.01207650D+03, 5.93753260D+03, 5.86317810D+03, 5.78901790D+03,
     $ 5.71505690D+03, 5.64129970D+03, 5.56775110D+03, 5.49441530D+03,
     $ 5.42129660D+03, 5.34839890D+03, 5.27572590D+03, 5.20328070D+03/
      data ( FDNS( 37,J,2),J=1,12) /
     $ 1.625D-10, 7.255D-10, 2.005D-09, 4.395D-09, 8.355D-09, 1.441D-08,
     $ 2.313D-08, 3.511D-08, 5.099D-08, 7.136D-08, 9.685D-08, 1.281D-07/
      data (WNUPS( 38,J,1),J=1,12) /
     $ 6.41739890D+03, 6.33683200D+03, 6.25646830D+03, 6.17631320D+03,
     $ 6.09637200D+03, 6.01664980D+03, 5.93715180D+03, 5.85788260D+03,
     $ 5.77884710D+03, 5.70004920D+03, 5.62149300D+03, 5.54318190D+03/
      data ( FUPS( 38,J,1),J=1,12) /
     $ 4.481D-10, 1.924D-09, 5.137D-09, 1.091D-08, 2.017D-08, 3.391D-08,
     $ 5.316D-08, 7.900D-08, 1.125D-07, 1.547D-07, 2.065D-07, 2.691D-07/
      data (WNDNS( 38,J,1),J=1,12) /
     $ 6.13184650D+03, 6.05393970D+03, 5.97623620D+03, 5.89874110D+03,
     $ 5.82145970D+03, 5.74439730D+03, 5.66755880D+03, 5.59094900D+03,
     $ 5.51457240D+03, 5.43843330D+03, 5.36253550D+03, 5.28688240D+03/
      data ( FDNS( 38,J,1),J=1,12) /
     $ 1.762D-10, 7.884D-10, 2.183D-09, 4.792D-09, 9.125D-09, 1.575D-08,
     $ 2.529D-08, 3.840D-08, 5.578D-08, 7.805D-08, 1.059D-07, 1.400D-07/
      data (WNUPS( 38,J,2),J=1,12) /
     $ 6.27805510D+03, 6.20105770D+03, 6.12424990D+03, 6.04763650D+03,
     $ 5.97122250D+03, 5.89501250D+03, 5.81901130D+03, 5.74322320D+03,
     $ 5.66765250D+03, 5.59230310D+03, 5.51717870D+03, 5.44228250D+03/
      data ( FUPS( 38,J,2),J=1,12) /
     $ 4.029D-10, 1.729D-09, 4.616D-09, 9.801D-09, 1.812D-08, 3.045D-08,
     $ 4.776D-08, 7.101D-08, 1.012D-07, 1.392D-07, 1.860D-07, 2.424D-07/
      data (WNDNS( 38,J,2),J=1,12) /
     $ 6.00486340D+03, 5.93035230D+03, 5.85603060D+03, 5.78190330D+03,
     $ 5.70797520D+03, 5.63425110D+03, 5.56073540D+03, 5.48743270D+03,
     $ 5.41434710D+03, 5.34148260D+03, 5.26884280D+03, 5.19643090D+03/
      data ( FDNS( 38,J,2),J=1,12) /
     $ 1.610D-10, 7.195D-10, 1.990D-09, 4.361D-09, 8.296D-09, 1.431D-08,
     $ 2.297D-08, 3.490D-08, 5.068D-08, 7.094D-08, 9.629D-08, 1.273D-07/
      data (WNUPS( 39,J,1),J=1,12) /
     $ 6.41704010D+03, 6.33643820D+03, 6.25603960D+03, 6.17584970D+03,
     $ 6.09587370D+03, 6.01611680D+03, 5.93658400D+03, 5.85728030D+03,
     $ 5.77821010D+03, 5.69937770D+03, 5.62078700D+03, 5.54244140D+03/
      data ( FUPS( 39,J,1),J=1,12) /
     $ 4.542D-10, 1.949D-09, 5.201D-09, 1.104D-08, 2.040D-08, 3.430D-08,
     $ 5.375D-08, 7.986D-08, 1.137D-07, 1.562D-07, 2.086D-07, 2.716D-07/
      data (WNDNS( 39,J,1),J=1,12) /
     $ 6.12411950D+03, 6.04624790D+03, 5.96857950D+03, 5.89111960D+03,
     $ 5.81387350D+03, 5.73684630D+03, 5.66004310D+03, 5.58346870D+03,
     $ 5.50712760D+03, 5.43102400D+03, 5.35516170D+03, 5.27954420D+03/
      data ( FDNS( 39,J,1),J=1,12) /
     $ 1.746D-10, 7.818D-10, 2.166D-09, 4.757D-09, 9.061D-09, 1.565D-08,
     $ 2.513D-08, 3.816D-08, 5.544D-08, 7.759D-08, 1.053D-07, 1.391D-07/
      data (WNUPS( 39,J,2),J=1,12) /
     $ 6.27780430D+03, 6.20077430D+03, 6.12393380D+03, 6.04728790D+03,
     $ 5.97084140D+03, 5.89459890D+03, 5.81856520D+03, 5.74274480D+03,
     $ 5.66714170D+03, 5.59176000D+03, 5.51660330D+03, 5.44167490D+03/
      data ( FUPS( 39,J,2),J=1,12) /
     $ 4.082D-10, 1.752D-09, 4.673D-09, 9.918D-09, 1.832D-08, 3.079D-08,
     $ 4.829D-08, 7.177D-08, 1.022D-07, 1.406D-07, 1.878D-07, 2.448D-07/
      data (WNDNS( 39,J,2),J=1,12) /
     $ 5.99755720D+03, 5.92307890D+03, 5.84879000D+03, 5.77469560D+03,
     $ 5.70080050D+03, 5.62710930D+03, 5.55362670D+03, 5.48035710D+03,
     $ 5.40730460D+03, 5.33447330D+03, 5.26186660D+03, 5.18948790D+03/
      data ( FDNS( 39,J,2),J=1,12) /
     $ 1.596D-10, 7.135D-10, 1.975D-09, 4.330D-09, 8.239D-09, 1.422D-08,
     $ 2.284D-08, 3.468D-08, 5.037D-08, 7.052D-08, 9.573D-08, 1.266D-07/
      data (WNUPS( 40,J,1),J=1,12) /
     $ 6.41657050D+03, 6.33593370D+03, 6.25550030D+03, 6.17527540D+03,
     $ 6.09526460D+03, 6.01547290D+03, 5.93590550D+03, 5.85656710D+03,
     $ 5.77746230D+03, 5.69859540D+03, 5.61997020D+03, 5.54159000D+03/
      data ( FUPS( 40,J,1),J=1,12) /
     $ 4.603D-10, 1.975D-09, 5.267D-09, 1.118D-08, 2.065D-08, 3.468D-08,
     $ 5.435D-08, 8.072D-08, 1.149D-07, 1.578D-07, 2.108D-07, 2.742D-07/
      data (WNDNS( 40,J,1),J=1,12) /
     $ 6.11629330D+03, 6.03845670D+03, 5.96082340D+03, 5.88339870D+03,
     $ 5.80618780D+03, 5.72919600D+03, 5.65242810D+03, 5.57588910D+03,
     $ 5.49958340D+03, 5.42351530D+03, 5.34768860D+03, 5.27210660D+03/
      data ( FDNS( 40,J,1),J=1,12) /
     $ 1.731D-10, 7.754D-10, 2.149D-09, 4.722D-09, 8.999D-09, 1.554D-08,
     $ 2.498D-08, 3.794D-08, 5.511D-08, 7.715D-08, 1.047D-07, 1.384D-07/
      data (WNUPS( 40,J,2),J=1,12) /
     $ 6.27745010D+03, 6.20038750D+03, 6.12351440D+03, 6.04683590D+03,
     $ 5.97035680D+03, 5.89408190D+03, 5.81801580D+03, 5.74216290D+03,
     $ 5.66652750D+03, 5.59111360D+03, 5.51592460D+03, 5.44096390D+03/
      data ( FUPS( 40,J,2),J=1,12) /
     $ 4.135D-10, 1.775D-09, 4.730D-09, 1.004D-08, 1.853D-08, 3.114D-08,
     $ 4.881D-08, 7.253D-08, 1.033D-07, 1.420D-07, 1.896D-07, 2.471D-07/
      data (WNDNS( 40,J,2),J=1,12) /
     $ 5.99015810D+03, 5.91571250D+03, 5.84145650D+03, 5.76739500D+03,
     $ 5.69353280D+03, 5.61987450D+03, 5.54642500D+03, 5.47318840D+03,
     $ 5.40016910D+03, 5.32737090D+03, 5.25479750D+03, 5.18245200D+03/
      data ( FDNS( 40,J,2),J=1,12) /
     $ 1.581D-10, 7.077D-10, 1.959D-09, 4.299D-09, 8.183D-09, 1.412D-08,
     $ 2.269D-08, 3.447D-08, 5.007D-08, 7.011D-08, 9.519D-08, 1.259D-07/
      data (WNUPS( 41,J,1),J=1,12) /
     $ 6.41599010D+03, 6.33531840D+03, 6.25485000D+03, 6.17459030D+03,
     $ 6.09454460D+03, 6.01471820D+03, 5.93511610D+03, 5.85574300D+03,
     $ 5.77660360D+03, 5.69770220D+03, 5.61904240D+03, 5.54062770D+03/
      data ( FUPS( 41,J,1),J=1,12) /
     $ 4.664D-10, 2.001D-09, 5.335D-09, 1.132D-08, 2.090D-08, 3.509D-08,
     $ 5.496D-08, 8.160D-08, 1.161D-07, 1.595D-07, 2.128D-07, 2.769D-07/
      data (WNDNS( 41,J,1),J=1,12) /
     $ 6.10836780D+03, 6.03056640D+03, 5.95296820D+03, 5.87557860D+03,
     $ 5.79840300D+03, 5.72144640D+03, 5.64471390D+03, 5.56821030D+03,
     $ 5.49194010D+03, 5.41590750D+03, 5.34011630D+03, 5.26456980D+03/
      data ( FDNS( 41,J,1),J=1,12) /
     $ 1.714D-10, 7.690D-10, 2.134D-09, 4.689D-09, 8.939D-09, 1.545D-08,
     $ 2.482D-08, 3.771D-08, 5.478D-08, 7.670D-08, 1.041D-07, 1.376D-07/
      data (WNUPS( 41,J,2),J=1,12) /
     $ 6.27699250D+03, 6.19989720D+03, 6.12299150D+03, 6.04628040D+03,
     $ 5.96976880D+03, 5.89346140D+03, 5.81736280D+03, 5.74147760D+03,
     $ 5.66580980D+03, 5.59036350D+03, 5.51514230D+03, 5.44014940D+03/
      data ( FUPS( 41,J,2),J=1,12) /
     $ 4.190D-10, 1.796D-09, 4.789D-09, 1.016D-08, 1.875D-08, 3.149D-08,
     $ 4.935D-08, 7.331D-08, 1.043D-07, 1.435D-07, 1.915D-07, 2.494D-07/
      data (WNDNS( 41,J,2),J=1,12) /
     $ 5.98266610D+03, 5.90825330D+03, 5.83403010D+03, 5.76000150D+03,
     $ 5.68617220D+03, 5.61254690D+03, 5.53913040D+03, 5.46592690D+03,
     $ 5.39294070D+03, 5.32017570D+03, 5.24763550D+03, 5.17532320D+03/
      data ( FDNS( 41,J,2),J=1,12) /
     $ 1.567D-10, 7.019D-10, 1.945D-09, 4.269D-09, 8.128D-09, 1.404D-08,
     $ 2.255D-08, 3.427D-08, 4.977D-08, 6.971D-08, 9.465D-08, 1.252D-07/
      data (WNUPS( 42,J,1),J=1,12) /
     $ 6.41529870D+03, 6.33459200D+03, 6.25408870D+03, 6.17379410D+03,
     $ 6.09371360D+03, 6.01385240D+03, 5.93421560D+03, 5.85480790D+03,
     $ 5.77563390D+03, 5.69669780D+03, 5.61800350D+03, 5.53955430D+03/
      data ( FUPS( 42,J,1),J=1,12) /
     $ 4.728D-10, 2.028D-09, 5.402D-09, 1.146D-08, 2.114D-08, 3.549D-08,
     $ 5.558D-08, 8.249D-08, 1.173D-07, 1.612D-07, 2.149D-07, 2.796D-07/
      data (WNDNS( 42,J,1),J=1,12) /
     $ 6.10034330D+03, 6.02257700D+03, 5.94501390D+03, 5.86765950D+03,
     $ 5.79051900D+03, 5.71359770D+03, 5.63690060D+03, 5.56043230D+03,
     $ 5.48419760D+03, 5.40820050D+03, 5.33244480D+03, 5.25693400D+03/
      data ( FDNS( 42,J,1),J=1,12) /
     $ 1.700D-10, 7.629D-10, 2.118D-09, 4.656D-09, 8.879D-09, 1.534D-08,
     $ 2.467D-08, 3.748D-08, 5.447D-08, 7.627D-08, 1.035D-07, 1.368D-07/
      data (WNUPS( 42,J,2),J=1,12) /
     $ 6.27643120D+03, 6.19930320D+03, 6.12236490D+03, 6.04562130D+03,
     $ 5.96907710D+03, 5.89273720D+03, 5.81660620D+03, 5.74068850D+03,
     $ 5.66498840D+03, 5.58950980D+03, 5.51425630D+03, 5.43923110D+03/
      data ( FUPS( 42,J,2),J=1,12) /
     $ 4.245D-10, 1.819D-09, 4.849D-09, 1.028D-08, 1.898D-08, 3.186D-08,
     $ 4.989D-08, 7.410D-08, 1.054D-07, 1.449D-07, 1.934D-07, 2.518D-07/
      data (WNDNS( 42,J,2),J=1,12) /
     $ 5.97508140D+03, 5.90070140D+03, 5.82651110D+03, 5.75251530D+03,
     $ 5.67871890D+03, 5.60512660D+03, 5.53174310D+03, 5.45857270D+03,
     $ 5.38561960D+03, 5.31288770D+03, 5.24038070D+03, 5.16810170D+03/
      data ( FDNS( 42,J,2),J=1,12) /
     $ 1.554D-10, 6.962D-10, 1.929D-09, 4.238D-09, 8.073D-09, 1.394D-08,
     $ 2.241D-08, 3.406D-08, 4.949D-08, 6.932D-08, 9.413D-08, 1.245D-07/
      data (WNUPS( 43,J,1),J=1,12) /
     $ 6.41449610D+03, 6.33375450D+03, 6.25321620D+03, 6.17288670D+03,
     $ 6.09277140D+03, 6.01287540D+03, 5.93320380D+03, 5.85376140D+03,
     $ 5.77455280D+03, 5.69558220D+03, 5.61685340D+03, 5.53836970D+03/
      data ( FUPS( 43,J,1),J=1,12) /
     $ 4.792D-10, 2.054D-09, 5.472D-09, 1.160D-08, 2.140D-08, 3.592D-08,
     $ 5.621D-08, 8.340D-08, 1.186D-07, 1.628D-07, 2.171D-07, 2.824D-07/
      data (WNDNS( 43,J,1),J=1,12) /
     $ 6.09221990D+03, 6.01448860D+03, 5.93696060D+03, 5.85964130D+03,
     $ 5.78253610D+03, 5.70565010D+03, 5.62898830D+03, 5.55255550D+03,
     $ 5.47635610D+03, 5.40039450D+03, 5.32467440D+03, 5.24919910D+03/
      data ( FDNS( 43,J,1),J=1,12) /
     $ 1.685D-10, 7.569D-10, 2.101D-09, 4.624D-09, 8.821D-09, 1.525D-08,
     $ 2.452D-08, 3.726D-08, 5.415D-08, 7.584D-08, 1.030D-07, 1.361D-07/
      data (WNUPS( 43,J,2),J=1,12) /
     $ 6.27576620D+03, 6.19860550D+03, 6.12163460D+03, 6.04485830D+03,
     $ 5.96828160D+03, 5.89190910D+03, 5.81574570D+03, 5.73979560D+03,
     $ 5.66406320D+03, 5.58855230D+03, 5.51326650D+03, 5.43820900D+03/
      data ( FUPS( 43,J,2),J=1,12) /
     $ 4.301D-10, 1.844D-09, 4.909D-09, 1.040D-08, 1.920D-08, 3.222D-08,
     $ 5.045D-08, 7.489D-08, 1.065D-07, 1.464D-07, 1.953D-07, 2.542D-07/
      data (WNDNS( 43,J,2),J=1,12) /
     $ 5.96740410D+03, 5.89305690D+03, 5.81889940D+03, 5.74493650D+03,
     $ 5.67117300D+03, 5.59761370D+03, 5.52426310D+03, 5.45112580D+03,
     $ 5.37820590D+03, 5.30550720D+03, 5.23303340D+03, 5.16078760D+03/
      data ( FDNS( 43,J,2),J=1,12) /
     $ 1.540D-10, 6.907D-10, 1.915D-09, 4.209D-09, 8.021D-09, 1.386D-08,
     $ 2.228D-08, 3.386D-08, 4.921D-08, 6.893D-08, 9.361D-08, 1.238D-07/
      data (WNUPS( 44,J,1),J=1,12) /
     $ 6.41358220D+03, 6.33280560D+03, 6.25223240D+03, 6.17186800D+03,
     $ 6.09171780D+03, 6.01178700D+03, 5.93208070D+03, 5.85260360D+03,
     $ 5.77336040D+03, 5.69435520D+03, 5.61559180D+03, 5.53707360D+03/
      data ( FUPS( 44,J,1),J=1,12) /
     $ 4.857D-10, 2.082D-09, 5.541D-09, 1.175D-08, 2.166D-08, 3.633D-08,
     $ 5.685D-08, 8.432D-08, 1.199D-07, 1.645D-07, 2.193D-07, 2.852D-07/
      data (WNDNS( 44,J,1),J=1,12) /
     $ 6.08399770D+03, 6.00630150D+03, 5.92880860D+03, 5.85152440D+03,
     $ 5.77445440D+03, 5.69760360D+03, 5.62097720D+03, 5.54457970D+03,
     $ 5.46841590D+03, 5.39248980D+03, 5.31680520D+03, 5.24136540D+03/
      data ( FDNS( 44,J,1),J=1,12) /
     $ 1.671D-10, 7.509D-10, 2.087D-09, 4.592D-09, 8.763D-09, 1.516D-08,
     $ 2.437D-08, 3.704D-08, 5.385D-08, 7.542D-08, 1.024D-07, 1.354D-07/
      data (WNUPS( 44,J,2),J=1,12) /
     $ 6.27499730D+03, 6.19780390D+03, 6.12080030D+03, 6.04399140D+03,
     $ 5.96738210D+03, 5.89097720D+03, 5.81478120D+03, 5.73879880D+03,
     $ 5.66303390D+03, 5.58749070D+03, 5.51217270D+03, 5.43708290D+03/
      data ( FUPS( 44,J,2),J=1,12) /
     $ 4.359D-10, 1.867D-09, 4.971D-09, 1.053D-08, 1.943D-08, 3.259D-08,
     $ 5.101D-08, 7.570D-08, 1.077D-07, 1.478D-07, 1.972D-07, 2.567D-07/
      data (WNDNS( 44,J,2),J=1,12) /
     $ 5.95963450D+03, 5.88532000D+03, 5.81119530D+03, 5.73726520D+03,
     $ 5.66353460D+03, 5.59000820D+03, 5.51669070D+03, 5.44358650D+03,
     $ 5.37069970D+03, 5.29803420D+03, 5.22559350D+03, 5.15338100D+03/
      data ( FDNS( 44,J,2),J=1,12) /
     $ 1.527D-10, 6.853D-10, 1.901D-09, 4.180D-09, 7.969D-09, 1.378D-08,
     $ 2.215D-08, 3.366D-08, 4.893D-08, 6.854D-08, 9.309D-08, 1.231D-07/
      data (WNUPS( 45,J,1),J=1,12) /
     $ 6.41255690D+03, 6.33174530D+03, 6.25113710D+03, 6.17073780D+03,
     $ 6.09055270D+03, 6.01058710D+03, 5.93084600D+03, 5.85133430D+03,
     $ 5.77205640D+03, 5.69301660D+03, 5.61421860D+03, 5.53566590D+03/
      data ( FUPS( 45,J,1),J=1,12) /
     $ 4.924D-10, 2.109D-09, 5.613D-09, 1.189D-08, 2.192D-08, 3.676D-08,
     $ 5.749D-08, 8.526D-08, 1.211D-07, 1.663D-07, 2.216D-07, 2.880D-07/
      data (WNDNS( 45,J,1),J=1,12) /
     $ 6.07567690D+03, 5.99801570D+03, 5.92055790D+03, 5.84330890D+03,
     $ 5.76627400D+03, 5.68945850D+03, 5.61286730D+03, 5.53650530D+03,
     $ 5.46037690D+03, 5.38448630D+03, 5.30883720D+03, 5.23343300D+03/
      data ( FDNS( 45,J,1),J=1,12) /
     $ 1.657D-10, 7.452D-10, 2.071D-09, 4.562D-09, 8.708D-09, 1.507D-08,
     $ 2.423D-08, 3.684D-08, 5.355D-08, 7.500D-08, 1.018D-07, 1.346D-07/
      data (WNUPS( 45,J,2),J=1,12) /
     $ 6.27412430D+03, 6.19689830D+03, 6.11986200D+03, 6.04302050D+03,
     $ 5.96637860D+03, 5.88994110D+03, 5.81371270D+03, 5.73769780D+03,
     $ 5.66190060D+03, 5.58632500D+03, 5.51097470D+03, 5.43585270D+03/
      data ( FUPS( 45,J,2),J=1,12) /
     $ 4.417D-10, 1.891D-09, 5.034D-09, 1.066D-08, 1.965D-08, 3.297D-08,
     $ 5.158D-08, 7.653D-08, 1.088D-07, 1.494D-07, 1.992D-07, 2.592D-07/
      data (WNDNS( 45,J,2),J=1,12) /
     $ 5.95177250D+03, 5.87749080D+03, 5.80339880D+03, 5.72950160D+03,
     $ 5.65580390D+03, 5.58231050D+03, 5.50902600D+03, 5.43595480D+03,
     $ 5.36310110D+03, 5.29046870D+03, 5.21806130D+03, 5.14588200D+03/
      data ( FDNS( 45,J,2),J=1,12) /
     $ 1.514D-10, 6.800D-10, 1.888D-09, 4.152D-09, 7.918D-09, 1.369D-08,
     $ 2.201D-08, 3.347D-08, 4.866D-08, 6.816D-08, 9.259D-08, 1.225D-07/
      data (WNUPS( 46,J,1),J=1,12) /
     $ 6.41142000D+03, 6.33057340D+03, 6.24993020D+03, 6.16949590D+03,
     $ 6.08927600D+03, 6.00927560D+03, 5.92949970D+03, 5.84995320D+03,
     $ 5.77064070D+03, 5.69156630D+03, 5.61273370D+03, 5.53414640D+03/
      data ( FUPS( 46,J,1),J=1,12) /
     $ 4.991D-10, 2.137D-09, 5.687D-09, 1.204D-08, 2.219D-08, 3.720D-08,
     $ 5.815D-08, 8.621D-08, 1.224D-07, 1.680D-07, 2.238D-07, 2.908D-07/
      data (WNDNS( 46,J,1),J=1,12) /
     $ 6.06725760D+03, 5.98963140D+03, 5.91220860D+03, 5.83499470D+03,
     $ 5.75799510D+03, 5.68121480D+03, 5.60465900D+03, 5.52833230D+03,
     $ 5.45223930D+03, 5.37638420D+03, 5.30077070D+03, 5.22540210D+03/
      data ( FDNS( 46,J,1),J=1,12) /
     $ 1.643D-10, 7.395D-10, 2.057D-09, 4.531D-09, 8.653D-09, 1.497D-08,
     $ 2.409D-08, 3.662D-08, 5.326D-08, 7.459D-08, 1.013D-07, 1.339D-07/
      data (WNUPS( 46,J,2),J=1,12) /
     $ 6.27314720D+03, 6.19588850D+03, 6.11881950D+03, 6.04194530D+03,
     $ 5.96527080D+03, 5.88880080D+03, 5.81253990D+03, 5.73649260D+03,
     $ 5.66066300D+03, 5.58505510D+03, 5.50967240D+03, 5.43451810D+03/
      data ( FUPS( 46,J,2),J=1,12) /
     $ 4.476D-10, 1.916D-09, 5.098D-09, 1.079D-08, 1.989D-08, 3.334D-08,
     $ 5.216D-08, 7.736D-08, 1.100D-07, 1.509D-07, 2.012D-07, 2.618D-07/
      data (WNDNS( 46,J,2),J=1,12) /
     $ 5.94381830D+03, 5.86956940D+03, 5.79551020D+03, 5.72164570D+03,
     $ 5.64798090D+03, 5.57452050D+03, 5.50126900D+03, 5.42823080D+03,
     $ 5.35541020D+03, 5.28281110D+03, 5.21043690D+03, 5.13829080D+03/
      data ( FDNS( 46,J,2),J=1,12) /
     $ 1.502D-10, 6.748D-10, 1.874D-09, 4.124D-09, 7.868D-09, 1.360D-08,
     $ 2.188D-08, 3.328D-08, 4.839D-08, 6.780D-08, 9.210D-08, 1.218D-07/
      data (WNUPS( 47,J,1),J=1,12) /
     $ 6.41017130D+03, 6.32928970D+03, 6.24861150D+03, 6.16814230D+03,
     $ 6.08788740D+03, 6.00785210D+03, 5.92804150D+03, 5.84846030D+03,
     $ 5.76911310D+03, 5.69000410D+03, 5.61113690D+03, 5.53251500D+03/
      data ( FUPS( 47,J,1),J=1,12) /
     $ 5.060D-10, 2.166D-09, 5.760D-09, 1.219D-08, 2.246D-08, 3.763D-08,
     $ 5.883D-08, 8.717D-08, 1.238D-07, 1.698D-07, 2.261D-07, 2.938D-07/
      data (WNDNS( 47,J,1),J=1,12) /
     $ 6.05874000D+03, 5.98114880D+03, 5.90376100D+03, 5.82658220D+03,
     $ 5.74961770D+03, 5.67287270D+03, 5.59635220D+03, 5.52006090D+03,
     $ 5.44400340D+03, 5.36818370D+03, 5.29260570D+03, 5.21727260D+03/
      data ( FDNS( 47,J,1),J=1,12) /
     $ 1.629D-10, 7.339D-10, 2.042D-09, 4.501D-09, 8.599D-09, 1.488D-08,
     $ 2.395D-08, 3.642D-08, 5.297D-08, 7.420D-08, 1.008D-07, 1.332D-07/
      data (WNUPS( 47,J,2),J=1,12) /
     $ 6.27206580D+03, 6.19477430D+03, 6.11767270D+03, 6.04076580D+03,
     $ 5.96405870D+03, 5.88755620D+03, 5.81126280D+03, 5.73518300D+03,
     $ 5.65932100D+03, 5.58368070D+03, 5.50826570D+03, 5.43307910D+03/
      data ( FUPS( 47,J,2),J=1,12) /
     $ 4.537D-10, 1.941D-09, 5.162D-09, 1.092D-08, 2.013D-08, 3.373D-08,
     $ 5.275D-08, 7.820D-08, 1.111D-07, 1.525D-07, 2.032D-07, 2.643D-07/
      data (WNDNS( 47,J,2),J=1,12) /
     $ 5.93577210D+03, 5.86155590D+03, 5.78752940D+03, 5.71369780D+03,
     $ 5.64006590D+03, 5.56663830D+03, 5.49341980D+03, 5.42041480D+03,
     $ 5.34762730D+03, 5.27506130D+03, 5.20272030D+03, 5.13060740D+03/
      data ( FDNS( 47,J,2),J=1,12) /
     $ 1.489D-10, 6.698D-10, 1.861D-09, 4.097D-09, 7.818D-09, 1.353D-08,
     $ 2.176D-08, 3.309D-08, 4.813D-08, 6.744D-08, 9.161D-08, 1.213D-07/
      data (WNUPS( 48,J,1),J=1,12) /
     $ 6.40881080D+03, 6.32789410D+03, 6.24718080D+03, 6.16667670D+03,
     $ 6.08638690D+03, 6.00631670D+03, 5.92647130D+03, 5.84685540D+03,
     $ 5.76747350D+03, 5.68832980D+03, 5.60942810D+03, 5.53077160D+03/
      data ( FUPS( 48,J,1),J=1,12) /
     $ 5.131D-10, 2.195D-09, 5.836D-09, 1.235D-08, 2.274D-08, 3.808D-08,
     $ 5.951D-08, 8.815D-08, 1.252D-07, 1.716D-07, 2.284D-07, 2.966D-07/
      data (WNDNS( 48,J,1),J=1,12) /
     $ 6.05012410D+03, 5.97256790D+03, 5.89521520D+03, 5.81807150D+03,
     $ 5.74114210D+03, 5.66443230D+03, 5.58794710D+03, 5.51169120D+03,
     $ 5.43566910D+03, 5.35988490D+03, 5.28434250D+03, 5.20904490D+03/
      data ( FDNS( 48,J,1),J=1,12) /
     $ 1.616D-10, 7.285D-10, 2.029D-09, 4.472D-09, 8.546D-09, 1.479D-08,
     $ 2.381D-08, 3.623D-08, 5.268D-08, 7.380D-08, 1.002D-07, 1.325D-07/
      data (WNUPS( 48,J,2),J=1,12) /
     $ 6.27088000D+03, 6.19355580D+03, 6.11642140D+03, 6.03948190D+03,
     $ 5.96274210D+03, 5.88620700D+03, 5.80988110D+03, 5.73376880D+03,
     $ 5.65787440D+03, 5.58220180D+03, 5.50675450D+03, 5.43153560D+03/
      data ( FUPS( 48,J,2),J=1,12) /
     $ 4.598D-10, 1.966D-09, 5.228D-09, 1.106D-08, 2.037D-08, 3.413D-08,
     $ 5.335D-08, 7.906D-08, 1.123D-07, 1.541D-07, 2.053D-07, 2.668D-07/
      data (WNDNS( 48,J,2),J=1,12) /
     $ 5.92763400D+03, 5.85345040D+03, 5.77945680D+03, 5.70565790D+03,
     $ 5.63205880D+03, 5.55866420D+03, 5.48547870D+03, 5.41250670D+03,
     $ 5.33975230D+03, 5.26721950D+03, 5.19491170D+03, 5.12283200D+03/
      data ( FDNS( 48,J,2),J=1,12) /
     $ 1.477D-10, 6.647D-10, 1.848D-09, 4.070D-09, 7.770D-09, 1.344D-08,
     $ 2.164D-08, 3.291D-08, 4.787D-08, 6.708D-08, 9.113D-08, 1.206D-07/
      data (WNUPS( 49,J,1),J=1,12) /
     $ 6.40733820D+03, 6.32638640D+03, 6.24563810D+03, 6.16509890D+03,
     $ 6.08477420D+03, 6.00466920D+03, 5.92478890D+03, 5.84513830D+03,
     $ 5.76572170D+03, 5.68654330D+03, 5.60760700D+03, 5.52891580D+03/
      data ( FUPS( 49,J,1),J=1,12) /
     $ 5.201D-10, 2.225D-09, 5.912D-09, 1.251D-08, 2.302D-08, 3.855D-08,
     $ 6.020D-08, 8.914D-08, 1.265D-07, 1.734D-07, 2.308D-07, 2.997D-07/
      data (WNDNS( 49,J,1),J=1,12) /
     $ 6.04141020D+03, 5.96388890D+03, 5.88657120D+03, 5.80946260D+03,
     $ 5.73256840D+03, 5.65589380D+03, 5.57944380D+03, 5.50322330D+03,
     $ 5.42723660D+03, 5.35148790D+03, 5.27598100D+03, 5.20071900D+03/
      data ( FDNS( 49,J,1),J=1,12) /
     $ 1.604D-10, 7.231D-10, 2.015D-09, 4.444D-09, 8.496D-09, 1.472D-08,
     $ 2.369D-08, 3.603D-08, 5.240D-08, 7.342D-08, 9.972D-08, 1.318D-07/
      data (WNUPS( 49,J,2),J=1,12) /
     $ 6.26958960D+03, 6.19223260D+03, 6.11506550D+03, 6.03809330D+03,
     $ 5.96132090D+03, 5.88475320D+03, 5.80839470D+03, 5.73225000D+03,
     $ 5.65632320D+03, 5.58061820D+03, 5.50513850D+03, 5.42988720D+03/
      data ( FUPS( 49,J,2),J=1,12) /
     $ 4.660D-10, 1.993D-09, 5.295D-09, 1.120D-08, 2.062D-08, 3.453D-08,
     $ 5.395D-08, 7.994D-08, 1.135D-07, 1.557D-07, 2.074D-07, 2.695D-07/
      data (WNDNS( 49,J,2),J=1,12) /
     $ 5.91940400D+03, 5.84525320D+03, 5.77129220D+03, 5.69752620D+03,
     $ 5.62395990D+03, 5.55059830D+03, 5.47744570D+03, 5.40450670D+03,
     $ 5.33178550D+03, 5.25928580D+03, 5.18701120D+03, 5.11496470D+03/
      data ( FDNS( 49,J,2),J=1,12) /
     $ 1.466D-10, 6.599D-10, 1.836D-09, 4.044D-09, 7.723D-09, 1.336D-08,
     $ 2.152D-08, 3.274D-08, 4.762D-08, 6.674D-08, 9.067D-08, 1.200D-07/
      data (WNUPS( 50,J,1),J=1,12) /
     $ 6.40575350D+03, 6.32476650D+03, 6.24398320D+03, 6.16340900D+03,
     $ 6.08304930D+03, 6.00290940D+03, 5.92299430D+03, 5.84330880D+03,
     $ 5.76385750D+03, 5.68464450D+03, 5.60567350D+03, 5.52694770D+03/
      data ( FUPS( 50,J,1),J=1,12) /
     $ 5.274D-10, 2.255D-09, 5.990D-09, 1.267D-08, 2.330D-08, 3.900D-08,
     $ 6.090D-08, 9.015D-08, 1.279D-07, 1.753D-07, 2.332D-07, 3.026D-07/
      data (WNDNS( 50,J,1),J=1,12) /
     $ 6.03259830D+03, 5.95511200D+03, 5.87782920D+03, 5.80075570D+03,
     $ 5.72389660D+03, 5.64725720D+03, 5.57084250D+03, 5.49465730D+03,
     $ 5.41870610D+03, 5.34299290D+03, 5.26752140D+03, 5.19229490D+03/
      data ( FDNS( 50,J,1),J=1,12) /
     $ 1.591D-10, 7.180D-10, 2.002D-09, 4.417D-09, 8.446D-09, 1.463D-08,
     $ 2.355D-08, 3.584D-08, 5.213D-08, 7.305D-08, 9.921D-08, 1.312D-07/
      data (WNUPS( 50,J,2),J=1,12) /
     $ 6.26819450D+03, 6.19080470D+03, 6.11360490D+03, 6.03659990D+03,
     $ 5.95979490D+03, 5.88319450D+03, 5.80680350D+03, 5.73062630D+03,
     $ 5.65466710D+03, 5.57892970D+03, 5.50341760D+03, 5.42813400D+03/
      data ( FUPS( 50,J,2),J=1,12) /
     $ 4.723D-10, 2.019D-09, 5.363D-09, 1.133D-08, 2.086D-08, 3.493D-08,
     $ 5.457D-08, 8.082D-08, 1.147D-07, 1.573D-07, 2.095D-07, 2.722D-07/
      data (WNDNS( 50,J,2),J=1,12) /
     $ 5.91108240D+03, 5.83696420D+03, 5.76303600D+03, 5.68930270D+03,
     $ 5.61576930D+03, 5.54244050D+03, 5.46932100D+03, 5.39641500D+03,
     $ 5.32372690D+03, 5.25126030D+03, 5.17901890D+03, 5.10700570D+03/
      data ( FDNS( 50,J,2),J=1,12) /
     $ 1.454D-10, 6.551D-10, 1.824D-09, 4.020D-09, 7.678D-09, 1.329D-08,
     $ 2.140D-08, 3.256D-08, 4.737D-08, 6.640D-08, 9.021D-08, 1.194D-07/
      data (WNUPS( 51,J,1),J=1,12) /
     $ 6.40405640D+03, 6.32303430D+03, 6.24221590D+03, 6.16160660D+03,
     $ 6.08121190D+03, 6.00103710D+03, 5.92108710D+03, 5.84136690D+03,
     $ 5.76188080D+03, 5.68263310D+03, 5.60362740D+03, 5.52486700D+03/
      data ( FUPS( 51,J,1),J=1,12) /
     $ 5.348D-10, 2.285D-09, 6.068D-09, 1.282D-08, 2.359D-08, 3.948D-08,
     $ 6.161D-08, 9.117D-08, 1.293D-07, 1.771D-07, 2.356D-07, 3.057D-07/
      data (WNDNS( 51,J,1),J=1,12) /
     $ 6.02368860D+03, 5.94623720D+03, 5.86898950D+03, 5.79195090D+03,
     $ 5.71512690D+03, 5.63852280D+03, 5.56214330D+03, 5.48599350D+03,
     $ 5.41007760D+03, 5.33439990D+03, 5.25896390D+03, 5.18377300D+03/
      data ( FDNS( 51,J,1),J=1,12) /
     $ 1.579D-10, 7.129D-10, 1.988D-09, 4.390D-09, 8.397D-09, 1.455D-08,
     $ 2.343D-08, 3.565D-08, 5.186D-08, 7.268D-08, 9.874D-08, 1.305D-07/
      data (WNUPS( 51,J,2),J=1,12) /
     $ 6.26669460D+03, 6.18927200D+03, 6.11203940D+03, 6.03500170D+03,
     $ 5.95816400D+03, 5.88153100D+03, 5.80510740D+03, 5.72889770D+03,
     $ 5.65290600D+03, 5.57713620D+03, 5.50159170D+03, 5.42627580D+03/
      data ( FUPS( 51,J,2),J=1,12) /
     $ 4.788D-10, 2.046D-09, 5.432D-09, 1.148D-08, 2.112D-08, 3.534D-08,
     $ 5.519D-08, 8.171D-08, 1.159D-07, 1.589D-07, 2.116D-07, 2.749D-07/
      data (WNDNS( 51,J,2),J=1,12) /
     $ 5.90266920D+03, 5.82858370D+03, 5.75468820D+03, 5.68098770D+03,
     $ 5.60748710D+03, 5.53419120D+03, 5.46110460D+03, 5.38823170D+03,
     $ 5.31557660D+03, 5.24314320D+03, 5.17093500D+03, 5.09895490D+03/
      data ( FDNS( 51,J,2),J=1,12) /
     $ 1.443D-10, 6.505D-10, 1.812D-09, 3.995D-09, 7.633D-09, 1.321D-08,
     $ 2.128D-08, 3.239D-08, 4.713D-08, 6.606D-08, 8.976D-08, 1.187D-07/
      data (WNUPS( 52,J,1),J=1,12) /
     $ 6.40224680D+03, 6.32118960D+03, 6.24033600D+03, 6.15969170D+03,
     $ 6.07926200D+03, 5.99905220D+03, 5.91906740D+03, 5.83931230D+03,
     $ 5.75979150D+03, 5.68050900D+03, 5.60146870D+03, 5.52267360D+03/
      data ( FUPS( 52,J,1),J=1,12) /
     $ 5.422D-10, 2.317D-09, 6.149D-09, 1.299D-08, 2.388D-08, 3.995D-08,
     $ 6.233D-08, 9.221D-08, 1.308D-07, 1.790D-07, 2.381D-07, 3.088D-07/
      data (WNDNS( 52,J,1),J=1,12) /
     $ 6.01468130D+03, 5.93726480D+03, 5.86005200D+03, 5.78304840D+03,
     $ 5.70625960D+03, 5.62969050D+03, 5.55334640D+03, 5.47723180D+03,
     $ 5.40135140D+03, 5.32570910D+03, 5.25030860D+03, 5.17515320D+03/
      data ( FDNS( 52,J,1),J=1,12) /
     $ 1.567D-10, 7.080D-10, 1.976D-09, 4.364D-09, 8.350D-09, 1.447D-08,
     $ 2.330D-08, 3.548D-08, 5.160D-08, 7.232D-08, 9.819D-08, 1.299D-07/
      data (WNUPS( 52,J,2),J=1,12) /
     $ 6.26508980D+03, 6.18763430D+03, 6.11036880D+03, 6.03329840D+03,
     $ 5.95642800D+03, 5.87976240D+03, 5.80330620D+03, 5.72706400D+03,
     $ 5.65103980D+03, 5.57523750D+03, 5.49966070D+03, 5.42431230D+03/
      data ( FUPS( 52,J,2),J=1,12) /
     $ 4.853D-10, 2.073D-09, 5.502D-09, 1.162D-08, 2.137D-08, 3.576D-08,
     $ 5.583D-08, 8.263D-08, 1.172D-07, 1.606D-07, 2.138D-07, 2.776D-07/
      data (WNDNS( 52,J,2),J=1,12) /
     $ 5.89416460D+03, 5.82011180D+03, 5.74624890D+03, 5.67258120D+03,
     $ 5.59911340D+03, 5.52585040D+03, 5.45279670D+03, 5.37995680D+03,
     $ 5.30733480D+03, 5.23493450D+03, 5.16275950D+03, 5.09081260D+03/
      data ( FDNS( 52,J,2),J=1,12) /
     $ 1.432D-10, 6.460D-10, 1.800D-09, 3.970D-09, 7.590D-09, 1.314D-08,
     $ 2.117D-08, 3.222D-08, 4.689D-08, 6.573D-08, 8.931D-08, 1.182D-07/
      data (WNUPS( 53,J,1),J=1,12) /
     $ 6.40032460D+03, 6.31923220D+03, 6.23834350D+03, 6.15766400D+03,
     $ 6.07719930D+03, 5.99695450D+03, 5.91693480D+03, 5.83714490D+03,
     $ 5.75758930D+03, 5.67827210D+03, 5.59919700D+03, 5.52036720D+03/
      data ( FUPS( 53,J,1),J=1,12) /
     $ 5.499D-10, 2.348D-09, 6.230D-09, 1.315D-08, 2.418D-08, 4.044D-08,
     $ 6.307D-08, 9.327D-08, 1.322D-07, 1.810D-07, 2.406D-07, 3.120D-07/
      data (WNDNS( 53,J,1),J=1,12) /
     $ 6.00557640D+03, 5.92819480D+03, 5.85101690D+03, 5.77404840D+03,
     $ 5.69729460D+03, 5.62076070D+03, 5.54445180D+03, 5.46837250D+03,
     $ 5.39252750D+03, 5.31692060D+03, 5.24155560D+03, 5.16643570D+03/
      data ( FDNS( 53,J,1),J=1,12) /
     $ 1.555D-10, 7.032D-10, 1.964D-09, 4.338D-09, 8.304D-09, 1.439D-08,
     $ 2.319D-08, 3.529D-08, 5.135D-08, 7.196D-08, 9.776D-08, 1.293D-07/
      data (WNUPS( 53,J,2),J=1,12) /
     $ 6.26337980D+03, 6.18589150D+03, 6.10859320D+03, 6.03149000D+03,
     $ 5.95458680D+03, 5.87788850D+03, 5.80139980D+03, 5.72512500D+03,
     $ 5.64906830D+03, 5.57323360D+03, 5.49762430D+03, 5.42224360D+03/
      data ( FUPS( 53,J,2),J=1,12) /
     $ 4.920D-10, 2.100D-09, 5.573D-09, 1.177D-08, 2.164D-08, 3.618D-08,
     $ 5.647D-08, 8.355D-08, 1.185D-07, 1.623D-07, 2.160D-07, 2.804D-07/
      data (WNDNS( 53,J,2),J=1,12) /
     $ 5.88556880D+03, 5.81154850D+03, 5.73771830D+03, 5.66408330D+03,
     $ 5.59064830D+03, 5.51741810D+03, 5.44439740D+03, 5.37159050D+03,
     $ 5.29900160D+03, 5.22663440D+03, 5.15449250D+03, 5.08257890D+03/
      data ( FDNS( 53,J,2),J=1,12) /
     $ 1.421D-10, 6.416D-10, 1.789D-09, 3.947D-09, 7.547D-09, 1.307D-08,
     $ 2.106D-08, 3.206D-08, 4.665D-08, 6.541D-08, 8.889D-08, 1.177D-07/
      data (WNUPS( 54,J,1),J=1,12) /
     $ 6.39828960D+03, 6.31716200D+03, 6.23623810D+03, 6.15552350D+03,
     $ 6.07502370D+03, 5.99474400D+03, 5.91468930D+03, 5.83486450D+03,
     $ 5.75527410D+03, 5.67592210D+03, 5.59681230D+03, 5.51794780D+03/
      data ( FUPS( 54,J,1),J=1,12) /
     $ 5.577D-10, 2.380D-09, 6.313D-09, 1.333D-08, 2.449D-08, 4.093D-08,
     $ 6.381D-08, 9.430D-08, 1.336D-07, 1.829D-07, 2.431D-07, 3.151D-07/
      data (WNDNS( 54,J,1),J=1,12) /
     $ 5.99637420D+03, 5.91902730D+03, 5.84188440D+03, 5.76495080D+03,
     $ 5.68823210D+03, 5.61173330D+03, 5.53545960D+03, 5.45941570D+03,
     $ 5.38360600D+03, 5.30803460D+03, 5.23270510D+03, 5.15762060D+03/
      data ( FDNS( 54,J,1),J=1,12) /
     $ 1.544D-10, 6.985D-10, 1.951D-09, 4.314D-09, 8.258D-09, 1.432D-08,
     $ 2.306D-08, 3.512D-08, 5.110D-08, 7.162D-08, 9.725D-08, 1.286D-07/
      data (WNUPS( 54,J,2),J=1,12) /
     $ 6.26156460D+03, 6.18404340D+03, 6.10671220D+03, 6.02957620D+03,
     $ 5.95264030D+03, 5.87590930D+03, 5.79938800D+03, 5.72308060D+03,
     $ 5.64699140D+03, 5.57112420D+03, 5.49548250D+03, 5.42006930D+03/
      data ( FUPS( 54,J,2),J=1,12) /
     $ 4.988D-10, 2.128D-09, 5.646D-09, 1.192D-08, 2.190D-08, 3.661D-08,
     $ 5.711D-08, 8.449D-08, 1.198D-07, 1.640D-07, 2.182D-07, 2.832D-07/
      data (WNDNS( 54,J,2),J=1,12) /
     $ 5.87688170D+03, 5.80289400D+03, 5.72909650D+03, 5.65549420D+03,
     $ 5.58209190D+03, 5.50889460D+03, 5.43590680D+03, 5.36313290D+03,
     $ 5.29057710D+03, 5.21824300D+03, 5.14613430D+03, 5.07425380D+03/
      data ( FDNS( 54,J,2),J=1,12) /
     $ 1.411D-10, 6.372D-10, 1.778D-09, 3.924D-09, 7.506D-09, 1.301D-08,
     $ 2.095D-08, 3.190D-08, 4.642D-08, 6.509D-08, 8.846D-08, 1.171D-07/
      data (WNUPS( 55,J,1),J=1,12) /
     $ 6.39614170D+03, 6.31497880D+03, 6.23401970D+03, 6.15327000D+03,
     $ 6.07273510D+03, 5.99242030D+03, 5.91233070D+03, 5.83247100D+03,
     $ 5.75284580D+03, 5.67345900D+03, 5.59431440D+03, 5.51541520D+03/
      data ( FUPS( 55,J,1),J=1,12) /
     $ 5.655D-10, 2.413D-09, 6.397D-09, 1.350D-08, 2.480D-08, 4.142D-08,
     $ 6.457D-08, 9.541D-08, 1.351D-07, 1.849D-07, 2.456D-07, 3.183D-07/
      data (WNDNS( 55,J,1),J=1,12) /
     $ 5.98707470D+03, 5.90976260D+03, 5.83265460D+03, 5.75575600D+03,
     $ 5.67907220D+03, 5.60260860D+03, 5.52637010D+03, 5.45036150D+03,
     $ 5.37458710D+03, 5.29905110D+03, 5.22375700D+03, 5.14870810D+03/
      data ( FDNS( 55,J,1),J=1,12) /
     $ 1.532D-10, 6.940D-10, 1.940D-09, 4.289D-09, 8.214D-09, 1.424D-08,
     $ 2.295D-08, 3.495D-08, 5.086D-08, 7.128D-08, 9.685D-08, 1.280D-07/
      data (WNUPS( 55,J,2),J=1,12) /
     $ 6.25964400D+03, 6.18208990D+03, 6.10472590D+03, 6.02755700D+03,
     $ 5.95058830D+03, 5.87382460D+03, 5.79727060D+03, 5.72093060D+03,
     $ 5.64480890D+03, 5.56890920D+03, 5.49323510D+03, 5.41778940D+03/
      data ( FUPS( 55,J,2),J=1,12) /
     $ 5.057D-10, 2.157D-09, 5.719D-09, 1.206D-08, 2.217D-08, 3.705D-08,
     $ 5.778D-08, 8.544D-08, 1.211D-07, 1.658D-07, 2.205D-07, 2.861D-07/
      data (WNDNS( 55,J,2),J=1,12) /
     $ 5.86810360D+03, 5.79414850D+03, 5.72038360D+03, 5.64681390D+03,
     $ 5.57344450D+03, 5.50028000D+03, 5.42732510D+03, 5.35458420D+03,
     $ 5.28206140D+03, 5.20976040D+03, 5.13768480D+03, 5.06583750D+03/
      data ( FDNS( 55,J,2),J=1,12) /
     $ 1.401D-10, 6.331D-10, 1.767D-09, 3.902D-09, 7.465D-09, 1.294D-08,
     $ 2.085D-08, 3.175D-08, 4.620D-08, 6.478D-08, 8.805D-08, 1.165D-07/
      data (WNUPS( 56,J,1),J=1,12) /
     $ 6.39388080D+03, 6.31268260D+03, 6.23168820D+03, 6.15090330D+03,
     $ 6.07033330D+03, 5.98998340D+03, 5.90985880D+03, 5.82996420D+03,
     $ 5.75030410D+03, 5.67088250D+03, 5.59170320D+03, 5.51276910D+03/
      data ( FUPS( 56,J,1),J=1,12) /
     $ 5.736D-10, 2.446D-09, 6.484D-09, 1.368D-08, 2.511D-08, 4.193D-08,
     $ 6.533D-08, 9.649D-08, 1.367D-07, 1.868D-07, 2.482D-07, 3.216D-07/
      data (WNDNS( 56,J,1),J=1,12) /
     $ 5.97767800D+03, 5.90040080D+03, 5.82332750D+03, 5.74646390D+03,
     $ 5.66981520D+03, 5.59338670D+03, 5.51718330D+03, 5.44121000D+03,
     $ 5.36547090D+03, 5.28997030D+03, 5.21471170D+03, 5.13969820D+03/
      data ( FDNS( 56,J,1),J=1,12) /
     $ 1.522D-10, 6.896D-10, 1.928D-09, 4.265D-09, 8.172D-09, 1.418D-08,
     $ 2.284D-08, 3.479D-08, 5.062D-08, 7.096D-08, 9.637D-08, 1.274D-07/
      data (WNUPS( 56,J,2),J=1,12) /
     $ 6.25761790D+03, 6.18003090D+03, 6.10263390D+03, 6.02543220D+03,
     $ 5.94843070D+03, 5.87163430D+03, 5.79504760D+03, 5.71867500D+03,
     $ 5.64252070D+03, 5.56658850D+03, 5.49088180D+03, 5.41540370D+03/
      data ( FUPS( 56,J,2),J=1,12) /
     $ 5.126D-10, 2.186D-09, 5.795D-09, 1.223D-08, 2.244D-08, 3.750D-08,
     $ 5.845D-08, 8.641D-08, 1.224D-07, 1.676D-07, 2.227D-07, 2.889D-07/
      data (WNDNS( 56,J,2),J=1,12) /
     $ 5.85923460D+03, 5.78531200D+03, 5.71157970D+03, 5.63804270D+03,
     $ 5.56470600D+03, 5.49157430D+03, 5.41865230D+03, 5.34594440D+03,
     $ 5.27345460D+03, 5.20118670D+03, 5.12914420D+03, 5.05733010D+03/
      data ( FDNS( 56,J,2),J=1,12) /
     $ 1.390D-10, 6.289D-10, 1.757D-09, 3.880D-09, 7.426D-09, 1.288D-08,
     $ 2.074D-08, 3.159D-08, 4.598D-08, 6.449D-08, 8.764D-08, 1.160D-07/
      data (WNUPS( 57,J,1),J=1,12) /
     $ 6.39150660D+03, 6.31027300D+03, 6.22924340D+03, 6.14842330D+03,
     $ 6.06781810D+03, 5.98743320D+03, 5.90727350D+03, 5.82734400D+03,
     $ 5.74764900D+03, 5.66819250D+03, 5.58897830D+03, 5.51000940D+03/
      data ( FUPS( 57,J,1),J=1,12) /
     $ 5.818D-10, 2.480D-09, 6.571D-09, 1.385D-08, 2.542D-08, 4.244D-08,
     $ 6.611D-08, 9.761D-08, 1.382D-07, 1.889D-07, 2.509D-07, 3.250D-07/
      data (WNDNS( 57,J,1),J=1,12) /
     $ 5.96818440D+03, 5.89094190D+03, 5.81390350D+03, 5.73707470D+03,
     $ 5.66046100D+03, 5.58406760D+03, 5.50789940D+03, 5.43196130D+03,
     $ 5.35625760D+03, 5.28079230D+03, 5.20556910D+03, 5.13059110D+03/
      data ( FDNS( 57,J,1),J=1,12) /
     $ 1.511D-10, 6.853D-10, 1.917D-09, 4.243D-09, 8.130D-09, 1.410D-08,
     $ 2.273D-08, 3.463D-08, 5.039D-08, 7.063D-08, 9.591D-08, 1.269D-07/
      data (WNUPS( 57,J,2),J=1,12) /
     $ 6.25548620D+03, 6.17786610D+03, 6.10043630D+03, 6.02320170D+03,
     $ 5.94616740D+03, 5.86933820D+03, 5.79271880D+03, 5.71631350D+03,
     $ 5.64012660D+03, 5.56416190D+03, 5.48842270D+03, 5.41291210D+03/
      data ( FUPS( 57,J,2),J=1,12) /
     $ 5.197D-10, 2.216D-09, 5.870D-09, 1.238D-08, 2.272D-08, 3.794D-08,
     $ 5.913D-08, 8.738D-08, 1.238D-07, 1.693D-07, 2.250D-07, 2.919D-07/
      data (WNDNS( 57,J,2),J=1,12) /
     $ 5.85027470D+03, 5.77638470D+03, 5.70268500D+03, 5.62918060D+03,
     $ 5.55587660D+03, 5.48277770D+03, 5.40988860D+03, 5.33721360D+03,
     $ 5.26475680D+03, 5.19252210D+03, 5.12051270D+03, 5.04873170D+03/
      data ( FDNS( 57,J,2),J=1,12) /
     $ 1.381D-10, 6.250D-10, 1.746D-09, 3.859D-09, 7.387D-09, 1.281D-08,
     $ 2.064D-08, 3.144D-08, 4.577D-08, 6.419D-08, 8.722D-08, 1.155D-07/
      data (WNUPS( 58,J,1),J=1,12) /
     $ 6.38901900D+03, 6.30775010D+03, 6.22668520D+03, 6.14582980D+03,
     $ 6.06518940D+03, 5.98476930D+03, 5.90457470D+03, 5.82461010D+03,
     $ 5.74488020D+03, 5.66538890D+03, 5.58613980D+03, 5.50713600D+03/
      data ( FUPS( 58,J,1),J=1,12) /
     $ 5.900D-10, 2.514D-09, 6.659D-09, 1.403D-08, 2.575D-08, 4.297D-08,
     $ 6.690D-08, 9.878D-08, 1.397D-07, 1.910D-07, 2.536D-07, 3.283D-07/
      data (WNDNS( 58,J,1),J=1,12) /
     $ 5.95859390D+03, 5.88138610D+03, 5.80438250D+03, 5.72758860D+03,
     $ 5.65100990D+03, 5.57465150D+03, 5.49851850D+03, 5.42261560D+03,
     $ 5.34694720D+03, 5.27151730D+03, 5.19632950D+03, 5.12138680D+03/
      data ( FDNS( 58,J,1),J=1,12) /
     $ 1.502D-10, 6.811D-10, 1.907D-09, 4.221D-09, 8.090D-09, 1.403D-08,
     $ 2.263D-08, 3.447D-08, 5.016D-08, 7.032D-08, 9.556D-08, 1.263D-07/
      data (WNUPS( 58,J,2),J=1,12) /
     $ 6.25324870D+03, 6.17559560D+03, 6.09813280D+03, 6.02086530D+03,
     $ 5.94379810D+03, 5.86693610D+03, 5.79028400D+03, 5.71384610D+03,
     $ 5.63762660D+03, 5.56162920D+03, 5.48585750D+03, 5.41031440D+03/
      data ( FUPS( 58,J,2),J=1,12) /
     $ 5.270D-10, 2.245D-09, 5.947D-09, 1.253D-08, 2.300D-08, 3.840D-08,
     $ 5.982D-08, 8.835D-08, 1.251D-07, 1.711D-07, 2.274D-07, 2.948D-07/
      data (WNDNS( 58,J,2),J=1,12) /
     $ 5.84122420D+03, 5.76736670D+03, 5.69369950D+03, 5.62022780D+03,
     $ 5.54695640D+03, 5.47389030D+03, 5.40103410D+03, 5.32839200D+03,
     $ 5.25596820D+03, 5.18376650D+03, 5.11179030D+03, 5.04004240D+03/
      data ( FDNS( 58,J,2),J=1,12) /
     $ 1.372D-10, 6.211D-10, 1.736D-09, 3.838D-09, 7.350D-09, 1.274D-08,
     $ 2.055D-08, 3.130D-08, 4.556D-08, 6.390D-08, 8.684D-08, 1.150D-07/
      data (WNUPS( 59,J,1),J=1,12) /
     $ 6.38641790D+03, 6.30511360D+03, 6.22401330D+03, 6.14312260D+03,
     $ 6.06244700D+03, 5.98199180D+03, 5.90176200D+03, 5.82176250D+03,
     $ 5.74199760D+03, 5.66247140D+03, 5.58318740D+03, 5.50414870D+03/
      data ( FUPS( 59,J,1),J=1,12) /
     $ 5.985D-10, 2.550D-09, 6.749D-09, 1.421D-08, 2.608D-08, 4.350D-08,
     $ 6.770D-08, 9.991D-08, 1.413D-07, 1.931D-07, 2.562D-07, 3.317D-07/
      data (WNDNS( 59,J,1),J=1,12) /
     $ 5.94890660D+03, 5.87173360D+03, 5.79476480D+03, 5.71800570D+03,
     $ 5.64146190D+03, 5.56513850D+03, 5.48904070D+03, 5.41317300D+03,
     $ 5.33753980D+03, 5.26214530D+03, 5.18699290D+03, 5.11208560D+03/
      data ( FDNS( 59,J,1),J=1,12) /
     $ 1.492D-10, 6.771D-10, 1.897D-09, 4.199D-09, 8.050D-09, 1.397D-08,
     $ 2.253D-08, 3.431D-08, 4.994D-08, 7.001D-08, 9.513D-08, 1.257D-07/
      data (WNUPS( 59,J,2),J=1,12) /
     $ 6.25090520D+03, 6.17321920D+03, 6.09572330D+03, 6.01842290D+03,
     $ 5.94132280D+03, 5.86442800D+03, 5.78774310D+03, 5.71127250D+03,
     $ 5.63502030D+03, 5.55899040D+03, 5.48318610D+03, 5.40761040D+03/
      data ( FUPS( 59,J,2),J=1,12) /
     $ 5.344D-10, 2.276D-09, 6.026D-09, 1.269D-08, 2.328D-08, 3.886D-08,
     $ 6.052D-08, 8.940D-08, 1.265D-07, 1.730D-07, 2.297D-07, 2.978D-07/
      data (WNDNS( 59,J,2),J=1,12) /
     $ 5.83208310D+03, 5.75825800D+03, 5.68462340D+03, 5.61118430D+03,
     $ 5.53794560D+03, 5.46491230D+03, 5.39208890D+03, 5.31947970D+03,
     $ 5.24708890D+03, 5.17492030D+03, 5.10297710D+03, 5.03126230D+03/
      data ( FDNS( 59,J,2),J=1,12) /
     $ 1.362D-10, 6.174D-10, 1.726D-09, 3.818D-09, 7.313D-09, 1.269D-08,
     $ 2.045D-08, 3.116D-08, 4.536D-08, 6.362D-08, 8.647D-08, 1.145D-07/
      data (WNUPS( 60,J,1),J=1,12) /
     $ 6.38370320D+03, 6.30236340D+03, 6.22122770D+03, 6.14030170D+03,
     $ 6.05959080D+03, 5.97910040D+03, 5.89883550D+03, 5.81880090D+03,
     $ 5.73900100D+03, 5.65943980D+03, 5.58012090D+03, 5.50104730D+03/
      data ( FUPS( 60,J,1),J=1,12) /
     $ 6.071D-10, 2.585D-09, 6.840D-09, 1.440D-08, 2.640D-08, 4.403D-08,
     $ 6.851D-08, 1.011D-07, 1.429D-07, 1.952D-07, 2.590D-07, 3.351D-07/
      data (WNDNS( 60,J,1),J=1,12) /
     $ 5.93912280D+03, 5.86198440D+03, 5.78505030D+03, 5.70832610D+03,
     $ 5.63181720D+03, 5.55552890D+03, 5.47946610D+03, 5.40363360D+03,
     $ 5.32803570D+03, 5.25267650D+03, 5.17755940D+03, 5.10268760D+03/
      data ( FDNS( 60,J,1),J=1,12) /
     $ 1.482D-10, 6.731D-10, 1.886D-09, 4.179D-09, 8.012D-09, 1.391D-08,
     $ 2.243D-08, 3.417D-08, 4.973D-08, 6.970D-08, 9.471D-08, 1.252D-07/
      data (WNUPS( 60,J,2),J=1,12) /
     $ 6.24845570D+03, 6.17073660D+03, 6.09320770D+03, 6.01587430D+03,
     $ 5.93874130D+03, 5.86181360D+03, 5.78509590D+03, 5.70859260D+03,
     $ 5.63230780D+03, 5.55624520D+03, 5.48040830D+03, 5.40480000D+03/
      data ( FUPS( 60,J,2),J=1,12) /
     $ 5.418D-10, 2.307D-09, 6.106D-09, 1.286D-08, 2.358D-08, 3.934D-08,
     $ 6.124D-08, 9.042D-08, 1.279D-07, 1.749D-07, 2.322D-07, 3.008D-07/
      data (WNDNS( 60,J,2),J=1,12) /
     $ 5.82285160D+03, 5.74905900D+03, 5.67545680D+03, 5.60205020D+03,
     $ 5.52884430D+03, 5.45584370D+03, 5.38305300D+03, 5.31047680D+03,
     $ 5.23811900D+03, 5.16598330D+03, 5.09407320D+03, 5.02239150D+03/
      data ( FDNS( 60,J,2),J=1,12) /
     $ 1.354D-10, 6.137D-10, 1.717D-09, 3.799D-09, 7.278D-09, 1.263D-08,
     $ 2.036D-08, 3.102D-08, 4.517D-08, 6.334D-08, 8.612D-08, 1.140D-07/
      data (WNUPS( 61,J,1),J=1,12) /
     $ 6.38087460D+03, 6.29949930D+03, 6.21832820D+03, 6.13736680D+03,
     $ 6.05662060D+03, 5.97609500D+03, 5.89579500D+03, 5.81572520D+03,
     $ 5.73589030D+03, 5.65629410D+03, 5.57694020D+03, 5.49783170D+03/
      data ( FUPS( 61,J,1),J=1,12) /
     $ 6.159D-10, 2.621D-09, 6.933D-09, 1.460D-08, 2.674D-08, 4.458D-08,
     $ 6.934D-08, 1.022D-07, 1.445D-07, 1.974D-07, 2.617D-07, 3.387D-07/
      data (WNDNS( 61,J,1),J=1,12) /
     $ 5.92924250D+03, 5.85213880D+03, 5.77523940D+03, 5.69854990D+03,
     $ 5.62207590D+03, 5.54582250D+03, 5.46979480D+03, 5.39399750D+03,
     $ 5.31843490D+03, 5.24311090D+03, 5.16802920D+03, 5.09319270D+03/
      data ( FDNS( 61,J,1),J=1,12) /
     $ 1.472D-10, 6.693D-10, 1.876D-09, 4.159D-09, 7.976D-09, 1.385D-08,
     $ 2.233D-08, 3.402D-08, 4.952D-08, 6.941D-08, 9.431D-08, 1.246D-07/
      data (WNUPS( 61,J,2),J=1,12) /
     $ 6.24590010D+03, 6.16814780D+03, 6.09058590D+03, 6.01321940D+03,
     $ 5.93605350D+03, 5.85909290D+03, 5.78234240D+03, 5.70580630D+03,
     $ 5.62948870D+03, 5.55339350D+03, 5.47752400D+03, 5.40188300D+03/
      data ( FUPS( 61,J,2),J=1,12) /
     $ 5.495D-10, 2.339D-09, 6.187D-09, 1.302D-08, 2.387D-08, 3.981D-08,
     $ 6.195D-08, 9.140D-08, 1.293D-07, 1.768D-07, 2.346D-07, 3.039D-07/
      data (WNDNS( 61,J,2),J=1,12) /
     $ 5.81352980D+03, 5.73976950D+03, 5.66619980D+03, 5.59282580D+03,
     $ 5.51965250D+03, 5.44668460D+03, 5.37392680D+03, 5.30138340D+03,
     $ 5.22905850D+03, 5.15695590D+03, 5.08507880D+03, 5.01343020D+03/
      data ( FDNS( 61,J,2),J=1,12) /
     $ 1.345D-10, 6.102D-10, 1.708D-09, 3.780D-09, 7.244D-09, 1.257D-08,
     $ 2.027D-08, 3.089D-08, 4.497D-08, 6.307D-08, 8.569D-08, 1.134D-07/
      data (WNUPS( 62,J,1),J=1,12) /
     $ 6.37793200D+03, 6.29652130D+03, 6.21531460D+03, 6.13431780D+03,
     $ 6.05353630D+03, 5.97297540D+03, 5.89264010D+03, 5.81253530D+03,
     $ 5.73266530D+03, 5.65303410D+03, 5.57364520D+03, 5.49450160D+03/
      data ( FUPS( 62,J,1),J=1,12) /
     $ 6.247D-10, 2.658D-09, 7.028D-09, 1.479D-08, 2.709D-08, 4.514D-08,
     $ 7.017D-08, 1.034D-07, 1.462D-07, 1.995D-07, 2.646D-07, 3.422D-07/
      data (WNDNS( 62,J,1),J=1,12) /
     $ 5.91926590D+03, 5.84219670D+03, 5.76533200D+03, 5.68867730D+03,
     $ 5.61223820D+03, 5.53601970D+03, 5.46002710D+03, 5.38426490D+03,
     $ 5.30873740D+03, 5.23344880D+03, 5.15840240D+03, 5.08360120D+03/
      data ( FDNS( 62,J,1),J=1,12) /
     $ 1.464D-10, 6.658D-10, 1.867D-09, 4.138D-09, 7.940D-09, 1.378D-08,
     $ 2.224D-08, 3.388D-08, 4.931D-08, 6.913D-08, 9.392D-08, 1.242D-07/
      data (WNUPS( 62,J,2),J=1,12) /
     $ 6.24323810D+03, 6.16545260D+03, 6.08785760D+03, 6.01045810D+03,
     $ 5.93325920D+03, 5.85626570D+03, 5.77948230D+03, 5.70291340D+03,
     $ 5.62656310D+03, 5.55043520D+03, 5.47453300D+03, 5.39885930D+03/
      data ( FUPS( 62,J,2),J=1,12) /
     $ 5.572D-10, 2.371D-09, 6.269D-09, 1.320D-08, 2.417D-08, 4.029D-08,
     $ 6.268D-08, 9.244D-08, 1.308D-07, 1.786D-07, 2.371D-07, 3.070D-07/
      data (WNDNS( 62,J,2),J=1,12) /
     $ 5.80411770D+03, 5.73038990D+03, 5.65685260D+03, 5.58351110D+03,
     $ 5.51037030D+03, 5.43743510D+03, 5.36471010D+03, 5.29219960D+03,
     $ 5.21990760D+03, 5.14783800D+03, 5.07599400D+03, 5.00437840D+03/
      data ( FDNS( 62,J,2),J=1,12) /
     $ 1.337D-10, 6.067D-10, 1.699D-09, 3.762D-09, 7.210D-09, 1.251D-08,
     $ 2.018D-08, 3.076D-08, 4.478D-08, 6.281D-08, 8.536D-08, 1.130D-07/
      data (WNUPS( 63,J,1),J=1,12) /
     $ 6.37487530D+03, 6.29342900D+03, 6.21218680D+03, 6.13115460D+03,
     $ 6.05033770D+03, 5.96974140D+03, 5.88937090D+03, 5.80923090D+03,
     $ 5.72932580D+03, 5.64965950D+03, 5.57023550D+03, 5.49105690D+03/
      data ( FUPS( 63,J,1),J=1,12) /
     $ 6.338D-10, 2.695D-09, 7.124D-09, 1.498D-08, 2.743D-08, 4.570D-08,
     $ 7.102D-08, 1.046D-07, 1.478D-07, 2.017D-07, 2.674D-07, 3.458D-07/
      data (WNDNS( 63,J,1),J=1,12) /
     $ 5.90919300D+03, 5.83215840D+03, 5.75532830D+03, 5.67870840D+03,
     $ 5.60230400D+03, 5.52612060D+03, 5.45016290D+03, 5.37443580D+03,
     $ 5.29894360D+03, 5.22369020D+03, 5.14867910D+03, 5.07391320D+03/
      data ( FDNS( 63,J,1),J=1,12) /
     $ 1.455D-10, 6.622D-10, 1.858D-09, 4.120D-09, 7.906D-09, 1.373D-08,
     $ 2.215D-08, 3.374D-08, 4.912D-08, 6.885D-08, 9.354D-08, 1.236D-07/
      data (WNUPS( 63,J,2),J=1,12) /
     $ 6.24046960D+03, 6.16265100D+03, 6.08502280D+03, 6.00759020D+03,
     $ 5.93035820D+03, 5.85333180D+03, 5.77651550D+03, 5.69991380D+03,
     $ 5.62353070D+03, 5.54737010D+03, 5.47143510D+03, 5.39572880D+03/
      data ( FUPS( 63,J,2),J=1,12) /
     $ 5.650D-10, 2.403D-09, 6.352D-09, 1.336D-08, 2.447D-08, 4.078D-08,
     $ 6.342D-08, 9.352D-08, 1.322D-07, 1.806D-07, 2.396D-07, 3.102D-07/
      data (WNDNS( 63,J,2),J=1,12) /
     $ 5.79461560D+03, 5.72092010D+03, 5.64741520D+03, 5.57410620D+03,
     $ 5.50099800D+03, 5.42809550D+03, 5.35540320D+03, 5.28292550D+03,
     $ 5.21066650D+03, 5.13862980D+03, 5.06681880D+03, 4.99523620D+03/
      data ( FDNS( 63,J,2),J=1,12) /
     $ 1.328D-10, 6.034D-10, 1.691D-09, 3.744D-09, 7.178D-09, 1.246D-08,
     $ 2.010D-08, 3.063D-08, 4.460D-08, 6.255D-08, 8.504D-08, 1.125D-07/
      data (WNUPS( 64,J,1),J=1,12) /
     $ 6.37170430D+03, 6.29022240D+03, 6.20894470D+03, 6.12787690D+03,
     $ 6.04702450D+03, 5.96639300D+03, 5.88598720D+03, 5.80581190D+03,
     $ 5.72587160D+03, 5.64617020D+03, 5.56671120D+03, 5.48749740D+03/
      data ( FUPS( 64,J,1),J=1,12) /
     $ 6.430D-10, 2.733D-09, 7.221D-09, 1.518D-08, 2.779D-08, 4.627D-08,
     $ 7.188D-08, 1.059D-07, 1.495D-07, 2.039D-07, 2.702D-07, 3.494D-07/
      data (WNDNS( 64,J,1),J=1,12) /
     $ 5.89902410D+03, 5.82202400D+03, 5.74522850D+03, 5.66864330D+03,
     $ 5.59227370D+03, 5.51612510D+03, 5.44020240D+03, 5.36451040D+03,
     $ 5.28905340D+03, 5.21383520D+03, 5.13885940D+03, 5.06412880D+03/
      data ( FDNS( 64,J,1),J=1,12) /
     $ 1.447D-10, 6.588D-10, 1.849D-09, 4.102D-09, 7.876D-09, 1.367D-08,
     $ 2.205D-08, 3.360D-08, 4.892D-08, 6.857D-08, 9.318D-08, 1.231D-07/
      data (WNUPS( 64,J,2),J=1,12) /
     $ 6.23759450D+03, 6.15974270D+03, 6.08208130D+03, 6.00461560D+03,
     $ 5.92735050D+03, 5.85029110D+03, 5.77344190D+03, 5.69680730D+03,
     $ 5.62039140D+03, 5.54419800D+03, 5.46823030D+03, 5.39249120D+03/
      data ( FUPS( 64,J,2),J=1,12) /
     $ 5.731D-10, 2.436D-09, 6.437D-09, 1.354D-08, 2.478D-08, 4.128D-08,
     $ 6.418D-08, 9.465D-08, 1.337D-07, 1.825D-07, 2.421D-07, 3.134D-07/
      data (WNDNS( 64,J,2),J=1,12) /
     $ 5.78502350D+03, 5.71136030D+03, 5.63788780D+03, 5.56461130D+03,
     $ 5.49153560D+03, 5.41866570D+03, 5.34600620D+03, 5.27356130D+03,
     $ 5.20133510D+03, 5.12933140D+03, 5.05755340D+03, 4.98600380D+03/
      data ( FDNS( 64,J,2),J=1,12) /
     $ 1.321D-10, 6.002D-10, 1.682D-09, 3.727D-09, 7.147D-09, 1.241D-08,
     $ 2.002D-08, 3.051D-08, 4.443D-08, 6.230D-08, 8.465D-08, 1.120D-07/
      data (WNUPS( 65,J,1),J=1,12) /
     $ 6.36841890D+03, 6.28690130D+03, 6.20558800D+03, 6.12448460D+03,
     $ 6.04359680D+03, 5.96292980D+03, 5.88248870D+03, 5.80227820D+03,
     $ 5.72230270D+03, 5.64256610D+03, 5.56307190D+03, 5.48382290D+03/
      data ( FUPS( 65,J,1),J=1,12) /
     $ 6.523D-10, 2.772D-09, 7.321D-09, 1.539D-08, 2.815D-08, 4.685D-08,
     $ 7.276D-08, 1.071D-07, 1.512D-07, 2.062D-07, 2.732D-07, 3.530D-07/
      data (WNDNS( 65,J,1),J=1,12) /
     $ 5.88875920D+03, 5.81179360D+03, 5.73503270D+03, 5.65848210D+03,
     $ 5.58214730D+03, 5.50603350D+03, 5.43014580D+03, 5.35448890D+03,
     $ 5.27906690D+03, 5.20388400D+03, 5.12894340D+03, 5.05424810D+03/
      data ( FDNS( 65,J,1),J=1,12) /
     $ 1.439D-10, 6.555D-10, 1.840D-09, 4.084D-09, 7.840D-09, 1.362D-08,
     $ 2.197D-08, 3.348D-08, 4.873D-08, 6.831D-08, 9.275D-08, 1.227D-07/
      data (WNUPS( 65,J,2),J=1,12) /
     $ 6.23461270D+03, 6.15672760D+03, 6.07903300D+03, 6.00153400D+03,
     $ 5.92423590D+03, 5.84714340D+03, 5.77026120D+03, 5.69359370D+03,
     $ 5.61714500D+03, 5.54091880D+03, 5.46491830D+03, 5.38914640D+03/
      data ( FUPS( 65,J,2),J=1,12) /
     $ 5.812D-10, 2.470D-09, 6.523D-09, 1.371D-08, 2.509D-08, 4.179D-08,
     $ 6.495D-08, 9.574D-08, 1.352D-07, 1.846D-07, 2.447D-07, 3.166D-07/
      data (WNDNS( 65,J,2),J=1,12) /
     $ 5.77534160D+03, 5.70171060D+03, 5.62827050D+03, 5.55502640D+03,
     $ 5.48198320D+03, 5.40914590D+03, 5.33651910D+03, 5.26410700D+03,
     $ 5.19191370D+03, 5.11994290D+03, 5.04819780D+03, 4.97668130D+03/
      data ( FDNS( 65,J,2),J=1,12) /
     $ 1.313D-10, 5.971D-10, 1.674D-09, 3.711D-09, 7.117D-09, 1.236D-08,
     $ 1.994D-08, 3.039D-08, 4.425D-08, 6.206D-08, 8.435D-08, 1.116D-07/
      data (WNUPS( 66,J,1),J=1,12) /
     $ 6.36501890D+03, 6.28346560D+03, 6.20211660D+03, 6.12097760D+03,
     $ 6.04005430D+03, 5.95935180D+03, 5.87887530D+03, 5.79862950D+03,
     $ 5.71861870D+03, 5.63884690D+03, 5.55931750D+03, 5.48003330D+03/
      data ( FUPS( 66,J,1),J=1,12) /
     $ 6.618D-10, 2.811D-09, 7.421D-09, 1.559D-08, 2.851D-08, 4.744D-08,
     $ 7.364D-08, 1.084D-07, 1.530D-07, 2.085D-07, 2.761D-07, 3.567D-07/
      data (WNDNS( 66,J,1),J=1,12) /
     $ 5.87839850D+03, 5.80146730D+03, 5.72474090D+03, 5.64822490D+03,
     $ 5.57192490D+03, 5.49584590D+03, 5.41999320D+03, 5.34437120D+03,
     $ 5.26898440D+03, 5.19383660D+03, 5.11893120D+03, 5.04427110D+03/
      data ( FDNS( 66,J,1),J=1,12) /
     $ 1.431D-10, 6.523D-10, 1.832D-09, 4.067D-09, 7.812D-09, 1.356D-08,
     $ 2.189D-08, 3.335D-08, 4.855D-08, 6.805D-08, 9.241D-08, 1.222D-07/
      data (WNUPS( 66,J,2),J=1,12) /
     $ 6.23152400D+03, 6.15360550D+03, 6.07587760D+03, 5.99834550D+03,
     $ 5.92101420D+03, 5.84388870D+03, 5.76697350D+03, 5.69027300D+03,
     $ 5.61379140D+03, 5.53753230D+03, 5.46149900D+03, 5.38569420D+03/
      data ( FUPS( 66,J,2),J=1,12) /
     $ 5.895D-10, 2.504D-09, 6.611D-09, 1.389D-08, 2.541D-08, 4.231D-08,
     $ 6.572D-08, 9.679D-08, 1.367D-07, 1.866D-07, 2.473D-07, 3.198D-07/
      data (WNDNS( 66,J,2),J=1,12) /
     $ 5.76556990D+03, 5.69197120D+03, 5.61856340D+03, 5.54535160D+03,
     $ 5.47234100D+03, 5.39953630D+03, 5.32694210D+03, 5.25456270D+03,
     $ 5.18240230D+03, 5.11046440D+03, 5.03875220D+03, 4.96726870D+03/
      data ( FDNS( 66,J,2),J=1,12) /
     $ 1.306D-10, 5.941D-10, 1.667D-09, 3.695D-09, 7.088D-09, 1.231D-08,
     $ 1.986D-08, 3.027D-08, 4.408D-08, 6.183D-08, 8.398D-08, 1.112D-07/
      data (WNUPS( 67,J,1),J=1,12) /
     $ 6.36150420D+03, 6.27991510D+03, 6.19853030D+03, 6.11735570D+03,
     $ 6.03639680D+03, 5.95565880D+03, 5.87514690D+03, 5.79486570D+03,
     $ 5.71481970D+03, 5.63501260D+03, 5.55544790D+03, 5.47612840D+03/
      data ( FUPS( 67,J,1),J=1,12) /
     $ 6.716D-10, 2.851D-09, 7.526D-09, 1.580D-08, 2.888D-08, 4.804D-08,
     $ 7.454D-08, 1.097D-07, 1.547D-07, 2.108D-07, 2.791D-07, 3.605D-07/
      data (WNDNS( 67,J,1),J=1,12) /
     $ 5.86794210D+03, 5.79104530D+03, 5.71435340D+03, 5.63787200D+03,
     $ 5.56160660D+03, 5.48556240D+03, 5.40974450D+03, 5.33415760D+03,
     $ 5.25880580D+03, 5.18369320D+03, 5.10882300D+03, 5.03419810D+03/
      data ( FDNS( 67,J,1),J=1,12) /
     $ 1.424D-10, 6.493D-10, 1.825D-09, 4.051D-09, 7.778D-09, 1.352D-08,
     $ 2.181D-08, 3.324D-08, 4.838D-08, 6.781D-08, 9.207D-08, 1.217D-07/
      data (WNUPS( 67,J,2),J=1,12) /
     $ 6.22832820D+03, 6.15037640D+03, 6.07261520D+03, 5.99504980D+03,
     $ 5.91768540D+03, 5.84052670D+03, 5.76357840D+03, 5.68684500D+03,
     $ 5.61033040D+03, 5.53403840D+03, 5.45797220D+03, 5.38213460D+03/
      data ( FUPS( 67,J,2),J=1,12) /
     $ 5.979D-10, 2.538D-09, 6.701D-09, 1.408D-08, 2.574D-08, 4.283D-08,
     $ 6.650D-08, 9.797D-08, 1.383D-07, 1.886D-07, 2.499D-07, 3.232D-07/
      data (WNDNS( 67,J,2),J=1,12) /
     $ 5.75570860D+03, 5.68214210D+03, 5.60876650D+03, 5.53558720D+03,
     $ 5.46260900D+03, 5.38983680D+03, 5.31727530D+03, 5.24492870D+03,
     $ 5.17280100D+03, 5.10089600D+03, 5.02921670D+03, 4.95776610D+03/
      data ( FDNS( 67,J,2),J=1,12) /
     $ 1.299D-10, 5.913D-10, 1.659D-09, 3.679D-09, 7.060D-09, 1.226D-08,
     $ 1.979D-08, 3.016D-08, 4.392D-08, 6.159D-08, 8.370D-08, 1.107D-07/
      data (WNUPS( 68,J,1),J=1,12) /
     $ 6.35787450D+03, 6.27624960D+03, 6.19482910D+03, 6.11361880D+03,
     $ 6.03262420D+03, 5.95185070D+03, 5.87130330D+03, 5.79098670D+03,
     $ 5.71090520D+03, 5.63106280D+03, 5.55146280D+03, 5.47210800D+03/
      data ( FUPS( 68,J,1),J=1,12) /
     $ 6.814D-10, 2.892D-09, 7.630D-09, 1.601D-08, 2.926D-08, 4.864D-08,
     $ 7.548D-08, 1.110D-07, 1.565D-07, 2.132D-07, 2.821D-07, 3.643D-07/
      data (WNDNS( 68,J,1),J=1,12) /
     $ 5.85739010D+03, 5.78052770D+03, 5.70387020D+03, 5.62742330D+03,
     $ 5.55119250D+03, 5.47518310D+03, 5.39940010D+03, 5.32384810D+03,
     $ 5.24853140D+03, 5.17345380D+03, 5.09861880D+03, 5.02402900D+03/
      data ( FDNS( 68,J,1),J=1,12) /
     $ 1.416D-10, 6.464D-10, 1.818D-09, 4.035D-09, 7.752D-09, 1.347D-08,
     $ 2.173D-08, 3.312D-08, 4.820D-08, 6.756D-08, 9.175D-08, 1.212D-07/
      data (WNUPS( 68,J,2),J=1,12) /
     $ 6.22502530D+03, 6.14704010D+03, 6.06924550D+03, 5.99164680D+03,
     $ 5.91424910D+03, 5.83705730D+03, 5.76007590D+03, 5.68330940D+03,
     $ 5.60676190D+03, 5.53043690D+03, 5.45433780D+03, 5.37846720D+03/
      data ( FUPS( 68,J,2),J=1,12) /
     $ 6.064D-10, 2.574D-09, 6.791D-09, 1.426D-08, 2.607D-08, 4.336D-08,
     $ 6.730D-08, 9.911D-08, 1.399D-07, 1.907D-07, 2.526D-07, 3.265D-07/
      data (WNDNS( 68,J,2),J=1,12) /
     $ 5.74575780D+03, 5.67222350D+03, 5.59888010D+03, 5.52573310D+03,
     $ 5.45278730D+03, 5.38004770D+03, 5.30751870D+03, 5.23520480D+03,
     $ 5.16311000D+03, 5.09123780D+03, 5.01959140D+03, 4.94817370D+03/
      data ( FDNS( 68,J,2),J=1,12) /
     $ 1.292D-10, 5.885D-10, 1.652D-09, 3.664D-09, 7.033D-09, 1.222D-08,
     $ 1.972D-08, 3.005D-08, 4.376D-08, 6.137D-08, 8.343D-08, 1.103D-07/
      data (WNUPS( 69,J,1),J=1,12) /
     $ 6.35412990D+03, 6.27246900D+03, 6.19101270D+03, 6.10976660D+03,
     $ 6.02873630D+03, 5.94792720D+03, 5.86734420D+03, 5.78699220D+03,
     $ 5.70687530D+03, 5.62699750D+03, 5.54736210D+03, 5.46797200D+03/
      data ( FUPS( 69,J,1),J=1,12) /
     $ 6.915D-10, 2.933D-09, 7.737D-09, 1.623D-08, 2.964D-08, 4.926D-08,
     $ 7.635D-08, 1.123D-07, 1.583D-07, 2.156D-07, 2.853D-07, 3.682D-07/
      data (WNDNS( 69,J,1),J=1,12) /
     $ 5.84674270D+03, 5.76991450D+03, 5.69329140D+03, 5.61687900D+03,
     $ 5.54068280D+03, 5.46470820D+03, 5.38896000D+03, 5.31344290D+03,
     $ 5.23816120D+03, 5.16311870D+03, 5.08831880D+03, 5.01376410D+03/
      data ( FDNS( 69,J,1),J=1,12) /
     $ 1.409D-10, 6.436D-10, 1.810D-09, 4.020D-09, 7.727D-09, 1.342D-08,
     $ 2.166D-08, 3.301D-08, 4.804D-08, 6.732D-08, 9.144D-08, 1.208D-07/
      data (WNUPS( 69,J,2),J=1,12) /
     $ 6.22161510D+03, 6.14359640D+03, 6.06576840D+03, 5.98813640D+03,
     $ 5.91070540D+03, 5.83348030D+03, 5.75646580D+03, 5.67966620D+03,
     $ 5.60308570D+03, 5.52672770D+03, 5.45059560D+03, 5.37469200D+03/
      data ( FUPS( 69,J,2),J=1,12) /
     $ 6.152D-10, 2.610D-09, 6.883D-09, 1.445D-08, 2.639D-08, 4.389D-08,
     $ 6.811D-08, 1.002D-07, 1.415D-07, 1.928D-07, 2.553D-07, 3.299D-07/
      data (WNDNS( 69,J,2),J=1,12) /
     $ 5.73571760D+03, 5.66221540D+03, 5.58890430D+03, 5.51578950D+03,
     $ 5.44287610D+03, 5.37016900D+03, 5.29767260D+03, 5.22539140D+03,
     $ 5.15332930D+03, 5.08148990D+03, 5.00987640D+03, 4.93849150D+03/
      data ( FDNS( 69,J,2),J=1,12) /
     $ 1.286D-10, 5.858D-10, 1.645D-09, 3.650D-09, 7.006D-09, 1.217D-08,
     $ 1.965D-08, 2.994D-08, 4.360D-08, 6.115D-08, 8.309D-08, 1.099D-07/
      data (WNUPS( 70,J,1),J=1,12) /
     $ 6.35027000D+03, 6.26857320D+03, 6.18708090D+03, 6.10579900D+03,
     $ 6.02473300D+03, 5.94388820D+03, 5.86326960D+03, 5.78288210D+03,
     $ 5.70272970D+03, 5.62281650D+03, 5.54314570D+03, 5.46372000D+03/
      data ( FUPS( 70,J,1),J=1,12) /
     $ 7.017D-10, 2.976D-09, 7.842D-09, 1.645D-08, 3.003D-08, 4.988D-08,
     $ 7.734D-08, 1.137D-07, 1.601D-07, 2.180D-07, 2.883D-07, 3.721D-07/
      data (WNDNS( 70,J,1),J=1,12) /
     $ 5.83599990D+03, 5.75920600D+03, 5.68261720D+03, 5.60623930D+03,
     $ 5.53007770D+03, 5.45413770D+03, 5.37842420D+03, 5.30294200D+03,
     $ 5.22769530D+03, 5.15268790D+03, 5.07792300D+03, 5.00340340D+03/
      data ( FDNS( 70,J,1),J=1,12) /
     $ 1.403D-10, 6.409D-10, 1.804D-09, 4.006D-09, 7.695D-09, 1.338D-08,
     $ 2.159D-08, 3.289D-08, 4.788D-08, 6.710D-08, 9.113D-08, 1.204D-07/
      data (WNUPS( 70,J,2),J=1,12) /
     $ 6.21809750D+03, 6.14004530D+03, 6.06218380D+03, 5.98451830D+03,
     $ 5.90705400D+03, 5.82979560D+03, 5.75274790D+03, 5.67591530D+03,
     $ 5.59930160D+03, 5.52291060D+03, 5.44674540D+03, 5.37080880D+03/
      data ( FUPS( 70,J,2),J=1,12) /
     $ 6.240D-10, 2.647D-09, 6.976D-09, 1.463D-08, 2.673D-08, 4.443D-08,
     $ 6.893D-08, 1.014D-07, 1.430D-07, 1.949D-07, 2.580D-07, 3.333D-07/
      data (WNDNS( 70,J,2),J=1,12) /
     $ 5.72558820D+03, 5.65211800D+03, 5.57883910D+03, 5.50575650D+03,
     $ 5.43287550D+03, 5.36020080D+03, 5.28773700D+03, 5.21548840D+03,
     $ 5.14345900D+03, 5.07165240D+03, 5.00007170D+03, 4.92871970D+03/
      data ( FDNS( 70,J,2),J=1,12) /
     $ 1.279D-10, 5.833D-10, 1.639D-09, 3.636D-09, 6.982D-09, 1.213D-08,
     $ 1.958D-08, 2.984D-08, 4.345D-08, 6.094D-08, 8.277D-08, 1.095D-07/
      data (WNUPS( 71,J,1),J=1,12) /
     $ 6.34629470D+03, 6.26456190D+03, 6.18303370D+03, 6.10171590D+03,
     $ 6.02061400D+03, 5.93973350D+03, 5.85907930D+03, 5.77865620D+03,
     $ 5.69846830D+03, 5.61851950D+03, 5.53881320D+03, 5.45935210D+03/
      data ( FUPS( 71,J,1),J=1,12) /
     $ 7.121D-10, 3.018D-09, 7.950D-09, 1.667D-08, 3.042D-08, 5.052D-08,
     $ 7.830D-08, 1.150D-07, 1.620D-07, 2.205D-07, 2.915D-07, 3.760D-07/
      data (WNDNS( 71,J,1),J=1,12) /
     $ 5.82516190D+03, 5.74840220D+03, 5.67184770D+03, 5.59550410D+03,
     $ 5.51937710D+03, 5.44347170D+03, 5.36779300D+03, 5.29234570D+03,
     $ 5.21713390D+03, 5.14216140D+03, 5.06743160D+03, 4.99294710D+03/
      data ( FDNS( 71,J,1),J=1,12) /
     $ 1.397D-10, 6.385D-10, 1.797D-09, 3.993D-09, 7.671D-09, 1.334D-08,
     $ 2.152D-08, 3.279D-08, 4.772D-08, 6.687D-08, 9.077D-08, 1.199D-07/
      data (WNUPS( 71,J,2),J=1,12) /
     $ 6.21447220D+03, 6.13638650D+03, 6.05849150D+03, 5.98079250D+03,
     $ 5.90329480D+03, 5.82600310D+03, 5.74892220D+03, 5.67205630D+03,
     $ 5.59540950D+03, 5.51898540D+03, 5.44278720D+03, 5.36681750D+03/
      data ( FUPS( 71,J,2),J=1,12) /
     $ 6.330D-10, 2.684D-09, 7.072D-09, 1.483D-08, 2.708D-08, 4.499D-08,
     $ 6.976D-08, 1.026D-07, 1.447D-07, 1.970D-07, 2.608D-07, 3.368D-07/
      data (WNDNS( 71,J,2),J=1,12) /
     $ 5.71536960D+03, 5.64193140D+03, 5.56868460D+03, 5.49563430D+03,
     $ 5.42278560D+03, 5.35014320D+03, 5.27771200D+03, 5.20549600D+03,
     $ 5.13349920D+03, 5.06172540D+03, 4.99017750D+03, 4.91885830D+03/
      data ( FDNS( 71,J,2),J=1,12) /
     $ 1.273D-10, 5.808D-10, 1.632D-09, 3.624D-09, 6.958D-09, 1.209D-08,
     $ 1.951D-08, 2.975D-08, 4.331D-08, 6.073D-08, 8.252D-08, 1.092D-07/
      data (WNUPS( 72,J,1),J=1,12) /
     $ 6.34220400D+03, 6.26043500D+03, 6.17887080D+03, 6.09751700D+03,
     $ 6.01637930D+03, 5.93546300D+03, 5.85477310D+03, 5.77431430D+03,
     $ 5.69409080D+03, 5.61410650D+03, 5.53436460D+03, 5.45486790D+03/
      data ( FUPS( 72,J,1),J=1,12) /
     $ 7.224D-10, 3.062D-09, 8.063D-09, 1.690D-08, 3.082D-08, 5.116D-08,
     $ 7.923D-08, 1.164D-07, 1.639D-07, 2.229D-07, 2.947D-07, 3.800D-07/
      data (WNDNS( 72,J,1),J=1,12) /
     $ 5.81422880D+03, 5.73750320D+03, 5.66098300D+03, 5.58467380D+03,
     $ 5.50858120D+03, 5.43271040D+03, 5.35706640D+03, 5.28165390D+03,
     $ 5.20647700D+03, 5.13153950D+03, 5.05684460D+03, 4.98239510D+03/
      data ( FDNS( 72,J,1),J=1,12) /
     $ 1.391D-10, 6.360D-10, 1.791D-09, 3.980D-09, 7.648D-09, 1.330D-08,
     $ 2.146D-08, 3.269D-08, 4.757D-08, 6.666D-08, 9.048D-08, 1.196D-07/
      data (WNUPS( 72,J,2),J=1,12) /
     $ 6.21073930D+03, 6.13261980D+03, 6.05469130D+03, 5.97695880D+03,
     $ 5.89942770D+03, 5.82210260D+03, 5.74498840D+03, 5.66808930D+03,
     $ 5.59140930D+03, 5.51495200D+03, 5.43872070D+03, 5.36271780D+03/
      data ( FUPS( 72,J,2),J=1,12) /
     $ 6.422D-10, 2.721D-09, 7.168D-09, 1.503D-08, 2.743D-08, 4.555D-08,
     $ 7.063D-08, 1.038D-07, 1.463D-07, 1.992D-07, 2.636D-07, 3.403D-07/
      data (WNDNS( 72,J,2),J=1,12) /
     $ 5.70506190D+03, 5.63165570D+03, 5.55844100D+03, 5.48542280D+03,
     $ 5.41260640D+03, 5.33999640D+03, 5.26759760D+03, 5.19541420D+03,
     $ 5.12345010D+03, 5.05170900D+03, 4.98019390D+03, 4.90890750D+03/
      data ( FDNS( 72,J,2),J=1,12) /
     $ 1.268D-10, 5.786D-10, 1.626D-09, 3.611D-09, 6.938D-09, 1.205D-08,
     $ 1.945D-08, 2.965D-08, 4.317D-08, 6.054D-08, 8.221D-08, 1.088D-07/
      data (WNUPS( 73,J,1),J=1,12) /
     $ 6.33799750D+03, 6.25619240D+03, 6.17459210D+03, 6.09320230D+03,
     $ 6.01202870D+03, 5.93107650D+03, 5.85035080D+03, 5.76985630D+03,
     $ 5.68959720D+03, 5.60957720D+03, 5.52979970D+03, 5.45026730D+03/
      data ( FUPS( 73,J,1),J=1,12) /
     $ 7.331D-10, 3.106D-09, 8.172D-09, 1.712D-08, 3.123D-08, 5.181D-08,
     $ 8.021D-08, 1.178D-07, 1.658D-07, 2.254D-07, 2.979D-07, 3.841D-07/
      data (WNDNS( 73,J,1),J=1,12) /
     $ 5.80320070D+03, 5.72650920D+03, 5.65002320D+03, 5.57374830D+03,
     $ 5.49769010D+03, 5.42185390D+03, 5.34624460D+03, 5.27086680D+03,
     $ 5.19572470D+03, 5.12082210D+03, 5.04616220D+03, 4.97174770D+03/
      data ( FDNS( 73,J,1),J=1,12) /
     $ 1.385D-10, 6.337D-10, 1.785D-09, 3.967D-09, 7.626D-09, 1.325D-08,
     $ 2.139D-08, 3.259D-08, 4.743D-08, 6.646D-08, 9.020D-08, 1.192D-07/
      data (WNUPS( 73,J,2),J=1,12) /
     $ 6.20689840D+03, 6.12874530D+03, 6.05078310D+03, 5.97301710D+03,
     $ 5.89545240D+03, 5.81809390D+03, 5.74094630D+03, 5.66401390D+03,
     $ 5.58730070D+03, 5.51081030D+03, 5.43454570D+03, 5.35850960D+03/
      data ( FUPS( 73,J,2),J=1,12) /
     $ 6.515D-10, 2.759D-09, 7.269D-09, 1.523D-08, 2.778D-08, 4.612D-08,
     $ 7.145D-08, 1.050D-07, 1.480D-07, 2.014D-07, 2.664D-07, 3.439D-07/
      data (WNDNS( 73,J,2),J=1,12) /
     $ 5.69466530D+03, 5.62129110D+03, 5.54810830D+03, 5.47512230D+03,
     $ 5.40233810D+03, 5.32976050D+03, 5.25739410D+03, 5.18524320D+03,
     $ 5.11331180D+03, 5.04160330D+03, 4.97012090D+03, 4.89886720D+03/
      data ( FDNS( 73,J,2),J=1,12) /
     $ 1.262D-10, 5.763D-10, 1.621D-09, 3.599D-09, 6.912D-09, 1.201D-08,
     $ 1.939D-08, 2.956D-08, 4.303D-08, 6.034D-08, 8.197D-08, 1.084D-07/
      data (WNUPS( 74,J,1),J=1,12) /
     $ 6.33367520D+03, 6.25183390D+03, 6.17019740D+03, 6.08877160D+03,
     $ 6.00756190D+03, 5.92657380D+03, 5.84581230D+03, 5.76528200D+03,
     $ 5.68498710D+03, 5.60493150D+03, 5.52511830D+03, 5.44555010D+03/
      data ( FUPS( 74,J,1),J=1,12) /
     $ 7.442D-10, 3.150D-09, 8.293D-09, 1.735D-08, 3.164D-08, 5.247D-08,
     $ 8.122D-08, 1.192D-07, 1.678D-07, 2.280D-07, 3.012D-07, 3.882D-07/
      data (WNDNS( 74,J,1),J=1,12) /
     $ 5.79207780D+03, 5.71542030D+03, 5.63896840D+03, 5.56272780D+03,
     $ 5.48670400D+03, 5.41090230D+03, 5.33532760D+03, 5.25998450D+03,
     $ 5.18487720D+03, 5.11000950D+03, 5.03538450D+03, 4.96100490D+03/
      data ( FDNS( 74,J,1),J=1,12) /
     $ 1.380D-10, 6.316D-10, 1.779D-09, 3.956D-09, 7.604D-09, 1.321D-08,
     $ 2.133D-08, 3.250D-08, 4.729D-08, 6.626D-08, 8.993D-08, 1.188D-07/
      data (WNUPS( 74,J,2),J=1,12) /
     $ 6.20294960D+03, 6.12476270D+03, 6.04676680D+03, 5.96896710D+03,
     $ 5.89136890D+03, 5.81397700D+03, 5.73679590D+03, 5.65983020D+03,
     $ 5.58308370D+03, 5.50655990D+03, 5.43026210D+03, 5.35419280D+03/
      data ( FUPS( 74,J,2),J=1,12) /
     $ 6.610D-10, 2.799D-09, 7.367D-09, 1.543D-08, 2.814D-08, 4.669D-08,
     $ 7.231D-08, 1.063D-07, 1.497D-07, 2.037D-07, 2.693D-07, 3.475D-07/
      data (WNDNS( 74,J,2),J=1,12) /
     $ 5.68417980D+03, 5.61083750D+03, 5.53768670D+03, 5.46473280D+03,
     $ 5.39198080D+03, 5.31943550D+03, 5.24710150D+03, 5.17498310D+03,
     $ 5.10308430D+03, 5.03140840D+03, 4.95995870D+03, 4.88873770D+03/
      data ( FDNS( 74,J,2),J=1,12) /
     $ 1.257D-10, 5.742D-10, 1.615D-09, 3.588D-09, 6.893D-09, 1.198D-08,
     $ 1.934D-08, 2.947D-08, 4.291D-08, 6.015D-08, 8.168D-08, 1.081D-07/
      data (WNUPS( 75,J,1),J=1,12) /
     $ 6.32923690D+03, 6.24735930D+03, 6.16568660D+03, 6.08422460D+03,
     $ 6.00297890D+03, 5.92195480D+03, 5.84115730D+03, 5.76059120D+03,
     $ 5.68026050D+03, 5.60016910D+03, 5.52032010D+03, 5.44071610D+03/
      data ( FUPS( 75,J,1),J=1,12) /
     $ 7.557D-10, 3.197D-09, 8.409D-09, 1.759D-08, 3.205D-08, 5.315D-08,
     $ 8.221D-08, 1.206D-07, 1.697D-07, 2.306D-07, 3.045D-07, 3.923D-07/
      data (WNDNS( 75,J,1),J=1,12) /
     $ 5.78086010D+03, 5.70423670D+03, 5.62781880D+03, 5.55161240D+03,
     $ 5.47562290D+03, 5.39985560D+03, 5.32431550D+03, 5.24900710D+03,
     $ 5.17393460D+03, 5.09910170D+03, 5.02451160D+03, 4.95016680D+03/
      data ( FDNS( 75,J,1),J=1,12) /
     $ 1.375D-10, 6.296D-10, 1.774D-09, 3.945D-09, 7.583D-09, 1.319D-08,
     $ 2.127D-08, 3.241D-08, 4.716D-08, 6.606D-08, 8.967D-08, 1.184D-07/
      data (WNUPS( 75,J,2),J=1,12) /
     $ 6.19889250D+03, 6.12067190D+03, 6.04264220D+03, 5.96480880D+03,
     $ 5.88717700D+03, 5.80975150D+03, 5.73253700D+03, 5.65553780D+03,
     $ 5.57875800D+03, 5.50220090D+03, 5.42586980D+03, 5.34976710D+03/
      data ( FUPS( 75,J,2),J=1,12) /
     $ 6.706D-10, 2.838D-09, 7.470D-09, 1.563D-08, 2.850D-08, 4.728D-08,
     $ 7.322D-08, 1.075D-07, 1.513D-07, 2.059D-07, 2.722D-07, 3.511D-07/
      data (WNDNS( 75,J,2),J=1,12) /
     $ 5.67360570D+03, 5.60029520D+03, 5.52717640D+03, 5.45425450D+03,
     $ 5.38153460D+03, 5.30902150D+03, 5.23671990D+03, 5.16463400D+03,
     $ 5.09276770D+03, 5.02112440D+03, 4.94970740D+03, 4.87851910D+03/
      data ( FDNS( 75,J,2),J=1,12) /
     $ 1.252D-10, 5.722D-10, 1.610D-09, 3.577D-09, 6.874D-09, 1.195D-08,
     $ 1.928D-08, 2.938D-08, 4.278D-08, 5.997D-08, 8.146D-08, 1.077D-07/
      data (WNUPS( 76,J,1),J=1,12) /
     $ 6.32468250D+03, 6.24276850D+03, 6.16105950D+03, 6.07956120D+03,
     $ 5.99827940D+03, 5.91721920D+03, 5.83638580D+03, 5.75578370D+03,
     $ 5.67541720D+03, 5.59528990D+03, 5.51540510D+03, 5.43576520D+03/
      data ( FUPS( 76,J,1),J=1,12) /
     $ 7.669D-10, 3.243D-09, 8.523D-09, 1.783D-08, 3.248D-08, 5.383D-08,
     $ 8.325D-08, 1.221D-07, 1.717D-07, 2.332D-07, 3.079D-07, 3.965D-07/
      data (WNDNS( 76,J,1),J=1,12) /
     $ 5.76954780D+03, 5.69295830D+03, 5.61657450D+03, 5.54040220D+03,
     $ 5.46444700D+03, 5.38871410D+03, 5.31320850D+03, 5.23793470D+03,
     $ 5.16289690D+03, 5.08809880D+03, 5.01354350D+03, 4.93923360D+03/
      data ( FDNS( 76,J,1),J=1,12) /
     $ 1.371D-10, 6.277D-10, 1.769D-09, 3.935D-09, 7.562D-09, 1.315D-08,
     $ 2.122D-08, 3.233D-08, 4.703D-08, 6.588D-08, 8.941D-08, 1.180D-07/
      data (WNUPS( 76,J,2),J=1,12) /
     $ 6.19472720D+03, 6.11647260D+03, 6.03840910D+03, 5.96054200D+03,
     $ 5.88287650D+03, 5.80541740D+03, 5.72816940D+03, 5.65113680D+03,
     $ 5.57432350D+03, 5.49773300D+03, 5.42136850D+03, 5.34523240D+03/
      data ( FUPS( 76,J,2),J=1,12) /
     $ 6.801D-10, 2.878D-09, 7.570D-09, 1.584D-08, 2.887D-08, 4.787D-08,
     $ 7.411D-08, 1.088D-07, 1.531D-07, 2.082D-07, 2.752D-07, 3.548D-07/
      data (WNDNS( 76,J,2),J=1,12) /
     $ 5.66294290D+03, 5.58966420D+03, 5.51657720D+03, 5.44368730D+03,
     $ 5.37099950D+03, 5.29851870D+03, 5.22624940D+03, 5.15419590D+03,
     $ 5.08236210D+03, 5.01075140D+03, 4.93936700D+03, 4.86821130D+03/
      data ( FDNS( 76,J,2),J=1,12) /
     $ 1.247D-10, 5.703D-10, 1.605D-09, 3.567D-09, 6.856D-09, 1.192D-08,
     $ 1.923D-08, 2.931D-08, 4.266D-08, 5.980D-08, 8.124D-08, 1.074D-07/
      data (WNUPS( 77,J,1),J=1,12) /
     $ 6.32001180D+03, 6.23806130D+03, 6.15631590D+03, 6.07478130D+03,
     $ 5.99346320D+03, 5.91236700D+03, 5.83149750D+03, 5.75085940D+03,
     $ 5.67045690D+03, 5.59029370D+03, 5.51037290D+03, 5.43069710D+03/
      data ( FUPS( 77,J,1),J=1,12) /
     $ 7.784D-10, 3.290D-09, 8.647D-09, 1.808D-08, 3.292D-08, 5.452D-08,
     $ 8.431D-08, 1.236D-07, 1.737D-07, 2.359D-07, 3.112D-07, 4.008D-07/
      data (WNDNS( 77,J,1),J=1,12) /
     $ 5.75814100D+03, 5.68158530D+03, 5.60523550D+03, 5.52909730D+03,
     $ 5.45317630D+03, 5.37747780D+03, 5.30200660D+03, 5.22676740D+03,
     $ 5.15176430D+03, 5.07700090D+03, 5.00248040D+03, 4.92820520D+03/
      data ( FDNS( 77,J,1),J=1,12) /
     $ 1.366D-10, 6.259D-10, 1.765D-09, 3.925D-09, 7.548D-09, 1.312D-08,
     $ 2.117D-08, 3.225D-08, 4.690D-08, 6.568D-08, 8.910D-08, 1.177D-07/
      data (WNUPS( 77,J,2),J=1,12) /
     $ 6.19045340D+03, 6.11216490D+03, 6.03406750D+03, 5.95616660D+03,
     $ 5.87846730D+03, 5.80097460D+03, 5.72369290D+03, 5.64662680D+03,
     $ 5.56978000D+03, 5.49315610D+03, 5.41675810D+03, 5.34058850D+03/
      data ( FUPS( 77,J,2),J=1,12) /
     $ 6.902D-10, 2.920D-09, 7.673D-09, 1.605D-08, 2.924D-08, 4.848D-08,
     $ 7.503D-08, 1.101D-07, 1.549D-07, 2.105D-07, 2.781D-07, 3.586D-07/
      data (WNDNS( 77,J,2),J=1,12) /
     $ 5.65219160D+03, 5.57894460D+03, 5.50588950D+03, 5.43303150D+03,
     $ 5.36037580D+03, 5.28792710D+03, 5.21569010D+03, 5.14366900D+03,
     $ 5.07186760D+03, 5.00028950D+03, 4.92893760D+03, 4.85781450D+03/
      data ( FDNS( 77,J,2),J=1,12) /
     $ 1.243D-10, 5.686D-10, 1.601D-09, 3.557D-09, 6.839D-09, 1.188D-08,
     $ 1.918D-08, 2.923D-08, 4.254D-08, 5.963D-08, 8.097D-08, 1.070D-07/
      data (WNUPS( 78,J,1),J=1,12) /
     $ 6.31522450D+03, 6.23323760D+03, 6.15145570D+03, 6.06988470D+03,
     $ 5.98853030D+03, 5.90739780D+03, 5.82649220D+03, 5.74581800D+03,
     $ 5.66537950D+03, 5.58518030D+03, 5.50522360D+03, 5.42551160D+03/
      data ( FUPS( 78,J,1),J=1,12) /
     $ 7.897D-10, 3.338D-09, 8.768D-09, 1.833D-08, 3.335D-08, 5.522D-08,
     $ 8.535D-08, 1.250D-07, 1.757D-07, 2.386D-07, 3.147D-07, 4.051D-07/
      data (WNDNS( 78,J,1),J=1,12) /
     $ 5.74663980D+03, 5.67011790D+03, 5.59380200D+03, 5.51769780D+03,
     $ 5.44181100D+03, 5.36614680D+03, 5.29071000D+03, 5.21550540D+03,
     $ 5.14053690D+03, 5.06580810D+03, 4.99132230D+03, 4.91708190D+03/
      data ( FDNS( 78,J,1),J=1,12) /
     $ 1.362D-10, 6.243D-10, 1.761D-09, 3.917D-09, 7.529D-09, 1.309D-08,
     $ 2.112D-08, 3.217D-08, 4.679D-08, 6.554D-08, 8.885D-08, 1.173D-07/
      data (WNUPS( 78,J,2),J=1,12) /
     $ 6.18607100D+03, 6.10774850D+03, 6.02961720D+03, 5.95168240D+03,
     $ 5.87394920D+03, 5.79642280D+03, 5.71910750D+03, 5.64200770D+03,
     $ 5.56512740D+03, 5.48846990D+03, 5.41203840D+03, 5.33583530D+03/
      data ( FUPS( 78,J,2),J=1,12) /
     $ 7.006D-10, 2.961D-09, 7.781D-09, 1.627D-08, 2.963D-08, 4.908D-08,
     $ 7.594D-08, 1.114D-07, 1.566D-07, 2.129D-07, 2.812D-07, 3.623D-07/
      data (WNDNS( 78,J,2),J=1,12) /
     $ 5.64135190D+03, 5.56813660D+03, 5.49511330D+03, 5.42228720D+03,
     $ 5.34966350D+03, 5.27724690D+03, 5.20504210D+03, 5.13305330D+03,
     $ 5.06128440D+03, 4.98973870D+03, 4.91841940D+03, 4.84732880D+03/
      data ( FDNS( 78,J,2),J=1,12) /
     $ 1.239D-10, 5.669D-10, 1.597D-09, 3.548D-09, 6.822D-09, 1.185D-08,
     $ 1.913D-08, 2.915D-08, 4.243D-08, 5.947D-08, 8.076D-08, 1.068D-07/
      data (WNUPS( 79,J,1),J=1,12) /
     $ 6.31032070D+03, 6.22829710D+03, 6.14647870D+03, 6.06487120D+03,
     $ 5.98348050D+03, 5.90231170D+03, 5.82136980D+03, 5.74065950D+03,
     $ 5.66018490D+03, 5.57994960D+03, 5.49995670D+03, 5.42020860D+03/
      data ( FUPS( 79,J,1),J=1,12) /
     $ 8.019D-10, 3.387D-09, 8.892D-09, 1.858D-08, 3.380D-08, 5.594D-08,
     $ 8.637D-08, 1.266D-07, 1.778D-07, 2.413D-07, 3.182D-07, 4.094D-07/
      data (WNDNS( 79,J,1),J=1,12) /
     $ 5.73504430D+03, 5.65855620D+03, 5.58227410D+03, 5.50620390D+03,
     $ 5.43035120D+03, 5.35472120D+03, 5.27931880D+03, 5.20414860D+03,
     $ 5.12921460D+03, 5.05452060D+03, 4.98006940D+03, 4.90586360D+03/
      data ( FDNS( 79,J,1),J=1,12) /
     $ 1.358D-10, 6.228D-10, 1.757D-09, 3.908D-09, 7.516D-09, 1.306D-08,
     $ 2.108D-08, 3.209D-08, 4.667D-08, 6.535D-08, 8.862D-08, 1.170D-07/
      data (WNUPS( 79,J,2),J=1,12) /
     $ 6.18157990D+03, 6.10322330D+03, 6.02505790D+03, 5.94708910D+03,
     $ 5.86932220D+03, 5.79176190D+03, 5.71441280D+03, 5.63727940D+03,
     $ 5.56036540D+03, 5.48367440D+03, 5.40720930D+03, 5.33097250D+03/
      data ( FUPS( 79,J,2),J=1,12) /
     $ 7.108D-10, 3.003D-09, 7.885D-09, 1.648D-08, 3.001D-08, 4.971D-08,
     $ 7.688D-08, 1.127D-07, 1.585D-07, 2.153D-07, 2.842D-07, 3.662D-07/
      data (WNDNS( 79,J,2),J=1,12) /
     $ 5.63042390D+03, 5.55724030D+03, 5.48424860D+03, 5.41145440D+03,
     $ 5.33886260D+03, 5.26647810D+03, 5.19430550D+03, 5.12234900D+03,
     $ 5.05061240D+03, 4.97909920D+03, 4.90781230D+03, 4.83675420D+03/
      data ( FDNS( 79,J,2),J=1,12) /
     $ 1.235D-10, 5.654D-10, 1.592D-09, 3.540D-09, 6.805D-09, 1.182D-08,
     $ 1.909D-08, 2.908D-08, 4.233D-08, 5.931D-08, 8.050D-08, 1.064D-07/
      data (WNUPS( 80,J,1),J=1,12) /
     $ 6.30530000D+03, 6.22323970D+03, 6.14138460D+03, 6.05974070D+03,
     $ 5.97831340D+03, 5.89710830D+03, 5.81613010D+03, 5.73538360D+03,
     $ 5.65487280D+03, 5.57460130D+03, 5.49457220D+03, 5.41478790D+03/
      data ( FUPS( 80,J,1),J=1,12) /
     $ 8.138D-10, 3.436D-09, 9.019D-09, 1.884D-08, 3.425D-08, 5.665D-08,
     $ 8.748D-08, 1.281D-07, 1.799D-07, 2.440D-07, 3.217D-07, 4.138D-07/
      data (WNDNS( 80,J,1),J=1,12) /
     $ 5.72335470D+03, 5.64690020D+03, 5.57065180D+03, 5.49461560D+03,
     $ 5.41879690D+03, 5.34320110D+03, 5.26783300D+03, 5.19269720D+03,
     $ 5.11779780D+03, 5.04313830D+03, 4.96872170D+03, 4.89455050D+03/
      data ( FDNS( 80,J,1),J=1,12) /
     $ 1.355D-10, 6.217D-10, 1.753D-09, 3.901D-09, 7.497D-09, 1.304D-08,
     $ 2.103D-08, 3.202D-08, 4.657D-08, 6.522D-08, 8.839D-08, 1.167D-07/
      data (WNUPS( 80,J,2),J=1,12) /
     $ 6.17697990D+03, 6.09858910D+03, 6.02038960D+03, 5.94238680D+03,
     $ 5.86458590D+03, 5.78699170D+03, 5.70960890D+03, 5.63244170D+03,
     $ 5.55549400D+03, 5.47876930D+03, 5.40227060D+03, 5.32600010D+03/
      data ( FUPS( 80,J,2),J=1,12) /
     $ 7.214D-10, 3.047D-09, 8.000D-09, 1.671D-08, 3.040D-08, 5.033D-08,
     $ 7.780D-08, 1.140D-07, 1.603D-07, 2.177D-07, 2.873D-07, 3.701D-07/
      data (WNDNS( 80,J,2),J=1,12) /
     $ 5.61940780D+03, 5.54625560D+03, 5.47329570D+03, 5.40053320D+03,
     $ 5.32797330D+03, 5.25562090D+03, 5.18348040D+03, 5.11155610D+03,
     $ 5.03985190D+03, 4.96837100D+03, 4.89711660D+03, 4.82609090D+03/
      data ( FDNS( 80,J,2),J=1,12) /
     $ 1.232D-10, 5.640D-10, 1.589D-09, 3.532D-09, 6.789D-09, 1.180D-08,
     $ 1.904D-08, 2.902D-08, 4.222D-08, 5.917D-08, 8.031D-08, 1.061D-07/
      data (WNUPS( 81,J,1),J=1,12) /
     $ 6.30016240D+03, 6.21806530D+03, 6.13617350D+03, 6.05449290D+03,
     $ 5.97302910D+03, 5.89178750D+03, 5.81077290D+03, 5.72999010D+03,
     $ 5.64944300D+03, 5.56913530D+03, 5.48906990D+03, 5.40924920D+03/
      data ( FUPS( 81,J,1),J=1,12) /
     $ 8.261D-10, 3.488D-09, 9.149D-09, 1.909D-08, 3.470D-08, 5.739D-08,
     $ 8.857D-08, 1.297D-07, 1.820D-07, 2.468D-07, 3.253D-07, 4.183D-07/
      data (WNDNS( 81,J,1),J=1,12) /
     $ 5.71157100D+03, 5.63515000D+03, 5.55893540D+03, 5.48293300D+03,
     $ 5.40714830D+03, 5.33158660D+03, 5.25625280D+03, 5.18115140D+03,
     $ 5.10628640D+03, 5.03166140D+03, 4.95727940D+03, 4.88314270D+03/
      data ( FDNS( 81,J,1),J=1,12) /
     $ 1.352D-10, 6.202D-10, 1.750D-09, 3.894D-09, 7.485D-09, 1.301D-08,
     $ 2.099D-08, 3.196D-08, 4.647D-08, 6.503D-08, 8.816D-08, 1.164D-07/
      data (WNUPS( 81,J,2),J=1,12) /
     $ 6.17227080D+03, 6.09384580D+03, 6.01561210D+03, 5.93757520D+03,
     $ 5.85974030D+03, 5.78211210D+03, 5.70469540D+03, 5.62749440D+03,
     $ 5.55051300D+03, 5.47375460D+03, 5.39722200D+03, 5.32091780D+03/
      data ( FUPS( 81,J,2),J=1,12) /
     $ 7.323D-10, 3.090D-09, 8.112D-09, 1.694D-08, 3.080D-08, 5.098D-08,
     $ 7.876D-08, 1.154D-07, 1.621D-07, 2.201D-07, 2.904D-07, 3.740D-07/
      data (WNDNS( 81,J,2),J=1,12) /
     $ 5.60830350D+03, 5.53518280D+03, 5.46225450D+03, 5.38952370D+03,
     $ 5.31699570D+03, 5.24467520D+03, 5.17256690D+03, 5.10067480D+03,
     $ 5.02900280D+03, 4.95755430D+03, 4.88633220D+03, 4.81533900D+03/
      data ( FDNS( 81,J,2),J=1,12) /
     $ 1.228D-10, 5.627D-10, 1.586D-09, 3.525D-09, 6.773D-09, 1.177D-08,
     $ 1.901D-08, 2.895D-08, 4.213D-08, 5.902D-08, 8.012D-08, 1.058D-07/
      data (WNUPS( 82,J,1),J=1,12) /
     $ 6.29490760D+03, 6.21277370D+03, 6.13084500D+03, 6.04912770D+03,
     $ 5.96762730D+03, 5.88634910D+03, 5.80529810D+03, 5.72447880D+03,
     $ 5.64389530D+03, 5.56355130D+03, 5.48344950D+03, 5.40359240D+03/
      data ( FUPS( 82,J,1),J=1,12) /
     $ 8.387D-10, 3.539D-09, 9.276D-09, 1.936D-08, 3.517D-08, 5.813D-08,
     $ 8.969D-08, 1.312D-07, 1.842D-07, 2.496D-07, 3.289D-07, 4.228D-07/
      data (WNDNS( 82,J,1),J=1,12) /
     $ 5.69969330D+03, 5.62330590D+03, 5.54712490D+03, 5.47115620D+03,
     $ 5.39540550D+03, 5.31987780D+03, 5.24457820D+03, 5.16951110D+03,
     $ 5.09468050D+03, 5.02009000D+03, 4.94574250D+03, 4.87164030D+03/
      data ( FDNS( 82,J,1),J=1,12) /
     $ 1.349D-10, 6.194D-10, 1.747D-09, 3.888D-09, 7.473D-09, 1.299D-08,
     $ 2.095D-08, 3.190D-08, 4.637D-08, 6.491D-08, 8.800D-08, 1.161D-07/
      data (WNUPS( 82,J,2),J=1,12) /
     $ 6.16745260D+03, 6.08899320D+03, 6.01072530D+03, 5.93265420D+03,
     $ 5.85478510D+03, 5.77712300D+03, 5.69967230D+03, 5.62243750D+03,
     $ 5.54542220D+03, 5.46862990D+03, 5.39206350D+03, 5.31572540D+03/
      data ( FUPS( 82,J,2),J=1,12) /
     $ 7.429D-10, 3.134D-09, 8.221D-09, 1.717D-08, 3.120D-08, 5.162D-08,
     $ 7.969D-08, 1.167D-07, 1.640D-07, 2.226D-07, 2.936D-07, 3.779D-07/
      data (WNDNS( 82,J,2),J=1,12) /
     $ 5.59711120D+03, 5.52402200D+03, 5.45112520D+03, 5.37842610D+03,
     $ 5.30592990D+03, 5.23364130D+03, 5.16156500D+03, 5.08970500D+03,
     $ 5.01806530D+03, 4.94664910D+03, 4.87545940D+03, 4.80449840D+03/
      data ( FDNS( 82,J,2),J=1,12) /
     $ 1.225D-10, 5.615D-10, 1.582D-09, 3.519D-09, 6.764D-09, 1.175D-08,
     $ 1.896D-08, 2.889D-08, 4.204D-08, 5.888D-08, 7.988D-08, 1.056D-07/
      data (WNUPS( 83,J,1),J=1,12) /
     $ 6.28953560D+03, 6.20736460D+03, 6.12539910D+03, 6.04364490D+03,
     $ 5.96210780D+03, 5.88079290D+03, 5.79970530D+03, 5.71884960D+03,
     $ 5.63822970D+03, 5.55784910D+03, 5.47771090D+03, 5.39781730D+03/
      data ( FUPS( 83,J,1),J=1,12) /
     $ 8.515D-10, 3.591D-09, 9.412D-09, 1.963D-08, 3.564D-08, 5.889D-08,
     $ 9.085D-08, 1.328D-07, 1.863D-07, 2.525D-07, 3.325D-07, 4.274D-07/
      data (WNDNS( 83,J,1),J=1,12) /
     $ 5.68772180D+03, 5.61136780D+03, 5.53522040D+03, 5.45928540D+03,
     $ 5.38356850D+03, 5.30807490D+03, 5.23280940D+03, 5.15777650D+03,
     $ 5.08298020D+03, 5.00842410D+03, 4.93411100D+03, 4.86004320D+03/
      data ( FDNS( 83,J,1),J=1,12) /
     $ 1.347D-10, 6.180D-10, 1.745D-09, 3.882D-09, 7.461D-09, 1.297D-08,
     $ 2.092D-08, 3.184D-08, 4.628D-08, 6.473D-08, 8.778D-08, 1.157D-07/
      data (WNUPS( 83,J,2),J=1,12) /
     $ 6.16252500D+03, 6.08403120D+03, 6.00572890D+03, 5.92762360D+03,
     $ 5.84972030D+03, 5.77202410D+03, 5.69453940D+03, 5.61727060D+03,
     $ 5.54022140D+03, 5.46339520D+03, 5.38679490D+03, 5.31042280D+03/
      data ( FUPS( 83,J,2),J=1,12) /
     $ 7.539D-10, 3.180D-09, 8.339D-09, 1.739D-08, 3.161D-08, 5.228D-08,
     $ 8.073D-08, 1.182D-07, 1.659D-07, 2.251D-07, 2.968D-07, 3.819D-07/
      data (WNDNS( 83,J,2),J=1,12) /
     $ 5.58583100D+03, 5.51277320D+03, 5.43990790D+03, 5.36724040D+03,
     $ 5.29477590D+03, 5.22251920D+03, 5.15047490D+03, 5.07864700D+03,
     $ 5.00703940D+03, 4.93565550D+03, 4.86449800D+03, 4.79356930D+03/
      data ( FDNS( 83,J,2),J=1,12) /
     $ 1.223D-10, 5.604D-10, 1.580D-09, 3.513D-09, 6.749D-09, 1.173D-08,
     $ 1.893D-08, 2.884D-08, 4.195D-08, 5.875D-08, 7.970D-08, 1.053D-07/
      data (WNUPS( 84,J,1),J=1,12) /
     $ 6.28404600D+03, 6.20183800D+03, 6.11983550D+03, 6.03804440D+03,
     $ 5.95647040D+03, 5.87511880D+03, 5.79399460D+03, 5.71310220D+03,
     $ 5.63244580D+03, 5.55202870D+03, 5.47185390D+03, 5.39192360D+03/
      data ( FUPS( 84,J,1),J=1,12) /
     $ 8.647D-10, 3.644D-09, 9.545D-09, 1.990D-08, 3.612D-08, 5.966D-08,
     $ 9.198D-08, 1.345D-07, 1.886D-07, 2.554D-07, 3.362D-07, 4.320D-07/
      data (WNDNS( 84,J,1),J=1,12) /
     $ 5.67565650D+03, 5.59933580D+03, 5.52322190D+03, 5.44732060D+03,
     $ 5.37163750D+03, 5.29617780D+03, 5.22094640D+03, 5.14594770D+03,
     $ 5.07118570D+03, 4.99666390D+03, 4.92238520D+03, 4.84835180D+03/
      data ( FDNS( 84,J,1),J=1,12) /
     $ 1.344D-10, 6.172D-10, 1.743D-09, 3.878D-09, 7.456D-09, 1.295D-08,
     $ 2.088D-08, 3.179D-08, 4.619D-08, 6.462D-08, 8.757D-08, 1.155D-07/
      data (WNUPS( 84,J,2),J=1,12) /
     $ 6.15748790D+03, 6.07895960D+03, 6.00062290D+03, 5.92248320D+03,
     $ 5.84454570D+03, 5.76681530D+03, 5.68929650D+03, 5.61199360D+03,
     $ 5.53491040D+03, 5.45805020D+03, 5.38141590D+03, 5.30500980D+03/
      data ( FUPS( 84,J,2),J=1,12) /
     $ 7.653D-10, 3.226D-09, 8.455D-09, 1.763D-08, 3.203D-08, 5.295D-08,
     $ 8.168D-08, 1.196D-07, 1.678D-07, 2.277D-07, 3.001D-07, 3.860D-07/
      data (WNDNS( 84,J,2),J=1,12) /
     $ 5.57446310D+03, 5.50143650D+03, 5.42860260D+03, 5.35596670D+03,
     $ 5.28353390D+03, 5.21130900D+03, 5.13929660D+03, 5.06750080D+03,
     $ 4.99592530D+03, 4.92457350D+03, 4.85344830D+03, 4.78255190D+03/
      data ( FDNS( 84,J,2),J=1,12) /
     $ 1.220D-10, 5.595D-10, 1.578D-09, 3.507D-09, 6.740D-09, 1.172D-08,
     $ 1.890D-08, 2.878D-08, 4.186D-08, 5.863D-08, 7.953D-08, 1.050D-07/
      data (WNUPS( 85,J,1),J=1,12) /
     $ 6.27843890D+03, 6.19619360D+03, 6.11415400D+03, 6.03232590D+03,
     $ 5.95071500D+03, 5.86932660D+03, 5.78816560D+03, 5.70723660D+03,
     $ 5.62654340D+03, 5.54608970D+03, 5.46587820D+03, 5.38591120D+03/
      data ( FUPS( 85,J,1),J=1,12) /
     $ 8.781D-10, 3.698D-09, 9.680D-09, 2.018D-08, 3.660D-08, 6.041D-08,
     $ 9.314D-08, 1.361D-07, 1.908D-07, 2.583D-07, 3.400D-07, 4.367D-07/
      data (WNDNS( 85,J,1),J=1,12) /
     $ 5.66349760D+03, 5.58721020D+03, 5.51112970D+03, 5.43526200D+03,
     $ 5.35961260D+03, 5.28418670D+03, 5.20898930D+03, 5.13402470D+03,
     $ 5.05929700D+03, 4.98480940D+03, 4.91056500D+03, 4.83656590D+03/
      data ( FDNS( 85,J,1),J=1,12) /
     $ 1.343D-10, 6.170D-10, 1.741D-09, 3.873D-09, 7.444D-09, 1.294D-08,
     $ 2.085D-08, 3.174D-08, 4.611D-08, 6.450D-08, 8.737D-08, 1.152D-07/
      data (WNUPS( 85,J,2),J=1,12) /
     $ 6.15234120D+03, 6.07377830D+03, 5.99540710D+03, 5.91723300D+03,
     $ 5.83926110D+03, 5.76149640D+03, 5.68394340D+03, 5.60660640D+03,
     $ 5.52948910D+03, 5.45259490D+03, 5.37592650D+03, 5.29948620D+03/
      data ( FUPS( 85,J,2),J=1,12) /
     $ 7.763D-10, 3.272D-09, 8.574D-09, 1.787D-08, 3.245D-08, 5.362D-08,
     $ 8.272D-08, 1.210D-07, 1.698D-07, 2.302D-07, 3.033D-07, 3.901D-07/
      data (WNDNS( 85,J,2),J=1,12) /
     $ 5.56300740D+03, 5.49001210D+03, 5.41720960D+03, 5.34460510D+03,
     $ 5.27220390D+03, 5.20001080D+03, 5.12803020D+03, 5.05626640D+03,
     $ 4.98472300D+03, 4.91340340D+03, 4.84231030D+03, 4.77144600D+03/
      data ( FDNS( 85,J,2),J=1,12) /
     $ 1.218D-10, 5.586D-10, 1.575D-09, 3.502D-09, 6.731D-09, 1.170D-08,
     $ 1.887D-08, 2.873D-08, 4.178D-08, 5.848D-08, 7.936D-08, 1.048D-07/
      data (WNUPS( 86,J,1),J=1,12) /
     $ 6.27271390D+03, 6.19043140D+03, 6.10835460D+03, 6.02648930D+03,
     $ 5.94484140D+03, 5.86341610D+03, 5.78221820D+03, 5.70125240D+03,
     $ 5.62052250D+03, 5.54003200D+03, 5.45978370D+03, 5.37977980D+03/
      data ( FUPS( 86,J,1),J=1,12) /
     $ 8.912D-10, 3.753D-09, 9.825D-09, 2.046D-08, 3.710D-08, 6.123D-08,
     $ 9.433D-08, 1.378D-07, 1.930D-07, 2.613D-07, 3.437D-07, 4.414D-07/
      data (WNDNS( 86,J,1),J=1,12) /
     $ 5.65124510D+03, 5.57499090D+03, 5.49894380D+03, 5.42310960D+03,
     $ 5.34749380D+03, 5.27210180D+03, 5.19693830D+03, 5.12200770D+03,
     $ 5.04731410D+03, 4.97286080D+03, 4.89865060D+03, 4.82468570D+03/
      data ( FDNS( 86,J,1),J=1,12) /
     $ 1.342D-10, 6.162D-10, 1.739D-09, 3.870D-09, 7.439D-09, 1.292D-08,
     $ 2.083D-08, 3.169D-08, 4.603D-08, 6.439D-08, 8.723D-08, 1.150D-07/
      data (WNUPS( 86,J,2),J=1,12) /
     $ 6.14708460D+03, 6.06848710D+03, 5.99008130D+03, 5.91187270D+03,
     $ 5.83386640D+03, 5.75606730D+03, 5.67848000D+03, 5.60110880D+03,
     $ 5.52395730D+03, 5.44702890D+03, 5.37032630D+03, 5.29385180D+03/
      data ( FUPS( 86,J,2),J=1,12) /
     $ 7.883D-10, 3.320D-09, 8.696D-09, 1.812D-08, 3.288D-08, 5.431D-08,
     $ 8.374D-08, 1.225D-07, 1.718D-07, 2.328D-07, 3.067D-07, 3.943D-07/
      data (WNDNS( 86,J,2),J=1,12) /
     $ 5.55146410D+03, 5.47850000D+03, 5.40572880D+03, 5.33315580D+03,
     $ 5.26078610D+03, 5.18862470D+03, 5.11667590D+03, 5.04494400D+03,
     $ 4.97343260D+03, 4.90214500D+03, 4.83108410D+03, 4.76025190D+03/
      data ( FDNS( 86,J,2),J=1,12) /
     $ 1.216D-10, 5.579D-10, 1.573D-09, 3.498D-09, 6.723D-09, 1.168D-08,
     $ 1.884D-08, 2.869D-08, 4.171D-08, 5.838D-08, 7.919D-08, 1.045D-07/
      data (WNUPS( 87,J,1),J=1,12) /
     $ 6.26687100D+03, 6.18455110D+03, 6.10243690D+03, 6.02053450D+03,
     $ 5.93884940D+03, 5.85738700D+03, 5.77615220D+03, 5.69514950D+03,
     $ 5.61438270D+03, 5.53385540D+03, 5.45357020D+03, 5.37352930D+03/
      data ( FUPS( 87,J,1),J=1,12) /
     $ 9.052D-10, 3.809D-09, 9.965D-09, 2.075D-08, 3.760D-08, 6.202D-08,
     $ 9.549D-08, 1.395D-07, 1.953D-07, 2.643D-07, 3.476D-07, 4.462D-07/
      data (WNDNS( 87,J,1),J=1,12) /
     $ 5.63889920D+03, 5.56267820D+03, 5.48666430D+03, 5.41086350D+03,
     $ 5.33528130D+03, 5.25992300D+03, 5.18479330D+03, 5.10989680D+03,
     $ 5.03523720D+03, 4.96081800D+03, 4.88664200D+03, 4.81271120D+03/
      data ( FDNS( 87,J,1),J=1,12) /
     $ 1.341D-10, 6.154D-10, 1.738D-09, 3.867D-09, 7.429D-09, 1.291D-08,
     $ 2.081D-08, 3.165D-08, 4.597D-08, 6.429D-08, 8.703D-08, 1.147D-07/
      data (WNUPS( 87,J,2),J=1,12) /
     $ 6.14171820D+03, 6.06308590D+03, 5.98464540D+03, 5.90640210D+03,
     $ 5.82836130D+03, 5.75052780D+03, 5.67290620D+03, 5.59550060D+03,
     $ 5.51831480D+03, 5.44135220D+03, 5.36461530D+03, 5.28810650D+03/
      data ( FUPS( 87,J,2),J=1,12) /
     $ 8.000D-10, 3.368D-09, 8.815D-09, 1.836D-08, 3.331D-08, 5.500D-08,
     $ 8.480D-08, 1.239D-07, 1.738D-07, 2.354D-07, 3.100D-07, 3.985D-07/
      data (WNDNS( 87,J,2),J=1,12) /
     $ 5.53983340D+03, 5.46690030D+03, 5.39416030D+03, 5.32161870D+03,
     $ 5.24928050D+03, 5.17715070D+03, 5.10523370D+03, 5.03353360D+03,
     $ 4.96205420D+03, 4.89079860D+03, 4.81976970D+03, 4.74896960D+03/
      data ( FDNS( 87,J,2),J=1,12) /
     $ 1.215D-10, 5.573D-10, 1.571D-09, 3.495D-09, 6.714D-09, 1.167D-08,
     $ 1.882D-08, 2.865D-08, 4.164D-08, 5.829D-08, 7.903D-08, 1.043D-07/
      data (WNUPS( 88,J,1),J=1,12) /
     $ 6.26090990D+03, 6.17855250D+03, 6.09640090D+03, 6.01446110D+03,
     $ 5.93273880D+03, 5.85123930D+03, 5.76996740D+03, 5.68892770D+03,
     $ 5.60812390D+03, 5.52755960D+03, 5.44723740D+03, 5.36715940D+03/
      data ( FUPS( 88,J,1),J=1,12) /
     $ 9.189D-10, 3.866D-09, 1.011D-08, 2.103D-08, 3.811D-08, 6.286D-08,
     $ 9.669D-08, 1.412D-07, 1.977D-07, 2.674D-07, 3.515D-07, 4.510D-07/
      data (WNDNS( 88,J,1),J=1,12) /
     $ 5.62646000D+03, 5.55027200D+03, 5.47429130D+03, 5.39852380D+03,
     $ 5.32297510D+03, 5.24765040D+03, 5.17255460D+03, 5.09769190D+03,
     $ 5.02306640D+03, 4.94868130D+03, 4.87453930D+03, 4.80064260D+03/
      data ( FDNS( 88,J,1),J=1,12) /
     $ 1.340D-10, 6.153D-10, 1.737D-09, 3.865D-09, 7.424D-09, 1.290D-08,
     $ 2.079D-08, 3.161D-08, 4.590D-08, 6.418D-08, 8.689D-08, 1.145D-07/
      data (WNUPS( 88,J,2),J=1,12) /
     $ 6.13624160D+03, 6.05757440D+03, 5.97909920D+03, 5.90082120D+03,
     $ 5.82274570D+03, 5.74487770D+03, 5.66722160D+03, 5.58978160D+03,
     $ 5.51256150D+03, 5.43556450D+03, 5.35879330D+03, 5.28225000D+03/
      data ( FUPS( 88,J,2),J=1,12) /
     $ 8.120D-10, 3.417D-09, 8.943D-09, 1.862D-08, 3.375D-08, 5.571D-08,
     $ 8.583D-08, 1.254D-07, 1.758D-07, 2.381D-07, 3.134D-07, 4.027D-07/
      data (WNDNS( 88,J,2),J=1,12) /
     $ 5.52811520D+03, 5.45521320D+03, 5.38250430D+03, 5.30999390D+03,
     $ 5.23768720D+03, 5.16558890D+03, 5.09370360D+03, 5.02203540D+03,
     $ 4.95058780D+03, 4.87936420D+03, 4.80836730D+03, 4.73759910D+03/
      data ( FDNS( 88,J,2),J=1,12) /
     $ 1.214D-10, 5.568D-10, 1.570D-09, 3.492D-09, 6.706D-09, 1.166D-08,
     $ 1.879D-08, 2.860D-08, 4.158D-08, 5.819D-08, 7.887D-08, 1.041D-07/
      data (WNUPS( 89,J,1),J=1,12) /
     $ 6.25483050D+03, 6.17243540D+03, 6.09024630D+03, 6.00826910D+03,
     $ 5.92650950D+03, 5.84497270D+03, 5.76366370D+03, 5.68258680D+03,
     $ 5.60174590D+03, 5.52114450D+03, 5.44078520D+03, 5.36067000D+03/
      data ( FUPS( 89,J,1),J=1,12) /
     $ 9.333D-10, 3.924D-09, 1.025D-08, 2.133D-08, 3.863D-08, 6.367D-08,
     $ 9.797D-08, 1.429D-07, 2.000D-07, 2.705D-07, 3.554D-07, 4.559D-07/
      data (WNDNS( 89,J,1),J=1,12) /
     $ 5.61392750D+03, 5.53777240D+03, 5.46182480D+03, 5.38609060D+03,
     $ 5.31057540D+03, 5.23528430D+03, 5.16022210D+03, 5.08539330D+03,
     $ 5.01080170D+03, 4.93645050D+03, 4.86234260D+03, 4.78847990D+03/
      data ( FDNS( 89,J,1),J=1,12) /
     $ 1.339D-10, 6.151D-10, 1.737D-09, 3.864D-09, 7.425D-09, 1.289D-08,
     $ 2.077D-08, 3.158D-08, 4.584D-08, 6.408D-08, 8.670D-08, 1.142D-07/
      data (WNUPS( 89,J,2),J=1,12) /
     $ 6.13065470D+03, 6.05195260D+03, 5.97344250D+03, 5.89512970D+03,
     $ 5.81701950D+03, 5.73911690D+03, 5.66142620D+03, 5.58395180D+03,
     $ 5.50669720D+03, 5.42966570D+03, 5.35286000D+03, 5.27628220D+03/
      data ( FUPS( 89,J,2),J=1,12) /
     $ 8.243D-10, 3.467D-09, 9.068D-09, 1.887D-08, 3.420D-08, 5.642D-08,
     $ 8.689D-08, 1.269D-07, 1.779D-07, 2.408D-07, 3.169D-07, 4.070D-07/
      data (WNDNS( 89,J,2),J=1,12) /
     $ 5.51630970D+03, 5.44343860D+03, 5.37076080D+03, 5.29828170D+03,
     $ 5.22600630D+03, 5.15393950D+03, 5.08208580D+03, 5.01044930D+03,
     $ 4.93903360D+03, 4.86784190D+03, 4.79687690D+03, 4.72614070D+03/
      data ( FDNS( 89,J,2),J=1,12) /
     $ 1.213D-10, 5.564D-10, 1.569D-09, 3.489D-09, 6.704D-09, 1.164D-08,
     $ 1.877D-08, 2.857D-08, 4.151D-08, 5.810D-08, 7.872D-08, 1.039D-07/
      data (WNUPS( 90,J,1),J=1,12) /
     $ 6.24863250D+03, 6.16619980D+03, 6.08397300D+03, 6.00195830D+03,
     $ 5.92016120D+03, 5.83858700D+03, 5.75724070D+03, 5.67612660D+03,
     $ 5.59524850D+03, 5.51460990D+03, 5.43421330D+03, 5.35406070D+03/
      data ( FUPS( 90,J,1),J=1,12) /
     $ 9.480D-10, 3.983D-09, 1.040D-08, 2.163D-08, 3.915D-08, 6.453D-08,
     $ 9.916D-08, 1.447D-07, 2.024D-07, 2.736D-07, 3.594D-07, 4.608D-07/
      data (WNDNS( 90,J,1),J=1,12) /
     $ 5.60130180D+03, 5.52517960D+03, 5.44926510D+03, 5.37356400D+03,
     $ 5.29808210D+03, 5.22282450D+03, 5.14779600D+03, 5.07300100D+03,
     $ 4.99844320D+03, 4.92412600D+03, 4.85005190D+03, 4.77622310D+03/
      data ( FDNS( 90,J,1),J=1,12) /
     $ 1.339D-10, 6.155D-10, 1.737D-09, 3.863D-09, 7.420D-09, 1.288D-08,
     $ 2.075D-08, 3.154D-08, 4.578D-08, 6.398D-08, 8.657D-08, 1.140D-07/
      data (WNUPS( 90,J,2),J=1,12) /
     $ 6.12495740D+03, 6.04622030D+03, 5.96767520D+03, 5.88932750D+03,
     $ 5.81118250D+03, 5.73324510D+03, 5.65551980D+03, 5.57801080D+03,
     $ 5.50072160D+03, 5.42365560D+03, 5.34681530D+03, 5.27020280D+03/
      data ( FUPS( 90,J,2),J=1,12) /
     $ 8.369D-10, 3.518D-09, 9.196D-09, 1.913D-08, 3.466D-08, 5.715D-08,
     $ 8.799D-08, 1.285D-07, 1.799D-07, 2.436D-07, 3.203D-07, 4.114D-07/
      data (WNDNS( 90,J,2),J=1,12) /
     $ 5.50441690D+03, 5.43157670D+03, 5.35892990D+03, 5.28648190D+03,
     $ 5.21423790D+03, 5.14220250D+03, 5.07038040D+03, 4.99877550D+03,
     $ 4.92739160D+03, 4.85623170D+03, 4.78529860D+03, 4.71459420D+03/
      data ( FDNS( 90,J,2),J=1,12) /
     $ 1.212D-10, 5.564D-10, 1.569D-09, 3.488D-09, 6.702D-09, 1.164D-08,
     $ 1.876D-08, 2.854D-08, 4.146D-08, 5.801D-08, 7.856D-08, 1.036D-07/
      data (WNUPS( 91,J,1),J=1,12) /
     $ 6.24231600D+03, 6.15984530D+03, 6.07758080D+03, 5.99552840D+03,
     $ 5.91369370D+03, 5.83208210D+03, 5.75069830D+03, 5.66954690D+03,
     $ 5.58863150D+03, 5.50795560D+03, 5.42752160D+03, 5.34733150D+03/
      data ( FUPS( 91,J,1),J=1,12) /
     $ 9.624D-10, 4.043D-09, 1.055D-08, 2.193D-08, 3.969D-08, 6.536D-08,
     $ 1.004D-07, 1.465D-07, 2.048D-07, 2.767D-07, 3.634D-07, 4.659D-07/
      data (WNDNS( 91,J,1),J=1,12) /
     $ 5.58858320D+03, 5.51249370D+03, 5.43661210D+03, 5.36094410D+03,
     $ 5.28549550D+03, 5.21027130D+03, 5.13527630D+03, 5.06051500D+03,
     $ 4.98599100D+03, 4.91170760D+03, 4.83766740D+03, 4.76387240D+03/
      data ( FDNS( 91,J,1),J=1,12) /
     $ 1.339D-10, 6.153D-10, 1.737D-09, 3.863D-09, 7.421D-09, 1.287D-08,
     $ 2.074D-08, 3.152D-08, 4.573D-08, 6.388D-08, 8.645D-08, 1.138D-07/
      data (WNUPS( 91,J,2),J=1,12) /
     $ 6.11914960D+03, 6.04037730D+03, 5.96179710D+03, 5.88341440D+03,
     $ 5.80523450D+03, 5.72726230D+03, 5.64950220D+03, 5.57195850D+03,
     $ 5.49463470D+03, 5.41753400D+03, 5.34065900D+03, 5.26401180D+03/
      data ( FUPS( 91,J,2),J=1,12) /
     $ 8.492D-10, 3.570D-09, 9.326D-09, 1.939D-08, 3.512D-08, 5.790D-08,
     $ 8.906D-08, 1.301D-07, 1.820D-07, 2.463D-07, 3.239D-07, 4.158D-07/
      data (WNDNS( 91,J,2),J=1,12) /
     $ 5.49243710D+03, 5.41962760D+03, 5.34701180D+03, 5.27459480D+03,
     $ 5.20238200D+03, 5.13037800D+03, 5.05858740D+03, 4.98701410D+03,
     $ 4.91566180D+03, 4.84453370D+03, 4.77363240D+03, 4.70295980D+03/
      data ( FDNS( 91,J,2),J=1,12) /
     $ 1.212D-10, 5.563D-10, 1.568D-09, 3.486D-09, 6.694D-09, 1.163D-08,
     $ 1.874D-08, 2.851D-08, 4.141D-08, 5.792D-08, 7.847D-08, 1.034D-07/
      data (WNUPS( 92,J,1),J=1,12) /
     $ 6.23588050D+03, 6.15337190D+03, 6.07106950D+03, 5.98897930D+03,
     $ 5.90710690D+03, 5.82545770D+03, 5.74403640D+03, 5.66284750D+03,
     $ 5.58189470D+03, 5.50118120D+03, 5.42070980D+03, 5.34048210D+03/
      data ( FUPS( 92,J,1),J=1,12) /
     $ 9.776D-10, 4.103D-09, 1.071D-08, 2.224D-08, 4.022D-08, 6.623D-08,
     $ 1.017D-07, 1.483D-07, 2.073D-07, 2.799D-07, 3.675D-07, 4.709D-07/
      data (WNDNS( 92,J,1),J=1,12) /
     $ 5.57577150D+03, 5.49971470D+03, 5.42386590D+03, 5.34823100D+03,
     $ 5.27281550D+03, 5.19762470D+03, 5.12266320D+03, 5.04793540D+03,
     $ 4.97344510D+03, 4.89919550D+03, 4.82518910D+03, 4.75142780D+03/
      data ( FDNS( 92,J,1),J=1,12) /
     $ 1.340D-10, 6.157D-10, 1.738D-09, 3.864D-09, 7.416D-09, 1.288D-08,
     $ 2.073D-08, 3.149D-08, 4.569D-08, 6.378D-08, 8.632D-08, 1.136D-07/
      data (WNUPS( 92,J,2),J=1,12) /
     $ 6.11323100D+03, 6.03442340D+03, 5.95580800D+03, 5.87739020D+03,
     $ 5.79917540D+03, 5.72116820D+03, 5.64337330D+03, 5.56579470D+03,
     $ 5.48843610D+03, 5.41130070D+03, 5.33439090D+03, 5.25770880D+03/
      data ( FUPS( 92,J,2),J=1,12) /
     $ 8.623D-10, 3.622D-09, 9.459D-09, 1.966D-08, 3.558D-08, 5.863D-08,
     $ 9.022D-08, 1.316D-07, 1.842D-07, 2.491D-07, 3.275D-07, 4.202D-07/
      data (WNDNS( 92,J,2),J=1,12) /
     $ 5.48037010D+03, 5.40759140D+03, 5.33500640D+03, 5.26262040D+03,
     $ 5.19043870D+03, 5.11846600D+03, 5.04670680D+03, 4.97516510D+03,
     $ 4.90384450D+03, 4.83274800D+03, 4.76187840D+03, 4.69123750D+03/
      data ( FDNS( 92,J,2),J=1,12) /
     $ 1.212D-10, 5.562D-10, 1.568D-09, 3.486D-09, 6.692D-09, 1.162D-08,
     $ 1.872D-08, 2.848D-08, 4.136D-08, 5.784D-08, 7.832D-08, 1.032D-07/
      data (WNUPS( 93,J,1),J=1,12) /
     $ 6.22932610D+03, 6.14677940D+03, 6.06443890D+03, 5.98231080D+03,
     $ 5.90040060D+03, 5.81871360D+03, 5.73725470D+03, 5.65602820D+03,
     $ 5.57503780D+03, 5.49428680D+03, 5.41377770D+03, 5.33351220D+03/
      data ( FUPS( 93,J,1),J=1,12) /
     $ 9.924D-10, 4.165D-09, 1.086D-08, 2.256D-08, 4.077D-08, 6.708D-08,
     $ 1.030D-07, 1.501D-07, 2.097D-07, 2.832D-07, 3.716D-07, 4.761D-07/
      data (WNDNS( 93,J,1),J=1,12) /
     $ 5.56286700D+03, 5.48684280D+03, 5.41102670D+03, 5.33542470D+03,
     $ 5.26004230D+03, 5.18488470D+03, 5.10995660D+03, 5.03526240D+03,
     $ 4.96080570D+03, 4.88658970D+03, 4.81261700D+03, 4.73888940D+03/
      data ( FDNS( 93,J,1),J=1,12) /
     $ 1.341D-10, 6.160D-10, 1.739D-09, 3.865D-09, 7.422D-09, 1.287D-08,
     $ 2.072D-08, 3.148D-08, 4.565D-08, 6.374D-08, 8.620D-08, 1.134D-07/
      data (WNUPS( 93,J,2),J=1,12) /
     $ 6.10720150D+03, 6.02835860D+03, 5.94970780D+03, 5.87125490D+03,
     $ 5.79300490D+03, 5.71496270D+03, 5.63713280D+03, 5.55951930D+03,
     $ 5.48212580D+03, 5.40495550D+03, 5.32801080D+03, 5.25129370D+03/
      data ( FUPS( 93,J,2),J=1,12) /
     $ 8.757D-10, 3.675D-09, 9.595D-09, 1.993D-08, 3.606D-08, 5.941D-08,
     $ 9.130D-08, 1.332D-07, 1.864D-07, 2.519D-07, 3.311D-07, 4.248D-07/
      data (WNDNS( 93,J,2),J=1,12) /
     $ 5.46821620D+03, 5.39546810D+03, 5.32291390D+03, 5.25055880D+03,
     $ 5.17840820D+03, 5.10646670D+03, 5.03473890D+03, 4.96322860D+03,
     $ 4.89193950D+03, 4.82087470D+03, 4.75003670D+03, 4.67942740D+03/
      data ( FDNS( 93,J,2),J=1,12) /
     $ 1.212D-10, 5.561D-10, 1.568D-09, 3.486D-09, 6.695D-09, 1.162D-08,
     $ 1.872D-08, 2.846D-08, 4.132D-08, 5.775D-08, 7.818D-08, 1.031D-07/
      data (WNUPS( 94,J,1),J=1,12) /
     $ 6.22265240D+03, 6.14006750D+03, 6.05768890D+03, 5.97552270D+03,
     $ 5.89357450D+03, 5.81184970D+03, 5.73035300D+03, 5.64908880D+03,
     $ 5.56806070D+03, 5.48727190D+03, 5.40672500D+03, 5.32642170D+03/
      data ( FUPS( 94,J,1),J=1,12) /
     $ 1.008D-09, 4.228D-09, 1.102D-08, 2.287D-08, 4.133D-08, 6.797D-08,
     $ 1.043D-07, 1.520D-07, 2.122D-07, 2.865D-07, 3.758D-07, 4.813D-07/
      data (WNDNS( 94,J,1),J=1,12) /
     $ 5.54986970D+03, 5.47387800D+03, 5.39809450D+03, 5.32252530D+03,
     $ 5.24717590D+03, 5.17205150D+03, 5.09715670D+03, 5.02249590D+03,
     $ 4.94807280D+03, 4.87389040D+03, 4.79995130D+03, 4.72625720D+03/
      data ( FDNS( 94,J,1),J=1,12) /
     $ 1.342D-10, 6.169D-10, 1.740D-09, 3.868D-09, 7.423D-09, 1.287D-08,
     $ 2.071D-08, 3.146D-08, 4.561D-08, 6.365D-08, 8.608D-08, 1.132D-07/
      data (WNUPS( 94,J,2),J=1,12) /
     $ 6.10106100D+03, 6.02218250D+03, 5.94349640D+03, 5.86500810D+03,
     $ 5.78672290D+03, 5.70864550D+03, 5.63078060D+03, 5.55313210D+03,
     $ 5.47570360D+03, 5.39849830D+03, 5.32151860D+03, 5.24476630D+03/
      data ( FUPS( 94,J,2),J=1,12) /
     $ 8.888D-10, 3.729D-09, 9.733D-09, 2.020D-08, 3.655D-08, 6.016D-08,
     $ 9.246D-08, 1.348D-07, 1.886D-07, 2.548D-07, 3.348D-07, 4.293D-07/
      data (WNDNS( 94,J,2),J=1,12) /
     $ 5.45597540D+03, 5.38325790D+03, 5.31073430D+03, 5.23841010D+03,
     $ 5.16629040D+03, 5.09438010D+03, 5.02268350D+03, 4.95120470D+03,
     $ 4.87994710D+03, 4.80891380D+03, 4.73810740D+03, 4.66752960D+03/
      data ( FDNS( 94,J,2),J=1,12) /
     $ 1.213D-10, 5.566D-10, 1.569D-09, 3.487D-09, 6.693D-09, 1.161D-08,
     $ 1.871D-08, 2.844D-08, 4.128D-08, 5.767D-08, 7.810D-08, 1.029D-07/
      data (WNUPS( 95,J,1),J=1,12) /
     $ 6.21585940D+03, 6.13323600D+03, 6.05081910D+03, 5.96861480D+03,
     $ 5.88662860D+03, 5.80486580D+03, 5.72333120D+03, 5.64202900D+03,
     $ 5.56096310D+03, 5.48013650D+03, 5.39955170D+03, 5.31921030D+03/
      data ( FUPS( 95,J,1),J=1,12) /
     $ 1.024D-09, 4.293D-09, 1.119D-08, 2.320D-08, 4.189D-08, 6.889D-08,
     $ 1.057D-07, 1.538D-07, 2.148D-07, 2.898D-07, 3.801D-07, 4.865D-07/
      data (WNDNS( 95,J,1),J=1,12) /
     $ 5.53677970D+03, 5.46082030D+03, 5.38506950D+03, 5.30953300D+03,
     $ 5.23421650D+03, 5.15912510D+03, 5.08426360D+03, 5.00963610D+03,
     $ 4.93524640D+03, 4.86109750D+03, 4.78719190D+03, 4.71353130D+03/
      data ( FDNS( 95,J,1),J=1,12) /
     $ 1.344D-10, 6.173D-10, 1.742D-09, 3.871D-09, 7.424D-09, 1.287D-08,
     $ 2.072D-08, 3.145D-08, 4.558D-08, 6.361D-08, 8.597D-08, 1.131D-07/
      data (WNUPS( 95,J,2),J=1,12) /
     $ 6.09480920D+03, 6.01589510D+03, 5.93717350D+03, 5.85864980D+03,
     $ 5.78032920D+03, 5.70221660D+03, 5.62431640D+03, 5.54663280D+03,
     $ 5.46916920D+03, 5.39192880D+03, 5.31491390D+03, 5.23812650D+03/
      data ( FUPS( 95,J,2),J=1,12) /
     $ 9.021D-10, 3.785D-09, 9.868D-09, 2.049D-08, 3.703D-08, 6.095D-08,
     $ 9.360D-08, 1.365D-07, 1.907D-07, 2.577D-07, 3.384D-07, 4.339D-07/
      data (WNDNS( 95,J,2),J=1,12) /
     $ 5.44364780D+03, 5.37096070D+03, 5.29846770D+03, 5.22617430D+03,
     $ 5.15408560D+03, 5.08220630D+03, 5.01054090D+03, 4.93909330D+03,
     $ 4.86786720D+03, 4.79686540D+03, 4.72609040D+03, 4.65554420D+03/
      data ( FDNS( 95,J,2),J=1,12) /
     $ 1.214D-10, 5.571D-10, 1.570D-09, 3.488D-09, 6.696D-09, 1.162D-08,
     $ 1.870D-08, 2.842D-08, 4.125D-08, 5.764D-08, 7.801D-08, 1.028D-07/
      data (WNUPS( 96,J,1),J=1,12) /
     $ 6.20894670D+03, 6.12628490D+03, 6.04382960D+03, 5.96158690D+03,
     $ 5.87956250D+03, 5.79776160D+03, 5.71618890D+03, 5.63484880D+03,
     $ 5.55374490D+03, 5.47288030D+03, 5.39225740D+03, 5.31187770D+03/
      data ( FUPS( 96,J,1),J=1,12) /
     $ 1.040D-09, 4.358D-09, 1.135D-08, 2.352D-08, 4.247D-08, 6.979D-08,
     $ 1.070D-07, 1.558D-07, 2.173D-07, 2.931D-07, 3.843D-07, 4.918D-07/
      data (WNDNS( 96,J,1),J=1,12) /
     $ 5.52359710D+03, 5.44767000D+03, 5.37195160D+03, 5.29644770D+03,
     $ 5.22116400D+03, 5.14610570D+03, 5.07127730D+03, 4.99668300D+03,
     $ 4.92232670D+03, 4.84821120D+03, 4.77433900D+03, 4.70071180D+03/
      data ( FDNS( 96,J,1),J=1,12) /
     $ 1.346D-10, 6.181D-10, 1.744D-09, 3.874D-09, 7.430D-09, 1.288D-08,
     $ 2.072D-08, 3.144D-08, 4.556D-08, 6.352D-08, 8.585D-08, 1.129D-07/
      data (WNUPS( 96,J,2),J=1,12) /
     $ 6.08844610D+03, 6.00949630D+03, 5.93073900D+03, 5.85217970D+03,
     $ 5.77382360D+03, 5.69567560D+03, 5.61774020D+03, 5.54002130D+03,
     $ 5.46252250D+03, 5.38524690D+03, 5.30819670D+03, 5.23137390D+03/
      data ( FUPS( 96,J,2),J=1,12) /
     $ 9.162D-10, 3.841D-09, 1.001D-08, 2.077D-08, 3.753D-08, 6.173D-08,
     $ 9.482D-08, 1.381D-07, 1.930D-07, 2.607D-07, 3.422D-07, 4.385D-07/
      data (WNDNS( 96,J,2),J=1,12) /
     $ 5.43123350D+03, 5.35857670D+03, 5.28611430D+03, 5.21385150D+03,
     $ 5.14179360D+03, 5.06994530D+03, 4.99831110D+03, 4.92689470D+03,
     $ 4.85569990D+03, 4.78472950D+03, 4.71398600D+03, 4.64347110D+03/
      data ( FDNS( 96,J,2),J=1,12) /
     $ 1.215D-10, 5.575D-10, 1.571D-09, 3.490D-09, 6.699D-09, 1.162D-08,
     $ 1.870D-08, 2.841D-08, 4.122D-08, 5.756D-08, 7.788D-08, 1.026D-07/
      data (WNUPS( 97,J,1),J=1,12) /
     $ 6.20191430D+03, 6.11921380D+03, 6.03672000D+03, 5.95443880D+03,
     $ 5.87237610D+03, 5.79053690D+03, 5.70892600D+03, 5.62754780D+03,
     $ 5.54640570D+03, 5.46550300D+03, 5.38484190D+03, 5.30442390D+03/
      data ( FUPS( 97,J,1),J=1,12) /
     $ 1.056D-09, 4.424D-09, 1.152D-08, 2.386D-08, 4.305D-08, 7.067D-08,
     $ 1.084D-07, 1.577D-07, 2.199D-07, 2.965D-07, 3.887D-07, 4.972D-07/
      data (WNDNS( 97,J,1),J=1,12) /
     $ 5.51032190D+03, 5.43442700D+03, 5.35874090D+03, 5.28326960D+03,
     $ 5.20801870D+03, 5.13299320D+03, 5.05819780D+03, 4.98363680D+03,
     $ 4.90931360D+03, 4.83523150D+03, 4.76139260D+03, 4.68779870D+03/
      data ( FDNS( 97,J,1),J=1,12) /
     $ 1.349D-10, 6.195D-10, 1.746D-09, 3.878D-09, 7.436D-09, 1.289D-08,
     $ 2.072D-08, 3.144D-08, 4.554D-08, 6.349D-08, 8.579D-08, 1.128D-07/
      data (WNUPS( 97,J,2),J=1,12) /
     $ 6.08197140D+03, 6.00298570D+03, 5.92419260D+03, 5.84559770D+03,
     $ 5.76720600D+03, 5.68902260D+03, 5.61105170D+03, 5.53329740D+03,
     $ 5.45576330D+03, 5.37845230D+03, 5.30136670D+03, 5.22450840D+03/
      data ( FUPS( 97,J,2),J=1,12) /
     $ 9.301D-10, 3.898D-09, 1.016D-08, 2.106D-08, 3.804D-08, 6.254D-08,
     $ 9.601D-08, 1.398D-07, 1.953D-07, 2.636D-07, 3.460D-07, 4.433D-07/
      data (WNDNS( 97,J,2),J=1,12) /
     $ 5.41873250D+03, 5.34610610D+03, 5.27367400D+03, 5.20144180D+03,
     $ 5.12941470D+03, 5.05759730D+03, 4.98599400D+03, 4.91460890D+03,
     $ 4.84344530D+03, 4.77250620D+03, 4.70179400D+03, 4.63131050D+03/
      data ( FDNS( 97,J,2),J=1,12) /
     $ 1.216D-10, 5.579D-10, 1.573D-09, 3.493D-09, 6.703D-09, 1.162D-08,
     $ 1.870D-08, 2.841D-08, 4.119D-08, 5.754D-08, 7.779D-08, 1.025D-07/
      data (WNUPS( 98,J,1),J=1,12) /
     $ 6.19476200D+03, 6.11202270D+03, 6.02949010D+03, 5.94717040D+03,
     $ 5.86506910D+03, 5.78319150D+03, 5.70154240D+03, 5.62012580D+03,
     $ 5.53894550D+03, 5.45800450D+03, 5.37730500D+03, 5.29684850D+03/
      data ( FUPS( 98,J,1),J=1,12) /
     $ 1.073D-09, 4.491D-09, 1.169D-08, 2.420D-08, 4.364D-08, 7.164D-08,
     $ 1.098D-07, 1.596D-07, 2.226D-07, 3.000D-07, 3.930D-07, 5.026D-07/
      data (WNDNS( 98,J,1),J=1,12) /
     $ 5.49695440D+03, 5.42109150D+03, 5.34543760D+03, 5.26999880D+03,
     $ 5.19478040D+03, 5.11978770D+03, 5.04502530D+03, 4.97049730D+03,
     $ 4.89620740D+03, 4.82215840D+03, 4.74835280D+03, 4.67479200D+03/
      data ( FDNS( 98,J,1),J=1,12) /
     $ 1.351D-10, 6.203D-10, 1.749D-09, 3.884D-09, 7.447D-09, 1.290D-08,
     $ 2.073D-08, 3.144D-08, 4.552D-08, 6.345D-08, 8.569D-08, 1.126D-07/
      data (WNUPS( 98,J,2),J=1,12) /
     $ 6.07538490D+03, 5.99636330D+03, 5.91753430D+03, 5.83890360D+03,
     $ 5.76047620D+03, 5.68225710D+03, 5.60425070D+03, 5.52646100D+03,
     $ 5.44889140D+03, 5.37154490D+03, 5.29442380D+03, 5.21752980D+03/
      data ( FUPS( 98,J,2),J=1,12) /
     $ 9.446D-10, 3.956D-09, 1.030D-08, 2.135D-08, 3.854D-08, 6.333D-08,
     $ 9.718D-08, 1.415D-07, 1.976D-07, 2.667D-07, 3.498D-07, 4.480D-07/
      data (WNDNS( 98,J,2),J=1,12) /
     $ 5.40614500D+03, 5.33354870D+03, 5.26114700D+03, 5.18894530D+03,
     $ 5.11694880D+03, 5.04516220D+03, 4.97359000D+03, 4.90223590D+03,
     $ 4.83110350D+03, 4.76019560D+03, 4.68951470D+03, 4.61906230D+03/
      data ( FDNS( 98,J,2),J=1,12) /
     $ 1.218D-10, 5.589D-10, 1.575D-09, 3.496D-09, 6.706D-09, 1.162D-08,
     $ 1.870D-08, 2.840D-08, 4.118D-08, 5.746D-08, 7.772D-08, 1.023D-07/
      data (WNUPS( 99,J,1),J=1,12) /
     $ 6.18748950D+03, 6.10471120D+03, 6.02213980D+03, 5.93978140D+03,
     $ 5.85764150D+03, 5.77572530D+03, 5.69403770D+03, 5.61258270D+03,
     $ 5.53136400D+03, 5.45038450D+03, 5.36964640D+03, 5.28915130D+03/
      data ( FUPS( 99,J,1),J=1,12) /
     $ 1.090D-09, 4.559D-09, 1.186D-08, 2.454D-08, 4.424D-08, 7.259D-08,
     $ 1.112D-07, 1.616D-07, 2.253D-07, 3.035D-07, 3.974D-07, 5.081D-07/
      data (WNDNS( 99,J,1),J=1,12) /
     $ 5.48349440D+03, 5.40766350D+03, 5.33204180D+03, 5.25663520D+03,
     $ 5.18144940D+03, 5.10648930D+03, 5.03175980D+03, 4.95726480D+03,
     $ 4.88300790D+03, 4.80899210D+03, 4.73521960D+03, 4.66169190D+03/
      data ( FDNS( 99,J,1),J=1,12) /
     $ 1.355D-10, 6.216D-10, 1.752D-09, 3.890D-09, 7.452D-09, 1.290D-08,
     $ 2.074D-08, 3.144D-08, 4.551D-08, 6.342D-08, 8.563D-08, 1.125D-07/
      data (WNUPS( 99,J,2),J=1,12) /
     $ 6.06868660D+03, 5.98962880D+03, 5.91076390D+03, 5.83209720D+03,
     $ 5.75363400D+03, 5.67537920D+03, 5.59733710D+03, 5.51951170D+03,
     $ 5.44190650D+03, 5.36452440D+03, 5.28736760D+03, 5.21043790D+03/
      data ( FUPS( 99,J,2),J=1,12) /
     $ 9.589D-10, 4.015D-09, 1.045D-08, 2.165D-08, 3.907D-08, 6.416D-08,
     $ 9.843D-08, 1.432D-07, 1.999D-07, 2.697D-07, 3.537D-07, 4.528D-07/
      data (WNDNS( 99,J,2),J=1,12) /
     $ 5.39347100D+03, 5.32090480D+03, 5.24853330D+03, 5.17636200D+03,
     $ 5.10439610D+03, 5.03264020D+03, 4.96109880D+03, 4.88977580D+03,
     $ 4.81867440D+03, 4.74779770D+03, 4.67714790D+03, 4.60672670D+03/
      data ( FDNS( 99,J,2),J=1,12) /
     $ 1.220D-10, 5.598D-10, 1.577D-09, 3.501D-09, 6.714D-09, 1.163D-08,
     $ 1.871D-08, 2.840D-08, 4.116D-08, 5.744D-08, 7.764D-08, 1.022D-07/
      data (WNUPS(100,J,1),J=1,12) /
     $ 6.18009670D+03, 6.09727930D+03, 6.01466890D+03, 5.93227150D+03,
     $ 5.85009280D+03, 5.76813800D+03, 5.68641170D+03, 5.60491820D+03,
     $ 5.52366090D+03, 5.44264280D+03, 5.36186610D+03, 5.28133200D+03/
      data ( FUPS(100,J,1),J=1,12) /
     $ 1.107D-09, 4.629D-09, 1.203D-08, 2.489D-08, 4.485D-08, 7.357D-08,
     $ 1.126D-07, 1.636D-07, 2.280D-07, 3.070D-07, 4.019D-07, 5.136D-07/
      data (WNDNS(100,J,1),J=1,12) /
     $ 5.46994220D+03, 5.39414310D+03, 5.31855340D+03, 5.24317900D+03,
     $ 5.16802560D+03, 5.09309820D+03, 5.01840130D+03, 4.94393920D+03,
     $ 4.86971530D+03, 4.79573250D+03, 4.72199300D+03, 4.64849830D+03/
      data ( FDNS(100,J,1),J=1,12) /
     $ 1.358D-10, 6.234D-10, 1.756D-09, 3.897D-09, 7.463D-09, 1.292D-08,
     $ 2.075D-08, 3.145D-08, 4.551D-08, 6.338D-08, 8.557D-08, 1.124D-07/
      data (WNUPS(100,J,2),J=1,12) /
     $ 6.06187620D+03, 5.98278220D+03, 5.90388110D+03, 5.82517830D+03,
     $ 5.74667920D+03, 5.66838850D+03, 5.59031060D+03, 5.51244950D+03,
     $ 5.43480860D+03, 5.35739070D+03, 5.28019810D+03, 5.20323240D+03/
      data ( FUPS(100,J,2),J=1,12) /
     $ 9.739D-10, 4.074D-09, 1.060D-08, 2.195D-08, 3.959D-08, 6.503D-08,
     $ 9.965D-08, 1.450D-07, 2.023D-07, 2.728D-07, 3.576D-07, 4.577D-07/
      data (WNDNS(100,J,2),J=1,12) /
     $ 5.38071060D+03, 5.30817430D+03, 5.23583290D+03, 5.16369200D+03,
     $ 5.09175660D+03, 5.02003140D+03, 4.94852080D+03, 4.87722860D+03,
     $ 4.80615820D+03, 4.73531260D+03, 4.66469390D+03, 4.59430370D+03/
      data ( FDNS(100,J,2),J=1,12) /
     $ 1.223D-10, 5.607D-10, 1.579D-09, 3.505D-09, 6.716D-09, 1.164D-08,
     $ 1.872D-08, 2.840D-08, 4.115D-08, 5.741D-08, 7.761D-08, 1.021D-07/
      data (WNUPS(101,J,1),J=1,12) /
     $ 6.17258340D+03, 6.08972670D+03, 6.00707720D+03, 5.92464070D+03,
     $ 5.84242310D+03, 5.76042940D+03, 5.67866440D+03, 5.59713210D+03,
     $ 5.51583610D+03, 5.43477920D+03, 5.35396360D+03, 5.27339050D+03/
      data ( FUPS(101,J,1),J=1,12) /
     $ 1.125D-09, 4.700D-09, 1.221D-08, 2.525D-08, 4.547D-08, 7.453D-08,
     $ 1.141D-07, 1.657D-07, 2.307D-07, 3.106D-07, 4.064D-07, 5.194D-07/
      data (WNDNS(101,J,1),J=1,12) /
     $ 5.45629770D+03, 5.38053030D+03, 5.30497250D+03, 5.22963030D+03,
     $ 5.15450920D+03, 5.07961420D+03, 5.00495000D+03, 4.93052070D+03,
     $ 4.85632970D+03, 4.78237980D+03, 4.70867320D+03, 4.63521130D+03/
      data ( FDNS(101,J,1),J=1,12) /
     $ 1.362D-10, 6.251D-10, 1.760D-09, 3.904D-09, 7.473D-09, 1.294D-08,
     $ 2.077D-08, 3.146D-08, 4.551D-08, 6.340D-08, 8.552D-08, 1.123D-07/
      data (WNUPS(101,J,2),J=1,12) /
     $ 6.05495360D+03, 5.97582320D+03, 5.89688580D+03, 5.81814690D+03,
     $ 5.73961170D+03, 5.66128490D+03, 5.58317110D+03, 5.50527410D+03,
     $ 5.42759730D+03, 5.35014350D+03, 5.27291500D+03, 5.19591330D+03/
      data ( FUPS(101,J,2),J=1,12) /
     $ 9.891D-10, 4.135D-09, 1.075D-08, 2.225D-08, 4.012D-08, 6.587D-08,
     $ 1.009D-07, 1.468D-07, 2.047D-07, 2.759D-07, 3.616D-07, 4.626D-07/
      data (WNDNS(101,J,2),J=1,12) /
     $ 5.36786390D+03, 5.29535740D+03, 5.22304610D+03, 5.15093540D+03,
     $ 5.07903030D+03, 5.00733570D+03, 4.93585580D+03, 4.86459440D+03,
     $ 4.79355500D+03, 4.72274030D+03, 4.65215260D+03, 4.58179340D+03/
      data ( FDNS(101,J,2),J=1,12) /
     $ 1.226D-10, 5.621D-10, 1.582D-09, 3.510D-09, 6.724D-09, 1.165D-08,
     $ 1.872D-08, 2.840D-08, 4.115D-08, 5.739D-08, 7.754D-08, 1.020D-07/
      data (WNUPS(102,J,1),J=1,12) /
     $ 6.16494940D+03, 6.08205330D+03, 5.99936440D+03, 5.91688870D+03,
     $ 5.83463200D+03, 5.75259930D+03, 5.67079530D+03, 5.58922410D+03,
     $ 5.50788920D+03, 5.42679340D+03, 5.34593870D+03, 5.26532650D+03/
      data ( FUPS(102,J,1),J=1,12) /
     $ 1.142D-09, 4.772D-09, 1.239D-08, 2.561D-08, 4.609D-08, 7.552D-08,
     $ 1.155D-07, 1.677D-07, 2.335D-07, 3.142D-07, 4.110D-07, 5.251D-07/
      data (WNDNS(102,J,1),J=1,12) /
     $ 5.44256110D+03, 5.36682530D+03, 5.29129930D+03, 5.21598910D+03,
     $ 5.14090010D+03, 5.06603760D+03, 4.99140590D+03, 4.91700920D+03,
     $ 4.84285100D+03, 4.76893390D+03, 4.69526010D+03, 4.62183100D+03/
      data ( FDNS(102,J,1),J=1,12) /
     $ 1.367D-10, 6.268D-10, 1.764D-09, 3.912D-09, 7.488D-09, 1.295D-08,
     $ 2.079D-08, 3.148D-08, 4.552D-08, 6.337D-08, 8.546D-08, 1.121D-07/
      data (WNUPS(102,J,2),J=1,12) /
     $ 6.04791860D+03, 5.96875170D+03, 5.88977780D+03, 5.81100260D+03,
     $ 5.73243110D+03, 5.65406830D+03, 5.57591840D+03, 5.49798530D+03,
     $ 5.42027250D+03, 5.34278270D+03, 5.26551810D+03, 5.18848010D+03/
      data ( FUPS(102,J,2),J=1,12) /
     $ 1.004D-09, 4.197D-09, 1.091D-08, 2.257D-08, 4.067D-08, 6.670D-08,
     $ 1.022D-07, 1.485D-07, 2.071D-07, 2.791D-07, 3.656D-07, 4.676D-07/
      data (WNDNS(102,J,2),J=1,12) /
     $ 5.35493080D+03, 5.28245420D+03, 5.21017280D+03, 5.13809210D+03,
     $ 5.06621740D+03, 4.99455320D+03, 4.92310390D+03, 4.85187330D+03,
     $ 4.78086470D+03, 4.71008090D+03, 4.63952410D+03, 4.56919570D+03/
      data ( FDNS(102,J,2),J=1,12) /
     $ 1.229D-10, 5.634D-10, 1.585D-09, 3.516D-09, 6.737D-09, 1.166D-08,
     $ 1.874D-08, 2.841D-08, 4.115D-08, 5.737D-08, 7.746D-08, 1.019D-07/
      data (WNUPS(103,J,1),J=1,12) /
     $ 6.15719450D+03, 6.07425870D+03, 5.99153030D+03, 5.90901530D+03,
     $ 5.82671930D+03, 5.74464750D+03, 5.66280440D+03, 5.58119410D+03,
     $ 5.49982010D+03, 5.41868520D+03, 5.33779130D+03, 5.25713970D+03/
      data ( FUPS(103,J,1),J=1,12) /
     $ 1.160D-09, 4.845D-09, 1.258D-08, 2.598D-08, 4.673D-08, 7.654D-08,
     $ 1.170D-07, 1.698D-07, 2.363D-07, 3.179D-07, 4.157D-07, 5.307D-07/
      data (WNDNS(103,J,1),J=1,12) /
     $ 5.42873240D+03, 5.35302810D+03, 5.27753380D+03, 5.20225540D+03,
     $ 5.12719860D+03, 5.05236830D+03, 4.97776900D+03, 4.90340490D+03,
     $ 4.82927930D+03, 4.75539490D+03, 4.68175390D+03, 4.60835730D+03/
      data ( FDNS(103,J,1),J=1,12) /
     $ 1.371D-10, 6.285D-10, 1.769D-09, 3.921D-09, 7.502D-09, 1.297D-08,
     $ 2.081D-08, 3.150D-08, 4.553D-08, 6.333D-08, 8.541D-08, 1.121D-07/
      data (WNUPS(103,J,2),J=1,12) /
     $ 6.04077100D+03, 5.96156740D+03, 5.88255700D+03, 5.80374530D+03,
     $ 5.72513740D+03, 5.64673830D+03, 5.56855220D+03, 5.49058300D+03,
     $ 5.41283400D+03, 5.33530800D+03, 5.25800720D+03, 5.18093280D+03/
      data ( FUPS(103,J,2),J=1,12) /
     $ 1.020D-09, 4.260D-09, 1.107D-08, 2.288D-08, 4.122D-08, 6.761D-08,
     $ 1.035D-07, 1.503D-07, 2.096D-07, 2.823D-07, 3.697D-07, 4.726D-07/
      data (WNDNS(103,J,2),J=1,12) /
     $ 5.34191160D+03, 5.26946460D+03, 5.19721300D+03, 5.12516240D+03,
     $ 5.05331790D+03, 4.98168410D+03, 4.91026530D+03, 4.83906530D+03,
     $ 4.76808740D+03, 4.69733440D+03, 4.62680840D+03, 4.55651080D+03/
      data ( FDNS(103,J,2),J=1,12) /
     $ 1.232D-10, 5.647D-10, 1.589D-09, 3.523D-09, 6.744D-09, 1.168D-08,
     $ 1.875D-08, 2.843D-08, 4.115D-08, 5.734D-08, 7.744D-08, 1.018D-07/
      data (WNUPS(104,J,1),J=1,12) /
     $ 6.14931840D+03, 6.06634290D+03, 5.98357490D+03, 5.90102030D+03,
     $ 5.81868490D+03, 5.73657370D+03, 5.65469130D+03, 5.57304180D+03,
     $ 5.49162860D+03, 5.41045440D+03, 5.32952110D+03, 5.24882990D+03/
      data ( FUPS(104,J,1),J=1,12) /
     $ 1.179D-09, 4.918D-09, 1.276D-08, 2.635D-08, 4.738D-08, 7.754D-08,
     $ 1.186D-07, 1.719D-07, 2.391D-07, 3.215D-07, 4.203D-07, 5.362D-07/
      data (WNDNS(104,J,1),J=1,12) /
     $ 5.41481180D+03, 5.33913870D+03, 5.26367600D+03, 5.18842940D+03,
     $ 5.11340450D+03, 5.03860630D+03, 4.96403950D+03, 4.88970780D+03,
     $ 4.81561470D+03, 4.74176290D+03, 4.66815440D+03, 4.59479040D+03/
      data ( FDNS(104,J,1),J=1,12) /
     $ 1.377D-10, 6.306D-10, 1.775D-09, 3.931D-09, 7.517D-09, 1.299D-08,
     $ 2.083D-08, 3.152D-08, 4.555D-08, 6.335D-08, 8.536D-08, 1.120D-07/
      data (WNUPS(104,J,2),J=1,12) /
     $ 6.03351060D+03, 5.95427020D+03, 5.87522310D+03, 5.79637480D+03,
     $ 5.71773040D+03, 5.63929490D+03, 5.56107240D+03, 5.48306690D+03,
     $ 5.40528160D+03, 5.32771930D+03, 5.25038200D+03, 5.17327110D+03/
      data ( FUPS(104,J,2),J=1,12) /
     $ 1.036D-09, 4.324D-09, 1.123D-08, 2.320D-08, 4.178D-08, 6.845D-08,
     $ 1.048D-07, 1.522D-07, 2.120D-07, 2.855D-07, 3.738D-07, 4.777D-07/
      data (WNDNS(104,J,2),J=1,12) /
     $ 5.32880620D+03, 5.25638880D+03, 5.18416690D+03, 5.11214630D+03,
     $ 5.04033180D+03, 4.96872830D+03, 4.89733990D+03, 4.82617050D+03,
     $ 4.75522320D+03, 4.68450090D+03, 4.61400560D+03, 4.54373860D+03/
      data ( FDNS(104,J,2),J=1,12) /
     $ 1.236D-10, 5.660D-10, 1.593D-09, 3.530D-09, 6.756D-09, 1.169D-08,
     $ 1.877D-08, 2.844D-08, 4.116D-08, 5.737D-08, 7.742D-08, 1.017D-07/
      data (WNUPS(105,J,1),J=1,12) /
     $ 6.14132110D+03, 6.05830560D+03, 5.97549770D+03, 5.89290350D+03,
     $ 5.81052840D+03, 5.72837770D+03, 5.64645590D+03, 5.56476700D+03,
     $ 5.48331440D+03, 5.40210070D+03, 5.32112780D+03, 5.24039690D+03/
      data ( FUPS(105,J,1),J=1,12) /
     $ 1.198D-09, 4.995D-09, 1.295D-08, 2.672D-08, 4.804D-08, 7.856D-08,
     $ 1.200D-07, 1.741D-07, 2.420D-07, 3.253D-07, 4.251D-07, 5.421D-07/
      data (WNDNS(105,J,1),J=1,12) /
     $ 5.40079920D+03, 5.32515730D+03, 5.24972600D+03, 5.17451100D+03,
     $ 5.09951800D+03, 5.02475190D+03, 4.95021720D+03, 4.87591790D+03,
     $ 4.80185720D+03, 4.72803790D+03, 4.65446190D+03, 4.58113030D+03/
      data ( FDNS(105,J,1),J=1,12) /
     $ 1.382D-10, 6.332D-10, 1.780D-09, 3.941D-09, 7.536D-09, 1.301D-08,
     $ 2.086D-08, 3.155D-08, 4.557D-08, 6.336D-08, 8.536D-08, 1.119D-07/
      data (WNUPS(105,J,2),J=1,12) /
     $ 6.02613730D+03, 5.94685990D+03, 5.86777590D+03, 5.78889090D+03,
     $ 5.71020990D+03, 5.63173780D+03, 5.55347880D+03, 5.47543680D+03,
     $ 5.39761510D+03, 5.32001630D+03, 5.24264240D+03, 5.16549480D+03/
      data ( FUPS(105,J,2),J=1,12) /
     $ 1.052D-09, 4.389D-09, 1.139D-08, 2.353D-08, 4.234D-08, 6.938D-08,
     $ 1.061D-07, 1.541D-07, 2.145D-07, 2.888D-07, 3.779D-07, 4.828D-07/
      data (WNDNS(105,J,2),J=1,12) /
     $ 5.31561480D+03, 5.24322680D+03, 5.17103460D+03, 5.09904370D+03,
     $ 5.02725920D+03, 4.95568590D+03, 4.88432780D+03, 4.81318880D+03,
     $ 4.74227210D+03, 4.67158040D+03, 4.60111570D+03, 4.53087930D+03/
      data ( FDNS(105,J,2),J=1,12) /
     $ 1.240D-10, 5.678D-10, 1.597D-09, 3.538D-09, 6.768D-09, 1.171D-08,
     $ 1.879D-08, 2.846D-08, 4.117D-08, 5.735D-08, 7.735D-08, 1.016D-07/
      data (WNUPS(106,J,1),J=1,12) /
     $ 6.13320220D+03, 6.05014660D+03, 5.96729870D+03, 5.88466460D+03,
     $ 5.80224970D+03, 5.72005930D+03, 5.63809790D+03, 5.55636940D+03,
     $ 5.47487720D+03, 5.39362390D+03, 5.31261120D+03, 5.23184030D+03/
      data ( FUPS(106,J,1),J=1,12) /
     $ 1.217D-09, 5.071D-09, 1.314D-08, 2.711D-08, 4.867D-08, 7.962D-08,
     $ 1.216D-07, 1.762D-07, 2.449D-07, 3.291D-07, 4.299D-07, 5.483D-07/
      data (WNDNS(106,J,1),J=1,12) /
     $ 5.38669470D+03, 5.31108390D+03, 5.23568380D+03, 5.16050040D+03,
     $ 5.08553910D+03, 5.01080490D+03, 4.93630240D+03, 4.86203530D+03,
     $ 4.78800690D+03, 4.71422000D+03, 4.64067630D+03, 4.56737690D+03/
      data ( FDNS(106,J,1),J=1,12) /
     $ 1.388D-10, 6.357D-10, 1.786D-09, 3.953D-09, 7.554D-09, 1.304D-08,
     $ 2.089D-08, 3.158D-08, 4.559D-08, 6.338D-08, 8.535D-08, 1.118D-07/
      data (WNUPS(106,J,2),J=1,12) /
     $ 6.01865090D+03, 5.93933640D+03, 5.86021540D+03, 5.78129340D+03,
     $ 5.70257560D+03, 5.62406670D+03, 5.54577110D+03, 5.46769250D+03,
     $ 5.38983420D+03, 5.31219870D+03, 5.23478820D+03, 5.15760370D+03/
      data ( FUPS(106,J,2),J=1,12) /
     $ 1.068D-09, 4.455D-09, 1.155D-08, 2.386D-08, 4.292D-08, 7.028D-08,
     $ 1.075D-07, 1.560D-07, 2.171D-07, 2.921D-07, 3.821D-07, 4.882D-07/
      data (WNDNS(106,J,2),J=1,12) /
     $ 5.30233740D+03, 5.22997870D+03, 5.15781600D+03, 5.08585480D+03,
     $ 5.01410020D+03, 4.94255690D+03, 4.87122910D+03, 4.80012050D+03,
     $ 4.72923420D+03, 4.65857300D+03, 4.58813870D+03, 4.51793280D+03/
      data ( FDNS(106,J,2),J=1,12) /
     $ 1.245D-10, 5.700D-10, 1.602D-09, 3.547D-09, 6.784D-09, 1.173D-08,
     $ 1.881D-08, 2.848D-08, 4.119D-08, 5.732D-08, 7.732D-08, 1.015D-07/
      data (WNUPS(107,J,1),J=1,12) /
     $ 6.12496160D+03, 6.04186570D+03, 5.95897760D+03, 5.87630340D+03,
     $ 5.79384860D+03, 5.71161830D+03, 5.62961710D+03, 5.54784890D+03,
     $ 5.46631690D+03, 5.38502370D+03, 5.30397110D+03, 5.22316000D+03/
      data ( FUPS(107,J,1),J=1,12) /
     $ 1.237D-09, 5.150D-09, 1.334D-08, 2.750D-08, 4.939D-08, 8.070D-08,
     $ 1.232D-07, 1.784D-07, 2.479D-07, 3.329D-07, 4.347D-07, 5.545D-07/
      data (WNDNS(107,J,1),J=1,12) /
     $ 5.37249840D+03, 5.29691860D+03, 5.22154960D+03, 5.14639760D+03,
     $ 5.07146790D+03, 4.99676550D+03, 4.92229490D+03, 4.84805990D+03,
     $ 4.77406380D+03, 4.70030910D+03, 4.62679760D+03, 4.55353040D+03/
      data ( FDNS(107,J,1),J=1,12) /
     $ 1.394D-10, 6.381D-10, 1.793D-09, 3.965D-09, 7.572D-09, 1.307D-08,
     $ 2.092D-08, 3.162D-08, 4.562D-08, 6.340D-08, 8.535D-08, 1.118D-07/
      data (WNUPS(107,J,2),J=1,12) /
     $ 6.01105120D+03, 5.93169940D+03, 5.85254120D+03, 5.77358210D+03,
     $ 5.69482740D+03, 5.61628170D+03, 5.53794920D+03, 5.45983390D+03,
     $ 5.38193880D+03, 5.30426650D+03, 5.22681900D+03, 5.14959750D+03/
      data ( FUPS(107,J,2),J=1,12) /
     $ 1.085D-09, 4.523D-09, 1.172D-08, 2.420D-08, 4.350D-08, 7.122D-08,
     $ 1.088D-07, 1.579D-07, 2.197D-07, 2.954D-07, 3.863D-07, 4.934D-07/
      data (WNDNS(107,J,2),J=1,12) /
     $ 5.28897400D+03, 5.21664450D+03, 5.14451120D+03, 5.07257960D+03,
     $ 5.00085480D+03, 4.92934150D+03, 4.85804380D+03, 4.78696540D+03,
     $ 4.71610950D+03, 4.64547860D+03, 4.57507480D+03, 4.50489920D+03/
      data ( FDNS(107,J,2),J=1,12) /
     $ 1.250D-10, 5.721D-10, 1.607D-09, 3.556D-09, 6.800D-09, 1.175D-08,
     $ 1.884D-08, 2.851D-08, 4.121D-08, 5.735D-08, 7.735D-08, 1.015D-07/
      data (WNUPS(108,J,1),J=1,12) /
     $ 6.11659910D+03, 6.03346270D+03, 5.95053420D+03, 5.86781980D+03,
     $ 5.78532480D+03, 5.70305450D+03, 5.62101330D+03, 5.53920510D+03,
     $ 5.45763310D+03, 5.37629990D+03, 5.29520710D+03, 5.21435560D+03/
      data ( FUPS(108,J,1),J=1,12) /
     $ 1.256D-09, 5.233D-09, 1.354D-08, 2.789D-08, 5.005D-08, 8.177D-08,
     $ 1.248D-07, 1.807D-07, 2.509D-07, 3.368D-07, 4.396D-07, 5.605D-07/
      data (WNDNS(108,J,1),J=1,12) /
     $ 5.35821030D+03, 5.28266130D+03, 5.20732340D+03, 5.13220270D+03,
     $ 5.05730440D+03, 4.98263370D+03, 4.90819500D+03, 4.83399200D+03,
     $ 4.76002790D+03, 4.68630530D+03, 4.61282590D+03, 4.53959070D+03/
      data ( FDNS(108,J,1),J=1,12) /
     $ 1.401D-10, 6.410D-10, 1.800D-09, 3.978D-09, 7.594D-09, 1.310D-08,
     $ 2.096D-08, 3.166D-08, 4.566D-08, 6.341D-08, 8.535D-08, 1.118D-07/
      data (WNUPS(108,J,2),J=1,12) /
     $ 6.00333790D+03, 5.92394870D+03, 5.84475320D+03, 5.76575690D+03,
     $ 5.68696500D+03, 5.60838230D+03, 5.53001290D+03, 5.45186060D+03,
     $ 5.37392850D+03, 5.29621930D+03, 5.21873480D+03, 5.14147600D+03/
      data ( FUPS(108,J,2),J=1,12) /
     $ 1.102D-09, 4.591D-09, 1.190D-08, 2.454D-08, 4.409D-08, 7.214D-08,
     $ 1.102D-07, 1.598D-07, 2.223D-07, 2.988D-07, 3.907D-07, 4.986D-07/
      data (WNDNS(108,J,2),J=1,12) /
     $ 5.27552480D+03, 5.20322430D+03, 5.13112030D+03, 5.05921820D+03,
     $ 4.98752310D+03, 4.91603960D+03, 4.84477190D+03, 4.77372370D+03,
     $ 4.70289800D+03, 4.63229740D+03, 4.56192380D+03, 4.49177850D+03/
      data ( FDNS(108,J,2),J=1,12) /
     $ 1.255D-10, 5.742D-10, 1.612D-09, 3.566D-09, 6.816D-09, 1.177D-08,
     $ 1.887D-08, 2.854D-08, 4.124D-08, 5.737D-08, 7.733D-08, 1.015D-07/
      data (WNUPS(109,J,1),J=1,12) /
     $ 6.10811450D+03, 6.02493740D+03, 5.94196830D+03, 5.85921340D+03,
     $ 5.77667810D+03, 5.69436760D+03, 5.61228620D+03, 5.53043780D+03,
     $ 5.44882570D+03, 5.36745220D+03, 5.28631900D+03, 5.20542700D+03/
      data ( FUPS(109,J,1),J=1,12) /
     $ 1.276D-09, 5.313D-09, 1.374D-08, 2.829D-08, 5.074D-08, 8.286D-08,
     $ 1.264D-07, 1.829D-07, 2.539D-07, 3.407D-07, 4.446D-07, 5.664D-07/
      data (WNDNS(109,J,1),J=1,12) /
     $ 5.34383050D+03, 5.26831220D+03, 5.19300520D+03, 5.11791560D+03,
     $ 5.04304870D+03, 4.96840960D+03, 4.89400250D+03, 4.81983140D+03,
     $ 4.74589930D+03, 4.67220870D+03, 4.59876130D+03, 4.52555790D+03/
      data ( FDNS(109,J,1),J=1,12) /
     $ 1.409D-10, 6.438D-10, 1.806D-09, 3.992D-09, 7.616D-09, 1.313D-08,
     $ 2.100D-08, 3.170D-08, 4.571D-08, 6.342D-08, 8.534D-08, 1.117D-07/
      data (WNUPS(109,J,2),J=1,12) /
     $ 5.99551110D+03, 5.91608430D+03, 5.83685120D+03, 5.75781750D+03,
     $ 5.67898840D+03, 5.60036840D+03, 5.52196190D+03, 5.44377250D+03,
     $ 5.36580330D+03, 5.28805700D+03, 5.21053520D+03, 5.13323900D+03/
      data ( FUPS(109,J,2),J=1,12) /
     $ 1.119D-09, 4.659D-09, 1.207D-08, 2.488D-08, 4.469D-08, 7.309D-08,
     $ 1.116D-07, 1.618D-07, 2.249D-07, 3.023D-07, 3.950D-07, 5.041D-07/
      data (WNDNS(109,J,2),J=1,12) /
     $ 5.26198970D+03, 5.18971820D+03, 5.11764330D+03, 5.04577060D+03,
     $ 4.97410510D+03, 4.90265140D+03, 4.83141360D+03, 4.76039530D+03,
     $ 4.68959980D+03, 4.61902940D+03, 4.54868600D+03, 4.47857070D+03/
      data ( FDNS(109,J,2),J=1,12) /
     $ 1.261D-10, 5.763D-10, 1.618D-09, 3.577D-09, 6.831D-09, 1.179D-08,
     $ 1.889D-08, 2.858D-08, 4.127D-08, 5.740D-08, 7.731D-08, 1.014D-07/
      data (WNUPS(110,J,1),J=1,12) /
     $ 6.09950750D+03, 6.01628950D+03, 5.93327970D+03, 5.85048410D+03,
     $ 5.76790830D+03, 5.68555730D+03, 5.60343550D+03, 5.52154680D+03,
     $ 5.43989430D+03, 5.35848040D+03, 5.27730670D+03, 5.19637380D+03/
      data ( FUPS(110,J,1),J=1,12) /
     $ 1.297D-09, 5.393D-09, 1.395D-08, 2.870D-08, 5.146D-08, 8.397D-08,
     $ 1.280D-07, 1.852D-07, 2.570D-07, 3.447D-07, 4.496D-07, 5.726D-07/
      data (WNDNS(110,J,1),J=1,12) /
     $ 5.32935910D+03, 5.25387130D+03, 5.17859510D+03, 5.10353640D+03,
     $ 5.02870080D+03, 4.95409310D+03, 4.87971770D+03, 4.80557820D+03,
     $ 4.73167800D+03, 4.65801920D+03, 4.58460360D+03, 4.51143200D+03/
      data ( FDNS(110,J,1),J=1,12) /
     $ 1.416D-10, 6.471D-10, 1.814D-09, 4.006D-09, 7.638D-09, 1.316D-08,
     $ 2.104D-08, 3.175D-08, 4.575D-08, 6.348D-08, 8.534D-08, 1.117D-07/
      data (WNUPS(110,J,2),J=1,12) /
     $ 5.98757030D+03, 5.90810570D+03, 5.82883500D+03, 5.74976380D+03,
     $ 5.67089720D+03, 5.59223980D+03, 5.51379600D+03, 5.43556930D+03,
     $ 5.35756290D+03, 5.27977920D+03, 5.20222000D+03, 5.12488630D+03/
      data ( FUPS(110,J,2),J=1,12) /
     $ 1.137D-09, 4.731D-09, 1.225D-08, 2.523D-08, 4.530D-08, 7.406D-08,
     $ 1.131D-07, 1.637D-07, 2.276D-07, 3.058D-07, 3.994D-07, 5.096D-07/
      data (WNDNS(110,J,2),J=1,12) /
     $ 5.24836880D+03, 5.17612620D+03, 5.10408030D+03, 5.03223690D+03,
     $ 4.96060080D+03, 4.88917670D+03, 4.81796870D+03, 4.74698040D+03,
     $ 4.67621490D+03, 4.60567450D+03, 4.53536120D+03, 4.46527590D+03/
      data ( FDNS(110,J,2),J=1,12) /
     $ 1.267D-10, 5.787D-10, 1.624D-09, 3.589D-09, 6.851D-09, 1.182D-08,
     $ 1.893D-08, 2.862D-08, 4.131D-08, 5.742D-08, 7.733D-08, 1.014D-07/
      data (WNUPS(111,J,1),J=1,12) /
     $ 6.09077800D+03, 6.00751890D+03, 5.92446810D+03, 5.84163160D+03,
     $ 5.75901510D+03, 5.67662350D+03, 5.59446110D+03, 5.51253190D+03,
     $ 5.43083880D+03, 5.34938420D+03, 5.26816970D+03, 5.18719580D+03/
      data ( FUPS(111,J,1),J=1,12) /
     $ 1.318D-09, 5.480D-09, 1.415D-08, 2.912D-08, 5.217D-08, 8.511D-08,
     $ 1.297D-07, 1.875D-07, 2.600D-07, 3.487D-07, 4.548D-07, 5.787D-07/
      data (WNDNS(111,J,1),J=1,12) /
     $ 5.31479610D+03, 5.23933870D+03, 5.16409310D+03, 5.08906530D+03,
     $ 5.01426070D+03, 4.93968430D+03, 4.86534030D+03, 4.79123250D+03,
     $ 4.71736390D+03, 4.64373690D+03, 4.57035300D+03, 4.49721300D+03/
      data ( FDNS(111,J,1),J=1,12) /
     $ 1.425D-10, 6.502D-10, 1.822D-09, 4.022D-09, 7.664D-09, 1.319D-08,
     $ 2.109D-08, 3.180D-08, 4.578D-08, 6.354D-08, 8.538D-08, 1.117D-07/
      data (WNUPS(111,J,2),J=1,12) /
     $ 5.97951560D+03, 5.90001300D+03, 5.82070440D+03, 5.74159550D+03,
     $ 5.66269120D+03, 5.58399630D+03, 5.50551500D+03, 5.42725090D+03,
     $ 5.34920710D+03, 5.27138590D+03, 5.19378900D+03, 5.11641760D+03/
      data ( FUPS(111,J,2),J=1,12) /
     $ 1.154D-09, 4.801D-09, 1.243D-08, 2.559D-08, 4.593D-08, 7.502D-08,
     $ 1.145D-07, 1.657D-07, 2.303D-07, 3.093D-07, 4.038D-07, 5.149D-07/
      data (WNDNS(111,J,2),J=1,12) /
     $ 5.23466230D+03, 5.16244830D+03, 5.09043140D+03, 5.01861710D+03,
     $ 4.94701030D+03, 4.87561570D+03, 4.80443740D+03, 4.73347890D+03,
     $ 4.66274330D+03, 4.59223290D+03, 4.52194950D+03, 4.45189410D+03/
      data ( FDNS(111,J,2),J=1,12) /
     $ 1.273D-10, 5.816D-10, 1.630D-09, 3.601D-09, 6.870D-09, 1.185D-08,
     $ 1.896D-08, 2.865D-08, 4.135D-08, 5.744D-08, 7.735D-08, 1.014D-07/
C
      call HI ('COSECN')
C     !BEG
C     !END
      call BYE ('COSECN')
C
      end
